
kernel.o:     file format elf32-i386


Disassembly of section .text:

c0020058 <start>:
start:

# The loader called into us with CS = 0x2000, SS = 0x0000, ESP = 0xf000,
# but we should initialize the other segment registers.

	mov $0x2000, %ax
c0020058:	b8 00 20 8e d8       	mov    $0xd88e2000,%eax
	mov %ax, %ds
	mov %ax, %es
c002005d:	8e c0                	mov    %eax,%es

# Set string instructions to go upward.
	cld
c002005f:	fc                   	cld    
#### which returns AX = (kB of physical memory) - 1024.  This only
#### works for memory sizes <= 65 MB, which should be fine for our
#### purposes.  We cap memory at 64 MB because that's all we prepare
#### page tables for, below.

	movb $0x88, %ah
c0020060:	b4 88                	mov    $0x88,%ah
	int $0x15
c0020062:	cd 15                	int    $0x15
	addl $1024, %eax	# Total kB memory
c0020064:	66 05 00 04          	add    $0x400,%ax
c0020068:	00 00                	add    %al,(%eax)
	cmp $0x10000, %eax	# Cap at 64 MB
c002006a:	66 3d 00 00          	cmp    $0x0,%ax
c002006e:	01 00                	add    %eax,(%eax)
	jbe 1f
c0020070:	76 06                	jbe    c0020078 <start+0x20>
	mov $0x10000, %eax
c0020072:	66 b8 00 00          	mov    $0x0,%ax
c0020076:	01 00                	add    %eax,(%eax)
1:	shrl $2, %eax		# Total 4 kB pages
c0020078:	66 c1 e8 02          	shr    $0x2,%ax
	addr32 movl %eax, init_ram_pages - LOADER_PHYS_BASE - 0x20000
c002007c:	67 66 a3 5e 01       	addr16 mov %ax,0x15e
c0020081:	00 00                	add    %al,(%eax)
#### Enable A20.  Address line 20 is tied low when the machine boots,
#### which prevents addressing memory about 1 MB.  This code fixes it.

# Poll status register while busy.

1:	inb $0x64, %al
c0020083:	e4 64                	in     $0x64,%al
	testb $0x2, %al
c0020085:	a8 02                	test   $0x2,%al
	jnz 1b
c0020087:	75 fa                	jne    c0020083 <start+0x2b>

# Send command for writing output port.

	movb $0xd1, %al
c0020089:	b0 d1                	mov    $0xd1,%al
	outb %al, $0x64
c002008b:	e6 64                	out    %al,$0x64

# Poll status register while busy.

1:	inb $0x64, %al
c002008d:	e4 64                	in     $0x64,%al
	testb $0x2, %al
c002008f:	a8 02                	test   $0x2,%al
	jnz 1b
c0020091:	75 fa                	jne    c002008d <start+0x35>

# Enable A20 line.

	movb $0xdf, %al
c0020093:	b0 df                	mov    $0xdf,%al
	outb %al, $0x60
c0020095:	e6 60                	out    %al,$0x60

# Poll status register while busy.

1:	inb $0x64, %al
c0020097:	e4 64                	in     $0x64,%al
	testb $0x2, %al
c0020099:	a8 02                	test   $0x2,%al
	jnz 1b
c002009b:	75 fa                	jne    c0020097 <start+0x3f>

#### Create temporary page directory and page table and set page
#### directory base register.

# Create page directory at 0xf000 (60 kB) and fill with zeroes.
	mov $0xf00, %ax
c002009d:	b8 00 0f 8e c0       	mov    $0xc08e0f00,%eax
	mov %ax, %es
	subl %eax, %eax
c00200a2:	66 29 c0             	sub    %ax,%ax
	subl %edi, %edi
c00200a5:	66 29 ff             	sub    %di,%di
	movl $0x400, %ecx
c00200a8:	66 b9 00 04          	mov    $0x400,%cx
c00200ac:	00 00                	add    %al,(%eax)
	rep stosl
c00200ae:	66 f3 ab             	rep stos %ax,%es:(%edi)
# Add PDEs to point to page tables for the first 64 MB of RAM.
# Also add identical PDEs starting at LOADER_PHYS_BASE.
# See [IA32-v3a] section 3.7.6 "Page-Directory and Page-Table Entries"
# for a description of the bits in %eax.

	movl $0x10007, %eax
c00200b1:	66 b8 07 00          	mov    $0x7,%ax
c00200b5:	01 00                	add    %eax,(%eax)
	movl $0x11, %ecx
c00200b7:	66 b9 11 00          	mov    $0x11,%cx
c00200bb:	00 00                	add    %al,(%eax)
	subl %edi, %edi
c00200bd:	66 29 ff             	sub    %di,%di
1:	movl %eax, %es:(%di)
c00200c0:	26 66 89 05 26 66 89 	mov    %ax,%es:0x85896626
c00200c7:	85 
	movl %eax, %es:LOADER_PHYS_BASE >> 20(%di)
c00200c8:	00 0c 83             	add    %cl,(%ebx,%eax,4)
	addw $4, %di
c00200cb:	c7 04 66 05 00 10 00 	movl   $0x100005,(%esi,%eiz,2)
	addl $0x1000, %eax
c00200d2:	00 e2                	add    %ah,%dl
	loop 1b
c00200d4:	eb b8                	jmp    c002008e <start+0x36>
# Set up page tables for one-to-map linear to physical map for the
# first 64 MB of RAM.
# See [IA32-v3a] section 3.7.6 "Page-Directory and Page-Table Entries"
# for a description of the bits in %eax.

	movw $0x1000, %ax
c00200d6:	00 10                	add    %dl,(%eax)
	movw %ax, %es
c00200d8:	8e c0                	mov    %eax,%es
	movl $0x7, %eax
c00200da:	66 b8 07 00          	mov    $0x7,%ax
c00200de:	00 00                	add    %al,(%eax)
	movl $0x4000, %ecx
c00200e0:	66 b9 00 40          	mov    $0x4000,%cx
c00200e4:	00 00                	add    %al,(%eax)
	subl %edi, %edi
c00200e6:	66 29 ff             	sub    %di,%di
1:	movl %eax, %es:(%di)
c00200e9:	26 66 89 05 83 c7 04 	mov    %ax,%es:0x6604c783
c00200f0:	66 
	addw $4, %di
	addl $0x1000, %eax
c00200f1:	05 00 10 00 00       	add    $0x1000,%eax
	loop 1b
c00200f6:	e2 f1                	loop   c00200e9 <start+0x91>

# Set page directory base register.

	movl $0xf000, %eax
c00200f8:	66 b8 00 f0          	mov    $0xf000,%ax
c00200fc:	00 00                	add    %al,(%eax)
	movl %eax, %cr3
c00200fe:	0f 22 d8             	mov    %eax,%cr3
#### Switch to protected mode.

# First, disable interrupts.  We won't set up the IDT until we get
# into C code, so any interrupt would blow us away.

	cli
c0020101:	fa                   	cli    
# We need a data32 prefix to ensure that all 32 bits of the GDT
# descriptor are loaded (default is to load only 24 bits).
# The CPU doesn't need an addr32 prefix but ELF doesn't do 16-bit
# relocations.

	data32 addr32 lgdt gdtdesc - LOADER_PHYS_BASE - 0x20000
c0020102:	67 66 0f 01 15       	lgdtw  (%di)
c0020107:	58                   	pop    %eax
c0020108:	01 00                	add    %eax,(%eax)
c002010a:	00 0f                	add    %cl,(%edi)
#    WP (Write Protect): if unset, ring 0 code ignores
#       write-protect bits in page tables (!).
#    EM (Emulation): forces floating-point instructions to trap.
#       We don't support floating point.

	movl %cr0, %eax
c002010c:	20 c0                	and    %al,%al
	orl $CR0_PE | CR0_PG | CR0_WP | CR0_EM, %eax
c002010e:	66 0d 05 00          	or     $0x5,%ax
c0020112:	01 80 0f 22 c0 66    	add    %eax,0x66c0220f(%eax)
# the real-mode code segment cached in %cs's segment descriptor.  We
# need to reload %cs, and the easiest way is to use a far jump.
# Because we're not running in a 32-bit segment the data32 prefix is
# needed to jump to a 32-bit offset in the target segment.

	data32 ljmp $SEL_KCSEG, $1f
c0020118:	ea 1f 01 02 c0 08 00 	ljmp   $0x8,$0xc002011f
	.code32

# Reload all the other segment registers and the stack pointer to
# point into our new GDT.

1:	mov $SEL_KDSEG, %ax
c002011f:	66 b8 10 00          	mov    $0x10,%ax
	mov %ax, %ds
c0020123:	8e d8                	mov    %eax,%ds
	mov %ax, %es
c0020125:	8e c0                	mov    %eax,%es
	mov %ax, %fs
c0020127:	8e e0                	mov    %eax,%fs
	mov %ax, %gs
c0020129:	8e e8                	mov    %eax,%gs
	mov %ax, %ss
c002012b:	8e d0                	mov    %eax,%ss
	addl $LOADER_PHYS_BASE, %esp
c002012d:	81 c4 00 00 00 c0    	add    $0xc0000000,%esp
	movl $0, %ebp			# Null-terminate main()'s backtrace
c0020133:	bd 00 00 00 00       	mov    $0x0,%ebp

#### Call pintos_init().

	call pintos_init
c0020138:	e8 56 00 00 00       	call   c0020193 <pintos_init>

# pintos_init() shouldn't ever return.  If it does, spin.

1:	jmp 1b
c002013d:	eb fe                	jmp    c002013d <start+0xe5>
	...

c0020140 <gdt>:
	...
c0020148:	ff                   	(bad)  
c0020149:	ff 00                	incl   (%eax)
c002014b:	00 00                	add    %al,(%eax)
c002014d:	9a cf 00 ff ff 00 00 	lcall  $0x0,$0xffff00cf
c0020154:	00                   	.byte 0x0
c0020155:	92                   	xchg   %eax,%edx
c0020156:	cf                   	iret   
	...

c0020158 <gdtdesc>:
c0020158:	17                   	pop    %ss
c0020159:	00 40 01             	add    %al,0x1(%eax)
c002015c:	02 c0                	add    %al,%al

c002015e <init_ram_pages>:
c002015e:	00 00                	add    %al,(%eax)
	...

c0020162 <run_task>:
}

/* Runs the task specified in ARGV[1]. */
static void
run_task (char **argv)
{
c0020162:	53                   	push   %ebx
c0020163:	83 ec 10             	sub    $0x10,%esp
  const char *task = argv[1];
c0020166:	8b 44 24 18          	mov    0x18(%esp),%eax
c002016a:	8b 58 04             	mov    0x4(%eax),%ebx
  
  printf ("Executing '%s':\n", task);
c002016d:	53                   	push   %ebx
c002016e:	68 71 cb 02 c0       	push   $0xc002cb71
c0020173:	e8 1a 5a 00 00       	call   c0025b92 <printf>
#ifdef USERPROG
  process_wait (process_execute (task));
#else
  run_test (task);
c0020178:	89 1c 24             	mov    %ebx,(%esp)
c002017b:	e8 cd 8f 00 00       	call   c002914d <run_test>
#endif
  printf ("Execution of '%s' complete.\n", task);
c0020180:	83 c4 08             	add    $0x8,%esp
c0020183:	53                   	push   %ebx
c0020184:	68 82 cb 02 c0       	push   $0xc002cb82
c0020189:	e8 04 5a 00 00       	call   c0025b92 <printf>
}
c002018e:	83 c4 18             	add    $0x18,%esp
c0020191:	5b                   	pop    %ebx
c0020192:	c3                   	ret    

c0020193 <pintos_init>:
{
c0020193:	55                   	push   %ebp
c0020194:	57                   	push   %edi
c0020195:	56                   	push   %esi
c0020196:	53                   	push   %ebx
c0020197:	83 ec 2c             	sub    $0x2c,%esp
  memset (&_start_bss, 0, &_end_bss - &_start_bss);
c002019a:	b9 6d 83 03 c0       	mov    $0xc003836d,%ecx
c002019f:	81 e9 b0 67 03 c0    	sub    $0xc00367b0,%ecx
c00201a5:	ba b0 67 03 c0       	mov    $0xc00367b0,%edx
c00201aa:	b0 00                	mov    $0x0,%al
c00201ac:	89 d7                	mov    %edx,%edi
c00201ae:	f3 aa                	rep stos %al,%es:(%edi)
  argc = *(uint32_t *) ptov (LOADER_ARG_CNT);
c00201b0:	8b 35 3a 7d 00 c0    	mov    0xc0007d3a,%esi
  for (i = 0; i < argc; i++) 
c00201b6:	85 f6                	test   %esi,%esi
c00201b8:	0f 8e 8e 04 00 00    	jle    c002064c <pintos_init+0x4b9>
c00201be:	bf 00 00 00 00       	mov    $0x0,%edi
c00201c3:	bb 3e 7d 00 c0       	mov    $0xc0007d3e,%ebx
      p += strnlen (p, end - p) + 1;
c00201c8:	bd be 7d 00 c0       	mov    $0xc0007dbe,%ebp
c00201cd:	eb 08                	jmp    c00201d7 <pintos_init+0x44>
      if (p >= end)
c00201cf:	81 fb bd 7d 00 c0    	cmp    $0xc0007dbd,%ebx
c00201d5:	77 43                	ja     c002021a <pintos_init+0x87>
      argv[i] = p;
c00201d7:	89 1c bd c0 67 03 c0 	mov    %ebx,-0x3ffc9840(,%edi,4)
      p += strnlen (p, end - p) + 1;
c00201de:	83 ec 08             	sub    $0x8,%esp
c00201e1:	89 e8                	mov    %ebp,%eax
c00201e3:	29 d8                	sub    %ebx,%eax
c00201e5:	50                   	push   %eax
c00201e6:	53                   	push   %ebx
c00201e7:	e8 23 6b 00 00       	call   c0026d0f <strnlen>
c00201ec:	8d 5c 03 01          	lea    0x1(%ebx,%eax,1),%ebx
  for (i = 0; i < argc; i++) 
c00201f0:	47                   	inc    %edi
c00201f1:	83 c4 10             	add    $0x10,%esp
c00201f4:	39 fe                	cmp    %edi,%esi
c00201f6:	75 d7                	jne    c00201cf <pintos_init+0x3c>
  argv[argc] = NULL;
c00201f8:	c7 04 bd c0 67 03 c0 	movl   $0x0,-0x3ffc9840(,%edi,4)
c00201ff:	00 00 00 00 
  printf ("Kernel command line:");
c0020203:	83 ec 0c             	sub    $0xc,%esp
c0020206:	68 47 cc 02 c0       	push   $0xc002cc47
c002020b:	e8 82 59 00 00       	call   c0025b92 <printf>
c0020210:	83 c4 10             	add    $0x10,%esp
c0020213:	bb 00 00 00 00       	mov    $0x0,%ebx
c0020218:	eb 33                	jmp    c002024d <pintos_init+0xba>
        PANIC ("command line arguments overflow");
c002021a:	68 5c cc 02 c0       	push   $0xc002cc5c
c002021f:	68 e8 b4 02 c0       	push   $0xc002b4e8
c0020224:	68 d3 00 00 00       	push   $0xd3
c0020229:	68 9f cb 02 c0       	push   $0xc002cb9f
c002022e:	e8 0d 74 00 00       	call   c0027640 <debug_panic>
      printf (" %s", argv[i]);
c0020233:	83 ec 08             	sub    $0x8,%esp
c0020236:	56                   	push   %esi
c0020237:	68 73 d9 02 c0       	push   $0xc002d973
c002023c:	e8 51 59 00 00       	call   c0025b92 <printf>
c0020241:	83 c4 10             	add    $0x10,%esp
  for (i = 0; i < argc; i++)
c0020244:	43                   	inc    %ebx
c0020245:	39 df                	cmp    %ebx,%edi
c0020247:	0f 84 1a 04 00 00    	je     c0020667 <pintos_init+0x4d4>
    if (strchr (argv[i], ' ') == NULL)
c002024d:	8b 34 9d c0 67 03 c0 	mov    -0x3ffc9840(,%ebx,4),%esi
c0020254:	83 ec 08             	sub    $0x8,%esp
c0020257:	6a 20                	push   $0x20
c0020259:	56                   	push   %esi
c002025a:	e8 f9 67 00 00       	call   c0026a58 <strchr>
c002025f:	83 c4 10             	add    $0x10,%esp
c0020262:	85 c0                	test   %eax,%eax
c0020264:	74 cd                	je     c0020233 <pintos_init+0xa0>
      printf (" '%s'", argv[i]);
c0020266:	83 ec 08             	sub    $0x8,%esp
c0020269:	56                   	push   %esi
c002026a:	68 b4 cb 02 c0       	push   $0xc002cbb4
c002026f:	e8 1e 59 00 00       	call   c0025b92 <printf>
c0020274:	83 c4 10             	add    $0x10,%esp
c0020277:	eb cb                	jmp    c0020244 <pintos_init+0xb1>
/* Prints a kernel command line help message and powers off the
   machine. */
static void
usage (void)
{
  printf ("\nCommand line syntax: [OPTION...] [ACTION...]\n"
c0020279:	83 ec 0c             	sub    $0xc,%esp
c002027c:	68 7c cc 02 c0       	push   $0xc002cc7c
c0020281:	e8 08 8e 00 00       	call   c002908e <puts>
          "  -mlfqs             Use multi-level feedback queue scheduler.\n"
#ifdef USERPROG
          "  -ul=COUNT          Limit user memory to COUNT pages.\n"
#endif
          );
  shutdown_power_off ();
c0020286:	e8 ca 51 00 00       	call   c0025455 <shutdown_power_off>
        shutdown_configure (SHUTDOWN_POWER_OFF);
c002028b:	83 ec 0c             	sub    $0xc,%esp
c002028e:	6a 01                	push   $0x1
c0020290:	e8 4a 51 00 00       	call   c00253df <shutdown_configure>
c0020295:	83 c4 10             	add    $0x10,%esp
  for (; *argv != NULL && **argv == '-'; argv++)
c0020298:	83 c5 04             	add    $0x4,%ebp
c002029b:	8b 45 00             	mov    0x0(%ebp),%eax
c002029e:	85 c0                	test   %eax,%eax
c00202a0:	0f 84 07 01 00 00    	je     c00203ad <pintos_init+0x21a>
c00202a6:	80 38 2d             	cmpb   $0x2d,(%eax)
c00202a9:	0f 85 fe 00 00 00    	jne    c00203ad <pintos_init+0x21a>
      char *name = strtok_r (*argv, "=", &save_ptr);
c00202af:	83 ec 04             	sub    $0x4,%esp
c00202b2:	53                   	push   %ebx
c00202b3:	68 05 d8 02 c0       	push   $0xc002d805
c00202b8:	50                   	push   %eax
c00202b9:	e8 a2 68 00 00       	call   c0026b60 <strtok_r>
c00202be:	89 c6                	mov    %eax,%esi
c00202c0:	89 44 24 10          	mov    %eax,0x10(%esp)
      char *value = strtok_r (NULL, "", &save_ptr);
c00202c4:	83 c4 0c             	add    $0xc,%esp
c00202c7:	53                   	push   %ebx
c00202c8:	68 17 d8 02 c0       	push   $0xc002d817
c00202cd:	6a 00                	push   $0x0
c00202cf:	e8 8c 68 00 00       	call   c0026b60 <strtok_r>
      if (!strcmp (name, "-h"))
c00202d4:	bf ba cb 02 c0       	mov    $0xc002cbba,%edi
c00202d9:	b9 03 00 00 00       	mov    $0x3,%ecx
c00202de:	f3 a6                	repz cmpsb %es:(%edi),%ds:(%esi)
c00202e0:	0f 97 c1             	seta   %cl
c00202e3:	0f 92 c2             	setb   %dl
c00202e6:	83 c4 10             	add    $0x10,%esp
c00202e9:	38 d1                	cmp    %dl,%cl
c00202eb:	74 8c                	je     c0020279 <pintos_init+0xe6>
      else if (!strcmp (name, "-q"))
c00202ed:	bf bd cb 02 c0       	mov    $0xc002cbbd,%edi
c00202f2:	b9 03 00 00 00       	mov    $0x3,%ecx
c00202f7:	8b 34 24             	mov    (%esp),%esi
c00202fa:	f3 a6                	repz cmpsb %es:(%edi),%ds:(%esi)
c00202fc:	0f 97 c1             	seta   %cl
c00202ff:	0f 92 c2             	setb   %dl
c0020302:	38 d1                	cmp    %dl,%cl
c0020304:	74 85                	je     c002028b <pintos_init+0xf8>
      else if (!strcmp (name, "-r"))
c0020306:	bf c0 cb 02 c0       	mov    $0xc002cbc0,%edi
c002030b:	b9 03 00 00 00       	mov    $0x3,%ecx
c0020310:	8b 34 24             	mov    (%esp),%esi
c0020313:	f3 a6                	repz cmpsb %es:(%edi),%ds:(%esi)
c0020315:	0f 97 c1             	seta   %cl
c0020318:	0f 92 c2             	setb   %dl
c002031b:	38 d1                	cmp    %dl,%cl
c002031d:	74 3e                	je     c002035d <pintos_init+0x1ca>
      else if (!strcmp (name, "-rs"))
c002031f:	bf c3 cb 02 c0       	mov    $0xc002cbc3,%edi
c0020324:	b9 04 00 00 00       	mov    $0x4,%ecx
c0020329:	8b 34 24             	mov    (%esp),%esi
c002032c:	f3 a6                	repz cmpsb %es:(%edi),%ds:(%esi)
c002032e:	0f 97 c1             	seta   %cl
c0020331:	0f 92 c2             	setb   %dl
c0020334:	38 d1                	cmp    %dl,%cl
c0020336:	74 37                	je     c002036f <pintos_init+0x1dc>
      else if (!strcmp (name, "-mlfqs"))
c0020338:	bf c7 cb 02 c0       	mov    $0xc002cbc7,%edi
c002033d:	b9 07 00 00 00       	mov    $0x7,%ecx
c0020342:	8b 34 24             	mov    (%esp),%esi
c0020345:	f3 a6                	repz cmpsb %es:(%edi),%ds:(%esi)
c0020347:	0f 97 c2             	seta   %dl
c002034a:	0f 92 c0             	setb   %al
c002034d:	38 c2                	cmp    %al,%dl
c002034f:	75 37                	jne    c0020388 <pintos_init+0x1f5>
        thread_mlfqs = true;
c0020351:	c6 05 6c 83 03 c0 01 	movb   $0x1,0xc003836c
c0020358:	e9 3b ff ff ff       	jmp    c0020298 <pintos_init+0x105>
        shutdown_configure (SHUTDOWN_REBOOT);
c002035d:	83 ec 0c             	sub    $0xc,%esp
c0020360:	6a 02                	push   $0x2
c0020362:	e8 78 50 00 00       	call   c00253df <shutdown_configure>
c0020367:	83 c4 10             	add    $0x10,%esp
c002036a:	e9 29 ff ff ff       	jmp    c0020298 <pintos_init+0x105>
        random_init (atoi (value));
c002036f:	83 ec 0c             	sub    $0xc,%esp
c0020372:	50                   	push   %eax
c0020373:	e8 64 63 00 00       	call   c00266dc <atoi>
c0020378:	89 04 24             	mov    %eax,(%esp)
c002037b:	e8 8f 52 00 00       	call   c002560f <random_init>
c0020380:	83 c4 10             	add    $0x10,%esp
c0020383:	e9 10 ff ff ff       	jmp    c0020298 <pintos_init+0x105>
        PANIC ("unknown option `%s' (use -h for help)", name);
c0020388:	83 ec 0c             	sub    $0xc,%esp
c002038b:	ff 74 24 0c          	pushl  0xc(%esp)
c002038f:	68 4c ce 02 c0       	push   $0xc002ce4c
c0020394:	68 d8 b4 02 c0       	push   $0xc002b4d8
c0020399:	68 0c 01 00 00       	push   $0x10c
c002039e:	68 9f cb 02 c0       	push   $0xc002cb9f
c00203a3:	e8 98 72 00 00       	call   c0027640 <debug_panic>
  for (; *argv != NULL && **argv == '-'; argv++)
c00203a8:	bd c0 67 03 c0       	mov    $0xc00367c0,%ebp
  random_init (rtc_get_time ());
c00203ad:	e8 9a 4e 00 00       	call   c002524c <rtc_get_time>
c00203b2:	83 ec 0c             	sub    $0xc,%esp
c00203b5:	50                   	push   %eax
c00203b6:	e8 54 52 00 00       	call   c002560f <random_init>
  thread_init ();
c00203bb:	e8 1a 04 00 00       	call   c00207da <thread_init>
  console_init ();  
c00203c0:	e8 58 8c 00 00       	call   c002901d <console_init>
  printf ("Pintos booting with %'"PRIu32" kB RAM...\n",
c00203c5:	83 c4 08             	add    $0x8,%esp
          init_ram_pages * PGSIZE / 1024);
c00203c8:	a1 5e 01 02 c0       	mov    0xc002015e,%eax
c00203cd:	c1 e0 0c             	shl    $0xc,%eax
  printf ("Pintos booting with %'"PRIu32" kB RAM...\n",
c00203d0:	c1 e8 0a             	shr    $0xa,%eax
c00203d3:	50                   	push   %eax
c00203d4:	68 74 ce 02 c0       	push   $0xc002ce74
c00203d9:	e8 b4 57 00 00       	call   c0025b92 <printf>
  palloc_init (user_page_limit);
c00203de:	c7 04 24 ff ff ff ff 	movl   $0xffffffff,(%esp)
c00203e5:	e8 2c 24 00 00       	call   c0022816 <palloc_init>
  malloc_init ();
c00203ea:	e8 d6 27 00 00       	call   c0022bc5 <malloc_init>
  pd = init_page_dir = palloc_get_page (PAL_ASSERT | PAL_ZERO);
c00203ef:	c7 04 24 03 00 00 00 	movl   $0x3,(%esp)
c00203f6:	e8 44 25 00 00       	call   c002293f <palloc_get_page>
c00203fb:	89 44 24 18          	mov    %eax,0x18(%esp)
c00203ff:	a3 68 83 03 c0       	mov    %eax,0xc0038368
  for (page = 0; page < init_ram_pages; page++)
c0020404:	83 c4 10             	add    $0x10,%esp
c0020407:	83 3d 5e 01 02 c0 00 	cmpl   $0x0,0xc002015e
c002040e:	0f 84 23 01 00 00    	je     c0020537 <pintos_init+0x3a4>
c0020414:	bf 00 00 00 c0       	mov    $0xc0000000,%edi
c0020419:	b8 00 00 00 00       	mov    $0x0,%eax
c002041e:	be 00 00 00 00       	mov    $0x0,%esi
      bool in_kernel_text = &_start <= vaddr && vaddr < &_end_kernel_text;
c0020423:	89 6c 24 0c          	mov    %ebp,0xc(%esp)
c0020427:	eb 5b                	jmp    c0020484 <pintos_init+0x2f1>
  for (; *argv != NULL && **argv == '-'; argv++)
c0020429:	bd c0 67 03 c0       	mov    $0xc00367c0,%ebp
c002042e:	e9 7a ff ff ff       	jmp    c00203ad <pintos_init+0x21a>
      bool in_kernel_text = &_start <= vaddr && vaddr < &_end_kernel_text;
c0020433:	b1 00                	mov    $0x0,%cl
c0020435:	83 e1 01             	and    $0x1,%ecx
c0020438:	88 0c 24             	mov    %cl,(%esp)
      if (pd[pde_idx] == 0)
c002043b:	8b 4c 24 08          	mov    0x8(%esp),%ecx
c002043f:	8d 2c 91             	lea    (%ecx,%edx,4),%ebp
c0020442:	83 7d 00 00          	cmpl   $0x0,0x0(%ebp)
c0020446:	74 63                	je     c00204ab <pintos_init+0x318>
      pt[pte_idx] = pte_create_kernel (vaddr, !in_kernel_text);
c0020448:	8d 0c 98             	lea    (%eax,%ebx,4),%ecx
/* Returns physical address at which kernel virtual address VADDR
   is mapped. */
static inline uintptr_t
vtop (const void *vaddr)
{
  ASSERT (is_kernel_vaddr (vaddr));
c002044b:	81 7c 24 04 ff ff ff 	cmpl   $0xbfffffff,0x4(%esp)
c0020452:	bf 
c0020453:	0f 86 bc 00 00 00    	jbe    c0020515 <pintos_init+0x382>

  return (uintptr_t) vaddr - (uintptr_t) PHYS_BASE;
c0020459:	8d 97 00 00 00 40    	lea    0x40000000(%edi),%edx
   The PTE's page is readable.
   If WRITABLE is true then it will be writable as well.
   The page will be usable only by ring 0 code (the kernel). */
static inline uint32_t pte_create_kernel (void *page, bool writable) {
  ASSERT (pg_ofs (page) == 0);
  return vtop (page) | PTE_P | (writable ? PTE_W : 0);
c002045f:	8a 1c 24             	mov    (%esp),%bl
c0020462:	83 f3 01             	xor    $0x1,%ebx
c0020465:	0f b6 db             	movzbl %bl,%ebx
c0020468:	d1 e3                	shl    %ebx
c002046a:	83 ca 01             	or     $0x1,%edx
c002046d:	09 da                	or     %ebx,%edx
c002046f:	89 11                	mov    %edx,(%ecx)
  for (page = 0; page < init_ram_pages; page++)
c0020471:	46                   	inc    %esi
c0020472:	3b 35 5e 01 02 c0    	cmp    0xc002015e,%esi
c0020478:	0f 83 b5 00 00 00    	jae    c0020533 <pintos_init+0x3a0>
c002047e:	81 c7 00 10 00 00    	add    $0x1000,%edi
  return (uintptr_t) va >> PDSHIFT;
c0020484:	89 fa                	mov    %edi,%edx
c0020486:	c1 ea 16             	shr    $0x16,%edx
  return ((uintptr_t) va & PTMASK) >> PTSHIFT;
c0020489:	89 fb                	mov    %edi,%ebx
c002048b:	c1 eb 0c             	shr    $0xc,%ebx
c002048e:	81 e3 ff 03 00 00    	and    $0x3ff,%ebx
c0020494:	89 7c 24 04          	mov    %edi,0x4(%esp)
      bool in_kernel_text = &_start <= vaddr && vaddr < &_end_kernel_text;
c0020498:	81 ff 00 00 02 c0    	cmp    $0xc0020000,%edi
c002049e:	72 93                	jb     c0020433 <pintos_init+0x2a0>
c00204a0:	81 ff 00 00 03 c0    	cmp    $0xc0030000,%edi
c00204a6:	0f 92 c1             	setb   %cl
c00204a9:	eb 8a                	jmp    c0020435 <pintos_init+0x2a2>
          pt = palloc_get_page (PAL_ASSERT | PAL_ZERO);
c00204ab:	83 ec 0c             	sub    $0xc,%esp
c00204ae:	6a 03                	push   $0x3
c00204b0:	e8 8a 24 00 00       	call   c002293f <palloc_get_page>
  return (uintptr_t) va & PGMASK;
c00204b5:	89 c2                	mov    %eax,%edx
  ASSERT (pg_ofs (pt) == 0);
c00204b7:	83 c4 10             	add    $0x10,%esp
c00204ba:	a9 ff 0f 00 00       	test   $0xfff,%eax
c00204bf:	75 18                	jne    c00204d9 <pintos_init+0x346>
  ASSERT (is_kernel_vaddr (vaddr));
c00204c1:	3d ff ff ff bf       	cmp    $0xbfffffff,%eax
c00204c6:	76 2f                	jbe    c00204f7 <pintos_init+0x364>
  return (uintptr_t) vaddr - (uintptr_t) PHYS_BASE;
c00204c8:	81 c2 00 00 00 40    	add    $0x40000000,%edx
  return vtop (pt) | PTE_U | PTE_P | PTE_W;
c00204ce:	83 ca 07             	or     $0x7,%edx
c00204d1:	89 55 00             	mov    %edx,0x0(%ebp)
c00204d4:	e9 6f ff ff ff       	jmp    c0020448 <pintos_init+0x2b5>
  ASSERT (pg_ofs (pt) == 0);
c00204d9:	83 ec 0c             	sub    $0xc,%esp
c00204dc:	68 ce cb 02 c0       	push   $0xc002cbce
c00204e1:	68 df cb 02 c0       	push   $0xc002cbdf
c00204e6:	68 cc b4 02 c0       	push   $0xc002b4cc
c00204eb:	6a 48                	push   $0x48
c00204ed:	68 f6 cb 02 c0       	push   $0xc002cbf6
c00204f2:	e8 49 71 00 00       	call   c0027640 <debug_panic>
  ASSERT (is_kernel_vaddr (vaddr));
c00204f7:	83 ec 0c             	sub    $0xc,%esp
c00204fa:	68 0a cc 02 c0       	push   $0xc002cc0a
c00204ff:	68 df cb 02 c0       	push   $0xc002cbdf
c0020504:	68 c4 b4 02 c0       	push   $0xc002b4c4
c0020509:	6a 54                	push   $0x54
c002050b:	68 22 cc 02 c0       	push   $0xc002cc22
c0020510:	e8 2b 71 00 00       	call   c0027640 <debug_panic>
c0020515:	83 ec 0c             	sub    $0xc,%esp
c0020518:	68 0a cc 02 c0       	push   $0xc002cc0a
c002051d:	68 df cb 02 c0       	push   $0xc002cbdf
c0020522:	68 c4 b4 02 c0       	push   $0xc002b4c4
c0020527:	6a 54                	push   $0x54
c0020529:	68 22 cc 02 c0       	push   $0xc002cc22
c002052e:	e8 0d 71 00 00       	call   c0027640 <debug_panic>
c0020533:	8b 6c 24 0c          	mov    0xc(%esp),%ebp
  asm volatile ("movl %0, %%cr3" : : "r" (vtop (init_page_dir)));
c0020537:	a1 68 83 03 c0       	mov    0xc0038368,%eax
c002053c:	3d ff ff ff bf       	cmp    $0xbfffffff,%eax
c0020541:	76 4d                	jbe    c0020590 <pintos_init+0x3fd>
  return (uintptr_t) vaddr - (uintptr_t) PHYS_BASE;
c0020543:	05 00 00 00 40       	add    $0x40000000,%eax
c0020548:	0f 22 d8             	mov    %eax,%cr3
  intr_init ();
c002054b:	e8 54 0b 00 00       	call   c00210a4 <intr_init>
  timer_init ();
c0020550:	e8 35 2c 00 00       	call   c002318a <timer_init>
  kbd_init ();
c0020555:	e8 ea 30 00 00       	call   c0023644 <kbd_init>
  input_init ();
c002055a:	e8 81 48 00 00       	call   c0024de0 <input_init>
  thread_start ();
c002055f:	e8 b5 04 00 00       	call   c0020a19 <thread_start>
  serial_init_queue ();
c0020564:	e8 df 34 00 00       	call   c0023a48 <serial_init_queue>
  timer_calibrate ();
c0020569:	e8 42 2c 00 00       	call   c00231b0 <timer_calibrate>
  printf ("Boot complete.\n");
c002056e:	83 ec 0c             	sub    $0xc,%esp
c0020571:	68 38 cc 02 c0       	push   $0xc002cc38
c0020576:	e8 13 8b 00 00       	call   c002908e <puts>
  if (*argv != NULL) {
c002057b:	8b 75 00             	mov    0x0(%ebp),%esi
c002057e:	83 c4 10             	add    $0x10,%esp
c0020581:	85 f6                	test   %esi,%esi
c0020583:	0f 84 b9 00 00 00    	je     c0020642 <pintos_init+0x4af>
  return vtop (page) | PTE_P | (writable ? PTE_W : 0);
c0020589:	bf a2 d1 02 c0       	mov    $0xc002d1a2,%edi
c002058e:	eb 74                	jmp    c0020604 <pintos_init+0x471>
  ASSERT (is_kernel_vaddr (vaddr));
c0020590:	83 ec 0c             	sub    $0xc,%esp
c0020593:	68 0a cc 02 c0       	push   $0xc002cc0a
c0020598:	68 df cb 02 c0       	push   $0xc002cbdf
c002059d:	68 c4 b4 02 c0       	push   $0xc002b4c4
c00205a2:	6a 54                	push   $0x54
c00205a4:	68 22 cc 02 c0       	push   $0xc002cc22
c00205a9:	e8 92 70 00 00       	call   c0027640 <debug_panic>
      for (i = 1; i < a->argc; i++)
c00205ae:	8b 53 04             	mov    0x4(%ebx),%edx
c00205b1:	83 fa 01             	cmp    $0x1,%edx
c00205b4:	7e 36                	jle    c00205ec <pintos_init+0x459>
        if (argv[i] == NULL)
c00205b6:	83 7d 04 00          	cmpl   $0x0,0x4(%ebp)
c00205ba:	74 11                	je     c00205cd <pintos_init+0x43a>
c00205bc:	b8 01 00 00 00       	mov    $0x1,%eax
      for (i = 1; i < a->argc; i++)
c00205c1:	40                   	inc    %eax
c00205c2:	39 d0                	cmp    %edx,%eax
c00205c4:	74 26                	je     c00205ec <pintos_init+0x459>
        if (argv[i] == NULL)
c00205c6:	83 7c 85 00 00       	cmpl   $0x0,0x0(%ebp,%eax,4)
c00205cb:	75 f4                	jne    c00205c1 <pintos_init+0x42e>
          PANIC ("action `%s' requires %d argument(s)", *argv, a->argc - 1);
c00205cd:	83 ec 08             	sub    $0x8,%esp
c00205d0:	4a                   	dec    %edx
c00205d1:	52                   	push   %edx
c00205d2:	56                   	push   %esi
c00205d3:	68 c0 ce 02 c0       	push   $0xc002cec0
c00205d8:	68 a0 b4 02 c0       	push   $0xc002b4a0
c00205dd:	68 55 01 00 00       	push   $0x155
c00205e2:	68 9f cb 02 c0       	push   $0xc002cb9f
c00205e7:	e8 54 70 00 00       	call   c0027640 <debug_panic>
      a->function (argv);
c00205ec:	83 ec 0c             	sub    $0xc,%esp
c00205ef:	55                   	push   %ebp
c00205f0:	ff 53 08             	call   *0x8(%ebx)
      argv += a->argc;
c00205f3:	8b 43 04             	mov    0x4(%ebx),%eax
c00205f6:	8d 6c 85 00          	lea    0x0(%ebp,%eax,4),%ebp
  while (*argv != NULL)
c00205fa:	8b 75 00             	mov    0x0(%ebp),%esi
c00205fd:	83 c4 10             	add    $0x10,%esp
c0020600:	85 f6                	test   %esi,%esi
c0020602:	74 3e                	je     c0020642 <pintos_init+0x4af>
c0020604:	89 f8                	mov    %edi,%eax
c0020606:	bb ac b4 02 c0       	mov    $0xc002b4ac,%ebx
        else if (!strcmp (*argv, a->name))
c002060b:	83 ec 08             	sub    $0x8,%esp
c002060e:	50                   	push   %eax
c002060f:	56                   	push   %esi
c0020610:	e8 e0 63 00 00       	call   c00269f5 <strcmp>
c0020615:	83 c4 10             	add    $0x10,%esp
c0020618:	85 c0                	test   %eax,%eax
c002061a:	74 92                	je     c00205ae <pintos_init+0x41b>
      for (a = actions; ; a++)
c002061c:	83 c3 0c             	add    $0xc,%ebx
        if (a->name == NULL)
c002061f:	8b 03                	mov    (%ebx),%eax
c0020621:	85 c0                	test   %eax,%eax
c0020623:	75 e6                	jne    c002060b <pintos_init+0x478>
          PANIC ("unknown action `%s' (use -h for help)", *argv);
c0020625:	83 ec 0c             	sub    $0xc,%esp
c0020628:	56                   	push   %esi
c0020629:	68 98 ce 02 c0       	push   $0xc002ce98
c002062e:	68 a0 b4 02 c0       	push   $0xc002b4a0
c0020633:	68 4e 01 00 00       	push   $0x14e
c0020638:	68 9f cb 02 c0       	push   $0xc002cb9f
c002063d:	e8 fe 6f 00 00       	call   c0027640 <debug_panic>
  shutdown ();
c0020642:	e8 8d 4e 00 00       	call   c00254d4 <shutdown>
  thread_exit ();
c0020647:	e8 88 07 00 00       	call   c0020dd4 <thread_exit>
  argv[argc] = NULL;
c002064c:	c7 04 b5 c0 67 03 c0 	movl   $0x0,-0x3ffc9840(,%esi,4)
c0020653:	00 00 00 00 
  printf ("Kernel command line:");
c0020657:	83 ec 0c             	sub    $0xc,%esp
c002065a:	68 47 cc 02 c0       	push   $0xc002cc47
c002065f:	e8 2e 55 00 00       	call   c0025b92 <printf>
c0020664:	83 c4 10             	add    $0x10,%esp
  printf ("\n");
c0020667:	83 ec 0c             	sub    $0xc,%esp
c002066a:	6a 0a                	push   $0xa
c002066c:	e8 89 8a 00 00       	call   c00290fa <putchar>
  for (; *argv != NULL && **argv == '-'; argv++)
c0020671:	a1 c0 67 03 c0       	mov    0xc00367c0,%eax
c0020676:	83 c4 10             	add    $0x10,%esp
c0020679:	85 c0                	test   %eax,%eax
c002067b:	0f 84 27 fd ff ff    	je     c00203a8 <pintos_init+0x215>
c0020681:	80 38 2d             	cmpb   $0x2d,(%eax)
c0020684:	0f 85 9f fd ff ff    	jne    c0020429 <pintos_init+0x296>
c002068a:	bd c0 67 03 c0       	mov    $0xc00367c0,%ebp
      char *name = strtok_r (*argv, "=", &save_ptr);
c002068f:	8d 5c 24 1c          	lea    0x1c(%esp),%ebx
c0020693:	e9 17 fc ff ff       	jmp    c00202af <pintos_init+0x11c>

c0020698 <alloc_frame>:

/* Allocates a SIZE-byte frame at the top of thread T's stack and
   returns a pointer to the frame's base. */
static void *
alloc_frame (struct thread *t, size_t size) 
{
c0020698:	83 ec 0c             	sub    $0xc,%esp
  return t != NULL && t->magic == THREAD_MAGIC;
c002069b:	85 c0                	test   %eax,%eax
c002069d:	74 09                	je     c00206a8 <alloc_frame+0x10>
c002069f:	81 78 30 4b bf 6a cd 	cmpl   $0xcd6abf4b,0x30(%eax)
c00206a6:	74 42                	je     c00206ea <alloc_frame+0x52>
  /* Stack data is always allocated in word-size units. */
  ASSERT (is_thread (t));
c00206a8:	83 ec 0c             	sub    $0xc,%esp
c00206ab:	68 19 cf 02 c0       	push   $0xc002cf19
c00206b0:	68 df cb 02 c0       	push   $0xc002cbdf
c00206b5:	68 7c b5 02 c0       	push   $0xc002b57c
c00206ba:	68 de 01 00 00       	push   $0x1de
c00206bf:	68 02 cf 02 c0       	push   $0xc002cf02
c00206c4:	e8 77 6f 00 00       	call   c0027640 <debug_panic>
  ASSERT (size % sizeof (uint32_t) == 0);
c00206c9:	83 ec 0c             	sub    $0xc,%esp
c00206cc:	68 e4 ce 02 c0       	push   $0xc002cee4
c00206d1:	68 df cb 02 c0       	push   $0xc002cbdf
c00206d6:	68 7c b5 02 c0       	push   $0xc002b57c
c00206db:	68 df 01 00 00       	push   $0x1df
c00206e0:	68 02 cf 02 c0       	push   $0xc002cf02
c00206e5:	e8 56 6f 00 00       	call   c0027640 <debug_panic>
c00206ea:	f6 c2 03             	test   $0x3,%dl
c00206ed:	75 da                	jne    c00206c9 <alloc_frame+0x31>

  t->stack -= size;
c00206ef:	8b 48 18             	mov    0x18(%eax),%ecx
c00206f2:	29 d1                	sub    %edx,%ecx
c00206f4:	89 48 18             	mov    %ecx,0x18(%eax)
  return t->stack;
}
c00206f7:	89 c8                	mov    %ecx,%eax
c00206f9:	83 c4 0c             	add    $0xc,%esp
c00206fc:	c3                   	ret    

c00206fd <init_thread>:
{
c00206fd:	57                   	push   %edi
c00206fe:	56                   	push   %esi
c00206ff:	53                   	push   %ebx
  ASSERT (t != NULL);
c0020700:	85 c0                	test   %eax,%eax
c0020702:	74 73                	je     c0020777 <init_thread+0x7a>
c0020704:	89 c3                	mov    %eax,%ebx
c0020706:	89 ce                	mov    %ecx,%esi
  ASSERT (PRI_MIN <= priority && priority <= PRI_MAX);
c0020708:	83 f9 3f             	cmp    $0x3f,%ecx
c002070b:	0f 87 87 00 00 00    	ja     c0020798 <init_thread+0x9b>
  ASSERT (name != NULL);
c0020711:	85 d2                	test   %edx,%edx
c0020713:	0f 84 a0 00 00 00    	je     c00207b9 <init_thread+0xbc>
  memset (t, 0, sizeof *t);
c0020719:	b9 0d 00 00 00       	mov    $0xd,%ecx
c002071e:	b8 00 00 00 00       	mov    $0x0,%eax
c0020723:	89 df                	mov    %ebx,%edi
c0020725:	f3 ab                	rep stos %eax,%es:(%edi)
  t->status = THREAD_BLOCKED;
c0020727:	c7 43 04 02 00 00 00 	movl   $0x2,0x4(%ebx)
  strlcpy (t->name, name, sizeof t->name);
c002072e:	83 ec 04             	sub    $0x4,%esp
c0020731:	6a 10                	push   $0x10
c0020733:	52                   	push   %edx
c0020734:	8d 43 08             	lea    0x8(%ebx),%eax
c0020737:	50                   	push   %eax
c0020738:	e8 fd 65 00 00       	call   c0026d3a <strlcpy>
  t->stack = (uint8_t *) t + PGSIZE;
c002073d:	8d 83 00 10 00 00    	lea    0x1000(%ebx),%eax
c0020743:	89 43 18             	mov    %eax,0x18(%ebx)
  t->priority = priority;
c0020746:	89 73 1c             	mov    %esi,0x1c(%ebx)
  t->magic = THREAD_MAGIC;
c0020749:	c7 43 30 4b bf 6a cd 	movl   $0xcd6abf4b,0x30(%ebx)
  old_level = intr_disable ();
c0020750:	e8 2e 09 00 00       	call   c0021083 <intr_disable>
c0020755:	89 c6                	mov    %eax,%esi
  list_push_back (&all_list, &t->allelem);
c0020757:	83 c4 08             	add    $0x8,%esp
c002075a:	83 c3 20             	add    $0x20,%ebx
c002075d:	53                   	push   %ebx
c002075e:	68 00 69 03 c0       	push   $0xc0036900
c0020763:	e8 1c 74 00 00       	call   c0027b84 <list_push_back>
  intr_set_level (old_level);
c0020768:	89 34 24             	mov    %esi,(%esp)
c002076b:	e8 1a 09 00 00       	call   c002108a <intr_set_level>
}
c0020770:	83 c4 10             	add    $0x10,%esp
c0020773:	5b                   	pop    %ebx
c0020774:	5e                   	pop    %esi
c0020775:	5f                   	pop    %edi
c0020776:	c3                   	ret    
  ASSERT (t != NULL);
c0020777:	83 ec 0c             	sub    $0xc,%esp
c002077a:	68 db e3 02 c0       	push   $0xc002e3db
c002077f:	68 df cb 02 c0       	push   $0xc002cbdf
c0020784:	68 a8 b5 02 c0       	push   $0xc002b5a8
c0020789:	68 c8 01 00 00       	push   $0x1c8
c002078e:	68 02 cf 02 c0       	push   $0xc002cf02
c0020793:	e8 a8 6e 00 00       	call   c0027640 <debug_panic>
  ASSERT (PRI_MIN <= priority && priority <= PRI_MAX);
c0020798:	83 ec 0c             	sub    $0xc,%esp
c002079b:	68 f4 cf 02 c0       	push   $0xc002cff4
c00207a0:	68 df cb 02 c0       	push   $0xc002cbdf
c00207a5:	68 a8 b5 02 c0       	push   $0xc002b5a8
c00207aa:	68 c9 01 00 00       	push   $0x1c9
c00207af:	68 02 cf 02 c0       	push   $0xc002cf02
c00207b4:	e8 87 6e 00 00       	call   c0027640 <debug_panic>
  ASSERT (name != NULL);
c00207b9:	83 ec 0c             	sub    $0xc,%esp
c00207bc:	68 27 cf 02 c0       	push   $0xc002cf27
c00207c1:	68 df cb 02 c0       	push   $0xc002cbdf
c00207c6:	68 a8 b5 02 c0       	push   $0xc002b5a8
c00207cb:	68 ca 01 00 00       	push   $0x1ca
c00207d0:	68 02 cf 02 c0       	push   $0xc002cf02
c00207d5:	e8 66 6e 00 00       	call   c0027640 <debug_panic>

c00207da <thread_init>:
{
c00207da:	56                   	push   %esi
c00207db:	53                   	push   %ebx
c00207dc:	83 ec 04             	sub    $0x4,%esp
  ASSERT (intr_get_level () == INTR_OFF);
c00207df:	e8 62 08 00 00       	call   c0021046 <intr_get_level>
c00207e4:	85 c0                	test   %eax,%eax
c00207e6:	75 7b                	jne    c0020863 <thread_init+0x89>
  lock_init (&tid_lock);
c00207e8:	83 ec 0c             	sub    $0xc,%esp
c00207eb:	68 e0 68 03 c0       	push   $0xc00368e0
c00207f0:	e8 ef 1a 00 00       	call   c00222e4 <lock_init>
  list_init (&ready_list);
c00207f5:	c7 04 24 10 69 03 c0 	movl   $0xc0036910,(%esp)
c00207fc:	e8 e6 6e 00 00       	call   c00276e7 <list_init>
  list_init (&all_list);
c0020801:	c7 04 24 00 69 03 c0 	movl   $0xc0036900,(%esp)
c0020808:	e8 da 6e 00 00       	call   c00276e7 <list_init>
  asm ("mov %%esp, %0" : "=g" (esp));
c002080d:	89 e0                	mov    %esp,%eax
  return (void *) ((uintptr_t) va & ~PGMASK);
c002080f:	25 00 f0 ff ff       	and    $0xfffff000,%eax
  initial_thread = running_thread ();
c0020814:	a3 f8 68 03 c0       	mov    %eax,0xc00368f8
  init_thread (initial_thread, "main", PRI_DEFAULT);
c0020819:	b9 1f 00 00 00       	mov    $0x1f,%ecx
c002081e:	ba 52 cf 02 c0       	mov    $0xc002cf52,%edx
c0020823:	e8 d5 fe ff ff       	call   c00206fd <init_thread>
  initial_thread->status = THREAD_RUNNING;
c0020828:	8b 1d f8 68 03 c0    	mov    0xc00368f8,%ebx
c002082e:	c7 43 04 00 00 00 00 	movl   $0x0,0x4(%ebx)
allocate_tid (void) 
{
  static tid_t next_tid = 1;
  tid_t tid;

  lock_acquire (&tid_lock);
c0020835:	c7 04 24 e0 68 03 c0 	movl   $0xc00368e0,(%esp)
c002083c:	e8 25 1b 00 00       	call   c0022366 <lock_acquire>
  tid = next_tid++;
c0020841:	8b 35 6c 63 03 c0    	mov    0xc003636c,%esi
c0020847:	8d 46 01             	lea    0x1(%esi),%eax
c002084a:	a3 6c 63 03 c0       	mov    %eax,0xc003636c
  lock_release (&tid_lock);
c002084f:	c7 04 24 e0 68 03 c0 	movl   $0xc00368e0,(%esp)
c0020856:	e8 30 1c 00 00       	call   c002248b <lock_release>
  initial_thread->tid = allocate_tid ();
c002085b:	89 33                	mov    %esi,(%ebx)
}
c002085d:	83 c4 14             	add    $0x14,%esp
c0020860:	5b                   	pop    %ebx
c0020861:	5e                   	pop    %esi
c0020862:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0020863:	83 ec 0c             	sub    $0xc,%esp
c0020866:	68 34 cf 02 c0       	push   $0xc002cf34
c002086b:	68 df cb 02 c0       	push   $0xc002cbdf
c0020870:	68 b4 b5 02 c0       	push   $0xc002b5b4
c0020875:	6a 5a                	push   $0x5a
c0020877:	68 02 cf 02 c0       	push   $0xc002cf02
c002087c:	e8 bf 6d 00 00       	call   c0027640 <debug_panic>

c0020881 <thread_print_stats>:
{
c0020881:	83 ec 10             	sub    $0x10,%esp
  printf ("Thread: %lld idle ticks, %lld kernel ticks, %lld user ticks\n",
c0020884:	6a 00                	push   $0x0
c0020886:	6a 00                	push   $0x0
c0020888:	ff 35 d4 68 03 c0    	pushl  0xc00368d4
c002088e:	ff 35 d0 68 03 c0    	pushl  0xc00368d0
c0020894:	ff 35 dc 68 03 c0    	pushl  0xc00368dc
c002089a:	ff 35 d8 68 03 c0    	pushl  0xc00368d8
c00208a0:	68 20 d0 02 c0       	push   $0xc002d020
c00208a5:	e8 e8 52 00 00       	call   c0025b92 <printf>
}
c00208aa:	83 c4 2c             	add    $0x2c,%esp
c00208ad:	c3                   	ret    

c00208ae <thread_unblock>:
{
c00208ae:	56                   	push   %esi
c00208af:	53                   	push   %ebx
c00208b0:	83 ec 04             	sub    $0x4,%esp
c00208b3:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  return t != NULL && t->magic == THREAD_MAGIC;
c00208b7:	85 db                	test   %ebx,%ebx
c00208b9:	74 09                	je     c00208c4 <thread_unblock+0x16>
c00208bb:	81 7b 30 4b bf 6a cd 	cmpl   $0xcd6abf4b,0x30(%ebx)
c00208c2:	74 42                	je     c0020906 <thread_unblock+0x58>
  ASSERT (is_thread (t));
c00208c4:	83 ec 0c             	sub    $0xc,%esp
c00208c7:	68 19 cf 02 c0       	push   $0xc002cf19
c00208cc:	68 df cb 02 c0       	push   $0xc002cbdf
c00208d1:	68 50 b5 02 c0       	push   $0xc002b550
c00208d6:	68 ec 00 00 00       	push   $0xec
c00208db:	68 02 cf 02 c0       	push   $0xc002cf02
c00208e0:	e8 5b 6d 00 00       	call   c0027640 <debug_panic>
  ASSERT (t->status == THREAD_BLOCKED);
c00208e5:	83 ec 0c             	sub    $0xc,%esp
c00208e8:	68 57 cf 02 c0       	push   $0xc002cf57
c00208ed:	68 df cb 02 c0       	push   $0xc002cbdf
c00208f2:	68 50 b5 02 c0       	push   $0xc002b550
c00208f7:	68 ef 00 00 00       	push   $0xef
c00208fc:	68 02 cf 02 c0       	push   $0xc002cf02
c0020901:	e8 3a 6d 00 00       	call   c0027640 <debug_panic>
  old_level = intr_disable ();
c0020906:	e8 78 07 00 00       	call   c0021083 <intr_disable>
c002090b:	89 c6                	mov    %eax,%esi
  ASSERT (t->status == THREAD_BLOCKED);
c002090d:	83 7b 04 02          	cmpl   $0x2,0x4(%ebx)
c0020911:	75 d2                	jne    c00208e5 <thread_unblock+0x37>
  list_push_back (&ready_list, &t->elem);
c0020913:	83 ec 08             	sub    $0x8,%esp
c0020916:	8d 43 28             	lea    0x28(%ebx),%eax
c0020919:	50                   	push   %eax
c002091a:	68 10 69 03 c0       	push   $0xc0036910
c002091f:	e8 60 72 00 00       	call   c0027b84 <list_push_back>
  t->status = THREAD_READY;
c0020924:	c7 43 04 01 00 00 00 	movl   $0x1,0x4(%ebx)
  intr_set_level (old_level);
c002092b:	89 34 24             	mov    %esi,(%esp)
c002092e:	e8 57 07 00 00       	call   c002108a <intr_set_level>
}
c0020933:	83 c4 10             	add    $0x10,%esp
c0020936:	83 c4 04             	add    $0x4,%esp
c0020939:	5b                   	pop    %ebx
c002093a:	5e                   	pop    %esi
c002093b:	c3                   	ret    

c002093c <thread_create>:
{
c002093c:	57                   	push   %edi
c002093d:	56                   	push   %esi
c002093e:	53                   	push   %ebx
c002093f:	8b 7c 24 18          	mov    0x18(%esp),%edi
  ASSERT (function != NULL);
c0020943:	85 ff                	test   %edi,%edi
c0020945:	0f 84 a6 00 00 00    	je     c00209f1 <thread_create+0xb5>
  t = palloc_get_page (PAL_ZERO);
c002094b:	83 ec 0c             	sub    $0xc,%esp
c002094e:	6a 02                	push   $0x2
c0020950:	e8 ea 1f 00 00       	call   c002293f <palloc_get_page>
c0020955:	89 c3                	mov    %eax,%ebx
  if (t == NULL)
c0020957:	83 c4 10             	add    $0x10,%esp
c002095a:	85 c0                	test   %eax,%eax
c002095c:	0f 84 b0 00 00 00    	je     c0020a12 <thread_create+0xd6>
  init_thread (t, name, priority);
c0020962:	8b 4c 24 14          	mov    0x14(%esp),%ecx
c0020966:	8b 54 24 10          	mov    0x10(%esp),%edx
c002096a:	e8 8e fd ff ff       	call   c00206fd <init_thread>
  lock_acquire (&tid_lock);
c002096f:	83 ec 0c             	sub    $0xc,%esp
c0020972:	68 e0 68 03 c0       	push   $0xc00368e0
c0020977:	e8 ea 19 00 00       	call   c0022366 <lock_acquire>
  tid = next_tid++;
c002097c:	8b 35 6c 63 03 c0    	mov    0xc003636c,%esi
c0020982:	8d 46 01             	lea    0x1(%esi),%eax
c0020985:	a3 6c 63 03 c0       	mov    %eax,0xc003636c
  lock_release (&tid_lock);
c002098a:	c7 04 24 e0 68 03 c0 	movl   $0xc00368e0,(%esp)
c0020991:	e8 f5 1a 00 00       	call   c002248b <lock_release>
  tid = t->tid = allocate_tid ();
c0020996:	89 33                	mov    %esi,(%ebx)
  kf = alloc_frame (t, sizeof *kf);
c0020998:	ba 0c 00 00 00       	mov    $0xc,%edx
c002099d:	89 d8                	mov    %ebx,%eax
c002099f:	e8 f4 fc ff ff       	call   c0020698 <alloc_frame>
  kf->eip = NULL;
c00209a4:	c7 00 00 00 00 00    	movl   $0x0,(%eax)
  kf->function = function;
c00209aa:	89 78 04             	mov    %edi,0x4(%eax)
  kf->aux = aux;
c00209ad:	8b 54 24 2c          	mov    0x2c(%esp),%edx
c00209b1:	89 50 08             	mov    %edx,0x8(%eax)
  ef = alloc_frame (t, sizeof *ef);
c00209b4:	ba 04 00 00 00       	mov    $0x4,%edx
c00209b9:	89 d8                	mov    %ebx,%eax
c00209bb:	e8 d8 fc ff ff       	call   c0020698 <alloc_frame>
  ef->eip = (void (*) (void)) kernel_thread;
c00209c0:	c7 00 41 0e 02 c0    	movl   $0xc0020e41,(%eax)
  sf = alloc_frame (t, sizeof *sf);
c00209c6:	ba 1c 00 00 00       	mov    $0x1c,%edx
c00209cb:	89 d8                	mov    %ebx,%eax
c00209cd:	e8 c6 fc ff ff       	call   c0020698 <alloc_frame>
  sf->eip = switch_entry;
c00209d2:	c7 40 10 12 0f 02 c0 	movl   $0xc0020f12,0x10(%eax)
  sf->ebp = 0;
c00209d9:	c7 40 08 00 00 00 00 	movl   $0x0,0x8(%eax)
  thread_unblock (t);
c00209e0:	89 1c 24             	mov    %ebx,(%esp)
c00209e3:	e8 c6 fe ff ff       	call   c00208ae <thread_unblock>
  return tid;
c00209e8:	83 c4 10             	add    $0x10,%esp
}
c00209eb:	89 f0                	mov    %esi,%eax
c00209ed:	5b                   	pop    %ebx
c00209ee:	5e                   	pop    %esi
c00209ef:	5f                   	pop    %edi
c00209f0:	c3                   	ret    
  ASSERT (function != NULL);
c00209f1:	83 ec 0c             	sub    $0xc,%esp
c00209f4:	68 73 cf 02 c0       	push   $0xc002cf73
c00209f9:	68 df cb 02 c0       	push   $0xc002cbdf
c00209fe:	68 98 b5 02 c0       	push   $0xc002b598
c0020a03:	68 af 00 00 00       	push   $0xaf
c0020a08:	68 02 cf 02 c0       	push   $0xc002cf02
c0020a0d:	e8 2e 6c 00 00       	call   c0027640 <debug_panic>
    return TID_ERROR;
c0020a12:	be ff ff ff ff       	mov    $0xffffffff,%esi
c0020a17:	eb d2                	jmp    c00209eb <thread_create+0xaf>

c0020a19 <thread_start>:
{
c0020a19:	53                   	push   %ebx
c0020a1a:	83 ec 30             	sub    $0x30,%esp
  sema_init (&idle_started, 0);
c0020a1d:	6a 00                	push   $0x0
c0020a1f:	8d 5c 24 18          	lea    0x18(%esp),%ebx
c0020a23:	53                   	push   %ebx
c0020a24:	e8 88 16 00 00       	call   c00220b1 <sema_init>
  thread_create ("idle", PRI_MIN, idle, &idle_started);
c0020a29:	53                   	push   %ebx
c0020a2a:	68 aa 0d 02 c0       	push   $0xc0020daa
c0020a2f:	6a 00                	push   $0x0
c0020a31:	68 84 cf 02 c0       	push   $0xc002cf84
c0020a36:	e8 01 ff ff ff       	call   c002093c <thread_create>
  intr_enable ();
c0020a3b:	83 c4 20             	add    $0x20,%esp
c0020a3e:	e8 0c 06 00 00       	call   c002104f <intr_enable>
  sema_down (&idle_started);
c0020a43:	83 ec 0c             	sub    $0xc,%esp
c0020a46:	53                   	push   %ebx
c0020a47:	e8 a4 16 00 00       	call   c00220f0 <sema_down>
}
c0020a4c:	83 c4 38             	add    $0x38,%esp
c0020a4f:	5b                   	pop    %ebx
c0020a50:	c3                   	ret    

c0020a51 <thread_current>:
{
c0020a51:	83 ec 0c             	sub    $0xc,%esp
  asm ("mov %%esp, %0" : "=g" (esp));
c0020a54:	89 e0                	mov    %esp,%eax
  return t != NULL && t->magic == THREAD_MAGIC;
c0020a56:	25 00 f0 ff ff       	and    $0xfffff000,%eax
c0020a5b:	74 09                	je     c0020a66 <thread_current+0x15>
c0020a5d:	81 78 30 4b bf 6a cd 	cmpl   $0xcd6abf4b,0x30(%eax)
c0020a64:	74 42                	je     c0020aa8 <thread_current+0x57>
  ASSERT (is_thread (t));
c0020a66:	83 ec 0c             	sub    $0xc,%esp
c0020a69:	68 19 cf 02 c0       	push   $0xc002cf19
c0020a6e:	68 df cb 02 c0       	push   $0xc002cbdf
c0020a73:	68 40 b5 02 c0       	push   $0xc002b540
c0020a78:	68 09 01 00 00       	push   $0x109
c0020a7d:	68 02 cf 02 c0       	push   $0xc002cf02
c0020a82:	e8 b9 6b 00 00       	call   c0027640 <debug_panic>
  ASSERT (t->status == THREAD_RUNNING);
c0020a87:	83 ec 0c             	sub    $0xc,%esp
c0020a8a:	68 89 cf 02 c0       	push   $0xc002cf89
c0020a8f:	68 df cb 02 c0       	push   $0xc002cbdf
c0020a94:	68 40 b5 02 c0       	push   $0xc002b540
c0020a99:	68 0a 01 00 00       	push   $0x10a
c0020a9e:	68 02 cf 02 c0       	push   $0xc002cf02
c0020aa3:	e8 98 6b 00 00       	call   c0027640 <debug_panic>
c0020aa8:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0020aac:	75 d9                	jne    c0020a87 <thread_current+0x36>
}
c0020aae:	83 c4 0c             	add    $0xc,%esp
c0020ab1:	c3                   	ret    

c0020ab2 <thread_tick>:
{
c0020ab2:	83 ec 0c             	sub    $0xc,%esp
  struct thread *t = thread_current ();
c0020ab5:	e8 97 ff ff ff       	call   c0020a51 <thread_current>
  if (t == idle_thread)
c0020aba:	3b 05 fc 68 03 c0    	cmp    0xc00368fc,%eax
c0020ac0:	74 22                	je     c0020ae4 <thread_tick+0x32>
    kernel_ticks++;
c0020ac2:	83 05 d0 68 03 c0 01 	addl   $0x1,0xc00368d0
c0020ac9:	83 15 d4 68 03 c0 00 	adcl   $0x0,0xc00368d4
  if (++thread_ticks >= TIME_SLICE)
c0020ad0:	a1 c8 68 03 c0       	mov    0xc00368c8,%eax
c0020ad5:	40                   	inc    %eax
c0020ad6:	a3 c8 68 03 c0       	mov    %eax,0xc00368c8
c0020adb:	83 f8 03             	cmp    $0x3,%eax
c0020ade:	77 14                	ja     c0020af4 <thread_tick+0x42>
}
c0020ae0:	83 c4 0c             	add    $0xc,%esp
c0020ae3:	c3                   	ret    
    idle_ticks++;
c0020ae4:	83 05 d8 68 03 c0 01 	addl   $0x1,0xc00368d8
c0020aeb:	83 15 dc 68 03 c0 00 	adcl   $0x0,0xc00368dc
c0020af2:	eb dc                	jmp    c0020ad0 <thread_tick+0x1e>
    intr_yield_on_return ();
c0020af4:	e8 b1 07 00 00       	call   c00212aa <intr_yield_on_return>
}
c0020af9:	eb e5                	jmp    c0020ae0 <thread_tick+0x2e>

c0020afb <thread_name>:
{
c0020afb:	83 ec 0c             	sub    $0xc,%esp
  return thread_current ()->name;
c0020afe:	e8 4e ff ff ff       	call   c0020a51 <thread_current>
c0020b03:	83 c0 08             	add    $0x8,%eax
}
c0020b06:	83 c4 0c             	add    $0xc,%esp
c0020b09:	c3                   	ret    

c0020b0a <thread_tid>:
{
c0020b0a:	83 ec 0c             	sub    $0xc,%esp
  return thread_current ()->tid;
c0020b0d:	e8 3f ff ff ff       	call   c0020a51 <thread_current>
c0020b12:	8b 00                	mov    (%eax),%eax
}
c0020b14:	83 c4 0c             	add    $0xc,%esp
c0020b17:	c3                   	ret    

c0020b18 <thread_foreach>:
{
c0020b18:	57                   	push   %edi
c0020b19:	56                   	push   %esi
c0020b1a:	53                   	push   %ebx
c0020b1b:	8b 74 24 10          	mov    0x10(%esp),%esi
c0020b1f:	8b 7c 24 14          	mov    0x14(%esp),%edi
  ASSERT (intr_get_level () == INTR_OFF);
c0020b23:	e8 1e 05 00 00       	call   c0021046 <intr_get_level>
c0020b28:	85 c0                	test   %eax,%eax
c0020b2a:	75 14                	jne    c0020b40 <thread_foreach+0x28>
  for (e = list_begin (&all_list); e != list_end (&all_list);
c0020b2c:	83 ec 0c             	sub    $0xc,%esp
c0020b2f:	68 00 69 03 c0       	push   $0xc0036900
c0020b34:	e8 f1 6b 00 00       	call   c002772a <list_begin>
c0020b39:	89 c3                	mov    %eax,%ebx
c0020b3b:	83 c4 10             	add    $0x10,%esp
c0020b3e:	eb 38                	jmp    c0020b78 <thread_foreach+0x60>
  ASSERT (intr_get_level () == INTR_OFF);
c0020b40:	83 ec 0c             	sub    $0xc,%esp
c0020b43:	68 34 cf 02 c0       	push   $0xc002cf34
c0020b48:	68 df cb 02 c0       	push   $0xc002cbdf
c0020b4d:	68 14 b5 02 c0       	push   $0xc002b514
c0020b52:	68 44 01 00 00       	push   $0x144
c0020b57:	68 02 cf 02 c0       	push   $0xc002cf02
c0020b5c:	e8 df 6a 00 00       	call   c0027640 <debug_panic>
      func (t, aux);
c0020b61:	83 ec 08             	sub    $0x8,%esp
c0020b64:	57                   	push   %edi
      struct thread *t = list_entry (e, struct thread, allelem);
c0020b65:	8d 43 e0             	lea    -0x20(%ebx),%eax
      func (t, aux);
c0020b68:	50                   	push   %eax
c0020b69:	ff d6                	call   *%esi
       e = list_next (e))
c0020b6b:	89 1c 24             	mov    %ebx,(%esp)
c0020b6e:	e8 e7 6b 00 00       	call   c002775a <list_next>
c0020b73:	89 c3                	mov    %eax,%ebx
c0020b75:	83 c4 10             	add    $0x10,%esp
  for (e = list_begin (&all_list); e != list_end (&all_list);
c0020b78:	83 ec 0c             	sub    $0xc,%esp
c0020b7b:	68 00 69 03 c0       	push   $0xc0036900
c0020b80:	e8 1d 6c 00 00       	call   c00277a2 <list_end>
c0020b85:	83 c4 10             	add    $0x10,%esp
c0020b88:	39 c3                	cmp    %eax,%ebx
c0020b8a:	75 d5                	jne    c0020b61 <thread_foreach+0x49>
}
c0020b8c:	5b                   	pop    %ebx
c0020b8d:	5e                   	pop    %esi
c0020b8e:	5f                   	pop    %edi
c0020b8f:	c3                   	ret    

c0020b90 <thread_set_priority>:
{
c0020b90:	83 ec 0c             	sub    $0xc,%esp
  thread_current ()->priority = new_priority;
c0020b93:	e8 b9 fe ff ff       	call   c0020a51 <thread_current>
c0020b98:	8b 54 24 10          	mov    0x10(%esp),%edx
c0020b9c:	89 50 1c             	mov    %edx,0x1c(%eax)
}
c0020b9f:	83 c4 0c             	add    $0xc,%esp
c0020ba2:	c3                   	ret    

c0020ba3 <thread_get_priority>:
{
c0020ba3:	83 ec 0c             	sub    $0xc,%esp
  return thread_current ()->priority;
c0020ba6:	e8 a6 fe ff ff       	call   c0020a51 <thread_current>
c0020bab:	8b 40 1c             	mov    0x1c(%eax),%eax
}
c0020bae:	83 c4 0c             	add    $0xc,%esp
c0020bb1:	c3                   	ret    

c0020bb2 <thread_set_nice>:
{
c0020bb2:	c3                   	ret    

c0020bb3 <thread_get_nice>:
}
c0020bb3:	b8 00 00 00 00       	mov    $0x0,%eax
c0020bb8:	c3                   	ret    

c0020bb9 <thread_get_load_avg>:
}
c0020bb9:	b8 00 00 00 00       	mov    $0x0,%eax
c0020bbe:	c3                   	ret    

c0020bbf <thread_get_recent_cpu>:
}
c0020bbf:	b8 00 00 00 00       	mov    $0x0,%eax
c0020bc4:	c3                   	ret    

c0020bc5 <thread_schedule_tail>:
{
c0020bc5:	56                   	push   %esi
c0020bc6:	53                   	push   %ebx
c0020bc7:	83 ec 04             	sub    $0x4,%esp
c0020bca:	8b 74 24 10          	mov    0x10(%esp),%esi
  asm ("mov %%esp, %0" : "=g" (esp));
c0020bce:	89 e3                	mov    %esp,%ebx
c0020bd0:	81 e3 00 f0 ff ff    	and    $0xfffff000,%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c0020bd6:	e8 6b 04 00 00       	call   c0021046 <intr_get_level>
c0020bdb:	85 c0                	test   %eax,%eax
c0020bdd:	75 21                	jne    c0020c00 <thread_schedule_tail+0x3b>
  cur->status = THREAD_RUNNING;
c0020bdf:	c7 43 04 00 00 00 00 	movl   $0x0,0x4(%ebx)
  thread_ticks = 0;
c0020be6:	c7 05 c8 68 03 c0 00 	movl   $0x0,0xc00368c8
c0020bed:	00 00 00 
  if (prev != NULL && prev->status == THREAD_DYING && prev != initial_thread) 
c0020bf0:	85 f6                	test   %esi,%esi
c0020bf2:	74 06                	je     c0020bfa <thread_schedule_tail+0x35>
c0020bf4:	83 7e 04 03          	cmpl   $0x3,0x4(%esi)
c0020bf8:	74 27                	je     c0020c21 <thread_schedule_tail+0x5c>
}
c0020bfa:	83 c4 04             	add    $0x4,%esp
c0020bfd:	5b                   	pop    %ebx
c0020bfe:	5e                   	pop    %esi
c0020bff:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0020c00:	83 ec 0c             	sub    $0xc,%esp
c0020c03:	68 34 cf 02 c0       	push   $0xc002cf34
c0020c08:	68 df cb 02 c0       	push   $0xc002cbdf
c0020c0d:	68 fc b4 02 c0       	push   $0xc002b4fc
c0020c12:	68 08 02 00 00       	push   $0x208
c0020c17:	68 02 cf 02 c0       	push   $0xc002cf02
c0020c1c:	e8 1f 6a 00 00       	call   c0027640 <debug_panic>
  if (prev != NULL && prev->status == THREAD_DYING && prev != initial_thread) 
c0020c21:	3b 35 f8 68 03 c0    	cmp    0xc00368f8,%esi
c0020c27:	74 d1                	je     c0020bfa <thread_schedule_tail+0x35>
      ASSERT (prev != cur);
c0020c29:	39 de                	cmp    %ebx,%esi
c0020c2b:	74 0e                	je     c0020c3b <thread_schedule_tail+0x76>
      palloc_free_page (prev);
c0020c2d:	83 ec 0c             	sub    $0xc,%esp
c0020c30:	56                   	push   %esi
c0020c31:	e8 33 1e 00 00       	call   c0022a69 <palloc_free_page>
c0020c36:	83 c4 10             	add    $0x10,%esp
}
c0020c39:	eb bf                	jmp    c0020bfa <thread_schedule_tail+0x35>
      ASSERT (prev != cur);
c0020c3b:	83 ec 0c             	sub    $0xc,%esp
c0020c3e:	68 a5 cf 02 c0       	push   $0xc002cfa5
c0020c43:	68 df cb 02 c0       	push   $0xc002cbdf
c0020c48:	68 fc b4 02 c0       	push   $0xc002b4fc
c0020c4d:	68 1c 02 00 00       	push   $0x21c
c0020c52:	68 02 cf 02 c0       	push   $0xc002cf02
c0020c57:	e8 e4 69 00 00       	call   c0027640 <debug_panic>

c0020c5c <schedule>:
{
c0020c5c:	56                   	push   %esi
c0020c5d:	53                   	push   %ebx
c0020c5e:	83 ec 10             	sub    $0x10,%esp
  asm ("mov %%esp, %0" : "=g" (esp));
c0020c61:	89 e3                	mov    %esp,%ebx
c0020c63:	81 e3 00 f0 ff ff    	and    $0xfffff000,%ebx
  if (list_empty (&ready_list))
c0020c69:	68 10 69 03 c0       	push   $0xc0036910
c0020c6e:	e8 b9 6f 00 00       	call   c0027c2c <list_empty>
c0020c73:	83 c4 10             	add    $0x10,%esp
c0020c76:	84 c0                	test   %al,%al
c0020c78:	74 43                	je     c0020cbd <schedule+0x61>
    return idle_thread;
c0020c7a:	8b 35 fc 68 03 c0    	mov    0xc00368fc,%esi
  ASSERT (intr_get_level () == INTR_OFF);
c0020c80:	e8 c1 03 00 00       	call   c0021046 <intr_get_level>
c0020c85:	85 c0                	test   %eax,%eax
c0020c87:	75 49                	jne    c0020cd2 <schedule+0x76>
  ASSERT (cur->status != THREAD_RUNNING);
c0020c89:	83 7b 04 00          	cmpl   $0x0,0x4(%ebx)
c0020c8d:	74 64                	je     c0020cf3 <schedule+0x97>
  return t != NULL && t->magic == THREAD_MAGIC;
c0020c8f:	85 f6                	test   %esi,%esi
c0020c91:	74 09                	je     c0020c9c <schedule+0x40>
c0020c93:	81 7e 30 4b bf 6a cd 	cmpl   $0xcd6abf4b,0x30(%esi)
c0020c9a:	74 78                	je     c0020d14 <schedule+0xb8>
  ASSERT (is_thread (next));
c0020c9c:	83 ec 0c             	sub    $0xc,%esp
c0020c9f:	68 cf cf 02 c0       	push   $0xc002cfcf
c0020ca4:	68 df cb 02 c0       	push   $0xc002cbdf
c0020ca9:	68 60 b5 02 c0       	push   $0xc002b560
c0020cae:	68 31 02 00 00       	push   $0x231
c0020cb3:	68 02 cf 02 c0       	push   $0xc002cf02
c0020cb8:	e8 83 69 00 00       	call   c0027640 <debug_panic>
    return list_entry (list_pop_front (&ready_list), struct thread, elem);
c0020cbd:	83 ec 0c             	sub    $0xc,%esp
c0020cc0:	68 10 69 03 c0       	push   $0xc0036910
c0020cc5:	e8 c4 6f 00 00       	call   c0027c8e <list_pop_front>
c0020cca:	8d 70 d8             	lea    -0x28(%eax),%esi
c0020ccd:	83 c4 10             	add    $0x10,%esp
c0020cd0:	eb ae                	jmp    c0020c80 <schedule+0x24>
  ASSERT (intr_get_level () == INTR_OFF);
c0020cd2:	83 ec 0c             	sub    $0xc,%esp
c0020cd5:	68 34 cf 02 c0       	push   $0xc002cf34
c0020cda:	68 df cb 02 c0       	push   $0xc002cbdf
c0020cdf:	68 60 b5 02 c0       	push   $0xc002b560
c0020ce4:	68 2f 02 00 00       	push   $0x22f
c0020ce9:	68 02 cf 02 c0       	push   $0xc002cf02
c0020cee:	e8 4d 69 00 00       	call   c0027640 <debug_panic>
  ASSERT (cur->status != THREAD_RUNNING);
c0020cf3:	83 ec 0c             	sub    $0xc,%esp
c0020cf6:	68 b1 cf 02 c0       	push   $0xc002cfb1
c0020cfb:	68 df cb 02 c0       	push   $0xc002cbdf
c0020d00:	68 60 b5 02 c0       	push   $0xc002b560
c0020d05:	68 30 02 00 00       	push   $0x230
c0020d0a:	68 02 cf 02 c0       	push   $0xc002cf02
c0020d0f:	e8 2c 69 00 00       	call   c0027640 <debug_panic>
  if (cur != next)
c0020d14:	39 de                	cmp    %ebx,%esi
c0020d16:	74 1f                	je     c0020d37 <schedule+0xdb>
    prev = switch_threads (cur, next);
c0020d18:	83 ec 08             	sub    $0x8,%esp
c0020d1b:	56                   	push   %esi
c0020d1c:	53                   	push   %ebx
c0020d1d:	e8 d3 01 00 00       	call   c0020ef5 <switch_threads>
c0020d22:	83 c4 10             	add    $0x10,%esp
  thread_schedule_tail (prev);
c0020d25:	83 ec 0c             	sub    $0xc,%esp
c0020d28:	50                   	push   %eax
c0020d29:	e8 97 fe ff ff       	call   c0020bc5 <thread_schedule_tail>
}
c0020d2e:	83 c4 10             	add    $0x10,%esp
c0020d31:	83 c4 04             	add    $0x4,%esp
c0020d34:	5b                   	pop    %ebx
c0020d35:	5e                   	pop    %esi
c0020d36:	c3                   	ret    
  struct thread *prev = NULL;
c0020d37:	b8 00 00 00 00       	mov    $0x0,%eax
c0020d3c:	eb e7                	jmp    c0020d25 <schedule+0xc9>

c0020d3e <thread_block>:
{
c0020d3e:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (!intr_context ());
c0020d41:	e8 5e 05 00 00       	call   c00212a4 <intr_context>
c0020d46:	84 c0                	test   %al,%al
c0020d48:	75 1e                	jne    c0020d68 <thread_block+0x2a>
  ASSERT (intr_get_level () == INTR_OFF);
c0020d4a:	e8 f7 02 00 00       	call   c0021046 <intr_get_level>
c0020d4f:	85 c0                	test   %eax,%eax
c0020d51:	75 36                	jne    c0020d89 <thread_block+0x4b>
  thread_current ()->status = THREAD_BLOCKED;
c0020d53:	e8 f9 fc ff ff       	call   c0020a51 <thread_current>
c0020d58:	c7 40 04 02 00 00 00 	movl   $0x2,0x4(%eax)
  schedule ();
c0020d5f:	e8 f8 fe ff ff       	call   c0020c5c <schedule>
}
c0020d64:	83 c4 0c             	add    $0xc,%esp
c0020d67:	c3                   	ret    
  ASSERT (!intr_context ());
c0020d68:	83 ec 0c             	sub    $0xc,%esp
c0020d6b:	68 e0 cf 02 c0       	push   $0xc002cfe0
c0020d70:	68 df cb 02 c0       	push   $0xc002cbdf
c0020d75:	68 6c b5 02 c0       	push   $0xc002b56c
c0020d7a:	68 d8 00 00 00       	push   $0xd8
c0020d7f:	68 02 cf 02 c0       	push   $0xc002cf02
c0020d84:	e8 b7 68 00 00       	call   c0027640 <debug_panic>
  ASSERT (intr_get_level () == INTR_OFF);
c0020d89:	83 ec 0c             	sub    $0xc,%esp
c0020d8c:	68 34 cf 02 c0       	push   $0xc002cf34
c0020d91:	68 df cb 02 c0       	push   $0xc002cbdf
c0020d96:	68 6c b5 02 c0       	push   $0xc002b56c
c0020d9b:	68 d9 00 00 00       	push   $0xd9
c0020da0:	68 02 cf 02 c0       	push   $0xc002cf02
c0020da5:	e8 96 68 00 00       	call   c0027640 <debug_panic>

c0020daa <idle>:
{
c0020daa:	83 ec 0c             	sub    $0xc,%esp
  idle_thread = thread_current ();
c0020dad:	e8 9f fc ff ff       	call   c0020a51 <thread_current>
c0020db2:	a3 fc 68 03 c0       	mov    %eax,0xc00368fc
  sema_up (idle_started);
c0020db7:	83 ec 0c             	sub    $0xc,%esp
c0020dba:	ff 74 24 1c          	pushl  0x1c(%esp)
c0020dbe:	e8 0e 14 00 00       	call   c00221d1 <sema_up>
c0020dc3:	83 c4 10             	add    $0x10,%esp
      intr_disable ();
c0020dc6:	e8 b8 02 00 00       	call   c0021083 <intr_disable>
      thread_block ();
c0020dcb:	e8 6e ff ff ff       	call   c0020d3e <thread_block>
      asm volatile ("sti; hlt" : : : "memory");
c0020dd0:	fb                   	sti    
c0020dd1:	f4                   	hlt    
c0020dd2:	eb f2                	jmp    c0020dc6 <idle+0x1c>

c0020dd4 <thread_exit>:
{
c0020dd4:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (!intr_context ());
c0020dd7:	e8 c8 04 00 00       	call   c00212a4 <intr_context>
c0020ddc:	84 c0                	test   %al,%al
c0020dde:	74 21                	je     c0020e01 <thread_exit+0x2d>
c0020de0:	83 ec 0c             	sub    $0xc,%esp
c0020de3:	68 e0 cf 02 c0       	push   $0xc002cfe0
c0020de8:	68 df cb 02 c0       	push   $0xc002cbdf
c0020ded:	68 34 b5 02 c0       	push   $0xc002b534
c0020df2:	68 1b 01 00 00       	push   $0x11b
c0020df7:	68 02 cf 02 c0       	push   $0xc002cf02
c0020dfc:	e8 3f 68 00 00       	call   c0027640 <debug_panic>
  intr_disable ();
c0020e01:	e8 7d 02 00 00       	call   c0021083 <intr_disable>
  list_remove (&thread_current()->allelem);
c0020e06:	e8 46 fc ff ff       	call   c0020a51 <thread_current>
c0020e0b:	83 ec 0c             	sub    $0xc,%esp
c0020e0e:	83 c0 20             	add    $0x20,%eax
c0020e11:	50                   	push   %eax
c0020e12:	e8 8a 6d 00 00       	call   c0027ba1 <list_remove>
  thread_current ()->status = THREAD_DYING;
c0020e17:	e8 35 fc ff ff       	call   c0020a51 <thread_current>
c0020e1c:	c7 40 04 03 00 00 00 	movl   $0x3,0x4(%eax)
  schedule ();
c0020e23:	e8 34 fe ff ff       	call   c0020c5c <schedule>
  NOT_REACHED ();
c0020e28:	68 60 d0 02 c0       	push   $0xc002d060
c0020e2d:	68 34 b5 02 c0       	push   $0xc002b534
c0020e32:	68 28 01 00 00       	push   $0x128
c0020e37:	68 02 cf 02 c0       	push   $0xc002cf02
c0020e3c:	e8 ff 67 00 00       	call   c0027640 <debug_panic>

c0020e41 <kernel_thread>:
{
c0020e41:	53                   	push   %ebx
c0020e42:	83 ec 08             	sub    $0x8,%esp
c0020e45:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (function != NULL);
c0020e49:	85 db                	test   %ebx,%ebx
c0020e4b:	74 13                	je     c0020e60 <kernel_thread+0x1f>
  intr_enable ();       /* The scheduler runs with interrupts off. */
c0020e4d:	e8 fd 01 00 00       	call   c002104f <intr_enable>
  function (aux);       /* Execute the thread function. */
c0020e52:	83 ec 0c             	sub    $0xc,%esp
c0020e55:	ff 74 24 20          	pushl  0x20(%esp)
c0020e59:	ff d3                	call   *%ebx
  thread_exit ();       /* If function() returns, kill the thread. */
c0020e5b:	e8 74 ff ff ff       	call   c0020dd4 <thread_exit>
  ASSERT (function != NULL);
c0020e60:	83 ec 0c             	sub    $0xc,%esp
c0020e63:	68 73 cf 02 c0       	push   $0xc002cf73
c0020e68:	68 df cb 02 c0       	push   $0xc002cbdf
c0020e6d:	68 88 b5 02 c0       	push   $0xc002b588
c0020e72:	68 a5 01 00 00       	push   $0x1a5
c0020e77:	68 02 cf 02 c0       	push   $0xc002cf02
c0020e7c:	e8 bf 67 00 00       	call   c0027640 <debug_panic>

c0020e81 <thread_yield>:
{
c0020e81:	56                   	push   %esi
c0020e82:	53                   	push   %ebx
c0020e83:	83 ec 04             	sub    $0x4,%esp
  struct thread *cur = thread_current ();
c0020e86:	e8 c6 fb ff ff       	call   c0020a51 <thread_current>
c0020e8b:	89 c3                	mov    %eax,%ebx
  ASSERT (!intr_context ());
c0020e8d:	e8 12 04 00 00       	call   c00212a4 <intr_context>
c0020e92:	84 c0                	test   %al,%al
c0020e94:	75 3e                	jne    c0020ed4 <thread_yield+0x53>
  old_level = intr_disable ();
c0020e96:	e8 e8 01 00 00       	call   c0021083 <intr_disable>
c0020e9b:	89 c6                	mov    %eax,%esi
  if (cur != idle_thread) 
c0020e9d:	3b 1d fc 68 03 c0    	cmp    0xc00368fc,%ebx
c0020ea3:	74 14                	je     c0020eb9 <thread_yield+0x38>
    list_push_back (&ready_list, &cur->elem);
c0020ea5:	83 ec 08             	sub    $0x8,%esp
c0020ea8:	8d 43 28             	lea    0x28(%ebx),%eax
c0020eab:	50                   	push   %eax
c0020eac:	68 10 69 03 c0       	push   $0xc0036910
c0020eb1:	e8 ce 6c 00 00       	call   c0027b84 <list_push_back>
c0020eb6:	83 c4 10             	add    $0x10,%esp
  cur->status = THREAD_READY;
c0020eb9:	c7 43 04 01 00 00 00 	movl   $0x1,0x4(%ebx)
  schedule ();
c0020ec0:	e8 97 fd ff ff       	call   c0020c5c <schedule>
  intr_set_level (old_level);
c0020ec5:	83 ec 0c             	sub    $0xc,%esp
c0020ec8:	56                   	push   %esi
c0020ec9:	e8 bc 01 00 00       	call   c002108a <intr_set_level>
}
c0020ece:	83 c4 14             	add    $0x14,%esp
c0020ed1:	5b                   	pop    %ebx
c0020ed2:	5e                   	pop    %esi
c0020ed3:	c3                   	ret    
  ASSERT (!intr_context ());
c0020ed4:	83 ec 0c             	sub    $0xc,%esp
c0020ed7:	68 e0 cf 02 c0       	push   $0xc002cfe0
c0020edc:	68 df cb 02 c0       	push   $0xc002cbdf
c0020ee1:	68 24 b5 02 c0       	push   $0xc002b524
c0020ee6:	68 33 01 00 00       	push   $0x133
c0020eeb:	68 02 cf 02 c0       	push   $0xc002cf02
c0020ef0:	e8 4b 67 00 00       	call   c0027640 <debug_panic>

c0020ef5 <switch_threads>:
	# but requires us to preserve %ebx, %ebp, %esi, %edi.  See
	# [SysV-ABI-386] pages 3-11 and 3-12 for details.
	#
	# This stack frame must match the one set up by thread_create()
	# in size.
	pushl %ebx
c0020ef5:	53                   	push   %ebx
	pushl %ebp
c0020ef6:	55                   	push   %ebp
	pushl %esi
c0020ef7:	56                   	push   %esi
	pushl %edi
c0020ef8:	57                   	push   %edi

	# Get offsetof (struct thread, stack).
.globl thread_stack_ofs
	mov thread_stack_ofs, %edx
c0020ef9:	8b 15 70 63 03 c0    	mov    0xc0036370,%edx

	# Save current stack pointer to old thread's stack, if any.
	movl SWITCH_CUR(%esp), %eax
c0020eff:	8b 44 24 14          	mov    0x14(%esp),%eax
	movl %esp, (%eax,%edx,1)
c0020f03:	89 24 10             	mov    %esp,(%eax,%edx,1)

	# Restore stack pointer from new thread's stack.
	movl SWITCH_NEXT(%esp), %ecx
c0020f06:	8b 4c 24 18          	mov    0x18(%esp),%ecx
	movl (%ecx,%edx,1), %esp
c0020f0a:	8b 24 11             	mov    (%ecx,%edx,1),%esp

	# Restore caller's register state.
	popl %edi
c0020f0d:	5f                   	pop    %edi
	popl %esi
c0020f0e:	5e                   	pop    %esi
	popl %ebp
c0020f0f:	5d                   	pop    %ebp
	popl %ebx
c0020f10:	5b                   	pop    %ebx
        ret
c0020f11:	c3                   	ret    

c0020f12 <switch_entry>:

.globl switch_entry
.func switch_entry
switch_entry:
	# Discard switch_threads() arguments.
	addl $8, %esp
c0020f12:	83 c4 08             	add    $0x8,%esp

	# Call thread_schedule_tail(prev).
	pushl %eax
c0020f15:	50                   	push   %eax
.globl thread_schedule_tail
	call thread_schedule_tail
c0020f16:	e8 aa fc ff ff       	call   c0020bc5 <thread_schedule_tail>
	addl $4, %esp
c0020f1b:	83 c4 04             	add    $0x4,%esp

	# Start thread proper.
	ret
c0020f1e:	c3                   	ret    

c0020f1f <make_gate>:
   disables interrupts, but entering a trap gate does not.  See
   [IA32-v3a] section 5.12.1.2 "Flag Usage By Exception- or
   Interrupt-Handler Procedure" for discussion. */
static uint64_t
make_gate (void (*function) (void), int dpl, int type)
{
c0020f1f:	83 ec 0c             	sub    $0xc,%esp
  uint32_t e0, e1;

  ASSERT (function != NULL);
c0020f22:	85 c0                	test   %eax,%eax
c0020f24:	74 2b                	je     c0020f51 <make_gate+0x32>
  ASSERT (dpl >= 0 && dpl <= 3);
c0020f26:	83 fa 03             	cmp    $0x3,%edx
c0020f29:	77 47                	ja     c0020f72 <make_gate+0x53>
  ASSERT (type >= 0 && type <= 15);
c0020f2b:	83 f9 0f             	cmp    $0xf,%ecx
c0020f2e:	77 63                	ja     c0020f93 <make_gate+0x74>

  e1 = (((uint32_t) function & 0xffff0000) /* Offset 31:16. */
        | (1 << 15)                        /* Present. */
        | ((uint32_t) dpl << 13)           /* Descriptor privilege level. */
        | (0 << 12)                        /* System. */
        | ((uint32_t) type << 8));         /* Gate type. */
c0020f30:	c1 e1 08             	shl    $0x8,%ecx
  e1 = (((uint32_t) function & 0xffff0000) /* Offset 31:16. */
c0020f33:	80 cd 80             	or     $0x80,%ch
        | ((uint32_t) dpl << 13)           /* Descriptor privilege level. */
c0020f36:	c1 e2 0d             	shl    $0xd,%edx
  e1 = (((uint32_t) function & 0xffff0000) /* Offset 31:16. */
c0020f39:	09 ca                	or     %ecx,%edx
c0020f3b:	89 c1                	mov    %eax,%ecx
c0020f3d:	81 e1 00 00 ff ff    	and    $0xffff0000,%ecx
c0020f43:	09 ca                	or     %ecx,%edx
  e0 = (((uint32_t) function & 0xffff)     /* Offset 15:0. */
c0020f45:	0f b7 c0             	movzwl %ax,%eax
c0020f48:	0d 00 00 08 00       	or     $0x80000,%eax

  return e0 | ((uint64_t) e1 << 32);
}
c0020f4d:	83 c4 0c             	add    $0xc,%esp
c0020f50:	c3                   	ret    
  ASSERT (function != NULL);
c0020f51:	83 ec 0c             	sub    $0xc,%esp
c0020f54:	68 73 cf 02 c0       	push   $0xc002cf73
c0020f59:	68 df cb 02 c0       	push   $0xc002cbdf
c0020f5e:	68 3c b6 02 c0       	push   $0xc002b63c
c0020f63:	68 2a 01 00 00       	push   $0x12a
c0020f68:	68 82 d0 02 c0       	push   $0xc002d082
c0020f6d:	e8 ce 66 00 00       	call   c0027640 <debug_panic>
  ASSERT (dpl >= 0 && dpl <= 3);
c0020f72:	83 ec 0c             	sub    $0xc,%esp
c0020f75:	68 9c d0 02 c0       	push   $0xc002d09c
c0020f7a:	68 df cb 02 c0       	push   $0xc002cbdf
c0020f7f:	68 3c b6 02 c0       	push   $0xc002b63c
c0020f84:	68 2b 01 00 00       	push   $0x12b
c0020f89:	68 82 d0 02 c0       	push   $0xc002d082
c0020f8e:	e8 ad 66 00 00       	call   c0027640 <debug_panic>
  ASSERT (type >= 0 && type <= 15);
c0020f93:	83 ec 0c             	sub    $0xc,%esp
c0020f96:	68 b1 d0 02 c0       	push   $0xc002d0b1
c0020f9b:	68 df cb 02 c0       	push   $0xc002cbdf
c0020fa0:	68 3c b6 02 c0       	push   $0xc002b63c
c0020fa5:	68 2c 01 00 00       	push   $0x12c
c0020faa:	68 82 d0 02 c0       	push   $0xc002d082
c0020faf:	e8 8c 66 00 00       	call   c0027640 <debug_panic>

c0020fb4 <register_handler>:
{
c0020fb4:	53                   	push   %ebx
c0020fb5:	83 ec 08             	sub    $0x8,%esp
  ASSERT (intr_handlers[vec_no] == NULL);
c0020fb8:	0f b6 d8             	movzbl %al,%ebx
c0020fbb:	83 3c 9d 40 71 03 c0 	cmpl   $0x0,-0x3ffc8ec0(,%ebx,4)
c0020fc2:	00 
c0020fc3:	75 3f                	jne    c0021004 <register_handler+0x50>
  if (level == INTR_ON)
c0020fc5:	83 f9 01             	cmp    $0x1,%ecx
c0020fc8:	74 5b                	je     c0021025 <register_handler+0x71>
/* Creates an interrupt gate that invokes FUNCTION with the given
   DPL. */
static uint64_t
make_intr_gate (void (*function) (void), int dpl)
{
  return make_gate (function, dpl, 14);
c0020fca:	8b 04 9d 74 63 03 c0 	mov    -0x3ffc9c8c(,%ebx,4),%eax
c0020fd1:	b9 0e 00 00 00       	mov    $0xe,%ecx
c0020fd6:	e8 44 ff ff ff       	call   c0020f1f <make_gate>
    idt[vec_no] = make_intr_gate (intr_stubs[vec_no], dpl);
c0020fdb:	89 04 dd 40 75 03 c0 	mov    %eax,-0x3ffc8ac0(,%ebx,8)
c0020fe2:	89 14 dd 44 75 03 c0 	mov    %edx,-0x3ffc8abc(,%ebx,8)
  intr_handlers[vec_no] = handler;
c0020fe9:	8b 44 24 10          	mov    0x10(%esp),%eax
c0020fed:	89 04 9d 40 71 03 c0 	mov    %eax,-0x3ffc8ec0(,%ebx,4)
  intr_names[vec_no] = name;
c0020ff4:	8b 44 24 14          	mov    0x14(%esp),%eax
c0020ff8:	89 04 9d 40 6d 03 c0 	mov    %eax,-0x3ffc92c0(,%ebx,4)
}
c0020fff:	83 c4 08             	add    $0x8,%esp
c0021002:	5b                   	pop    %ebx
c0021003:	c3                   	ret    
  ASSERT (intr_handlers[vec_no] == NULL);
c0021004:	83 ec 0c             	sub    $0xc,%esp
c0021007:	68 c9 d0 02 c0       	push   $0xc002d0c9
c002100c:	68 df cb 02 c0       	push   $0xc002cbdf
c0021011:	68 14 b6 02 c0       	push   $0xc002b614
c0021016:	68 a8 00 00 00       	push   $0xa8
c002101b:	68 82 d0 02 c0       	push   $0xc002d082
c0021020:	e8 1b 66 00 00       	call   c0027640 <debug_panic>
/* Creates a trap gate that invokes FUNCTION with the given
   DPL. */
static uint64_t
make_trap_gate (void (*function) (void), int dpl)
{
  return make_gate (function, dpl, 15);
c0021025:	8b 04 9d 74 63 03 c0 	mov    -0x3ffc9c8c(,%ebx,4),%eax
c002102c:	b9 0f 00 00 00       	mov    $0xf,%ecx
c0021031:	e8 e9 fe ff ff       	call   c0020f1f <make_gate>
    idt[vec_no] = make_trap_gate (intr_stubs[vec_no], dpl);
c0021036:	89 04 dd 40 75 03 c0 	mov    %eax,-0x3ffc8ac0(,%ebx,8)
c002103d:	89 14 dd 44 75 03 c0 	mov    %edx,-0x3ffc8abc(,%ebx,8)
c0021044:	eb a3                	jmp    c0020fe9 <register_handler+0x35>

c0021046 <intr_get_level>:
  asm volatile ("pushfl; popl %0" : "=g" (flags));
c0021046:	9c                   	pushf  
c0021047:	58                   	pop    %eax
  return flags & FLAG_IF ? INTR_ON : INTR_OFF;
c0021048:	c1 e8 09             	shr    $0x9,%eax
c002104b:	83 e0 01             	and    $0x1,%eax
}
c002104e:	c3                   	ret    

c002104f <intr_enable>:
{
c002104f:	83 ec 0c             	sub    $0xc,%esp
  enum intr_level old_level = intr_get_level ();
c0021052:	e8 ef ff ff ff       	call   c0021046 <intr_get_level>
  ASSERT (!intr_context ());
c0021057:	80 3d 21 69 03 c0 00 	cmpb   $0x0,0xc0036921
c002105e:	75 05                	jne    c0021065 <intr_enable+0x16>
  asm volatile ("sti");
c0021060:	fb                   	sti    
}
c0021061:	83 c4 0c             	add    $0xc,%esp
c0021064:	c3                   	ret    
  ASSERT (!intr_context ());
c0021065:	83 ec 0c             	sub    $0xc,%esp
c0021068:	68 e0 cf 02 c0       	push   $0xc002cfe0
c002106d:	68 df cb 02 c0       	push   $0xc002cbdf
c0021072:	68 48 b6 02 c0       	push   $0xc002b648
c0021077:	6a 5b                	push   $0x5b
c0021079:	68 82 d0 02 c0       	push   $0xc002d082
c002107e:	e8 bd 65 00 00       	call   c0027640 <debug_panic>

c0021083 <intr_disable>:
  enum intr_level old_level = intr_get_level ();
c0021083:	e8 be ff ff ff       	call   c0021046 <intr_get_level>
  asm volatile ("cli" : : : "memory");
c0021088:	fa                   	cli    
}
c0021089:	c3                   	ret    

c002108a <intr_set_level>:
{
c002108a:	83 ec 0c             	sub    $0xc,%esp
  return level == INTR_ON ? intr_enable () : intr_disable ();
c002108d:	83 7c 24 10 01       	cmpl   $0x1,0x10(%esp)
c0021092:	74 09                	je     c002109d <intr_set_level+0x13>
c0021094:	e8 ea ff ff ff       	call   c0021083 <intr_disable>
}
c0021099:	83 c4 0c             	add    $0xc,%esp
c002109c:	c3                   	ret    
  return level == INTR_ON ? intr_enable () : intr_disable ();
c002109d:	e8 ad ff ff ff       	call   c002104f <intr_enable>
c00210a2:	eb f5                	jmp    c0021099 <intr_set_level+0xf>

c00210a4 <intr_init>:
{
c00210a4:	53                   	push   %ebx
c00210a5:	83 ec 18             	sub    $0x18,%esp
/* Writes byte DATA to PORT. */
static inline void
outb (uint16_t port, uint8_t data)
{
  /* See [IA32-v2b] "OUT". */
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00210a8:	b0 ff                	mov    $0xff,%al
c00210aa:	e6 21                	out    %al,$0x21
c00210ac:	e6 a1                	out    %al,$0xa1
c00210ae:	b0 11                	mov    $0x11,%al
c00210b0:	e6 20                	out    %al,$0x20
c00210b2:	b0 20                	mov    $0x20,%al
c00210b4:	e6 21                	out    %al,$0x21
c00210b6:	b0 04                	mov    $0x4,%al
c00210b8:	e6 21                	out    %al,$0x21
c00210ba:	b0 01                	mov    $0x1,%al
c00210bc:	e6 21                	out    %al,$0x21
c00210be:	b0 11                	mov    $0x11,%al
c00210c0:	e6 a0                	out    %al,$0xa0
c00210c2:	b0 28                	mov    $0x28,%al
c00210c4:	e6 a1                	out    %al,$0xa1
c00210c6:	b0 02                	mov    $0x2,%al
c00210c8:	e6 a1                	out    %al,$0xa1
c00210ca:	b0 01                	mov    $0x1,%al
c00210cc:	e6 a1                	out    %al,$0xa1
c00210ce:	b0 00                	mov    $0x0,%al
c00210d0:	e6 21                	out    %al,$0x21
c00210d2:	e6 a1                	out    %al,$0xa1
c00210d4:	bb 00 00 00 00       	mov    $0x0,%ebx
  return make_gate (function, dpl, 14);
c00210d9:	8b 83 74 63 03 c0    	mov    -0x3ffc9c8c(%ebx),%eax
c00210df:	b9 0e 00 00 00       	mov    $0xe,%ecx
c00210e4:	ba 00 00 00 00       	mov    $0x0,%edx
c00210e9:	e8 31 fe ff ff       	call   c0020f1f <make_gate>
    idt[i] = make_intr_gate (intr_stubs[i], 0);
c00210ee:	89 84 1b 40 75 03 c0 	mov    %eax,-0x3ffc8ac0(%ebx,%ebx,1)
c00210f5:	89 94 1b 44 75 03 c0 	mov    %edx,-0x3ffc8abc(%ebx,%ebx,1)
c00210fc:	83 c3 04             	add    $0x4,%ebx
  for (i = 0; i < INTR_CNT; i++)
c00210ff:	81 fb 00 04 00 00    	cmp    $0x400,%ebx
c0021105:	75 d2                	jne    c00210d9 <intr_init+0x35>
/* Returns a descriptor that yields the given LIMIT and BASE when
   used as an operand for the LIDT instruction. */
static inline uint64_t
make_idtr_operand (uint16_t limit, void *base)
{
  return limit | ((uint64_t) (uint32_t) base << 16);
c0021107:	b8 40 75 03 c0       	mov    $0xc0037540,%eax
c002110c:	ba 00 00 00 00       	mov    $0x0,%edx
c0021111:	0f a4 c2 10          	shld   $0x10,%eax,%edx
c0021115:	c1 e0 10             	shl    $0x10,%eax
c0021118:	0d ff 07 00 00       	or     $0x7ff,%eax
c002111d:	89 44 24 08          	mov    %eax,0x8(%esp)
c0021121:	89 54 24 0c          	mov    %edx,0xc(%esp)
  asm volatile ("lidt %0" : : "m" (idtr_operand));
c0021125:	0f 01 5c 24 08       	lidtl  0x8(%esp)
c002112a:	b8 40 6d 03 c0       	mov    $0xc0036d40,%eax
c002112f:	ba 40 71 03 c0       	mov    $0xc0037140,%edx
    intr_names[i] = "unknown";
c0021134:	c7 00 e7 d0 02 c0    	movl   $0xc002d0e7,(%eax)
c002113a:	83 c0 04             	add    $0x4,%eax
  for (i = 0; i < INTR_CNT; i++)
c002113d:	39 c2                	cmp    %eax,%edx
c002113f:	75 f3                	jne    c0021134 <intr_init+0x90>
  intr_names[0] = "#DE Divide Error";
c0021141:	c7 05 40 6d 03 c0 ef 	movl   $0xc002d0ef,0xc0036d40
c0021148:	d0 02 c0 
  intr_names[1] = "#DB Debug Exception";
c002114b:	c7 05 44 6d 03 c0 00 	movl   $0xc002d100,0xc0036d44
c0021152:	d1 02 c0 
  intr_names[2] = "NMI Interrupt";
c0021155:	c7 05 48 6d 03 c0 14 	movl   $0xc002d114,0xc0036d48
c002115c:	d1 02 c0 
  intr_names[3] = "#BP Breakpoint Exception";
c002115f:	c7 05 4c 6d 03 c0 22 	movl   $0xc002d122,0xc0036d4c
c0021166:	d1 02 c0 
  intr_names[4] = "#OF Overflow Exception";
c0021169:	c7 05 50 6d 03 c0 3b 	movl   $0xc002d13b,0xc0036d50
c0021170:	d1 02 c0 
  intr_names[5] = "#BR BOUND Range Exceeded Exception";
c0021173:	c7 05 54 6d 03 c0 78 	movl   $0xc002d278,0xc0036d54
c002117a:	d2 02 c0 
  intr_names[6] = "#UD Invalid Opcode Exception";
c002117d:	c7 05 58 6d 03 c0 52 	movl   $0xc002d152,0xc0036d58
c0021184:	d1 02 c0 
  intr_names[7] = "#NM Device Not Available Exception";
c0021187:	c7 05 5c 6d 03 c0 9c 	movl   $0xc002d29c,0xc0036d5c
c002118e:	d2 02 c0 
  intr_names[8] = "#DF Double Fault Exception";
c0021191:	c7 05 60 6d 03 c0 6f 	movl   $0xc002d16f,0xc0036d60
c0021198:	d1 02 c0 
  intr_names[9] = "Coprocessor Segment Overrun";
c002119b:	c7 05 64 6d 03 c0 8a 	movl   $0xc002d18a,0xc0036d64
c00211a2:	d1 02 c0 
  intr_names[10] = "#TS Invalid TSS Exception";
c00211a5:	c7 05 68 6d 03 c0 a6 	movl   $0xc002d1a6,0xc0036d68
c00211ac:	d1 02 c0 
  intr_names[11] = "#NP Segment Not Present";
c00211af:	c7 05 6c 6d 03 c0 c0 	movl   $0xc002d1c0,0xc0036d6c
c00211b6:	d1 02 c0 
  intr_names[12] = "#SS Stack Fault Exception";
c00211b9:	c7 05 70 6d 03 c0 d8 	movl   $0xc002d1d8,0xc0036d70
c00211c0:	d1 02 c0 
  intr_names[13] = "#GP General Protection Exception";
c00211c3:	c7 05 74 6d 03 c0 c0 	movl   $0xc002d2c0,0xc0036d74
c00211ca:	d2 02 c0 
  intr_names[14] = "#PF Page-Fault Exception";
c00211cd:	c7 05 78 6d 03 c0 f2 	movl   $0xc002d1f2,0xc0036d78
c00211d4:	d1 02 c0 
  intr_names[16] = "#MF x87 FPU Floating-Point Error";
c00211d7:	c7 05 80 6d 03 c0 e4 	movl   $0xc002d2e4,0xc0036d80
c00211de:	d2 02 c0 
  intr_names[17] = "#AC Alignment Check Exception";
c00211e1:	c7 05 84 6d 03 c0 0b 	movl   $0xc002d20b,0xc0036d84
c00211e8:	d2 02 c0 
  intr_names[18] = "#MC Machine-Check Exception";
c00211eb:	c7 05 88 6d 03 c0 29 	movl   $0xc002d229,0xc0036d88
c00211f2:	d2 02 c0 
  intr_names[19] = "#XF SIMD Floating-Point Exception";
c00211f5:	c7 05 8c 6d 03 c0 08 	movl   $0xc002d308,0xc0036d8c
c00211fc:	d3 02 c0 
}
c00211ff:	83 c4 18             	add    $0x18,%esp
c0021202:	5b                   	pop    %ebx
c0021203:	c3                   	ret    

c0021204 <intr_register_ext>:
{
c0021204:	83 ec 0c             	sub    $0xc,%esp
c0021207:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (vec_no >= 0x20 && vec_no <= 0x2f);
c002120b:	8d 50 e0             	lea    -0x20(%eax),%edx
c002120e:	80 fa 0f             	cmp    $0xf,%dl
c0021211:	77 21                	ja     c0021234 <intr_register_ext+0x30>
  register_handler (vec_no, 0, INTR_OFF, handler, name);
c0021213:	0f b6 c0             	movzbl %al,%eax
c0021216:	83 ec 08             	sub    $0x8,%esp
c0021219:	ff 74 24 20          	pushl  0x20(%esp)
c002121d:	ff 74 24 20          	pushl  0x20(%esp)
c0021221:	b9 00 00 00 00       	mov    $0x0,%ecx
c0021226:	ba 00 00 00 00       	mov    $0x0,%edx
c002122b:	e8 84 fd ff ff       	call   c0020fb4 <register_handler>
}
c0021230:	83 c4 1c             	add    $0x1c,%esp
c0021233:	c3                   	ret    
  ASSERT (vec_no >= 0x20 && vec_no <= 0x2f);
c0021234:	83 ec 0c             	sub    $0xc,%esp
c0021237:	68 2c d3 02 c0       	push   $0xc002d32c
c002123c:	68 df cb 02 c0       	push   $0xc002cbdf
c0021241:	68 28 b6 02 c0       	push   $0xc002b628
c0021246:	68 b8 00 00 00       	push   $0xb8
c002124b:	68 82 d0 02 c0       	push   $0xc002d082
c0021250:	e8 eb 63 00 00       	call   c0027640 <debug_panic>

c0021255 <intr_register_int>:
{
c0021255:	83 ec 0c             	sub    $0xc,%esp
c0021258:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (vec_no < 0x20 || vec_no > 0x2f);
c002125c:	8d 50 e0             	lea    -0x20(%eax),%edx
c002125f:	80 fa 0f             	cmp    $0xf,%dl
c0021262:	76 1f                	jbe    c0021283 <intr_register_int+0x2e>
  register_handler (vec_no, dpl, level, handler, name);
c0021264:	0f b6 c0             	movzbl %al,%eax
c0021267:	83 ec 08             	sub    $0x8,%esp
c002126a:	ff 74 24 28          	pushl  0x28(%esp)
c002126e:	ff 74 24 28          	pushl  0x28(%esp)
c0021272:	8b 4c 24 28          	mov    0x28(%esp),%ecx
c0021276:	8b 54 24 24          	mov    0x24(%esp),%edx
c002127a:	e8 35 fd ff ff       	call   c0020fb4 <register_handler>
}
c002127f:	83 c4 1c             	add    $0x1c,%esp
c0021282:	c3                   	ret    
  ASSERT (vec_no < 0x20 || vec_no > 0x2f);
c0021283:	83 ec 0c             	sub    $0xc,%esp
c0021286:	68 50 d3 02 c0       	push   $0xc002d350
c002128b:	68 df cb 02 c0       	push   $0xc002cbdf
c0021290:	68 00 b6 02 c0       	push   $0xc002b600
c0021295:	68 cd 00 00 00       	push   $0xcd
c002129a:	68 82 d0 02 c0       	push   $0xc002d082
c002129f:	e8 9c 63 00 00       	call   c0027640 <debug_panic>

c00212a4 <intr_context>:
}
c00212a4:	a0 21 69 03 c0       	mov    0xc0036921,%al
c00212a9:	c3                   	ret    

c00212aa <intr_yield_on_return>:
  ASSERT (intr_context ());
c00212aa:	80 3d 21 69 03 c0 00 	cmpb   $0x0,0xc0036921
c00212b1:	74 08                	je     c00212bb <intr_yield_on_return+0x11>
  yield_on_return = true;
c00212b3:	c6 05 20 69 03 c0 01 	movb   $0x1,0xc0036920
c00212ba:	c3                   	ret    
{
c00212bb:	83 ec 18             	sub    $0x18,%esp
  ASSERT (intr_context ());
c00212be:	68 e1 cf 02 c0       	push   $0xc002cfe1
c00212c3:	68 df cb 02 c0       	push   $0xc002cbdf
c00212c8:	68 e8 b5 02 c0       	push   $0xc002b5e8
c00212cd:	68 e0 00 00 00       	push   $0xe0
c00212d2:	68 82 d0 02 c0       	push   $0xc002d082
c00212d7:	e8 64 63 00 00       	call   c0027640 <debug_panic>

c00212dc <intr_handler>:
   function is called by the assembly language interrupt stubs in
   intr-stubs.S.  FRAME describes the interrupt and the
   interrupted thread's registers. */
void
intr_handler (struct intr_frame *frame) 
{
c00212dc:	56                   	push   %esi
c00212dd:	53                   	push   %ebx
c00212de:	83 ec 04             	sub    $0x4,%esp
c00212e1:	8b 74 24 10          	mov    0x10(%esp),%esi

  /* External interrupts are special.
     We only handle one at a time (so interrupts must be off)
     and they need to be acknowledged on the PIC (see below).
     An external interrupt handler cannot sleep. */
  external = frame->vec_no >= 0x20 && frame->vec_no < 0x30;
c00212e5:	8b 46 30             	mov    0x30(%esi),%eax
c00212e8:	8d 58 e0             	lea    -0x20(%eax),%ebx
  if (external) 
c00212eb:	83 fb 0f             	cmp    $0xf,%ebx
c00212ee:	76 26                	jbe    c0021316 <intr_handler+0x3a>
      in_external_intr = true;
      yield_on_return = false;
    }

  /* Invoke the interrupt's handler. */
  handler = intr_handlers[frame->vec_no];
c00212f0:	8b 56 30             	mov    0x30(%esi),%edx
c00212f3:	8b 04 95 40 71 03 c0 	mov    -0x3ffc8ec0(,%edx,4),%eax
  if (handler != NULL)
c00212fa:	85 c0                	test   %eax,%eax
c00212fc:	74 7c                	je     c002137a <intr_handler+0x9e>
    handler (frame);
c00212fe:	83 ec 0c             	sub    $0xc,%esp
c0021301:	56                   	push   %esi
c0021302:	ff d0                	call   *%eax
c0021304:	83 c4 10             	add    $0x10,%esp
    }
  else
    unexpected_interrupt (frame);

  /* Complete the processing of an external interrupt. */
  if (external) 
c0021307:	83 fb 0f             	cmp    $0xf,%ebx
c002130a:	0f 86 aa 00 00 00    	jbe    c00213ba <intr_handler+0xde>
      pic_end_of_interrupt (frame->vec_no); 

      if (yield_on_return) 
        thread_yield (); 
    }
}
c0021310:	83 c4 04             	add    $0x4,%esp
c0021313:	5b                   	pop    %ebx
c0021314:	5e                   	pop    %esi
c0021315:	c3                   	ret    
      ASSERT (intr_get_level () == INTR_OFF);
c0021316:	e8 2b fd ff ff       	call   c0021046 <intr_get_level>
c002131b:	85 c0                	test   %eax,%eax
c002131d:	75 19                	jne    c0021338 <intr_handler+0x5c>
      ASSERT (!intr_context ());
c002131f:	80 3d 21 69 03 c0 00 	cmpb   $0x0,0xc0036921
c0021326:	75 31                	jne    c0021359 <intr_handler+0x7d>
      in_external_intr = true;
c0021328:	c6 05 21 69 03 c0 01 	movb   $0x1,0xc0036921
      yield_on_return = false;
c002132f:	c6 05 20 69 03 c0 00 	movb   $0x0,0xc0036920
c0021336:	eb b8                	jmp    c00212f0 <intr_handler+0x14>
      ASSERT (intr_get_level () == INTR_OFF);
c0021338:	83 ec 0c             	sub    $0xc,%esp
c002133b:	68 34 cf 02 c0       	push   $0xc002cf34
c0021340:	68 df cb 02 c0       	push   $0xc002cbdf
c0021345:	68 d8 b5 02 c0       	push   $0xc002b5d8
c002134a:	68 65 01 00 00       	push   $0x165
c002134f:	68 82 d0 02 c0       	push   $0xc002d082
c0021354:	e8 e7 62 00 00       	call   c0027640 <debug_panic>
      ASSERT (!intr_context ());
c0021359:	83 ec 0c             	sub    $0xc,%esp
c002135c:	68 e0 cf 02 c0       	push   $0xc002cfe0
c0021361:	68 df cb 02 c0       	push   $0xc002cbdf
c0021366:	68 d8 b5 02 c0       	push   $0xc002b5d8
c002136b:	68 66 01 00 00       	push   $0x166
c0021370:	68 82 d0 02 c0       	push   $0xc002d082
c0021375:	e8 c6 62 00 00       	call   c0027640 <debug_panic>
  else if (frame->vec_no == 0x27 || frame->vec_no == 0x2f)
c002137a:	89 d0                	mov    %edx,%eax
c002137c:	83 e0 f7             	and    $0xfffffff7,%eax
c002137f:	83 f8 27             	cmp    $0x27,%eax
c0021382:	74 83                	je     c0021307 <intr_handler+0x2b>
   unexpected interrupt is one that has no registered handler. */
static void
unexpected_interrupt (const struct intr_frame *f)
{
  /* Count the number so far. */
  unsigned int n = ++unexpected_cnt[f->vec_no];
c0021384:	8b 0c 95 40 69 03 c0 	mov    -0x3ffc96c0(,%edx,4),%ecx
c002138b:	8d 41 01             	lea    0x1(%ecx),%eax
c002138e:	89 04 95 40 69 03 c0 	mov    %eax,-0x3ffc96c0(,%edx,4)
  /* If the number is a power of 2, print a message.  This rate
     limiting means that we get information about an uncommon
     unexpected interrupt the first time and fairly often after
     that, but one that occurs many times will not overwhelm the
     console. */
  if ((n & (n - 1)) == 0)
c0021395:	85 c1                	test   %eax,%ecx
c0021397:	0f 85 6a ff ff ff    	jne    c0021307 <intr_handler+0x2b>
    printf ("Unexpected interrupt %#04x (%s)\n",
c002139d:	83 ec 04             	sub    $0x4,%esp
c00213a0:	ff 34 95 40 6d 03 c0 	pushl  -0x3ffc92c0(,%edx,4)
c00213a7:	52                   	push   %edx
c00213a8:	68 70 d3 02 c0       	push   $0xc002d370
c00213ad:	e8 e0 47 00 00       	call   c0025b92 <printf>
c00213b2:	83 c4 10             	add    $0x10,%esp
c00213b5:	e9 4d ff ff ff       	jmp    c0021307 <intr_handler+0x2b>
      ASSERT (intr_get_level () == INTR_OFF);
c00213ba:	e8 87 fc ff ff       	call   c0021046 <intr_get_level>
c00213bf:	85 c0                	test   %eax,%eax
c00213c1:	75 3d                	jne    c0021400 <intr_handler+0x124>
      ASSERT (intr_context ());
c00213c3:	80 3d 21 69 03 c0 00 	cmpb   $0x0,0xc0036921
c00213ca:	74 55                	je     c0021421 <intr_handler+0x145>
      in_external_intr = false;
c00213cc:	c6 05 21 69 03 c0 00 	movb   $0x0,0xc0036921
      pic_end_of_interrupt (frame->vec_no); 
c00213d3:	8b 56 30             	mov    0x30(%esi),%edx
  ASSERT (irq >= 0x20 && irq < 0x30);
c00213d6:	8d 42 e0             	lea    -0x20(%edx),%eax
c00213d9:	83 f8 0f             	cmp    $0xf,%eax
c00213dc:	77 64                	ja     c0021442 <intr_handler+0x166>
c00213de:	b0 20                	mov    $0x20,%al
c00213e0:	e6 20                	out    %al,$0x20
  if (irq >= 0x28)
c00213e2:	83 fa 27             	cmp    $0x27,%edx
c00213e5:	7e 02                	jle    c00213e9 <intr_handler+0x10d>
c00213e7:	e6 a0                	out    %al,$0xa0
      if (yield_on_return) 
c00213e9:	80 3d 20 69 03 c0 00 	cmpb   $0x0,0xc0036920
c00213f0:	0f 84 1a ff ff ff    	je     c0021310 <intr_handler+0x34>
        thread_yield (); 
c00213f6:	e8 86 fa ff ff       	call   c0020e81 <thread_yield>
}
c00213fb:	e9 10 ff ff ff       	jmp    c0021310 <intr_handler+0x34>
      ASSERT (intr_get_level () == INTR_OFF);
c0021400:	83 ec 0c             	sub    $0xc,%esp
c0021403:	68 34 cf 02 c0       	push   $0xc002cf34
c0021408:	68 df cb 02 c0       	push   $0xc002cbdf
c002140d:	68 d8 b5 02 c0       	push   $0xc002b5d8
c0021412:	68 7c 01 00 00       	push   $0x17c
c0021417:	68 82 d0 02 c0       	push   $0xc002d082
c002141c:	e8 1f 62 00 00       	call   c0027640 <debug_panic>
      ASSERT (intr_context ());
c0021421:	83 ec 0c             	sub    $0xc,%esp
c0021424:	68 e1 cf 02 c0       	push   $0xc002cfe1
c0021429:	68 df cb 02 c0       	push   $0xc002cbdf
c002142e:	68 d8 b5 02 c0       	push   $0xc002b5d8
c0021433:	68 7d 01 00 00       	push   $0x17d
c0021438:	68 82 d0 02 c0       	push   $0xc002d082
c002143d:	e8 fe 61 00 00       	call   c0027640 <debug_panic>
  ASSERT (irq >= 0x20 && irq < 0x30);
c0021442:	83 ec 0c             	sub    $0xc,%esp
c0021445:	68 45 d2 02 c0       	push   $0xc002d245
c002144a:	68 df cb 02 c0       	push   $0xc002cbdf
c002144f:	68 c0 b5 02 c0       	push   $0xc002b5c0
c0021454:	68 0b 01 00 00       	push   $0x10b
c0021459:	68 82 d0 02 c0       	push   $0xc002d082
c002145e:	e8 dd 61 00 00       	call   c0027640 <debug_panic>

c0021463 <intr_dump_frame>:
}

/* Dumps interrupt frame F to the console, for debugging. */
void
intr_dump_frame (const struct intr_frame *f) 
{
c0021463:	56                   	push   %esi
c0021464:	53                   	push   %ebx
c0021465:	83 ec 04             	sub    $0x4,%esp
c0021468:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  /* Store current value of CR2 into `cr2'.
     CR2 is the linear address of the last page fault.
     See [IA32-v2a] "MOV--Move to/from Control Registers" and
     [IA32-v3a] 5.14 "Interrupt 14--Page Fault Exception
     (#PF)". */
  asm ("movl %%cr2, %0" : "=r" (cr2));
c002146c:	0f 20 d6             	mov    %cr2,%esi

  printf ("Interrupt %#04x (%s) at eip=%p\n",
          f->vec_no, intr_names[f->vec_no], f->eip);
c002146f:	8b 43 30             	mov    0x30(%ebx),%eax
  printf ("Interrupt %#04x (%s) at eip=%p\n",
c0021472:	ff 73 3c             	pushl  0x3c(%ebx)
c0021475:	ff 34 85 40 6d 03 c0 	pushl  -0x3ffc92c0(,%eax,4)
c002147c:	50                   	push   %eax
c002147d:	68 94 d3 02 c0       	push   $0xc002d394
c0021482:	e8 0b 47 00 00       	call   c0025b92 <printf>
  printf (" cr2=%08"PRIx32" error=%08"PRIx32"\n", cr2, f->error_code);
c0021487:	83 c4 0c             	add    $0xc,%esp
c002148a:	ff 73 34             	pushl  0x34(%ebx)
c002148d:	56                   	push   %esi
c002148e:	68 5f d2 02 c0       	push   $0xc002d25f
c0021493:	e8 fa 46 00 00       	call   c0025b92 <printf>
  printf (" eax=%08"PRIx32" ebx=%08"PRIx32" ecx=%08"PRIx32" edx=%08"PRIx32"\n",
c0021498:	83 c4 04             	add    $0x4,%esp
c002149b:	ff 73 14             	pushl  0x14(%ebx)
c002149e:	ff 73 18             	pushl  0x18(%ebx)
c00214a1:	ff 73 10             	pushl  0x10(%ebx)
c00214a4:	ff 73 1c             	pushl  0x1c(%ebx)
c00214a7:	68 b4 d3 02 c0       	push   $0xc002d3b4
c00214ac:	e8 e1 46 00 00       	call   c0025b92 <printf>
          f->eax, f->ebx, f->ecx, f->edx);
  printf (" esi=%08"PRIx32" edi=%08"PRIx32" esp=%08"PRIx32" ebp=%08"PRIx32"\n",
c00214b1:	83 c4 14             	add    $0x14,%esp
c00214b4:	ff 73 08             	pushl  0x8(%ebx)
c00214b7:	ff 73 48             	pushl  0x48(%ebx)
c00214ba:	ff 33                	pushl  (%ebx)
c00214bc:	ff 73 04             	pushl  0x4(%ebx)
c00214bf:	68 dc d3 02 c0       	push   $0xc002d3dc
c00214c4:	e8 c9 46 00 00       	call   c0025b92 <printf>
          f->esi, f->edi, (uint32_t) f->esp, f->ebp);
  printf (" cs=%04"PRIx16" ds=%04"PRIx16" es=%04"PRIx16" ss=%04"PRIx16"\n",
c00214c9:	83 c4 14             	add    $0x14,%esp
c00214cc:	0f b7 43 4c          	movzwl 0x4c(%ebx),%eax
c00214d0:	50                   	push   %eax
c00214d1:	0f b7 43 28          	movzwl 0x28(%ebx),%eax
c00214d5:	50                   	push   %eax
c00214d6:	0f b7 43 2c          	movzwl 0x2c(%ebx),%eax
c00214da:	50                   	push   %eax
c00214db:	0f b7 43 40          	movzwl 0x40(%ebx),%eax
c00214df:	50                   	push   %eax
c00214e0:	68 04 d4 02 c0       	push   $0xc002d404
c00214e5:	e8 a8 46 00 00       	call   c0025b92 <printf>
          f->cs, f->ds, f->es, f->ss);
}
c00214ea:	83 c4 24             	add    $0x24,%esp
c00214ed:	5b                   	pop    %ebx
c00214ee:	5e                   	pop    %esi
c00214ef:	c3                   	ret    

c00214f0 <intr_name>:

/* Returns the name of interrupt VEC. */
const char *
intr_name (uint8_t vec) 
{
  return intr_names[vec];
c00214f0:	0f b6 44 24 04       	movzbl 0x4(%esp),%eax
c00214f5:	8b 04 85 40 6d 03 c0 	mov    -0x3ffc92c0(,%eax,4),%eax
}
c00214fc:	c3                   	ret    

c00214fd <intr_entry>:
   We "fall through" to intr_exit to return from the interrupt.
*/
.func intr_entry
intr_entry:
	/* Save caller's registers. */
	pushl %ds
c00214fd:	1e                   	push   %ds
	pushl %es
c00214fe:	06                   	push   %es
	pushl %fs
c00214ff:	0f a0                	push   %fs
	pushl %gs
c0021501:	0f a8                	push   %gs
	pushal
c0021503:	60                   	pusha  
        
	/* Set up kernel environment. */
	cld			/* String instructions go upward. */
c0021504:	fc                   	cld    
	mov $SEL_KDSEG, %eax	/* Initialize segment registers. */
c0021505:	b8 10 00 00 00       	mov    $0x10,%eax
	mov %eax, %ds
c002150a:	8e d8                	mov    %eax,%ds
	mov %eax, %es
c002150c:	8e c0                	mov    %eax,%es
	leal 56(%esp), %ebp	/* Set up frame pointer. */
c002150e:	8d 6c 24 38          	lea    0x38(%esp),%ebp

	/* Call interrupt handler. */
	pushl %esp
c0021512:	54                   	push   %esp
.globl intr_handler
	call intr_handler
c0021513:	e8 c4 fd ff ff       	call   c00212dc <intr_handler>
	addl $4, %esp
c0021518:	83 c4 04             	add    $0x4,%esp

c002151b <intr_exit>:
   userprog/process.c). */
.globl intr_exit
.func intr_exit
intr_exit:
        /* Restore caller's registers. */
	popal
c002151b:	61                   	popa   
	popl %gs
c002151c:	0f a9                	pop    %gs
	popl %fs
c002151e:	0f a1                	pop    %fs
	popl %es
c0021520:	07                   	pop    %es
	popl %ds
c0021521:	1f                   	pop    %ds

        /* Discard `struct intr_frame' vec_no, error_code,
           frame_pointer members. */
	addl $12, %esp
c0021522:	83 c4 0c             	add    $0xc,%esp

        /* Return to caller. */
	iret
c0021525:	cf                   	iret   

c0021526 <intr00_stub>:
                                                \
	.data;                                  \
	.long intr##NUMBER##_stub;

/* All the stubs. */
STUB(00, zero) STUB(01, zero) STUB(02, zero) STUB(03, zero)
c0021526:	55                   	push   %ebp
c0021527:	6a 00                	push   $0x0
c0021529:	6a 00                	push   $0x0
c002152b:	eb d0                	jmp    c00214fd <intr_entry>

c002152d <intr01_stub>:
c002152d:	55                   	push   %ebp
c002152e:	6a 00                	push   $0x0
c0021530:	6a 01                	push   $0x1
c0021532:	eb c9                	jmp    c00214fd <intr_entry>

c0021534 <intr02_stub>:
c0021534:	55                   	push   %ebp
c0021535:	6a 00                	push   $0x0
c0021537:	6a 02                	push   $0x2
c0021539:	eb c2                	jmp    c00214fd <intr_entry>

c002153b <intr03_stub>:
c002153b:	55                   	push   %ebp
c002153c:	6a 00                	push   $0x0
c002153e:	6a 03                	push   $0x3
c0021540:	eb bb                	jmp    c00214fd <intr_entry>

c0021542 <intr04_stub>:
STUB(04, zero) STUB(05, zero) STUB(06, zero) STUB(07, zero)
c0021542:	55                   	push   %ebp
c0021543:	6a 00                	push   $0x0
c0021545:	6a 04                	push   $0x4
c0021547:	eb b4                	jmp    c00214fd <intr_entry>

c0021549 <intr05_stub>:
c0021549:	55                   	push   %ebp
c002154a:	6a 00                	push   $0x0
c002154c:	6a 05                	push   $0x5
c002154e:	eb ad                	jmp    c00214fd <intr_entry>

c0021550 <intr06_stub>:
c0021550:	55                   	push   %ebp
c0021551:	6a 00                	push   $0x0
c0021553:	6a 06                	push   $0x6
c0021555:	eb a6                	jmp    c00214fd <intr_entry>

c0021557 <intr07_stub>:
c0021557:	55                   	push   %ebp
c0021558:	6a 00                	push   $0x0
c002155a:	6a 07                	push   $0x7
c002155c:	eb 9f                	jmp    c00214fd <intr_entry>

c002155e <intr08_stub>:
STUB(08, REAL) STUB(09, zero) STUB(0a, REAL) STUB(0b, REAL)
c002155e:	ff 34 24             	pushl  (%esp)
c0021561:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c0021565:	6a 08                	push   $0x8
c0021567:	eb 94                	jmp    c00214fd <intr_entry>

c0021569 <intr09_stub>:
c0021569:	55                   	push   %ebp
c002156a:	6a 00                	push   $0x0
c002156c:	6a 09                	push   $0x9
c002156e:	eb 8d                	jmp    c00214fd <intr_entry>

c0021570 <intr0a_stub>:
c0021570:	ff 34 24             	pushl  (%esp)
c0021573:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c0021577:	6a 0a                	push   $0xa
c0021579:	eb 82                	jmp    c00214fd <intr_entry>

c002157b <intr0b_stub>:
c002157b:	ff 34 24             	pushl  (%esp)
c002157e:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c0021582:	6a 0b                	push   $0xb
c0021584:	e9 74 ff ff ff       	jmp    c00214fd <intr_entry>

c0021589 <intr0c_stub>:
STUB(0c, zero) STUB(0d, REAL) STUB(0e, REAL) STUB(0f, zero)
c0021589:	55                   	push   %ebp
c002158a:	6a 00                	push   $0x0
c002158c:	6a 0c                	push   $0xc
c002158e:	e9 6a ff ff ff       	jmp    c00214fd <intr_entry>

c0021593 <intr0d_stub>:
c0021593:	ff 34 24             	pushl  (%esp)
c0021596:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c002159a:	6a 0d                	push   $0xd
c002159c:	e9 5c ff ff ff       	jmp    c00214fd <intr_entry>

c00215a1 <intr0e_stub>:
c00215a1:	ff 34 24             	pushl  (%esp)
c00215a4:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c00215a8:	6a 0e                	push   $0xe
c00215aa:	e9 4e ff ff ff       	jmp    c00214fd <intr_entry>

c00215af <intr0f_stub>:
c00215af:	55                   	push   %ebp
c00215b0:	6a 00                	push   $0x0
c00215b2:	6a 0f                	push   $0xf
c00215b4:	e9 44 ff ff ff       	jmp    c00214fd <intr_entry>

c00215b9 <intr10_stub>:

STUB(10, zero) STUB(11, REAL) STUB(12, zero) STUB(13, zero)
c00215b9:	55                   	push   %ebp
c00215ba:	6a 00                	push   $0x0
c00215bc:	6a 10                	push   $0x10
c00215be:	e9 3a ff ff ff       	jmp    c00214fd <intr_entry>

c00215c3 <intr11_stub>:
c00215c3:	ff 34 24             	pushl  (%esp)
c00215c6:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c00215ca:	6a 11                	push   $0x11
c00215cc:	e9 2c ff ff ff       	jmp    c00214fd <intr_entry>

c00215d1 <intr12_stub>:
c00215d1:	55                   	push   %ebp
c00215d2:	6a 00                	push   $0x0
c00215d4:	6a 12                	push   $0x12
c00215d6:	e9 22 ff ff ff       	jmp    c00214fd <intr_entry>

c00215db <intr13_stub>:
c00215db:	55                   	push   %ebp
c00215dc:	6a 00                	push   $0x0
c00215de:	6a 13                	push   $0x13
c00215e0:	e9 18 ff ff ff       	jmp    c00214fd <intr_entry>

c00215e5 <intr14_stub>:
STUB(14, zero) STUB(15, zero) STUB(16, zero) STUB(17, zero)
c00215e5:	55                   	push   %ebp
c00215e6:	6a 00                	push   $0x0
c00215e8:	6a 14                	push   $0x14
c00215ea:	e9 0e ff ff ff       	jmp    c00214fd <intr_entry>

c00215ef <intr15_stub>:
c00215ef:	55                   	push   %ebp
c00215f0:	6a 00                	push   $0x0
c00215f2:	6a 15                	push   $0x15
c00215f4:	e9 04 ff ff ff       	jmp    c00214fd <intr_entry>

c00215f9 <intr16_stub>:
c00215f9:	55                   	push   %ebp
c00215fa:	6a 00                	push   $0x0
c00215fc:	6a 16                	push   $0x16
c00215fe:	e9 fa fe ff ff       	jmp    c00214fd <intr_entry>

c0021603 <intr17_stub>:
c0021603:	55                   	push   %ebp
c0021604:	6a 00                	push   $0x0
c0021606:	6a 17                	push   $0x17
c0021608:	e9 f0 fe ff ff       	jmp    c00214fd <intr_entry>

c002160d <intr18_stub>:
STUB(18, REAL) STUB(19, zero) STUB(1a, REAL) STUB(1b, REAL)
c002160d:	ff 34 24             	pushl  (%esp)
c0021610:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c0021614:	6a 18                	push   $0x18
c0021616:	e9 e2 fe ff ff       	jmp    c00214fd <intr_entry>

c002161b <intr19_stub>:
c002161b:	55                   	push   %ebp
c002161c:	6a 00                	push   $0x0
c002161e:	6a 19                	push   $0x19
c0021620:	e9 d8 fe ff ff       	jmp    c00214fd <intr_entry>

c0021625 <intr1a_stub>:
c0021625:	ff 34 24             	pushl  (%esp)
c0021628:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c002162c:	6a 1a                	push   $0x1a
c002162e:	e9 ca fe ff ff       	jmp    c00214fd <intr_entry>

c0021633 <intr1b_stub>:
c0021633:	ff 34 24             	pushl  (%esp)
c0021636:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c002163a:	6a 1b                	push   $0x1b
c002163c:	e9 bc fe ff ff       	jmp    c00214fd <intr_entry>

c0021641 <intr1c_stub>:
STUB(1c, zero) STUB(1d, REAL) STUB(1e, REAL) STUB(1f, zero)
c0021641:	55                   	push   %ebp
c0021642:	6a 00                	push   $0x0
c0021644:	6a 1c                	push   $0x1c
c0021646:	e9 b2 fe ff ff       	jmp    c00214fd <intr_entry>

c002164b <intr1d_stub>:
c002164b:	ff 34 24             	pushl  (%esp)
c002164e:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c0021652:	6a 1d                	push   $0x1d
c0021654:	e9 a4 fe ff ff       	jmp    c00214fd <intr_entry>

c0021659 <intr1e_stub>:
c0021659:	ff 34 24             	pushl  (%esp)
c002165c:	89 6c 24 04          	mov    %ebp,0x4(%esp)
c0021660:	6a 1e                	push   $0x1e
c0021662:	e9 96 fe ff ff       	jmp    c00214fd <intr_entry>

c0021667 <intr1f_stub>:
c0021667:	55                   	push   %ebp
c0021668:	6a 00                	push   $0x0
c002166a:	6a 1f                	push   $0x1f
c002166c:	e9 8c fe ff ff       	jmp    c00214fd <intr_entry>

c0021671 <intr20_stub>:

STUB(20, zero) STUB(21, zero) STUB(22, zero) STUB(23, zero)
c0021671:	55                   	push   %ebp
c0021672:	6a 00                	push   $0x0
c0021674:	6a 20                	push   $0x20
c0021676:	e9 82 fe ff ff       	jmp    c00214fd <intr_entry>

c002167b <intr21_stub>:
c002167b:	55                   	push   %ebp
c002167c:	6a 00                	push   $0x0
c002167e:	6a 21                	push   $0x21
c0021680:	e9 78 fe ff ff       	jmp    c00214fd <intr_entry>

c0021685 <intr22_stub>:
c0021685:	55                   	push   %ebp
c0021686:	6a 00                	push   $0x0
c0021688:	6a 22                	push   $0x22
c002168a:	e9 6e fe ff ff       	jmp    c00214fd <intr_entry>

c002168f <intr23_stub>:
c002168f:	55                   	push   %ebp
c0021690:	6a 00                	push   $0x0
c0021692:	6a 23                	push   $0x23
c0021694:	e9 64 fe ff ff       	jmp    c00214fd <intr_entry>

c0021699 <intr24_stub>:
STUB(24, zero) STUB(25, zero) STUB(26, zero) STUB(27, zero)
c0021699:	55                   	push   %ebp
c002169a:	6a 00                	push   $0x0
c002169c:	6a 24                	push   $0x24
c002169e:	e9 5a fe ff ff       	jmp    c00214fd <intr_entry>

c00216a3 <intr25_stub>:
c00216a3:	55                   	push   %ebp
c00216a4:	6a 00                	push   $0x0
c00216a6:	6a 25                	push   $0x25
c00216a8:	e9 50 fe ff ff       	jmp    c00214fd <intr_entry>

c00216ad <intr26_stub>:
c00216ad:	55                   	push   %ebp
c00216ae:	6a 00                	push   $0x0
c00216b0:	6a 26                	push   $0x26
c00216b2:	e9 46 fe ff ff       	jmp    c00214fd <intr_entry>

c00216b7 <intr27_stub>:
c00216b7:	55                   	push   %ebp
c00216b8:	6a 00                	push   $0x0
c00216ba:	6a 27                	push   $0x27
c00216bc:	e9 3c fe ff ff       	jmp    c00214fd <intr_entry>

c00216c1 <intr28_stub>:
STUB(28, zero) STUB(29, zero) STUB(2a, zero) STUB(2b, zero)
c00216c1:	55                   	push   %ebp
c00216c2:	6a 00                	push   $0x0
c00216c4:	6a 28                	push   $0x28
c00216c6:	e9 32 fe ff ff       	jmp    c00214fd <intr_entry>

c00216cb <intr29_stub>:
c00216cb:	55                   	push   %ebp
c00216cc:	6a 00                	push   $0x0
c00216ce:	6a 29                	push   $0x29
c00216d0:	e9 28 fe ff ff       	jmp    c00214fd <intr_entry>

c00216d5 <intr2a_stub>:
c00216d5:	55                   	push   %ebp
c00216d6:	6a 00                	push   $0x0
c00216d8:	6a 2a                	push   $0x2a
c00216da:	e9 1e fe ff ff       	jmp    c00214fd <intr_entry>

c00216df <intr2b_stub>:
c00216df:	55                   	push   %ebp
c00216e0:	6a 00                	push   $0x0
c00216e2:	6a 2b                	push   $0x2b
c00216e4:	e9 14 fe ff ff       	jmp    c00214fd <intr_entry>

c00216e9 <intr2c_stub>:
STUB(2c, zero) STUB(2d, zero) STUB(2e, zero) STUB(2f, zero)
c00216e9:	55                   	push   %ebp
c00216ea:	6a 00                	push   $0x0
c00216ec:	6a 2c                	push   $0x2c
c00216ee:	e9 0a fe ff ff       	jmp    c00214fd <intr_entry>

c00216f3 <intr2d_stub>:
c00216f3:	55                   	push   %ebp
c00216f4:	6a 00                	push   $0x0
c00216f6:	6a 2d                	push   $0x2d
c00216f8:	e9 00 fe ff ff       	jmp    c00214fd <intr_entry>

c00216fd <intr2e_stub>:
c00216fd:	55                   	push   %ebp
c00216fe:	6a 00                	push   $0x0
c0021700:	6a 2e                	push   $0x2e
c0021702:	e9 f6 fd ff ff       	jmp    c00214fd <intr_entry>

c0021707 <intr2f_stub>:
c0021707:	55                   	push   %ebp
c0021708:	6a 00                	push   $0x0
c002170a:	6a 2f                	push   $0x2f
c002170c:	e9 ec fd ff ff       	jmp    c00214fd <intr_entry>

c0021711 <intr30_stub>:

STUB(30, zero) STUB(31, zero) STUB(32, zero) STUB(33, zero)
c0021711:	55                   	push   %ebp
c0021712:	6a 00                	push   $0x0
c0021714:	6a 30                	push   $0x30
c0021716:	e9 e2 fd ff ff       	jmp    c00214fd <intr_entry>

c002171b <intr31_stub>:
c002171b:	55                   	push   %ebp
c002171c:	6a 00                	push   $0x0
c002171e:	6a 31                	push   $0x31
c0021720:	e9 d8 fd ff ff       	jmp    c00214fd <intr_entry>

c0021725 <intr32_stub>:
c0021725:	55                   	push   %ebp
c0021726:	6a 00                	push   $0x0
c0021728:	6a 32                	push   $0x32
c002172a:	e9 ce fd ff ff       	jmp    c00214fd <intr_entry>

c002172f <intr33_stub>:
c002172f:	55                   	push   %ebp
c0021730:	6a 00                	push   $0x0
c0021732:	6a 33                	push   $0x33
c0021734:	e9 c4 fd ff ff       	jmp    c00214fd <intr_entry>

c0021739 <intr34_stub>:
STUB(34, zero) STUB(35, zero) STUB(36, zero) STUB(37, zero)
c0021739:	55                   	push   %ebp
c002173a:	6a 00                	push   $0x0
c002173c:	6a 34                	push   $0x34
c002173e:	e9 ba fd ff ff       	jmp    c00214fd <intr_entry>

c0021743 <intr35_stub>:
c0021743:	55                   	push   %ebp
c0021744:	6a 00                	push   $0x0
c0021746:	6a 35                	push   $0x35
c0021748:	e9 b0 fd ff ff       	jmp    c00214fd <intr_entry>

c002174d <intr36_stub>:
c002174d:	55                   	push   %ebp
c002174e:	6a 00                	push   $0x0
c0021750:	6a 36                	push   $0x36
c0021752:	e9 a6 fd ff ff       	jmp    c00214fd <intr_entry>

c0021757 <intr37_stub>:
c0021757:	55                   	push   %ebp
c0021758:	6a 00                	push   $0x0
c002175a:	6a 37                	push   $0x37
c002175c:	e9 9c fd ff ff       	jmp    c00214fd <intr_entry>

c0021761 <intr38_stub>:
STUB(38, zero) STUB(39, zero) STUB(3a, zero) STUB(3b, zero)
c0021761:	55                   	push   %ebp
c0021762:	6a 00                	push   $0x0
c0021764:	6a 38                	push   $0x38
c0021766:	e9 92 fd ff ff       	jmp    c00214fd <intr_entry>

c002176b <intr39_stub>:
c002176b:	55                   	push   %ebp
c002176c:	6a 00                	push   $0x0
c002176e:	6a 39                	push   $0x39
c0021770:	e9 88 fd ff ff       	jmp    c00214fd <intr_entry>

c0021775 <intr3a_stub>:
c0021775:	55                   	push   %ebp
c0021776:	6a 00                	push   $0x0
c0021778:	6a 3a                	push   $0x3a
c002177a:	e9 7e fd ff ff       	jmp    c00214fd <intr_entry>

c002177f <intr3b_stub>:
c002177f:	55                   	push   %ebp
c0021780:	6a 00                	push   $0x0
c0021782:	6a 3b                	push   $0x3b
c0021784:	e9 74 fd ff ff       	jmp    c00214fd <intr_entry>

c0021789 <intr3c_stub>:
STUB(3c, zero) STUB(3d, zero) STUB(3e, zero) STUB(3f, zero)
c0021789:	55                   	push   %ebp
c002178a:	6a 00                	push   $0x0
c002178c:	6a 3c                	push   $0x3c
c002178e:	e9 6a fd ff ff       	jmp    c00214fd <intr_entry>

c0021793 <intr3d_stub>:
c0021793:	55                   	push   %ebp
c0021794:	6a 00                	push   $0x0
c0021796:	6a 3d                	push   $0x3d
c0021798:	e9 60 fd ff ff       	jmp    c00214fd <intr_entry>

c002179d <intr3e_stub>:
c002179d:	55                   	push   %ebp
c002179e:	6a 00                	push   $0x0
c00217a0:	6a 3e                	push   $0x3e
c00217a2:	e9 56 fd ff ff       	jmp    c00214fd <intr_entry>

c00217a7 <intr3f_stub>:
c00217a7:	55                   	push   %ebp
c00217a8:	6a 00                	push   $0x0
c00217aa:	6a 3f                	push   $0x3f
c00217ac:	e9 4c fd ff ff       	jmp    c00214fd <intr_entry>

c00217b1 <intr40_stub>:

STUB(40, zero) STUB(41, zero) STUB(42, zero) STUB(43, zero)
c00217b1:	55                   	push   %ebp
c00217b2:	6a 00                	push   $0x0
c00217b4:	6a 40                	push   $0x40
c00217b6:	e9 42 fd ff ff       	jmp    c00214fd <intr_entry>

c00217bb <intr41_stub>:
c00217bb:	55                   	push   %ebp
c00217bc:	6a 00                	push   $0x0
c00217be:	6a 41                	push   $0x41
c00217c0:	e9 38 fd ff ff       	jmp    c00214fd <intr_entry>

c00217c5 <intr42_stub>:
c00217c5:	55                   	push   %ebp
c00217c6:	6a 00                	push   $0x0
c00217c8:	6a 42                	push   $0x42
c00217ca:	e9 2e fd ff ff       	jmp    c00214fd <intr_entry>

c00217cf <intr43_stub>:
c00217cf:	55                   	push   %ebp
c00217d0:	6a 00                	push   $0x0
c00217d2:	6a 43                	push   $0x43
c00217d4:	e9 24 fd ff ff       	jmp    c00214fd <intr_entry>

c00217d9 <intr44_stub>:
STUB(44, zero) STUB(45, zero) STUB(46, zero) STUB(47, zero)
c00217d9:	55                   	push   %ebp
c00217da:	6a 00                	push   $0x0
c00217dc:	6a 44                	push   $0x44
c00217de:	e9 1a fd ff ff       	jmp    c00214fd <intr_entry>

c00217e3 <intr45_stub>:
c00217e3:	55                   	push   %ebp
c00217e4:	6a 00                	push   $0x0
c00217e6:	6a 45                	push   $0x45
c00217e8:	e9 10 fd ff ff       	jmp    c00214fd <intr_entry>

c00217ed <intr46_stub>:
c00217ed:	55                   	push   %ebp
c00217ee:	6a 00                	push   $0x0
c00217f0:	6a 46                	push   $0x46
c00217f2:	e9 06 fd ff ff       	jmp    c00214fd <intr_entry>

c00217f7 <intr47_stub>:
c00217f7:	55                   	push   %ebp
c00217f8:	6a 00                	push   $0x0
c00217fa:	6a 47                	push   $0x47
c00217fc:	e9 fc fc ff ff       	jmp    c00214fd <intr_entry>

c0021801 <intr48_stub>:
STUB(48, zero) STUB(49, zero) STUB(4a, zero) STUB(4b, zero)
c0021801:	55                   	push   %ebp
c0021802:	6a 00                	push   $0x0
c0021804:	6a 48                	push   $0x48
c0021806:	e9 f2 fc ff ff       	jmp    c00214fd <intr_entry>

c002180b <intr49_stub>:
c002180b:	55                   	push   %ebp
c002180c:	6a 00                	push   $0x0
c002180e:	6a 49                	push   $0x49
c0021810:	e9 e8 fc ff ff       	jmp    c00214fd <intr_entry>

c0021815 <intr4a_stub>:
c0021815:	55                   	push   %ebp
c0021816:	6a 00                	push   $0x0
c0021818:	6a 4a                	push   $0x4a
c002181a:	e9 de fc ff ff       	jmp    c00214fd <intr_entry>

c002181f <intr4b_stub>:
c002181f:	55                   	push   %ebp
c0021820:	6a 00                	push   $0x0
c0021822:	6a 4b                	push   $0x4b
c0021824:	e9 d4 fc ff ff       	jmp    c00214fd <intr_entry>

c0021829 <intr4c_stub>:
STUB(4c, zero) STUB(4d, zero) STUB(4e, zero) STUB(4f, zero)
c0021829:	55                   	push   %ebp
c002182a:	6a 00                	push   $0x0
c002182c:	6a 4c                	push   $0x4c
c002182e:	e9 ca fc ff ff       	jmp    c00214fd <intr_entry>

c0021833 <intr4d_stub>:
c0021833:	55                   	push   %ebp
c0021834:	6a 00                	push   $0x0
c0021836:	6a 4d                	push   $0x4d
c0021838:	e9 c0 fc ff ff       	jmp    c00214fd <intr_entry>

c002183d <intr4e_stub>:
c002183d:	55                   	push   %ebp
c002183e:	6a 00                	push   $0x0
c0021840:	6a 4e                	push   $0x4e
c0021842:	e9 b6 fc ff ff       	jmp    c00214fd <intr_entry>

c0021847 <intr4f_stub>:
c0021847:	55                   	push   %ebp
c0021848:	6a 00                	push   $0x0
c002184a:	6a 4f                	push   $0x4f
c002184c:	e9 ac fc ff ff       	jmp    c00214fd <intr_entry>

c0021851 <intr50_stub>:

STUB(50, zero) STUB(51, zero) STUB(52, zero) STUB(53, zero)
c0021851:	55                   	push   %ebp
c0021852:	6a 00                	push   $0x0
c0021854:	6a 50                	push   $0x50
c0021856:	e9 a2 fc ff ff       	jmp    c00214fd <intr_entry>

c002185b <intr51_stub>:
c002185b:	55                   	push   %ebp
c002185c:	6a 00                	push   $0x0
c002185e:	6a 51                	push   $0x51
c0021860:	e9 98 fc ff ff       	jmp    c00214fd <intr_entry>

c0021865 <intr52_stub>:
c0021865:	55                   	push   %ebp
c0021866:	6a 00                	push   $0x0
c0021868:	6a 52                	push   $0x52
c002186a:	e9 8e fc ff ff       	jmp    c00214fd <intr_entry>

c002186f <intr53_stub>:
c002186f:	55                   	push   %ebp
c0021870:	6a 00                	push   $0x0
c0021872:	6a 53                	push   $0x53
c0021874:	e9 84 fc ff ff       	jmp    c00214fd <intr_entry>

c0021879 <intr54_stub>:
STUB(54, zero) STUB(55, zero) STUB(56, zero) STUB(57, zero)
c0021879:	55                   	push   %ebp
c002187a:	6a 00                	push   $0x0
c002187c:	6a 54                	push   $0x54
c002187e:	e9 7a fc ff ff       	jmp    c00214fd <intr_entry>

c0021883 <intr55_stub>:
c0021883:	55                   	push   %ebp
c0021884:	6a 00                	push   $0x0
c0021886:	6a 55                	push   $0x55
c0021888:	e9 70 fc ff ff       	jmp    c00214fd <intr_entry>

c002188d <intr56_stub>:
c002188d:	55                   	push   %ebp
c002188e:	6a 00                	push   $0x0
c0021890:	6a 56                	push   $0x56
c0021892:	e9 66 fc ff ff       	jmp    c00214fd <intr_entry>

c0021897 <intr57_stub>:
c0021897:	55                   	push   %ebp
c0021898:	6a 00                	push   $0x0
c002189a:	6a 57                	push   $0x57
c002189c:	e9 5c fc ff ff       	jmp    c00214fd <intr_entry>

c00218a1 <intr58_stub>:
STUB(58, zero) STUB(59, zero) STUB(5a, zero) STUB(5b, zero)
c00218a1:	55                   	push   %ebp
c00218a2:	6a 00                	push   $0x0
c00218a4:	6a 58                	push   $0x58
c00218a6:	e9 52 fc ff ff       	jmp    c00214fd <intr_entry>

c00218ab <intr59_stub>:
c00218ab:	55                   	push   %ebp
c00218ac:	6a 00                	push   $0x0
c00218ae:	6a 59                	push   $0x59
c00218b0:	e9 48 fc ff ff       	jmp    c00214fd <intr_entry>

c00218b5 <intr5a_stub>:
c00218b5:	55                   	push   %ebp
c00218b6:	6a 00                	push   $0x0
c00218b8:	6a 5a                	push   $0x5a
c00218ba:	e9 3e fc ff ff       	jmp    c00214fd <intr_entry>

c00218bf <intr5b_stub>:
c00218bf:	55                   	push   %ebp
c00218c0:	6a 00                	push   $0x0
c00218c2:	6a 5b                	push   $0x5b
c00218c4:	e9 34 fc ff ff       	jmp    c00214fd <intr_entry>

c00218c9 <intr5c_stub>:
STUB(5c, zero) STUB(5d, zero) STUB(5e, zero) STUB(5f, zero)
c00218c9:	55                   	push   %ebp
c00218ca:	6a 00                	push   $0x0
c00218cc:	6a 5c                	push   $0x5c
c00218ce:	e9 2a fc ff ff       	jmp    c00214fd <intr_entry>

c00218d3 <intr5d_stub>:
c00218d3:	55                   	push   %ebp
c00218d4:	6a 00                	push   $0x0
c00218d6:	6a 5d                	push   $0x5d
c00218d8:	e9 20 fc ff ff       	jmp    c00214fd <intr_entry>

c00218dd <intr5e_stub>:
c00218dd:	55                   	push   %ebp
c00218de:	6a 00                	push   $0x0
c00218e0:	6a 5e                	push   $0x5e
c00218e2:	e9 16 fc ff ff       	jmp    c00214fd <intr_entry>

c00218e7 <intr5f_stub>:
c00218e7:	55                   	push   %ebp
c00218e8:	6a 00                	push   $0x0
c00218ea:	6a 5f                	push   $0x5f
c00218ec:	e9 0c fc ff ff       	jmp    c00214fd <intr_entry>

c00218f1 <intr60_stub>:

STUB(60, zero) STUB(61, zero) STUB(62, zero) STUB(63, zero)
c00218f1:	55                   	push   %ebp
c00218f2:	6a 00                	push   $0x0
c00218f4:	6a 60                	push   $0x60
c00218f6:	e9 02 fc ff ff       	jmp    c00214fd <intr_entry>

c00218fb <intr61_stub>:
c00218fb:	55                   	push   %ebp
c00218fc:	6a 00                	push   $0x0
c00218fe:	6a 61                	push   $0x61
c0021900:	e9 f8 fb ff ff       	jmp    c00214fd <intr_entry>

c0021905 <intr62_stub>:
c0021905:	55                   	push   %ebp
c0021906:	6a 00                	push   $0x0
c0021908:	6a 62                	push   $0x62
c002190a:	e9 ee fb ff ff       	jmp    c00214fd <intr_entry>

c002190f <intr63_stub>:
c002190f:	55                   	push   %ebp
c0021910:	6a 00                	push   $0x0
c0021912:	6a 63                	push   $0x63
c0021914:	e9 e4 fb ff ff       	jmp    c00214fd <intr_entry>

c0021919 <intr64_stub>:
STUB(64, zero) STUB(65, zero) STUB(66, zero) STUB(67, zero)
c0021919:	55                   	push   %ebp
c002191a:	6a 00                	push   $0x0
c002191c:	6a 64                	push   $0x64
c002191e:	e9 da fb ff ff       	jmp    c00214fd <intr_entry>

c0021923 <intr65_stub>:
c0021923:	55                   	push   %ebp
c0021924:	6a 00                	push   $0x0
c0021926:	6a 65                	push   $0x65
c0021928:	e9 d0 fb ff ff       	jmp    c00214fd <intr_entry>

c002192d <intr66_stub>:
c002192d:	55                   	push   %ebp
c002192e:	6a 00                	push   $0x0
c0021930:	6a 66                	push   $0x66
c0021932:	e9 c6 fb ff ff       	jmp    c00214fd <intr_entry>

c0021937 <intr67_stub>:
c0021937:	55                   	push   %ebp
c0021938:	6a 00                	push   $0x0
c002193a:	6a 67                	push   $0x67
c002193c:	e9 bc fb ff ff       	jmp    c00214fd <intr_entry>

c0021941 <intr68_stub>:
STUB(68, zero) STUB(69, zero) STUB(6a, zero) STUB(6b, zero)
c0021941:	55                   	push   %ebp
c0021942:	6a 00                	push   $0x0
c0021944:	6a 68                	push   $0x68
c0021946:	e9 b2 fb ff ff       	jmp    c00214fd <intr_entry>

c002194b <intr69_stub>:
c002194b:	55                   	push   %ebp
c002194c:	6a 00                	push   $0x0
c002194e:	6a 69                	push   $0x69
c0021950:	e9 a8 fb ff ff       	jmp    c00214fd <intr_entry>

c0021955 <intr6a_stub>:
c0021955:	55                   	push   %ebp
c0021956:	6a 00                	push   $0x0
c0021958:	6a 6a                	push   $0x6a
c002195a:	e9 9e fb ff ff       	jmp    c00214fd <intr_entry>

c002195f <intr6b_stub>:
c002195f:	55                   	push   %ebp
c0021960:	6a 00                	push   $0x0
c0021962:	6a 6b                	push   $0x6b
c0021964:	e9 94 fb ff ff       	jmp    c00214fd <intr_entry>

c0021969 <intr6c_stub>:
STUB(6c, zero) STUB(6d, zero) STUB(6e, zero) STUB(6f, zero)
c0021969:	55                   	push   %ebp
c002196a:	6a 00                	push   $0x0
c002196c:	6a 6c                	push   $0x6c
c002196e:	e9 8a fb ff ff       	jmp    c00214fd <intr_entry>

c0021973 <intr6d_stub>:
c0021973:	55                   	push   %ebp
c0021974:	6a 00                	push   $0x0
c0021976:	6a 6d                	push   $0x6d
c0021978:	e9 80 fb ff ff       	jmp    c00214fd <intr_entry>

c002197d <intr6e_stub>:
c002197d:	55                   	push   %ebp
c002197e:	6a 00                	push   $0x0
c0021980:	6a 6e                	push   $0x6e
c0021982:	e9 76 fb ff ff       	jmp    c00214fd <intr_entry>

c0021987 <intr6f_stub>:
c0021987:	55                   	push   %ebp
c0021988:	6a 00                	push   $0x0
c002198a:	6a 6f                	push   $0x6f
c002198c:	e9 6c fb ff ff       	jmp    c00214fd <intr_entry>

c0021991 <intr70_stub>:

STUB(70, zero) STUB(71, zero) STUB(72, zero) STUB(73, zero)
c0021991:	55                   	push   %ebp
c0021992:	6a 00                	push   $0x0
c0021994:	6a 70                	push   $0x70
c0021996:	e9 62 fb ff ff       	jmp    c00214fd <intr_entry>

c002199b <intr71_stub>:
c002199b:	55                   	push   %ebp
c002199c:	6a 00                	push   $0x0
c002199e:	6a 71                	push   $0x71
c00219a0:	e9 58 fb ff ff       	jmp    c00214fd <intr_entry>

c00219a5 <intr72_stub>:
c00219a5:	55                   	push   %ebp
c00219a6:	6a 00                	push   $0x0
c00219a8:	6a 72                	push   $0x72
c00219aa:	e9 4e fb ff ff       	jmp    c00214fd <intr_entry>

c00219af <intr73_stub>:
c00219af:	55                   	push   %ebp
c00219b0:	6a 00                	push   $0x0
c00219b2:	6a 73                	push   $0x73
c00219b4:	e9 44 fb ff ff       	jmp    c00214fd <intr_entry>

c00219b9 <intr74_stub>:
STUB(74, zero) STUB(75, zero) STUB(76, zero) STUB(77, zero)
c00219b9:	55                   	push   %ebp
c00219ba:	6a 00                	push   $0x0
c00219bc:	6a 74                	push   $0x74
c00219be:	e9 3a fb ff ff       	jmp    c00214fd <intr_entry>

c00219c3 <intr75_stub>:
c00219c3:	55                   	push   %ebp
c00219c4:	6a 00                	push   $0x0
c00219c6:	6a 75                	push   $0x75
c00219c8:	e9 30 fb ff ff       	jmp    c00214fd <intr_entry>

c00219cd <intr76_stub>:
c00219cd:	55                   	push   %ebp
c00219ce:	6a 00                	push   $0x0
c00219d0:	6a 76                	push   $0x76
c00219d2:	e9 26 fb ff ff       	jmp    c00214fd <intr_entry>

c00219d7 <intr77_stub>:
c00219d7:	55                   	push   %ebp
c00219d8:	6a 00                	push   $0x0
c00219da:	6a 77                	push   $0x77
c00219dc:	e9 1c fb ff ff       	jmp    c00214fd <intr_entry>

c00219e1 <intr78_stub>:
STUB(78, zero) STUB(79, zero) STUB(7a, zero) STUB(7b, zero)
c00219e1:	55                   	push   %ebp
c00219e2:	6a 00                	push   $0x0
c00219e4:	6a 78                	push   $0x78
c00219e6:	e9 12 fb ff ff       	jmp    c00214fd <intr_entry>

c00219eb <intr79_stub>:
c00219eb:	55                   	push   %ebp
c00219ec:	6a 00                	push   $0x0
c00219ee:	6a 79                	push   $0x79
c00219f0:	e9 08 fb ff ff       	jmp    c00214fd <intr_entry>

c00219f5 <intr7a_stub>:
c00219f5:	55                   	push   %ebp
c00219f6:	6a 00                	push   $0x0
c00219f8:	6a 7a                	push   $0x7a
c00219fa:	e9 fe fa ff ff       	jmp    c00214fd <intr_entry>

c00219ff <intr7b_stub>:
c00219ff:	55                   	push   %ebp
c0021a00:	6a 00                	push   $0x0
c0021a02:	6a 7b                	push   $0x7b
c0021a04:	e9 f4 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a09 <intr7c_stub>:
STUB(7c, zero) STUB(7d, zero) STUB(7e, zero) STUB(7f, zero)
c0021a09:	55                   	push   %ebp
c0021a0a:	6a 00                	push   $0x0
c0021a0c:	6a 7c                	push   $0x7c
c0021a0e:	e9 ea fa ff ff       	jmp    c00214fd <intr_entry>

c0021a13 <intr7d_stub>:
c0021a13:	55                   	push   %ebp
c0021a14:	6a 00                	push   $0x0
c0021a16:	6a 7d                	push   $0x7d
c0021a18:	e9 e0 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a1d <intr7e_stub>:
c0021a1d:	55                   	push   %ebp
c0021a1e:	6a 00                	push   $0x0
c0021a20:	6a 7e                	push   $0x7e
c0021a22:	e9 d6 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a27 <intr7f_stub>:
c0021a27:	55                   	push   %ebp
c0021a28:	6a 00                	push   $0x0
c0021a2a:	6a 7f                	push   $0x7f
c0021a2c:	e9 cc fa ff ff       	jmp    c00214fd <intr_entry>

c0021a31 <intr80_stub>:

STUB(80, zero) STUB(81, zero) STUB(82, zero) STUB(83, zero)
c0021a31:	55                   	push   %ebp
c0021a32:	6a 00                	push   $0x0
c0021a34:	68 80 00 00 00       	push   $0x80
c0021a39:	e9 bf fa ff ff       	jmp    c00214fd <intr_entry>

c0021a3e <intr81_stub>:
c0021a3e:	55                   	push   %ebp
c0021a3f:	6a 00                	push   $0x0
c0021a41:	68 81 00 00 00       	push   $0x81
c0021a46:	e9 b2 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a4b <intr82_stub>:
c0021a4b:	55                   	push   %ebp
c0021a4c:	6a 00                	push   $0x0
c0021a4e:	68 82 00 00 00       	push   $0x82
c0021a53:	e9 a5 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a58 <intr83_stub>:
c0021a58:	55                   	push   %ebp
c0021a59:	6a 00                	push   $0x0
c0021a5b:	68 83 00 00 00       	push   $0x83
c0021a60:	e9 98 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a65 <intr84_stub>:
STUB(84, zero) STUB(85, zero) STUB(86, zero) STUB(87, zero)
c0021a65:	55                   	push   %ebp
c0021a66:	6a 00                	push   $0x0
c0021a68:	68 84 00 00 00       	push   $0x84
c0021a6d:	e9 8b fa ff ff       	jmp    c00214fd <intr_entry>

c0021a72 <intr85_stub>:
c0021a72:	55                   	push   %ebp
c0021a73:	6a 00                	push   $0x0
c0021a75:	68 85 00 00 00       	push   $0x85
c0021a7a:	e9 7e fa ff ff       	jmp    c00214fd <intr_entry>

c0021a7f <intr86_stub>:
c0021a7f:	55                   	push   %ebp
c0021a80:	6a 00                	push   $0x0
c0021a82:	68 86 00 00 00       	push   $0x86
c0021a87:	e9 71 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a8c <intr87_stub>:
c0021a8c:	55                   	push   %ebp
c0021a8d:	6a 00                	push   $0x0
c0021a8f:	68 87 00 00 00       	push   $0x87
c0021a94:	e9 64 fa ff ff       	jmp    c00214fd <intr_entry>

c0021a99 <intr88_stub>:
STUB(88, zero) STUB(89, zero) STUB(8a, zero) STUB(8b, zero)
c0021a99:	55                   	push   %ebp
c0021a9a:	6a 00                	push   $0x0
c0021a9c:	68 88 00 00 00       	push   $0x88
c0021aa1:	e9 57 fa ff ff       	jmp    c00214fd <intr_entry>

c0021aa6 <intr89_stub>:
c0021aa6:	55                   	push   %ebp
c0021aa7:	6a 00                	push   $0x0
c0021aa9:	68 89 00 00 00       	push   $0x89
c0021aae:	e9 4a fa ff ff       	jmp    c00214fd <intr_entry>

c0021ab3 <intr8a_stub>:
c0021ab3:	55                   	push   %ebp
c0021ab4:	6a 00                	push   $0x0
c0021ab6:	68 8a 00 00 00       	push   $0x8a
c0021abb:	e9 3d fa ff ff       	jmp    c00214fd <intr_entry>

c0021ac0 <intr8b_stub>:
c0021ac0:	55                   	push   %ebp
c0021ac1:	6a 00                	push   $0x0
c0021ac3:	68 8b 00 00 00       	push   $0x8b
c0021ac8:	e9 30 fa ff ff       	jmp    c00214fd <intr_entry>

c0021acd <intr8c_stub>:
STUB(8c, zero) STUB(8d, zero) STUB(8e, zero) STUB(8f, zero)
c0021acd:	55                   	push   %ebp
c0021ace:	6a 00                	push   $0x0
c0021ad0:	68 8c 00 00 00       	push   $0x8c
c0021ad5:	e9 23 fa ff ff       	jmp    c00214fd <intr_entry>

c0021ada <intr8d_stub>:
c0021ada:	55                   	push   %ebp
c0021adb:	6a 00                	push   $0x0
c0021add:	68 8d 00 00 00       	push   $0x8d
c0021ae2:	e9 16 fa ff ff       	jmp    c00214fd <intr_entry>

c0021ae7 <intr8e_stub>:
c0021ae7:	55                   	push   %ebp
c0021ae8:	6a 00                	push   $0x0
c0021aea:	68 8e 00 00 00       	push   $0x8e
c0021aef:	e9 09 fa ff ff       	jmp    c00214fd <intr_entry>

c0021af4 <intr8f_stub>:
c0021af4:	55                   	push   %ebp
c0021af5:	6a 00                	push   $0x0
c0021af7:	68 8f 00 00 00       	push   $0x8f
c0021afc:	e9 fc f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b01 <intr90_stub>:

STUB(90, zero) STUB(91, zero) STUB(92, zero) STUB(93, zero)
c0021b01:	55                   	push   %ebp
c0021b02:	6a 00                	push   $0x0
c0021b04:	68 90 00 00 00       	push   $0x90
c0021b09:	e9 ef f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b0e <intr91_stub>:
c0021b0e:	55                   	push   %ebp
c0021b0f:	6a 00                	push   $0x0
c0021b11:	68 91 00 00 00       	push   $0x91
c0021b16:	e9 e2 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b1b <intr92_stub>:
c0021b1b:	55                   	push   %ebp
c0021b1c:	6a 00                	push   $0x0
c0021b1e:	68 92 00 00 00       	push   $0x92
c0021b23:	e9 d5 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b28 <intr93_stub>:
c0021b28:	55                   	push   %ebp
c0021b29:	6a 00                	push   $0x0
c0021b2b:	68 93 00 00 00       	push   $0x93
c0021b30:	e9 c8 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b35 <intr94_stub>:
STUB(94, zero) STUB(95, zero) STUB(96, zero) STUB(97, zero)
c0021b35:	55                   	push   %ebp
c0021b36:	6a 00                	push   $0x0
c0021b38:	68 94 00 00 00       	push   $0x94
c0021b3d:	e9 bb f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b42 <intr95_stub>:
c0021b42:	55                   	push   %ebp
c0021b43:	6a 00                	push   $0x0
c0021b45:	68 95 00 00 00       	push   $0x95
c0021b4a:	e9 ae f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b4f <intr96_stub>:
c0021b4f:	55                   	push   %ebp
c0021b50:	6a 00                	push   $0x0
c0021b52:	68 96 00 00 00       	push   $0x96
c0021b57:	e9 a1 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b5c <intr97_stub>:
c0021b5c:	55                   	push   %ebp
c0021b5d:	6a 00                	push   $0x0
c0021b5f:	68 97 00 00 00       	push   $0x97
c0021b64:	e9 94 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b69 <intr98_stub>:
STUB(98, zero) STUB(99, zero) STUB(9a, zero) STUB(9b, zero)
c0021b69:	55                   	push   %ebp
c0021b6a:	6a 00                	push   $0x0
c0021b6c:	68 98 00 00 00       	push   $0x98
c0021b71:	e9 87 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b76 <intr99_stub>:
c0021b76:	55                   	push   %ebp
c0021b77:	6a 00                	push   $0x0
c0021b79:	68 99 00 00 00       	push   $0x99
c0021b7e:	e9 7a f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b83 <intr9a_stub>:
c0021b83:	55                   	push   %ebp
c0021b84:	6a 00                	push   $0x0
c0021b86:	68 9a 00 00 00       	push   $0x9a
c0021b8b:	e9 6d f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b90 <intr9b_stub>:
c0021b90:	55                   	push   %ebp
c0021b91:	6a 00                	push   $0x0
c0021b93:	68 9b 00 00 00       	push   $0x9b
c0021b98:	e9 60 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021b9d <intr9c_stub>:
STUB(9c, zero) STUB(9d, zero) STUB(9e, zero) STUB(9f, zero)
c0021b9d:	55                   	push   %ebp
c0021b9e:	6a 00                	push   $0x0
c0021ba0:	68 9c 00 00 00       	push   $0x9c
c0021ba5:	e9 53 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021baa <intr9d_stub>:
c0021baa:	55                   	push   %ebp
c0021bab:	6a 00                	push   $0x0
c0021bad:	68 9d 00 00 00       	push   $0x9d
c0021bb2:	e9 46 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021bb7 <intr9e_stub>:
c0021bb7:	55                   	push   %ebp
c0021bb8:	6a 00                	push   $0x0
c0021bba:	68 9e 00 00 00       	push   $0x9e
c0021bbf:	e9 39 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021bc4 <intr9f_stub>:
c0021bc4:	55                   	push   %ebp
c0021bc5:	6a 00                	push   $0x0
c0021bc7:	68 9f 00 00 00       	push   $0x9f
c0021bcc:	e9 2c f9 ff ff       	jmp    c00214fd <intr_entry>

c0021bd1 <intra0_stub>:

STUB(a0, zero) STUB(a1, zero) STUB(a2, zero) STUB(a3, zero)
c0021bd1:	55                   	push   %ebp
c0021bd2:	6a 00                	push   $0x0
c0021bd4:	68 a0 00 00 00       	push   $0xa0
c0021bd9:	e9 1f f9 ff ff       	jmp    c00214fd <intr_entry>

c0021bde <intra1_stub>:
c0021bde:	55                   	push   %ebp
c0021bdf:	6a 00                	push   $0x0
c0021be1:	68 a1 00 00 00       	push   $0xa1
c0021be6:	e9 12 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021beb <intra2_stub>:
c0021beb:	55                   	push   %ebp
c0021bec:	6a 00                	push   $0x0
c0021bee:	68 a2 00 00 00       	push   $0xa2
c0021bf3:	e9 05 f9 ff ff       	jmp    c00214fd <intr_entry>

c0021bf8 <intra3_stub>:
c0021bf8:	55                   	push   %ebp
c0021bf9:	6a 00                	push   $0x0
c0021bfb:	68 a3 00 00 00       	push   $0xa3
c0021c00:	e9 f8 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c05 <intra4_stub>:
STUB(a4, zero) STUB(a5, zero) STUB(a6, zero) STUB(a7, zero)
c0021c05:	55                   	push   %ebp
c0021c06:	6a 00                	push   $0x0
c0021c08:	68 a4 00 00 00       	push   $0xa4
c0021c0d:	e9 eb f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c12 <intra5_stub>:
c0021c12:	55                   	push   %ebp
c0021c13:	6a 00                	push   $0x0
c0021c15:	68 a5 00 00 00       	push   $0xa5
c0021c1a:	e9 de f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c1f <intra6_stub>:
c0021c1f:	55                   	push   %ebp
c0021c20:	6a 00                	push   $0x0
c0021c22:	68 a6 00 00 00       	push   $0xa6
c0021c27:	e9 d1 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c2c <intra7_stub>:
c0021c2c:	55                   	push   %ebp
c0021c2d:	6a 00                	push   $0x0
c0021c2f:	68 a7 00 00 00       	push   $0xa7
c0021c34:	e9 c4 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c39 <intra8_stub>:
STUB(a8, zero) STUB(a9, zero) STUB(aa, zero) STUB(ab, zero)
c0021c39:	55                   	push   %ebp
c0021c3a:	6a 00                	push   $0x0
c0021c3c:	68 a8 00 00 00       	push   $0xa8
c0021c41:	e9 b7 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c46 <intra9_stub>:
c0021c46:	55                   	push   %ebp
c0021c47:	6a 00                	push   $0x0
c0021c49:	68 a9 00 00 00       	push   $0xa9
c0021c4e:	e9 aa f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c53 <intraa_stub>:
c0021c53:	55                   	push   %ebp
c0021c54:	6a 00                	push   $0x0
c0021c56:	68 aa 00 00 00       	push   $0xaa
c0021c5b:	e9 9d f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c60 <intrab_stub>:
c0021c60:	55                   	push   %ebp
c0021c61:	6a 00                	push   $0x0
c0021c63:	68 ab 00 00 00       	push   $0xab
c0021c68:	e9 90 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c6d <intrac_stub>:
STUB(ac, zero) STUB(ad, zero) STUB(ae, zero) STUB(af, zero)
c0021c6d:	55                   	push   %ebp
c0021c6e:	6a 00                	push   $0x0
c0021c70:	68 ac 00 00 00       	push   $0xac
c0021c75:	e9 83 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c7a <intrad_stub>:
c0021c7a:	55                   	push   %ebp
c0021c7b:	6a 00                	push   $0x0
c0021c7d:	68 ad 00 00 00       	push   $0xad
c0021c82:	e9 76 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c87 <intrae_stub>:
c0021c87:	55                   	push   %ebp
c0021c88:	6a 00                	push   $0x0
c0021c8a:	68 ae 00 00 00       	push   $0xae
c0021c8f:	e9 69 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021c94 <intraf_stub>:
c0021c94:	55                   	push   %ebp
c0021c95:	6a 00                	push   $0x0
c0021c97:	68 af 00 00 00       	push   $0xaf
c0021c9c:	e9 5c f8 ff ff       	jmp    c00214fd <intr_entry>

c0021ca1 <intrb0_stub>:

STUB(b0, zero) STUB(b1, zero) STUB(b2, zero) STUB(b3, zero)
c0021ca1:	55                   	push   %ebp
c0021ca2:	6a 00                	push   $0x0
c0021ca4:	68 b0 00 00 00       	push   $0xb0
c0021ca9:	e9 4f f8 ff ff       	jmp    c00214fd <intr_entry>

c0021cae <intrb1_stub>:
c0021cae:	55                   	push   %ebp
c0021caf:	6a 00                	push   $0x0
c0021cb1:	68 b1 00 00 00       	push   $0xb1
c0021cb6:	e9 42 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021cbb <intrb2_stub>:
c0021cbb:	55                   	push   %ebp
c0021cbc:	6a 00                	push   $0x0
c0021cbe:	68 b2 00 00 00       	push   $0xb2
c0021cc3:	e9 35 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021cc8 <intrb3_stub>:
c0021cc8:	55                   	push   %ebp
c0021cc9:	6a 00                	push   $0x0
c0021ccb:	68 b3 00 00 00       	push   $0xb3
c0021cd0:	e9 28 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021cd5 <intrb4_stub>:
STUB(b4, zero) STUB(b5, zero) STUB(b6, zero) STUB(b7, zero)
c0021cd5:	55                   	push   %ebp
c0021cd6:	6a 00                	push   $0x0
c0021cd8:	68 b4 00 00 00       	push   $0xb4
c0021cdd:	e9 1b f8 ff ff       	jmp    c00214fd <intr_entry>

c0021ce2 <intrb5_stub>:
c0021ce2:	55                   	push   %ebp
c0021ce3:	6a 00                	push   $0x0
c0021ce5:	68 b5 00 00 00       	push   $0xb5
c0021cea:	e9 0e f8 ff ff       	jmp    c00214fd <intr_entry>

c0021cef <intrb6_stub>:
c0021cef:	55                   	push   %ebp
c0021cf0:	6a 00                	push   $0x0
c0021cf2:	68 b6 00 00 00       	push   $0xb6
c0021cf7:	e9 01 f8 ff ff       	jmp    c00214fd <intr_entry>

c0021cfc <intrb7_stub>:
c0021cfc:	55                   	push   %ebp
c0021cfd:	6a 00                	push   $0x0
c0021cff:	68 b7 00 00 00       	push   $0xb7
c0021d04:	e9 f4 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d09 <intrb8_stub>:
STUB(b8, zero) STUB(b9, zero) STUB(ba, zero) STUB(bb, zero)
c0021d09:	55                   	push   %ebp
c0021d0a:	6a 00                	push   $0x0
c0021d0c:	68 b8 00 00 00       	push   $0xb8
c0021d11:	e9 e7 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d16 <intrb9_stub>:
c0021d16:	55                   	push   %ebp
c0021d17:	6a 00                	push   $0x0
c0021d19:	68 b9 00 00 00       	push   $0xb9
c0021d1e:	e9 da f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d23 <intrba_stub>:
c0021d23:	55                   	push   %ebp
c0021d24:	6a 00                	push   $0x0
c0021d26:	68 ba 00 00 00       	push   $0xba
c0021d2b:	e9 cd f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d30 <intrbb_stub>:
c0021d30:	55                   	push   %ebp
c0021d31:	6a 00                	push   $0x0
c0021d33:	68 bb 00 00 00       	push   $0xbb
c0021d38:	e9 c0 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d3d <intrbc_stub>:
STUB(bc, zero) STUB(bd, zero) STUB(be, zero) STUB(bf, zero)
c0021d3d:	55                   	push   %ebp
c0021d3e:	6a 00                	push   $0x0
c0021d40:	68 bc 00 00 00       	push   $0xbc
c0021d45:	e9 b3 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d4a <intrbd_stub>:
c0021d4a:	55                   	push   %ebp
c0021d4b:	6a 00                	push   $0x0
c0021d4d:	68 bd 00 00 00       	push   $0xbd
c0021d52:	e9 a6 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d57 <intrbe_stub>:
c0021d57:	55                   	push   %ebp
c0021d58:	6a 00                	push   $0x0
c0021d5a:	68 be 00 00 00       	push   $0xbe
c0021d5f:	e9 99 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d64 <intrbf_stub>:
c0021d64:	55                   	push   %ebp
c0021d65:	6a 00                	push   $0x0
c0021d67:	68 bf 00 00 00       	push   $0xbf
c0021d6c:	e9 8c f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d71 <intrc0_stub>:

STUB(c0, zero) STUB(c1, zero) STUB(c2, zero) STUB(c3, zero)
c0021d71:	55                   	push   %ebp
c0021d72:	6a 00                	push   $0x0
c0021d74:	68 c0 00 00 00       	push   $0xc0
c0021d79:	e9 7f f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d7e <intrc1_stub>:
c0021d7e:	55                   	push   %ebp
c0021d7f:	6a 00                	push   $0x0
c0021d81:	68 c1 00 00 00       	push   $0xc1
c0021d86:	e9 72 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d8b <intrc2_stub>:
c0021d8b:	55                   	push   %ebp
c0021d8c:	6a 00                	push   $0x0
c0021d8e:	68 c2 00 00 00       	push   $0xc2
c0021d93:	e9 65 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021d98 <intrc3_stub>:
c0021d98:	55                   	push   %ebp
c0021d99:	6a 00                	push   $0x0
c0021d9b:	68 c3 00 00 00       	push   $0xc3
c0021da0:	e9 58 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021da5 <intrc4_stub>:
STUB(c4, zero) STUB(c5, zero) STUB(c6, zero) STUB(c7, zero)
c0021da5:	55                   	push   %ebp
c0021da6:	6a 00                	push   $0x0
c0021da8:	68 c4 00 00 00       	push   $0xc4
c0021dad:	e9 4b f7 ff ff       	jmp    c00214fd <intr_entry>

c0021db2 <intrc5_stub>:
c0021db2:	55                   	push   %ebp
c0021db3:	6a 00                	push   $0x0
c0021db5:	68 c5 00 00 00       	push   $0xc5
c0021dba:	e9 3e f7 ff ff       	jmp    c00214fd <intr_entry>

c0021dbf <intrc6_stub>:
c0021dbf:	55                   	push   %ebp
c0021dc0:	6a 00                	push   $0x0
c0021dc2:	68 c6 00 00 00       	push   $0xc6
c0021dc7:	e9 31 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021dcc <intrc7_stub>:
c0021dcc:	55                   	push   %ebp
c0021dcd:	6a 00                	push   $0x0
c0021dcf:	68 c7 00 00 00       	push   $0xc7
c0021dd4:	e9 24 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021dd9 <intrc8_stub>:
STUB(c8, zero) STUB(c9, zero) STUB(ca, zero) STUB(cb, zero)
c0021dd9:	55                   	push   %ebp
c0021dda:	6a 00                	push   $0x0
c0021ddc:	68 c8 00 00 00       	push   $0xc8
c0021de1:	e9 17 f7 ff ff       	jmp    c00214fd <intr_entry>

c0021de6 <intrc9_stub>:
c0021de6:	55                   	push   %ebp
c0021de7:	6a 00                	push   $0x0
c0021de9:	68 c9 00 00 00       	push   $0xc9
c0021dee:	e9 0a f7 ff ff       	jmp    c00214fd <intr_entry>

c0021df3 <intrca_stub>:
c0021df3:	55                   	push   %ebp
c0021df4:	6a 00                	push   $0x0
c0021df6:	68 ca 00 00 00       	push   $0xca
c0021dfb:	e9 fd f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e00 <intrcb_stub>:
c0021e00:	55                   	push   %ebp
c0021e01:	6a 00                	push   $0x0
c0021e03:	68 cb 00 00 00       	push   $0xcb
c0021e08:	e9 f0 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e0d <intrcc_stub>:
STUB(cc, zero) STUB(cd, zero) STUB(ce, zero) STUB(cf, zero)
c0021e0d:	55                   	push   %ebp
c0021e0e:	6a 00                	push   $0x0
c0021e10:	68 cc 00 00 00       	push   $0xcc
c0021e15:	e9 e3 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e1a <intrcd_stub>:
c0021e1a:	55                   	push   %ebp
c0021e1b:	6a 00                	push   $0x0
c0021e1d:	68 cd 00 00 00       	push   $0xcd
c0021e22:	e9 d6 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e27 <intrce_stub>:
c0021e27:	55                   	push   %ebp
c0021e28:	6a 00                	push   $0x0
c0021e2a:	68 ce 00 00 00       	push   $0xce
c0021e2f:	e9 c9 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e34 <intrcf_stub>:
c0021e34:	55                   	push   %ebp
c0021e35:	6a 00                	push   $0x0
c0021e37:	68 cf 00 00 00       	push   $0xcf
c0021e3c:	e9 bc f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e41 <intrd0_stub>:

STUB(d0, zero) STUB(d1, zero) STUB(d2, zero) STUB(d3, zero)
c0021e41:	55                   	push   %ebp
c0021e42:	6a 00                	push   $0x0
c0021e44:	68 d0 00 00 00       	push   $0xd0
c0021e49:	e9 af f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e4e <intrd1_stub>:
c0021e4e:	55                   	push   %ebp
c0021e4f:	6a 00                	push   $0x0
c0021e51:	68 d1 00 00 00       	push   $0xd1
c0021e56:	e9 a2 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e5b <intrd2_stub>:
c0021e5b:	55                   	push   %ebp
c0021e5c:	6a 00                	push   $0x0
c0021e5e:	68 d2 00 00 00       	push   $0xd2
c0021e63:	e9 95 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e68 <intrd3_stub>:
c0021e68:	55                   	push   %ebp
c0021e69:	6a 00                	push   $0x0
c0021e6b:	68 d3 00 00 00       	push   $0xd3
c0021e70:	e9 88 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e75 <intrd4_stub>:
STUB(d4, zero) STUB(d5, zero) STUB(d6, zero) STUB(d7, zero)
c0021e75:	55                   	push   %ebp
c0021e76:	6a 00                	push   $0x0
c0021e78:	68 d4 00 00 00       	push   $0xd4
c0021e7d:	e9 7b f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e82 <intrd5_stub>:
c0021e82:	55                   	push   %ebp
c0021e83:	6a 00                	push   $0x0
c0021e85:	68 d5 00 00 00       	push   $0xd5
c0021e8a:	e9 6e f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e8f <intrd6_stub>:
c0021e8f:	55                   	push   %ebp
c0021e90:	6a 00                	push   $0x0
c0021e92:	68 d6 00 00 00       	push   $0xd6
c0021e97:	e9 61 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021e9c <intrd7_stub>:
c0021e9c:	55                   	push   %ebp
c0021e9d:	6a 00                	push   $0x0
c0021e9f:	68 d7 00 00 00       	push   $0xd7
c0021ea4:	e9 54 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021ea9 <intrd8_stub>:
STUB(d8, zero) STUB(d9, zero) STUB(da, zero) STUB(db, zero)
c0021ea9:	55                   	push   %ebp
c0021eaa:	6a 00                	push   $0x0
c0021eac:	68 d8 00 00 00       	push   $0xd8
c0021eb1:	e9 47 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021eb6 <intrd9_stub>:
c0021eb6:	55                   	push   %ebp
c0021eb7:	6a 00                	push   $0x0
c0021eb9:	68 d9 00 00 00       	push   $0xd9
c0021ebe:	e9 3a f6 ff ff       	jmp    c00214fd <intr_entry>

c0021ec3 <intrda_stub>:
c0021ec3:	55                   	push   %ebp
c0021ec4:	6a 00                	push   $0x0
c0021ec6:	68 da 00 00 00       	push   $0xda
c0021ecb:	e9 2d f6 ff ff       	jmp    c00214fd <intr_entry>

c0021ed0 <intrdb_stub>:
c0021ed0:	55                   	push   %ebp
c0021ed1:	6a 00                	push   $0x0
c0021ed3:	68 db 00 00 00       	push   $0xdb
c0021ed8:	e9 20 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021edd <intrdc_stub>:
STUB(dc, zero) STUB(dd, zero) STUB(de, zero) STUB(df, zero)
c0021edd:	55                   	push   %ebp
c0021ede:	6a 00                	push   $0x0
c0021ee0:	68 dc 00 00 00       	push   $0xdc
c0021ee5:	e9 13 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021eea <intrdd_stub>:
c0021eea:	55                   	push   %ebp
c0021eeb:	6a 00                	push   $0x0
c0021eed:	68 dd 00 00 00       	push   $0xdd
c0021ef2:	e9 06 f6 ff ff       	jmp    c00214fd <intr_entry>

c0021ef7 <intrde_stub>:
c0021ef7:	55                   	push   %ebp
c0021ef8:	6a 00                	push   $0x0
c0021efa:	68 de 00 00 00       	push   $0xde
c0021eff:	e9 f9 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f04 <intrdf_stub>:
c0021f04:	55                   	push   %ebp
c0021f05:	6a 00                	push   $0x0
c0021f07:	68 df 00 00 00       	push   $0xdf
c0021f0c:	e9 ec f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f11 <intre0_stub>:

STUB(e0, zero) STUB(e1, zero) STUB(e2, zero) STUB(e3, zero)
c0021f11:	55                   	push   %ebp
c0021f12:	6a 00                	push   $0x0
c0021f14:	68 e0 00 00 00       	push   $0xe0
c0021f19:	e9 df f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f1e <intre1_stub>:
c0021f1e:	55                   	push   %ebp
c0021f1f:	6a 00                	push   $0x0
c0021f21:	68 e1 00 00 00       	push   $0xe1
c0021f26:	e9 d2 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f2b <intre2_stub>:
c0021f2b:	55                   	push   %ebp
c0021f2c:	6a 00                	push   $0x0
c0021f2e:	68 e2 00 00 00       	push   $0xe2
c0021f33:	e9 c5 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f38 <intre3_stub>:
c0021f38:	55                   	push   %ebp
c0021f39:	6a 00                	push   $0x0
c0021f3b:	68 e3 00 00 00       	push   $0xe3
c0021f40:	e9 b8 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f45 <intre4_stub>:
STUB(e4, zero) STUB(e5, zero) STUB(e6, zero) STUB(e7, zero)
c0021f45:	55                   	push   %ebp
c0021f46:	6a 00                	push   $0x0
c0021f48:	68 e4 00 00 00       	push   $0xe4
c0021f4d:	e9 ab f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f52 <intre5_stub>:
c0021f52:	55                   	push   %ebp
c0021f53:	6a 00                	push   $0x0
c0021f55:	68 e5 00 00 00       	push   $0xe5
c0021f5a:	e9 9e f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f5f <intre6_stub>:
c0021f5f:	55                   	push   %ebp
c0021f60:	6a 00                	push   $0x0
c0021f62:	68 e6 00 00 00       	push   $0xe6
c0021f67:	e9 91 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f6c <intre7_stub>:
c0021f6c:	55                   	push   %ebp
c0021f6d:	6a 00                	push   $0x0
c0021f6f:	68 e7 00 00 00       	push   $0xe7
c0021f74:	e9 84 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f79 <intre8_stub>:
STUB(e8, zero) STUB(e9, zero) STUB(ea, zero) STUB(eb, zero)
c0021f79:	55                   	push   %ebp
c0021f7a:	6a 00                	push   $0x0
c0021f7c:	68 e8 00 00 00       	push   $0xe8
c0021f81:	e9 77 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f86 <intre9_stub>:
c0021f86:	55                   	push   %ebp
c0021f87:	6a 00                	push   $0x0
c0021f89:	68 e9 00 00 00       	push   $0xe9
c0021f8e:	e9 6a f5 ff ff       	jmp    c00214fd <intr_entry>

c0021f93 <intrea_stub>:
c0021f93:	55                   	push   %ebp
c0021f94:	6a 00                	push   $0x0
c0021f96:	68 ea 00 00 00       	push   $0xea
c0021f9b:	e9 5d f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fa0 <intreb_stub>:
c0021fa0:	55                   	push   %ebp
c0021fa1:	6a 00                	push   $0x0
c0021fa3:	68 eb 00 00 00       	push   $0xeb
c0021fa8:	e9 50 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fad <intrec_stub>:
STUB(ec, zero) STUB(ed, zero) STUB(ee, zero) STUB(ef, zero)
c0021fad:	55                   	push   %ebp
c0021fae:	6a 00                	push   $0x0
c0021fb0:	68 ec 00 00 00       	push   $0xec
c0021fb5:	e9 43 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fba <intred_stub>:
c0021fba:	55                   	push   %ebp
c0021fbb:	6a 00                	push   $0x0
c0021fbd:	68 ed 00 00 00       	push   $0xed
c0021fc2:	e9 36 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fc7 <intree_stub>:
c0021fc7:	55                   	push   %ebp
c0021fc8:	6a 00                	push   $0x0
c0021fca:	68 ee 00 00 00       	push   $0xee
c0021fcf:	e9 29 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fd4 <intref_stub>:
c0021fd4:	55                   	push   %ebp
c0021fd5:	6a 00                	push   $0x0
c0021fd7:	68 ef 00 00 00       	push   $0xef
c0021fdc:	e9 1c f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fe1 <intrf0_stub>:

STUB(f0, zero) STUB(f1, zero) STUB(f2, zero) STUB(f3, zero)
c0021fe1:	55                   	push   %ebp
c0021fe2:	6a 00                	push   $0x0
c0021fe4:	68 f0 00 00 00       	push   $0xf0
c0021fe9:	e9 0f f5 ff ff       	jmp    c00214fd <intr_entry>

c0021fee <intrf1_stub>:
c0021fee:	55                   	push   %ebp
c0021fef:	6a 00                	push   $0x0
c0021ff1:	68 f1 00 00 00       	push   $0xf1
c0021ff6:	e9 02 f5 ff ff       	jmp    c00214fd <intr_entry>

c0021ffb <intrf2_stub>:
c0021ffb:	55                   	push   %ebp
c0021ffc:	6a 00                	push   $0x0
c0021ffe:	68 f2 00 00 00       	push   $0xf2
c0022003:	e9 f5 f4 ff ff       	jmp    c00214fd <intr_entry>

c0022008 <intrf3_stub>:
c0022008:	55                   	push   %ebp
c0022009:	6a 00                	push   $0x0
c002200b:	68 f3 00 00 00       	push   $0xf3
c0022010:	e9 e8 f4 ff ff       	jmp    c00214fd <intr_entry>

c0022015 <intrf4_stub>:
STUB(f4, zero) STUB(f5, zero) STUB(f6, zero) STUB(f7, zero)
c0022015:	55                   	push   %ebp
c0022016:	6a 00                	push   $0x0
c0022018:	68 f4 00 00 00       	push   $0xf4
c002201d:	e9 db f4 ff ff       	jmp    c00214fd <intr_entry>

c0022022 <intrf5_stub>:
c0022022:	55                   	push   %ebp
c0022023:	6a 00                	push   $0x0
c0022025:	68 f5 00 00 00       	push   $0xf5
c002202a:	e9 ce f4 ff ff       	jmp    c00214fd <intr_entry>

c002202f <intrf6_stub>:
c002202f:	55                   	push   %ebp
c0022030:	6a 00                	push   $0x0
c0022032:	68 f6 00 00 00       	push   $0xf6
c0022037:	e9 c1 f4 ff ff       	jmp    c00214fd <intr_entry>

c002203c <intrf7_stub>:
c002203c:	55                   	push   %ebp
c002203d:	6a 00                	push   $0x0
c002203f:	68 f7 00 00 00       	push   $0xf7
c0022044:	e9 b4 f4 ff ff       	jmp    c00214fd <intr_entry>

c0022049 <intrf8_stub>:
STUB(f8, zero) STUB(f9, zero) STUB(fa, zero) STUB(fb, zero)
c0022049:	55                   	push   %ebp
c002204a:	6a 00                	push   $0x0
c002204c:	68 f8 00 00 00       	push   $0xf8
c0022051:	e9 a7 f4 ff ff       	jmp    c00214fd <intr_entry>

c0022056 <intrf9_stub>:
c0022056:	55                   	push   %ebp
c0022057:	6a 00                	push   $0x0
c0022059:	68 f9 00 00 00       	push   $0xf9
c002205e:	e9 9a f4 ff ff       	jmp    c00214fd <intr_entry>

c0022063 <intrfa_stub>:
c0022063:	55                   	push   %ebp
c0022064:	6a 00                	push   $0x0
c0022066:	68 fa 00 00 00       	push   $0xfa
c002206b:	e9 8d f4 ff ff       	jmp    c00214fd <intr_entry>

c0022070 <intrfb_stub>:
c0022070:	55                   	push   %ebp
c0022071:	6a 00                	push   $0x0
c0022073:	68 fb 00 00 00       	push   $0xfb
c0022078:	e9 80 f4 ff ff       	jmp    c00214fd <intr_entry>

c002207d <intrfc_stub>:
STUB(fc, zero) STUB(fd, zero) STUB(fe, zero) STUB(ff, zero)
c002207d:	55                   	push   %ebp
c002207e:	6a 00                	push   $0x0
c0022080:	68 fc 00 00 00       	push   $0xfc
c0022085:	e9 73 f4 ff ff       	jmp    c00214fd <intr_entry>

c002208a <intrfd_stub>:
c002208a:	55                   	push   %ebp
c002208b:	6a 00                	push   $0x0
c002208d:	68 fd 00 00 00       	push   $0xfd
c0022092:	e9 66 f4 ff ff       	jmp    c00214fd <intr_entry>

c0022097 <intrfe_stub>:
c0022097:	55                   	push   %ebp
c0022098:	6a 00                	push   $0x0
c002209a:	68 fe 00 00 00       	push   $0xfe
c002209f:	e9 59 f4 ff ff       	jmp    c00214fd <intr_entry>

c00220a4 <intrff_stub>:
c00220a4:	55                   	push   %ebp
c00220a5:	6a 00                	push   $0x0
c00220a7:	68 ff 00 00 00       	push   $0xff
c00220ac:	e9 4c f4 ff ff       	jmp    c00214fd <intr_entry>

c00220b1 <sema_init>:

   - up or "V": increment the value (and wake up one waiting
     thread, if any). */
void
sema_init (struct semaphore *sema, unsigned value) 
{
c00220b1:	83 ec 0c             	sub    $0xc,%esp
c00220b4:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (sema != NULL);
c00220b8:	85 c0                	test   %eax,%eax
c00220ba:	74 16                	je     c00220d2 <sema_init+0x21>

  sema->value = value;
c00220bc:	8b 54 24 14          	mov    0x14(%esp),%edx
c00220c0:	89 10                	mov    %edx,(%eax)
  list_init (&sema->waiters);
c00220c2:	83 ec 0c             	sub    $0xc,%esp
c00220c5:	83 c0 04             	add    $0x4,%eax
c00220c8:	50                   	push   %eax
c00220c9:	e8 19 56 00 00       	call   c00276e7 <list_init>
}
c00220ce:	83 c4 1c             	add    $0x1c,%esp
c00220d1:	c3                   	ret    
  ASSERT (sema != NULL);
c00220d2:	83 ec 0c             	sub    $0xc,%esp
c00220d5:	68 2a d4 02 c0       	push   $0xc002d42a
c00220da:	68 df cb 02 c0       	push   $0xc002cbdf
c00220df:	68 08 b7 02 c0       	push   $0xc002b708
c00220e4:	6a 2f                	push   $0x2f
c00220e6:	68 37 d4 02 c0       	push   $0xc002d437
c00220eb:	e8 50 55 00 00       	call   c0027640 <debug_panic>

c00220f0 <sema_down>:
   interrupt handler.  This function may be called with
   interrupts disabled, but if it sleeps then the next scheduled
   thread will probably turn interrupts back on. */
void
sema_down (struct semaphore *sema) 
{
c00220f0:	57                   	push   %edi
c00220f1:	56                   	push   %esi
c00220f2:	53                   	push   %ebx
c00220f3:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  enum intr_level old_level;

  ASSERT (sema != NULL);
c00220f7:	85 db                	test   %ebx,%ebx
c00220f9:	74 4c                	je     c0022147 <sema_down+0x57>
  ASSERT (!intr_context ());
c00220fb:	e8 a4 f1 ff ff       	call   c00212a4 <intr_context>
c0022100:	84 c0                	test   %al,%al
c0022102:	75 61                	jne    c0022165 <sema_down+0x75>

  old_level = intr_disable ();
c0022104:	e8 7a ef ff ff       	call   c0021083 <intr_disable>
c0022109:	89 c7                	mov    %eax,%edi
  while (sema->value == 0) 
c002210b:	8b 03                	mov    (%ebx),%eax
c002210d:	85 c0                	test   %eax,%eax
c002210f:	75 23                	jne    c0022134 <sema_down+0x44>
    {
      list_push_back (&sema->waiters, &thread_current ()->elem);
c0022111:	8d 73 04             	lea    0x4(%ebx),%esi
c0022114:	e8 38 e9 ff ff       	call   c0020a51 <thread_current>
c0022119:	83 ec 08             	sub    $0x8,%esp
c002211c:	83 c0 28             	add    $0x28,%eax
c002211f:	50                   	push   %eax
c0022120:	56                   	push   %esi
c0022121:	e8 5e 5a 00 00       	call   c0027b84 <list_push_back>
      thread_block ();
c0022126:	e8 13 ec ff ff       	call   c0020d3e <thread_block>
  while (sema->value == 0) 
c002212b:	8b 03                	mov    (%ebx),%eax
c002212d:	83 c4 10             	add    $0x10,%esp
c0022130:	85 c0                	test   %eax,%eax
c0022132:	74 e0                	je     c0022114 <sema_down+0x24>
    }
  sema->value--;
c0022134:	48                   	dec    %eax
c0022135:	89 03                	mov    %eax,(%ebx)
  intr_set_level (old_level);
c0022137:	83 ec 0c             	sub    $0xc,%esp
c002213a:	57                   	push   %edi
c002213b:	e8 4a ef ff ff       	call   c002108a <intr_set_level>
}
c0022140:	83 c4 10             	add    $0x10,%esp
c0022143:	5b                   	pop    %ebx
c0022144:	5e                   	pop    %esi
c0022145:	5f                   	pop    %edi
c0022146:	c3                   	ret    
  ASSERT (sema != NULL);
c0022147:	83 ec 0c             	sub    $0xc,%esp
c002214a:	68 2a d4 02 c0       	push   $0xc002d42a
c002214f:	68 df cb 02 c0       	push   $0xc002cbdf
c0022154:	68 fc b6 02 c0       	push   $0xc002b6fc
c0022159:	6a 41                	push   $0x41
c002215b:	68 37 d4 02 c0       	push   $0xc002d437
c0022160:	e8 db 54 00 00       	call   c0027640 <debug_panic>
  ASSERT (!intr_context ());
c0022165:	83 ec 0c             	sub    $0xc,%esp
c0022168:	68 e0 cf 02 c0       	push   $0xc002cfe0
c002216d:	68 df cb 02 c0       	push   $0xc002cbdf
c0022172:	68 fc b6 02 c0       	push   $0xc002b6fc
c0022177:	6a 42                	push   $0x42
c0022179:	68 37 d4 02 c0       	push   $0xc002d437
c002217e:	e8 bd 54 00 00       	call   c0027640 <debug_panic>

c0022183 <sema_try_down>:
   decremented, false otherwise.

   This function may be called from an interrupt handler. */
bool
sema_try_down (struct semaphore *sema) 
{
c0022183:	53                   	push   %ebx
c0022184:	83 ec 08             	sub    $0x8,%esp
c0022187:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  enum intr_level old_level;
  bool success;

  ASSERT (sema != NULL);
c002218b:	85 db                	test   %ebx,%ebx
c002218d:	74 20                	je     c00221af <sema_try_down+0x2c>

  old_level = intr_disable ();
c002218f:	e8 ef ee ff ff       	call   c0021083 <intr_disable>
  if (sema->value > 0) 
c0022194:	8b 13                	mov    (%ebx),%edx
c0022196:	85 d2                	test   %edx,%edx
c0022198:	74 33                	je     c00221cd <sema_try_down+0x4a>
    {
      sema->value--;
c002219a:	4a                   	dec    %edx
c002219b:	89 13                	mov    %edx,(%ebx)
      success = true; 
c002219d:	b3 01                	mov    $0x1,%bl
    }
  else
    success = false;
  intr_set_level (old_level);
c002219f:	83 ec 0c             	sub    $0xc,%esp
c00221a2:	50                   	push   %eax
c00221a3:	e8 e2 ee ff ff       	call   c002108a <intr_set_level>

  return success;
}
c00221a8:	88 d8                	mov    %bl,%al
c00221aa:	83 c4 18             	add    $0x18,%esp
c00221ad:	5b                   	pop    %ebx
c00221ae:	c3                   	ret    
  ASSERT (sema != NULL);
c00221af:	83 ec 0c             	sub    $0xc,%esp
c00221b2:	68 2a d4 02 c0       	push   $0xc002d42a
c00221b7:	68 df cb 02 c0       	push   $0xc002cbdf
c00221bc:	68 ec b6 02 c0       	push   $0xc002b6ec
c00221c1:	6a 59                	push   $0x59
c00221c3:	68 37 d4 02 c0       	push   $0xc002d437
c00221c8:	e8 73 54 00 00       	call   c0027640 <debug_panic>
    success = false;
c00221cd:	b3 00                	mov    $0x0,%bl
c00221cf:	eb ce                	jmp    c002219f <sema_try_down+0x1c>

c00221d1 <sema_up>:
   and wakes up one thread of those waiting for SEMA, if any.

   This function may be called from an interrupt handler. */
void
sema_up (struct semaphore *sema) 
{
c00221d1:	57                   	push   %edi
c00221d2:	56                   	push   %esi
c00221d3:	53                   	push   %ebx
c00221d4:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  enum intr_level old_level;

  ASSERT (sema != NULL);
c00221d8:	85 db                	test   %ebx,%ebx
c00221da:	74 2c                	je     c0022208 <sema_up+0x37>

  old_level = intr_disable ();
c00221dc:	e8 a2 ee ff ff       	call   c0021083 <intr_disable>
c00221e1:	89 c7                	mov    %eax,%edi
  if (!list_empty (&sema->waiters)) 
c00221e3:	8d 73 04             	lea    0x4(%ebx),%esi
c00221e6:	83 ec 0c             	sub    $0xc,%esp
c00221e9:	56                   	push   %esi
c00221ea:	e8 3d 5a 00 00       	call   c0027c2c <list_empty>
c00221ef:	83 c4 10             	add    $0x10,%esp
c00221f2:	84 c0                	test   %al,%al
c00221f4:	74 30                	je     c0022226 <sema_up+0x55>
    thread_unblock (list_entry (list_pop_front (&sema->waiters),
                                struct thread, elem));
  sema->value++;
c00221f6:	ff 03                	incl   (%ebx)
  intr_set_level (old_level);
c00221f8:	83 ec 0c             	sub    $0xc,%esp
c00221fb:	57                   	push   %edi
c00221fc:	e8 89 ee ff ff       	call   c002108a <intr_set_level>
}
c0022201:	83 c4 10             	add    $0x10,%esp
c0022204:	5b                   	pop    %ebx
c0022205:	5e                   	pop    %esi
c0022206:	5f                   	pop    %edi
c0022207:	c3                   	ret    
  ASSERT (sema != NULL);
c0022208:	83 ec 0c             	sub    $0xc,%esp
c002220b:	68 2a d4 02 c0       	push   $0xc002d42a
c0022210:	68 df cb 02 c0       	push   $0xc002cbdf
c0022215:	68 e4 b6 02 c0       	push   $0xc002b6e4
c002221a:	6a 71                	push   $0x71
c002221c:	68 37 d4 02 c0       	push   $0xc002d437
c0022221:	e8 1a 54 00 00       	call   c0027640 <debug_panic>
    thread_unblock (list_entry (list_pop_front (&sema->waiters),
c0022226:	83 ec 0c             	sub    $0xc,%esp
c0022229:	56                   	push   %esi
c002222a:	e8 5f 5a 00 00       	call   c0027c8e <list_pop_front>
c002222f:	83 e8 28             	sub    $0x28,%eax
c0022232:	89 04 24             	mov    %eax,(%esp)
c0022235:	e8 74 e6 ff ff       	call   c00208ae <thread_unblock>
c002223a:	83 c4 10             	add    $0x10,%esp
c002223d:	eb b7                	jmp    c00221f6 <sema_up+0x25>

c002223f <sema_test_helper>:
}

/* Thread function used by sema_self_test(). */
static void
sema_test_helper (void *sema_) 
{
c002223f:	57                   	push   %edi
c0022240:	56                   	push   %esi
c0022241:	53                   	push   %ebx
c0022242:	8b 74 24 10          	mov    0x10(%esp),%esi
c0022246:	bb 0a 00 00 00       	mov    $0xa,%ebx
  int i;

  for (i = 0; i < 10; i++) 
    {
      sema_down (&sema[0]);
      sema_up (&sema[1]);
c002224b:	8d 7e 14             	lea    0x14(%esi),%edi
      sema_down (&sema[0]);
c002224e:	83 ec 0c             	sub    $0xc,%esp
c0022251:	56                   	push   %esi
c0022252:	e8 99 fe ff ff       	call   c00220f0 <sema_down>
      sema_up (&sema[1]);
c0022257:	89 3c 24             	mov    %edi,(%esp)
c002225a:	e8 72 ff ff ff       	call   c00221d1 <sema_up>
  for (i = 0; i < 10; i++) 
c002225f:	83 c4 10             	add    $0x10,%esp
c0022262:	4b                   	dec    %ebx
c0022263:	75 e9                	jne    c002224e <sema_test_helper+0xf>
    }
}
c0022265:	5b                   	pop    %ebx
c0022266:	5e                   	pop    %esi
c0022267:	5f                   	pop    %edi
c0022268:	c3                   	ret    

c0022269 <sema_self_test>:
{
c0022269:	57                   	push   %edi
c002226a:	56                   	push   %esi
c002226b:	53                   	push   %ebx
c002226c:	83 ec 3c             	sub    $0x3c,%esp
  printf ("Testing semaphores...");
c002226f:	68 4d d4 02 c0       	push   $0xc002d44d
c0022274:	e8 19 39 00 00       	call   c0025b92 <printf>
  sema_init (&sema[0], 0);
c0022279:	83 c4 08             	add    $0x8,%esp
c002227c:	6a 00                	push   $0x0
c002227e:	8d 5c 24 14          	lea    0x14(%esp),%ebx
c0022282:	53                   	push   %ebx
c0022283:	e8 29 fe ff ff       	call   c00220b1 <sema_init>
  sema_init (&sema[1], 0);
c0022288:	83 c4 08             	add    $0x8,%esp
c002228b:	6a 00                	push   $0x0
c002228d:	8d 44 24 28          	lea    0x28(%esp),%eax
c0022291:	50                   	push   %eax
c0022292:	e8 1a fe ff ff       	call   c00220b1 <sema_init>
  thread_create ("sema-test", PRI_DEFAULT, sema_test_helper, &sema);
c0022297:	53                   	push   %ebx
c0022298:	68 3f 22 02 c0       	push   $0xc002223f
c002229d:	6a 1f                	push   $0x1f
c002229f:	68 63 d4 02 c0       	push   $0xc002d463
c00222a4:	e8 93 e6 ff ff       	call   c002093c <thread_create>
c00222a9:	83 c4 20             	add    $0x20,%esp
c00222ac:	bb 0a 00 00 00       	mov    $0xa,%ebx
      sema_up (&sema[0]);
c00222b1:	8d 7c 24 08          	lea    0x8(%esp),%edi
      sema_down (&sema[1]);
c00222b5:	8d 74 24 1c          	lea    0x1c(%esp),%esi
      sema_up (&sema[0]);
c00222b9:	83 ec 0c             	sub    $0xc,%esp
c00222bc:	57                   	push   %edi
c00222bd:	e8 0f ff ff ff       	call   c00221d1 <sema_up>
      sema_down (&sema[1]);
c00222c2:	89 34 24             	mov    %esi,(%esp)
c00222c5:	e8 26 fe ff ff       	call   c00220f0 <sema_down>
  for (i = 0; i < 10; i++) 
c00222ca:	83 c4 10             	add    $0x10,%esp
c00222cd:	4b                   	dec    %ebx
c00222ce:	75 e9                	jne    c00222b9 <sema_self_test+0x50>
  printf ("done.\n");
c00222d0:	83 ec 0c             	sub    $0xc,%esp
c00222d3:	68 6d d4 02 c0       	push   $0xc002d46d
c00222d8:	e8 b1 6d 00 00       	call   c002908e <puts>
}
c00222dd:	83 c4 40             	add    $0x40,%esp
c00222e0:	5b                   	pop    %ebx
c00222e1:	5e                   	pop    %esi
c00222e2:	5f                   	pop    %edi
c00222e3:	c3                   	ret    

c00222e4 <lock_init>:
   acquire and release it.  When these restrictions prove
   onerous, it's a good sign that a semaphore should be used,
   instead of a lock. */
void
lock_init (struct lock *lock)
{
c00222e4:	83 ec 0c             	sub    $0xc,%esp
c00222e7:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (lock != NULL);
c00222eb:	85 c0                	test   %eax,%eax
c00222ed:	74 18                	je     c0022307 <lock_init+0x23>

  lock->holder = NULL;
c00222ef:	c7 00 00 00 00 00    	movl   $0x0,(%eax)
  sema_init (&lock->semaphore, 1);
c00222f5:	83 ec 08             	sub    $0x8,%esp
c00222f8:	6a 01                	push   $0x1
c00222fa:	83 c0 04             	add    $0x4,%eax
c00222fd:	50                   	push   %eax
c00222fe:	e8 ae fd ff ff       	call   c00220b1 <sema_init>
}
c0022303:	83 c4 1c             	add    $0x1c,%esp
c0022306:	c3                   	ret    
  ASSERT (lock != NULL);
c0022307:	83 ec 0c             	sub    $0xc,%esp
c002230a:	68 73 d4 02 c0       	push   $0xc002d473
c002230f:	68 df cb 02 c0       	push   $0xc002cbdf
c0022314:	68 d8 b6 02 c0       	push   $0xc002b6d8
c0022319:	68 b2 00 00 00       	push   $0xb2
c002231e:	68 37 d4 02 c0       	push   $0xc002d437
c0022323:	e8 18 53 00 00       	call   c0027640 <debug_panic>

c0022328 <lock_held_by_current_thread>:
/* Returns true if the current thread holds LOCK, false
   otherwise.  (Note that testing whether some other thread holds
   a lock would be racy.) */
bool
lock_held_by_current_thread (const struct lock *lock) 
{
c0022328:	53                   	push   %ebx
c0022329:	83 ec 08             	sub    $0x8,%esp
c002232c:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (lock != NULL);
c0022330:	85 c0                	test   %eax,%eax
c0022332:	74 11                	je     c0022345 <lock_held_by_current_thread+0x1d>

  return lock->holder == thread_current ();
c0022334:	8b 18                	mov    (%eax),%ebx
c0022336:	e8 16 e7 ff ff       	call   c0020a51 <thread_current>
c002233b:	39 c3                	cmp    %eax,%ebx
c002233d:	0f 94 c0             	sete   %al
}
c0022340:	83 c4 08             	add    $0x8,%esp
c0022343:	5b                   	pop    %ebx
c0022344:	c3                   	ret    
  ASSERT (lock != NULL);
c0022345:	83 ec 0c             	sub    $0xc,%esp
c0022348:	68 73 d4 02 c0       	push   $0xc002d473
c002234d:	68 df cb 02 c0       	push   $0xc002cbdf
c0022352:	68 88 b6 02 c0       	push   $0xc002b688
c0022357:	68 f4 00 00 00       	push   $0xf4
c002235c:	68 37 d4 02 c0       	push   $0xc002d437
c0022361:	e8 da 52 00 00       	call   c0027640 <debug_panic>

c0022366 <lock_acquire>:
{
c0022366:	53                   	push   %ebx
c0022367:	83 ec 08             	sub    $0x8,%esp
c002236a:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (lock != NULL);
c002236e:	85 db                	test   %ebx,%ebx
c0022370:	74 31                	je     c00223a3 <lock_acquire+0x3d>
  ASSERT (!intr_context ());
c0022372:	e8 2d ef ff ff       	call   c00212a4 <intr_context>
c0022377:	84 c0                	test   %al,%al
c0022379:	75 49                	jne    c00223c4 <lock_acquire+0x5e>
  ASSERT (!lock_held_by_current_thread (lock));
c002237b:	83 ec 0c             	sub    $0xc,%esp
c002237e:	53                   	push   %ebx
c002237f:	e8 a4 ff ff ff       	call   c0022328 <lock_held_by_current_thread>
c0022384:	83 c4 10             	add    $0x10,%esp
c0022387:	84 c0                	test   %al,%al
c0022389:	75 5a                	jne    c00223e5 <lock_acquire+0x7f>
  sema_down (&lock->semaphore);
c002238b:	83 ec 0c             	sub    $0xc,%esp
c002238e:	8d 43 04             	lea    0x4(%ebx),%eax
c0022391:	50                   	push   %eax
c0022392:	e8 59 fd ff ff       	call   c00220f0 <sema_down>
  lock->holder = thread_current ();
c0022397:	e8 b5 e6 ff ff       	call   c0020a51 <thread_current>
c002239c:	89 03                	mov    %eax,(%ebx)
}
c002239e:	83 c4 18             	add    $0x18,%esp
c00223a1:	5b                   	pop    %ebx
c00223a2:	c3                   	ret    
  ASSERT (lock != NULL);
c00223a3:	83 ec 0c             	sub    $0xc,%esp
c00223a6:	68 73 d4 02 c0       	push   $0xc002d473
c00223ab:	68 df cb 02 c0       	push   $0xc002cbdf
c00223b0:	68 c8 b6 02 c0       	push   $0xc002b6c8
c00223b5:	68 c3 00 00 00       	push   $0xc3
c00223ba:	68 37 d4 02 c0       	push   $0xc002d437
c00223bf:	e8 7c 52 00 00       	call   c0027640 <debug_panic>
  ASSERT (!intr_context ());
c00223c4:	83 ec 0c             	sub    $0xc,%esp
c00223c7:	68 e0 cf 02 c0       	push   $0xc002cfe0
c00223cc:	68 df cb 02 c0       	push   $0xc002cbdf
c00223d1:	68 c8 b6 02 c0       	push   $0xc002b6c8
c00223d6:	68 c4 00 00 00       	push   $0xc4
c00223db:	68 37 d4 02 c0       	push   $0xc002d437
c00223e0:	e8 5b 52 00 00       	call   c0027640 <debug_panic>
  ASSERT (!lock_held_by_current_thread (lock));
c00223e5:	83 ec 0c             	sub    $0xc,%esp
c00223e8:	68 90 d4 02 c0       	push   $0xc002d490
c00223ed:	68 df cb 02 c0       	push   $0xc002cbdf
c00223f2:	68 c8 b6 02 c0       	push   $0xc002b6c8
c00223f7:	68 c5 00 00 00       	push   $0xc5
c00223fc:	68 37 d4 02 c0       	push   $0xc002d437
c0022401:	e8 3a 52 00 00       	call   c0027640 <debug_panic>

c0022406 <lock_try_acquire>:
{
c0022406:	56                   	push   %esi
c0022407:	53                   	push   %ebx
c0022408:	83 ec 04             	sub    $0x4,%esp
c002240b:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (lock != NULL);
c002240f:	85 db                	test   %ebx,%ebx
c0022411:	74 2d                	je     c0022440 <lock_try_acquire+0x3a>
  ASSERT (!lock_held_by_current_thread (lock));
c0022413:	83 ec 0c             	sub    $0xc,%esp
c0022416:	53                   	push   %ebx
c0022417:	e8 0c ff ff ff       	call   c0022328 <lock_held_by_current_thread>
c002241c:	83 c4 10             	add    $0x10,%esp
c002241f:	84 c0                	test   %al,%al
c0022421:	75 3e                	jne    c0022461 <lock_try_acquire+0x5b>
  success = sema_try_down (&lock->semaphore);
c0022423:	83 ec 0c             	sub    $0xc,%esp
c0022426:	8d 43 04             	lea    0x4(%ebx),%eax
c0022429:	50                   	push   %eax
c002242a:	e8 54 fd ff ff       	call   c0022183 <sema_try_down>
c002242f:	89 c6                	mov    %eax,%esi
  if (success)
c0022431:	83 c4 10             	add    $0x10,%esp
c0022434:	84 c0                	test   %al,%al
c0022436:	75 4a                	jne    c0022482 <lock_try_acquire+0x7c>
}
c0022438:	89 f0                	mov    %esi,%eax
c002243a:	83 c4 04             	add    $0x4,%esp
c002243d:	5b                   	pop    %ebx
c002243e:	5e                   	pop    %esi
c002243f:	c3                   	ret    
  ASSERT (lock != NULL);
c0022440:	83 ec 0c             	sub    $0xc,%esp
c0022443:	68 73 d4 02 c0       	push   $0xc002d473
c0022448:	68 df cb 02 c0       	push   $0xc002cbdf
c002244d:	68 b4 b6 02 c0       	push   $0xc002b6b4
c0022452:	68 d6 00 00 00       	push   $0xd6
c0022457:	68 37 d4 02 c0       	push   $0xc002d437
c002245c:	e8 df 51 00 00       	call   c0027640 <debug_panic>
  ASSERT (!lock_held_by_current_thread (lock));
c0022461:	83 ec 0c             	sub    $0xc,%esp
c0022464:	68 90 d4 02 c0       	push   $0xc002d490
c0022469:	68 df cb 02 c0       	push   $0xc002cbdf
c002246e:	68 b4 b6 02 c0       	push   $0xc002b6b4
c0022473:	68 d7 00 00 00       	push   $0xd7
c0022478:	68 37 d4 02 c0       	push   $0xc002d437
c002247d:	e8 be 51 00 00       	call   c0027640 <debug_panic>
    lock->holder = thread_current ();
c0022482:	e8 ca e5 ff ff       	call   c0020a51 <thread_current>
c0022487:	89 03                	mov    %eax,(%ebx)
  return success;
c0022489:	eb ad                	jmp    c0022438 <lock_try_acquire+0x32>

c002248b <lock_release>:
{
c002248b:	53                   	push   %ebx
c002248c:	83 ec 08             	sub    $0x8,%esp
c002248f:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (lock != NULL);
c0022493:	85 db                	test   %ebx,%ebx
c0022495:	74 27                	je     c00224be <lock_release+0x33>
  ASSERT (lock_held_by_current_thread (lock));
c0022497:	83 ec 0c             	sub    $0xc,%esp
c002249a:	53                   	push   %ebx
c002249b:	e8 88 fe ff ff       	call   c0022328 <lock_held_by_current_thread>
c00224a0:	83 c4 10             	add    $0x10,%esp
c00224a3:	84 c0                	test   %al,%al
c00224a5:	74 38                	je     c00224df <lock_release+0x54>
  lock->holder = NULL;
c00224a7:	c7 03 00 00 00 00    	movl   $0x0,(%ebx)
  sema_up (&lock->semaphore);
c00224ad:	83 ec 0c             	sub    $0xc,%esp
c00224b0:	83 c3 04             	add    $0x4,%ebx
c00224b3:	53                   	push   %ebx
c00224b4:	e8 18 fd ff ff       	call   c00221d1 <sema_up>
}
c00224b9:	83 c4 18             	add    $0x18,%esp
c00224bc:	5b                   	pop    %ebx
c00224bd:	c3                   	ret    
  ASSERT (lock != NULL);
c00224be:	83 ec 0c             	sub    $0xc,%esp
c00224c1:	68 73 d4 02 c0       	push   $0xc002d473
c00224c6:	68 df cb 02 c0       	push   $0xc002cbdf
c00224cb:	68 a4 b6 02 c0       	push   $0xc002b6a4
c00224d0:	68 e7 00 00 00       	push   $0xe7
c00224d5:	68 37 d4 02 c0       	push   $0xc002d437
c00224da:	e8 61 51 00 00       	call   c0027640 <debug_panic>
  ASSERT (lock_held_by_current_thread (lock));
c00224df:	83 ec 0c             	sub    $0xc,%esp
c00224e2:	68 b4 d4 02 c0       	push   $0xc002d4b4
c00224e7:	68 df cb 02 c0       	push   $0xc002cbdf
c00224ec:	68 a4 b6 02 c0       	push   $0xc002b6a4
c00224f1:	68 e8 00 00 00       	push   $0xe8
c00224f6:	68 37 d4 02 c0       	push   $0xc002d437
c00224fb:	e8 40 51 00 00       	call   c0027640 <debug_panic>

c0022500 <cond_init>:
/* Initializes condition variable COND.  A condition variable
   allows one piece of code to signal a condition and cooperating
   code to receive the signal and act upon it. */
void
cond_init (struct condition *cond)
{
c0022500:	83 ec 0c             	sub    $0xc,%esp
c0022503:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (cond != NULL);
c0022507:	85 c0                	test   %eax,%eax
c0022509:	74 0d                	je     c0022518 <cond_init+0x18>

  list_init (&cond->waiters);
c002250b:	83 ec 0c             	sub    $0xc,%esp
c002250e:	50                   	push   %eax
c002250f:	e8 d3 51 00 00       	call   c00276e7 <list_init>
}
c0022514:	83 c4 1c             	add    $0x1c,%esp
c0022517:	c3                   	ret    
  ASSERT (cond != NULL);
c0022518:	83 ec 0c             	sub    $0xc,%esp
c002251b:	68 80 d4 02 c0       	push   $0xc002d480
c0022520:	68 df cb 02 c0       	push   $0xc002cbdf
c0022525:	68 7c b6 02 c0       	push   $0xc002b67c
c002252a:	68 06 01 00 00       	push   $0x106
c002252f:	68 37 d4 02 c0       	push   $0xc002d437
c0022534:	e8 07 51 00 00       	call   c0027640 <debug_panic>

c0022539 <cond_wait>:
   interrupt handler.  This function may be called with
   interrupts disabled, but interrupts will be turned back on if
   we need to sleep. */
void
cond_wait (struct condition *cond, struct lock *lock) 
{
c0022539:	55                   	push   %ebp
c002253a:	57                   	push   %edi
c002253b:	56                   	push   %esi
c002253c:	53                   	push   %ebx
c002253d:	83 ec 2c             	sub    $0x2c,%esp
c0022540:	8b 74 24 40          	mov    0x40(%esp),%esi
c0022544:	8b 5c 24 44          	mov    0x44(%esp),%ebx
  struct semaphore_elem waiter;

  ASSERT (cond != NULL);
c0022548:	85 f6                	test   %esi,%esi
c002254a:	74 62                	je     c00225ae <cond_wait+0x75>
  ASSERT (lock != NULL);
c002254c:	85 db                	test   %ebx,%ebx
c002254e:	74 7f                	je     c00225cf <cond_wait+0x96>
  ASSERT (!intr_context ());
c0022550:	e8 4f ed ff ff       	call   c00212a4 <intr_context>
c0022555:	84 c0                	test   %al,%al
c0022557:	0f 85 93 00 00 00    	jne    c00225f0 <cond_wait+0xb7>
  ASSERT (lock_held_by_current_thread (lock));
c002255d:	83 ec 0c             	sub    $0xc,%esp
c0022560:	53                   	push   %ebx
c0022561:	e8 c2 fd ff ff       	call   c0022328 <lock_held_by_current_thread>
c0022566:	83 c4 10             	add    $0x10,%esp
c0022569:	84 c0                	test   %al,%al
c002256b:	0f 84 a0 00 00 00    	je     c0022611 <cond_wait+0xd8>
  
  sema_init (&waiter.semaphore, 0);
c0022571:	83 ec 08             	sub    $0x8,%esp
c0022574:	6a 00                	push   $0x0
c0022576:	8d 6c 24 10          	lea    0x10(%esp),%ebp
c002257a:	8d 7c 24 18          	lea    0x18(%esp),%edi
c002257e:	57                   	push   %edi
c002257f:	e8 2d fb ff ff       	call   c00220b1 <sema_init>
  list_push_back (&cond->waiters, &waiter.elem);
c0022584:	83 c4 08             	add    $0x8,%esp
c0022587:	55                   	push   %ebp
c0022588:	56                   	push   %esi
c0022589:	e8 f6 55 00 00       	call   c0027b84 <list_push_back>
  lock_release (lock);
c002258e:	89 1c 24             	mov    %ebx,(%esp)
c0022591:	e8 f5 fe ff ff       	call   c002248b <lock_release>
  sema_down (&waiter.semaphore);
c0022596:	89 3c 24             	mov    %edi,(%esp)
c0022599:	e8 52 fb ff ff       	call   c00220f0 <sema_down>
  lock_acquire (lock);
c002259e:	89 1c 24             	mov    %ebx,(%esp)
c00225a1:	e8 c0 fd ff ff       	call   c0022366 <lock_acquire>
}
c00225a6:	83 c4 3c             	add    $0x3c,%esp
c00225a9:	5b                   	pop    %ebx
c00225aa:	5e                   	pop    %esi
c00225ab:	5f                   	pop    %edi
c00225ac:	5d                   	pop    %ebp
c00225ad:	c3                   	ret    
  ASSERT (cond != NULL);
c00225ae:	83 ec 0c             	sub    $0xc,%esp
c00225b1:	68 80 d4 02 c0       	push   $0xc002d480
c00225b6:	68 df cb 02 c0       	push   $0xc002cbdf
c00225bb:	68 70 b6 02 c0       	push   $0xc002b670
c00225c0:	68 24 01 00 00       	push   $0x124
c00225c5:	68 37 d4 02 c0       	push   $0xc002d437
c00225ca:	e8 71 50 00 00       	call   c0027640 <debug_panic>
  ASSERT (lock != NULL);
c00225cf:	83 ec 0c             	sub    $0xc,%esp
c00225d2:	68 73 d4 02 c0       	push   $0xc002d473
c00225d7:	68 df cb 02 c0       	push   $0xc002cbdf
c00225dc:	68 70 b6 02 c0       	push   $0xc002b670
c00225e1:	68 25 01 00 00       	push   $0x125
c00225e6:	68 37 d4 02 c0       	push   $0xc002d437
c00225eb:	e8 50 50 00 00       	call   c0027640 <debug_panic>
  ASSERT (!intr_context ());
c00225f0:	83 ec 0c             	sub    $0xc,%esp
c00225f3:	68 e0 cf 02 c0       	push   $0xc002cfe0
c00225f8:	68 df cb 02 c0       	push   $0xc002cbdf
c00225fd:	68 70 b6 02 c0       	push   $0xc002b670
c0022602:	68 26 01 00 00       	push   $0x126
c0022607:	68 37 d4 02 c0       	push   $0xc002d437
c002260c:	e8 2f 50 00 00       	call   c0027640 <debug_panic>
  ASSERT (lock_held_by_current_thread (lock));
c0022611:	83 ec 0c             	sub    $0xc,%esp
c0022614:	68 b4 d4 02 c0       	push   $0xc002d4b4
c0022619:	68 df cb 02 c0       	push   $0xc002cbdf
c002261e:	68 70 b6 02 c0       	push   $0xc002b670
c0022623:	68 27 01 00 00       	push   $0x127
c0022628:	68 37 d4 02 c0       	push   $0xc002d437
c002262d:	e8 0e 50 00 00       	call   c0027640 <debug_panic>

c0022632 <cond_signal>:
   An interrupt handler cannot acquire a lock, so it does not
   make sense to try to signal a condition variable within an
   interrupt handler. */
void
cond_signal (struct condition *cond, struct lock *lock UNUSED) 
{
c0022632:	56                   	push   %esi
c0022633:	53                   	push   %ebx
c0022634:	83 ec 04             	sub    $0x4,%esp
c0022637:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c002263b:	8b 74 24 14          	mov    0x14(%esp),%esi
  ASSERT (cond != NULL);
c002263f:	85 db                	test   %ebx,%ebx
c0022641:	74 37                	je     c002267a <cond_signal+0x48>
  ASSERT (lock != NULL);
c0022643:	85 f6                	test   %esi,%esi
c0022645:	74 54                	je     c002269b <cond_signal+0x69>
  ASSERT (!intr_context ());
c0022647:	e8 58 ec ff ff       	call   c00212a4 <intr_context>
c002264c:	84 c0                	test   %al,%al
c002264e:	75 6c                	jne    c00226bc <cond_signal+0x8a>
  ASSERT (lock_held_by_current_thread (lock));
c0022650:	83 ec 0c             	sub    $0xc,%esp
c0022653:	56                   	push   %esi
c0022654:	e8 cf fc ff ff       	call   c0022328 <lock_held_by_current_thread>
c0022659:	83 c4 10             	add    $0x10,%esp
c002265c:	84 c0                	test   %al,%al
c002265e:	74 7d                	je     c00226dd <cond_signal+0xab>

  if (!list_empty (&cond->waiters)) 
c0022660:	83 ec 0c             	sub    $0xc,%esp
c0022663:	53                   	push   %ebx
c0022664:	e8 c3 55 00 00       	call   c0027c2c <list_empty>
c0022669:	83 c4 10             	add    $0x10,%esp
c002266c:	84 c0                	test   %al,%al
c002266e:	0f 84 8a 00 00 00    	je     c00226fe <cond_signal+0xcc>
    sema_up (&list_entry (list_pop_front (&cond->waiters),
                          struct semaphore_elem, elem)->semaphore);
}
c0022674:	83 c4 04             	add    $0x4,%esp
c0022677:	5b                   	pop    %ebx
c0022678:	5e                   	pop    %esi
c0022679:	c3                   	ret    
  ASSERT (cond != NULL);
c002267a:	83 ec 0c             	sub    $0xc,%esp
c002267d:	68 80 d4 02 c0       	push   $0xc002d480
c0022682:	68 df cb 02 c0       	push   $0xc002cbdf
c0022687:	68 64 b6 02 c0       	push   $0xc002b664
c002268c:	68 3a 01 00 00       	push   $0x13a
c0022691:	68 37 d4 02 c0       	push   $0xc002d437
c0022696:	e8 a5 4f 00 00       	call   c0027640 <debug_panic>
  ASSERT (lock != NULL);
c002269b:	83 ec 0c             	sub    $0xc,%esp
c002269e:	68 73 d4 02 c0       	push   $0xc002d473
c00226a3:	68 df cb 02 c0       	push   $0xc002cbdf
c00226a8:	68 64 b6 02 c0       	push   $0xc002b664
c00226ad:	68 3b 01 00 00       	push   $0x13b
c00226b2:	68 37 d4 02 c0       	push   $0xc002d437
c00226b7:	e8 84 4f 00 00       	call   c0027640 <debug_panic>
  ASSERT (!intr_context ());
c00226bc:	83 ec 0c             	sub    $0xc,%esp
c00226bf:	68 e0 cf 02 c0       	push   $0xc002cfe0
c00226c4:	68 df cb 02 c0       	push   $0xc002cbdf
c00226c9:	68 64 b6 02 c0       	push   $0xc002b664
c00226ce:	68 3c 01 00 00       	push   $0x13c
c00226d3:	68 37 d4 02 c0       	push   $0xc002d437
c00226d8:	e8 63 4f 00 00       	call   c0027640 <debug_panic>
  ASSERT (lock_held_by_current_thread (lock));
c00226dd:	83 ec 0c             	sub    $0xc,%esp
c00226e0:	68 b4 d4 02 c0       	push   $0xc002d4b4
c00226e5:	68 df cb 02 c0       	push   $0xc002cbdf
c00226ea:	68 64 b6 02 c0       	push   $0xc002b664
c00226ef:	68 3d 01 00 00       	push   $0x13d
c00226f4:	68 37 d4 02 c0       	push   $0xc002d437
c00226f9:	e8 42 4f 00 00       	call   c0027640 <debug_panic>
    sema_up (&list_entry (list_pop_front (&cond->waiters),
c00226fe:	83 ec 0c             	sub    $0xc,%esp
c0022701:	53                   	push   %ebx
c0022702:	e8 87 55 00 00       	call   c0027c8e <list_pop_front>
c0022707:	83 c0 08             	add    $0x8,%eax
c002270a:	89 04 24             	mov    %eax,(%esp)
c002270d:	e8 bf fa ff ff       	call   c00221d1 <sema_up>
c0022712:	83 c4 10             	add    $0x10,%esp
}
c0022715:	e9 5a ff ff ff       	jmp    c0022674 <cond_signal+0x42>

c002271a <cond_broadcast>:
   An interrupt handler cannot acquire a lock, so it does not
   make sense to try to signal a condition variable within an
   interrupt handler. */
void
cond_broadcast (struct condition *cond, struct lock *lock) 
{
c002271a:	56                   	push   %esi
c002271b:	53                   	push   %ebx
c002271c:	83 ec 04             	sub    $0x4,%esp
c002271f:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0022723:	8b 74 24 14          	mov    0x14(%esp),%esi
  ASSERT (cond != NULL);
c0022727:	85 db                	test   %ebx,%ebx
c0022729:	74 25                	je     c0022750 <cond_broadcast+0x36>
  ASSERT (lock != NULL);
c002272b:	85 f6                	test   %esi,%esi
c002272d:	75 4f                	jne    c002277e <cond_broadcast+0x64>
c002272f:	83 ec 0c             	sub    $0xc,%esp
c0022732:	68 73 d4 02 c0       	push   $0xc002d473
c0022737:	68 df cb 02 c0       	push   $0xc002cbdf
c002273c:	68 54 b6 02 c0       	push   $0xc002b654
c0022741:	68 4e 01 00 00       	push   $0x14e
c0022746:	68 37 d4 02 c0       	push   $0xc002d437
c002274b:	e8 f0 4e 00 00       	call   c0027640 <debug_panic>
  ASSERT (cond != NULL);
c0022750:	83 ec 0c             	sub    $0xc,%esp
c0022753:	68 80 d4 02 c0       	push   $0xc002d480
c0022758:	68 df cb 02 c0       	push   $0xc002cbdf
c002275d:	68 54 b6 02 c0       	push   $0xc002b654
c0022762:	68 4d 01 00 00       	push   $0x14d
c0022767:	68 37 d4 02 c0       	push   $0xc002d437
c002276c:	e8 cf 4e 00 00       	call   c0027640 <debug_panic>

  while (!list_empty (&cond->waiters))
    cond_signal (cond, lock);
c0022771:	83 ec 08             	sub    $0x8,%esp
c0022774:	56                   	push   %esi
c0022775:	53                   	push   %ebx
c0022776:	e8 b7 fe ff ff       	call   c0022632 <cond_signal>
c002277b:	83 c4 10             	add    $0x10,%esp
  while (!list_empty (&cond->waiters))
c002277e:	83 ec 0c             	sub    $0xc,%esp
c0022781:	53                   	push   %ebx
c0022782:	e8 a5 54 00 00       	call   c0027c2c <list_empty>
c0022787:	83 c4 10             	add    $0x10,%esp
c002278a:	84 c0                	test   %al,%al
c002278c:	74 e3                	je     c0022771 <cond_broadcast+0x57>
}
c002278e:	83 c4 04             	add    $0x4,%esp
c0022791:	5b                   	pop    %ebx
c0022792:	5e                   	pop    %esi
c0022793:	c3                   	ret    

c0022794 <init_pool>:

/* Initializes pool P as starting at START and ending at END,
   naming it NAME for debugging purposes. */
static void
init_pool (struct pool *p, void *base, size_t page_cnt, const char *name) 
{
c0022794:	55                   	push   %ebp
c0022795:	57                   	push   %edi
c0022796:	56                   	push   %esi
c0022797:	53                   	push   %ebx
c0022798:	83 ec 18             	sub    $0x18,%esp
c002279b:	89 c5                	mov    %eax,%ebp
c002279d:	89 d7                	mov    %edx,%edi
c002279f:	89 ce                	mov    %ecx,%esi
  /* We'll put the pool's used_map at its base.
     Calculate the space needed for the bitmap
     and subtract it from the pool's size. */
  size_t bm_pages = DIV_ROUND_UP (bitmap_buf_size (page_cnt), PGSIZE);
c00227a1:	51                   	push   %ecx
c00227a2:	e8 fc 5a 00 00       	call   c00282a3 <bitmap_buf_size>
c00227a7:	8d 98 ff 0f 00 00    	lea    0xfff(%eax),%ebx
c00227ad:	89 d8                	mov    %ebx,%eax
c00227af:	c1 e8 0c             	shr    $0xc,%eax
  if (bm_pages > page_cnt)
c00227b2:	83 c4 10             	add    $0x10,%esp
c00227b5:	39 c6                	cmp    %eax,%esi
c00227b7:	72 3d                	jb     c00227f6 <init_pool+0x62>
    PANIC ("Not enough memory in %s for bitmap.", name);
  page_cnt -= bm_pages;
c00227b9:	29 c6                	sub    %eax,%esi

  printf ("%zu pages available in %s.\n", page_cnt, name);
c00227bb:	83 ec 04             	sub    $0x4,%esp
c00227be:	ff 74 24 24          	pushl  0x24(%esp)
c00227c2:	56                   	push   %esi
c00227c3:	68 43 d5 02 c0       	push   $0xc002d543
c00227c8:	e8 c5 33 00 00       	call   c0025b92 <printf>

  /* Initialize the pool. */
  lock_init (&p->lock);
c00227cd:	89 2c 24             	mov    %ebp,(%esp)
c00227d0:	e8 0f fb ff ff       	call   c00222e4 <lock_init>
  p->used_map = bitmap_create_in_buf (page_cnt, base, bm_pages * PGSIZE);
c00227d5:	81 e3 00 f0 ff ff    	and    $0xfffff000,%ebx
c00227db:	83 c4 0c             	add    $0xc,%esp
c00227de:	53                   	push   %ebx
c00227df:	57                   	push   %edi
c00227e0:	56                   	push   %esi
c00227e1:	e8 96 5d 00 00       	call   c002857c <bitmap_create_in_buf>
c00227e6:	89 45 18             	mov    %eax,0x18(%ebp)
  p->base = base + bm_pages * PGSIZE;
c00227e9:	01 df                	add    %ebx,%edi
c00227eb:	89 7d 1c             	mov    %edi,0x1c(%ebp)
}
c00227ee:	83 c4 1c             	add    $0x1c,%esp
c00227f1:	5b                   	pop    %ebx
c00227f2:	5e                   	pop    %esi
c00227f3:	5f                   	pop    %edi
c00227f4:	5d                   	pop    %ebp
c00227f5:	c3                   	ret    
    PANIC ("Not enough memory in %s for bitmap.", name);
c00227f6:	83 ec 0c             	sub    $0xc,%esp
c00227f9:	ff 74 24 2c          	pushl  0x2c(%esp)
c00227fd:	68 d8 d4 02 c0       	push   $0xc002d4d8
c0022802:	68 40 b7 02 c0       	push   $0xc002b740
c0022807:	68 a1 00 00 00       	push   $0xa1
c002280c:	68 2c d5 02 c0       	push   $0xc002d52c
c0022811:	e8 2a 4e 00 00       	call   c0027640 <debug_panic>

c0022816 <palloc_init>:
{
c0022816:	56                   	push   %esi
c0022817:	53                   	push   %ebx
c0022818:	83 ec 04             	sub    $0x4,%esp
  uint8_t *free_end = ptov (init_ram_pages * PGSIZE);
c002281b:	a1 5e 01 02 c0       	mov    0xc002015e,%eax
c0022820:	c1 e0 0c             	shl    $0xc,%eax
  ASSERT ((void *) paddr < PHYS_BASE);
c0022823:	3d ff ff ff bf       	cmp    $0xbfffffff,%eax
c0022828:	77 5b                	ja     c0022885 <palloc_init+0x6f>
  size_t free_pages = (free_end - free_start) / PGSIZE;
c002282a:	2d 00 00 10 00       	sub    $0x100000,%eax
c002282f:	89 c3                	mov    %eax,%ebx
c0022831:	85 c0                	test   %eax,%eax
c0022833:	78 6e                	js     c00228a3 <palloc_init+0x8d>
c0022835:	c1 fb 0c             	sar    $0xc,%ebx
  size_t user_pages = free_pages / 2;
c0022838:	89 d8                	mov    %ebx,%eax
c002283a:	d1 e8                	shr    %eax
c002283c:	89 c6                	mov    %eax,%esi
c002283e:	3b 44 24 10          	cmp    0x10(%esp),%eax
c0022842:	76 04                	jbe    c0022848 <palloc_init+0x32>
c0022844:	8b 74 24 10          	mov    0x10(%esp),%esi
  kernel_pages = free_pages - user_pages;
c0022848:	29 f3                	sub    %esi,%ebx
  init_pool (&kernel_pool, free_start, kernel_pages, "kernel pool");
c002284a:	83 ec 0c             	sub    $0xc,%esp
c002284d:	68 7a d5 02 c0       	push   $0xc002d57a
c0022852:	89 d9                	mov    %ebx,%ecx
c0022854:	ba 00 00 10 c0       	mov    $0xc0100000,%edx
c0022859:	b8 60 7d 03 c0       	mov    $0xc0037d60,%eax
c002285e:	e8 31 ff ff ff       	call   c0022794 <init_pool>
  init_pool (&user_pool, free_start + kernel_pages * PGSIZE,
c0022863:	c1 e3 0c             	shl    $0xc,%ebx
c0022866:	8d 93 00 00 10 c0    	lea    -0x3ff00000(%ebx),%edx
c002286c:	c7 04 24 86 d5 02 c0 	movl   $0xc002d586,(%esp)
c0022873:	89 f1                	mov    %esi,%ecx
c0022875:	b8 40 7d 03 c0       	mov    $0xc0037d40,%eax
c002287a:	e8 15 ff ff ff       	call   c0022794 <init_pool>
}
c002287f:	83 c4 14             	add    $0x14,%esp
c0022882:	5b                   	pop    %ebx
c0022883:	5e                   	pop    %esi
c0022884:	c3                   	ret    
c0022885:	83 ec 0c             	sub    $0xc,%esp
c0022888:	68 5f d5 02 c0       	push   $0xc002d55f
c002288d:	68 df cb 02 c0       	push   $0xc002cbdf
c0022892:	68 4c b7 02 c0       	push   $0xc002b74c
c0022897:	6a 4a                	push   $0x4a
c0022899:	68 22 cc 02 c0       	push   $0xc002cc22
c002289e:	e8 9d 4d 00 00       	call   c0027640 <debug_panic>
  size_t free_pages = (free_end - free_start) / PGSIZE;
c00228a3:	8d 98 ff 0f 00 00    	lea    0xfff(%eax),%ebx
c00228a9:	eb 8a                	jmp    c0022835 <palloc_init+0x1f>

c00228ab <palloc_get_multiple>:
{
c00228ab:	57                   	push   %edi
c00228ac:	56                   	push   %esi
c00228ad:	53                   	push   %ebx
c00228ae:	8b 7c 24 14          	mov    0x14(%esp),%edi
  struct pool *pool = flags & PAL_USER ? &user_pool : &kernel_pool;
c00228b2:	f6 44 24 10 04       	testb  $0x4,0x10(%esp)
c00228b7:	75 47                	jne    c0022900 <palloc_get_multiple+0x55>
c00228b9:	bb 60 7d 03 c0       	mov    $0xc0037d60,%ebx
  if (page_cnt == 0)
c00228be:	85 ff                	test   %edi,%edi
c00228c0:	74 76                	je     c0022938 <palloc_get_multiple+0x8d>
  lock_acquire (&pool->lock);
c00228c2:	83 ec 0c             	sub    $0xc,%esp
c00228c5:	53                   	push   %ebx
c00228c6:	e8 9b fa ff ff       	call   c0022366 <lock_acquire>
  page_idx = bitmap_scan_and_flip (pool->used_map, 0, page_cnt, false);
c00228cb:	6a 00                	push   $0x0
c00228cd:	57                   	push   %edi
c00228ce:	6a 00                	push   $0x0
c00228d0:	ff 73 18             	pushl  0x18(%ebx)
c00228d3:	e8 73 5f 00 00       	call   c002884b <bitmap_scan_and_flip>
c00228d8:	89 c6                	mov    %eax,%esi
  lock_release (&pool->lock);
c00228da:	83 c4 14             	add    $0x14,%esp
c00228dd:	53                   	push   %ebx
c00228de:	e8 a8 fb ff ff       	call   c002248b <lock_release>
  if (page_idx != BITMAP_ERROR)
c00228e3:	83 c4 10             	add    $0x10,%esp
c00228e6:	83 fe ff             	cmp    $0xffffffff,%esi
c00228e9:	74 29                	je     c0022914 <palloc_get_multiple+0x69>
    pages = pool->base + PGSIZE * page_idx;
c00228eb:	c1 e6 0c             	shl    $0xc,%esi
  if (pages != NULL) 
c00228ee:	03 73 1c             	add    0x1c(%ebx),%esi
c00228f1:	74 21                	je     c0022914 <palloc_get_multiple+0x69>
      if (flags & PAL_ZERO)
c00228f3:	f6 44 24 10 02       	testb  $0x2,0x10(%esp)
c00228f8:	75 0d                	jne    c0022907 <palloc_get_multiple+0x5c>
}
c00228fa:	89 f0                	mov    %esi,%eax
c00228fc:	5b                   	pop    %ebx
c00228fd:	5e                   	pop    %esi
c00228fe:	5f                   	pop    %edi
c00228ff:	c3                   	ret    
  struct pool *pool = flags & PAL_USER ? &user_pool : &kernel_pool;
c0022900:	bb 40 7d 03 c0       	mov    $0xc0037d40,%ebx
c0022905:	eb b7                	jmp    c00228be <palloc_get_multiple+0x13>
        memset (pages, 0, PGSIZE * page_cnt);
c0022907:	89 f9                	mov    %edi,%ecx
c0022909:	c1 e1 0c             	shl    $0xc,%ecx
c002290c:	b0 00                	mov    $0x0,%al
c002290e:	89 f7                	mov    %esi,%edi
c0022910:	f3 aa                	rep stos %al,%es:(%edi)
c0022912:	eb e6                	jmp    c00228fa <palloc_get_multiple+0x4f>
      if (flags & PAL_ASSERT)
c0022914:	f6 44 24 10 01       	testb  $0x1,0x10(%esp)
c0022919:	75 07                	jne    c0022922 <palloc_get_multiple+0x77>
  return pages;
c002291b:	be 00 00 00 00       	mov    $0x0,%esi
c0022920:	eb d8                	jmp    c00228fa <palloc_get_multiple+0x4f>
        PANIC ("palloc_get: out of pages");
c0022922:	68 90 d5 02 c0       	push   $0xc002d590
c0022927:	68 2c b7 02 c0       	push   $0xc002b72c
c002292c:	6a 61                	push   $0x61
c002292e:	68 2c d5 02 c0       	push   $0xc002d52c
c0022933:	e8 08 4d 00 00       	call   c0027640 <debug_panic>
    return NULL;
c0022938:	be 00 00 00 00       	mov    $0x0,%esi
c002293d:	eb bb                	jmp    c00228fa <palloc_get_multiple+0x4f>

c002293f <palloc_get_page>:
{
c002293f:	83 ec 14             	sub    $0x14,%esp
  return palloc_get_multiple (flags, 1);
c0022942:	6a 01                	push   $0x1
c0022944:	ff 74 24 1c          	pushl  0x1c(%esp)
c0022948:	e8 5e ff ff ff       	call   c00228ab <palloc_get_multiple>
}
c002294d:	83 c4 1c             	add    $0x1c,%esp
c0022950:	c3                   	ret    

c0022951 <palloc_free_multiple>:
{
c0022951:	55                   	push   %ebp
c0022952:	57                   	push   %edi
c0022953:	56                   	push   %esi
c0022954:	53                   	push   %ebx
c0022955:	83 ec 0c             	sub    $0xc,%esp
c0022958:	8b 5c 24 24          	mov    0x24(%esp),%ebx
  ASSERT (pg_ofs (pages) == 0);
c002295c:	f7 44 24 20 ff 0f 00 	testl  $0xfff,0x20(%esp)
c0022963:	00 
c0022964:	75 13                	jne    c0022979 <palloc_free_multiple+0x28>
  if (pages == NULL || page_cnt == 0)
c0022966:	83 7c 24 20 00       	cmpl   $0x0,0x20(%esp)
c002296b:	74 04                	je     c0022971 <palloc_free_multiple+0x20>
c002296d:	85 db                	test   %ebx,%ebx
c002296f:	75 26                	jne    c0022997 <palloc_free_multiple+0x46>
}
c0022971:	83 c4 0c             	add    $0xc,%esp
c0022974:	5b                   	pop    %ebx
c0022975:	5e                   	pop    %esi
c0022976:	5f                   	pop    %edi
c0022977:	5d                   	pop    %ebp
c0022978:	c3                   	ret    
  ASSERT (pg_ofs (pages) == 0);
c0022979:	83 ec 0c             	sub    $0xc,%esp
c002297c:	68 a9 d5 02 c0       	push   $0xc002d5a9
c0022981:	68 df cb 02 c0       	push   $0xc002cbdf
c0022986:	68 14 b7 02 c0       	push   $0xc002b714
c002298b:	6a 7b                	push   $0x7b
c002298d:	68 2c d5 02 c0       	push   $0xc002d52c
c0022992:	e8 a9 4c 00 00       	call   c0027640 <debug_panic>
  return (uintptr_t) va >> PGBITS;
c0022997:	8b 74 24 20          	mov    0x20(%esp),%esi
c002299b:	c1 ee 0c             	shr    $0xc,%esi
c002299e:	8b 2d 7c 7d 03 c0    	mov    0xc0037d7c,%ebp
c00229a4:	c1 ed 0c             	shr    $0xc,%ebp
static bool
page_from_pool (const struct pool *pool, void *page) 
{
  size_t page_no = pg_no (page);
  size_t start_page = pg_no (pool->base);
  size_t end_page = start_page + bitmap_size (pool->used_map);
c00229a7:	83 ec 0c             	sub    $0xc,%esp
c00229aa:	ff 35 78 7d 03 c0    	pushl  0xc0037d78
c00229b0:	e8 27 59 00 00       	call   c00282dc <bitmap_size>

  return page_no >= start_page && page_no < end_page;
c00229b5:	83 c4 10             	add    $0x10,%esp
c00229b8:	39 ee                	cmp    %ebp,%esi
c00229ba:	72 06                	jb     c00229c2 <palloc_free_multiple+0x71>
  size_t end_page = start_page + bitmap_size (pool->used_map);
c00229bc:	01 c5                	add    %eax,%ebp
  return page_no >= start_page && page_no < end_page;
c00229be:	39 ee                	cmp    %ebp,%esi
c00229c0:	72 44                	jb     c0022a06 <palloc_free_multiple+0xb5>
c00229c2:	8b 2d 5c 7d 03 c0    	mov    0xc0037d5c,%ebp
c00229c8:	c1 ed 0c             	shr    $0xc,%ebp
  size_t end_page = start_page + bitmap_size (pool->used_map);
c00229cb:	83 ec 0c             	sub    $0xc,%esp
c00229ce:	ff 35 58 7d 03 c0    	pushl  0xc0037d58
c00229d4:	e8 03 59 00 00       	call   c00282dc <bitmap_size>
  return page_no >= start_page && page_no < end_page;
c00229d9:	83 c4 10             	add    $0x10,%esp
c00229dc:	39 ee                	cmp    %ebp,%esi
c00229de:	73 19                	jae    c00229f9 <palloc_free_multiple+0xa8>
    NOT_REACHED ();
c00229e0:	68 60 d0 02 c0       	push   $0xc002d060
c00229e5:	68 14 b7 02 c0       	push   $0xc002b714
c00229ea:	68 84 00 00 00       	push   $0x84
c00229ef:	68 2c d5 02 c0       	push   $0xc002d52c
c00229f4:	e8 47 4c 00 00       	call   c0027640 <debug_panic>
  size_t end_page = start_page + bitmap_size (pool->used_map);
c00229f9:	01 e8                	add    %ebp,%eax
  return page_no >= start_page && page_no < end_page;
c00229fb:	39 c6                	cmp    %eax,%esi
c00229fd:	73 e1                	jae    c00229e0 <palloc_free_multiple+0x8f>
    pool = &user_pool;
c00229ff:	bd 40 7d 03 c0       	mov    $0xc0037d40,%ebp
c0022a04:	eb 05                	jmp    c0022a0b <palloc_free_multiple+0xba>
    pool = &kernel_pool;
c0022a06:	bd 60 7d 03 c0       	mov    $0xc0037d60,%ebp
c0022a0b:	8b 45 1c             	mov    0x1c(%ebp),%eax
c0022a0e:	c1 e8 0c             	shr    $0xc,%eax
  page_idx = pg_no (pages) - pg_no (pool->base);
c0022a11:	29 c6                	sub    %eax,%esi
  memset (pages, 0xcc, PGSIZE * page_cnt);
c0022a13:	89 d9                	mov    %ebx,%ecx
c0022a15:	c1 e1 0c             	shl    $0xc,%ecx
c0022a18:	b0 cc                	mov    $0xcc,%al
c0022a1a:	8b 7c 24 20          	mov    0x20(%esp),%edi
c0022a1e:	f3 aa                	rep stos %al,%es:(%edi)
  ASSERT (bitmap_all (pool->used_map, page_idx, page_cnt));
c0022a20:	83 ec 04             	sub    $0x4,%esp
c0022a23:	53                   	push   %ebx
c0022a24:	56                   	push   %esi
c0022a25:	ff 75 18             	pushl  0x18(%ebp)
c0022a28:	e8 51 5d 00 00       	call   c002877e <bitmap_all>
c0022a2d:	83 c4 10             	add    $0x10,%esp
c0022a30:	84 c0                	test   %al,%al
c0022a32:	74 14                	je     c0022a48 <palloc_free_multiple+0xf7>
  bitmap_set_multiple (pool->used_map, page_idx, page_cnt, false);
c0022a34:	6a 00                	push   $0x0
c0022a36:	53                   	push   %ebx
c0022a37:	56                   	push   %esi
c0022a38:	ff 75 18             	pushl  0x18(%ebp)
c0022a3b:	e8 e9 59 00 00       	call   c0028429 <bitmap_set_multiple>
c0022a40:	83 c4 10             	add    $0x10,%esp
c0022a43:	e9 29 ff ff ff       	jmp    c0022971 <palloc_free_multiple+0x20>
  ASSERT (bitmap_all (pool->used_map, page_idx, page_cnt));
c0022a48:	83 ec 0c             	sub    $0xc,%esp
c0022a4b:	68 fc d4 02 c0       	push   $0xc002d4fc
c0022a50:	68 df cb 02 c0       	push   $0xc002cbdf
c0022a55:	68 14 b7 02 c0       	push   $0xc002b714
c0022a5a:	68 8c 00 00 00       	push   $0x8c
c0022a5f:	68 2c d5 02 c0       	push   $0xc002d52c
c0022a64:	e8 d7 4b 00 00       	call   c0027640 <debug_panic>

c0022a69 <palloc_free_page>:
{
c0022a69:	83 ec 14             	sub    $0x14,%esp
  palloc_free_multiple (page, 1);
c0022a6c:	6a 01                	push   $0x1
c0022a6e:	ff 74 24 1c          	pushl  0x1c(%esp)
c0022a72:	e8 da fe ff ff       	call   c0022951 <palloc_free_multiple>
}
c0022a77:	83 c4 1c             	add    $0x1c,%esp
c0022a7a:	c3                   	ret    

c0022a7b <arena_to_block>:
}

/* Returns the (IDX - 1)'th block within arena A. */
static struct block *
arena_to_block (struct arena *a, size_t idx) 
{
c0022a7b:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (a != NULL);
c0022a7e:	85 c0                	test   %eax,%eax
c0022a80:	74 1b                	je     c0022a9d <arena_to_block+0x22>
  ASSERT (a->magic == ARENA_MAGIC);
c0022a82:	81 38 ed 8e 54 9a    	cmpl   $0x9a548eed,(%eax)
c0022a88:	75 34                	jne    c0022abe <arena_to_block+0x43>
  ASSERT (idx < a->desc->blocks_per_arena);
c0022a8a:	8b 48 04             	mov    0x4(%eax),%ecx
c0022a8d:	39 51 04             	cmp    %edx,0x4(%ecx)
c0022a90:	76 4d                	jbe    c0022adf <arena_to_block+0x64>
  return (struct block *) ((uint8_t *) a
                           + sizeof *a
                           + idx * a->desc->block_size);
c0022a92:	0f af 11             	imul   (%ecx),%edx
  return (struct block *) ((uint8_t *) a
c0022a95:	8d 44 10 0c          	lea    0xc(%eax,%edx,1),%eax
}
c0022a99:	83 c4 0c             	add    $0xc,%esp
c0022a9c:	c3                   	ret    
  ASSERT (a != NULL);
c0022a9d:	83 ec 0c             	sub    $0xc,%esp
c0022aa0:	68 2d d4 02 c0       	push   $0xc002d42d
c0022aa5:	68 df cb 02 c0       	push   $0xc002cbdf
c0022aaa:	68 6c b7 02 c0       	push   $0xc002b76c
c0022aaf:	68 20 01 00 00       	push   $0x120
c0022ab4:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022ab9:	e8 82 4b 00 00       	call   c0027640 <debug_panic>
  ASSERT (a->magic == ARENA_MAGIC);
c0022abe:	83 ec 0c             	sub    $0xc,%esp
c0022ac1:	68 d4 d5 02 c0       	push   $0xc002d5d4
c0022ac6:	68 df cb 02 c0       	push   $0xc002cbdf
c0022acb:	68 6c b7 02 c0       	push   $0xc002b76c
c0022ad0:	68 21 01 00 00       	push   $0x121
c0022ad5:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022ada:	e8 61 4b 00 00       	call   c0027640 <debug_panic>
  ASSERT (idx < a->desc->blocks_per_arena);
c0022adf:	83 ec 0c             	sub    $0xc,%esp
c0022ae2:	68 ec d5 02 c0       	push   $0xc002d5ec
c0022ae7:	68 df cb 02 c0       	push   $0xc002cbdf
c0022aec:	68 6c b7 02 c0       	push   $0xc002b76c
c0022af1:	68 22 01 00 00       	push   $0x122
c0022af6:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022afb:	e8 40 4b 00 00       	call   c0027640 <debug_panic>

c0022b00 <block_to_arena>:
{
c0022b00:	53                   	push   %ebx
c0022b01:	83 ec 08             	sub    $0x8,%esp
  ASSERT (a != NULL);
c0022b04:	89 c1                	mov    %eax,%ecx
c0022b06:	81 e1 00 f0 ff ff    	and    $0xfffff000,%ecx
c0022b0c:	74 29                	je     c0022b37 <block_to_arena+0x37>
  ASSERT (a->magic == ARENA_MAGIC);
c0022b0e:	81 39 ed 8e 54 9a    	cmpl   $0x9a548eed,(%ecx)
c0022b14:	75 42                	jne    c0022b58 <block_to_arena+0x58>
  ASSERT (a->desc == NULL
c0022b16:	8b 59 04             	mov    0x4(%ecx),%ebx
c0022b19:	85 db                	test   %ebx,%ebx
c0022b1b:	74 7d                	je     c0022b9a <block_to_arena+0x9a>
  return (uintptr_t) va & PGMASK;
c0022b1d:	25 ff 0f 00 00       	and    $0xfff,%eax
c0022b22:	83 e8 0c             	sub    $0xc,%eax
c0022b25:	ba 00 00 00 00       	mov    $0x0,%edx
c0022b2a:	f7 33                	divl   (%ebx)
c0022b2c:	85 d2                	test   %edx,%edx
c0022b2e:	75 49                	jne    c0022b79 <block_to_arena+0x79>
}
c0022b30:	89 c8                	mov    %ecx,%eax
c0022b32:	83 c4 08             	add    $0x8,%esp
c0022b35:	5b                   	pop    %ebx
c0022b36:	c3                   	ret    
  ASSERT (a != NULL);
c0022b37:	83 ec 0c             	sub    $0xc,%esp
c0022b3a:	68 2d d4 02 c0       	push   $0xc002d42d
c0022b3f:	68 df cb 02 c0       	push   $0xc002cbdf
c0022b44:	68 5c b7 02 c0       	push   $0xc002b75c
c0022b49:	68 11 01 00 00       	push   $0x111
c0022b4e:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022b53:	e8 e8 4a 00 00       	call   c0027640 <debug_panic>
  ASSERT (a->magic == ARENA_MAGIC);
c0022b58:	83 ec 0c             	sub    $0xc,%esp
c0022b5b:	68 d4 d5 02 c0       	push   $0xc002d5d4
c0022b60:	68 df cb 02 c0       	push   $0xc002cbdf
c0022b65:	68 5c b7 02 c0       	push   $0xc002b75c
c0022b6a:	68 12 01 00 00       	push   $0x112
c0022b6f:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022b74:	e8 c7 4a 00 00       	call   c0027640 <debug_panic>
  ASSERT (a->desc == NULL
c0022b79:	83 ec 0c             	sub    $0xc,%esp
c0022b7c:	68 0c d6 02 c0       	push   $0xc002d60c
c0022b81:	68 df cb 02 c0       	push   $0xc002cbdf
c0022b86:	68 5c b7 02 c0       	push   $0xc002b75c
c0022b8b:	68 16 01 00 00       	push   $0x116
c0022b90:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022b95:	e8 a6 4a 00 00       	call   c0027640 <debug_panic>
c0022b9a:	25 ff 0f 00 00       	and    $0xfff,%eax
  ASSERT (a->desc != NULL || pg_ofs (b) == sizeof *a);
c0022b9f:	83 f8 0c             	cmp    $0xc,%eax
c0022ba2:	74 8c                	je     c0022b30 <block_to_arena+0x30>
c0022ba4:	83 ec 0c             	sub    $0xc,%esp
c0022ba7:	68 54 d6 02 c0       	push   $0xc002d654
c0022bac:	68 df cb 02 c0       	push   $0xc002cbdf
c0022bb1:	68 5c b7 02 c0       	push   $0xc002b75c
c0022bb6:	68 17 01 00 00       	push   $0x117
c0022bbb:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022bc0:	e8 7b 4a 00 00       	call   c0027640 <debug_panic>

c0022bc5 <malloc_init>:
{
c0022bc5:	55                   	push   %ebp
c0022bc6:	57                   	push   %edi
c0022bc7:	56                   	push   %esi
c0022bc8:	53                   	push   %ebx
c0022bc9:	83 ec 0c             	sub    $0xc,%esp
      struct desc *d = &descs[desc_cnt++];
c0022bcc:	a1 80 7d 03 c0       	mov    0xc0037d80,%eax
c0022bd1:	8d 50 01             	lea    0x1(%eax),%edx
c0022bd4:	89 15 80 7d 03 c0    	mov    %edx,0xc0037d80
      ASSERT (desc_cnt <= sizeof descs / sizeof *descs);
c0022bda:	83 fa 0a             	cmp    $0xa,%edx
c0022bdd:	0f 87 b0 00 00 00    	ja     c0022c93 <malloc_init+0xce>
      d->block_size = block_size;
c0022be3:	8d 1c 00             	lea    (%eax,%eax,1),%ebx
c0022be6:	8d 14 03             	lea    (%ebx,%eax,1),%edx
c0022be9:	c1 e2 04             	shl    $0x4,%edx
c0022bec:	c7 82 a0 7d 03 c0 10 	movl   $0x10,-0x3ffc8260(%edx)
c0022bf3:	00 00 00 
      d->blocks_per_arena = (PGSIZE - sizeof (struct arena)) / block_size;
c0022bf6:	c7 82 a4 7d 03 c0 ff 	movl   $0xff,-0x3ffc825c(%edx)
c0022bfd:	00 00 00 
c0022c00:	89 d3                	mov    %edx,%ebx
      list_init (&d->free_list);
c0022c02:	83 ec 0c             	sub    $0xc,%esp
c0022c05:	8d 82 a8 7d 03 c0    	lea    -0x3ffc8258(%edx),%eax
c0022c0b:	50                   	push   %eax
c0022c0c:	e8 d6 4a 00 00       	call   c00276e7 <list_init>
      lock_init (&d->lock);
c0022c11:	81 c3 b8 7d 03 c0    	add    $0xc0037db8,%ebx
c0022c17:	89 1c 24             	mov    %ebx,(%esp)
c0022c1a:	e8 c5 f6 ff ff       	call   c00222e4 <lock_init>
c0022c1f:	83 c4 10             	add    $0x10,%esp
  for (block_size = 16; block_size < PGSIZE / 2; block_size *= 2)
c0022c22:	be 20 00 00 00       	mov    $0x20,%esi
      d->blocks_per_arena = (PGSIZE - sizeof (struct arena)) / block_size;
c0022c27:	bf f4 0f 00 00       	mov    $0xff4,%edi
      struct desc *d = &descs[desc_cnt++];
c0022c2c:	8b 0d 80 7d 03 c0    	mov    0xc0037d80,%ecx
c0022c32:	8d 41 01             	lea    0x1(%ecx),%eax
c0022c35:	a3 80 7d 03 c0       	mov    %eax,0xc0037d80
      ASSERT (desc_cnt <= sizeof descs / sizeof *descs);
c0022c3a:	83 f8 0a             	cmp    $0xa,%eax
c0022c3d:	77 54                	ja     c0022c93 <malloc_init+0xce>
      d->block_size = block_size;
c0022c3f:	8d 1c 09             	lea    (%ecx,%ecx,1),%ebx
c0022c42:	8d 2c 0b             	lea    (%ebx,%ecx,1),%ebp
c0022c45:	c1 e5 04             	shl    $0x4,%ebp
c0022c48:	89 b5 a0 7d 03 c0    	mov    %esi,-0x3ffc8260(%ebp)
      d->blocks_per_arena = (PGSIZE - sizeof (struct arena)) / block_size;
c0022c4e:	89 f8                	mov    %edi,%eax
c0022c50:	ba 00 00 00 00       	mov    $0x0,%edx
c0022c55:	f7 f6                	div    %esi
c0022c57:	89 85 a4 7d 03 c0    	mov    %eax,-0x3ffc825c(%ebp)
c0022c5d:	89 eb                	mov    %ebp,%ebx
      list_init (&d->free_list);
c0022c5f:	83 ec 0c             	sub    $0xc,%esp
c0022c62:	8d 85 a8 7d 03 c0    	lea    -0x3ffc8258(%ebp),%eax
c0022c68:	50                   	push   %eax
c0022c69:	e8 79 4a 00 00       	call   c00276e7 <list_init>
      lock_init (&d->lock);
c0022c6e:	81 c3 b8 7d 03 c0    	add    $0xc0037db8,%ebx
c0022c74:	89 1c 24             	mov    %ebx,(%esp)
c0022c77:	e8 68 f6 ff ff       	call   c00222e4 <lock_init>
  for (block_size = 16; block_size < PGSIZE / 2; block_size *= 2)
c0022c7c:	8d 04 36             	lea    (%esi,%esi,1),%eax
c0022c7f:	89 c6                	mov    %eax,%esi
c0022c81:	83 c4 10             	add    $0x10,%esp
c0022c84:	3d ff 07 00 00       	cmp    $0x7ff,%eax
c0022c89:	76 a1                	jbe    c0022c2c <malloc_init+0x67>
}
c0022c8b:	83 c4 0c             	add    $0xc,%esp
c0022c8e:	5b                   	pop    %ebx
c0022c8f:	5e                   	pop    %esi
c0022c90:	5f                   	pop    %edi
c0022c91:	5d                   	pop    %ebp
c0022c92:	c3                   	ret    
      ASSERT (desc_cnt <= sizeof descs / sizeof *descs);
c0022c93:	83 ec 0c             	sub    $0xc,%esp
c0022c96:	68 80 d6 02 c0       	push   $0xc002d680
c0022c9b:	68 df cb 02 c0       	push   $0xc002cbdf
c0022ca0:	68 7c b7 02 c0       	push   $0xc002b77c
c0022ca5:	6a 4f                	push   $0x4f
c0022ca7:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022cac:	e8 8f 49 00 00       	call   c0027640 <debug_panic>

c0022cb1 <malloc>:
{
c0022cb1:	55                   	push   %ebp
c0022cb2:	57                   	push   %edi
c0022cb3:	56                   	push   %esi
c0022cb4:	53                   	push   %ebx
c0022cb5:	83 ec 1c             	sub    $0x1c,%esp
c0022cb8:	8b 54 24 30          	mov    0x30(%esp),%edx
  if (size == 0)
c0022cbc:	85 d2                	test   %edx,%edx
c0022cbe:	0f 84 2c 01 00 00    	je     c0022df0 <malloc+0x13f>
  for (d = descs; d < descs + desc_cnt; d++)
c0022cc4:	8b 0d 80 7d 03 c0    	mov    0xc0037d80,%ecx
c0022cca:	8d 04 09             	lea    (%ecx,%ecx,1),%eax
c0022ccd:	01 c8                	add    %ecx,%eax
c0022ccf:	c1 e0 04             	shl    $0x4,%eax
c0022cd2:	05 a0 7d 03 c0       	add    $0xc0037da0,%eax
c0022cd7:	3d a0 7d 03 c0       	cmp    $0xc0037da0,%eax
c0022cdc:	0f 86 bb 00 00 00    	jbe    c0022d9d <malloc+0xec>
    if (d->block_size >= size)
c0022ce2:	3b 15 a0 7d 03 c0    	cmp    0xc0037da0,%edx
c0022ce8:	0f 86 10 01 00 00    	jbe    c0022dfe <malloc+0x14d>
c0022cee:	bb a0 7d 03 c0       	mov    $0xc0037da0,%ebx
  for (d = descs; d < descs + desc_cnt; d++)
c0022cf3:	83 c3 30             	add    $0x30,%ebx
c0022cf6:	39 c3                	cmp    %eax,%ebx
c0022cf8:	0f 83 a4 00 00 00    	jae    c0022da2 <malloc+0xf1>
    if (d->block_size >= size)
c0022cfe:	3b 13                	cmp    (%ebx),%edx
c0022d00:	77 f1                	ja     c0022cf3 <malloc+0x42>
  lock_acquire (&d->lock);
c0022d02:	8d 43 18             	lea    0x18(%ebx),%eax
c0022d05:	89 44 24 0c          	mov    %eax,0xc(%esp)
c0022d09:	83 ec 0c             	sub    $0xc,%esp
c0022d0c:	50                   	push   %eax
c0022d0d:	e8 54 f6 ff ff       	call   c0022366 <lock_acquire>
  if (list_empty (&d->free_list))
c0022d12:	8d 7b 08             	lea    0x8(%ebx),%edi
c0022d15:	89 3c 24             	mov    %edi,(%esp)
c0022d18:	e8 0f 4f 00 00       	call   c0027c2c <list_empty>
c0022d1d:	83 c4 10             	add    $0x10,%esp
c0022d20:	84 c0                	test   %al,%al
c0022d22:	74 4d                	je     c0022d71 <malloc+0xc0>
      a = palloc_get_page (0);
c0022d24:	83 ec 0c             	sub    $0xc,%esp
c0022d27:	6a 00                	push   $0x0
c0022d29:	e8 11 fc ff ff       	call   c002293f <palloc_get_page>
c0022d2e:	89 c5                	mov    %eax,%ebp
      if (a == NULL) 
c0022d30:	83 c4 10             	add    $0x10,%esp
c0022d33:	85 c0                	test   %eax,%eax
c0022d35:	0f 84 9f 00 00 00    	je     c0022dda <malloc+0x129>
      a->magic = ARENA_MAGIC;
c0022d3b:	c7 00 ed 8e 54 9a    	movl   $0x9a548eed,(%eax)
      a->desc = d;
c0022d41:	89 58 04             	mov    %ebx,0x4(%eax)
      a->free_cnt = d->blocks_per_arena;
c0022d44:	8b 43 04             	mov    0x4(%ebx),%eax
c0022d47:	89 45 08             	mov    %eax,0x8(%ebp)
      for (i = 0; i < d->blocks_per_arena; i++) 
c0022d4a:	83 7b 04 00          	cmpl   $0x0,0x4(%ebx)
c0022d4e:	74 21                	je     c0022d71 <malloc+0xc0>
c0022d50:	be 00 00 00 00       	mov    $0x0,%esi
          struct block *b = arena_to_block (a, i);
c0022d55:	89 f2                	mov    %esi,%edx
c0022d57:	89 e8                	mov    %ebp,%eax
c0022d59:	e8 1d fd ff ff       	call   c0022a7b <arena_to_block>
          list_push_back (&d->free_list, &b->free_elem);
c0022d5e:	83 ec 08             	sub    $0x8,%esp
c0022d61:	50                   	push   %eax
c0022d62:	57                   	push   %edi
c0022d63:	e8 1c 4e 00 00       	call   c0027b84 <list_push_back>
      for (i = 0; i < d->blocks_per_arena; i++) 
c0022d68:	46                   	inc    %esi
c0022d69:	83 c4 10             	add    $0x10,%esp
c0022d6c:	39 73 04             	cmp    %esi,0x4(%ebx)
c0022d6f:	77 e4                	ja     c0022d55 <malloc+0xa4>
  b = list_entry (list_pop_front (&d->free_list), struct block, free_elem);
c0022d71:	83 ec 0c             	sub    $0xc,%esp
c0022d74:	57                   	push   %edi
c0022d75:	e8 14 4f 00 00       	call   c0027c8e <list_pop_front>
c0022d7a:	89 c3                	mov    %eax,%ebx
  a = block_to_arena (b);
c0022d7c:	e8 7f fd ff ff       	call   c0022b00 <block_to_arena>
  a->free_cnt--;
c0022d81:	ff 48 08             	decl   0x8(%eax)
  lock_release (&d->lock);
c0022d84:	83 c4 04             	add    $0x4,%esp
c0022d87:	ff 74 24 18          	pushl  0x18(%esp)
c0022d8b:	e8 fb f6 ff ff       	call   c002248b <lock_release>
  return b;
c0022d90:	83 c4 10             	add    $0x10,%esp
c0022d93:	89 d8                	mov    %ebx,%eax
}
c0022d95:	83 c4 1c             	add    $0x1c,%esp
c0022d98:	5b                   	pop    %ebx
c0022d99:	5e                   	pop    %esi
c0022d9a:	5f                   	pop    %edi
c0022d9b:	5d                   	pop    %ebp
c0022d9c:	c3                   	ret    
  for (d = descs; d < descs + desc_cnt; d++)
c0022d9d:	bb a0 7d 03 c0       	mov    $0xc0037da0,%ebx
  if (d == descs + desc_cnt) 
c0022da2:	39 d8                	cmp    %ebx,%eax
c0022da4:	0f 85 58 ff ff ff    	jne    c0022d02 <malloc+0x51>
      size_t page_cnt = DIV_ROUND_UP (size + sizeof *a, PGSIZE);
c0022daa:	8d 9a 0b 10 00 00    	lea    0x100b(%edx),%ebx
c0022db0:	c1 eb 0c             	shr    $0xc,%ebx
      a = palloc_get_multiple (0, page_cnt);
c0022db3:	83 ec 08             	sub    $0x8,%esp
c0022db6:	53                   	push   %ebx
c0022db7:	6a 00                	push   $0x0
c0022db9:	e8 ed fa ff ff       	call   c00228ab <palloc_get_multiple>
      if (a == NULL)
c0022dbe:	83 c4 10             	add    $0x10,%esp
c0022dc1:	85 c0                	test   %eax,%eax
c0022dc3:	74 32                	je     c0022df7 <malloc+0x146>
      a->magic = ARENA_MAGIC;
c0022dc5:	c7 00 ed 8e 54 9a    	movl   $0x9a548eed,(%eax)
      a->desc = NULL;
c0022dcb:	c7 40 04 00 00 00 00 	movl   $0x0,0x4(%eax)
      a->free_cnt = page_cnt;
c0022dd2:	89 58 08             	mov    %ebx,0x8(%eax)
      return a + 1;
c0022dd5:	83 c0 0c             	add    $0xc,%eax
c0022dd8:	eb bb                	jmp    c0022d95 <malloc+0xe4>
          lock_release (&d->lock);
c0022dda:	83 ec 0c             	sub    $0xc,%esp
c0022ddd:	ff 74 24 18          	pushl  0x18(%esp)
c0022de1:	e8 a5 f6 ff ff       	call   c002248b <lock_release>
          return NULL; 
c0022de6:	83 c4 10             	add    $0x10,%esp
c0022de9:	b8 00 00 00 00       	mov    $0x0,%eax
c0022dee:	eb a5                	jmp    c0022d95 <malloc+0xe4>
    return NULL;
c0022df0:	b8 00 00 00 00       	mov    $0x0,%eax
c0022df5:	eb 9e                	jmp    c0022d95 <malloc+0xe4>
        return NULL;
c0022df7:	b8 00 00 00 00       	mov    $0x0,%eax
c0022dfc:	eb 97                	jmp    c0022d95 <malloc+0xe4>
    if (d->block_size >= size)
c0022dfe:	bb a0 7d 03 c0       	mov    $0xc0037da0,%ebx
c0022e03:	e9 fa fe ff ff       	jmp    c0022d02 <malloc+0x51>

c0022e08 <calloc>:
{
c0022e08:	57                   	push   %edi
c0022e09:	53                   	push   %ebx
c0022e0a:	83 ec 04             	sub    $0x4,%esp
c0022e0d:	8b 44 24 10          	mov    0x10(%esp),%eax
  size = a * b;
c0022e11:	89 c3                	mov    %eax,%ebx
c0022e13:	0f af 5c 24 14       	imul   0x14(%esp),%ebx
  if (size < a || size < b)
c0022e18:	39 d8                	cmp    %ebx,%eax
c0022e1a:	77 28                	ja     c0022e44 <calloc+0x3c>
c0022e1c:	39 5c 24 14          	cmp    %ebx,0x14(%esp)
c0022e20:	77 29                	ja     c0022e4b <calloc+0x43>
  p = malloc (size);
c0022e22:	83 ec 0c             	sub    $0xc,%esp
c0022e25:	53                   	push   %ebx
c0022e26:	e8 86 fe ff ff       	call   c0022cb1 <malloc>
c0022e2b:	89 c2                	mov    %eax,%edx
  if (p != NULL)
c0022e2d:	83 c4 10             	add    $0x10,%esp
c0022e30:	85 c0                	test   %eax,%eax
c0022e32:	74 08                	je     c0022e3c <calloc+0x34>
    memset (p, 0, size);
c0022e34:	b0 00                	mov    $0x0,%al
c0022e36:	89 d7                	mov    %edx,%edi
c0022e38:	89 d9                	mov    %ebx,%ecx
c0022e3a:	f3 aa                	rep stos %al,%es:(%edi)
}
c0022e3c:	89 d0                	mov    %edx,%eax
c0022e3e:	83 c4 04             	add    $0x4,%esp
c0022e41:	5b                   	pop    %ebx
c0022e42:	5f                   	pop    %edi
c0022e43:	c3                   	ret    
    return NULL;
c0022e44:	ba 00 00 00 00       	mov    $0x0,%edx
c0022e49:	eb f1                	jmp    c0022e3c <calloc+0x34>
c0022e4b:	ba 00 00 00 00       	mov    $0x0,%edx
c0022e50:	eb ea                	jmp    c0022e3c <calloc+0x34>

c0022e52 <free>:
{
c0022e52:	55                   	push   %ebp
c0022e53:	57                   	push   %edi
c0022e54:	56                   	push   %esi
c0022e55:	53                   	push   %ebx
c0022e56:	83 ec 0c             	sub    $0xc,%esp
c0022e59:	8b 6c 24 20          	mov    0x20(%esp),%ebp
  if (p != NULL)
c0022e5d:	85 ed                	test   %ebp,%ebp
c0022e5f:	0f 84 86 00 00 00    	je     c0022eeb <free+0x99>
      struct arena *a = block_to_arena (b);
c0022e65:	89 e8                	mov    %ebp,%eax
c0022e67:	e8 94 fc ff ff       	call   c0022b00 <block_to_arena>
c0022e6c:	89 c6                	mov    %eax,%esi
      struct desc *d = a->desc;
c0022e6e:	8b 58 04             	mov    0x4(%eax),%ebx
      if (d != NULL) 
c0022e71:	85 db                	test   %ebx,%ebx
c0022e73:	0f 84 9b 00 00 00    	je     c0022f14 <free+0xc2>
          memset (b, 0xcc, d->block_size);
c0022e79:	8b 0b                	mov    (%ebx),%ecx
c0022e7b:	b0 cc                	mov    $0xcc,%al
c0022e7d:	89 ef                	mov    %ebp,%edi
c0022e7f:	f3 aa                	rep stos %al,%es:(%edi)
          lock_acquire (&d->lock);
c0022e81:	8d 7b 18             	lea    0x18(%ebx),%edi
c0022e84:	83 ec 0c             	sub    $0xc,%esp
c0022e87:	57                   	push   %edi
c0022e88:	e8 d9 f4 ff ff       	call   c0022366 <lock_acquire>
          list_push_front (&d->free_list, &b->free_elem);
c0022e8d:	83 c4 08             	add    $0x8,%esp
c0022e90:	55                   	push   %ebp
c0022e91:	8d 43 08             	lea    0x8(%ebx),%eax
c0022e94:	50                   	push   %eax
c0022e95:	e8 cd 4c 00 00       	call   c0027b67 <list_push_front>
          if (++a->free_cnt >= d->blocks_per_arena) 
c0022e9a:	8b 46 08             	mov    0x8(%esi),%eax
c0022e9d:	40                   	inc    %eax
c0022e9e:	89 46 08             	mov    %eax,0x8(%esi)
c0022ea1:	8b 53 04             	mov    0x4(%ebx),%edx
c0022ea4:	83 c4 10             	add    $0x10,%esp
c0022ea7:	39 d0                	cmp    %edx,%eax
c0022ea9:	72 34                	jb     c0022edf <free+0x8d>
              ASSERT (a->free_cnt == d->blocks_per_arena);
c0022eab:	39 d0                	cmp    %edx,%eax
c0022ead:	75 44                	jne    c0022ef3 <free+0xa1>
              for (i = 0; i < d->blocks_per_arena; i++) 
c0022eaf:	bd 00 00 00 00       	mov    $0x0,%ebp
c0022eb4:	85 c0                	test   %eax,%eax
c0022eb6:	74 1b                	je     c0022ed3 <free+0x81>
                  struct block *b = arena_to_block (a, i);
c0022eb8:	89 ea                	mov    %ebp,%edx
c0022eba:	89 f0                	mov    %esi,%eax
c0022ebc:	e8 ba fb ff ff       	call   c0022a7b <arena_to_block>
                  list_remove (&b->free_elem);
c0022ec1:	83 ec 0c             	sub    $0xc,%esp
c0022ec4:	50                   	push   %eax
c0022ec5:	e8 d7 4c 00 00       	call   c0027ba1 <list_remove>
              for (i = 0; i < d->blocks_per_arena; i++) 
c0022eca:	45                   	inc    %ebp
c0022ecb:	83 c4 10             	add    $0x10,%esp
c0022ece:	39 6b 04             	cmp    %ebp,0x4(%ebx)
c0022ed1:	77 e5                	ja     c0022eb8 <free+0x66>
              palloc_free_page (a);
c0022ed3:	83 ec 0c             	sub    $0xc,%esp
c0022ed6:	56                   	push   %esi
c0022ed7:	e8 8d fb ff ff       	call   c0022a69 <palloc_free_page>
c0022edc:	83 c4 10             	add    $0x10,%esp
          lock_release (&d->lock);
c0022edf:	83 ec 0c             	sub    $0xc,%esp
c0022ee2:	57                   	push   %edi
c0022ee3:	e8 a3 f5 ff ff       	call   c002248b <lock_release>
c0022ee8:	83 c4 10             	add    $0x10,%esp
}
c0022eeb:	83 c4 0c             	add    $0xc,%esp
c0022eee:	5b                   	pop    %ebx
c0022eef:	5e                   	pop    %esi
c0022ef0:	5f                   	pop    %edi
c0022ef1:	5d                   	pop    %ebp
c0022ef2:	c3                   	ret    
              ASSERT (a->free_cnt == d->blocks_per_arena);
c0022ef3:	83 ec 0c             	sub    $0xc,%esp
c0022ef6:	68 ac d6 02 c0       	push   $0xc002d6ac
c0022efb:	68 df cb 02 c0       	push   $0xc002cbdf
c0022f00:	68 54 b7 02 c0       	push   $0xc002b754
c0022f05:	68 f6 00 00 00       	push   $0xf6
c0022f0a:	68 bd d5 02 c0       	push   $0xc002d5bd
c0022f0f:	e8 2c 47 00 00       	call   c0027640 <debug_panic>
          palloc_free_multiple (a, a->free_cnt);
c0022f14:	83 ec 08             	sub    $0x8,%esp
c0022f17:	ff 70 08             	pushl  0x8(%eax)
c0022f1a:	50                   	push   %eax
c0022f1b:	e8 31 fa ff ff       	call   c0022951 <palloc_free_multiple>
          return;
c0022f20:	83 c4 10             	add    $0x10,%esp
c0022f23:	eb c6                	jmp    c0022eeb <free+0x99>

c0022f25 <realloc>:
{
c0022f25:	55                   	push   %ebp
c0022f26:	57                   	push   %edi
c0022f27:	56                   	push   %esi
c0022f28:	53                   	push   %ebx
c0022f29:	83 ec 0c             	sub    $0xc,%esp
c0022f2c:	8b 5c 24 20          	mov    0x20(%esp),%ebx
c0022f30:	8b 74 24 24          	mov    0x24(%esp),%esi
  if (new_size == 0) 
c0022f34:	85 f6                	test   %esi,%esi
c0022f36:	74 4a                	je     c0022f82 <realloc+0x5d>
      void *new_block = malloc (new_size);
c0022f38:	83 ec 0c             	sub    $0xc,%esp
c0022f3b:	56                   	push   %esi
c0022f3c:	e8 70 fd ff ff       	call   c0022cb1 <malloc>
c0022f41:	89 c5                	mov    %eax,%ebp
      if (old_block != NULL && new_block != NULL)
c0022f43:	83 c4 10             	add    $0x10,%esp
c0022f46:	85 db                	test   %ebx,%ebx
c0022f48:	74 2e                	je     c0022f78 <realloc+0x53>
c0022f4a:	85 c0                	test   %eax,%eax
c0022f4c:	74 2a                	je     c0022f78 <realloc+0x53>
  struct arena *a = block_to_arena (b);
c0022f4e:	89 d8                	mov    %ebx,%eax
c0022f50:	e8 ab fb ff ff       	call   c0022b00 <block_to_arena>
  struct desc *d = a->desc;
c0022f55:	8b 50 04             	mov    0x4(%eax),%edx
  return d != NULL ? d->block_size : PGSIZE * a->free_cnt - pg_ofs (block);
c0022f58:	85 d2                	test   %edx,%edx
c0022f5a:	74 39                	je     c0022f95 <realloc+0x70>
c0022f5c:	8b 02                	mov    (%edx),%eax
          size_t min_size = new_size < old_size ? new_size : old_size;
c0022f5e:	89 f1                	mov    %esi,%ecx
c0022f60:	39 c6                	cmp    %eax,%esi
c0022f62:	76 02                	jbe    c0022f66 <realloc+0x41>
c0022f64:	89 c1                	mov    %eax,%ecx
          memcpy (new_block, old_block, min_size);
c0022f66:	89 ef                	mov    %ebp,%edi
c0022f68:	89 de                	mov    %ebx,%esi
c0022f6a:	f3 a4                	rep movsb %ds:(%esi),%es:(%edi)
          free (old_block);
c0022f6c:	83 ec 0c             	sub    $0xc,%esp
c0022f6f:	53                   	push   %ebx
c0022f70:	e8 dd fe ff ff       	call   c0022e52 <free>
c0022f75:	83 c4 10             	add    $0x10,%esp
}
c0022f78:	89 e8                	mov    %ebp,%eax
c0022f7a:	83 c4 0c             	add    $0xc,%esp
c0022f7d:	5b                   	pop    %ebx
c0022f7e:	5e                   	pop    %esi
c0022f7f:	5f                   	pop    %edi
c0022f80:	5d                   	pop    %ebp
c0022f81:	c3                   	ret    
      free (old_block);
c0022f82:	83 ec 0c             	sub    $0xc,%esp
c0022f85:	53                   	push   %ebx
c0022f86:	e8 c7 fe ff ff       	call   c0022e52 <free>
      return NULL;
c0022f8b:	83 c4 10             	add    $0x10,%esp
c0022f8e:	bd 00 00 00 00       	mov    $0x0,%ebp
c0022f93:	eb e3                	jmp    c0022f78 <realloc+0x53>
  return d != NULL ? d->block_size : PGSIZE * a->free_cnt - pg_ofs (block);
c0022f95:	8b 40 08             	mov    0x8(%eax),%eax
c0022f98:	c1 e0 0c             	shl    $0xc,%eax
c0022f9b:	89 da                	mov    %ebx,%edx
c0022f9d:	81 e2 ff 0f 00 00    	and    $0xfff,%edx
c0022fa3:	29 d0                	sub    %edx,%eax
c0022fa5:	eb b7                	jmp    c0022f5e <realloc+0x39>

c0022fa7 <pit_configure_channel>:
     - Other modes are less useful.

   FREQUENCY is the number of periods per second, in Hz. */
void
pit_configure_channel (int channel, int mode, int frequency)
{
c0022fa7:	57                   	push   %edi
c0022fa8:	56                   	push   %esi
c0022fa9:	53                   	push   %ebx
c0022faa:	8b 74 24 10          	mov    0x10(%esp),%esi
c0022fae:	8b 5c 24 14          	mov    0x14(%esp),%ebx
c0022fb2:	8b 4c 24 18          	mov    0x18(%esp),%ecx
  uint16_t count;
  enum intr_level old_level;

  ASSERT (channel == 0 || channel == 2);
c0022fb6:	f7 c6 fd ff ff ff    	test   $0xfffffffd,%esi
c0022fbc:	74 1e                	je     c0022fdc <pit_configure_channel+0x35>
c0022fbe:	83 ec 0c             	sub    $0xc,%esp
c0022fc1:	68 cf d6 02 c0       	push   $0xc002d6cf
c0022fc6:	68 df cb 02 c0       	push   $0xc002cbdf
c0022fcb:	68 88 b7 02 c0       	push   $0xc002b788
c0022fd0:	6a 33                	push   $0x33
c0022fd2:	68 ec d6 02 c0       	push   $0xc002d6ec
c0022fd7:	e8 64 46 00 00       	call   c0027640 <debug_panic>
  ASSERT (mode == 2 || mode == 3);
c0022fdc:	8d 43 fe             	lea    -0x2(%ebx),%eax
c0022fdf:	83 f8 01             	cmp    $0x1,%eax
c0022fe2:	77 22                	ja     c0023006 <pit_configure_channel+0x5f>

  /* Convert FREQUENCY to a PIT counter value.  The PIT has a
     clock that runs at PIT_HZ cycles per second.  We must
     translate FREQUENCY into a number of these cycles. */
  if (frequency < 19)
c0022fe4:	83 f9 12             	cmp    $0x12,%ecx
c0022fe7:	7e 3b                	jle    c0023024 <pit_configure_channel+0x7d>
         16-bit counter.  Force it to 0, which the PIT treats as
         65536, the highest possible count.  This yields a 18.2
         Hz timer, approximately. */
      count = 0;
    }
  else if (frequency > PIT_HZ)
c0022fe9:	81 f9 dc 34 12 00    	cmp    $0x1234dc,%ecx
c0022fef:	7f 6b                	jg     c002305c <pit_configure_channel+0xb5>
         a 596.590 kHz timer, approximately.  (This timer rate is
         probably too fast to be useful anyhow.) */
      count = 2;
    }
  else
    count = (PIT_HZ + frequency / 2) / frequency;
c0022ff1:	89 c8                	mov    %ecx,%eax
c0022ff3:	c1 e8 1f             	shr    $0x1f,%eax
c0022ff6:	01 c8                	add    %ecx,%eax
c0022ff8:	d1 f8                	sar    %eax
c0022ffa:	05 dc 34 12 00       	add    $0x1234dc,%eax
c0022fff:	99                   	cltd   
c0023000:	f7 f9                	idiv   %ecx
c0023002:	89 c7                	mov    %eax,%edi
c0023004:	eb 23                	jmp    c0023029 <pit_configure_channel+0x82>
  ASSERT (mode == 2 || mode == 3);
c0023006:	83 ec 0c             	sub    $0xc,%esp
c0023009:	68 00 d7 02 c0       	push   $0xc002d700
c002300e:	68 df cb 02 c0       	push   $0xc002cbdf
c0023013:	68 88 b7 02 c0       	push   $0xc002b788
c0023018:	6a 34                	push   $0x34
c002301a:	68 ec d6 02 c0       	push   $0xc002d6ec
c002301f:	e8 1c 46 00 00       	call   c0027640 <debug_panic>
      count = 0;
c0023024:	bf 00 00 00 00       	mov    $0x0,%edi

  /* Configure the PIT mode and load its counters. */
  old_level = intr_disable ();
c0023029:	e8 55 e0 ff ff       	call   c0021083 <intr_disable>
c002302e:	89 c1                	mov    %eax,%ecx
  outb (PIT_PORT_CONTROL, (channel << 6) | 0x30 | (mode << 1));
c0023030:	8d 04 1b             	lea    (%ebx,%ebx,1),%eax
c0023033:	83 c8 30             	or     $0x30,%eax
c0023036:	89 f3                	mov    %esi,%ebx
c0023038:	c1 e3 06             	shl    $0x6,%ebx
c002303b:	09 d8                	or     %ebx,%eax
c002303d:	e6 43                	out    %al,$0x43
  outb (PIT_PORT_COUNTER (channel), count);
c002303f:	8d 56 40             	lea    0x40(%esi),%edx
c0023042:	89 f8                	mov    %edi,%eax
c0023044:	ee                   	out    %al,(%dx)
  outb (PIT_PORT_COUNTER (channel), count >> 8);
c0023045:	89 f8                	mov    %edi,%eax
c0023047:	66 c1 e8 08          	shr    $0x8,%ax
c002304b:	ee                   	out    %al,(%dx)
  intr_set_level (old_level);
c002304c:	83 ec 0c             	sub    $0xc,%esp
c002304f:	51                   	push   %ecx
c0023050:	e8 35 e0 ff ff       	call   c002108a <intr_set_level>
}
c0023055:	83 c4 10             	add    $0x10,%esp
c0023058:	5b                   	pop    %ebx
c0023059:	5e                   	pop    %esi
c002305a:	5f                   	pop    %edi
c002305b:	c3                   	ret    
      count = 2;
c002305c:	bf 02 00 00 00       	mov    $0x2,%edi
c0023061:	eb c6                	jmp    c0023029 <pit_configure_channel+0x82>

c0023063 <busy_wait>:
   affect timings, so that if this function was inlined
   differently in different places the results would be difficult
   to predict. */
static void NO_INLINE
busy_wait (int64_t loops) 
{
c0023063:	53                   	push   %ebx
  while (loops-- > 0)
c0023064:	89 c1                	mov    %eax,%ecx
c0023066:	89 d3                	mov    %edx,%ebx
c0023068:	83 c1 ff             	add    $0xffffffff,%ecx
c002306b:	83 d3 ff             	adc    $0xffffffff,%ebx
c002306e:	85 d2                	test   %edx,%edx
c0023070:	78 13                	js     c0023085 <busy_wait+0x22>
c0023072:	85 d2                	test   %edx,%edx
c0023074:	7e 11                	jle    c0023087 <busy_wait+0x24>
c0023076:	83 c1 ff             	add    $0xffffffff,%ecx
c0023079:	83 d3 ff             	adc    $0xffffffff,%ebx
c002307c:	89 d8                	mov    %ebx,%eax
c002307e:	21 c8                	and    %ecx,%eax
c0023080:	83 f8 ff             	cmp    $0xffffffff,%eax
c0023083:	75 f1                	jne    c0023076 <busy_wait+0x13>
    barrier ();
}
c0023085:	5b                   	pop    %ebx
c0023086:	c3                   	ret    
  while (loops-- > 0)
c0023087:	83 f8 00             	cmp    $0x0,%eax
c002308a:	76 f9                	jbe    c0023085 <busy_wait+0x22>
c002308c:	eb e8                	jmp    c0023076 <busy_wait+0x13>

c002308e <too_many_loops>:
{
c002308e:	55                   	push   %ebp
c002308f:	57                   	push   %edi
c0023090:	56                   	push   %esi
c0023091:	53                   	push   %ebx
c0023092:	83 ec 04             	sub    $0x4,%esp
  int64_t start = ticks;
c0023095:	8b 2d 88 7f 03 c0    	mov    0xc0037f88,%ebp
c002309b:	8b 3d 8c 7f 03 c0    	mov    0xc0037f8c,%edi
  while (ticks == start)
c00230a1:	8b 35 88 7f 03 c0    	mov    0xc0037f88,%esi
c00230a7:	8b 1d 8c 7f 03 c0    	mov    0xc0037f8c,%ebx
c00230ad:	89 ea                	mov    %ebp,%edx
c00230af:	31 f2                	xor    %esi,%edx
c00230b1:	89 f9                	mov    %edi,%ecx
c00230b3:	31 d9                	xor    %ebx,%ecx
c00230b5:	09 d1                	or     %edx,%ecx
c00230b7:	74 e8                	je     c00230a1 <too_many_loops+0x13>
  busy_wait (loops);
c00230b9:	ba 00 00 00 00       	mov    $0x0,%edx
c00230be:	e8 a0 ff ff ff       	call   c0023063 <busy_wait>
  return start != ticks;
c00230c3:	33 35 88 7f 03 c0    	xor    0xc0037f88,%esi
c00230c9:	33 1d 8c 7f 03 c0    	xor    0xc0037f8c,%ebx
c00230cf:	09 de                	or     %ebx,%esi
c00230d1:	0f 95 c0             	setne  %al
}
c00230d4:	83 c4 04             	add    $0x4,%esp
c00230d7:	5b                   	pop    %ebx
c00230d8:	5e                   	pop    %esi
c00230d9:	5f                   	pop    %edi
c00230da:	5d                   	pop    %ebp
c00230db:	c3                   	ret    

c00230dc <timer_interrupt>:
{
c00230dc:	83 ec 0c             	sub    $0xc,%esp
  ticks++;
c00230df:	83 05 88 7f 03 c0 01 	addl   $0x1,0xc0037f88
c00230e6:	83 15 8c 7f 03 c0 00 	adcl   $0x0,0xc0037f8c
  thread_tick ();
c00230ed:	e8 c0 d9 ff ff       	call   c0020ab2 <thread_tick>
}
c00230f2:	83 c4 0c             	add    $0xc,%esp
c00230f5:	c3                   	ret    

c00230f6 <real_time_delay>:
}

/* Busy-wait for approximately NUM/DENOM seconds. */
static void
real_time_delay (int64_t num, int32_t denom)
{
c00230f6:	57                   	push   %edi
c00230f7:	56                   	push   %esi
c00230f8:	53                   	push   %ebx
c00230f9:	89 c6                	mov    %eax,%esi
c00230fb:	89 d7                	mov    %edx,%edi
c00230fd:	89 cb                	mov    %ecx,%ebx
  /* Scale the numerator and denominator down by 1000 to avoid
     the possibility of overflow. */
  ASSERT (denom % 1000 == 0);
c00230ff:	b9 e8 03 00 00       	mov    $0x3e8,%ecx
c0023104:	89 d8                	mov    %ebx,%eax
c0023106:	99                   	cltd   
c0023107:	f7 f9                	idiv   %ecx
c0023109:	85 d2                	test   %edx,%edx
c002310b:	75 5c                	jne    c0023169 <real_time_delay+0x73>
  busy_wait (loops_per_tick * num / 1000 * TIMER_FREQ / (denom / 1000)); 
c002310d:	a1 80 7f 03 c0       	mov    0xc0037f80,%eax
c0023112:	0f af f8             	imul   %eax,%edi
c0023115:	f7 e6                	mul    %esi
c0023117:	01 fa                	add    %edi,%edx
c0023119:	6a 00                	push   $0x0
c002311b:	68 e8 03 00 00       	push   $0x3e8
c0023120:	52                   	push   %edx
c0023121:	50                   	push   %eax
c0023122:	e8 33 3f 00 00       	call   c002705a <__divdi3>
c0023127:	83 c4 10             	add    $0x10,%esp
c002312a:	89 c6                	mov    %eax,%esi
c002312c:	6b ca 64             	imul   $0x64,%edx,%ecx
c002312f:	bf 64 00 00 00       	mov    $0x64,%edi
c0023134:	89 f8                	mov    %edi,%eax
c0023136:	f7 e6                	mul    %esi
c0023138:	89 c6                	mov    %eax,%esi
c002313a:	89 d7                	mov    %edx,%edi
c002313c:	01 cf                	add    %ecx,%edi
c002313e:	b9 d3 4d 62 10       	mov    $0x10624dd3,%ecx
c0023143:	89 c8                	mov    %ecx,%eax
c0023145:	f7 eb                	imul   %ebx
c0023147:	89 d1                	mov    %edx,%ecx
c0023149:	89 c8                	mov    %ecx,%eax
c002314b:	c1 f8 06             	sar    $0x6,%eax
c002314e:	c1 fb 1f             	sar    $0x1f,%ebx
c0023151:	29 d8                	sub    %ebx,%eax
c0023153:	99                   	cltd   
c0023154:	52                   	push   %edx
c0023155:	50                   	push   %eax
c0023156:	57                   	push   %edi
c0023157:	56                   	push   %esi
c0023158:	e8 fd 3e 00 00       	call   c002705a <__divdi3>
c002315d:	83 c4 10             	add    $0x10,%esp
c0023160:	e8 fe fe ff ff       	call   c0023063 <busy_wait>
}
c0023165:	5b                   	pop    %ebx
c0023166:	5e                   	pop    %esi
c0023167:	5f                   	pop    %edi
c0023168:	c3                   	ret    
  ASSERT (denom % 1000 == 0);
c0023169:	83 ec 0c             	sub    $0xc,%esp
c002316c:	68 17 d7 02 c0       	push   $0xc002d717
c0023171:	68 df cb 02 c0       	push   $0xc002cbdf
c0023176:	68 a0 b7 02 c0       	push   $0xc002b7a0
c002317b:	68 f4 00 00 00       	push   $0xf4
c0023180:	68 29 d7 02 c0       	push   $0xc002d729
c0023185:	e8 b6 44 00 00       	call   c0027640 <debug_panic>

c002318a <timer_init>:
{
c002318a:	83 ec 10             	sub    $0x10,%esp
  pit_configure_channel (0, 2, TIMER_FREQ);
c002318d:	6a 64                	push   $0x64
c002318f:	6a 02                	push   $0x2
c0023191:	6a 00                	push   $0x0
c0023193:	e8 0f fe ff ff       	call   c0022fa7 <pit_configure_channel>
  intr_register_ext (0x20, timer_interrupt, "8254 Timer");
c0023198:	83 c4 0c             	add    $0xc,%esp
c002319b:	68 3f d7 02 c0       	push   $0xc002d73f
c00231a0:	68 dc 30 02 c0       	push   $0xc00230dc
c00231a5:	6a 20                	push   $0x20
c00231a7:	e8 58 e0 ff ff       	call   c0021204 <intr_register_ext>
}
c00231ac:	83 c4 1c             	add    $0x1c,%esp
c00231af:	c3                   	ret    

c00231b0 <timer_calibrate>:
{
c00231b0:	57                   	push   %edi
c00231b1:	56                   	push   %esi
c00231b2:	53                   	push   %ebx
  ASSERT (intr_get_level () == INTR_ON);
c00231b3:	e8 8e de ff ff       	call   c0021046 <intr_get_level>
c00231b8:	83 f8 01             	cmp    $0x1,%eax
c00231bb:	75 56                	jne    c0023213 <timer_calibrate+0x63>
  printf ("Calibrating timer...  ");
c00231bd:	83 ec 0c             	sub    $0xc,%esp
c00231c0:	68 67 d7 02 c0       	push   $0xc002d767
c00231c5:	e8 c8 29 00 00       	call   c0025b92 <printf>
  loops_per_tick = 1u << 10;
c00231ca:	c7 05 80 7f 03 c0 00 	movl   $0x400,0xc0037f80
c00231d1:	04 00 00 
  while (!too_many_loops (loops_per_tick << 1)) 
c00231d4:	83 c4 10             	add    $0x10,%esp
c00231d7:	8b 35 80 7f 03 c0    	mov    0xc0037f80,%esi
c00231dd:	8d 1c 36             	lea    (%esi,%esi,1),%ebx
c00231e0:	89 d8                	mov    %ebx,%eax
c00231e2:	e8 a7 fe ff ff       	call   c002308e <too_many_loops>
c00231e7:	84 c0                	test   %al,%al
c00231e9:	75 46                	jne    c0023231 <timer_calibrate+0x81>
      loops_per_tick <<= 1;
c00231eb:	89 1d 80 7f 03 c0    	mov    %ebx,0xc0037f80
      ASSERT (loops_per_tick != 0);
c00231f1:	85 db                	test   %ebx,%ebx
c00231f3:	75 e2                	jne    c00231d7 <timer_calibrate+0x27>
c00231f5:	83 ec 0c             	sub    $0xc,%esp
c00231f8:	68 7e d7 02 c0       	push   $0xc002d77e
c00231fd:	68 df cb 02 c0       	push   $0xc002cbdf
c0023202:	68 cc b7 02 c0       	push   $0xc002b7cc
c0023207:	6a 39                	push   $0x39
c0023209:	68 29 d7 02 c0       	push   $0xc002d729
c002320e:	e8 2d 44 00 00       	call   c0027640 <debug_panic>
  ASSERT (intr_get_level () == INTR_ON);
c0023213:	83 ec 0c             	sub    $0xc,%esp
c0023216:	68 4a d7 02 c0       	push   $0xc002d74a
c002321b:	68 df cb 02 c0       	push   $0xc002cbdf
c0023220:	68 cc b7 02 c0       	push   $0xc002b7cc
c0023225:	6a 30                	push   $0x30
c0023227:	68 29 d7 02 c0       	push   $0xc002d729
c002322c:	e8 0f 44 00 00       	call   c0027640 <debug_panic>
  for (test_bit = high_bit >> 1; test_bit != high_bit >> 10; test_bit >>= 1)
c0023231:	89 f3                	mov    %esi,%ebx
c0023233:	d1 eb                	shr    %ebx
c0023235:	89 f7                	mov    %esi,%edi
c0023237:	c1 ef 0a             	shr    $0xa,%edi
c002323a:	39 df                	cmp    %ebx,%edi
c002323c:	75 27                	jne    c0023265 <timer_calibrate+0xb5>
  printf ("%'"PRIu64" loops/s.\n", (uint64_t) loops_per_tick * TIMER_FREQ);
c002323e:	83 ec 04             	sub    $0x4,%esp
c0023241:	b8 64 00 00 00       	mov    $0x64,%eax
c0023246:	f7 25 80 7f 03 c0    	mull   0xc0037f80
c002324c:	52                   	push   %edx
c002324d:	50                   	push   %eax
c002324e:	68 92 d7 02 c0       	push   $0xc002d792
c0023253:	e8 3a 29 00 00       	call   c0025b92 <printf>
}
c0023258:	83 c4 10             	add    $0x10,%esp
c002325b:	5b                   	pop    %ebx
c002325c:	5e                   	pop    %esi
c002325d:	5f                   	pop    %edi
c002325e:	c3                   	ret    
  for (test_bit = high_bit >> 1; test_bit != high_bit >> 10; test_bit >>= 1)
c002325f:	d1 eb                	shr    %ebx
c0023261:	39 df                	cmp    %ebx,%edi
c0023263:	74 d9                	je     c002323e <timer_calibrate+0x8e>
    if (!too_many_loops (high_bit | test_bit))
c0023265:	89 f0                	mov    %esi,%eax
c0023267:	09 d8                	or     %ebx,%eax
c0023269:	e8 20 fe ff ff       	call   c002308e <too_many_loops>
c002326e:	84 c0                	test   %al,%al
c0023270:	75 ed                	jne    c002325f <timer_calibrate+0xaf>
      loops_per_tick |= test_bit;
c0023272:	09 1d 80 7f 03 c0    	or     %ebx,0xc0037f80
c0023278:	eb e5                	jmp    c002325f <timer_calibrate+0xaf>

c002327a <timer_ticks>:
{
c002327a:	57                   	push   %edi
c002327b:	56                   	push   %esi
c002327c:	83 ec 04             	sub    $0x4,%esp
  enum intr_level old_level = intr_disable ();
c002327f:	e8 ff dd ff ff       	call   c0021083 <intr_disable>
  int64_t t = ticks;
c0023284:	8b 35 88 7f 03 c0    	mov    0xc0037f88,%esi
c002328a:	8b 3d 8c 7f 03 c0    	mov    0xc0037f8c,%edi
  intr_set_level (old_level);
c0023290:	83 ec 0c             	sub    $0xc,%esp
c0023293:	50                   	push   %eax
c0023294:	e8 f1 dd ff ff       	call   c002108a <intr_set_level>
}
c0023299:	89 f0                	mov    %esi,%eax
c002329b:	89 fa                	mov    %edi,%edx
c002329d:	83 c4 14             	add    $0x14,%esp
c00232a0:	5e                   	pop    %esi
c00232a1:	5f                   	pop    %edi
c00232a2:	c3                   	ret    

c00232a3 <timer_elapsed>:
{
c00232a3:	57                   	push   %edi
c00232a4:	56                   	push   %esi
c00232a5:	83 ec 04             	sub    $0x4,%esp
c00232a8:	8b 74 24 10          	mov    0x10(%esp),%esi
c00232ac:	8b 7c 24 14          	mov    0x14(%esp),%edi
  return timer_ticks () - then;
c00232b0:	e8 c5 ff ff ff       	call   c002327a <timer_ticks>
c00232b5:	29 f0                	sub    %esi,%eax
c00232b7:	19 fa                	sbb    %edi,%edx
}
c00232b9:	83 c4 04             	add    $0x4,%esp
c00232bc:	5e                   	pop    %esi
c00232bd:	5f                   	pop    %edi
c00232be:	c3                   	ret    

c00232bf <timer_sleep>:
{
c00232bf:	55                   	push   %ebp
c00232c0:	57                   	push   %edi
c00232c1:	56                   	push   %esi
c00232c2:	53                   	push   %ebx
c00232c3:	83 ec 0c             	sub    $0xc,%esp
c00232c6:	8b 6c 24 20          	mov    0x20(%esp),%ebp
c00232ca:	8b 5c 24 24          	mov    0x24(%esp),%ebx
  int64_t start = timer_ticks ();
c00232ce:	e8 a7 ff ff ff       	call   c002327a <timer_ticks>
c00232d3:	89 c6                	mov    %eax,%esi
c00232d5:	89 d7                	mov    %edx,%edi
  ASSERT (intr_get_level () == INTR_ON);
c00232d7:	e8 6a dd ff ff       	call   c0021046 <intr_get_level>
c00232dc:	83 f8 01             	cmp    $0x1,%eax
c00232df:	74 23                	je     c0023304 <timer_sleep+0x45>
c00232e1:	83 ec 0c             	sub    $0xc,%esp
c00232e4:	68 4a d7 02 c0       	push   $0xc002d74a
c00232e9:	68 df cb 02 c0       	push   $0xc002cbdf
c00232ee:	68 c0 b7 02 c0       	push   $0xc002b7c0
c00232f3:	6a 5e                	push   $0x5e
c00232f5:	68 29 d7 02 c0       	push   $0xc002d729
c00232fa:	e8 41 43 00 00       	call   c0027640 <debug_panic>
    thread_yield ();
c00232ff:	e8 7d db ff ff       	call   c0020e81 <thread_yield>
  return timer_ticks () - then;
c0023304:	e8 71 ff ff ff       	call   c002327a <timer_ticks>
c0023309:	29 f0                	sub    %esi,%eax
c002330b:	19 fa                	sbb    %edi,%edx
  while (timer_elapsed (start) < ticks) 
c002330d:	39 d3                	cmp    %edx,%ebx
c002330f:	7f ee                	jg     c00232ff <timer_sleep+0x40>
c0023311:	7c 04                	jl     c0023317 <timer_sleep+0x58>
c0023313:	39 c5                	cmp    %eax,%ebp
c0023315:	77 e8                	ja     c00232ff <timer_sleep+0x40>
}
c0023317:	83 c4 0c             	add    $0xc,%esp
c002331a:	5b                   	pop    %ebx
c002331b:	5e                   	pop    %esi
c002331c:	5f                   	pop    %edi
c002331d:	5d                   	pop    %ebp
c002331e:	c3                   	ret    

c002331f <real_time_sleep>:
{
c002331f:	55                   	push   %ebp
c0023320:	57                   	push   %edi
c0023321:	56                   	push   %esi
c0023322:	53                   	push   %ebx
c0023323:	83 ec 1c             	sub    $0x1c,%esp
c0023326:	89 c6                	mov    %eax,%esi
c0023328:	89 44 24 08          	mov    %eax,0x8(%esp)
c002332c:	89 54 24 0c          	mov    %edx,0xc(%esp)
c0023330:	89 cd                	mov    %ecx,%ebp
  int64_t ticks = num * TIMER_FREQ / denom;
c0023332:	6b fa 64             	imul   $0x64,%edx,%edi
c0023335:	b9 64 00 00 00       	mov    $0x64,%ecx
c002333a:	89 c8                	mov    %ecx,%eax
c002333c:	f7 e6                	mul    %esi
c002333e:	89 c1                	mov    %eax,%ecx
c0023340:	89 d3                	mov    %edx,%ebx
c0023342:	01 fb                	add    %edi,%ebx
c0023344:	89 e8                	mov    %ebp,%eax
c0023346:	99                   	cltd   
c0023347:	52                   	push   %edx
c0023348:	55                   	push   %ebp
c0023349:	53                   	push   %ebx
c002334a:	51                   	push   %ecx
c002334b:	e8 0a 3d 00 00       	call   c002705a <__divdi3>
c0023350:	83 c4 10             	add    $0x10,%esp
c0023353:	89 c6                	mov    %eax,%esi
c0023355:	89 d7                	mov    %edx,%edi
  ASSERT (intr_get_level () == INTR_ON);
c0023357:	e8 ea dc ff ff       	call   c0021046 <intr_get_level>
c002335c:	83 f8 01             	cmp    $0x1,%eax
c002335f:	75 1d                	jne    c002337e <real_time_sleep+0x5f>
  if (ticks > 0)
c0023361:	85 ff                	test   %edi,%edi
c0023363:	78 3f                	js     c00233a4 <real_time_sleep+0x85>
c0023365:	85 ff                	test   %edi,%edi
c0023367:	7e 36                	jle    c002339f <real_time_sleep+0x80>
      timer_sleep (ticks); 
c0023369:	83 ec 08             	sub    $0x8,%esp
c002336c:	57                   	push   %edi
c002336d:	56                   	push   %esi
c002336e:	e8 4c ff ff ff       	call   c00232bf <timer_sleep>
c0023373:	83 c4 10             	add    $0x10,%esp
}
c0023376:	83 c4 1c             	add    $0x1c,%esp
c0023379:	5b                   	pop    %ebx
c002337a:	5e                   	pop    %esi
c002337b:	5f                   	pop    %edi
c002337c:	5d                   	pop    %ebp
c002337d:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_ON);
c002337e:	83 ec 0c             	sub    $0xc,%esp
c0023381:	68 4a d7 02 c0       	push   $0xc002d74a
c0023386:	68 df cb 02 c0       	push   $0xc002cbdf
c002338b:	68 b0 b7 02 c0       	push   $0xc002b7b0
c0023390:	68 de 00 00 00       	push   $0xde
c0023395:	68 29 d7 02 c0       	push   $0xc002d729
c002339a:	e8 a1 42 00 00       	call   c0027640 <debug_panic>
  if (ticks > 0)
c002339f:	83 fe 00             	cmp    $0x0,%esi
c00233a2:	77 c5                	ja     c0023369 <real_time_sleep+0x4a>
      real_time_delay (num, denom); 
c00233a4:	89 e9                	mov    %ebp,%ecx
c00233a6:	8b 44 24 08          	mov    0x8(%esp),%eax
c00233aa:	8b 54 24 0c          	mov    0xc(%esp),%edx
c00233ae:	e8 43 fd ff ff       	call   c00230f6 <real_time_delay>
}
c00233b3:	eb c1                	jmp    c0023376 <real_time_sleep+0x57>

c00233b5 <timer_msleep>:
{
c00233b5:	83 ec 0c             	sub    $0xc,%esp
  real_time_sleep (ms, 1000);
c00233b8:	b9 e8 03 00 00       	mov    $0x3e8,%ecx
c00233bd:	8b 44 24 10          	mov    0x10(%esp),%eax
c00233c1:	8b 54 24 14          	mov    0x14(%esp),%edx
c00233c5:	e8 55 ff ff ff       	call   c002331f <real_time_sleep>
}
c00233ca:	83 c4 0c             	add    $0xc,%esp
c00233cd:	c3                   	ret    

c00233ce <timer_usleep>:
{
c00233ce:	83 ec 0c             	sub    $0xc,%esp
  real_time_sleep (us, 1000 * 1000);
c00233d1:	b9 40 42 0f 00       	mov    $0xf4240,%ecx
c00233d6:	8b 44 24 10          	mov    0x10(%esp),%eax
c00233da:	8b 54 24 14          	mov    0x14(%esp),%edx
c00233de:	e8 3c ff ff ff       	call   c002331f <real_time_sleep>
}
c00233e3:	83 c4 0c             	add    $0xc,%esp
c00233e6:	c3                   	ret    

c00233e7 <timer_nsleep>:
{
c00233e7:	83 ec 0c             	sub    $0xc,%esp
  real_time_sleep (ns, 1000 * 1000 * 1000);
c00233ea:	b9 00 ca 9a 3b       	mov    $0x3b9aca00,%ecx
c00233ef:	8b 44 24 10          	mov    0x10(%esp),%eax
c00233f3:	8b 54 24 14          	mov    0x14(%esp),%edx
c00233f7:	e8 23 ff ff ff       	call   c002331f <real_time_sleep>
}
c00233fc:	83 c4 0c             	add    $0xc,%esp
c00233ff:	c3                   	ret    

c0023400 <timer_mdelay>:
{
c0023400:	83 ec 0c             	sub    $0xc,%esp
  real_time_delay (ms, 1000);
c0023403:	b9 e8 03 00 00       	mov    $0x3e8,%ecx
c0023408:	8b 44 24 10          	mov    0x10(%esp),%eax
c002340c:	8b 54 24 14          	mov    0x14(%esp),%edx
c0023410:	e8 e1 fc ff ff       	call   c00230f6 <real_time_delay>
}
c0023415:	83 c4 0c             	add    $0xc,%esp
c0023418:	c3                   	ret    

c0023419 <timer_udelay>:
{
c0023419:	83 ec 0c             	sub    $0xc,%esp
  real_time_delay (us, 1000 * 1000);
c002341c:	b9 40 42 0f 00       	mov    $0xf4240,%ecx
c0023421:	8b 44 24 10          	mov    0x10(%esp),%eax
c0023425:	8b 54 24 14          	mov    0x14(%esp),%edx
c0023429:	e8 c8 fc ff ff       	call   c00230f6 <real_time_delay>
}
c002342e:	83 c4 0c             	add    $0xc,%esp
c0023431:	c3                   	ret    

c0023432 <timer_ndelay>:
{
c0023432:	83 ec 0c             	sub    $0xc,%esp
  real_time_delay (ns, 1000 * 1000 * 1000);
c0023435:	b9 00 ca 9a 3b       	mov    $0x3b9aca00,%ecx
c002343a:	8b 44 24 10          	mov    0x10(%esp),%eax
c002343e:	8b 54 24 14          	mov    0x14(%esp),%edx
c0023442:	e8 af fc ff ff       	call   c00230f6 <real_time_delay>
}
c0023447:	83 c4 0c             	add    $0xc,%esp
c002344a:	c3                   	ret    

c002344b <timer_print_stats>:
{
c002344b:	83 ec 0c             	sub    $0xc,%esp
  printf ("Timer: %"PRId64" ticks\n", timer_ticks ());
c002344e:	e8 27 fe ff ff       	call   c002327a <timer_ticks>
c0023453:	83 ec 04             	sub    $0x4,%esp
c0023456:	52                   	push   %edx
c0023457:	50                   	push   %eax
c0023458:	68 a2 d7 02 c0       	push   $0xc002d7a2
c002345d:	e8 30 27 00 00       	call   c0025b92 <printf>
}
c0023462:	83 c4 1c             	add    $0x1c,%esp
c0023465:	c3                   	ret    

c0023466 <map_key>:
   If found, sets *C to the corresponding character and returns
   true.
   If not found, returns false and C is ignored. */
static bool
map_key (const struct keymap k[], unsigned scancode, uint8_t *c) 
{
c0023466:	55                   	push   %ebp
c0023467:	57                   	push   %edi
c0023468:	56                   	push   %esi
c0023469:	53                   	push   %ebx
c002346a:	83 ec 08             	sub    $0x8,%esp
c002346d:	89 0c 24             	mov    %ecx,(%esp)
  for (; k->first_scancode != 0; k++)
c0023470:	8a 18                	mov    (%eax),%bl
c0023472:	84 db                	test   %bl,%bl
c0023474:	74 49                	je     c00234bf <map_key+0x59>
c0023476:	89 c6                	mov    %eax,%esi
    if (scancode >= k->first_scancode
        && scancode < k->first_scancode + strlen (k->chars)) 
c0023478:	b0 00                	mov    $0x0,%al
c002347a:	eb 09                	jmp    c0023485 <map_key+0x1f>
  for (; k->first_scancode != 0; k++)
c002347c:	83 c6 08             	add    $0x8,%esi
c002347f:	8a 1e                	mov    (%esi),%bl
c0023481:	84 db                	test   %bl,%bl
c0023483:	74 30                	je     c00234b5 <map_key+0x4f>
    if (scancode >= k->first_scancode
c0023485:	0f b6 db             	movzbl %bl,%ebx
c0023488:	39 d3                	cmp    %edx,%ebx
c002348a:	77 f0                	ja     c002347c <map_key+0x16>
        && scancode < k->first_scancode + strlen (k->chars)) 
c002348c:	8b 6e 04             	mov    0x4(%esi),%ebp
c002348f:	b9 ff ff ff ff       	mov    $0xffffffff,%ecx
c0023494:	89 ef                	mov    %ebp,%edi
c0023496:	f2 ae                	repnz scas %es:(%edi),%al
c0023498:	f7 d1                	not    %ecx
c002349a:	8d 4c 0b ff          	lea    -0x1(%ebx,%ecx,1),%ecx
c002349e:	39 ca                	cmp    %ecx,%edx
c00234a0:	73 da                	jae    c002347c <map_key+0x16>
      {
        *c = k->chars[scancode - k->first_scancode];
c00234a2:	29 da                	sub    %ebx,%edx
c00234a4:	8a 44 15 00          	mov    0x0(%ebp,%edx,1),%al
c00234a8:	88 44 24 07          	mov    %al,0x7(%esp)
c00234ac:	8b 3c 24             	mov    (%esp),%edi
c00234af:	88 07                	mov    %al,(%edi)
        return true; 
c00234b1:	b0 01                	mov    $0x1,%al
c00234b3:	eb 02                	jmp    c00234b7 <map_key+0x51>
      }

  return false;
c00234b5:	b0 00                	mov    $0x0,%al
}
c00234b7:	83 c4 08             	add    $0x8,%esp
c00234ba:	5b                   	pop    %ebx
c00234bb:	5e                   	pop    %esi
c00234bc:	5f                   	pop    %edi
c00234bd:	5d                   	pop    %ebp
c00234be:	c3                   	ret    
  return false;
c00234bf:	b0 00                	mov    $0x0,%al
c00234c1:	eb f4                	jmp    c00234b7 <map_key+0x51>

c00234c3 <keyboard_interrupt>:
{
c00234c3:	55                   	push   %ebp
c00234c4:	57                   	push   %edi
c00234c5:	56                   	push   %esi
c00234c6:	53                   	push   %ebx
c00234c7:	83 ec 2c             	sub    $0x2c,%esp
  bool shift = left_shift || right_shift;
c00234ca:	a0 9e 7f 03 c0       	mov    0xc0037f9e,%al
c00234cf:	89 c7                	mov    %eax,%edi
c00234d1:	84 c0                	test   %al,%al
c00234d3:	75 07                	jne    c00234dc <keyboard_interrupt+0x19>
c00234d5:	a0 9d 7f 03 c0       	mov    0xc0037f9d,%al
c00234da:	89 c7                	mov    %eax,%edi
  bool alt = left_alt || right_alt;
c00234dc:	a0 9c 7f 03 c0       	mov    0xc0037f9c,%al
c00234e1:	89 c5                	mov    %eax,%ebp
c00234e3:	84 c0                	test   %al,%al
c00234e5:	75 07                	jne    c00234ee <keyboard_interrupt+0x2b>
c00234e7:	a0 9b 7f 03 c0       	mov    0xc0037f9b,%al
c00234ec:	89 c5                	mov    %eax,%ebp
  bool ctrl = left_ctrl || right_ctrl;
c00234ee:	a0 9a 7f 03 c0       	mov    0xc0037f9a,%al
c00234f3:	88 44 24 0f          	mov    %al,0xf(%esp)
c00234f7:	84 c0                	test   %al,%al
c00234f9:	75 09                	jne    c0023504 <keyboard_interrupt+0x41>
c00234fb:	a0 99 7f 03 c0       	mov    0xc0037f99,%al
c0023500:	88 44 24 0f          	mov    %al,0xf(%esp)
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0023504:	e4 60                	in     $0x60,%al
  code = inb (DATA_REG);
c0023506:	0f b6 d8             	movzbl %al,%ebx
  if (code == 0xe0)
c0023509:	81 fb e0 00 00 00    	cmp    $0xe0,%ebx
c002350f:	74 63                	je     c0023574 <keyboard_interrupt+0xb1>
  release = (code & 0x80) != 0;
c0023511:	89 de                	mov    %ebx,%esi
c0023513:	81 e6 80 00 00 00    	and    $0x80,%esi
  code &= ~0x80u;
c0023519:	80 e3 7f             	and    $0x7f,%bl
  if (code == 0x3a) 
c002351c:	83 fb 3a             	cmp    $0x3a,%ebx
c002351f:	74 5d                	je     c002357e <keyboard_interrupt+0xbb>
  else if (map_key (invariant_keymap, code, &c)
c0023521:	8d 4c 24 1f          	lea    0x1f(%esp),%ecx
c0023525:	89 da                	mov    %ebx,%edx
c0023527:	b8 a0 b8 02 c0       	mov    $0xc002b8a0,%eax
c002352c:	e8 35 ff ff ff       	call   c0023466 <map_key>
c0023531:	84 c0                	test   %al,%al
c0023533:	75 70                	jne    c00235a5 <keyboard_interrupt+0xe2>
           || (!shift && map_key (unshifted_keymap, code, &c))
c0023535:	89 f8                	mov    %edi,%eax
c0023537:	84 c0                	test   %al,%al
c0023539:	74 56                	je     c0023591 <keyboard_interrupt+0xce>
           || (shift && map_key (shifted_keymap, code, &c)))
c002353b:	8d 4c 24 1f          	lea    0x1f(%esp),%ecx
c002353f:	89 da                	mov    %ebx,%edx
c0023541:	b8 20 b8 02 c0       	mov    $0xc002b820,%eax
c0023546:	e8 1b ff ff ff       	call   c0023466 <map_key>
c002354b:	84 c0                	test   %al,%al
c002354d:	75 56                	jne    c00235a5 <keyboard_interrupt+0xe2>
        if (key->scancode == code)
c002354f:	83 fb 2a             	cmp    $0x2a,%ebx
c0023552:	0f 84 e2 00 00 00    	je     c002363a <keyboard_interrupt+0x177>
c0023558:	b8 e0 b7 02 c0       	mov    $0xc002b7e0,%eax
      for (key = shift_keys; key->scancode != 0; key++) 
c002355d:	83 c0 08             	add    $0x8,%eax
c0023560:	8b 10                	mov    (%eax),%edx
c0023562:	85 d2                	test   %edx,%edx
c0023564:	74 23                	je     c0023589 <keyboard_interrupt+0xc6>
        if (key->scancode == code)
c0023566:	39 d3                	cmp    %edx,%ebx
c0023568:	75 f3                	jne    c002355d <keyboard_interrupt+0x9a>
            *key->state_var = !release;
c002356a:	8b 40 04             	mov    0x4(%eax),%eax
c002356d:	85 f6                	test   %esi,%esi
c002356f:	0f 94 00             	sete   (%eax)
            break;
c0023572:	eb 15                	jmp    c0023589 <keyboard_interrupt+0xc6>
c0023574:	e4 60                	in     $0x60,%al
    code = (code << 8) | inb (DATA_REG);
c0023576:	0f b6 d8             	movzbl %al,%ebx
c0023579:	80 cf e0             	or     $0xe0,%bh
c002357c:	eb 93                	jmp    c0023511 <keyboard_interrupt+0x4e>
      if (!release)
c002357e:	85 f6                	test   %esi,%esi
c0023580:	75 07                	jne    c0023589 <keyboard_interrupt+0xc6>
        caps_lock = !caps_lock;
c0023582:	80 35 98 7f 03 c0 01 	xorb   $0x1,0xc0037f98
}
c0023589:	83 c4 2c             	add    $0x2c,%esp
c002358c:	5b                   	pop    %ebx
c002358d:	5e                   	pop    %esi
c002358e:	5f                   	pop    %edi
c002358f:	5d                   	pop    %ebp
c0023590:	c3                   	ret    
           || (!shift && map_key (unshifted_keymap, code, &c))
c0023591:	8d 4c 24 1f          	lea    0x1f(%esp),%ecx
c0023595:	89 da                	mov    %ebx,%edx
c0023597:	b8 60 b8 02 c0       	mov    $0xc002b860,%eax
c002359c:	e8 c5 fe ff ff       	call   c0023466 <map_key>
c00235a1:	84 c0                	test   %al,%al
c00235a3:	74 aa                	je     c002354f <keyboard_interrupt+0x8c>
      if (!release) 
c00235a5:	85 f6                	test   %esi,%esi
c00235a7:	75 e0                	jne    c0023589 <keyboard_interrupt+0xc6>
          if (c == 0177 && ctrl && alt)
c00235a9:	8a 44 24 1f          	mov    0x1f(%esp),%al
c00235ad:	3c 7f                	cmp    $0x7f,%al
c00235af:	74 4e                	je     c00235ff <keyboard_interrupt+0x13c>
          if (ctrl && c >= 0x40 && c < 0x60) 
c00235b1:	80 7c 24 0f 00       	cmpb   $0x0,0xf(%esp)
c00235b6:	74 08                	je     c00235c0 <keyboard_interrupt+0xfd>
c00235b8:	8d 50 c0             	lea    -0x40(%eax),%edx
c00235bb:	80 fa 1f             	cmp    $0x1f,%dl
c00235be:	76 60                	jbe    c0023620 <keyboard_interrupt+0x15d>
          else if (shift == caps_lock)
c00235c0:	89 f9                	mov    %edi,%ecx
c00235c2:	38 0d 98 7f 03 c0    	cmp    %cl,0xc0037f98
c00235c8:	74 5c                	je     c0023626 <keyboard_interrupt+0x163>
          if (alt)
c00235ca:	89 e8                	mov    %ebp,%eax
c00235cc:	84 c0                	test   %al,%al
c00235ce:	74 05                	je     c00235d5 <keyboard_interrupt+0x112>
            c += 0x80;
c00235d0:	80 44 24 1f 80       	addb   $0x80,0x1f(%esp)
          if (!input_full ())
c00235d5:	e8 c3 18 00 00       	call   c0024e9d <input_full>
c00235da:	84 c0                	test   %al,%al
c00235dc:	75 ab                	jne    c0023589 <keyboard_interrupt+0xc6>
              key_cnt++;
c00235de:	83 05 90 7f 03 c0 01 	addl   $0x1,0xc0037f90
c00235e5:	83 15 94 7f 03 c0 00 	adcl   $0x0,0xc0037f94
              input_putc (c);
c00235ec:	83 ec 0c             	sub    $0xc,%esp
c00235ef:	0f b6 44 24 2b       	movzbl 0x2b(%esp),%eax
c00235f4:	50                   	push   %eax
c00235f5:	e8 f7 17 00 00       	call   c0024df1 <input_putc>
c00235fa:	83 c4 10             	add    $0x10,%esp
c00235fd:	eb 8a                	jmp    c0023589 <keyboard_interrupt+0xc6>
          if (c == 0177 && ctrl && alt)
c00235ff:	80 7c 24 0f 00       	cmpb   $0x0,0xf(%esp)
c0023604:	74 06                	je     c002360c <keyboard_interrupt+0x149>
c0023606:	89 e9                	mov    %ebp,%ecx
c0023608:	84 c9                	test   %cl,%cl
c002360a:	75 0f                	jne    c002361b <keyboard_interrupt+0x158>
          else if (shift == caps_lock)
c002360c:	89 f9                	mov    %edi,%ecx
c002360e:	38 0d 98 7f 03 c0    	cmp    %cl,0xc0037f98
c0023614:	75 b4                	jne    c00235ca <keyboard_interrupt+0x107>
            c = tolower (c);
c0023616:	0f b6 c0             	movzbl %al,%eax
c0023619:	eb 19                	jmp    c0023634 <keyboard_interrupt+0x171>
            shutdown_reboot ();
c002361b:	e8 c9 1d 00 00       	call   c00253e9 <shutdown_reboot>
              c -= 0x40; 
c0023620:	88 54 24 1f          	mov    %dl,0x1f(%esp)
c0023624:	eb a4                	jmp    c00235ca <keyboard_interrupt+0x107>
            c = tolower (c);
c0023626:	0f b6 c0             	movzbl %al,%eax
#ifndef __LIB_CTYPE_H
#define __LIB_CTYPE_H

static inline int islower (int c) { return c >= 'a' && c <= 'z'; }
static inline int isupper (int c) { return c >= 'A' && c <= 'Z'; }
c0023629:	8d 50 bf             	lea    -0x41(%eax),%edx
static inline int isascii (int c) { return c >= 0 && c < 128; }
static inline int ispunct (int c) {
  return isprint (c) && !isalnum (c) && !isspace (c);
}

static inline int tolower (int c) { return isupper (c) ? c - 'A' + 'a' : c; }
c002362c:	83 fa 19             	cmp    $0x19,%edx
c002362f:	77 03                	ja     c0023634 <keyboard_interrupt+0x171>
c0023631:	83 c0 20             	add    $0x20,%eax
c0023634:	88 44 24 1f          	mov    %al,0x1f(%esp)
c0023638:	eb 90                	jmp    c00235ca <keyboard_interrupt+0x107>
      for (key = shift_keys; key->scancode != 0; key++) 
c002363a:	b8 e0 b7 02 c0       	mov    $0xc002b7e0,%eax
c002363f:	e9 26 ff ff ff       	jmp    c002356a <keyboard_interrupt+0xa7>

c0023644 <kbd_init>:
{
c0023644:	83 ec 10             	sub    $0x10,%esp
  intr_register_ext (0x21, keyboard_interrupt, "8042 Keyboard");
c0023647:	68 b5 d7 02 c0       	push   $0xc002d7b5
c002364c:	68 c3 34 02 c0       	push   $0xc00234c3
c0023651:	6a 21                	push   $0x21
c0023653:	e8 ac db ff ff       	call   c0021204 <intr_register_ext>
}
c0023658:	83 c4 1c             	add    $0x1c,%esp
c002365b:	c3                   	ret    

c002365c <kbd_print_stats>:
{
c002365c:	83 ec 10             	sub    $0x10,%esp
  printf ("Keyboard: %lld keys pressed\n", key_cnt);
c002365f:	ff 35 94 7f 03 c0    	pushl  0xc0037f94
c0023665:	ff 35 90 7f 03 c0    	pushl  0xc0037f90
c002366b:	68 c3 d7 02 c0       	push   $0xc002d7c3
c0023670:	e8 1d 25 00 00       	call   c0025b92 <printf>
}
c0023675:	83 c4 1c             	add    $0x1c,%esp
c0023678:	c3                   	ret    

c0023679 <move_cursor>:
/* Moves the hardware cursor to (cx,cy). */
static void
move_cursor (void) 
{
  /* See [FREEVGA] under "Manipulating the Text-mode Cursor". */
  uint16_t cp = cx + COL_CNT * cy;
c0023679:	a1 a8 7f 03 c0       	mov    0xc0037fa8,%eax
c002367e:	8d 0c 85 00 00 00 00 	lea    0x0(,%eax,4),%ecx
c0023685:	01 c1                	add    %eax,%ecx
c0023687:	c1 e1 04             	shl    $0x4,%ecx
c002368a:	03 0d ac 7f 03 c0    	add    0xc0037fac,%ecx
  outw (0x3d4, 0x0e | (cp & 0xff00));
c0023690:	89 c8                	mov    %ecx,%eax
c0023692:	b0 00                	mov    $0x0,%al
c0023694:	83 c8 0e             	or     $0xe,%eax
/* Writes the 16-bit DATA to PORT. */
static inline void
outw (uint16_t port, uint16_t data)
{
  /* See [IA32-v2b] "OUT". */
  asm volatile ("outw %w0, %w1" : : "a" (data), "Nd" (port));
c0023697:	ba d4 03 00 00       	mov    $0x3d4,%edx
c002369c:	66 ef                	out    %ax,(%dx)
  outw (0x3d4, 0x0f | (cp << 8));
c002369e:	89 c8                	mov    %ecx,%eax
c00236a0:	c1 e0 08             	shl    $0x8,%eax
c00236a3:	83 c8 0f             	or     $0xf,%eax
c00236a6:	66 ef                	out    %ax,(%dx)
c00236a8:	c3                   	ret    

c00236a9 <newline>:
  cx = 0;
c00236a9:	c7 05 ac 7f 03 c0 00 	movl   $0x0,0xc0037fac
c00236b0:	00 00 00 
  cy++;
c00236b3:	a1 a8 7f 03 c0       	mov    0xc0037fa8,%eax
c00236b8:	40                   	inc    %eax
  if (cy >= ROW_CNT)
c00236b9:	83 f8 18             	cmp    $0x18,%eax
c00236bc:	77 06                	ja     c00236c4 <newline+0x1b>
  cy++;
c00236be:	a3 a8 7f 03 c0       	mov    %eax,0xc0037fa8
c00236c3:	c3                   	ret    
{
c00236c4:	53                   	push   %ebx
c00236c5:	83 ec 0c             	sub    $0xc,%esp
      cy = ROW_CNT - 1;
c00236c8:	c7 05 a8 7f 03 c0 18 	movl   $0x18,0xc0037fa8
c00236cf:	00 00 00 
      memmove (&fb[0], &fb[1], sizeof fb[0] * (ROW_CNT - 1));
c00236d2:	8b 1d a4 7f 03 c0    	mov    0xc0037fa4,%ebx
c00236d8:	68 00 0f 00 00       	push   $0xf00
c00236dd:	8d 83 a0 00 00 00    	lea    0xa0(%ebx),%eax
c00236e3:	50                   	push   %eax
c00236e4:	53                   	push   %ebx
c00236e5:	e8 71 32 00 00       	call   c002695b <memmove>
c00236ea:	8d 83 00 0f 00 00    	lea    0xf00(%ebx),%eax
c00236f0:	8d 93 a0 0f 00 00    	lea    0xfa0(%ebx),%edx
c00236f6:	83 c4 10             	add    $0x10,%esp
      fb[y][x][0] = ' ';
c00236f9:	c6 00 20             	movb   $0x20,(%eax)
      fb[y][x][1] = GRAY_ON_BLACK;
c00236fc:	c6 40 01 07          	movb   $0x7,0x1(%eax)
c0023700:	83 c0 02             	add    $0x2,%eax
  for (x = 0; x < COL_CNT; x++)
c0023703:	39 d0                	cmp    %edx,%eax
c0023705:	75 f2                	jne    c00236f9 <newline+0x50>
}
c0023707:	83 c4 08             	add    $0x8,%esp
c002370a:	5b                   	pop    %ebx
c002370b:	c3                   	ret    

c002370c <vga_putc>:
{
c002370c:	56                   	push   %esi
c002370d:	53                   	push   %ebx
c002370e:	83 ec 04             	sub    $0x4,%esp
  enum intr_level old_level = intr_disable ();
c0023711:	e8 6d d9 ff ff       	call   c0021083 <intr_disable>
c0023716:	89 c3                	mov    %eax,%ebx
  if (!inited)
c0023718:	80 3d a0 7f 03 c0 00 	cmpb   $0x0,0xc0037fa0
c002371f:	74 17                	je     c0023738 <vga_putc+0x2c>
  switch (c) 
c0023721:	8b 44 24 10          	mov    0x10(%esp),%eax
c0023725:	83 e8 07             	sub    $0x7,%eax
c0023728:	83 f8 06             	cmp    $0x6,%eax
c002372b:	0f 87 23 01 00 00    	ja     c0023854 <vga_putc+0x148>
c0023731:	ff 24 85 f0 b8 02 c0 	jmp    *-0x3ffd4710(,%eax,4)
      fb = ptov (0xb8000);
c0023738:	c7 05 a4 7f 03 c0 00 	movl   $0xc00b8000,0xc0037fa4
c002373f:	80 0b c0 
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0023742:	ba d4 03 00 00       	mov    $0x3d4,%edx
c0023747:	b0 0e                	mov    $0xe,%al
c0023749:	ee                   	out    %al,(%dx)
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002374a:	b9 d5 03 00 00       	mov    $0x3d5,%ecx
c002374f:	89 ca                	mov    %ecx,%edx
c0023751:	ec                   	in     (%dx),%al
{
  /* See [FREEVGA] under "Manipulating the Text-mode Cursor". */
  uint16_t cp;

  outb (0x3d4, 0x0e);
  cp = inb (0x3d5) << 8;
c0023752:	89 c6                	mov    %eax,%esi
c0023754:	c1 e6 08             	shl    $0x8,%esi
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0023757:	ba d4 03 00 00       	mov    $0x3d4,%edx
c002375c:	b0 0f                	mov    $0xf,%al
c002375e:	ee                   	out    %al,(%dx)
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002375f:	89 ca                	mov    %ecx,%edx
c0023761:	ec                   	in     (%dx),%al

  outb (0x3d4, 0x0f);
  cp |= inb (0x3d5);
c0023762:	0f b6 c0             	movzbl %al,%eax
c0023765:	09 f0                	or     %esi,%eax
c0023767:	89 c1                	mov    %eax,%ecx

  *x = cp % COL_CNT;
c0023769:	be 50 00 00 00       	mov    $0x50,%esi
c002376e:	ba 00 00 00 00       	mov    $0x0,%edx
c0023773:	66 f7 f6             	div    %si
c0023776:	0f b7 d2             	movzwl %dx,%edx
c0023779:	89 15 ac 7f 03 c0    	mov    %edx,0xc0037fac
  *y = cp / COL_CNT;
c002377f:	0f b7 c1             	movzwl %cx,%eax
c0023782:	8d 14 80             	lea    (%eax,%eax,4),%edx
c0023785:	8d 14 92             	lea    (%edx,%edx,4),%edx
c0023788:	01 d2                	add    %edx,%edx
c002378a:	01 c2                	add    %eax,%edx
c002378c:	89 d1                	mov    %edx,%ecx
c002378e:	c1 e1 08             	shl    $0x8,%ecx
c0023791:	01 ca                	add    %ecx,%edx
c0023793:	8d 04 90             	lea    (%eax,%edx,4),%eax
c0023796:	c1 e8 16             	shr    $0x16,%eax
c0023799:	a3 a8 7f 03 c0       	mov    %eax,0xc0037fa8
      inited = true; 
c002379e:	c6 05 a0 7f 03 c0 01 	movb   $0x1,0xc0037fa0
c00237a5:	e9 77 ff ff ff       	jmp    c0023721 <vga_putc+0x15>
      fb[y][x][0] = ' ';
c00237aa:	a1 a4 7f 03 c0       	mov    0xc0037fa4,%eax
c00237af:	8d 88 a0 0f 00 00    	lea    0xfa0(%eax),%ecx
c00237b5:	8d 90 a0 00 00 00    	lea    0xa0(%eax),%edx
c00237bb:	c6 00 20             	movb   $0x20,(%eax)
      fb[y][x][1] = GRAY_ON_BLACK;
c00237be:	c6 40 01 07          	movb   $0x7,0x1(%eax)
c00237c2:	83 c0 02             	add    $0x2,%eax
  for (x = 0; x < COL_CNT; x++)
c00237c5:	39 d0                	cmp    %edx,%eax
c00237c7:	75 f2                	jne    c00237bb <vga_putc+0xaf>
c00237c9:	89 d0                	mov    %edx,%eax
  for (y = 0; y < ROW_CNT; y++)
c00237cb:	39 d1                	cmp    %edx,%ecx
c00237cd:	75 e6                	jne    c00237b5 <vga_putc+0xa9>
  cx = cy = 0;
c00237cf:	c7 05 a8 7f 03 c0 00 	movl   $0x0,0xc0037fa8
c00237d6:	00 00 00 
c00237d9:	c7 05 ac 7f 03 c0 00 	movl   $0x0,0xc0037fac
c00237e0:	00 00 00 
  move_cursor ();
c00237e3:	e8 91 fe ff ff       	call   c0023679 <move_cursor>
c00237e8:	eb 05                	jmp    c00237ef <vga_putc+0xe3>
      newline ();
c00237ea:	e8 ba fe ff ff       	call   c00236a9 <newline>
  move_cursor ();
c00237ef:	e8 85 fe ff ff       	call   c0023679 <move_cursor>
  intr_set_level (old_level);
c00237f4:	83 ec 0c             	sub    $0xc,%esp
c00237f7:	53                   	push   %ebx
c00237f8:	e8 8d d8 ff ff       	call   c002108a <intr_set_level>
}
c00237fd:	83 c4 14             	add    $0x14,%esp
c0023800:	5b                   	pop    %ebx
c0023801:	5e                   	pop    %esi
c0023802:	c3                   	ret    
      if (cx > 0)
c0023803:	a1 ac 7f 03 c0       	mov    0xc0037fac,%eax
c0023808:	85 c0                	test   %eax,%eax
c002380a:	74 e3                	je     c00237ef <vga_putc+0xe3>
        cx--;
c002380c:	48                   	dec    %eax
c002380d:	a3 ac 7f 03 c0       	mov    %eax,0xc0037fac
c0023812:	eb db                	jmp    c00237ef <vga_putc+0xe3>
      cx = 0;
c0023814:	c7 05 ac 7f 03 c0 00 	movl   $0x0,0xc0037fac
c002381b:	00 00 00 
      break;
c002381e:	eb cf                	jmp    c00237ef <vga_putc+0xe3>
      cx = ROUND_UP (cx + 1, 8);
c0023820:	a1 ac 7f 03 c0       	mov    0xc0037fac,%eax
c0023825:	83 c0 08             	add    $0x8,%eax
c0023828:	83 e0 f8             	and    $0xfffffff8,%eax
c002382b:	a3 ac 7f 03 c0       	mov    %eax,0xc0037fac
      if (cx >= COL_CNT)
c0023830:	83 f8 4f             	cmp    $0x4f,%eax
c0023833:	76 ba                	jbe    c00237ef <vga_putc+0xe3>
        newline ();
c0023835:	e8 6f fe ff ff       	call   c00236a9 <newline>
c002383a:	eb b3                	jmp    c00237ef <vga_putc+0xe3>
      intr_set_level (old_level);
c002383c:	83 ec 0c             	sub    $0xc,%esp
c002383f:	53                   	push   %ebx
c0023840:	e8 45 d8 ff ff       	call   c002108a <intr_set_level>
      speaker_beep ();
c0023845:	e8 0e 1d 00 00       	call   c0025558 <speaker_beep>
      intr_disable ();
c002384a:	e8 34 d8 ff ff       	call   c0021083 <intr_disable>
      break;
c002384f:	83 c4 10             	add    $0x10,%esp
c0023852:	eb 9b                	jmp    c00237ef <vga_putc+0xe3>
      fb[cy][cx][0] = c;
c0023854:	8b 35 a4 7f 03 c0    	mov    0xc0037fa4,%esi
c002385a:	a1 a8 7f 03 c0       	mov    0xc0037fa8,%eax
c002385f:	8d 04 80             	lea    (%eax,%eax,4),%eax
c0023862:	c1 e0 05             	shl    $0x5,%eax
c0023865:	01 f0                	add    %esi,%eax
c0023867:	8b 0d ac 7f 03 c0    	mov    0xc0037fac,%ecx
c002386d:	8a 54 24 10          	mov    0x10(%esp),%dl
c0023871:	88 14 48             	mov    %dl,(%eax,%ecx,2)
      fb[cy][cx][1] = GRAY_ON_BLACK;
c0023874:	a1 a8 7f 03 c0       	mov    0xc0037fa8,%eax
c0023879:	8d 04 80             	lea    (%eax,%eax,4),%eax
c002387c:	c1 e0 05             	shl    $0x5,%eax
c002387f:	8d 14 06             	lea    (%esi,%eax,1),%edx
c0023882:	a1 ac 7f 03 c0       	mov    0xc0037fac,%eax
c0023887:	c6 44 42 01 07       	movb   $0x7,0x1(%edx,%eax,2)
      if (++cx >= COL_CNT)
c002388c:	a1 ac 7f 03 c0       	mov    0xc0037fac,%eax
c0023891:	40                   	inc    %eax
c0023892:	a3 ac 7f 03 c0       	mov    %eax,0xc0037fac
c0023897:	83 f8 4f             	cmp    $0x4f,%eax
c002389a:	0f 86 4f ff ff ff    	jbe    c00237ef <vga_putc+0xe3>
        newline ();
c00238a0:	e8 04 fe ff ff       	call   c00236a9 <newline>
c00238a5:	e9 45 ff ff ff       	jmp    c00237ef <vga_putc+0xe3>

c00238aa <init_poll>:
   Polling mode busy-waits for the serial port to become free
   before writing to it.  It's slow, but until interrupts have
   been initialized it's all we can do. */
static void
init_poll (void) 
{
c00238aa:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (mode == UNINIT);
c00238ad:	83 3d 28 80 03 c0 00 	cmpl   $0x0,0xc0038028
c00238b4:	75 51                	jne    c0023907 <init_poll+0x5d>
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00238b6:	ba f9 03 00 00       	mov    $0x3f9,%edx
c00238bb:	b0 00                	mov    $0x0,%al
c00238bd:	ee                   	out    %al,(%dx)
c00238be:	ba fa 03 00 00       	mov    $0x3fa,%edx
c00238c3:	ee                   	out    %al,(%dx)
c00238c4:	ba fb 03 00 00       	mov    $0x3fb,%edx
c00238c9:	b0 83                	mov    $0x83,%al
c00238cb:	ee                   	out    %al,(%dx)
c00238cc:	ba f8 03 00 00       	mov    $0x3f8,%edx
c00238d1:	b0 0c                	mov    $0xc,%al
c00238d3:	ee                   	out    %al,(%dx)
c00238d4:	ba f9 03 00 00       	mov    $0x3f9,%edx
c00238d9:	b0 00                	mov    $0x0,%al
c00238db:	ee                   	out    %al,(%dx)
c00238dc:	ba fb 03 00 00       	mov    $0x3fb,%edx
c00238e1:	b0 03                	mov    $0x3,%al
c00238e3:	ee                   	out    %al,(%dx)
c00238e4:	ba fc 03 00 00       	mov    $0x3fc,%edx
c00238e9:	b0 08                	mov    $0x8,%al
c00238eb:	ee                   	out    %al,(%dx)
  outb (IER_REG, 0);                    /* Turn off all interrupts. */
  outb (FCR_REG, 0);                    /* Disable FIFO. */
  set_serial (9600);                    /* 9.6 kbps, N-8-1. */
  outb (MCR_REG, MCR_OUT2);             /* Required to enable interrupts. */
  intq_init (&txq);
c00238ec:	83 ec 0c             	sub    $0xc,%esp
c00238ef:	68 c0 7f 03 c0       	push   $0xc0037fc0
c00238f4:	e8 df 15 00 00       	call   c0024ed8 <intq_init>
  mode = POLL;
c00238f9:	c7 05 28 80 03 c0 01 	movl   $0x1,0xc0038028
c0023900:	00 00 00 
} 
c0023903:	83 c4 1c             	add    $0x1c,%esp
c0023906:	c3                   	ret    
  ASSERT (mode == UNINIT);
c0023907:	83 ec 0c             	sub    $0xc,%esp
c002390a:	68 3c d8 02 c0       	push   $0xc002d83c
c002390f:	68 df cb 02 c0       	push   $0xc002cbdf
c0023914:	68 34 b9 02 c0       	push   $0xc002b934
c0023919:	6a 45                	push   $0x45
c002391b:	68 4b d8 02 c0       	push   $0xc002d84b
c0023920:	e8 1b 3d 00 00       	call   c0027640 <debug_panic>

c0023925 <write_ier>:
}

/* Update interrupt enable register. */
static void
write_ier (void) 
{
c0023925:	53                   	push   %ebx
c0023926:	83 ec 08             	sub    $0x8,%esp
  uint8_t ier = 0;

  ASSERT (intr_get_level () == INTR_OFF);
c0023929:	e8 18 d7 ff ff       	call   c0021046 <intr_get_level>
c002392e:	85 c0                	test   %eax,%eax
c0023930:	75 30                	jne    c0023962 <write_ier+0x3d>

  /* Enable transmit interrupt if we have any characters to
     transmit. */
  if (!intq_empty (&txq))
c0023932:	83 ec 0c             	sub    $0xc,%esp
c0023935:	68 c0 7f 03 c0       	push   $0xc0037fc0
c002393a:	e8 c8 15 00 00       	call   c0024f07 <intq_empty>
c002393f:	83 c4 10             	add    $0x10,%esp
c0023942:	84 c0                	test   %al,%al
    ier |= IER_XMIT;
c0023944:	0f 94 c3             	sete   %bl
c0023947:	d1 e3                	shl    %ebx

  /* Enable receive interrupt if we have room to store any
     characters we receive. */
  if (!input_full ())
c0023949:	e8 4f 15 00 00       	call   c0024e9d <input_full>
c002394e:	84 c0                	test   %al,%al
c0023950:	75 03                	jne    c0023955 <write_ier+0x30>
    ier |= IER_RECV;
c0023952:	83 cb 01             	or     $0x1,%ebx
c0023955:	ba f9 03 00 00       	mov    $0x3f9,%edx
c002395a:	88 d8                	mov    %bl,%al
c002395c:	ee                   	out    %al,(%dx)
  
  outb (IER_REG, ier);
}
c002395d:	83 c4 08             	add    $0x8,%esp
c0023960:	5b                   	pop    %ebx
c0023961:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0023962:	83 ec 0c             	sub    $0xc,%esp
c0023965:	68 34 cf 02 c0       	push   $0xc002cf34
c002396a:	68 df cb 02 c0       	push   $0xc002cbdf
c002396f:	68 28 b9 02 c0       	push   $0xc002b928
c0023974:	68 b5 00 00 00       	push   $0xb5
c0023979:	68 4b d8 02 c0       	push   $0xc002d84b
c002397e:	e8 bd 3c 00 00       	call   c0027640 <debug_panic>

c0023983 <serial_interrupt>:
}

/* Serial interrupt handler. */
static void
serial_interrupt (struct intr_frame *f UNUSED) 
{
c0023983:	56                   	push   %esi
c0023984:	53                   	push   %ebx
c0023985:	83 ec 04             	sub    $0x4,%esp
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0023988:	ba fa 03 00 00       	mov    $0x3fa,%edx
c002398d:	ec                   	in     (%dx),%al
c002398e:	bb fd 03 00 00       	mov    $0x3fd,%ebx
c0023993:	be f8 03 00 00       	mov    $0x3f8,%esi
c0023998:	eb 12                	jmp    c00239ac <serial_interrupt+0x29>
c002399a:	89 f2                	mov    %esi,%edx
c002399c:	ec                   	in     (%dx),%al
  inb (IIR_REG);

  /* As long as we have room to receive a byte, and the hardware
     has a byte for us, receive a byte.  */
  while (!input_full () && (inb (LSR_REG) & LSR_DR) != 0)
    input_putc (inb (RBR_REG));
c002399d:	83 ec 0c             	sub    $0xc,%esp
c00239a0:	0f b6 c0             	movzbl %al,%eax
c00239a3:	50                   	push   %eax
c00239a4:	e8 48 14 00 00       	call   c0024df1 <input_putc>
c00239a9:	83 c4 10             	add    $0x10,%esp
  while (!input_full () && (inb (LSR_REG) & LSR_DR) != 0)
c00239ac:	e8 ec 14 00 00       	call   c0024e9d <input_full>
c00239b1:	84 c0                	test   %al,%al
c00239b3:	75 07                	jne    c00239bc <serial_interrupt+0x39>
c00239b5:	89 da                	mov    %ebx,%edx
c00239b7:	ec                   	in     (%dx),%al
c00239b8:	a8 01                	test   $0x1,%al
c00239ba:	75 de                	jne    c002399a <serial_interrupt+0x17>
c00239bc:	bb fd 03 00 00       	mov    $0x3fd,%ebx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00239c1:	be f8 03 00 00       	mov    $0x3f8,%esi
c00239c6:	eb 13                	jmp    c00239db <serial_interrupt+0x58>

  /* As long as we have a byte to transmit, and the hardware is
     ready to accept a byte for transmission, transmit a byte. */
  while (!intq_empty (&txq) && (inb (LSR_REG) & LSR_THRE) != 0) 
    outb (THR_REG, intq_getc (&txq));
c00239c8:	83 ec 0c             	sub    $0xc,%esp
c00239cb:	68 c0 7f 03 c0       	push   $0xc0037fc0
c00239d0:	e8 0e 17 00 00       	call   c00250e3 <intq_getc>
c00239d5:	89 f2                	mov    %esi,%edx
c00239d7:	ee                   	out    %al,(%dx)
c00239d8:	83 c4 10             	add    $0x10,%esp
  while (!intq_empty (&txq) && (inb (LSR_REG) & LSR_THRE) != 0) 
c00239db:	83 ec 0c             	sub    $0xc,%esp
c00239de:	68 c0 7f 03 c0       	push   $0xc0037fc0
c00239e3:	e8 1f 15 00 00       	call   c0024f07 <intq_empty>
c00239e8:	83 c4 10             	add    $0x10,%esp
c00239eb:	84 c0                	test   %al,%al
c00239ed:	75 07                	jne    c00239f6 <serial_interrupt+0x73>
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c00239ef:	89 da                	mov    %ebx,%edx
c00239f1:	ec                   	in     (%dx),%al
c00239f2:	a8 20                	test   $0x20,%al
c00239f4:	75 d2                	jne    c00239c8 <serial_interrupt+0x45>

  /* Update interrupt enable register based on queue status. */
  write_ier ();
c00239f6:	e8 2a ff ff ff       	call   c0023925 <write_ier>
}
c00239fb:	83 c4 04             	add    $0x4,%esp
c00239fe:	5b                   	pop    %ebx
c00239ff:	5e                   	pop    %esi
c0023a00:	c3                   	ret    

c0023a01 <putc_poll>:
{
c0023a01:	53                   	push   %ebx
c0023a02:	83 ec 08             	sub    $0x8,%esp
c0023a05:	89 c3                	mov    %eax,%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c0023a07:	e8 3a d6 ff ff       	call   c0021046 <intr_get_level>
c0023a0c:	85 c0                	test   %eax,%eax
c0023a0e:	75 17                	jne    c0023a27 <putc_poll+0x26>
c0023a10:	ba fd 03 00 00       	mov    $0x3fd,%edx
c0023a15:	ec                   	in     (%dx),%al
  while ((inb (LSR_REG) & LSR_THRE) == 0)
c0023a16:	a8 20                	test   $0x20,%al
c0023a18:	74 fb                	je     c0023a15 <putc_poll+0x14>
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0023a1a:	ba f8 03 00 00       	mov    $0x3f8,%edx
c0023a1f:	88 d8                	mov    %bl,%al
c0023a21:	ee                   	out    %al,(%dx)
}
c0023a22:	83 c4 08             	add    $0x8,%esp
c0023a25:	5b                   	pop    %ebx
c0023a26:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0023a27:	83 ec 0c             	sub    $0xc,%esp
c0023a2a:	68 34 cf 02 c0       	push   $0xc002cf34
c0023a2f:	68 df cb 02 c0       	push   $0xc002cbdf
c0023a34:	68 1c b9 02 c0       	push   $0xc002b91c
c0023a39:	68 c9 00 00 00       	push   $0xc9
c0023a3e:	68 4b d8 02 c0       	push   $0xc002d84b
c0023a43:	e8 f8 3b 00 00       	call   c0027640 <debug_panic>

c0023a48 <serial_init_queue>:
{
c0023a48:	53                   	push   %ebx
c0023a49:	83 ec 08             	sub    $0x8,%esp
  if (mode == UNINIT)
c0023a4c:	83 3d 28 80 03 c0 00 	cmpl   $0x0,0xc0038028
c0023a53:	74 40                	je     c0023a95 <serial_init_queue+0x4d>
  ASSERT (mode == POLL);
c0023a55:	83 3d 28 80 03 c0 01 	cmpl   $0x1,0xc0038028
c0023a5c:	75 3e                	jne    c0023a9c <serial_init_queue+0x54>
  intr_register_ext (0x20 + 4, serial_interrupt, "serial");
c0023a5e:	83 ec 04             	sub    $0x4,%esp
c0023a61:	68 6f d8 02 c0       	push   $0xc002d86f
c0023a66:	68 83 39 02 c0       	push   $0xc0023983
c0023a6b:	6a 24                	push   $0x24
c0023a6d:	e8 92 d7 ff ff       	call   c0021204 <intr_register_ext>
  mode = QUEUE;
c0023a72:	c7 05 28 80 03 c0 02 	movl   $0x2,0xc0038028
c0023a79:	00 00 00 
  old_level = intr_disable ();
c0023a7c:	e8 02 d6 ff ff       	call   c0021083 <intr_disable>
c0023a81:	89 c3                	mov    %eax,%ebx
  write_ier ();
c0023a83:	e8 9d fe ff ff       	call   c0023925 <write_ier>
  intr_set_level (old_level);
c0023a88:	89 1c 24             	mov    %ebx,(%esp)
c0023a8b:	e8 fa d5 ff ff       	call   c002108a <intr_set_level>
}
c0023a90:	83 c4 18             	add    $0x18,%esp
c0023a93:	5b                   	pop    %ebx
c0023a94:	c3                   	ret    
    init_poll ();
c0023a95:	e8 10 fe ff ff       	call   c00238aa <init_poll>
c0023a9a:	eb b9                	jmp    c0023a55 <serial_init_queue+0xd>
  ASSERT (mode == POLL);
c0023a9c:	83 ec 0c             	sub    $0xc,%esp
c0023a9f:	68 62 d8 02 c0       	push   $0xc002d862
c0023aa4:	68 df cb 02 c0       	push   $0xc002cbdf
c0023aa9:	68 40 b9 02 c0       	push   $0xc002b940
c0023aae:	6a 58                	push   $0x58
c0023ab0:	68 4b d8 02 c0       	push   $0xc002d84b
c0023ab5:	e8 86 3b 00 00       	call   c0027640 <debug_panic>

c0023aba <serial_putc>:
{
c0023aba:	56                   	push   %esi
c0023abb:	53                   	push   %ebx
c0023abc:	83 ec 04             	sub    $0x4,%esp
c0023abf:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  enum intr_level old_level = intr_disable ();
c0023ac3:	e8 bb d5 ff ff       	call   c0021083 <intr_disable>
c0023ac8:	89 c6                	mov    %eax,%esi
  if (mode != QUEUE)
c0023aca:	a1 28 80 03 c0       	mov    0xc0038028,%eax
c0023acf:	83 f8 02             	cmp    $0x2,%eax
c0023ad2:	74 22                	je     c0023af6 <serial_putc+0x3c>
      if (mode == UNINIT)
c0023ad4:	85 c0                	test   %eax,%eax
c0023ad6:	74 17                	je     c0023aef <serial_putc+0x35>
      putc_poll (byte); 
c0023ad8:	0f b6 c3             	movzbl %bl,%eax
c0023adb:	e8 21 ff ff ff       	call   c0023a01 <putc_poll>
  intr_set_level (old_level);
c0023ae0:	83 ec 0c             	sub    $0xc,%esp
c0023ae3:	56                   	push   %esi
c0023ae4:	e8 a1 d5 ff ff       	call   c002108a <intr_set_level>
}
c0023ae9:	83 c4 14             	add    $0x14,%esp
c0023aec:	5b                   	pop    %ebx
c0023aed:	5e                   	pop    %esi
c0023aee:	c3                   	ret    
        init_poll ();
c0023aef:	e8 b6 fd ff ff       	call   c00238aa <init_poll>
c0023af4:	eb e2                	jmp    c0023ad8 <serial_putc+0x1e>
      if (old_level == INTR_OFF && intq_full (&txq)) 
c0023af6:	85 f6                	test   %esi,%esi
c0023af8:	74 1b                	je     c0023b15 <serial_putc+0x5b>
      intq_putc (&txq, byte); 
c0023afa:	83 ec 08             	sub    $0x8,%esp
c0023afd:	0f b6 db             	movzbl %bl,%ebx
c0023b00:	53                   	push   %ebx
c0023b01:	68 c0 7f 03 c0       	push   $0xc0037fc0
c0023b06:	e8 8d 16 00 00       	call   c0025198 <intq_putc>
      write_ier ();
c0023b0b:	e8 15 fe ff ff       	call   c0023925 <write_ier>
c0023b10:	83 c4 10             	add    $0x10,%esp
c0023b13:	eb cb                	jmp    c0023ae0 <serial_putc+0x26>
      if (old_level == INTR_OFF && intq_full (&txq)) 
c0023b15:	83 ec 0c             	sub    $0xc,%esp
c0023b18:	68 c0 7f 03 c0       	push   $0xc0037fc0
c0023b1d:	e8 22 14 00 00       	call   c0024f44 <intq_full>
c0023b22:	83 c4 10             	add    $0x10,%esp
c0023b25:	84 c0                	test   %al,%al
c0023b27:	74 d1                	je     c0023afa <serial_putc+0x40>
          putc_poll (intq_getc (&txq)); 
c0023b29:	83 ec 0c             	sub    $0xc,%esp
c0023b2c:	68 c0 7f 03 c0       	push   $0xc0037fc0
c0023b31:	e8 ad 15 00 00       	call   c00250e3 <intq_getc>
c0023b36:	0f b6 c0             	movzbl %al,%eax
c0023b39:	e8 c3 fe ff ff       	call   c0023a01 <putc_poll>
c0023b3e:	83 c4 10             	add    $0x10,%esp
c0023b41:	eb b7                	jmp    c0023afa <serial_putc+0x40>

c0023b43 <serial_flush>:
{
c0023b43:	53                   	push   %ebx
c0023b44:	83 ec 08             	sub    $0x8,%esp
  enum intr_level old_level = intr_disable ();
c0023b47:	e8 37 d5 ff ff       	call   c0021083 <intr_disable>
c0023b4c:	89 c3                	mov    %eax,%ebx
  while (!intq_empty (&txq))
c0023b4e:	eb 18                	jmp    c0023b68 <serial_flush+0x25>
    putc_poll (intq_getc (&txq));
c0023b50:	83 ec 0c             	sub    $0xc,%esp
c0023b53:	68 c0 7f 03 c0       	push   $0xc0037fc0
c0023b58:	e8 86 15 00 00       	call   c00250e3 <intq_getc>
c0023b5d:	0f b6 c0             	movzbl %al,%eax
c0023b60:	e8 9c fe ff ff       	call   c0023a01 <putc_poll>
c0023b65:	83 c4 10             	add    $0x10,%esp
  while (!intq_empty (&txq))
c0023b68:	83 ec 0c             	sub    $0xc,%esp
c0023b6b:	68 c0 7f 03 c0       	push   $0xc0037fc0
c0023b70:	e8 92 13 00 00       	call   c0024f07 <intq_empty>
c0023b75:	83 c4 10             	add    $0x10,%esp
c0023b78:	84 c0                	test   %al,%al
c0023b7a:	74 d4                	je     c0023b50 <serial_flush+0xd>
  intr_set_level (old_level);
c0023b7c:	83 ec 0c             	sub    $0xc,%esp
c0023b7f:	53                   	push   %ebx
c0023b80:	e8 05 d5 ff ff       	call   c002108a <intr_set_level>
}
c0023b85:	83 c4 18             	add    $0x18,%esp
c0023b88:	5b                   	pop    %ebx
c0023b89:	c3                   	ret    

c0023b8a <serial_notify>:
{
c0023b8a:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (intr_get_level () == INTR_OFF);
c0023b8d:	e8 b4 d4 ff ff       	call   c0021046 <intr_get_level>
c0023b92:	85 c0                	test   %eax,%eax
c0023b94:	75 0d                	jne    c0023ba3 <serial_notify+0x19>
  if (mode == QUEUE)
c0023b96:	83 3d 28 80 03 c0 02 	cmpl   $0x2,0xc0038028
c0023b9d:	74 25                	je     c0023bc4 <serial_notify+0x3a>
}
c0023b9f:	83 c4 0c             	add    $0xc,%esp
c0023ba2:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0023ba3:	83 ec 0c             	sub    $0xc,%esp
c0023ba6:	68 34 cf 02 c0       	push   $0xc002cf34
c0023bab:	68 df cb 02 c0       	push   $0xc002cbdf
c0023bb0:	68 0c b9 02 c0       	push   $0xc002b90c
c0023bb5:	68 96 00 00 00       	push   $0x96
c0023bba:	68 4b d8 02 c0       	push   $0xc002d84b
c0023bbf:	e8 7c 3a 00 00       	call   c0027640 <debug_panic>
    write_ier ();
c0023bc4:	e8 5c fd ff ff       	call   c0023925 <write_ier>
}
c0023bc9:	eb d4                	jmp    c0023b9f <serial_notify+0x15>

c0023bcb <check_sector>:
/* Verifies that SECTOR is a valid offset within BLOCK.
   Panics if not. */
static void
check_sector (struct block *block, block_sector_t sector)
{
  if (sector >= block->size)
c0023bcb:	8b 48 1c             	mov    0x1c(%eax),%ecx
c0023bce:	39 d1                	cmp    %edx,%ecx
c0023bd0:	76 01                	jbe    c0023bd3 <check_sector+0x8>
c0023bd2:	c3                   	ret    
{
c0023bd3:	83 ec 10             	sub    $0x10,%esp
    {
      /* We do not use ASSERT because we want to panic here
         regardless of whether NDEBUG is defined. */
      PANIC ("Access past end of device %s (sector=%"PRDSNu", "
c0023bd6:	51                   	push   %ecx
c0023bd7:	52                   	push   %edx

/* Returns BLOCK's name (e.g. "hda"). */
const char *
block_name (struct block *block)
{
  return block->name;
c0023bd8:	83 c0 08             	add    $0x8,%eax
      PANIC ("Access past end of device %s (sector=%"PRDSNu", "
c0023bdb:	50                   	push   %eax
c0023bdc:	68 78 d8 02 c0       	push   $0xc002d878
c0023be1:	68 70 b9 02 c0       	push   $0xc002b970
c0023be6:	6a 70                	push   $0x70
c0023be8:	68 06 d9 02 c0       	push   $0xc002d906
c0023bed:	e8 4e 3a 00 00       	call   c0027640 <debug_panic>

c0023bf2 <block_type_name>:
{
c0023bf2:	83 ec 0c             	sub    $0xc,%esp
c0023bf5:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (type < BLOCK_CNT);
c0023bf9:	83 f8 05             	cmp    $0x5,%eax
c0023bfc:	77 0b                	ja     c0023c09 <block_type_name+0x17>
  return block_type_names[type];
c0023bfe:	8b 04 85 a0 b9 02 c0 	mov    -0x3ffd4660(,%eax,4),%eax
}
c0023c05:	83 c4 0c             	add    $0xc,%esp
c0023c08:	c3                   	ret    
  ASSERT (type < BLOCK_CNT);
c0023c09:	83 ec 0c             	sub    $0xc,%esp
c0023c0c:	68 1c d9 02 c0       	push   $0xc002d91c
c0023c11:	68 df cb 02 c0       	push   $0xc002cbdf
c0023c16:	68 b8 b9 02 c0       	push   $0xc002b9b8
c0023c1b:	6a 2f                	push   $0x2f
c0023c1d:	68 06 d9 02 c0       	push   $0xc002d906
c0023c22:	e8 19 3a 00 00       	call   c0027640 <debug_panic>

c0023c27 <block_get_role>:
{
c0023c27:	83 ec 0c             	sub    $0xc,%esp
c0023c2a:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (role < BLOCK_ROLE_CNT);
c0023c2e:	83 f8 03             	cmp    $0x3,%eax
c0023c31:	77 0b                	ja     c0023c3e <block_get_role+0x17>
  return block_by_role[role];
c0023c33:	8b 04 85 2c 80 03 c0 	mov    -0x3ffc7fd4(,%eax,4),%eax
}
c0023c3a:	83 c4 0c             	add    $0xc,%esp
c0023c3d:	c3                   	ret    
  ASSERT (role < BLOCK_ROLE_CNT);
c0023c3e:	83 ec 0c             	sub    $0xc,%esp
c0023c41:	68 2d d9 02 c0       	push   $0xc002d92d
c0023c46:	68 df cb 02 c0       	push   $0xc002cbdf
c0023c4b:	68 90 b9 02 c0       	push   $0xc002b990
c0023c50:	6a 38                	push   $0x38
c0023c52:	68 06 d9 02 c0       	push   $0xc002d906
c0023c57:	e8 e4 39 00 00       	call   c0027640 <debug_panic>

c0023c5c <block_set_role>:
{
c0023c5c:	83 ec 0c             	sub    $0xc,%esp
c0023c5f:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (role < BLOCK_ROLE_CNT);
c0023c63:	83 f8 03             	cmp    $0x3,%eax
c0023c66:	77 0f                	ja     c0023c77 <block_set_role+0x1b>
  block_by_role[role] = block;
c0023c68:	8b 54 24 14          	mov    0x14(%esp),%edx
c0023c6c:	89 14 85 2c 80 03 c0 	mov    %edx,-0x3ffc7fd4(,%eax,4)
}
c0023c73:	83 c4 0c             	add    $0xc,%esp
c0023c76:	c3                   	ret    
  ASSERT (role < BLOCK_ROLE_CNT);
c0023c77:	83 ec 0c             	sub    $0xc,%esp
c0023c7a:	68 2d d9 02 c0       	push   $0xc002d92d
c0023c7f:	68 df cb 02 c0       	push   $0xc002cbdf
c0023c84:	68 80 b9 02 c0       	push   $0xc002b980
c0023c89:	6a 40                	push   $0x40
c0023c8b:	68 06 d9 02 c0       	push   $0xc002d906
c0023c90:	e8 ab 39 00 00       	call   c0027640 <debug_panic>

c0023c95 <block_first>:
{
c0023c95:	53                   	push   %ebx
c0023c96:	83 ec 14             	sub    $0x14,%esp
  return list_elem_to_block (list_begin (&all_blocks));
c0023c99:	68 74 67 03 c0       	push   $0xc0036774
c0023c9e:	e8 87 3a 00 00       	call   c002772a <list_begin>
c0023ca3:	89 c3                	mov    %eax,%ebx
/* Returns the block device corresponding to LIST_ELEM, or a null
   pointer if LIST_ELEM is the list end of all_blocks. */
static struct block *
list_elem_to_block (struct list_elem *list_elem)
{
  return (list_elem != list_end (&all_blocks)
c0023ca5:	c7 04 24 74 67 03 c0 	movl   $0xc0036774,(%esp)
c0023cac:	e8 f1 3a 00 00       	call   c00277a2 <list_end>
          ? list_entry (list_elem, struct block, list_elem)
          : NULL);
c0023cb1:	83 c4 10             	add    $0x10,%esp
c0023cb4:	39 c3                	cmp    %eax,%ebx
c0023cb6:	74 07                	je     c0023cbf <block_first+0x2a>
c0023cb8:	89 d8                	mov    %ebx,%eax
}
c0023cba:	83 c4 08             	add    $0x8,%esp
c0023cbd:	5b                   	pop    %ebx
c0023cbe:	c3                   	ret    
          : NULL);
c0023cbf:	b8 00 00 00 00       	mov    $0x0,%eax
  return list_elem_to_block (list_begin (&all_blocks));
c0023cc4:	eb f4                	jmp    c0023cba <block_first+0x25>

c0023cc6 <block_next>:
{
c0023cc6:	53                   	push   %ebx
c0023cc7:	83 ec 14             	sub    $0x14,%esp
  return list_elem_to_block (list_next (&block->list_elem));
c0023cca:	ff 74 24 1c          	pushl  0x1c(%esp)
c0023cce:	e8 87 3a 00 00       	call   c002775a <list_next>
c0023cd3:	89 c3                	mov    %eax,%ebx
  return (list_elem != list_end (&all_blocks)
c0023cd5:	c7 04 24 74 67 03 c0 	movl   $0xc0036774,(%esp)
c0023cdc:	e8 c1 3a 00 00       	call   c00277a2 <list_end>
          : NULL);
c0023ce1:	83 c4 10             	add    $0x10,%esp
c0023ce4:	39 c3                	cmp    %eax,%ebx
c0023ce6:	74 07                	je     c0023cef <block_next+0x29>
c0023ce8:	89 d8                	mov    %ebx,%eax
}
c0023cea:	83 c4 08             	add    $0x8,%esp
c0023ced:	5b                   	pop    %ebx
c0023cee:	c3                   	ret    
          : NULL);
c0023cef:	b8 00 00 00 00       	mov    $0x0,%eax
  return list_elem_to_block (list_next (&block->list_elem));
c0023cf4:	eb f4                	jmp    c0023cea <block_next+0x24>

c0023cf6 <block_get_by_name>:
{
c0023cf6:	56                   	push   %esi
c0023cf7:	53                   	push   %ebx
c0023cf8:	83 ec 10             	sub    $0x10,%esp
c0023cfb:	8b 74 24 1c          	mov    0x1c(%esp),%esi
  for (e = list_begin (&all_blocks); e != list_end (&all_blocks);
c0023cff:	68 74 67 03 c0       	push   $0xc0036774
c0023d04:	e8 21 3a 00 00       	call   c002772a <list_begin>
c0023d09:	89 c3                	mov    %eax,%ebx
c0023d0b:	83 c4 10             	add    $0x10,%esp
c0023d0e:	83 ec 0c             	sub    $0xc,%esp
c0023d11:	68 74 67 03 c0       	push   $0xc0036774
c0023d16:	e8 87 3a 00 00       	call   c00277a2 <list_end>
c0023d1b:	83 c4 10             	add    $0x10,%esp
c0023d1e:	39 c3                	cmp    %eax,%ebx
c0023d20:	74 24                	je     c0023d46 <block_get_by_name+0x50>
      if (!strcmp (name, block->name))
c0023d22:	8d 43 08             	lea    0x8(%ebx),%eax
c0023d25:	83 ec 08             	sub    $0x8,%esp
c0023d28:	50                   	push   %eax
c0023d29:	56                   	push   %esi
c0023d2a:	e8 c6 2c 00 00       	call   c00269f5 <strcmp>
c0023d2f:	83 c4 10             	add    $0x10,%esp
c0023d32:	85 c0                	test   %eax,%eax
c0023d34:	74 1b                	je     c0023d51 <block_get_by_name+0x5b>
       e = list_next (e))
c0023d36:	83 ec 0c             	sub    $0xc,%esp
c0023d39:	53                   	push   %ebx
c0023d3a:	e8 1b 3a 00 00       	call   c002775a <list_next>
c0023d3f:	89 c3                	mov    %eax,%ebx
c0023d41:	83 c4 10             	add    $0x10,%esp
c0023d44:	eb c8                	jmp    c0023d0e <block_get_by_name+0x18>
  return NULL;
c0023d46:	b8 00 00 00 00       	mov    $0x0,%eax
}
c0023d4b:	83 c4 04             	add    $0x4,%esp
c0023d4e:	5b                   	pop    %ebx
c0023d4f:	5e                   	pop    %esi
c0023d50:	c3                   	ret    
c0023d51:	89 d8                	mov    %ebx,%eax
c0023d53:	eb f6                	jmp    c0023d4b <block_get_by_name+0x55>

c0023d55 <block_read>:
{
c0023d55:	56                   	push   %esi
c0023d56:	53                   	push   %ebx
c0023d57:	83 ec 04             	sub    $0x4,%esp
c0023d5a:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0023d5e:	8b 74 24 14          	mov    0x14(%esp),%esi
  check_sector (block, sector);
c0023d62:	89 f2                	mov    %esi,%edx
c0023d64:	89 d8                	mov    %ebx,%eax
c0023d66:	e8 60 fe ff ff       	call   c0023bcb <check_sector>
  block->ops->read (block->aux, sector, buffer);
c0023d6b:	83 ec 04             	sub    $0x4,%esp
c0023d6e:	8b 43 20             	mov    0x20(%ebx),%eax
c0023d71:	ff 74 24 1c          	pushl  0x1c(%esp)
c0023d75:	56                   	push   %esi
c0023d76:	ff 73 24             	pushl  0x24(%ebx)
c0023d79:	ff 10                	call   *(%eax)
  block->read_cnt++;
c0023d7b:	83 43 28 01          	addl   $0x1,0x28(%ebx)
c0023d7f:	83 53 2c 00          	adcl   $0x0,0x2c(%ebx)
}
c0023d83:	83 c4 14             	add    $0x14,%esp
c0023d86:	5b                   	pop    %ebx
c0023d87:	5e                   	pop    %esi
c0023d88:	c3                   	ret    

c0023d89 <block_write>:
{
c0023d89:	56                   	push   %esi
c0023d8a:	53                   	push   %ebx
c0023d8b:	83 ec 04             	sub    $0x4,%esp
c0023d8e:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0023d92:	8b 74 24 14          	mov    0x14(%esp),%esi
  check_sector (block, sector);
c0023d96:	89 f2                	mov    %esi,%edx
c0023d98:	89 d8                	mov    %ebx,%eax
c0023d9a:	e8 2c fe ff ff       	call   c0023bcb <check_sector>
  ASSERT (block->type != BLOCK_FOREIGN);
c0023d9f:	83 7b 18 05          	cmpl   $0x5,0x18(%ebx)
c0023da3:	74 1f                	je     c0023dc4 <block_write+0x3b>
  block->ops->write (block->aux, sector, buffer);
c0023da5:	83 ec 04             	sub    $0x4,%esp
c0023da8:	8b 43 20             	mov    0x20(%ebx),%eax
c0023dab:	ff 74 24 1c          	pushl  0x1c(%esp)
c0023daf:	56                   	push   %esi
c0023db0:	ff 73 24             	pushl  0x24(%ebx)
c0023db3:	ff 50 04             	call   *0x4(%eax)
  block->write_cnt++;
c0023db6:	83 43 30 01          	addl   $0x1,0x30(%ebx)
c0023dba:	83 53 34 00          	adcl   $0x0,0x34(%ebx)
}
c0023dbe:	83 c4 14             	add    $0x14,%esp
c0023dc1:	5b                   	pop    %ebx
c0023dc2:	5e                   	pop    %esi
c0023dc3:	c3                   	ret    
  ASSERT (block->type != BLOCK_FOREIGN);
c0023dc4:	83 ec 0c             	sub    $0xc,%esp
c0023dc7:	68 43 d9 02 c0       	push   $0xc002d943
c0023dcc:	68 df cb 02 c0       	push   $0xc002cbdf
c0023dd1:	68 64 b9 02 c0       	push   $0xc002b964
c0023dd6:	68 89 00 00 00       	push   $0x89
c0023ddb:	68 06 d9 02 c0       	push   $0xc002d906
c0023de0:	e8 5b 38 00 00       	call   c0027640 <debug_panic>

c0023de5 <block_size>:
  return block->size;
c0023de5:	8b 44 24 04          	mov    0x4(%esp),%eax
c0023de9:	8b 40 1c             	mov    0x1c(%eax),%eax
}
c0023dec:	c3                   	ret    

c0023ded <block_name>:
  return block->name;
c0023ded:	8b 44 24 04          	mov    0x4(%esp),%eax
c0023df1:	83 c0 08             	add    $0x8,%eax
}
c0023df4:	c3                   	ret    

c0023df5 <block_type>:
  return block->type;
c0023df5:	8b 44 24 04          	mov    0x4(%esp),%eax
c0023df9:	8b 40 18             	mov    0x18(%eax),%eax
}
c0023dfc:	c3                   	ret    

c0023dfd <block_print_stats>:
{
c0023dfd:	57                   	push   %edi
c0023dfe:	56                   	push   %esi
c0023dff:	53                   	push   %ebx
c0023e00:	be 2c 80 03 c0       	mov    $0xc003802c,%esi
c0023e05:	bf 3c 80 03 c0       	mov    $0xc003803c,%edi
c0023e0a:	eb 07                	jmp    c0023e13 <block_print_stats+0x16>
c0023e0c:	83 c6 04             	add    $0x4,%esi
  for (i = 0; i < BLOCK_ROLE_CNT; i++)
c0023e0f:	39 fe                	cmp    %edi,%esi
c0023e11:	74 34                	je     c0023e47 <block_print_stats+0x4a>
      struct block *block = block_by_role[i];
c0023e13:	8b 1e                	mov    (%esi),%ebx
      if (block != NULL)
c0023e15:	85 db                	test   %ebx,%ebx
c0023e17:	74 f3                	je     c0023e0c <block_print_stats+0xf>
          printf ("%s (%s): %llu reads, %llu writes\n",
c0023e19:	83 ec 0c             	sub    $0xc,%esp
c0023e1c:	ff 73 18             	pushl  0x18(%ebx)
c0023e1f:	e8 ce fd ff ff       	call   c0023bf2 <block_type_name>
c0023e24:	83 c4 0c             	add    $0xc,%esp
c0023e27:	ff 73 34             	pushl  0x34(%ebx)
c0023e2a:	ff 73 30             	pushl  0x30(%ebx)
c0023e2d:	ff 73 2c             	pushl  0x2c(%ebx)
c0023e30:	ff 73 28             	pushl  0x28(%ebx)
c0023e33:	50                   	push   %eax
c0023e34:	83 c3 08             	add    $0x8,%ebx
c0023e37:	53                   	push   %ebx
c0023e38:	68 ac d8 02 c0       	push   $0xc002d8ac
c0023e3d:	e8 50 1d 00 00       	call   c0025b92 <printf>
c0023e42:	83 c4 20             	add    $0x20,%esp
c0023e45:	eb c5                	jmp    c0023e0c <block_print_stats+0xf>
}
c0023e47:	5b                   	pop    %ebx
c0023e48:	5e                   	pop    %esi
c0023e49:	5f                   	pop    %edi
c0023e4a:	c3                   	ret    

c0023e4b <block_register>:
{
c0023e4b:	55                   	push   %ebp
c0023e4c:	57                   	push   %edi
c0023e4d:	56                   	push   %esi
c0023e4e:	53                   	push   %ebx
c0023e4f:	83 ec 18             	sub    $0x18,%esp
c0023e52:	8b 74 24 34          	mov    0x34(%esp),%esi
c0023e56:	8b 7c 24 38          	mov    0x38(%esp),%edi
  struct block *block = malloc (sizeof *block);
c0023e5a:	6a 38                	push   $0x38
c0023e5c:	e8 50 ee ff ff       	call   c0022cb1 <malloc>
  if (block == NULL)
c0023e61:	83 c4 10             	add    $0x10,%esp
c0023e64:	85 c0                	test   %eax,%eax
c0023e66:	0f 84 b6 00 00 00    	je     c0023f22 <block_register+0xd7>
c0023e6c:	89 c3                	mov    %eax,%ebx
  list_push_back (&all_blocks, &block->list_elem);
c0023e6e:	83 ec 08             	sub    $0x8,%esp
c0023e71:	50                   	push   %eax
c0023e72:	68 74 67 03 c0       	push   $0xc0036774
c0023e77:	e8 08 3d 00 00       	call   c0027b84 <list_push_back>
  strlcpy (block->name, name, sizeof block->name);
c0023e7c:	8d 6b 08             	lea    0x8(%ebx),%ebp
c0023e7f:	83 c4 0c             	add    $0xc,%esp
c0023e82:	6a 10                	push   $0x10
c0023e84:	ff 74 24 28          	pushl  0x28(%esp)
c0023e88:	55                   	push   %ebp
c0023e89:	e8 ac 2e 00 00       	call   c0026d3a <strlcpy>
  block->type = type;
c0023e8e:	8b 44 24 34          	mov    0x34(%esp),%eax
c0023e92:	89 43 18             	mov    %eax,0x18(%ebx)
  block->size = size;
c0023e95:	89 7b 1c             	mov    %edi,0x1c(%ebx)
  block->ops = ops;
c0023e98:	8b 44 24 40          	mov    0x40(%esp),%eax
c0023e9c:	89 43 20             	mov    %eax,0x20(%ebx)
  block->aux = aux;
c0023e9f:	8b 44 24 44          	mov    0x44(%esp),%eax
c0023ea3:	89 43 24             	mov    %eax,0x24(%ebx)
  block->read_cnt = 0;
c0023ea6:	c7 43 28 00 00 00 00 	movl   $0x0,0x28(%ebx)
c0023ead:	c7 43 2c 00 00 00 00 	movl   $0x0,0x2c(%ebx)
  block->write_cnt = 0;
c0023eb4:	c7 43 30 00 00 00 00 	movl   $0x0,0x30(%ebx)
c0023ebb:	c7 43 34 00 00 00 00 	movl   $0x0,0x34(%ebx)
  printf ("%s: %'"PRDSNu" sectors (", block->name, block->size);
c0023ec2:	83 c4 0c             	add    $0xc,%esp
c0023ec5:	57                   	push   %edi
c0023ec6:	55                   	push   %ebp
c0023ec7:	68 60 d9 02 c0       	push   $0xc002d960
c0023ecc:	e8 c1 1c 00 00       	call   c0025b92 <printf>
  print_human_readable_size ((uint64_t) block->size * BLOCK_SECTOR_SIZE);
c0023ed1:	83 c4 08             	add    $0x8,%esp
c0023ed4:	8b 43 1c             	mov    0x1c(%ebx),%eax
c0023ed7:	ba 00 00 00 00       	mov    $0x0,%edx
c0023edc:	0f a4 c2 09          	shld   $0x9,%eax,%edx
c0023ee0:	c1 e0 09             	shl    $0x9,%eax
c0023ee3:	52                   	push   %edx
c0023ee4:	50                   	push   %eax
c0023ee5:	e8 4c 26 00 00       	call   c0026536 <print_human_readable_size>
  printf (")");
c0023eea:	c7 04 24 29 00 00 00 	movl   $0x29,(%esp)
c0023ef1:	e8 04 52 00 00       	call   c00290fa <putchar>
  if (extra_info != NULL)
c0023ef6:	83 c4 10             	add    $0x10,%esp
c0023ef9:	85 f6                	test   %esi,%esi
c0023efb:	74 11                	je     c0023f0e <block_register+0xc3>
    printf (", %s", extra_info);
c0023efd:	83 ec 08             	sub    $0x8,%esp
c0023f00:	56                   	push   %esi
c0023f01:	68 72 d9 02 c0       	push   $0xc002d972
c0023f06:	e8 87 1c 00 00       	call   c0025b92 <printf>
c0023f0b:	83 c4 10             	add    $0x10,%esp
  printf ("\n");
c0023f0e:	83 ec 0c             	sub    $0xc,%esp
c0023f11:	6a 0a                	push   $0xa
c0023f13:	e8 e2 51 00 00       	call   c00290fa <putchar>
}
c0023f18:	89 d8                	mov    %ebx,%eax
c0023f1a:	83 c4 1c             	add    $0x1c,%esp
c0023f1d:	5b                   	pop    %ebx
c0023f1e:	5e                   	pop    %esi
c0023f1f:	5f                   	pop    %edi
c0023f20:	5d                   	pop    %ebp
c0023f21:	c3                   	ret    
    PANIC ("Failed to allocate memory for block device descriptor");
c0023f22:	68 d0 d8 02 c0       	push   $0xc002d8d0
c0023f27:	68 54 b9 02 c0       	push   $0xc002b954
c0023f2c:	68 c1 00 00 00       	push   $0xc1
c0023f31:	68 06 d9 02 c0       	push   $0xc002d906
c0023f36:	e8 05 37 00 00       	call   c0027640 <debug_panic>

c0023f3b <partition_read>:

/* Reads sector SECTOR from partition P into BUFFER, which must
   have room for BLOCK_SECTOR_SIZE bytes. */
static void
partition_read (void *p_, block_sector_t sector, void *buffer)
{
c0023f3b:	83 ec 10             	sub    $0x10,%esp
c0023f3e:	8b 54 24 14          	mov    0x14(%esp),%edx
  struct partition *p = p_;
  block_read (p->block, p->start + sector, buffer);
c0023f42:	ff 74 24 1c          	pushl  0x1c(%esp)
c0023f46:	8b 42 04             	mov    0x4(%edx),%eax
c0023f49:	03 44 24 1c          	add    0x1c(%esp),%eax
c0023f4d:	50                   	push   %eax
c0023f4e:	ff 32                	pushl  (%edx)
c0023f50:	e8 00 fe ff ff       	call   c0023d55 <block_read>
}
c0023f55:	83 c4 1c             	add    $0x1c,%esp
c0023f58:	c3                   	ret    

c0023f59 <read_partition_table>:
{
c0023f59:	55                   	push   %ebp
c0023f5a:	57                   	push   %edi
c0023f5b:	56                   	push   %esi
c0023f5c:	53                   	push   %ebx
c0023f5d:	81 ec c8 00 00 00    	sub    $0xc8,%esp
c0023f63:	89 c3                	mov    %eax,%ebx
c0023f65:	89 d6                	mov    %edx,%esi
c0023f67:	89 4c 24 0c          	mov    %ecx,0xc(%esp)
  if (sector >= block_size (block))
c0023f6b:	50                   	push   %eax
c0023f6c:	e8 74 fe ff ff       	call   c0023de5 <block_size>
c0023f71:	83 c4 10             	add    $0x10,%esp
c0023f74:	39 f0                	cmp    %esi,%eax
c0023f76:	76 6b                	jbe    c0023fe3 <read_partition_table+0x8a>
  pt = malloc (sizeof *pt);
c0023f78:	83 ec 0c             	sub    $0xc,%esp
c0023f7b:	68 00 02 00 00       	push   $0x200
c0023f80:	e8 2c ed ff ff       	call   c0022cb1 <malloc>
c0023f85:	89 c7                	mov    %eax,%edi
  if (pt == NULL)
c0023f87:	83 c4 10             	add    $0x10,%esp
c0023f8a:	85 c0                	test   %eax,%eax
c0023f8c:	74 72                	je     c0024000 <read_partition_table+0xa7>
  block_read (block, 0, pt);
c0023f8e:	83 ec 04             	sub    $0x4,%esp
c0023f91:	50                   	push   %eax
c0023f92:	6a 00                	push   $0x0
c0023f94:	53                   	push   %ebx
c0023f95:	e8 bb fd ff ff       	call   c0023d55 <block_read>
  if (pt->signature != 0xaa55)
c0023f9a:	83 c4 10             	add    $0x10,%esp
c0023f9d:	66 81 bf fe 01 00 00 	cmpw   $0xaa55,0x1fe(%edi)
c0023fa4:	55 aa 
c0023fa6:	0f 84 87 00 00 00    	je     c0024033 <read_partition_table+0xda>
      if (primary_extended_sector == 0)
c0023fac:	83 3c 24 00          	cmpl   $0x0,(%esp)
c0023fb0:	75 64                	jne    c0024016 <read_partition_table+0xbd>
        printf ("%s: Invalid partition table signature\n", block_name (block));
c0023fb2:	83 ec 0c             	sub    $0xc,%esp
c0023fb5:	53                   	push   %ebx
c0023fb6:	e8 32 fe ff ff       	call   c0023ded <block_name>
c0023fbb:	83 c4 08             	add    $0x8,%esp
c0023fbe:	50                   	push   %eax
c0023fbf:	68 8c de 02 c0       	push   $0xc002de8c
c0023fc4:	e8 c9 1b 00 00       	call   c0025b92 <printf>
c0023fc9:	83 c4 10             	add    $0x10,%esp
      free (pt);
c0023fcc:	83 ec 0c             	sub    $0xc,%esp
c0023fcf:	57                   	push   %edi
c0023fd0:	e8 7d ee ff ff       	call   c0022e52 <free>
      return;
c0023fd5:	83 c4 10             	add    $0x10,%esp
}
c0023fd8:	81 c4 bc 00 00 00    	add    $0xbc,%esp
c0023fde:	5b                   	pop    %ebx
c0023fdf:	5e                   	pop    %esi
c0023fe0:	5f                   	pop    %edi
c0023fe1:	5d                   	pop    %ebp
c0023fe2:	c3                   	ret    
      printf ("%s: Partition table at sector %"PRDSNu" past end of device.\n",
c0023fe3:	83 ec 0c             	sub    $0xc,%esp
c0023fe6:	53                   	push   %ebx
c0023fe7:	e8 01 fe ff ff       	call   c0023ded <block_name>
c0023fec:	83 c4 0c             	add    $0xc,%esp
c0023fef:	56                   	push   %esi
c0023ff0:	50                   	push   %eax
c0023ff1:	68 24 de 02 c0       	push   $0xc002de24
c0023ff6:	e8 97 1b 00 00       	call   c0025b92 <printf>
      return;
c0023ffb:	83 c4 10             	add    $0x10,%esp
c0023ffe:	eb d8                	jmp    c0023fd8 <read_partition_table+0x7f>
    PANIC ("Failed to allocate memory for partition table.");
c0024000:	68 5c de 02 c0       	push   $0xc002de5c
c0024005:	68 f0 bd 02 c0       	push   $0xc002bdf0
c002400a:	6a 5a                	push   $0x5a
c002400c:	68 93 d9 02 c0       	push   $0xc002d993
c0024011:	e8 2a 36 00 00       	call   c0027640 <debug_panic>
        printf ("%s: Invalid extended partition table in sector %"PRDSNu"\n",
c0024016:	83 ec 0c             	sub    $0xc,%esp
c0024019:	53                   	push   %ebx
c002401a:	e8 ce fd ff ff       	call   c0023ded <block_name>
c002401f:	83 c4 0c             	add    $0xc,%esp
c0024022:	56                   	push   %esi
c0024023:	50                   	push   %eax
c0024024:	68 b4 de 02 c0       	push   $0xc002deb4
c0024029:	e8 64 1b 00 00       	call   c0025b92 <printf>
c002402e:	83 c4 10             	add    $0x10,%esp
c0024031:	eb 99                	jmp    c0023fcc <read_partition_table+0x73>
c0024033:	8d af c2 01 00 00    	lea    0x1c2(%edi),%ebp
c0024039:	8d 87 02 02 00 00    	lea    0x202(%edi),%eax
c002403f:	89 44 24 04          	mov    %eax,0x4(%esp)
      snprintf (extra_info, sizeof extra_info, "%s (%02x)",
c0024043:	89 7c 24 0c          	mov    %edi,0xc(%esp)
c0024047:	89 5c 24 08          	mov    %ebx,0x8(%esp)
c002404b:	89 74 24 10          	mov    %esi,0x10(%esp)
c002404f:	eb 51                	jmp    c00240a2 <read_partition_table+0x149>
          printf ("%s: Extended partition in sector %"PRDSNu"\n",
c0024051:	83 ec 0c             	sub    $0xc,%esp
c0024054:	8b 5c 24 14          	mov    0x14(%esp),%ebx
c0024058:	53                   	push   %ebx
c0024059:	e8 8f fd ff ff       	call   c0023ded <block_name>
c002405e:	83 c4 0c             	add    $0xc,%esp
c0024061:	8b 74 24 14          	mov    0x14(%esp),%esi
c0024065:	56                   	push   %esi
c0024066:	50                   	push   %eax
c0024067:	68 e8 de 02 c0       	push   $0xc002dee8
c002406c:	e8 21 1b 00 00       	call   c0025b92 <printf>
          if (sector == 0)
c0024071:	83 c4 10             	add    $0x10,%esp
c0024074:	85 f6                	test   %esi,%esi
c0024076:	0f 85 33 01 00 00    	jne    c00241af <read_partition_table+0x256>
            read_partition_table (block, e->offset, e->offset, part_nr);
c002407c:	8b 57 04             	mov    0x4(%edi),%edx
c002407f:	83 ec 0c             	sub    $0xc,%esp
c0024082:	ff b4 24 dc 00 00 00 	pushl  0xdc(%esp)
c0024089:	89 d1                	mov    %edx,%ecx
c002408b:	89 d8                	mov    %ebx,%eax
c002408d:	e8 c7 fe ff ff       	call   c0023f59 <read_partition_table>
c0024092:	83 c4 10             	add    $0x10,%esp
c0024095:	83 c5 10             	add    $0x10,%ebp
  for (i = 0; i < sizeof pt->partitions / sizeof *pt->partitions; i++)
c0024098:	3b 6c 24 04          	cmp    0x4(%esp),%ebp
c002409c:	0f 84 b1 01 00 00    	je     c0024253 <read_partition_table+0x2fa>
c00240a2:	89 ef                	mov    %ebp,%edi
      if (e->size == 0 || e->type == 0)
c00240a4:	8b 75 08             	mov    0x8(%ebp),%esi
c00240a7:	85 f6                	test   %esi,%esi
c00240a9:	74 ea                	je     c0024095 <read_partition_table+0x13c>
c00240ab:	8a 5d 00             	mov    0x0(%ebp),%bl
c00240ae:	84 db                	test   %bl,%bl
c00240b0:	74 e3                	je     c0024095 <read_partition_table+0x13c>
      else if (e->type == 0x05       /* Extended partition. */
c00240b2:	88 d8                	mov    %bl,%al
c00240b4:	83 e0 7f             	and    $0x7f,%eax
c00240b7:	3c 05                	cmp    $0x5,%al
c00240b9:	74 96                	je     c0024051 <read_partition_table+0xf8>
               || e->type == 0x0f    /* Windows 98 extended partition. */
c00240bb:	80 fb 0f             	cmp    $0xf,%bl
c00240be:	74 91                	je     c0024051 <read_partition_table+0xf8>
               || e->type == 0xc5)   /* DR-DOS extended partition. */
c00240c0:	80 fb c5             	cmp    $0xc5,%bl
c00240c3:	74 8c                	je     c0024051 <read_partition_table+0xf8>
          ++*part_nr;
c00240c5:	8b 84 24 d0 00 00 00 	mov    0xd0(%esp),%eax
c00240cc:	8b 00                	mov    (%eax),%eax
c00240ce:	40                   	inc    %eax
c00240cf:	89 44 24 18          	mov    %eax,0x18(%esp)
c00240d3:	8b 94 24 d0 00 00 00 	mov    0xd0(%esp),%edx
c00240da:	89 02                	mov    %eax,(%edx)
          found_partition (block, e->type, e->offset + sector,
c00240dc:	8b 44 24 10          	mov    0x10(%esp),%eax
c00240e0:	03 45 04             	add    0x4(%ebp),%eax
c00240e3:	89 c7                	mov    %eax,%edi
c00240e5:	89 44 24 14          	mov    %eax,0x14(%esp)
  if (start >= block_size (block))
c00240e9:	83 ec 0c             	sub    $0xc,%esp
c00240ec:	ff 74 24 14          	pushl  0x14(%esp)
c00240f0:	e8 f0 fc ff ff       	call   c0023de5 <block_size>
c00240f5:	83 c4 10             	add    $0x10,%esp
c00240f8:	39 c7                	cmp    %eax,%edi
c00240fa:	0f 83 d2 00 00 00    	jae    c00241d2 <read_partition_table+0x279>
  else if (start + size < start || start + size > block_size (block))
c0024100:	8b 7c 24 14          	mov    0x14(%esp),%edi
c0024104:	01 f7                	add    %esi,%edi
c0024106:	0f 82 ed 00 00 00    	jb     c00241f9 <read_partition_table+0x2a0>
c002410c:	83 ec 0c             	sub    $0xc,%esp
c002410f:	ff 74 24 14          	pushl  0x14(%esp)
c0024113:	e8 cd fc ff ff       	call   c0023de5 <block_size>
c0024118:	83 c4 10             	add    $0x10,%esp
c002411b:	39 c7                	cmp    %eax,%edi
c002411d:	0f 87 d6 00 00 00    	ja     c00241f9 <read_partition_table+0x2a0>
          found_partition (block, e->type, e->offset + sector,
c0024123:	0f b6 fb             	movzbl %bl,%edi
                              : part_type == 0x21 ? BLOCK_FILESYS
c0024126:	80 fb 20             	cmp    $0x20,%bl
c0024129:	0f 84 39 01 00 00    	je     c0024268 <read_partition_table+0x30f>
c002412f:	80 fb 21             	cmp    $0x21,%bl
c0024132:	0f 84 c2 01 00 00    	je     c00242fa <read_partition_table+0x3a1>
c0024138:	80 fb 22             	cmp    $0x22,%bl
c002413b:	0f 84 c6 01 00 00    	je     c0024307 <read_partition_table+0x3ae>
c0024141:	80 fb 23             	cmp    $0x23,%bl
c0024144:	0f 84 ca 01 00 00    	je     c0024314 <read_partition_table+0x3bb>
      p = malloc (sizeof *p);
c002414a:	83 ec 0c             	sub    $0xc,%esp
c002414d:	6a 08                	push   $0x8
c002414f:	e8 5d eb ff ff       	call   c0022cb1 <malloc>
c0024154:	89 c3                	mov    %eax,%ebx
      if (p == NULL)
c0024156:	83 c4 10             	add    $0x10,%esp
c0024159:	85 c0                	test   %eax,%eax
c002415b:	0f 84 ca 00 00 00    	je     c002422b <read_partition_table+0x2d2>
      p->block = block;
c0024161:	8b 44 24 08          	mov    0x8(%esp),%eax
c0024165:	89 03                	mov    %eax,(%ebx)
      p->start = start;
c0024167:	8b 4c 24 14          	mov    0x14(%esp),%ecx
c002416b:	89 4b 04             	mov    %ecx,0x4(%ebx)
      snprintf (name, sizeof name, "%s%d", block_name (block), part_nr);
c002416e:	83 ec 0c             	sub    $0xc,%esp
c0024171:	50                   	push   %eax
c0024172:	e8 76 fc ff ff       	call   c0023ded <block_name>
c0024177:	83 c4 04             	add    $0x4,%esp
c002417a:	ff 74 24 24          	pushl  0x24(%esp)
c002417e:	50                   	push   %eax
c002417f:	68 ad d9 02 c0       	push   $0xc002d9ad
c0024184:	6a 10                	push   $0x10
c0024186:	8d 44 24 3c          	lea    0x3c(%esp),%eax
c002418a:	50                   	push   %eax
c002418b:	e8 8e 21 00 00       	call   c002631e <snprintf>
  return type_names[type] != NULL ? type_names[type] : "Unknown";
c0024190:	8b 04 bd e0 b9 02 c0 	mov    -0x3ffd4620(,%edi,4),%eax
c0024197:	83 c4 20             	add    $0x20,%esp
c002419a:	85 c0                	test   %eax,%eax
c002419c:	0f 84 a2 00 00 00    	je     c0024244 <read_partition_table+0x2eb>
                              : part_type == 0x21 ? BLOCK_FILESYS
c00241a2:	c7 44 24 1c 05 00 00 	movl   $0x5,0x1c(%esp)
c00241a9:	00 
c00241aa:	e9 0d 01 00 00       	jmp    c00242bc <read_partition_table+0x363>
            read_partition_table (block, e->offset + primary_extended_sector,
c00241af:	8b 0c 24             	mov    (%esp),%ecx
c00241b2:	89 ca                	mov    %ecx,%edx
c00241b4:	03 57 04             	add    0x4(%edi),%edx
c00241b7:	83 ec 0c             	sub    $0xc,%esp
c00241ba:	ff b4 24 dc 00 00 00 	pushl  0xdc(%esp)
c00241c1:	8b 44 24 18          	mov    0x18(%esp),%eax
c00241c5:	e8 8f fd ff ff       	call   c0023f59 <read_partition_table>
c00241ca:	83 c4 10             	add    $0x10,%esp
c00241cd:	e9 c3 fe ff ff       	jmp    c0024095 <read_partition_table+0x13c>
    printf ("%s%d: Partition starts past end of device (sector %"PRDSNu")\n",
c00241d2:	83 ec 0c             	sub    $0xc,%esp
c00241d5:	ff 74 24 14          	pushl  0x14(%esp)
c00241d9:	e8 0f fc ff ff       	call   c0023ded <block_name>
c00241de:	ff 74 24 24          	pushl  0x24(%esp)
c00241e2:	ff 74 24 2c          	pushl  0x2c(%esp)
c00241e6:	50                   	push   %eax
c00241e7:	68 10 df 02 c0       	push   $0xc002df10
c00241ec:	e8 a1 19 00 00       	call   c0025b92 <printf>
c00241f1:	83 c4 20             	add    $0x20,%esp
c00241f4:	e9 9c fe ff ff       	jmp    c0024095 <read_partition_table+0x13c>
    printf ("%s%d: Partition end (%"PRDSNu") past end of device (%"PRDSNu")\n",
c00241f9:	83 ec 0c             	sub    $0xc,%esp
c00241fc:	8b 74 24 14          	mov    0x14(%esp),%esi
c0024200:	56                   	push   %esi
c0024201:	e8 df fb ff ff       	call   c0023de5 <block_size>
c0024206:	89 c3                	mov    %eax,%ebx
c0024208:	89 34 24             	mov    %esi,(%esp)
c002420b:	e8 dd fb ff ff       	call   c0023ded <block_name>
c0024210:	89 1c 24             	mov    %ebx,(%esp)
c0024213:	57                   	push   %edi
c0024214:	ff 74 24 2c          	pushl  0x2c(%esp)
c0024218:	50                   	push   %eax
c0024219:	68 48 df 02 c0       	push   $0xc002df48
c002421e:	e8 6f 19 00 00       	call   c0025b92 <printf>
c0024223:	83 c4 20             	add    $0x20,%esp
c0024226:	e9 6a fe ff ff       	jmp    c0024095 <read_partition_table+0x13c>
        PANIC ("Failed to allocate memory for partition descriptor");
c002422b:	68 7c df 02 c0       	push   $0xc002df7c
c0024230:	68 e0 bd 02 c0       	push   $0xc002bde0
c0024235:	68 b1 00 00 00       	push   $0xb1
c002423a:	68 93 d9 02 c0       	push   $0xc002d993
c002423f:	e8 fc 33 00 00       	call   c0027640 <debug_panic>
                              : part_type == 0x21 ? BLOCK_FILESYS
c0024244:	c7 44 24 1c 05 00 00 	movl   $0x5,0x1c(%esp)
c002424b:	00 
  return type_names[type] != NULL ? type_names[type] : "Unknown";
c002424c:	b8 8b d9 02 c0       	mov    $0xc002d98b,%eax
c0024251:	eb 69                	jmp    c00242bc <read_partition_table+0x363>
c0024253:	8b 7c 24 0c          	mov    0xc(%esp),%edi
  free (pt);
c0024257:	83 ec 0c             	sub    $0xc,%esp
c002425a:	57                   	push   %edi
c002425b:	e8 f2 eb ff ff       	call   c0022e52 <free>
c0024260:	83 c4 10             	add    $0x10,%esp
c0024263:	e9 70 fd ff ff       	jmp    c0023fd8 <read_partition_table+0x7f>
                              : part_type == 0x21 ? BLOCK_FILESYS
c0024268:	c7 44 24 1c 00 00 00 	movl   $0x0,0x1c(%esp)
c002426f:	00 
      p = malloc (sizeof *p);
c0024270:	83 ec 0c             	sub    $0xc,%esp
c0024273:	6a 08                	push   $0x8
c0024275:	e8 37 ea ff ff       	call   c0022cb1 <malloc>
c002427a:	89 c3                	mov    %eax,%ebx
      if (p == NULL)
c002427c:	83 c4 10             	add    $0x10,%esp
c002427f:	85 c0                	test   %eax,%eax
c0024281:	74 a8                	je     c002422b <read_partition_table+0x2d2>
      p->block = block;
c0024283:	8b 44 24 08          	mov    0x8(%esp),%eax
c0024287:	89 03                	mov    %eax,(%ebx)
      p->start = start;
c0024289:	8b 4c 24 14          	mov    0x14(%esp),%ecx
c002428d:	89 4b 04             	mov    %ecx,0x4(%ebx)
      snprintf (name, sizeof name, "%s%d", block_name (block), part_nr);
c0024290:	83 ec 0c             	sub    $0xc,%esp
c0024293:	50                   	push   %eax
c0024294:	e8 54 fb ff ff       	call   c0023ded <block_name>
c0024299:	83 c4 04             	add    $0x4,%esp
c002429c:	ff 74 24 24          	pushl  0x24(%esp)
c00242a0:	50                   	push   %eax
c00242a1:	68 ad d9 02 c0       	push   $0xc002d9ad
c00242a6:	6a 10                	push   $0x10
c00242a8:	8d 44 24 3c          	lea    0x3c(%esp),%eax
c00242ac:	50                   	push   %eax
c00242ad:	e8 6c 20 00 00       	call   c002631e <snprintf>
  return type_names[type] != NULL ? type_names[type] : "Unknown";
c00242b2:	8b 04 bd e0 b9 02 c0 	mov    -0x3ffd4620(,%edi,4),%eax
c00242b9:	83 c4 20             	add    $0x20,%esp
      snprintf (extra_info, sizeof extra_info, "%s (%02x)",
c00242bc:	83 ec 0c             	sub    $0xc,%esp
c00242bf:	57                   	push   %edi
c00242c0:	50                   	push   %eax
c00242c1:	68 b2 d9 02 c0       	push   $0xc002d9b2
c00242c6:	68 80 00 00 00       	push   $0x80
c00242cb:	8d 44 24 4c          	lea    0x4c(%esp),%eax
c00242cf:	50                   	push   %eax
c00242d0:	e8 49 20 00 00       	call   c002631e <snprintf>
      block_register (name, type, extra_info, size, &partition_operations, p);
c00242d5:	83 c4 18             	add    $0x18,%esp
c00242d8:	53                   	push   %ebx
c00242d9:	68 84 67 03 c0       	push   $0xc0036784
c00242de:	56                   	push   %esi
c00242df:	8d 44 24 44          	lea    0x44(%esp),%eax
c00242e3:	50                   	push   %eax
c00242e4:	ff 74 24 34          	pushl  0x34(%esp)
c00242e8:	8d 44 24 3c          	lea    0x3c(%esp),%eax
c00242ec:	50                   	push   %eax
c00242ed:	e8 59 fb ff ff       	call   c0023e4b <block_register>
c00242f2:	83 c4 20             	add    $0x20,%esp
c00242f5:	e9 9b fd ff ff       	jmp    c0024095 <read_partition_table+0x13c>
                              : part_type == 0x21 ? BLOCK_FILESYS
c00242fa:	c7 44 24 1c 01 00 00 	movl   $0x1,0x1c(%esp)
c0024301:	00 
c0024302:	e9 69 ff ff ff       	jmp    c0024270 <read_partition_table+0x317>
c0024307:	c7 44 24 1c 02 00 00 	movl   $0x2,0x1c(%esp)
c002430e:	00 
c002430f:	e9 5c ff ff ff       	jmp    c0024270 <read_partition_table+0x317>
c0024314:	c7 44 24 1c 03 00 00 	movl   $0x3,0x1c(%esp)
c002431b:	00 
c002431c:	e9 4f ff ff ff       	jmp    c0024270 <read_partition_table+0x317>

c0024321 <partition_write>:
/* Write sector SECTOR to partition P from BUFFER, which must
   contain BLOCK_SECTOR_SIZE bytes.  Returns after the block has
   acknowledged receiving the data. */
static void
partition_write (void *p_, block_sector_t sector, const void *buffer)
{
c0024321:	83 ec 10             	sub    $0x10,%esp
c0024324:	8b 54 24 14          	mov    0x14(%esp),%edx
  struct partition *p = p_;
  block_write (p->block, p->start + sector, buffer);
c0024328:	ff 74 24 1c          	pushl  0x1c(%esp)
c002432c:	8b 42 04             	mov    0x4(%edx),%eax
c002432f:	03 44 24 1c          	add    0x1c(%esp),%eax
c0024333:	50                   	push   %eax
c0024334:	ff 32                	pushl  (%edx)
c0024336:	e8 4e fa ff ff       	call   c0023d89 <block_write>
}
c002433b:	83 c4 1c             	add    $0x1c,%esp
c002433e:	c3                   	ret    

c002433f <partition_scan>:
{
c002433f:	83 ec 28             	sub    $0x28,%esp
  int part_nr = 0;
c0024342:	c7 44 24 18 00 00 00 	movl   $0x0,0x18(%esp)
c0024349:	00 
  read_partition_table (block, 0, 0, &part_nr);
c002434a:	8d 44 24 18          	lea    0x18(%esp),%eax
c002434e:	50                   	push   %eax
c002434f:	b9 00 00 00 00       	mov    $0x0,%ecx
c0024354:	ba 00 00 00 00       	mov    $0x0,%edx
c0024359:	8b 44 24 30          	mov    0x30(%esp),%eax
c002435d:	e8 f7 fb ff ff       	call   c0023f59 <read_partition_table>
  if (part_nr == 0)
c0024362:	83 c4 10             	add    $0x10,%esp
c0024365:	83 7c 24 0c 00       	cmpl   $0x0,0xc(%esp)
c002436a:	74 04                	je     c0024370 <partition_scan+0x31>
}
c002436c:	83 c4 1c             	add    $0x1c,%esp
c002436f:	c3                   	ret    
    printf ("%s: Device contains no partitions\n", block_name (block));
c0024370:	83 ec 0c             	sub    $0xc,%esp
c0024373:	ff 74 24 2c          	pushl  0x2c(%esp)
c0024377:	e8 71 fa ff ff       	call   c0023ded <block_name>
c002437c:	83 c4 08             	add    $0x8,%esp
c002437f:	50                   	push   %eax
c0024380:	68 b0 df 02 c0       	push   $0xc002dfb0
c0024385:	e8 08 18 00 00       	call   c0025b92 <printf>
c002438a:	83 c4 10             	add    $0x10,%esp
}
c002438d:	eb dd                	jmp    c002436c <partition_scan+0x2d>

c002438f <descramble_ata_string>:
/* Translates STRING, which consists of SIZE bytes in a funky
   format, into a null-terminated string in-place.  Drops
   trailing whitespace and null bytes.  Returns STRING.  */
static char *
descramble_ata_string (char *string, int size) 
{
c002438f:	57                   	push   %edi
c0024390:	56                   	push   %esi
c0024391:	53                   	push   %ebx
c0024392:	89 d7                	mov    %edx,%edi
  int i;

  /* Swap all pairs of bytes. */
  for (i = 0; i + 1 < size; i += 2)
c0024394:	83 fa 01             	cmp    $0x1,%edx
c0024397:	7e 1d                	jle    c00243b6 <descramble_ata_string+0x27>
c0024399:	89 c1                	mov    %eax,%ecx
c002439b:	8d 5a fe             	lea    -0x2(%edx),%ebx
c002439e:	83 e3 fe             	and    $0xfffffffe,%ebx
c00243a1:	8d 74 18 02          	lea    0x2(%eax,%ebx,1),%esi
    {
      char tmp = string[i];
c00243a5:	8a 19                	mov    (%ecx),%bl
      string[i] = string[i + 1];
c00243a7:	8a 51 01             	mov    0x1(%ecx),%dl
c00243aa:	88 11                	mov    %dl,(%ecx)
      string[i + 1] = tmp;
c00243ac:	88 59 01             	mov    %bl,0x1(%ecx)
c00243af:	83 c1 02             	add    $0x2,%ecx
  for (i = 0; i + 1 < size; i += 2)
c00243b2:	39 f1                	cmp    %esi,%ecx
c00243b4:	75 ef                	jne    c00243a5 <descramble_ata_string+0x16>
    }

  /* Find the last non-white, non-null character. */
  for (size--; size > 0; size--)
c00243b6:	8d 57 ff             	lea    -0x1(%edi),%edx
c00243b9:	85 d2                	test   %edx,%edx
c00243bb:	7f 05                	jg     c00243c2 <descramble_ata_string+0x33>
c00243bd:	eb 14                	jmp    c00243d3 <descramble_ata_string+0x44>
c00243bf:	4a                   	dec    %edx
c00243c0:	74 11                	je     c00243d3 <descramble_ata_string+0x44>
    {
      int c = string[size - 1];
c00243c2:	8a 4c 10 ff          	mov    -0x1(%eax,%edx,1),%cl
      if (c != '\0' && !isspace (c))
c00243c6:	f6 c1 df             	test   $0xdf,%cl
c00243c9:	74 f4                	je     c00243bf <descramble_ata_string+0x30>
          || c == '\r' || c == '\t' || c == '\v');
c00243cb:	83 e9 09             	sub    $0x9,%ecx
c00243ce:	80 f9 04             	cmp    $0x4,%cl
c00243d1:	76 ec                	jbe    c00243bf <descramble_ata_string+0x30>
        break; 
    }
  string[size] = '\0';
c00243d3:	c6 04 10 00          	movb   $0x0,(%eax,%edx,1)

  return string;
}
c00243d7:	5b                   	pop    %ebx
c00243d8:	5e                   	pop    %esi
c00243d9:	5f                   	pop    %edi
c00243da:	c3                   	ret    

c00243db <interrupt_handler>:
}

/* ATA interrupt handler. */
static void
interrupt_handler (struct intr_frame *f) 
{
c00243db:	83 ec 0c             	sub    $0xc,%esp
  struct channel *c;

  for (c = channels; c < channels + CHANNEL_CNT; c++)
    if (f->vec_no == c->irq)
c00243de:	8b 44 24 10          	mov    0x10(%esp),%eax
c00243e2:	8b 40 30             	mov    0x30(%eax),%eax
c00243e5:	0f b6 15 4a 80 03 c0 	movzbl 0xc003804a,%edx
c00243ec:	39 d0                	cmp    %edx,%eax
c00243ee:	74 29                	je     c0024419 <interrupt_handler+0x3e>
c00243f0:	0f b6 15 ae 80 03 c0 	movzbl 0xc00380ae,%edx
c00243f7:	b9 a4 80 03 c0       	mov    $0xc00380a4,%ecx
c00243fc:	39 c2                	cmp    %eax,%edx
c00243fe:	74 1e                	je     c002441e <interrupt_handler+0x43>
        else
          printf ("%s: unexpected interrupt\n", c->name);
        return;
      }

  NOT_REACHED ();
c0024400:	68 60 d0 02 c0       	push   $0xc002d060
c0024405:	68 58 be 02 c0       	push   $0xc002be58
c002440a:	68 0c 02 00 00       	push   $0x20c
c002440f:	68 ed df 02 c0       	push   $0xc002dfed
c0024414:	e8 27 32 00 00       	call   c0027640 <debug_panic>
  for (c = channels; c < channels + CHANNEL_CNT; c++)
c0024419:	b9 40 80 03 c0       	mov    $0xc0038040,%ecx
        if (c->expecting_interrupt) 
c002441e:	80 79 24 00          	cmpb   $0x0,0x24(%ecx)
c0024422:	74 1a                	je     c002443e <interrupt_handler+0x63>
            inb (reg_status (c));               /* Acknowledge interrupt. */
c0024424:	8b 41 08             	mov    0x8(%ecx),%eax
c0024427:	8d 50 07             	lea    0x7(%eax),%edx
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002442a:	ec                   	in     (%dx),%al
            sema_up (&c->completion_wait);      /* Wake up waiter. */
c002442b:	83 ec 0c             	sub    $0xc,%esp
c002442e:	83 c1 28             	add    $0x28,%ecx
c0024431:	51                   	push   %ecx
c0024432:	e8 9a dd ff ff       	call   c00221d1 <sema_up>
c0024437:	83 c4 10             	add    $0x10,%esp
}
c002443a:	83 c4 0c             	add    $0xc,%esp
c002443d:	c3                   	ret    
          printf ("%s: unexpected interrupt\n", c->name);
c002443e:	83 ec 08             	sub    $0x8,%esp
c0024441:	51                   	push   %ecx
c0024442:	68 d3 df 02 c0       	push   $0xc002dfd3
c0024447:	e8 46 17 00 00       	call   c0025b92 <printf>
c002444c:	83 c4 10             	add    $0x10,%esp
c002444f:	eb e9                	jmp    c002443a <interrupt_handler+0x5f>

c0024451 <wait_until_idle>:
{
c0024451:	56                   	push   %esi
c0024452:	53                   	push   %ebx
c0024453:	83 ec 04             	sub    $0x4,%esp
c0024456:	89 c6                	mov    %eax,%esi
      if ((inb (reg_status (d->channel)) & (STA_BSY | STA_DRQ)) == 0)
c0024458:	8b 40 08             	mov    0x8(%eax),%eax
c002445b:	8b 40 08             	mov    0x8(%eax),%eax
c002445e:	8d 50 07             	lea    0x7(%eax),%edx
c0024461:	ec                   	in     (%dx),%al
c0024462:	a8 88                	test   $0x88,%al
c0024464:	74 45                	je     c00244ab <wait_until_idle+0x5a>
      timer_usleep (10);
c0024466:	83 ec 08             	sub    $0x8,%esp
c0024469:	6a 00                	push   $0x0
c002446b:	6a 0a                	push   $0xa
c002446d:	e8 5c ef ff ff       	call   c00233ce <timer_usleep>
c0024472:	83 c4 10             	add    $0x10,%esp
c0024475:	bb e7 03 00 00       	mov    $0x3e7,%ebx
      if ((inb (reg_status (d->channel)) & (STA_BSY | STA_DRQ)) == 0)
c002447a:	8b 46 08             	mov    0x8(%esi),%eax
c002447d:	8b 40 08             	mov    0x8(%eax),%eax
c0024480:	8d 50 07             	lea    0x7(%eax),%edx
c0024483:	ec                   	in     (%dx),%al
c0024484:	a8 88                	test   $0x88,%al
c0024486:	74 23                	je     c00244ab <wait_until_idle+0x5a>
      timer_usleep (10);
c0024488:	83 ec 08             	sub    $0x8,%esp
c002448b:	6a 00                	push   $0x0
c002448d:	6a 0a                	push   $0xa
c002448f:	e8 3a ef ff ff       	call   c00233ce <timer_usleep>
  for (i = 0; i < 1000; i++) 
c0024494:	83 c4 10             	add    $0x10,%esp
c0024497:	4b                   	dec    %ebx
c0024498:	75 e0                	jne    c002447a <wait_until_idle+0x29>
  printf ("%s: idle timeout\n", d->name);
c002449a:	83 ec 08             	sub    $0x8,%esp
c002449d:	56                   	push   %esi
c002449e:	68 01 e0 02 c0       	push   $0xc002e001
c00244a3:	e8 ea 16 00 00       	call   c0025b92 <printf>
c00244a8:	83 c4 10             	add    $0x10,%esp
}
c00244ab:	83 c4 04             	add    $0x4,%esp
c00244ae:	5b                   	pop    %ebx
c00244af:	5e                   	pop    %esi
c00244b0:	c3                   	ret    

c00244b1 <select_device>:
{
c00244b1:	83 ec 0c             	sub    $0xc,%esp
  struct channel *c = d->channel;
c00244b4:	8b 50 08             	mov    0x8(%eax),%edx
  if (d->dev_no == 1)
c00244b7:	83 78 0c 01          	cmpl   $0x1,0xc(%eax)
c00244bb:	74 23                	je     c00244e0 <select_device+0x2f>
  uint8_t dev = DEV_MBS;
c00244bd:	b0 a0                	mov    $0xa0,%al
  outb (reg_device (c), dev);
c00244bf:	8b 4a 08             	mov    0x8(%edx),%ecx
c00244c2:	8d 51 06             	lea    0x6(%ecx),%edx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00244c5:	ee                   	out    %al,(%dx)
  inb (reg_alt_status (c));
c00244c6:	8d 91 06 02 00 00    	lea    0x206(%ecx),%edx
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c00244cc:	ec                   	in     (%dx),%al
  timer_nsleep (400);
c00244cd:	83 ec 08             	sub    $0x8,%esp
c00244d0:	6a 00                	push   $0x0
c00244d2:	68 90 01 00 00       	push   $0x190
c00244d7:	e8 0b ef ff ff       	call   c00233e7 <timer_nsleep>
}
c00244dc:	83 c4 1c             	add    $0x1c,%esp
c00244df:	c3                   	ret    
    dev |= DEV_DEV;
c00244e0:	b0 b0                	mov    $0xb0,%al
c00244e2:	eb db                	jmp    c00244bf <select_device+0xe>

c00244e4 <check_device_type>:
{
c00244e4:	56                   	push   %esi
c00244e5:	53                   	push   %ebx
c00244e6:	83 ec 14             	sub    $0x14,%esp
c00244e9:	89 c6                	mov    %eax,%esi
  struct channel *c = d->channel;
c00244eb:	8b 58 08             	mov    0x8(%eax),%ebx
  select_device (d);
c00244ee:	e8 be ff ff ff       	call   c00244b1 <select_device>
  error = inb (reg_error (c));
c00244f3:	8b 5b 08             	mov    0x8(%ebx),%ebx
c00244f6:	8d 53 01             	lea    0x1(%ebx),%edx
c00244f9:	ec                   	in     (%dx),%al
c00244fa:	88 c1                	mov    %al,%cl
  lbam = inb (reg_lbam (c));
c00244fc:	8d 53 04             	lea    0x4(%ebx),%edx
c00244ff:	ec                   	in     (%dx),%al
c0024500:	88 44 24 0e          	mov    %al,0xe(%esp)
  lbah = inb (reg_lbah (c));
c0024504:	8d 53 05             	lea    0x5(%ebx),%edx
c0024507:	ec                   	in     (%dx),%al
c0024508:	88 44 24 0f          	mov    %al,0xf(%esp)
  status = inb (reg_status (c));
c002450c:	8d 53 07             	lea    0x7(%ebx),%edx
c002450f:	ec                   	in     (%dx),%al
  if ((error != 1 && (error != 0x81 || d->dev_no == 1))
c0024510:	80 f9 01             	cmp    $0x1,%cl
c0024513:	74 1b                	je     c0024530 <check_device_type+0x4c>
c0024515:	80 f9 81             	cmp    $0x81,%cl
c0024518:	74 10                	je     c002452a <check_device_type+0x46>
      d->is_ata = false;
c002451a:	c6 46 10 00          	movb   $0x0,0x10(%esi)
      return error != 0x81;      
c002451e:	80 f9 81             	cmp    $0x81,%cl
c0024521:	0f 95 c0             	setne  %al
}
c0024524:	83 c4 14             	add    $0x14,%esp
c0024527:	5b                   	pop    %ebx
c0024528:	5e                   	pop    %esi
c0024529:	c3                   	ret    
  if ((error != 1 && (error != 0x81 || d->dev_no == 1))
c002452a:	83 7e 0c 01          	cmpl   $0x1,0xc(%esi)
c002452e:	74 ea                	je     c002451a <check_device_type+0x36>
      || (status & STA_DRDY) == 0
c0024530:	a8 40                	test   $0x40,%al
c0024532:	74 e6                	je     c002451a <check_device_type+0x36>
      || (status & STA_BSY) != 0)
c0024534:	84 c0                	test   %al,%al
c0024536:	78 e2                	js     c002451a <check_device_type+0x36>
      d->is_ata = (lbam == 0 && lbah == 0) || (lbam == 0x3c && lbah == 0xc3);
c0024538:	80 7c 24 0e 00       	cmpb   $0x0,0xe(%esp)
c002453d:	75 16                	jne    c0024555 <check_device_type+0x71>
c002453f:	80 7c 24 0f 00       	cmpb   $0x0,0xf(%esp)
c0024544:	0f 94 c0             	sete   %al
c0024547:	0f b6 c0             	movzbl %al,%eax
c002454a:	88 46 10             	mov    %al,0x10(%esi)
c002454d:	80 66 10 01          	andb   $0x1,0x10(%esi)
      return true; 
c0024551:	b0 01                	mov    $0x1,%al
c0024553:	eb cf                	jmp    c0024524 <check_device_type+0x40>
      d->is_ata = (lbam == 0 && lbah == 0) || (lbam == 0x3c && lbah == 0xc3);
c0024555:	80 7c 24 0e 3c       	cmpb   $0x3c,0xe(%esp)
c002455a:	74 07                	je     c0024563 <check_device_type+0x7f>
c002455c:	b8 00 00 00 00       	mov    $0x0,%eax
c0024561:	eb e7                	jmp    c002454a <check_device_type+0x66>
c0024563:	80 7c 24 0f c3       	cmpb   $0xc3,0xf(%esp)
c0024568:	0f 94 c0             	sete   %al
c002456b:	0f b6 c0             	movzbl %al,%eax
c002456e:	eb da                	jmp    c002454a <check_device_type+0x66>

c0024570 <select_sector>:
{
c0024570:	57                   	push   %edi
c0024571:	56                   	push   %esi
c0024572:	53                   	push   %ebx
  struct channel *c = d->channel;
c0024573:	8b 78 08             	mov    0x8(%eax),%edi
  ASSERT (sec_no < (1UL << 28));
c0024576:	81 fa ff ff ff 0f    	cmp    $0xfffffff,%edx
c002457c:	77 4d                	ja     c00245cb <select_sector+0x5b>
c002457e:	89 c6                	mov    %eax,%esi
c0024580:	89 d3                	mov    %edx,%ebx
  wait_until_idle (d);
c0024582:	e8 ca fe ff ff       	call   c0024451 <wait_until_idle>
  select_device (d);
c0024587:	89 f0                	mov    %esi,%eax
c0024589:	e8 23 ff ff ff       	call   c00244b1 <select_device>
  wait_until_idle (d);
c002458e:	89 f0                	mov    %esi,%eax
c0024590:	e8 bc fe ff ff       	call   c0024451 <wait_until_idle>
  outb (reg_nsect (c), 1);
c0024595:	8b 4f 08             	mov    0x8(%edi),%ecx
c0024598:	8d 51 02             	lea    0x2(%ecx),%edx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c002459b:	b0 01                	mov    $0x1,%al
c002459d:	ee                   	out    %al,(%dx)
  outb (reg_lbal (c), sec_no);
c002459e:	8d 51 03             	lea    0x3(%ecx),%edx
c00245a1:	88 d8                	mov    %bl,%al
c00245a3:	ee                   	out    %al,(%dx)
  outb (reg_lbam (c), sec_no >> 8);
c00245a4:	89 d8                	mov    %ebx,%eax
c00245a6:	c1 e8 08             	shr    $0x8,%eax
c00245a9:	8d 51 04             	lea    0x4(%ecx),%edx
c00245ac:	ee                   	out    %al,(%dx)
  outb (reg_lbah (c), (sec_no >> 16));
c00245ad:	89 d8                	mov    %ebx,%eax
c00245af:	c1 e8 10             	shr    $0x10,%eax
c00245b2:	8d 51 05             	lea    0x5(%ecx),%edx
c00245b5:	ee                   	out    %al,(%dx)
        DEV_MBS | DEV_LBA | (d->dev_no == 1 ? DEV_DEV : 0) | (sec_no >> 24));
c00245b6:	83 7e 0c 01          	cmpl   $0x1,0xc(%esi)
c00245ba:	74 30                	je     c00245ec <select_sector+0x7c>
c00245bc:	b0 e0                	mov    $0xe0,%al
c00245be:	c1 eb 18             	shr    $0x18,%ebx
c00245c1:	09 d8                	or     %ebx,%eax
  outb (reg_device (c),
c00245c3:	8d 51 06             	lea    0x6(%ecx),%edx
c00245c6:	ee                   	out    %al,(%dx)
}
c00245c7:	5b                   	pop    %ebx
c00245c8:	5e                   	pop    %esi
c00245c9:	5f                   	pop    %edi
c00245ca:	c3                   	ret    
  ASSERT (sec_no < (1UL << 28));
c00245cb:	83 ec 0c             	sub    $0xc,%esp
c00245ce:	68 13 e0 02 c0       	push   $0xc002e013
c00245d3:	68 df cb 02 c0       	push   $0xc002cbdf
c00245d8:	68 28 be 02 c0       	push   $0xc002be28
c00245dd:	68 89 01 00 00       	push   $0x189
c00245e2:	68 ed df 02 c0       	push   $0xc002dfed
c00245e7:	e8 54 30 00 00       	call   c0027640 <debug_panic>
        DEV_MBS | DEV_LBA | (d->dev_no == 1 ? DEV_DEV : 0) | (sec_no >> 24));
c00245ec:	b0 f0                	mov    $0xf0,%al
c00245ee:	eb ce                	jmp    c00245be <select_sector+0x4e>

c00245f0 <wait_while_busy>:
{
c00245f0:	57                   	push   %edi
c00245f1:	56                   	push   %esi
c00245f2:	53                   	push   %ebx
c00245f3:	89 c7                	mov    %eax,%edi
  struct channel *c = d->channel;
c00245f5:	8b 70 08             	mov    0x8(%eax),%esi
  for (i = 0; i < 3000; i++)
c00245f8:	bb 00 00 00 00       	mov    $0x0,%ebx
      if (!(inb (reg_alt_status (c)) & STA_BSY)) 
c00245fd:	8b 46 08             	mov    0x8(%esi),%eax
c0024600:	8d 90 06 02 00 00    	lea    0x206(%eax),%edx
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0024606:	ec                   	in     (%dx),%al
c0024607:	84 c0                	test   %al,%al
c0024609:	79 33                	jns    c002463e <wait_while_busy+0x4e>
      timer_msleep (10);
c002460b:	83 ec 08             	sub    $0x8,%esp
c002460e:	6a 00                	push   $0x0
c0024610:	6a 0a                	push   $0xa
c0024612:	e8 9e ed ff ff       	call   c00233b5 <timer_msleep>
  for (i = 0; i < 3000; i++)
c0024617:	43                   	inc    %ebx
c0024618:	83 c4 10             	add    $0x10,%esp
c002461b:	81 fb b8 0b 00 00    	cmp    $0xbb8,%ebx
c0024621:	74 49                	je     c002466c <wait_while_busy+0x7c>
      if (i == 700)
c0024623:	81 fb bc 02 00 00    	cmp    $0x2bc,%ebx
c0024629:	75 d2                	jne    c00245fd <wait_while_busy+0xd>
        printf ("%s: busy, waiting...", d->name);
c002462b:	83 ec 08             	sub    $0x8,%esp
c002462e:	57                   	push   %edi
c002462f:	68 28 e0 02 c0       	push   $0xc002e028
c0024634:	e8 59 15 00 00       	call   c0025b92 <printf>
c0024639:	83 c4 10             	add    $0x10,%esp
c002463c:	eb bf                	jmp    c00245fd <wait_while_busy+0xd>
          if (i >= 700)
c002463e:	81 fb bb 02 00 00    	cmp    $0x2bb,%ebx
c0024644:	7f 14                	jg     c002465a <wait_while_busy+0x6a>
          return (inb (reg_alt_status (c)) & STA_DRQ) != 0;
c0024646:	8b 46 08             	mov    0x8(%esi),%eax
c0024649:	8d 90 06 02 00 00    	lea    0x206(%eax),%edx
c002464f:	ec                   	in     (%dx),%al
c0024650:	c0 e8 03             	shr    $0x3,%al
c0024653:	83 e0 01             	and    $0x1,%eax
}
c0024656:	5b                   	pop    %ebx
c0024657:	5e                   	pop    %esi
c0024658:	5f                   	pop    %edi
c0024659:	c3                   	ret    
            printf ("ok\n");
c002465a:	83 ec 0c             	sub    $0xc,%esp
c002465d:	68 3d e0 02 c0       	push   $0xc002e03d
c0024662:	e8 27 4a 00 00       	call   c002908e <puts>
c0024667:	83 c4 10             	add    $0x10,%esp
c002466a:	eb da                	jmp    c0024646 <wait_while_busy+0x56>
  printf ("failed\n");
c002466c:	83 ec 0c             	sub    $0xc,%esp
c002466f:	68 dc e8 02 c0       	push   $0xc002e8dc
c0024674:	e8 15 4a 00 00       	call   c002908e <puts>
  return false;
c0024679:	83 c4 10             	add    $0x10,%esp
c002467c:	b0 00                	mov    $0x0,%al
c002467e:	eb d6                	jmp    c0024656 <wait_while_busy+0x66>

c0024680 <issue_pio_command>:
{
c0024680:	56                   	push   %esi
c0024681:	53                   	push   %ebx
c0024682:	83 ec 04             	sub    $0x4,%esp
c0024685:	89 c3                	mov    %eax,%ebx
c0024687:	89 d6                	mov    %edx,%esi
  ASSERT (intr_get_level () == INTR_ON);
c0024689:	e8 b8 c9 ff ff       	call   c0021046 <intr_get_level>
c002468e:	83 f8 01             	cmp    $0x1,%eax
c0024691:	75 13                	jne    c00246a6 <issue_pio_command+0x26>
  c->expecting_interrupt = true;
c0024693:	c6 43 24 01          	movb   $0x1,0x24(%ebx)
  outb (reg_command (c), command);
c0024697:	8b 53 08             	mov    0x8(%ebx),%edx
c002469a:	83 c2 07             	add    $0x7,%edx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c002469d:	89 f0                	mov    %esi,%eax
c002469f:	ee                   	out    %al,(%dx)
}
c00246a0:	83 c4 04             	add    $0x4,%esp
c00246a3:	5b                   	pop    %ebx
c00246a4:	5e                   	pop    %esi
c00246a5:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_ON);
c00246a6:	83 ec 0c             	sub    $0xc,%esp
c00246a9:	68 4a d7 02 c0       	push   $0xc002d74a
c00246ae:	68 df cb 02 c0       	push   $0xc002cbdf
c00246b3:	68 08 be 02 c0       	push   $0xc002be08
c00246b8:	68 9b 01 00 00       	push   $0x19b
c00246bd:	68 ed df 02 c0       	push   $0xc002dfed
c00246c2:	e8 79 2f 00 00       	call   c0027640 <debug_panic>

c00246c7 <ide_write>:
{
c00246c7:	57                   	push   %edi
c00246c8:	56                   	push   %esi
c00246c9:	53                   	push   %ebx
c00246ca:	8b 74 24 10          	mov    0x10(%esp),%esi
  struct channel *c = d->channel;
c00246ce:	8b 5e 08             	mov    0x8(%esi),%ebx
  lock_acquire (&c->lock);
c00246d1:	8d 7b 0c             	lea    0xc(%ebx),%edi
c00246d4:	83 ec 0c             	sub    $0xc,%esp
c00246d7:	57                   	push   %edi
c00246d8:	e8 89 dc ff ff       	call   c0022366 <lock_acquire>
  select_sector (d, sec_no);
c00246dd:	8b 54 24 24          	mov    0x24(%esp),%edx
c00246e1:	89 f0                	mov    %esi,%eax
c00246e3:	e8 88 fe ff ff       	call   c0024570 <select_sector>
  issue_pio_command (c, CMD_WRITE_SECTOR_RETRY);
c00246e8:	ba 30 00 00 00       	mov    $0x30,%edx
c00246ed:	89 d8                	mov    %ebx,%eax
c00246ef:	e8 8c ff ff ff       	call   c0024680 <issue_pio_command>
  if (!wait_while_busy (d))
c00246f4:	89 f0                	mov    %esi,%eax
c00246f6:	e8 f5 fe ff ff       	call   c00245f0 <wait_while_busy>
c00246fb:	83 c4 10             	add    $0x10,%esp
c00246fe:	84 c0                	test   %al,%al
c0024700:	74 2a                	je     c002472c <ide_write+0x65>
   CNT-halfword buffer starting at ADDR. */
static inline void
outsw (uint16_t port, const void *addr, size_t cnt)
{
  /* See [IA32-v2b] "OUTS". */
  asm volatile ("rep outsw" : "+S" (addr), "+c" (cnt) : "d" (port));
c0024702:	8b 53 08             	mov    0x8(%ebx),%edx
c0024705:	8b 74 24 18          	mov    0x18(%esp),%esi
c0024709:	b9 00 01 00 00       	mov    $0x100,%ecx
c002470e:	66 f3 6f             	rep outsw %ds:(%esi),(%dx)
  sema_down (&c->completion_wait);
c0024711:	83 ec 0c             	sub    $0xc,%esp
c0024714:	83 c3 28             	add    $0x28,%ebx
c0024717:	53                   	push   %ebx
c0024718:	e8 d3 d9 ff ff       	call   c00220f0 <sema_down>
  lock_release (&c->lock);
c002471d:	89 3c 24             	mov    %edi,(%esp)
c0024720:	e8 66 dd ff ff       	call   c002248b <lock_release>
}
c0024725:	83 c4 10             	add    $0x10,%esp
c0024728:	5b                   	pop    %ebx
c0024729:	5e                   	pop    %esi
c002472a:	5f                   	pop    %edi
c002472b:	c3                   	ret    
    PANIC ("%s: disk write failed, sector=%"PRDSNu, d->name, sec_no);
c002472c:	83 ec 08             	sub    $0x8,%esp
c002472f:	ff 74 24 1c          	pushl  0x1c(%esp)
c0024733:	56                   	push   %esi
c0024734:	68 8c e0 02 c0       	push   $0xc002e08c
c0024739:	68 38 be 02 c0       	push   $0xc002be38
c002473e:	68 75 01 00 00       	push   $0x175
c0024743:	68 ed df 02 c0       	push   $0xc002dfed
c0024748:	e8 f3 2e 00 00       	call   c0027640 <debug_panic>

c002474d <identify_ata_device>:
{
c002474d:	57                   	push   %edi
c002474e:	56                   	push   %esi
c002474f:	53                   	push   %ebx
c0024750:	81 ec 80 02 00 00    	sub    $0x280,%esp
  struct channel *c = d->channel;
c0024756:	8b 70 08             	mov    0x8(%eax),%esi
  ASSERT (d->is_ata);
c0024759:	80 78 10 00          	cmpb   $0x0,0x10(%eax)
c002475d:	74 49                	je     c00247a8 <identify_ata_device+0x5b>
c002475f:	89 c3                	mov    %eax,%ebx
  wait_until_idle (d);
c0024761:	e8 eb fc ff ff       	call   c0024451 <wait_until_idle>
  select_device (d);
c0024766:	89 d8                	mov    %ebx,%eax
c0024768:	e8 44 fd ff ff       	call   c00244b1 <select_device>
  wait_until_idle (d);
c002476d:	89 d8                	mov    %ebx,%eax
c002476f:	e8 dd fc ff ff       	call   c0024451 <wait_until_idle>
  issue_pio_command (c, CMD_IDENTIFY_DEVICE);
c0024774:	ba ec 00 00 00       	mov    $0xec,%edx
c0024779:	89 f0                	mov    %esi,%eax
c002477b:	e8 00 ff ff ff       	call   c0024680 <issue_pio_command>
  sema_down (&c->completion_wait);
c0024780:	83 ec 0c             	sub    $0xc,%esp
c0024783:	8d 46 28             	lea    0x28(%esi),%eax
c0024786:	50                   	push   %eax
c0024787:	e8 64 d9 ff ff       	call   c00220f0 <sema_down>
  if (!wait_while_busy (d))
c002478c:	89 d8                	mov    %ebx,%eax
c002478e:	e8 5d fe ff ff       	call   c00245f0 <wait_while_busy>
c0024793:	83 c4 10             	add    $0x10,%esp
c0024796:	84 c0                	test   %al,%al
c0024798:	75 2f                	jne    c00247c9 <identify_ata_device+0x7c>
      d->is_ata = false;
c002479a:	c6 43 10 00          	movb   $0x0,0x10(%ebx)
}
c002479e:	81 c4 80 02 00 00    	add    $0x280,%esp
c00247a4:	5b                   	pop    %ebx
c00247a5:	5e                   	pop    %esi
c00247a6:	5f                   	pop    %edi
c00247a7:	c3                   	ret    
  ASSERT (d->is_ata);
c00247a8:	83 ec 0c             	sub    $0xc,%esp
c00247ab:	68 40 e0 02 c0       	push   $0xc002e040
c00247b0:	68 df cb 02 c0       	push   $0xc002cbdf
c00247b5:	68 44 be 02 c0       	push   $0xc002be44
c00247ba:	68 0d 01 00 00       	push   $0x10d
c00247bf:	68 ed df 02 c0       	push   $0xc002dfed
c00247c4:	e8 77 2e 00 00       	call   c0027640 <debug_panic>
  asm volatile ("rep insw" : "+D" (addr), "+c" (cnt) : "d" (port) : "memory");
c00247c9:	8b 56 08             	mov    0x8(%esi),%edx
c00247cc:	8d bc 24 80 00 00 00 	lea    0x80(%esp),%edi
c00247d3:	b9 00 01 00 00       	mov    $0x100,%ecx
c00247d8:	66 f3 6d             	rep insw (%dx),%es:(%edi)
  capacity = *(uint32_t *) &id[60 * 2];
c00247db:	8b b4 24 f8 00 00 00 	mov    0xf8(%esp),%esi
  model = descramble_ata_string (&id[10 * 2], 20);
c00247e2:	ba 14 00 00 00       	mov    $0x14,%edx
c00247e7:	8d 84 24 94 00 00 00 	lea    0x94(%esp),%eax
c00247ee:	e8 9c fb ff ff       	call   c002438f <descramble_ata_string>
c00247f3:	89 c7                	mov    %eax,%edi
  serial = descramble_ata_string (&id[27 * 2], 40);
c00247f5:	ba 28 00 00 00       	mov    $0x28,%edx
c00247fa:	8d 84 24 b6 00 00 00 	lea    0xb6(%esp),%eax
c0024801:	e8 89 fb ff ff       	call   c002438f <descramble_ata_string>
  snprintf (extra_info, sizeof extra_info,
c0024806:	83 ec 0c             	sub    $0xc,%esp
c0024809:	50                   	push   %eax
c002480a:	57                   	push   %edi
c002480b:	68 4a e0 02 c0       	push   $0xc002e04a
c0024810:	68 80 00 00 00       	push   $0x80
c0024815:	8d 44 24 1c          	lea    0x1c(%esp),%eax
c0024819:	50                   	push   %eax
c002481a:	e8 ff 1a 00 00       	call   c002631e <snprintf>
  if (capacity >= 1024 * 1024 * 1024 / BLOCK_SECTOR_SIZE)
c002481f:	83 c4 20             	add    $0x20,%esp
c0024822:	81 fe ff ff 1f 00    	cmp    $0x1fffff,%esi
c0024828:	76 3a                	jbe    c0024864 <identify_ata_device+0x117>
      printf ("%s: ignoring ", d->name);
c002482a:	83 ec 08             	sub    $0x8,%esp
c002482d:	53                   	push   %ebx
c002482e:	68 62 e0 02 c0       	push   $0xc002e062
c0024833:	e8 5a 13 00 00       	call   c0025b92 <printf>
      print_human_readable_size (capacity * 512);
c0024838:	83 c4 08             	add    $0x8,%esp
c002483b:	89 f0                	mov    %esi,%eax
c002483d:	c1 e0 09             	shl    $0x9,%eax
c0024840:	ba 00 00 00 00       	mov    $0x0,%edx
c0024845:	52                   	push   %edx
c0024846:	50                   	push   %eax
c0024847:	e8 ea 1c 00 00       	call   c0026536 <print_human_readable_size>
      printf ("disk for safety\n");
c002484c:	c7 04 24 70 e0 02 c0 	movl   $0xc002e070,(%esp)
c0024853:	e8 36 48 00 00       	call   c002908e <puts>
      d->is_ata = false;
c0024858:	c6 43 10 00          	movb   $0x0,0x10(%ebx)
      return;
c002485c:	83 c4 10             	add    $0x10,%esp
c002485f:	e9 3a ff ff ff       	jmp    c002479e <identify_ata_device+0x51>
  block = block_register (d->name, BLOCK_RAW, extra_info, capacity,
c0024864:	83 ec 08             	sub    $0x8,%esp
c0024867:	53                   	push   %ebx
c0024868:	68 8c 67 03 c0       	push   $0xc003678c
c002486d:	56                   	push   %esi
c002486e:	8d 44 24 14          	lea    0x14(%esp),%eax
c0024872:	50                   	push   %eax
c0024873:	6a 04                	push   $0x4
c0024875:	53                   	push   %ebx
c0024876:	e8 d0 f5 ff ff       	call   c0023e4b <block_register>
  partition_scan (block);
c002487b:	83 c4 14             	add    $0x14,%esp
c002487e:	50                   	push   %eax
c002487f:	e8 bb fa ff ff       	call   c002433f <partition_scan>
c0024884:	83 c4 10             	add    $0x10,%esp
c0024887:	e9 12 ff ff ff       	jmp    c002479e <identify_ata_device+0x51>

c002488c <ide_read>:
{
c002488c:	55                   	push   %ebp
c002488d:	57                   	push   %edi
c002488e:	56                   	push   %esi
c002488f:	53                   	push   %ebx
c0024890:	83 ec 18             	sub    $0x18,%esp
c0024893:	8b 74 24 2c          	mov    0x2c(%esp),%esi
  struct channel *c = d->channel;
c0024897:	8b 5e 08             	mov    0x8(%esi),%ebx
  lock_acquire (&c->lock);
c002489a:	8d 6b 0c             	lea    0xc(%ebx),%ebp
c002489d:	55                   	push   %ebp
c002489e:	e8 c3 da ff ff       	call   c0022366 <lock_acquire>
  select_sector (d, sec_no);
c00248a3:	8b 54 24 34          	mov    0x34(%esp),%edx
c00248a7:	89 f0                	mov    %esi,%eax
c00248a9:	e8 c2 fc ff ff       	call   c0024570 <select_sector>
  issue_pio_command (c, CMD_READ_SECTOR_RETRY);
c00248ae:	ba 20 00 00 00       	mov    $0x20,%edx
c00248b3:	89 d8                	mov    %ebx,%eax
c00248b5:	e8 c6 fd ff ff       	call   c0024680 <issue_pio_command>
  sema_down (&c->completion_wait);
c00248ba:	8d 43 28             	lea    0x28(%ebx),%eax
c00248bd:	89 04 24             	mov    %eax,(%esp)
c00248c0:	e8 2b d8 ff ff       	call   c00220f0 <sema_down>
  if (!wait_while_busy (d))
c00248c5:	89 f0                	mov    %esi,%eax
c00248c7:	e8 24 fd ff ff       	call   c00245f0 <wait_while_busy>
c00248cc:	83 c4 10             	add    $0x10,%esp
c00248cf:	84 c0                	test   %al,%al
c00248d1:	74 20                	je     c00248f3 <ide_read+0x67>
c00248d3:	8b 53 08             	mov    0x8(%ebx),%edx
c00248d6:	8b 7c 24 28          	mov    0x28(%esp),%edi
c00248da:	b9 00 01 00 00       	mov    $0x100,%ecx
c00248df:	66 f3 6d             	rep insw (%dx),%es:(%edi)
  lock_release (&c->lock);
c00248e2:	83 ec 0c             	sub    $0xc,%esp
c00248e5:	55                   	push   %ebp
c00248e6:	e8 a0 db ff ff       	call   c002248b <lock_release>
}
c00248eb:	83 c4 1c             	add    $0x1c,%esp
c00248ee:	5b                   	pop    %ebx
c00248ef:	5e                   	pop    %esi
c00248f0:	5f                   	pop    %edi
c00248f1:	5d                   	pop    %ebp
c00248f2:	c3                   	ret    
    PANIC ("%s: disk read failed, sector=%"PRDSNu, d->name, sec_no);
c00248f3:	83 ec 08             	sub    $0x8,%esp
c00248f6:	ff 74 24 2c          	pushl  0x2c(%esp)
c00248fa:	56                   	push   %esi
c00248fb:	68 b0 e0 02 c0       	push   $0xc002e0b0
c0024900:	68 1c be 02 c0       	push   $0xc002be1c
c0024905:	68 62 01 00 00       	push   $0x162
c002490a:	68 ed df 02 c0       	push   $0xc002dfed
c002490f:	e8 2c 2d 00 00       	call   c0027640 <debug_panic>

c0024914 <ide_init>:
{
c0024914:	55                   	push   %ebp
c0024915:	57                   	push   %edi
c0024916:	56                   	push   %esi
c0024917:	53                   	push   %ebx
c0024918:	83 ec 1c             	sub    $0x1c,%esp
      snprintf (c->name, sizeof c->name, "ide%zu", chan_no);
c002491b:	6a 00                	push   $0x0
c002491d:	68 80 e0 02 c0       	push   $0xc002e080
c0024922:	6a 08                	push   $0x8
c0024924:	68 40 80 03 c0       	push   $0xc0038040
c0024929:	e8 f0 19 00 00       	call   c002631e <snprintf>
          c->reg_base = 0x1f0;
c002492e:	66 c7 05 48 80 03 c0 	movw   $0x1f0,0xc0038048
c0024935:	f0 01 
          c->irq = 14 + 0x20;
c0024937:	c6 05 4a 80 03 c0 2e 	movb   $0x2e,0xc003804a
      lock_init (&c->lock);
c002493e:	c7 04 24 4c 80 03 c0 	movl   $0xc003804c,(%esp)
c0024945:	e8 9a d9 ff ff       	call   c00222e4 <lock_init>
      c->expecting_interrupt = false;
c002494a:	c6 05 64 80 03 c0 00 	movb   $0x0,0xc0038064
      sema_init (&c->completion_wait, 0);
c0024951:	83 c4 08             	add    $0x8,%esp
c0024954:	6a 00                	push   $0x0
c0024956:	68 68 80 03 c0       	push   $0xc0038068
c002495b:	e8 51 d7 ff ff       	call   c00220b1 <sema_init>
          snprintf (d->name, sizeof d->name,
c0024960:	6a 61                	push   $0x61
c0024962:	68 87 e0 02 c0       	push   $0xc002e087
c0024967:	6a 08                	push   $0x8
c0024969:	68 7c 80 03 c0       	push   $0xc003807c
c002496e:	e8 ab 19 00 00       	call   c002631e <snprintf>
          d->channel = c;
c0024973:	c7 05 84 80 03 c0 40 	movl   $0xc0038040,0xc0038084
c002497a:	80 03 c0 
          d->dev_no = dev_no;
c002497d:	c7 05 88 80 03 c0 00 	movl   $0x0,0xc0038088
c0024984:	00 00 00 
          d->is_ata = false;
c0024987:	c6 05 8c 80 03 c0 00 	movb   $0x0,0xc003808c
          snprintf (d->name, sizeof d->name,
c002498e:	83 c4 20             	add    $0x20,%esp
c0024991:	6a 62                	push   $0x62
c0024993:	68 87 e0 02 c0       	push   $0xc002e087
c0024998:	6a 08                	push   $0x8
c002499a:	68 90 80 03 c0       	push   $0xc0038090
c002499f:	e8 7a 19 00 00       	call   c002631e <snprintf>
          d->channel = c;
c00249a4:	c7 05 98 80 03 c0 40 	movl   $0xc0038040,0xc0038098
c00249ab:	80 03 c0 
          d->dev_no = dev_no;
c00249ae:	c7 05 9c 80 03 c0 01 	movl   $0x1,0xc003809c
c00249b5:	00 00 00 
          d->is_ata = false;
c00249b8:	c6 05 a0 80 03 c0 00 	movb   $0x0,0xc00380a0
      intr_register_ext (c->irq, interrupt_handler, c->name);
c00249bf:	83 c4 0c             	add    $0xc,%esp
c00249c2:	68 40 80 03 c0       	push   $0xc0038040
c00249c7:	68 db 43 02 c0       	push   $0xc00243db
c00249cc:	0f b6 05 4a 80 03 c0 	movzbl 0xc003804a,%eax
c00249d3:	50                   	push   %eax
c00249d4:	e8 2b c8 ff ff       	call   c0021204 <intr_register_ext>
      select_device (d);
c00249d9:	b8 7c 80 03 c0       	mov    $0xc003807c,%eax
c00249de:	e8 ce fa ff ff       	call   c00244b1 <select_device>
      outb (reg_nsect (c), 0x55);
c00249e3:	8b 0d 48 80 03 c0    	mov    0xc0038048,%ecx
c00249e9:	8d 59 02             	lea    0x2(%ecx),%ebx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00249ec:	b0 55                	mov    $0x55,%al
c00249ee:	89 da                	mov    %ebx,%edx
c00249f0:	ee                   	out    %al,(%dx)
      outb (reg_lbal (c), 0xaa);
c00249f1:	83 c1 03             	add    $0x3,%ecx
c00249f4:	b0 aa                	mov    $0xaa,%al
c00249f6:	89 ca                	mov    %ecx,%edx
c00249f8:	ee                   	out    %al,(%dx)
c00249f9:	89 da                	mov    %ebx,%edx
c00249fb:	ee                   	out    %al,(%dx)
c00249fc:	b0 55                	mov    $0x55,%al
c00249fe:	89 ca                	mov    %ecx,%edx
c0024a00:	ee                   	out    %al,(%dx)
c0024a01:	89 da                	mov    %ebx,%edx
c0024a03:	ee                   	out    %al,(%dx)
c0024a04:	b0 aa                	mov    $0xaa,%al
c0024a06:	89 ca                	mov    %ecx,%edx
c0024a08:	ee                   	out    %al,(%dx)
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0024a09:	89 da                	mov    %ebx,%edx
c0024a0b:	ec                   	in     (%dx),%al
                         && inb (reg_lbal (c)) == 0xaa);
c0024a0c:	83 c4 10             	add    $0x10,%esp
c0024a0f:	3c 55                	cmp    $0x55,%al
c0024a11:	0f 84 84 02 00 00    	je     c0024c9b <ide_init+0x387>
c0024a17:	b3 00                	mov    $0x0,%bl
      present[dev_no] = (inb (reg_nsect (c)) == 0x55
c0024a19:	88 5c 24 0e          	mov    %bl,0xe(%esp)
      select_device (d);
c0024a1d:	b8 90 80 03 c0       	mov    $0xc0038090,%eax
c0024a22:	e8 8a fa ff ff       	call   c00244b1 <select_device>
      outb (reg_nsect (c), 0x55);
c0024a27:	8b 0d 48 80 03 c0    	mov    0xc0038048,%ecx
c0024a2d:	8d 71 02             	lea    0x2(%ecx),%esi
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0024a30:	b0 55                	mov    $0x55,%al
c0024a32:	89 f2                	mov    %esi,%edx
c0024a34:	ee                   	out    %al,(%dx)
      outb (reg_lbal (c), 0xaa);
c0024a35:	8d 79 03             	lea    0x3(%ecx),%edi
c0024a38:	b0 aa                	mov    $0xaa,%al
c0024a3a:	89 fa                	mov    %edi,%edx
c0024a3c:	ee                   	out    %al,(%dx)
c0024a3d:	89 f2                	mov    %esi,%edx
c0024a3f:	ee                   	out    %al,(%dx)
c0024a40:	b0 55                	mov    $0x55,%al
c0024a42:	89 fa                	mov    %edi,%edx
c0024a44:	ee                   	out    %al,(%dx)
c0024a45:	89 f2                	mov    %esi,%edx
c0024a47:	ee                   	out    %al,(%dx)
c0024a48:	b0 aa                	mov    $0xaa,%al
c0024a4a:	89 fa                	mov    %edi,%edx
c0024a4c:	ee                   	out    %al,(%dx)
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0024a4d:	89 f2                	mov    %esi,%edx
c0024a4f:	ec                   	in     (%dx),%al
                         && inb (reg_lbal (c)) == 0xaa);
c0024a50:	3c 55                	cmp    $0x55,%al
c0024a52:	0f 84 50 02 00 00    	je     c0024ca8 <ide_init+0x394>
c0024a58:	be 00 00 00 00       	mov    $0x0,%esi
      present[dev_no] = (inb (reg_nsect (c)) == 0x55
c0024a5d:	89 f0                	mov    %esi,%eax
c0024a5f:	88 44 24 0f          	mov    %al,0xf(%esp)
  outb (reg_ctl (c), 0);
c0024a63:	8d 91 06 02 00 00    	lea    0x206(%ecx),%edx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0024a69:	b0 00                	mov    $0x0,%al
c0024a6b:	ee                   	out    %al,(%dx)
  timer_usleep (10);
c0024a6c:	83 ec 08             	sub    $0x8,%esp
c0024a6f:	6a 00                	push   $0x0
c0024a71:	6a 0a                	push   $0xa
c0024a73:	e8 56 e9 ff ff       	call   c00233ce <timer_usleep>
  outb (reg_ctl (c), CTL_SRST);
c0024a78:	a1 48 80 03 c0       	mov    0xc0038048,%eax
c0024a7d:	8d 90 06 02 00 00    	lea    0x206(%eax),%edx
c0024a83:	b0 04                	mov    $0x4,%al
c0024a85:	ee                   	out    %al,(%dx)
  timer_usleep (10);
c0024a86:	83 c4 08             	add    $0x8,%esp
c0024a89:	6a 00                	push   $0x0
c0024a8b:	6a 0a                	push   $0xa
c0024a8d:	e8 3c e9 ff ff       	call   c00233ce <timer_usleep>
  outb (reg_ctl (c), 0);
c0024a92:	a1 48 80 03 c0       	mov    0xc0038048,%eax
c0024a97:	8d 90 06 02 00 00    	lea    0x206(%eax),%edx
c0024a9d:	b0 00                	mov    $0x0,%al
c0024a9f:	ee                   	out    %al,(%dx)
  timer_msleep (150);
c0024aa0:	83 c4 08             	add    $0x8,%esp
c0024aa3:	6a 00                	push   $0x0
c0024aa5:	68 96 00 00 00       	push   $0x96
c0024aaa:	e8 06 e9 ff ff       	call   c00233b5 <timer_msleep>
  if (present[0]) 
c0024aaf:	83 c4 10             	add    $0x10,%esp
c0024ab2:	84 db                	test   %bl,%bl
c0024ab4:	0f 85 fd 01 00 00    	jne    c0024cb7 <ide_init+0x3a3>
  if (present[1])
c0024aba:	89 f0                	mov    %esi,%eax
c0024abc:	84 c0                	test   %al,%al
c0024abe:	0f 85 0c 02 00 00    	jne    c0024cd0 <ide_init+0x3bc>
      if (check_device_type (&c->devices[0]))
c0024ac4:	b8 7c 80 03 c0       	mov    $0xc003807c,%eax
c0024ac9:	e8 16 fa ff ff       	call   c00244e4 <check_device_type>
c0024ace:	84 c0                	test   %al,%al
c0024ad0:	0f 85 42 02 00 00    	jne    c0024d18 <ide_init+0x404>
        if (c->devices[dev_no].is_ata)
c0024ad6:	80 3d 8c 80 03 c0 00 	cmpb   $0x0,0xc003808c
c0024add:	0f 85 44 02 00 00    	jne    c0024d27 <ide_init+0x413>
c0024ae3:	80 3d a0 80 03 c0 00 	cmpb   $0x0,0xc00380a0
c0024aea:	0f 85 46 02 00 00    	jne    c0024d36 <ide_init+0x422>
      snprintf (c->name, sizeof c->name, "ide%zu", chan_no);
c0024af0:	6a 01                	push   $0x1
c0024af2:	68 80 e0 02 c0       	push   $0xc002e080
c0024af7:	6a 08                	push   $0x8
c0024af9:	68 a4 80 03 c0       	push   $0xc00380a4
c0024afe:	e8 1b 18 00 00       	call   c002631e <snprintf>
          c->reg_base = 0x170;
c0024b03:	66 c7 05 ac 80 03 c0 	movw   $0x170,0xc00380ac
c0024b0a:	70 01 
          c->irq = 15 + 0x20;
c0024b0c:	c6 05 ae 80 03 c0 2f 	movb   $0x2f,0xc00380ae
      lock_init (&c->lock);
c0024b13:	c7 04 24 b0 80 03 c0 	movl   $0xc00380b0,(%esp)
c0024b1a:	e8 c5 d7 ff ff       	call   c00222e4 <lock_init>
      c->expecting_interrupt = false;
c0024b1f:	c6 05 c8 80 03 c0 00 	movb   $0x0,0xc00380c8
      sema_init (&c->completion_wait, 0);
c0024b26:	83 c4 08             	add    $0x8,%esp
c0024b29:	6a 00                	push   $0x0
c0024b2b:	68 cc 80 03 c0       	push   $0xc00380cc
c0024b30:	e8 7c d5 ff ff       	call   c00220b1 <sema_init>
          snprintf (d->name, sizeof d->name,
c0024b35:	6a 63                	push   $0x63
c0024b37:	68 87 e0 02 c0       	push   $0xc002e087
c0024b3c:	6a 08                	push   $0x8
c0024b3e:	68 e0 80 03 c0       	push   $0xc00380e0
c0024b43:	e8 d6 17 00 00       	call   c002631e <snprintf>
          d->channel = c;
c0024b48:	c7 05 e8 80 03 c0 a4 	movl   $0xc00380a4,0xc00380e8
c0024b4f:	80 03 c0 
          d->dev_no = dev_no;
c0024b52:	c7 05 ec 80 03 c0 00 	movl   $0x0,0xc00380ec
c0024b59:	00 00 00 
          d->is_ata = false;
c0024b5c:	c6 05 f0 80 03 c0 00 	movb   $0x0,0xc00380f0
          snprintf (d->name, sizeof d->name,
c0024b63:	83 c4 20             	add    $0x20,%esp
c0024b66:	6a 64                	push   $0x64
c0024b68:	68 87 e0 02 c0       	push   $0xc002e087
c0024b6d:	6a 08                	push   $0x8
c0024b6f:	68 f4 80 03 c0       	push   $0xc00380f4
c0024b74:	e8 a5 17 00 00       	call   c002631e <snprintf>
          d->channel = c;
c0024b79:	c7 05 fc 80 03 c0 a4 	movl   $0xc00380a4,0xc00380fc
c0024b80:	80 03 c0 
          d->dev_no = dev_no;
c0024b83:	c7 05 00 81 03 c0 01 	movl   $0x1,0xc0038100
c0024b8a:	00 00 00 
          d->is_ata = false;
c0024b8d:	c6 05 04 81 03 c0 00 	movb   $0x0,0xc0038104
      intr_register_ext (c->irq, interrupt_handler, c->name);
c0024b94:	83 c4 0c             	add    $0xc,%esp
c0024b97:	68 a4 80 03 c0       	push   $0xc00380a4
c0024b9c:	68 db 43 02 c0       	push   $0xc00243db
c0024ba1:	0f b6 05 ae 80 03 c0 	movzbl 0xc00380ae,%eax
c0024ba8:	50                   	push   %eax
c0024ba9:	e8 56 c6 ff ff       	call   c0021204 <intr_register_ext>
c0024bae:	bf e0 80 03 c0       	mov    $0xc00380e0,%edi
c0024bb3:	8d 74 24 1e          	lea    0x1e(%esp),%esi
c0024bb7:	83 c4 10             	add    $0x10,%esp
      select_device (d);
c0024bba:	89 f8                	mov    %edi,%eax
c0024bbc:	e8 f0 f8 ff ff       	call   c00244b1 <select_device>
      outb (reg_nsect (c), 0x55);
c0024bc1:	8b 2d ac 80 03 c0    	mov    0xc00380ac,%ebp
c0024bc7:	8d 4d 02             	lea    0x2(%ebp),%ecx
c0024bca:	b0 55                	mov    $0x55,%al
c0024bcc:	89 ca                	mov    %ecx,%edx
c0024bce:	ee                   	out    %al,(%dx)
      outb (reg_lbal (c), 0xaa);
c0024bcf:	8d 5d 03             	lea    0x3(%ebp),%ebx
c0024bd2:	b0 aa                	mov    $0xaa,%al
c0024bd4:	89 da                	mov    %ebx,%edx
c0024bd6:	ee                   	out    %al,(%dx)
c0024bd7:	89 ca                	mov    %ecx,%edx
c0024bd9:	ee                   	out    %al,(%dx)
c0024bda:	b0 55                	mov    $0x55,%al
c0024bdc:	89 da                	mov    %ebx,%edx
c0024bde:	ee                   	out    %al,(%dx)
c0024bdf:	89 ca                	mov    %ecx,%edx
c0024be1:	ee                   	out    %al,(%dx)
c0024be2:	b0 aa                	mov    $0xaa,%al
c0024be4:	89 da                	mov    %ebx,%edx
c0024be6:	ee                   	out    %al,(%dx)
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0024be7:	89 ca                	mov    %ecx,%edx
c0024be9:	ec                   	in     (%dx),%al
                         && inb (reg_lbal (c)) == 0xaa);
c0024bea:	3c 55                	cmp    $0x55,%al
c0024bec:	0f 84 53 01 00 00    	je     c0024d45 <ide_init+0x431>
c0024bf2:	b0 00                	mov    $0x0,%al
      present[dev_no] = (inb (reg_nsect (c)) == 0x55
c0024bf4:	88 06                	mov    %al,(%esi)
c0024bf6:	83 c7 14             	add    $0x14,%edi
c0024bf9:	46                   	inc    %esi
  for (dev_no = 0; dev_no < 2; dev_no++)
c0024bfa:	8d 44 24 10          	lea    0x10(%esp),%eax
c0024bfe:	39 f0                	cmp    %esi,%eax
c0024c00:	75 b8                	jne    c0024bba <ide_init+0x2a6>
  outb (reg_ctl (c), 0);
c0024c02:	8d 95 06 02 00 00    	lea    0x206(%ebp),%edx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0024c08:	b0 00                	mov    $0x0,%al
c0024c0a:	ee                   	out    %al,(%dx)
  timer_usleep (10);
c0024c0b:	83 ec 08             	sub    $0x8,%esp
c0024c0e:	6a 00                	push   $0x0
c0024c10:	6a 0a                	push   $0xa
c0024c12:	e8 b7 e7 ff ff       	call   c00233ce <timer_usleep>
  outb (reg_ctl (c), CTL_SRST);
c0024c17:	a1 ac 80 03 c0       	mov    0xc00380ac,%eax
c0024c1c:	8d 90 06 02 00 00    	lea    0x206(%eax),%edx
c0024c22:	b0 04                	mov    $0x4,%al
c0024c24:	ee                   	out    %al,(%dx)
  timer_usleep (10);
c0024c25:	83 c4 08             	add    $0x8,%esp
c0024c28:	6a 00                	push   $0x0
c0024c2a:	6a 0a                	push   $0xa
c0024c2c:	e8 9d e7 ff ff       	call   c00233ce <timer_usleep>
  outb (reg_ctl (c), 0);
c0024c31:	a1 ac 80 03 c0       	mov    0xc00380ac,%eax
c0024c36:	8d 90 06 02 00 00    	lea    0x206(%eax),%edx
c0024c3c:	b0 00                	mov    $0x0,%al
c0024c3e:	ee                   	out    %al,(%dx)
  timer_msleep (150);
c0024c3f:	83 c4 08             	add    $0x8,%esp
c0024c42:	6a 00                	push   $0x0
c0024c44:	68 96 00 00 00       	push   $0x96
c0024c49:	e8 67 e7 ff ff       	call   c00233b5 <timer_msleep>
  if (present[0]) 
c0024c4e:	83 c4 10             	add    $0x10,%esp
c0024c51:	80 7c 24 0e 00       	cmpb   $0x0,0xe(%esp)
c0024c56:	0f 85 f6 00 00 00    	jne    c0024d52 <ide_init+0x43e>
  if (present[1])
c0024c5c:	80 7c 24 0f 00       	cmpb   $0x0,0xf(%esp)
c0024c61:	0f 85 04 01 00 00    	jne    c0024d6b <ide_init+0x457>
      if (check_device_type (&c->devices[0]))
c0024c67:	b8 e0 80 03 c0       	mov    $0xc00380e0,%eax
c0024c6c:	e8 73 f8 ff ff       	call   c00244e4 <check_device_type>
c0024c71:	84 c0                	test   %al,%al
c0024c73:	0f 85 3a 01 00 00    	jne    c0024db3 <ide_init+0x49f>
        if (c->devices[dev_no].is_ata)
c0024c79:	80 3d f0 80 03 c0 00 	cmpb   $0x0,0xc00380f0
c0024c80:	0f 85 3c 01 00 00    	jne    c0024dc2 <ide_init+0x4ae>
c0024c86:	80 3d 04 81 03 c0 00 	cmpb   $0x0,0xc0038104
c0024c8d:	0f 85 3e 01 00 00    	jne    c0024dd1 <ide_init+0x4bd>
}
c0024c93:	83 c4 1c             	add    $0x1c,%esp
c0024c96:	5b                   	pop    %ebx
c0024c97:	5e                   	pop    %esi
c0024c98:	5f                   	pop    %edi
c0024c99:	5d                   	pop    %ebp
c0024c9a:	c3                   	ret    
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0024c9b:	89 ca                	mov    %ecx,%edx
c0024c9d:	ec                   	in     (%dx),%al
                         && inb (reg_lbal (c)) == 0xaa);
c0024c9e:	3c aa                	cmp    $0xaa,%al
c0024ca0:	0f 94 c3             	sete   %bl
c0024ca3:	e9 71 fd ff ff       	jmp    c0024a19 <ide_init+0x105>
c0024ca8:	89 fa                	mov    %edi,%edx
c0024caa:	ec                   	in     (%dx),%al
c0024cab:	3c aa                	cmp    $0xaa,%al
c0024cad:	0f 94 c0             	sete   %al
c0024cb0:	89 c6                	mov    %eax,%esi
c0024cb2:	e9 a6 fd ff ff       	jmp    c0024a5d <ide_init+0x149>
      select_device (&c->devices[0]);
c0024cb7:	b8 7c 80 03 c0       	mov    $0xc003807c,%eax
c0024cbc:	e8 f0 f7 ff ff       	call   c00244b1 <select_device>
      wait_while_busy (&c->devices[0]); 
c0024cc1:	b8 7c 80 03 c0       	mov    $0xc003807c,%eax
c0024cc6:	e8 25 f9 ff ff       	call   c00245f0 <wait_while_busy>
c0024ccb:	e9 ea fd ff ff       	jmp    c0024aba <ide_init+0x1a6>
      select_device (&c->devices[1]);
c0024cd0:	b8 90 80 03 c0       	mov    $0xc0038090,%eax
c0024cd5:	e8 d7 f7 ff ff       	call   c00244b1 <select_device>
c0024cda:	bb b8 0b 00 00       	mov    $0xbb8,%ebx
c0024cdf:	eb 12                	jmp    c0024cf3 <ide_init+0x3df>
          timer_msleep (10);
c0024ce1:	83 ec 08             	sub    $0x8,%esp
c0024ce4:	6a 00                	push   $0x0
c0024ce6:	6a 0a                	push   $0xa
c0024ce8:	e8 c8 e6 ff ff       	call   c00233b5 <timer_msleep>
      for (i = 0; i < 3000; i++) 
c0024ced:	83 c4 10             	add    $0x10,%esp
c0024cf0:	4b                   	dec    %ebx
c0024cf1:	74 16                	je     c0024d09 <ide_init+0x3f5>
          if (inb (reg_nsect (c)) == 1 && inb (reg_lbal (c)) == 1)
c0024cf3:	8b 0d 48 80 03 c0    	mov    0xc0038048,%ecx
c0024cf9:	8d 51 02             	lea    0x2(%ecx),%edx
c0024cfc:	ec                   	in     (%dx),%al
c0024cfd:	3c 01                	cmp    $0x1,%al
c0024cff:	75 e0                	jne    c0024ce1 <ide_init+0x3cd>
c0024d01:	8d 51 03             	lea    0x3(%ecx),%edx
c0024d04:	ec                   	in     (%dx),%al
c0024d05:	3c 01                	cmp    $0x1,%al
c0024d07:	75 d8                	jne    c0024ce1 <ide_init+0x3cd>
      wait_while_busy (&c->devices[1]);
c0024d09:	b8 90 80 03 c0       	mov    $0xc0038090,%eax
c0024d0e:	e8 dd f8 ff ff       	call   c00245f0 <wait_while_busy>
c0024d13:	e9 ac fd ff ff       	jmp    c0024ac4 <ide_init+0x1b0>
        check_device_type (&c->devices[1]);
c0024d18:	b8 90 80 03 c0       	mov    $0xc0038090,%eax
c0024d1d:	e8 c2 f7 ff ff       	call   c00244e4 <check_device_type>
c0024d22:	e9 af fd ff ff       	jmp    c0024ad6 <ide_init+0x1c2>
          identify_ata_device (&c->devices[dev_no]);
c0024d27:	b8 7c 80 03 c0       	mov    $0xc003807c,%eax
c0024d2c:	e8 1c fa ff ff       	call   c002474d <identify_ata_device>
c0024d31:	e9 ad fd ff ff       	jmp    c0024ae3 <ide_init+0x1cf>
c0024d36:	b8 90 80 03 c0       	mov    $0xc0038090,%eax
c0024d3b:	e8 0d fa ff ff       	call   c002474d <identify_ata_device>
c0024d40:	e9 ab fd ff ff       	jmp    c0024af0 <ide_init+0x1dc>
c0024d45:	89 da                	mov    %ebx,%edx
c0024d47:	ec                   	in     (%dx),%al
                         && inb (reg_lbal (c)) == 0xaa);
c0024d48:	3c aa                	cmp    $0xaa,%al
c0024d4a:	0f 94 c0             	sete   %al
c0024d4d:	e9 a2 fe ff ff       	jmp    c0024bf4 <ide_init+0x2e0>
      select_device (&c->devices[0]);
c0024d52:	b8 e0 80 03 c0       	mov    $0xc00380e0,%eax
c0024d57:	e8 55 f7 ff ff       	call   c00244b1 <select_device>
      wait_while_busy (&c->devices[0]); 
c0024d5c:	b8 e0 80 03 c0       	mov    $0xc00380e0,%eax
c0024d61:	e8 8a f8 ff ff       	call   c00245f0 <wait_while_busy>
c0024d66:	e9 f1 fe ff ff       	jmp    c0024c5c <ide_init+0x348>
      select_device (&c->devices[1]);
c0024d6b:	b8 f4 80 03 c0       	mov    $0xc00380f4,%eax
c0024d70:	e8 3c f7 ff ff       	call   c00244b1 <select_device>
c0024d75:	bb b8 0b 00 00       	mov    $0xbb8,%ebx
c0024d7a:	eb 12                	jmp    c0024d8e <ide_init+0x47a>
          timer_msleep (10);
c0024d7c:	83 ec 08             	sub    $0x8,%esp
c0024d7f:	6a 00                	push   $0x0
c0024d81:	6a 0a                	push   $0xa
c0024d83:	e8 2d e6 ff ff       	call   c00233b5 <timer_msleep>
      for (i = 0; i < 3000; i++) 
c0024d88:	83 c4 10             	add    $0x10,%esp
c0024d8b:	4b                   	dec    %ebx
c0024d8c:	74 16                	je     c0024da4 <ide_init+0x490>
          if (inb (reg_nsect (c)) == 1 && inb (reg_lbal (c)) == 1)
c0024d8e:	8b 0d ac 80 03 c0    	mov    0xc00380ac,%ecx
c0024d94:	8d 51 02             	lea    0x2(%ecx),%edx
c0024d97:	ec                   	in     (%dx),%al
c0024d98:	3c 01                	cmp    $0x1,%al
c0024d9a:	75 e0                	jne    c0024d7c <ide_init+0x468>
c0024d9c:	8d 51 03             	lea    0x3(%ecx),%edx
c0024d9f:	ec                   	in     (%dx),%al
c0024da0:	3c 01                	cmp    $0x1,%al
c0024da2:	75 d8                	jne    c0024d7c <ide_init+0x468>
      wait_while_busy (&c->devices[1]);
c0024da4:	b8 f4 80 03 c0       	mov    $0xc00380f4,%eax
c0024da9:	e8 42 f8 ff ff       	call   c00245f0 <wait_while_busy>
c0024dae:	e9 b4 fe ff ff       	jmp    c0024c67 <ide_init+0x353>
        check_device_type (&c->devices[1]);
c0024db3:	b8 f4 80 03 c0       	mov    $0xc00380f4,%eax
c0024db8:	e8 27 f7 ff ff       	call   c00244e4 <check_device_type>
c0024dbd:	e9 b7 fe ff ff       	jmp    c0024c79 <ide_init+0x365>
          identify_ata_device (&c->devices[dev_no]);
c0024dc2:	b8 e0 80 03 c0       	mov    $0xc00380e0,%eax
c0024dc7:	e8 81 f9 ff ff       	call   c002474d <identify_ata_device>
c0024dcc:	e9 b5 fe ff ff       	jmp    c0024c86 <ide_init+0x372>
c0024dd1:	b8 f4 80 03 c0       	mov    $0xc00380f4,%eax
c0024dd6:	e8 72 f9 ff ff       	call   c002474d <identify_ata_device>
}
c0024ddb:	e9 b3 fe ff ff       	jmp    c0024c93 <ide_init+0x37f>

c0024de0 <input_init>:
static struct intq buffer;

/* Initializes the input buffer. */
void
input_init (void) 
{
c0024de0:	83 ec 18             	sub    $0x18,%esp
  intq_init (&buffer);
c0024de3:	68 20 81 03 c0       	push   $0xc0038120
c0024de8:	e8 eb 00 00 00       	call   c0024ed8 <intq_init>
}
c0024ded:	83 c4 1c             	add    $0x1c,%esp
c0024df0:	c3                   	ret    

c0024df1 <input_putc>:

/* Adds a key to the input buffer.
   Interrupts must be off and the buffer must not be full. */
void
input_putc (uint8_t key) 
{
c0024df1:	53                   	push   %ebx
c0024df2:	83 ec 08             	sub    $0x8,%esp
c0024df5:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c0024df9:	e8 48 c2 ff ff       	call   c0021046 <intr_get_level>
c0024dfe:	85 c0                	test   %eax,%eax
c0024e00:	75 2f                	jne    c0024e31 <input_putc+0x40>
  ASSERT (!intq_full (&buffer));
c0024e02:	83 ec 0c             	sub    $0xc,%esp
c0024e05:	68 20 81 03 c0       	push   $0xc0038120
c0024e0a:	e8 35 01 00 00       	call   c0024f44 <intq_full>
c0024e0f:	83 c4 10             	add    $0x10,%esp
c0024e12:	84 c0                	test   %al,%al
c0024e14:	75 39                	jne    c0024e4f <input_putc+0x5e>

  intq_putc (&buffer, key);
c0024e16:	83 ec 08             	sub    $0x8,%esp
c0024e19:	0f b6 db             	movzbl %bl,%ebx
c0024e1c:	53                   	push   %ebx
c0024e1d:	68 20 81 03 c0       	push   $0xc0038120
c0024e22:	e8 71 03 00 00       	call   c0025198 <intq_putc>
  serial_notify ();
c0024e27:	e8 5e ed ff ff       	call   c0023b8a <serial_notify>
}
c0024e2c:	83 c4 18             	add    $0x18,%esp
c0024e2f:	5b                   	pop    %ebx
c0024e30:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0024e31:	83 ec 0c             	sub    $0xc,%esp
c0024e34:	68 34 cf 02 c0       	push   $0xc002cf34
c0024e39:	68 df cb 02 c0       	push   $0xc002cbdf
c0024e3e:	68 78 be 02 c0       	push   $0xc002be78
c0024e43:	6a 15                	push   $0x15
c0024e45:	68 d0 e0 02 c0       	push   $0xc002e0d0
c0024e4a:	e8 f1 27 00 00       	call   c0027640 <debug_panic>
  ASSERT (!intq_full (&buffer));
c0024e4f:	83 ec 0c             	sub    $0xc,%esp
c0024e52:	68 e6 e0 02 c0       	push   $0xc002e0e6
c0024e57:	68 df cb 02 c0       	push   $0xc002cbdf
c0024e5c:	68 78 be 02 c0       	push   $0xc002be78
c0024e61:	6a 16                	push   $0x16
c0024e63:	68 d0 e0 02 c0       	push   $0xc002e0d0
c0024e68:	e8 d3 27 00 00       	call   c0027640 <debug_panic>

c0024e6d <input_getc>:

/* Retrieves a key from the input buffer.
   If the buffer is empty, waits for a key to be pressed. */
uint8_t
input_getc (void) 
{
c0024e6d:	56                   	push   %esi
c0024e6e:	53                   	push   %ebx
c0024e6f:	83 ec 04             	sub    $0x4,%esp
  enum intr_level old_level;
  uint8_t key;

  old_level = intr_disable ();
c0024e72:	e8 0c c2 ff ff       	call   c0021083 <intr_disable>
c0024e77:	89 c6                	mov    %eax,%esi
  key = intq_getc (&buffer);
c0024e79:	83 ec 0c             	sub    $0xc,%esp
c0024e7c:	68 20 81 03 c0       	push   $0xc0038120
c0024e81:	e8 5d 02 00 00       	call   c00250e3 <intq_getc>
c0024e86:	88 c3                	mov    %al,%bl
  serial_notify ();
c0024e88:	e8 fd ec ff ff       	call   c0023b8a <serial_notify>
  intr_set_level (old_level);
c0024e8d:	89 34 24             	mov    %esi,(%esp)
c0024e90:	e8 f5 c1 ff ff       	call   c002108a <intr_set_level>
  
  return key;
}
c0024e95:	88 d8                	mov    %bl,%al
c0024e97:	83 c4 14             	add    $0x14,%esp
c0024e9a:	5b                   	pop    %ebx
c0024e9b:	5e                   	pop    %esi
c0024e9c:	c3                   	ret    

c0024e9d <input_full>:
/* Returns true if the input buffer is full,
   false otherwise.
   Interrupts must be off. */
bool
input_full (void) 
{
c0024e9d:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (intr_get_level () == INTR_OFF);
c0024ea0:	e8 a1 c1 ff ff       	call   c0021046 <intr_get_level>
c0024ea5:	85 c0                	test   %eax,%eax
c0024ea7:	75 11                	jne    c0024eba <input_full+0x1d>
  return intq_full (&buffer);
c0024ea9:	83 ec 0c             	sub    $0xc,%esp
c0024eac:	68 20 81 03 c0       	push   $0xc0038120
c0024eb1:	e8 8e 00 00 00       	call   c0024f44 <intq_full>
}
c0024eb6:	83 c4 1c             	add    $0x1c,%esp
c0024eb9:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0024eba:	83 ec 0c             	sub    $0xc,%esp
c0024ebd:	68 34 cf 02 c0       	push   $0xc002cf34
c0024ec2:	68 df cb 02 c0       	push   $0xc002cbdf
c0024ec7:	68 6c be 02 c0       	push   $0xc002be6c
c0024ecc:	6a 32                	push   $0x32
c0024ece:	68 d0 e0 02 c0       	push   $0xc002e0d0
c0024ed3:	e8 68 27 00 00       	call   c0027640 <debug_panic>

c0024ed8 <intq_init>:
static void signal (struct intq *q, struct thread **waiter);

/* Initializes interrupt queue Q. */
void
intq_init (struct intq *q) 
{
c0024ed8:	53                   	push   %ebx
c0024ed9:	83 ec 14             	sub    $0x14,%esp
c0024edc:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_init (&q->lock);
c0024ee0:	53                   	push   %ebx
c0024ee1:	e8 fe d3 ff ff       	call   c00222e4 <lock_init>
  q->not_full = q->not_empty = NULL;
c0024ee6:	c7 43 1c 00 00 00 00 	movl   $0x0,0x1c(%ebx)
c0024eed:	c7 43 18 00 00 00 00 	movl   $0x0,0x18(%ebx)
  q->head = q->tail = 0;
c0024ef4:	c7 43 64 00 00 00 00 	movl   $0x0,0x64(%ebx)
c0024efb:	c7 43 60 00 00 00 00 	movl   $0x0,0x60(%ebx)
}
c0024f02:	83 c4 18             	add    $0x18,%esp
c0024f05:	5b                   	pop    %ebx
c0024f06:	c3                   	ret    

c0024f07 <intq_empty>:

/* Returns true if Q is empty, false otherwise. */
bool
intq_empty (const struct intq *q) 
{
c0024f07:	53                   	push   %ebx
c0024f08:	83 ec 08             	sub    $0x8,%esp
c0024f0b:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c0024f0f:	e8 32 c1 ff ff       	call   c0021046 <intr_get_level>
c0024f14:	85 c0                	test   %eax,%eax
c0024f16:	75 0e                	jne    c0024f26 <intq_empty+0x1f>
  return q->head == q->tail;
c0024f18:	8b 43 64             	mov    0x64(%ebx),%eax
c0024f1b:	39 43 60             	cmp    %eax,0x60(%ebx)
c0024f1e:	0f 94 c0             	sete   %al
}
c0024f21:	83 c4 08             	add    $0x8,%esp
c0024f24:	5b                   	pop    %ebx
c0024f25:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0024f26:	83 ec 0c             	sub    $0xc,%esp
c0024f29:	68 34 cf 02 c0       	push   $0xc002cf34
c0024f2e:	68 df cb 02 c0       	push   $0xc002cbdf
c0024f33:	68 b8 be 02 c0       	push   $0xc002beb8
c0024f38:	6a 16                	push   $0x16
c0024f3a:	68 fb e0 02 c0       	push   $0xc002e0fb
c0024f3f:	e8 fc 26 00 00       	call   c0027640 <debug_panic>

c0024f44 <intq_full>:

/* Returns true if Q is full, false otherwise. */
bool
intq_full (const struct intq *q) 
{
c0024f44:	53                   	push   %ebx
c0024f45:	83 ec 08             	sub    $0x8,%esp
c0024f48:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c0024f4c:	e8 f5 c0 ff ff       	call   c0021046 <intr_get_level>
c0024f51:	85 c0                	test   %eax,%eax
c0024f53:	75 16                	jne    c0024f6b <intq_full+0x27>

/* Returns the position after POS within an intq. */
static int
next (int pos) 
{
  return (pos + 1) % INTQ_BUFSIZE;
c0024f55:	8b 43 60             	mov    0x60(%ebx),%eax
c0024f58:	40                   	inc    %eax
c0024f59:	25 3f 00 00 80       	and    $0x8000003f,%eax
c0024f5e:	78 29                	js     c0024f89 <intq_full+0x45>
  return next (q->head) == q->tail;
c0024f60:	3b 43 64             	cmp    0x64(%ebx),%eax
c0024f63:	0f 94 c0             	sete   %al
}
c0024f66:	83 c4 08             	add    $0x8,%esp
c0024f69:	5b                   	pop    %ebx
c0024f6a:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0024f6b:	83 ec 0c             	sub    $0xc,%esp
c0024f6e:	68 34 cf 02 c0       	push   $0xc002cf34
c0024f73:	68 df cb 02 c0       	push   $0xc002cbdf
c0024f78:	68 ac be 02 c0       	push   $0xc002beac
c0024f7d:	6a 1e                	push   $0x1e
c0024f7f:	68 fb e0 02 c0       	push   $0xc002e0fb
c0024f84:	e8 b7 26 00 00       	call   c0027640 <debug_panic>
  return (pos + 1) % INTQ_BUFSIZE;
c0024f89:	48                   	dec    %eax
c0024f8a:	83 c8 c0             	or     $0xffffffc0,%eax
c0024f8d:	40                   	inc    %eax
c0024f8e:	eb d0                	jmp    c0024f60 <intq_full+0x1c>

c0024f90 <wait>:

/* WAITER must be the address of Q's not_empty or not_full
   member.  Waits until the given condition is true. */
static void
wait (struct intq *q UNUSED, struct thread **waiter) 
{
c0024f90:	56                   	push   %esi
c0024f91:	53                   	push   %ebx
c0024f92:	83 ec 04             	sub    $0x4,%esp
c0024f95:	89 c3                	mov    %eax,%ebx
c0024f97:	89 d6                	mov    %edx,%esi
  ASSERT (!intr_context ());
c0024f99:	e8 06 c3 ff ff       	call   c00212a4 <intr_context>
c0024f9e:	84 c0                	test   %al,%al
c0024fa0:	75 39                	jne    c0024fdb <wait+0x4b>
  ASSERT (intr_get_level () == INTR_OFF);
c0024fa2:	e8 9f c0 ff ff       	call   c0021046 <intr_get_level>
c0024fa7:	85 c0                	test   %eax,%eax
c0024fa9:	75 4e                	jne    c0024ff9 <wait+0x69>
  ASSERT ((waiter == &q->not_empty && intq_empty (q))
c0024fab:	8d 43 1c             	lea    0x1c(%ebx),%eax
c0024fae:	39 c6                	cmp    %eax,%esi
c0024fb0:	74 65                	je     c0025017 <wait+0x87>
c0024fb2:	8d 43 18             	lea    0x18(%ebx),%eax
c0024fb5:	39 c6                	cmp    %eax,%esi
c0024fb7:	75 70                	jne    c0025029 <wait+0x99>
c0024fb9:	83 ec 0c             	sub    $0xc,%esp
c0024fbc:	53                   	push   %ebx
c0024fbd:	e8 82 ff ff ff       	call   c0024f44 <intq_full>
c0024fc2:	83 c4 10             	add    $0x10,%esp
c0024fc5:	84 c0                	test   %al,%al
c0024fc7:	74 60                	je     c0025029 <wait+0x99>
          || (waiter == &q->not_full && intq_full (q)));

  *waiter = thread_current ();
c0024fc9:	e8 83 ba ff ff       	call   c0020a51 <thread_current>
c0024fce:	89 06                	mov    %eax,(%esi)
  thread_block ();
c0024fd0:	e8 69 bd ff ff       	call   c0020d3e <thread_block>
}
c0024fd5:	83 c4 04             	add    $0x4,%esp
c0024fd8:	5b                   	pop    %ebx
c0024fd9:	5e                   	pop    %esi
c0024fda:	c3                   	ret    
  ASSERT (!intr_context ());
c0024fdb:	83 ec 0c             	sub    $0xc,%esp
c0024fde:	68 e0 cf 02 c0       	push   $0xc002cfe0
c0024fe3:	68 df cb 02 c0       	push   $0xc002cbdf
c0024fe8:	68 98 be 02 c0       	push   $0xc002be98
c0024fed:	6a 59                	push   $0x59
c0024fef:	68 fb e0 02 c0       	push   $0xc002e0fb
c0024ff4:	e8 47 26 00 00       	call   c0027640 <debug_panic>
  ASSERT (intr_get_level () == INTR_OFF);
c0024ff9:	83 ec 0c             	sub    $0xc,%esp
c0024ffc:	68 34 cf 02 c0       	push   $0xc002cf34
c0025001:	68 df cb 02 c0       	push   $0xc002cbdf
c0025006:	68 98 be 02 c0       	push   $0xc002be98
c002500b:	6a 5a                	push   $0x5a
c002500d:	68 fb e0 02 c0       	push   $0xc002e0fb
c0025012:	e8 29 26 00 00       	call   c0027640 <debug_panic>
  ASSERT ((waiter == &q->not_empty && intq_empty (q))
c0025017:	83 ec 0c             	sub    $0xc,%esp
c002501a:	53                   	push   %ebx
c002501b:	e8 e7 fe ff ff       	call   c0024f07 <intq_empty>
c0025020:	83 c4 10             	add    $0x10,%esp
c0025023:	84 c0                	test   %al,%al
c0025025:	74 8b                	je     c0024fb2 <wait+0x22>
c0025027:	eb a0                	jmp    c0024fc9 <wait+0x39>
c0025029:	83 ec 0c             	sub    $0xc,%esp
c002502c:	68 10 e1 02 c0       	push   $0xc002e110
c0025031:	68 df cb 02 c0       	push   $0xc002cbdf
c0025036:	68 98 be 02 c0       	push   $0xc002be98
c002503b:	6a 5c                	push   $0x5c
c002503d:	68 fb e0 02 c0       	push   $0xc002e0fb
c0025042:	e8 f9 25 00 00       	call   c0027640 <debug_panic>

c0025047 <signal>:
   member, and the associated condition must be true.  If a
   thread is waiting for the condition, wakes it up and resets
   the waiting thread. */
static void
signal (struct intq *q UNUSED, struct thread **waiter) 
{
c0025047:	56                   	push   %esi
c0025048:	53                   	push   %ebx
c0025049:	83 ec 04             	sub    $0x4,%esp
c002504c:	89 c6                	mov    %eax,%esi
c002504e:	89 d3                	mov    %edx,%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c0025050:	e8 f1 bf ff ff       	call   c0021046 <intr_get_level>
c0025055:	85 c0                	test   %eax,%eax
c0025057:	75 3c                	jne    c0025095 <signal+0x4e>
  ASSERT ((waiter == &q->not_empty && !intq_empty (q))
c0025059:	8d 46 1c             	lea    0x1c(%esi),%eax
c002505c:	39 c3                	cmp    %eax,%ebx
c002505e:	74 53                	je     c00250b3 <signal+0x6c>
c0025060:	8d 46 18             	lea    0x18(%esi),%eax
c0025063:	39 c3                	cmp    %eax,%ebx
c0025065:	75 5e                	jne    c00250c5 <signal+0x7e>
c0025067:	83 ec 0c             	sub    $0xc,%esp
c002506a:	56                   	push   %esi
c002506b:	e8 d4 fe ff ff       	call   c0024f44 <intq_full>
c0025070:	83 c4 10             	add    $0x10,%esp
c0025073:	84 c0                	test   %al,%al
c0025075:	75 4e                	jne    c00250c5 <signal+0x7e>
          || (waiter == &q->not_full && !intq_full (q)));

  if (*waiter != NULL) 
c0025077:	8b 03                	mov    (%ebx),%eax
c0025079:	85 c0                	test   %eax,%eax
c002507b:	74 12                	je     c002508f <signal+0x48>
    {
      thread_unblock (*waiter);
c002507d:	83 ec 0c             	sub    $0xc,%esp
c0025080:	50                   	push   %eax
c0025081:	e8 28 b8 ff ff       	call   c00208ae <thread_unblock>
      *waiter = NULL;
c0025086:	c7 03 00 00 00 00    	movl   $0x0,(%ebx)
c002508c:	83 c4 10             	add    $0x10,%esp
    }
}
c002508f:	83 c4 04             	add    $0x4,%esp
c0025092:	5b                   	pop    %ebx
c0025093:	5e                   	pop    %esi
c0025094:	c3                   	ret    
  ASSERT (intr_get_level () == INTR_OFF);
c0025095:	83 ec 0c             	sub    $0xc,%esp
c0025098:	68 34 cf 02 c0       	push   $0xc002cf34
c002509d:	68 df cb 02 c0       	push   $0xc002cbdf
c00250a2:	68 90 be 02 c0       	push   $0xc002be90
c00250a7:	6a 69                	push   $0x69
c00250a9:	68 fb e0 02 c0       	push   $0xc002e0fb
c00250ae:	e8 8d 25 00 00       	call   c0027640 <debug_panic>
  ASSERT ((waiter == &q->not_empty && !intq_empty (q))
c00250b3:	83 ec 0c             	sub    $0xc,%esp
c00250b6:	56                   	push   %esi
c00250b7:	e8 4b fe ff ff       	call   c0024f07 <intq_empty>
c00250bc:	83 c4 10             	add    $0x10,%esp
c00250bf:	84 c0                	test   %al,%al
c00250c1:	74 b4                	je     c0025077 <signal+0x30>
c00250c3:	eb 9b                	jmp    c0025060 <signal+0x19>
c00250c5:	83 ec 0c             	sub    $0xc,%esp
c00250c8:	68 6c e1 02 c0       	push   $0xc002e16c
c00250cd:	68 df cb 02 c0       	push   $0xc002cbdf
c00250d2:	68 90 be 02 c0       	push   $0xc002be90
c00250d7:	6a 6b                	push   $0x6b
c00250d9:	68 fb e0 02 c0       	push   $0xc002e0fb
c00250de:	e8 5d 25 00 00       	call   c0027640 <debug_panic>

c00250e3 <intq_getc>:
{
c00250e3:	56                   	push   %esi
c00250e4:	53                   	push   %ebx
c00250e5:	83 ec 04             	sub    $0x4,%esp
c00250e8:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (intr_get_level () == INTR_OFF);
c00250ec:	e8 55 bf ff ff       	call   c0021046 <intr_get_level>
c00250f1:	85 c0                	test   %eax,%eax
c00250f3:	75 3b                	jne    c0025130 <intq_getc+0x4d>
      wait (q, &q->not_empty);
c00250f5:	8d 73 1c             	lea    0x1c(%ebx),%esi
  while (intq_empty (q)) 
c00250f8:	83 ec 0c             	sub    $0xc,%esp
c00250fb:	53                   	push   %ebx
c00250fc:	e8 06 fe ff ff       	call   c0024f07 <intq_empty>
c0025101:	83 c4 10             	add    $0x10,%esp
c0025104:	84 c0                	test   %al,%al
c0025106:	74 64                	je     c002516c <intq_getc+0x89>
      ASSERT (!intr_context ());
c0025108:	e8 97 c1 ff ff       	call   c00212a4 <intr_context>
c002510d:	84 c0                	test   %al,%al
c002510f:	75 3d                	jne    c002514e <intq_getc+0x6b>
      lock_acquire (&q->lock);
c0025111:	83 ec 0c             	sub    $0xc,%esp
c0025114:	53                   	push   %ebx
c0025115:	e8 4c d2 ff ff       	call   c0022366 <lock_acquire>
      wait (q, &q->not_empty);
c002511a:	89 f2                	mov    %esi,%edx
c002511c:	89 d8                	mov    %ebx,%eax
c002511e:	e8 6d fe ff ff       	call   c0024f90 <wait>
      lock_release (&q->lock);
c0025123:	89 1c 24             	mov    %ebx,(%esp)
c0025126:	e8 60 d3 ff ff       	call   c002248b <lock_release>
c002512b:	83 c4 10             	add    $0x10,%esp
c002512e:	eb c8                	jmp    c00250f8 <intq_getc+0x15>
  ASSERT (intr_get_level () == INTR_OFF);
c0025130:	83 ec 0c             	sub    $0xc,%esp
c0025133:	68 34 cf 02 c0       	push   $0xc002cf34
c0025138:	68 df cb 02 c0       	push   $0xc002cbdf
c002513d:	68 a0 be 02 c0       	push   $0xc002bea0
c0025142:	6a 2a                	push   $0x2a
c0025144:	68 fb e0 02 c0       	push   $0xc002e0fb
c0025149:	e8 f2 24 00 00       	call   c0027640 <debug_panic>
      ASSERT (!intr_context ());
c002514e:	83 ec 0c             	sub    $0xc,%esp
c0025151:	68 e0 cf 02 c0       	push   $0xc002cfe0
c0025156:	68 df cb 02 c0       	push   $0xc002cbdf
c002515b:	68 a0 be 02 c0       	push   $0xc002bea0
c0025160:	6a 2d                	push   $0x2d
c0025162:	68 fb e0 02 c0       	push   $0xc002e0fb
c0025167:	e8 d4 24 00 00       	call   c0027640 <debug_panic>
  byte = q->buf[q->tail];
c002516c:	8b 43 64             	mov    0x64(%ebx),%eax
c002516f:	0f b6 74 03 20       	movzbl 0x20(%ebx,%eax,1),%esi
  return (pos + 1) % INTQ_BUFSIZE;
c0025174:	40                   	inc    %eax
c0025175:	25 3f 00 00 80       	and    $0x8000003f,%eax
c002517a:	78 15                	js     c0025191 <intq_getc+0xae>
  q->tail = next (q->tail);
c002517c:	89 43 64             	mov    %eax,0x64(%ebx)
  signal (q, &q->not_full);
c002517f:	8d 53 18             	lea    0x18(%ebx),%edx
c0025182:	89 d8                	mov    %ebx,%eax
c0025184:	e8 be fe ff ff       	call   c0025047 <signal>
}
c0025189:	89 f0                	mov    %esi,%eax
c002518b:	83 c4 04             	add    $0x4,%esp
c002518e:	5b                   	pop    %ebx
c002518f:	5e                   	pop    %esi
c0025190:	c3                   	ret    
  return (pos + 1) % INTQ_BUFSIZE;
c0025191:	48                   	dec    %eax
c0025192:	83 c8 c0             	or     $0xffffffc0,%eax
c0025195:	40                   	inc    %eax
c0025196:	eb e4                	jmp    c002517c <intq_getc+0x99>

c0025198 <intq_putc>:
{
c0025198:	57                   	push   %edi
c0025199:	56                   	push   %esi
c002519a:	53                   	push   %ebx
c002519b:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c002519f:	8b 7c 24 14          	mov    0x14(%esp),%edi
  ASSERT (intr_get_level () == INTR_OFF);
c00251a3:	e8 9e be ff ff       	call   c0021046 <intr_get_level>
c00251a8:	85 c0                	test   %eax,%eax
c00251aa:	75 3b                	jne    c00251e7 <intq_putc+0x4f>
      wait (q, &q->not_full);
c00251ac:	8d 73 18             	lea    0x18(%ebx),%esi
  while (intq_full (q))
c00251af:	83 ec 0c             	sub    $0xc,%esp
c00251b2:	53                   	push   %ebx
c00251b3:	e8 8c fd ff ff       	call   c0024f44 <intq_full>
c00251b8:	83 c4 10             	add    $0x10,%esp
c00251bb:	84 c0                	test   %al,%al
c00251bd:	74 64                	je     c0025223 <intq_putc+0x8b>
      ASSERT (!intr_context ());
c00251bf:	e8 e0 c0 ff ff       	call   c00212a4 <intr_context>
c00251c4:	84 c0                	test   %al,%al
c00251c6:	75 3d                	jne    c0025205 <intq_putc+0x6d>
      lock_acquire (&q->lock);
c00251c8:	83 ec 0c             	sub    $0xc,%esp
c00251cb:	53                   	push   %ebx
c00251cc:	e8 95 d1 ff ff       	call   c0022366 <lock_acquire>
      wait (q, &q->not_full);
c00251d1:	89 f2                	mov    %esi,%edx
c00251d3:	89 d8                	mov    %ebx,%eax
c00251d5:	e8 b6 fd ff ff       	call   c0024f90 <wait>
      lock_release (&q->lock);
c00251da:	89 1c 24             	mov    %ebx,(%esp)
c00251dd:	e8 a9 d2 ff ff       	call   c002248b <lock_release>
c00251e2:	83 c4 10             	add    $0x10,%esp
c00251e5:	eb c8                	jmp    c00251af <intq_putc+0x17>
  ASSERT (intr_get_level () == INTR_OFF);
c00251e7:	83 ec 0c             	sub    $0xc,%esp
c00251ea:	68 34 cf 02 c0       	push   $0xc002cf34
c00251ef:	68 df cb 02 c0       	push   $0xc002cbdf
c00251f4:	68 84 be 02 c0       	push   $0xc002be84
c00251f9:	6a 3f                	push   $0x3f
c00251fb:	68 fb e0 02 c0       	push   $0xc002e0fb
c0025200:	e8 3b 24 00 00       	call   c0027640 <debug_panic>
      ASSERT (!intr_context ());
c0025205:	83 ec 0c             	sub    $0xc,%esp
c0025208:	68 e0 cf 02 c0       	push   $0xc002cfe0
c002520d:	68 df cb 02 c0       	push   $0xc002cbdf
c0025212:	68 84 be 02 c0       	push   $0xc002be84
c0025217:	6a 42                	push   $0x42
c0025219:	68 fb e0 02 c0       	push   $0xc002e0fb
c002521e:	e8 1d 24 00 00       	call   c0027640 <debug_panic>
  q->buf[q->head] = byte;
c0025223:	8b 43 60             	mov    0x60(%ebx),%eax
c0025226:	89 f9                	mov    %edi,%ecx
c0025228:	88 4c 03 20          	mov    %cl,0x20(%ebx,%eax,1)
  return (pos + 1) % INTQ_BUFSIZE;
c002522c:	40                   	inc    %eax
c002522d:	25 3f 00 00 80       	and    $0x8000003f,%eax
c0025232:	78 11                	js     c0025245 <intq_putc+0xad>
  q->head = next (q->head);
c0025234:	89 43 60             	mov    %eax,0x60(%ebx)
  signal (q, &q->not_empty);
c0025237:	8d 53 1c             	lea    0x1c(%ebx),%edx
c002523a:	89 d8                	mov    %ebx,%eax
c002523c:	e8 06 fe ff ff       	call   c0025047 <signal>
}
c0025241:	5b                   	pop    %ebx
c0025242:	5e                   	pop    %esi
c0025243:	5f                   	pop    %edi
c0025244:	c3                   	ret    
  return (pos + 1) % INTQ_BUFSIZE;
c0025245:	48                   	dec    %eax
c0025246:	83 c8 c0             	or     $0xffffffc0,%eax
c0025249:	40                   	inc    %eax
c002524a:	eb e8                	jmp    c0025234 <intq_putc+0x9c>

c002524c <rtc_get_time>:

/* Returns number of seconds since Unix epoch of January 1,
   1970. */
time_t
rtc_get_time (void)
{
c002524c:	55                   	push   %ebp
c002524d:	57                   	push   %edi
c002524e:	56                   	push   %esi
c002524f:	53                   	push   %ebx
c0025250:	83 ec 18             	sub    $0x18,%esp
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025253:	bf 00 00 00 00       	mov    $0x0,%edi
c0025258:	89 f8                	mov    %edi,%eax
c002525a:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002525c:	e4 71                	in     $0x71,%al
c002525e:	88 c2                	mov    %al,%dl
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025260:	b0 02                	mov    $0x2,%al
c0025262:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0025264:	e4 71                	in     $0x71,%al
c0025266:	88 04 24             	mov    %al,(%esp)
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025269:	b0 04                	mov    $0x4,%al
c002526b:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002526d:	e4 71                	in     $0x71,%al
c002526f:	88 44 24 13          	mov    %al,0x13(%esp)
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025273:	b0 07                	mov    $0x7,%al
c0025275:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0025277:	e4 71                	in     $0x71,%al
c0025279:	89 c5                	mov    %eax,%ebp
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c002527b:	b0 08                	mov    $0x8,%al
c002527d:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002527f:	e4 71                	in     $0x71,%al
c0025281:	88 c3                	mov    %al,%bl
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025283:	b0 09                	mov    $0x9,%al
c0025285:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0025287:	e4 71                	in     $0x71,%al
c0025289:	89 c6                	mov    %eax,%esi
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c002528b:	89 f8                	mov    %edi,%eax
c002528d:	e6 70                	out    %al,$0x70
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c002528f:	e4 71                	in     $0x71,%al

/* Returns the integer value of the given BCD byte. */
static int
bcd_to_bin (uint8_t x)
{
  return (x & 0x0f) + ((x >> 4) * 10);
c0025291:	88 c1                	mov    %al,%cl
c0025293:	c0 e9 04             	shr    $0x4,%cl
c0025296:	0f b6 c9             	movzbl %cl,%ecx
c0025299:	8d 0c 89             	lea    (%ecx,%ecx,4),%ecx
c002529c:	01 c9                	add    %ecx,%ecx
c002529e:	83 e0 0f             	and    $0xf,%eax
c00252a1:	01 c8                	add    %ecx,%eax
c00252a3:	88 d1                	mov    %dl,%cl
c00252a5:	c0 e9 04             	shr    $0x4,%cl
c00252a8:	0f b6 c9             	movzbl %cl,%ecx
c00252ab:	8d 0c 89             	lea    (%ecx,%ecx,4),%ecx
c00252ae:	01 c9                	add    %ecx,%ecx
c00252b0:	83 e2 0f             	and    $0xf,%edx
c00252b3:	01 ca                	add    %ecx,%edx
  while (sec != bcd_to_bin (cmos_read (RTC_REG_SEC)));
c00252b5:	39 d0                	cmp    %edx,%eax
c00252b7:	75 9f                	jne    c0025258 <rtc_get_time+0xc>
  return (x & 0x0f) + ((x >> 4) * 10);
c00252b9:	89 f2                	mov    %esi,%edx
c00252bb:	c0 ea 04             	shr    $0x4,%dl
c00252be:	0f b6 d2             	movzbl %dl,%edx
c00252c1:	8d 14 92             	lea    (%edx,%edx,4),%edx
c00252c4:	01 d2                	add    %edx,%edx
c00252c6:	83 e6 0f             	and    $0xf,%esi
c00252c9:	01 d6                	add    %edx,%esi
  if (year < 70)
c00252cb:	83 fe 45             	cmp    $0x45,%esi
c00252ce:	7f 03                	jg     c00252d3 <rtc_get_time+0x87>
    year += 100;
c00252d0:	83 c6 64             	add    $0x64,%esi
  return (x & 0x0f) + ((x >> 4) * 10);
c00252d3:	88 da                	mov    %bl,%dl
c00252d5:	c0 ea 04             	shr    $0x4,%dl
c00252d8:	0f b6 d2             	movzbl %dl,%edx
c00252db:	8d 14 92             	lea    (%edx,%edx,4),%edx
c00252de:	01 d2                	add    %edx,%edx
c00252e0:	83 e3 0f             	and    $0xf,%ebx
c00252e3:	01 d3                	add    %edx,%ebx
  year -= 70;
c00252e5:	8d 7e ba             	lea    -0x46(%esi),%edi
c00252e8:	89 7c 24 14          	mov    %edi,0x14(%esp)
  time = (year * 365 + (year - 1) / 4) * 24 * 60 * 60;
c00252ec:	83 ee 47             	sub    $0x47,%esi
c00252ef:	89 f2                	mov    %esi,%edx
c00252f1:	85 f6                	test   %esi,%esi
c00252f3:	0f 88 de 00 00 00    	js     c00253d7 <rtc_get_time+0x18b>
c00252f9:	c1 fa 02             	sar    $0x2,%edx
c00252fc:	8b 7c 24 14          	mov    0x14(%esp),%edi
c0025300:	8d 0c ff             	lea    (%edi,%edi,8),%ecx
c0025303:	8d 0c cf             	lea    (%edi,%ecx,8),%ecx
c0025306:	8d 0c 89             	lea    (%ecx,%ecx,4),%ecx
c0025309:	01 ca                	add    %ecx,%edx
c002530b:	8d 0c 92             	lea    (%edx,%edx,4),%ecx
c002530e:	8d 0c 8a             	lea    (%edx,%ecx,4),%ecx
c0025311:	8d 3c ca             	lea    (%edx,%ecx,8),%edi
c0025314:	c1 e7 02             	shl    $0x2,%edi
c0025317:	29 d7                	sub    %edx,%edi
c0025319:	c1 e7 07             	shl    $0x7,%edi
  for (i = 1; i <= mon; i++)
c002531c:	85 db                	test   %ebx,%ebx
c002531e:	7e 24                	jle    c0025344 <rtc_get_time+0xf8>
c0025320:	be 01 00 00 00       	mov    $0x1,%esi
    time += days_per_month[i - 1] * 24 * 60 * 60;
c0025325:	8b 0c b5 dc be 02 c0 	mov    -0x3ffd4124(,%esi,4),%ecx
c002532c:	8d 14 89             	lea    (%ecx,%ecx,4),%edx
c002532f:	8d 14 91             	lea    (%ecx,%edx,4),%edx
c0025332:	8d 14 d1             	lea    (%ecx,%edx,8),%edx
c0025335:	c1 e2 02             	shl    $0x2,%edx
c0025338:	29 ca                	sub    %ecx,%edx
c002533a:	c1 e2 07             	shl    $0x7,%edx
c002533d:	01 d7                	add    %edx,%edi
  for (i = 1; i <= mon; i++)
c002533f:	46                   	inc    %esi
c0025340:	39 de                	cmp    %ebx,%esi
c0025342:	7e e1                	jle    c0025325 <rtc_get_time+0xd9>
  if (mon > 2 && year % 4 == 0)
c0025344:	83 fb 02             	cmp    $0x2,%ebx
c0025347:	7e 0d                	jle    c0025356 <rtc_get_time+0x10a>
c0025349:	f6 44 24 14 03       	testb  $0x3,0x14(%esp)
c002534e:	75 06                	jne    c0025356 <rtc_get_time+0x10a>
    time += 24 * 60 * 60;
c0025350:	81 c7 80 51 01 00    	add    $0x15180,%edi
  return (x & 0x0f) + ((x >> 4) * 10);
c0025356:	8a 5c 24 13          	mov    0x13(%esp),%bl
c002535a:	88 da                	mov    %bl,%dl
c002535c:	c0 ea 04             	shr    $0x4,%dl
c002535f:	0f b6 d2             	movzbl %dl,%edx
c0025362:	8d 0c 92             	lea    (%edx,%edx,4),%ecx
c0025365:	01 c9                	add    %ecx,%ecx
c0025367:	89 da                	mov    %ebx,%edx
c0025369:	83 e2 0f             	and    $0xf,%edx
c002536c:	01 ca                	add    %ecx,%edx
  time += hour * 60 * 60;
c002536e:	8d 0c 12             	lea    (%edx,%edx,1),%ecx
c0025371:	01 d1                	add    %edx,%ecx
c0025373:	01 c9                	add    %ecx,%ecx
c0025375:	01 d1                	add    %edx,%ecx
c0025377:	c1 e1 05             	shl    $0x5,%ecx
c002537a:	01 d1                	add    %edx,%ecx
c002537c:	c1 e1 04             	shl    $0x4,%ecx
  return (x & 0x0f) + ((x >> 4) * 10);
c002537f:	8a 14 24             	mov    (%esp),%dl
c0025382:	c0 ea 04             	shr    $0x4,%dl
c0025385:	0f b6 d2             	movzbl %dl,%edx
c0025388:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002538b:	8d 1c 12             	lea    (%edx,%edx,1),%ebx
c002538e:	8b 14 24             	mov    (%esp),%edx
c0025391:	83 e2 0f             	and    $0xf,%edx
c0025394:	01 da                	add    %ebx,%edx
  time += min * 60;
c0025396:	8d 1c 12             	lea    (%edx,%edx,1),%ebx
c0025399:	01 da                	add    %ebx,%edx
c002539b:	8d 14 92             	lea    (%edx,%edx,4),%edx
  time += sec;
c002539e:	8d 14 91             	lea    (%ecx,%edx,4),%edx
c00253a1:	01 d0                	add    %edx,%eax
  return (x & 0x0f) + ((x >> 4) * 10);
c00253a3:	89 ea                	mov    %ebp,%edx
c00253a5:	c0 ea 04             	shr    $0x4,%dl
c00253a8:	0f b6 d2             	movzbl %dl,%edx
c00253ab:	8d 14 92             	lea    (%edx,%edx,4),%edx
c00253ae:	8d 0c 12             	lea    (%edx,%edx,1),%ecx
c00253b1:	89 ea                	mov    %ebp,%edx
c00253b3:	83 e2 0f             	and    $0xf,%edx
  time += (mday - 1) * 24 * 60 * 60;
c00253b6:	8d 4c 11 ff          	lea    -0x1(%ecx,%edx,1),%ecx
c00253ba:	8d 14 89             	lea    (%ecx,%ecx,4),%edx
c00253bd:	8d 14 91             	lea    (%ecx,%edx,4),%edx
c00253c0:	8d 14 d1             	lea    (%ecx,%edx,8),%edx
c00253c3:	c1 e2 02             	shl    $0x2,%edx
c00253c6:	29 ca                	sub    %ecx,%edx
c00253c8:	c1 e2 07             	shl    $0x7,%edx
  time += sec;
c00253cb:	01 d0                	add    %edx,%eax
c00253cd:	01 f8                	add    %edi,%eax
}
c00253cf:	83 c4 18             	add    $0x18,%esp
c00253d2:	5b                   	pop    %ebx
c00253d3:	5e                   	pop    %esi
c00253d4:	5f                   	pop    %edi
c00253d5:	5d                   	pop    %ebp
c00253d6:	c3                   	ret    
  time = (year * 365 + (year - 1) / 4) * 24 * 60 * 60;
c00253d7:	8d 56 03             	lea    0x3(%esi),%edx
c00253da:	e9 1a ff ff ff       	jmp    c00252f9 <rtc_get_time+0xad>

c00253df <shutdown_configure>:
/* Sets TYPE as the way that machine will shut down when Pintos
   execution is complete. */
void
shutdown_configure (enum shutdown_type type)
{
  how = type;
c00253df:	8b 44 24 04          	mov    0x4(%esp),%eax
c00253e3:	a3 88 81 03 c0       	mov    %eax,0xc0038188
c00253e8:	c3                   	ret    

c00253e9 <shutdown_reboot>:
}

/* Reboots the machine via the keyboard controller. */
void
shutdown_reboot (void)
{
c00253e9:	56                   	push   %esi
c00253ea:	53                   	push   %ebx
c00253eb:	83 ec 10             	sub    $0x10,%esp
  printf ("Rebooting...\n");
c00253ee:	68 c7 e1 02 c0       	push   $0xc002e1c7
c00253f3:	e8 96 3c 00 00       	call   c002908e <puts>
c00253f8:	83 c4 10             	add    $0x10,%esp
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00253fb:	be fe ff ff ff       	mov    $0xfffffffe,%esi
c0025400:	eb 1f                	jmp    c0025421 <shutdown_reboot+0x38>
          if ((inb (CONTROL_REG) & 0x02) == 0)
            break;
          timer_udelay (2);
        }

      timer_udelay (50);
c0025402:	83 ec 08             	sub    $0x8,%esp
c0025405:	6a 00                	push   $0x0
c0025407:	6a 32                	push   $0x32
c0025409:	e8 0b e0 ff ff       	call   c0023419 <timer_udelay>
c002540e:	89 f0                	mov    %esi,%eax
c0025410:	e6 64                	out    %al,$0x64

      /* Pulse bit 0 of the output port P2 of the keyboard controller.
       * This will reset the CPU. */
      outb (CONTROL_REG, 0xfe);
      timer_udelay (50);
c0025412:	83 c4 08             	add    $0x8,%esp
c0025415:	6a 00                	push   $0x0
c0025417:	6a 32                	push   $0x32
c0025419:	e8 fb df ff ff       	call   c0023419 <timer_udelay>
    {
c002541e:	83 c4 10             	add    $0x10,%esp
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0025421:	e4 64                	in     $0x64,%al
          if ((inb (CONTROL_REG) & 0x02) == 0)
c0025423:	a8 02                	test   $0x2,%al
c0025425:	74 db                	je     c0025402 <shutdown_reboot+0x19>
          timer_udelay (2);
c0025427:	83 ec 08             	sub    $0x8,%esp
c002542a:	6a 00                	push   $0x0
c002542c:	6a 02                	push   $0x2
c002542e:	e8 e6 df ff ff       	call   c0023419 <timer_udelay>
c0025433:	83 c4 10             	add    $0x10,%esp
c0025436:	bb ff ff 00 00       	mov    $0xffff,%ebx
c002543b:	e4 64                	in     $0x64,%al
          if ((inb (CONTROL_REG) & 0x02) == 0)
c002543d:	a8 02                	test   $0x2,%al
c002543f:	74 c1                	je     c0025402 <shutdown_reboot+0x19>
          timer_udelay (2);
c0025441:	83 ec 08             	sub    $0x8,%esp
c0025444:	6a 00                	push   $0x0
c0025446:	6a 02                	push   $0x2
c0025448:	e8 cc df ff ff       	call   c0023419 <timer_udelay>
      for (i = 0; i < 0x10000; i++)
c002544d:	83 c4 10             	add    $0x10,%esp
c0025450:	4b                   	dec    %ebx
c0025451:	75 e8                	jne    c002543b <shutdown_reboot+0x52>
c0025453:	eb ad                	jmp    c0025402 <shutdown_reboot+0x19>

c0025455 <shutdown_power_off>:

/* Powers down the machine we're running on,
   as long as we're running on Bochs or QEMU. */
void
shutdown_power_off (void)
{
c0025455:	57                   	push   %edi
c0025456:	56                   	push   %esi
c0025457:	83 ec 14             	sub    $0x14,%esp
  const char s[] = "Shutdown";
c002545a:	8d 7c 24 07          	lea    0x7(%esp),%edi
c002545e:	be f5 e1 02 c0       	mov    $0xc002e1f5,%esi
c0025463:	b9 09 00 00 00       	mov    $0x9,%ecx
c0025468:	f3 a4                	rep movsb %ds:(%esi),%es:(%edi)

/* Print statistics about Pintos execution. */
static void
print_stats (void)
{
  timer_print_stats ();
c002546a:	e8 dc df ff ff       	call   c002344b <timer_print_stats>
  thread_print_stats ();
c002546f:	e8 0d b4 ff ff       	call   c0020881 <thread_print_stats>
#ifdef FILESYS
  block_print_stats ();
#endif
  console_print_stats ();
c0025474:	e8 c4 3b 00 00       	call   c002903d <console_print_stats>
  kbd_print_stats ();
c0025479:	e8 de e1 ff ff       	call   c002365c <kbd_print_stats>
  printf ("Powering off...\n");
c002547e:	83 ec 0c             	sub    $0xc,%esp
c0025481:	68 d4 e1 02 c0       	push   $0xc002e1d4
c0025486:	e8 03 3c 00 00       	call   c002908e <puts>
  serial_flush ();
c002548b:	e8 b3 e6 ff ff       	call   c0023b43 <serial_flush>
  asm volatile ("outw %w0, %w1" : : "a" (data), "Nd" (port));
c0025490:	ba 04 b0 ff ff       	mov    $0xffffb004,%edx
c0025495:	b8 00 20 00 00       	mov    $0x2000,%eax
c002549a:	66 ef                	out    %ax,(%dx)
  for (p = s; *p != '\0'; p++)
c002549c:	8a 44 24 17          	mov    0x17(%esp),%al
c00254a0:	83 c4 10             	add    $0x10,%esp
c00254a3:	84 c0                	test   %al,%al
c00254a5:	74 11                	je     c00254b8 <shutdown_power_off+0x63>
c00254a7:	8d 4c 24 07          	lea    0x7(%esp),%ecx
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c00254ab:	ba 00 89 ff ff       	mov    $0xffff8900,%edx
c00254b0:	ee                   	out    %al,(%dx)
c00254b1:	41                   	inc    %ecx
c00254b2:	8a 01                	mov    (%ecx),%al
c00254b4:	84 c0                	test   %al,%al
c00254b6:	75 f8                	jne    c00254b0 <shutdown_power_off+0x5b>
c00254b8:	ba 01 05 00 00       	mov    $0x501,%edx
c00254bd:	b0 31                	mov    $0x31,%al
c00254bf:	ee                   	out    %al,(%dx)
  asm volatile ("cli; hlt" : : : "memory");
c00254c0:	fa                   	cli    
c00254c1:	f4                   	hlt    
  printf ("still running...\n");
c00254c2:	83 ec 0c             	sub    $0xc,%esp
c00254c5:	68 e4 e1 02 c0       	push   $0xc002e1e4
c00254ca:	e8 bf 3b 00 00       	call   c002908e <puts>
c00254cf:	83 c4 10             	add    $0x10,%esp
c00254d2:	eb fe                	jmp    c00254d2 <shutdown_power_off+0x7d>

c00254d4 <shutdown>:
{
c00254d4:	83 ec 0c             	sub    $0xc,%esp
  switch (how)
c00254d7:	a1 88 81 03 c0       	mov    0xc0038188,%eax
c00254dc:	83 f8 01             	cmp    $0x1,%eax
c00254df:	74 09                	je     c00254ea <shutdown+0x16>
c00254e1:	83 f8 02             	cmp    $0x2,%eax
c00254e4:	74 09                	je     c00254ef <shutdown+0x1b>
}
c00254e6:	83 c4 0c             	add    $0xc,%esp
c00254e9:	c3                   	ret    
      shutdown_power_off ();
c00254ea:	e8 66 ff ff ff       	call   c0025455 <shutdown_power_off>
      shutdown_reboot ();
c00254ef:	e8 f5 fe ff ff       	call   c00253e9 <shutdown_reboot>

c00254f4 <speaker_off>:

/* Turn off the PC speaker, by disconnecting the timer channel's
   output from the speaker. */
void
speaker_off (void)
{
c00254f4:	83 ec 0c             	sub    $0xc,%esp
  enum intr_level old_level = intr_disable ();
c00254f7:	e8 87 bb ff ff       	call   c0021083 <intr_disable>
c00254fc:	89 c2                	mov    %eax,%edx
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c00254fe:	e4 61                	in     $0x61,%al
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025500:	83 e0 fc             	and    $0xfffffffc,%eax
c0025503:	e6 61                	out    %al,$0x61
  outb (SPEAKER_PORT_GATE, inb (SPEAKER_PORT_GATE) & ~SPEAKER_GATE_ENABLE);
  intr_set_level (old_level);
c0025505:	83 ec 0c             	sub    $0xc,%esp
c0025508:	52                   	push   %edx
c0025509:	e8 7c bb ff ff       	call   c002108a <intr_set_level>
}
c002550e:	83 c4 1c             	add    $0x1c,%esp
c0025511:	c3                   	ret    

c0025512 <speaker_on>:
{
c0025512:	56                   	push   %esi
c0025513:	53                   	push   %ebx
c0025514:	83 ec 04             	sub    $0x4,%esp
c0025517:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  if (frequency >= 20 && frequency <= 20000)
c002551b:	8d 43 ec             	lea    -0x14(%ebx),%eax
c002551e:	3d 0c 4e 00 00       	cmp    $0x4e0c,%eax
c0025523:	76 0b                	jbe    c0025530 <speaker_on+0x1e>
      speaker_off ();
c0025525:	e8 ca ff ff ff       	call   c00254f4 <speaker_off>
}
c002552a:	83 c4 04             	add    $0x4,%esp
c002552d:	5b                   	pop    %ebx
c002552e:	5e                   	pop    %esi
c002552f:	c3                   	ret    
      enum intr_level old_level = intr_disable ();
c0025530:	e8 4e bb ff ff       	call   c0021083 <intr_disable>
c0025535:	89 c6                	mov    %eax,%esi
      pit_configure_channel (2, 3, frequency);
c0025537:	83 ec 04             	sub    $0x4,%esp
c002553a:	53                   	push   %ebx
c002553b:	6a 03                	push   $0x3
c002553d:	6a 02                	push   $0x2
c002553f:	e8 63 da ff ff       	call   c0022fa7 <pit_configure_channel>
  asm volatile ("inb %w1, %b0" : "=a" (data) : "Nd" (port));
c0025544:	e4 61                	in     $0x61,%al
      outb (SPEAKER_PORT_GATE, inb (SPEAKER_PORT_GATE) | SPEAKER_GATE_ENABLE);
c0025546:	83 c8 03             	or     $0x3,%eax
  asm volatile ("outb %b0, %w1" : : "a" (data), "Nd" (port));
c0025549:	e6 61                	out    %al,$0x61
      intr_set_level (old_level);
c002554b:	89 34 24             	mov    %esi,(%esp)
c002554e:	e8 37 bb ff ff       	call   c002108a <intr_set_level>
c0025553:	83 c4 10             	add    $0x10,%esp
c0025556:	eb d2                	jmp    c002552a <speaker_on+0x18>

c0025558 <speaker_beep>:

/* Briefly beep the PC speaker. */
void
speaker_beep (void)
{
c0025558:	83 ec 0c             	sub    $0xc,%esp

     We can't just enable interrupts while we sleep.  For one
     thing, we get called (indirectly) from printf, which should
     always work, even during boot before we're ready to enable
     interrupts. */
  if (intr_get_level () == INTR_ON)
c002555b:	e8 e6 ba ff ff       	call   c0021046 <intr_get_level>
c0025560:	83 f8 01             	cmp    $0x1,%eax
c0025563:	74 04                	je     c0025569 <speaker_beep+0x11>
    {
      speaker_on (440);
      timer_msleep (250);
      speaker_off ();
    }
}
c0025565:	83 c4 0c             	add    $0xc,%esp
c0025568:	c3                   	ret    
      speaker_on (440);
c0025569:	83 ec 0c             	sub    $0xc,%esp
c002556c:	68 b8 01 00 00       	push   $0x1b8
c0025571:	e8 9c ff ff ff       	call   c0025512 <speaker_on>
      timer_msleep (250);
c0025576:	83 c4 08             	add    $0x8,%esp
c0025579:	6a 00                	push   $0x0
c002557b:	68 fa 00 00 00       	push   $0xfa
c0025580:	e8 30 de ff ff       	call   c00233b5 <timer_msleep>
      speaker_off ();
c0025585:	e8 6a ff ff ff       	call   c00254f4 <speaker_off>
c002558a:	83 c4 10             	add    $0x10,%esp
}
c002558d:	eb d6                	jmp    c0025565 <speaker_beep+0xd>

c002558f <debug_backtrace>:
   each of the functions we are nested within.  gdb or addr2line
   may be applied to kernel.o to translate these into file names,
   line numbers, and function names.  */
void
debug_backtrace (void) 
{
c002558f:	55                   	push   %ebp
c0025590:	89 e5                	mov    %esp,%ebp
c0025592:	53                   	push   %ebx
c0025593:	83 ec 0c             	sub    $0xc,%esp
  static bool explained;
  void **frame;
  
  printf ("Call stack: %p", __builtin_return_address (0));
c0025596:	ff 75 04             	pushl  0x4(%ebp)
c0025599:	68 fe e1 02 c0       	push   $0xc002e1fe
c002559e:	e8 ef 05 00 00       	call   c0025b92 <printf>
  for (frame = __builtin_frame_address (1);
c00255a3:	8b 5d 00             	mov    0x0(%ebp),%ebx
c00255a6:	83 c4 10             	add    $0x10,%esp
c00255a9:	81 fb ff 0f 00 00    	cmp    $0xfff,%ebx
c00255af:	76 27                	jbe    c00255d8 <debug_backtrace+0x49>
       (uintptr_t) frame >= 0x1000 && frame[0] != NULL;
c00255b1:	83 3b 00             	cmpl   $0x0,(%ebx)
c00255b4:	74 22                	je     c00255d8 <debug_backtrace+0x49>
       frame = frame[0]) 
    printf (" %p", frame[1]);
c00255b6:	83 ec 08             	sub    $0x8,%esp
c00255b9:	ff 73 04             	pushl  0x4(%ebx)
c00255bc:	68 09 e2 02 c0       	push   $0xc002e209
c00255c1:	e8 cc 05 00 00       	call   c0025b92 <printf>
       frame = frame[0]) 
c00255c6:	8b 1b                	mov    (%ebx),%ebx
  for (frame = __builtin_frame_address (1);
c00255c8:	83 c4 10             	add    $0x10,%esp
c00255cb:	81 fb ff 0f 00 00    	cmp    $0xfff,%ebx
c00255d1:	76 05                	jbe    c00255d8 <debug_backtrace+0x49>
       (uintptr_t) frame >= 0x1000 && frame[0] != NULL;
c00255d3:	83 3b 00             	cmpl   $0x0,(%ebx)
c00255d6:	75 de                	jne    c00255b6 <debug_backtrace+0x27>
  printf (".\n");
c00255d8:	83 ec 0c             	sub    $0xc,%esp
c00255db:	68 97 dd 02 c0       	push   $0xc002dd97
c00255e0:	e8 a9 3a 00 00       	call   c002908e <puts>

  if (!explained) 
c00255e5:	83 c4 10             	add    $0x10,%esp
c00255e8:	80 3d 8c 81 03 c0 00 	cmpb   $0x0,0xc003818c
c00255ef:	74 05                	je     c00255f6 <debug_backtrace+0x67>
      explained = true;
      printf ("The `backtrace' program can make call stacks useful.\n"
              "Read \"Backtraces\" in the \"Debugging Tools\" chapter\n"
              "of the Pintos documentation for more information.\n");
    }
}
c00255f1:	8b 5d fc             	mov    -0x4(%ebp),%ebx
c00255f4:	c9                   	leave  
c00255f5:	c3                   	ret    
      explained = true;
c00255f6:	c6 05 8c 81 03 c0 01 	movb   $0x1,0xc003818c
      printf ("The `backtrace' program can make call stacks useful.\n"
c00255fd:	83 ec 0c             	sub    $0xc,%esp
c0025600:	68 10 e2 02 c0       	push   $0xc002e210
c0025605:	e8 84 3a 00 00       	call   c002908e <puts>
c002560a:	83 c4 10             	add    $0x10,%esp
}
c002560d:	eb e2                	jmp    c00255f1 <debug_backtrace+0x62>

c002560f <random_init>:
}

/* Initializes or reinitializes the PRNG with the given SEED. */
void
random_init (unsigned seed)
{
c002560f:	56                   	push   %esi
c0025610:	53                   	push   %ebx
  uint8_t *seedp = (uint8_t *) &seed;
  int i;
  uint8_t j;

  for (i = 0; i < 256; i++) 
c0025611:	b8 00 00 00 00       	mov    $0x0,%eax
    s[i] = i;
c0025616:	88 80 c0 81 03 c0    	mov    %al,-0x3ffc7e40(%eax)
  for (i = 0; i < 256; i++) 
c002561c:	40                   	inc    %eax
c002561d:	3d 00 01 00 00       	cmp    $0x100,%eax
c0025622:	75 f2                	jne    c0025616 <random_init+0x7>
c0025624:	be 00 00 00 00       	mov    $0x0,%esi
c0025629:	b8 00 00 00 00       	mov    $0x0,%eax
  for (i = j = 0; i < 256; i++) 
    {
      j += s[i] + seedp[i % sizeof seed];
c002562e:	89 c1                	mov    %eax,%ecx
c0025630:	83 e1 03             	and    $0x3,%ecx
c0025633:	8a 98 c0 81 03 c0    	mov    -0x3ffc7e40(%eax),%bl
c0025639:	88 da                	mov    %bl,%dl
c002563b:	02 54 0c 0c          	add    0xc(%esp,%ecx,1),%dl
c002563f:	88 d1                	mov    %dl,%cl
c0025641:	01 ce                	add    %ecx,%esi
      swap_byte (s + i, s + j);
c0025643:	89 f2                	mov    %esi,%edx
c0025645:	0f b6 ca             	movzbl %dl,%ecx
  *a = *b;
c0025648:	8a 91 c0 81 03 c0    	mov    -0x3ffc7e40(%ecx),%dl
c002564e:	88 90 c0 81 03 c0    	mov    %dl,-0x3ffc7e40(%eax)
  *b = t;
c0025654:	88 99 c0 81 03 c0    	mov    %bl,-0x3ffc7e40(%ecx)
  for (i = j = 0; i < 256; i++) 
c002565a:	40                   	inc    %eax
c002565b:	3d 00 01 00 00       	cmp    $0x100,%eax
c0025660:	75 cc                	jne    c002562e <random_init+0x1f>
    }

  s_i = s_j = 0;
c0025662:	c6 05 a1 81 03 c0 00 	movb   $0x0,0xc00381a1
c0025669:	c6 05 a2 81 03 c0 00 	movb   $0x0,0xc00381a2
  inited = true;
c0025670:	c6 05 a0 81 03 c0 01 	movb   $0x1,0xc00381a0
}
c0025677:	5b                   	pop    %ebx
c0025678:	5e                   	pop    %esi
c0025679:	c3                   	ret    

c002567a <random_bytes>:

/* Writes SIZE random bytes into BUF. */
void
random_bytes (void *buf_, size_t size) 
{
c002567a:	55                   	push   %ebp
c002567b:	57                   	push   %edi
c002567c:	56                   	push   %esi
c002567d:	53                   	push   %ebx
c002567e:	83 ec 04             	sub    $0x4,%esp
c0025681:	8b 7c 24 1c          	mov    0x1c(%esp),%edi
  uint8_t *buf;

  if (!inited)
c0025685:	80 3d a0 81 03 c0 00 	cmpb   $0x0,0xc00381a0
c002568c:	0f 84 8c 00 00 00    	je     c002571e <random_bytes+0xa4>
    random_init (0);

  for (buf = buf_; size-- > 0; buf++)
c0025692:	8d 6f ff             	lea    -0x1(%edi),%ebp
c0025695:	85 ff                	test   %edi,%edi
c0025697:	74 7d                	je     c0025716 <random_bytes+0x9c>
c0025699:	0f b6 35 a1 81 03 c0 	movzbl 0xc00381a1,%esi
c00256a0:	a0 a2 81 03 c0       	mov    0xc00381a2,%al
c00256a5:	40                   	inc    %eax
c00256a6:	88 44 24 03          	mov    %al,0x3(%esp)
c00256aa:	03 7c 24 18          	add    0x18(%esp),%edi
c00256ae:	88 44 24 01          	mov    %al,0x1(%esp)
c00256b2:	8b 4c 24 18          	mov    0x18(%esp),%ecx
    {
      uint8_t s_k;
      
      s_i++;
      s_j += s[s_i];
c00256b6:	0f b6 54 24 01       	movzbl 0x1(%esp),%edx
c00256bb:	89 f3                	mov    %esi,%ebx
c00256bd:	02 9a c0 81 03 c0    	add    -0x3ffc7e40(%edx),%bl
c00256c3:	89 de                	mov    %ebx,%esi
      swap_byte (s + s_i, s + s_j);
c00256c5:	0f b6 c3             	movzbl %bl,%eax
  uint8_t t = *a;
c00256c8:	8a 9a c0 81 03 c0    	mov    -0x3ffc7e40(%edx),%bl
c00256ce:	88 5c 24 02          	mov    %bl,0x2(%esp)
  *a = *b;
c00256d2:	8a 98 c0 81 03 c0    	mov    -0x3ffc7e40(%eax),%bl
c00256d8:	88 9a c0 81 03 c0    	mov    %bl,-0x3ffc7e40(%edx)
  *b = t;
c00256de:	8a 5c 24 02          	mov    0x2(%esp),%bl
c00256e2:	88 98 c0 81 03 c0    	mov    %bl,-0x3ffc7e40(%eax)

      s_k = s[s_i] + s[s_j];
c00256e8:	88 d8                	mov    %bl,%al
c00256ea:	02 82 c0 81 03 c0    	add    -0x3ffc7e40(%edx),%al
      *buf = s[s_k];
c00256f0:	0f b6 c0             	movzbl %al,%eax
c00256f3:	8a 90 c0 81 03 c0    	mov    -0x3ffc7e40(%eax),%dl
c00256f9:	88 11                	mov    %dl,(%ecx)
  for (buf = buf_; size-- > 0; buf++)
c00256fb:	41                   	inc    %ecx
c00256fc:	fe 44 24 01          	incb   0x1(%esp)
c0025700:	39 f9                	cmp    %edi,%ecx
c0025702:	75 b2                	jne    c00256b6 <random_bytes+0x3c>
c0025704:	8a 44 24 03          	mov    0x3(%esp),%al
c0025708:	01 e8                	add    %ebp,%eax
c002570a:	a2 a2 81 03 c0       	mov    %al,0xc00381a2
c002570f:	89 f0                	mov    %esi,%eax
c0025711:	a2 a1 81 03 c0       	mov    %al,0xc00381a1
    }
}
c0025716:	83 c4 04             	add    $0x4,%esp
c0025719:	5b                   	pop    %ebx
c002571a:	5e                   	pop    %esi
c002571b:	5f                   	pop    %edi
c002571c:	5d                   	pop    %ebp
c002571d:	c3                   	ret    
    random_init (0);
c002571e:	6a 00                	push   $0x0
c0025720:	e8 ea fe ff ff       	call   c002560f <random_init>
c0025725:	83 c4 04             	add    $0x4,%esp
c0025728:	e9 65 ff ff ff       	jmp    c0025692 <random_bytes+0x18>

c002572d <random_ulong>:
/* Returns a pseudo-random unsigned long.
   Use random_ulong() % n to obtain a random number in the range
   0...n (exclusive). */
unsigned long
random_ulong (void) 
{
c002572d:	83 ec 10             	sub    $0x10,%esp
  unsigned long ul;
  random_bytes (&ul, sizeof ul);
c0025730:	6a 04                	push   $0x4
c0025732:	8d 44 24 10          	lea    0x10(%esp),%eax
c0025736:	50                   	push   %eax
c0025737:	e8 3e ff ff ff       	call   c002567a <random_bytes>
  return ul;
}
c002573c:	8b 44 24 14          	mov    0x14(%esp),%eax
c0025740:	83 c4 18             	add    $0x18,%esp
c0025743:	c3                   	ret    

c0025744 <vsnprintf_helper>:
}

/* Helper function for vsnprintf(). */
static void
vsnprintf_helper (char ch, void *aux_)
{
c0025744:	53                   	push   %ebx
c0025745:	8b 5c 24 08          	mov    0x8(%esp),%ebx
c0025749:	8b 44 24 0c          	mov    0xc(%esp),%eax
  struct vsnprintf_aux *aux = aux_;

  if (aux->length++ < aux->max_length)
c002574d:	8b 50 04             	mov    0x4(%eax),%edx
c0025750:	8d 4a 01             	lea    0x1(%edx),%ecx
c0025753:	89 48 04             	mov    %ecx,0x4(%eax)
c0025756:	3b 50 08             	cmp    0x8(%eax),%edx
c0025759:	7d 09                	jge    c0025764 <vsnprintf_helper+0x20>
    *aux->p++ = ch;
c002575b:	8b 10                	mov    (%eax),%edx
c002575d:	8d 4a 01             	lea    0x1(%edx),%ecx
c0025760:	89 08                	mov    %ecx,(%eax)
c0025762:	88 1a                	mov    %bl,(%edx)
}
c0025764:	5b                   	pop    %ebx
c0025765:	c3                   	ret    

c0025766 <output_dup>:
}

/* Writes CH to OUTPUT with auxiliary data AUX, CNT times. */
static void
output_dup (char ch, size_t cnt, void (*output) (char, void *), void *aux) 
{
c0025766:	55                   	push   %ebp
c0025767:	57                   	push   %edi
c0025768:	56                   	push   %esi
c0025769:	53                   	push   %ebx
c002576a:	83 ec 0c             	sub    $0xc,%esp
c002576d:	8b 7c 24 20          	mov    0x20(%esp),%edi
  while (cnt-- > 0)
c0025771:	85 d2                	test   %edx,%edx
c0025773:	74 18                	je     c002578d <output_dup+0x27>
c0025775:	8d 5a ff             	lea    -0x1(%edx),%ebx
c0025778:	89 cd                	mov    %ecx,%ebp
    output (ch, aux);
c002577a:	0f be f0             	movsbl %al,%esi
c002577d:	83 ec 08             	sub    $0x8,%esp
c0025780:	57                   	push   %edi
c0025781:	56                   	push   %esi
c0025782:	ff d5                	call   *%ebp
  while (cnt-- > 0)
c0025784:	4b                   	dec    %ebx
c0025785:	83 c4 10             	add    $0x10,%esp
c0025788:	83 fb ff             	cmp    $0xffffffff,%ebx
c002578b:	75 f0                	jne    c002577d <output_dup+0x17>
}
c002578d:	83 c4 0c             	add    $0xc,%esp
c0025790:	5b                   	pop    %ebx
c0025791:	5e                   	pop    %esi
c0025792:	5f                   	pop    %edi
c0025793:	5d                   	pop    %ebp
c0025794:	c3                   	ret    

c0025795 <format_integer>:
{
c0025795:	55                   	push   %ebp
c0025796:	57                   	push   %edi
c0025797:	56                   	push   %esi
c0025798:	53                   	push   %ebx
c0025799:	83 ec 7c             	sub    $0x7c,%esp
c002579c:	89 c6                	mov    %eax,%esi
c002579e:	89 d7                	mov    %edx,%edi
c00257a0:	8b 84 24 90 00 00 00 	mov    0x90(%esp),%eax
  if (is_signed) 
c00257a7:	84 c9                	test   %cl,%cl
c00257a9:	74 42                	je     c00257ed <format_integer+0x58>
      if (c->flags & PLUS)
c00257ab:	8b 8c 24 98 00 00 00 	mov    0x98(%esp),%ecx
c00257b2:	8b 11                	mov    (%ecx),%edx
c00257b4:	f6 c2 02             	test   $0x2,%dl
c00257b7:	74 10                	je     c00257c9 <format_integer+0x34>
        sign = negative ? '-' : '+';
c00257b9:	3c 01                	cmp    $0x1,%al
c00257bb:	19 c0                	sbb    %eax,%eax
c00257bd:	83 e0 fe             	and    $0xfffffffe,%eax
c00257c0:	83 c0 2d             	add    $0x2d,%eax
c00257c3:	89 44 24 24          	mov    %eax,0x24(%esp)
c00257c7:	eb 2c                	jmp    c00257f5 <format_integer+0x60>
      else if (c->flags & SPACE)
c00257c9:	f6 c2 04             	test   $0x4,%dl
c00257cc:	74 10                	je     c00257de <format_integer+0x49>
        sign = negative ? '-' : ' ';
c00257ce:	3c 01                	cmp    $0x1,%al
c00257d0:	19 c0                	sbb    %eax,%eax
c00257d2:	83 e0 f3             	and    $0xfffffff3,%eax
c00257d5:	83 c0 2d             	add    $0x2d,%eax
c00257d8:	89 44 24 24          	mov    %eax,0x24(%esp)
c00257dc:	eb 17                	jmp    c00257f5 <format_integer+0x60>
        sign = '-';
c00257de:	3c 01                	cmp    $0x1,%al
c00257e0:	19 c0                	sbb    %eax,%eax
c00257e2:	f7 d0                	not    %eax
c00257e4:	83 e0 2d             	and    $0x2d,%eax
c00257e7:	89 44 24 24          	mov    %eax,0x24(%esp)
c00257eb:	eb 08                	jmp    c00257f5 <format_integer+0x60>
  sign = 0;
c00257ed:	c7 44 24 24 00 00 00 	movl   $0x0,0x24(%esp)
c00257f4:	00 
  x = (c->flags & POUND) && value ? b->x : 0;
c00257f5:	8b 84 24 98 00 00 00 	mov    0x98(%esp),%eax
c00257fc:	8b 00                	mov    (%eax),%eax
c00257fe:	89 44 24 28          	mov    %eax,0x28(%esp)
c0025802:	83 e0 08             	and    $0x8,%eax
c0025805:	89 44 24 2c          	mov    %eax,0x2c(%esp)
c0025809:	74 1a                	je     c0025825 <format_integer+0x90>
c002580b:	89 fa                	mov    %edi,%edx
c002580d:	09 f2                	or     %esi,%edx
c002580f:	0f 84 cc 00 00 00    	je     c00258e1 <format_integer+0x14c>
c0025815:	8b 84 24 94 00 00 00 	mov    0x94(%esp),%eax
c002581c:	8b 40 08             	mov    0x8(%eax),%eax
c002581f:	89 44 24 20          	mov    %eax,0x20(%esp)
c0025823:	eb 12                	jmp    c0025837 <format_integer+0xa2>
  while (value > 0) 
c0025825:	89 fa                	mov    %edi,%edx
c0025827:	09 f2                	or     %esi,%edx
c0025829:	0f 84 c3 01 00 00    	je     c00259f2 <format_integer+0x25d>
  x = (c->flags & POUND) && value ? b->x : 0;
c002582f:	c7 44 24 20 00 00 00 	movl   $0x0,0x20(%esp)
c0025836:	00 
      *cp++ = b->digits[value % b->base];
c0025837:	8b 84 24 94 00 00 00 	mov    0x94(%esp),%eax
c002583e:	8b 40 04             	mov    0x4(%eax),%eax
c0025841:	89 44 24 18          	mov    %eax,0x18(%esp)
c0025845:	8b 84 24 94 00 00 00 	mov    0x94(%esp),%eax
c002584c:	8b 00                	mov    (%eax),%eax
c002584e:	89 44 24 08          	mov    %eax,0x8(%esp)
c0025852:	89 c1                	mov    %eax,%ecx
c0025854:	c1 f9 1f             	sar    $0x1f,%ecx
c0025857:	89 4c 24 0c          	mov    %ecx,0xc(%esp)
c002585b:	c7 44 24 14 00 00 00 	movl   $0x0,0x14(%esp)
c0025862:	00 
c0025863:	8d 5c 24 30          	lea    0x30(%esp),%ebx
      if ((c->flags & GROUP) && digit_cnt > 0 && digit_cnt % b->group == 0)
c0025867:	8b 44 24 28          	mov    0x28(%esp),%eax
c002586b:	83 e0 20             	and    $0x20,%eax
c002586e:	89 44 24 1c          	mov    %eax,0x1c(%esp)
c0025872:	eb 3f                	jmp    c00258b3 <format_integer+0x11e>
c0025874:	89 dd                	mov    %ebx,%ebp
      *cp++ = b->digits[value % b->base];
c0025876:	8d 5d 01             	lea    0x1(%ebp),%ebx
c0025879:	ff 74 24 0c          	pushl  0xc(%esp)
c002587d:	ff 74 24 0c          	pushl  0xc(%esp)
c0025881:	57                   	push   %edi
c0025882:	56                   	push   %esi
c0025883:	e8 35 18 00 00       	call   c00270bd <__umoddi3>
c0025888:	83 c4 10             	add    $0x10,%esp
c002588b:	8b 4c 24 18          	mov    0x18(%esp),%ecx
c002588f:	8a 04 01             	mov    (%ecx,%eax,1),%al
c0025892:	88 45 00             	mov    %al,0x0(%ebp)
      value /= b->base;
c0025895:	ff 74 24 0c          	pushl  0xc(%esp)
c0025899:	ff 74 24 0c          	pushl  0xc(%esp)
c002589d:	57                   	push   %edi
c002589e:	56                   	push   %esi
c002589f:	e8 fd 17 00 00       	call   c00270a1 <__udivdi3>
c00258a4:	83 c4 10             	add    $0x10,%esp
c00258a7:	89 c6                	mov    %eax,%esi
c00258a9:	89 d7                	mov    %edx,%edi
      digit_cnt++;
c00258ab:	ff 44 24 14          	incl   0x14(%esp)
  while (value > 0) 
c00258af:	09 c2                	or     %eax,%edx
c00258b1:	74 3a                	je     c00258ed <format_integer+0x158>
      if ((c->flags & GROUP) && digit_cnt > 0 && digit_cnt % b->group == 0)
c00258b3:	83 7c 24 1c 00       	cmpl   $0x0,0x1c(%esp)
c00258b8:	74 ba                	je     c0025874 <format_integer+0xdf>
c00258ba:	8b 44 24 14          	mov    0x14(%esp),%eax
c00258be:	85 c0                	test   %eax,%eax
c00258c0:	7e 17                	jle    c00258d9 <format_integer+0x144>
c00258c2:	8b 8c 24 94 00 00 00 	mov    0x94(%esp),%ecx
c00258c9:	99                   	cltd   
c00258ca:	f7 79 0c             	idivl  0xc(%ecx)
c00258cd:	85 d2                	test   %edx,%edx
c00258cf:	75 0c                	jne    c00258dd <format_integer+0x148>
        *cp++ = ',';
c00258d1:	8d 6b 01             	lea    0x1(%ebx),%ebp
c00258d4:	c6 03 2c             	movb   $0x2c,(%ebx)
c00258d7:	eb 9d                	jmp    c0025876 <format_integer+0xe1>
c00258d9:	89 dd                	mov    %ebx,%ebp
c00258db:	eb 99                	jmp    c0025876 <format_integer+0xe1>
c00258dd:	89 dd                	mov    %ebx,%ebp
c00258df:	eb 95                	jmp    c0025876 <format_integer+0xe1>
  x = (c->flags & POUND) && value ? b->x : 0;
c00258e1:	c7 44 24 20 00 00 00 	movl   $0x0,0x20(%esp)
c00258e8:	00 
  cp = buf;
c00258e9:	8d 5c 24 30          	lea    0x30(%esp),%ebx
  precision = c->precision < 0 ? 1 : c->precision;
c00258ed:	8b 84 24 98 00 00 00 	mov    0x98(%esp),%eax
c00258f4:	8b 50 08             	mov    0x8(%eax),%edx
c00258f7:	85 d2                	test   %edx,%edx
c00258f9:	0f 88 04 01 00 00    	js     c0025a03 <format_integer+0x26e>
  while (cp - buf < precision && cp < buf + sizeof buf - 1)
c00258ff:	8d 7c 24 30          	lea    0x30(%esp),%edi
c0025903:	89 d8                	mov    %ebx,%eax
c0025905:	29 f8                	sub    %edi,%eax
c0025907:	39 c2                	cmp    %eax,%edx
c0025909:	7e 21                	jle    c002592c <format_integer+0x197>
c002590b:	8d 44 24 6f          	lea    0x6f(%esp),%eax
c002590f:	39 c3                	cmp    %eax,%ebx
c0025911:	73 19                	jae    c002592c <format_integer+0x197>
c0025913:	89 f9                	mov    %edi,%ecx
c0025915:	89 c6                	mov    %eax,%esi
    *cp++ = '0';
c0025917:	43                   	inc    %ebx
c0025918:	c6 43 ff 30          	movb   $0x30,-0x1(%ebx)
  while (cp - buf < precision && cp < buf + sizeof buf - 1)
c002591c:	89 d8                	mov    %ebx,%eax
c002591e:	29 c8                	sub    %ecx,%eax
c0025920:	39 d0                	cmp    %edx,%eax
c0025922:	7d 08                	jge    c002592c <format_integer+0x197>
c0025924:	39 f3                	cmp    %esi,%ebx
c0025926:	75 ef                	jne    c0025917 <format_integer+0x182>
    *cp++ = '0';
c0025928:	8d 5c 24 6f          	lea    0x6f(%esp),%ebx
  if ((c->flags & POUND) && b->base == 8 && (cp == buf || cp[-1] != '0'))
c002592c:	83 7c 24 2c 00       	cmpl   $0x0,0x2c(%esp)
c0025931:	74 10                	je     c0025943 <format_integer+0x1ae>
c0025933:	8b 84 24 94 00 00 00 	mov    0x94(%esp),%eax
c002593a:	83 38 08             	cmpl   $0x8,(%eax)
c002593d:	0f 84 ca 00 00 00    	je     c0025a0d <format_integer+0x278>
  pad_cnt = c->width - (cp - buf) - (x ? 2 : 0) - (sign != 0);
c0025943:	29 df                	sub    %ebx,%edi
c0025945:	8b 8c 24 98 00 00 00 	mov    0x98(%esp),%ecx
c002594c:	89 f8                	mov    %edi,%eax
c002594e:	03 41 04             	add    0x4(%ecx),%eax
c0025951:	83 7c 24 20 00       	cmpl   $0x0,0x20(%esp)
c0025956:	0f 95 c2             	setne  %dl
c0025959:	0f b6 d2             	movzbl %dl,%edx
c002595c:	d1 e2                	shl    %edx
c002595e:	29 d0                	sub    %edx,%eax
c0025960:	83 7c 24 24 00       	cmpl   $0x0,0x24(%esp)
c0025965:	0f 95 c2             	setne  %dl
c0025968:	0f b6 d2             	movzbl %dl,%edx
c002596b:	29 d0                	sub    %edx,%eax
c002596d:	89 c7                	mov    %eax,%edi
c002596f:	85 c0                	test   %eax,%eax
c0025971:	0f 88 b3 00 00 00    	js     c0025a2a <format_integer+0x295>
  if ((c->flags & (MINUS | ZERO)) == 0)
c0025977:	f6 44 24 28 11       	testb  $0x11,0x28(%esp)
c002597c:	0f 84 b2 00 00 00    	je     c0025a34 <format_integer+0x29f>
  if (sign)
c0025982:	83 7c 24 24 00       	cmpl   $0x0,0x24(%esp)
c0025987:	0f 85 cc 00 00 00    	jne    c0025a59 <format_integer+0x2c4>
  if (x) 
c002598d:	83 7c 24 20 00       	cmpl   $0x0,0x20(%esp)
c0025992:	0f 85 de 00 00 00    	jne    c0025a76 <format_integer+0x2e1>
  if (c->flags & ZERO)
c0025998:	8b 84 24 98 00 00 00 	mov    0x98(%esp),%eax
c002599f:	f6 00 10             	testb  $0x10,(%eax)
c00259a2:	0f 85 00 01 00 00    	jne    c0025aa8 <format_integer+0x313>
  while (cp > buf)
c00259a8:	8d 44 24 30          	lea    0x30(%esp),%eax
c00259ac:	39 c3                	cmp    %eax,%ebx
c00259ae:	76 2a                	jbe    c00259da <format_integer+0x245>
c00259b0:	89 c6                	mov    %eax,%esi
c00259b2:	89 7c 24 08          	mov    %edi,0x8(%esp)
c00259b6:	8b bc 24 9c 00 00 00 	mov    0x9c(%esp),%edi
c00259bd:	8b ac 24 a0 00 00 00 	mov    0xa0(%esp),%ebp
    output (*--cp, aux);
c00259c4:	4b                   	dec    %ebx
c00259c5:	83 ec 08             	sub    $0x8,%esp
c00259c8:	55                   	push   %ebp
c00259c9:	0f be 03             	movsbl (%ebx),%eax
c00259cc:	50                   	push   %eax
c00259cd:	ff d7                	call   *%edi
  while (cp > buf)
c00259cf:	83 c4 10             	add    $0x10,%esp
c00259d2:	39 f3                	cmp    %esi,%ebx
c00259d4:	75 ee                	jne    c00259c4 <format_integer+0x22f>
c00259d6:	8b 7c 24 08          	mov    0x8(%esp),%edi
  if (c->flags & MINUS)
c00259da:	8b 84 24 98 00 00 00 	mov    0x98(%esp),%eax
c00259e1:	f6 00 01             	testb  $0x1,(%eax)
c00259e4:	0f 85 e3 00 00 00    	jne    c0025acd <format_integer+0x338>
}
c00259ea:	83 c4 7c             	add    $0x7c,%esp
c00259ed:	5b                   	pop    %ebx
c00259ee:	5e                   	pop    %esi
c00259ef:	5f                   	pop    %edi
c00259f0:	5d                   	pop    %ebp
c00259f1:	c3                   	ret    
  x = (c->flags & POUND) && value ? b->x : 0;
c00259f2:	c7 44 24 20 00 00 00 	movl   $0x0,0x20(%esp)
c00259f9:	00 
  cp = buf;
c00259fa:	8d 5c 24 30          	lea    0x30(%esp),%ebx
c00259fe:	e9 ea fe ff ff       	jmp    c00258ed <format_integer+0x158>
  precision = c->precision < 0 ? 1 : c->precision;
c0025a03:	ba 01 00 00 00       	mov    $0x1,%edx
c0025a08:	e9 f2 fe ff ff       	jmp    c00258ff <format_integer+0x16a>
  if ((c->flags & POUND) && b->base == 8 && (cp == buf || cp[-1] != '0'))
c0025a0d:	8d 44 24 30          	lea    0x30(%esp),%eax
c0025a11:	39 c3                	cmp    %eax,%ebx
c0025a13:	74 0a                	je     c0025a1f <format_integer+0x28a>
c0025a15:	80 7b ff 30          	cmpb   $0x30,-0x1(%ebx)
c0025a19:	0f 84 24 ff ff ff    	je     c0025943 <format_integer+0x1ae>
    *cp++ = '0';
c0025a1f:	c6 03 30             	movb   $0x30,(%ebx)
c0025a22:	8d 5b 01             	lea    0x1(%ebx),%ebx
c0025a25:	e9 19 ff ff ff       	jmp    c0025943 <format_integer+0x1ae>
c0025a2a:	bf 00 00 00 00       	mov    $0x0,%edi
c0025a2f:	e9 43 ff ff ff       	jmp    c0025977 <format_integer+0x1e2>
    output_dup (' ', pad_cnt, output, aux);
c0025a34:	83 ec 0c             	sub    $0xc,%esp
c0025a37:	ff b4 24 ac 00 00 00 	pushl  0xac(%esp)
c0025a3e:	8b 8c 24 ac 00 00 00 	mov    0xac(%esp),%ecx
c0025a45:	89 fa                	mov    %edi,%edx
c0025a47:	b8 20 00 00 00       	mov    $0x20,%eax
c0025a4c:	e8 15 fd ff ff       	call   c0025766 <output_dup>
c0025a51:	83 c4 10             	add    $0x10,%esp
c0025a54:	e9 29 ff ff ff       	jmp    c0025982 <format_integer+0x1ed>
    output (sign, aux);
c0025a59:	83 ec 08             	sub    $0x8,%esp
c0025a5c:	ff b4 24 a8 00 00 00 	pushl  0xa8(%esp)
c0025a63:	ff 74 24 30          	pushl  0x30(%esp)
c0025a67:	ff 94 24 ac 00 00 00 	call   *0xac(%esp)
c0025a6e:	83 c4 10             	add    $0x10,%esp
c0025a71:	e9 17 ff ff ff       	jmp    c002598d <format_integer+0x1f8>
      output ('0', aux);
c0025a76:	83 ec 08             	sub    $0x8,%esp
c0025a79:	ff b4 24 a8 00 00 00 	pushl  0xa8(%esp)
c0025a80:	6a 30                	push   $0x30
c0025a82:	ff 94 24 ac 00 00 00 	call   *0xac(%esp)
      output (x, aux); 
c0025a89:	83 c4 08             	add    $0x8,%esp
c0025a8c:	ff b4 24 a8 00 00 00 	pushl  0xa8(%esp)
c0025a93:	0f be 44 24 2c       	movsbl 0x2c(%esp),%eax
c0025a98:	50                   	push   %eax
c0025a99:	ff 94 24 ac 00 00 00 	call   *0xac(%esp)
c0025aa0:	83 c4 10             	add    $0x10,%esp
c0025aa3:	e9 f0 fe ff ff       	jmp    c0025998 <format_integer+0x203>
    output_dup ('0', pad_cnt, output, aux);
c0025aa8:	83 ec 0c             	sub    $0xc,%esp
c0025aab:	ff b4 24 ac 00 00 00 	pushl  0xac(%esp)
c0025ab2:	8b 8c 24 ac 00 00 00 	mov    0xac(%esp),%ecx
c0025ab9:	89 fa                	mov    %edi,%edx
c0025abb:	b8 30 00 00 00       	mov    $0x30,%eax
c0025ac0:	e8 a1 fc ff ff       	call   c0025766 <output_dup>
c0025ac5:	83 c4 10             	add    $0x10,%esp
c0025ac8:	e9 db fe ff ff       	jmp    c00259a8 <format_integer+0x213>
    output_dup (' ', pad_cnt, output, aux);
c0025acd:	83 ec 0c             	sub    $0xc,%esp
c0025ad0:	ff b4 24 ac 00 00 00 	pushl  0xac(%esp)
c0025ad7:	8b 8c 24 ac 00 00 00 	mov    0xac(%esp),%ecx
c0025ade:	89 fa                	mov    %edi,%edx
c0025ae0:	b8 20 00 00 00       	mov    $0x20,%eax
c0025ae5:	e8 7c fc ff ff       	call   c0025766 <output_dup>
c0025aea:	83 c4 10             	add    $0x10,%esp
}
c0025aed:	e9 f8 fe ff ff       	jmp    c00259ea <format_integer+0x255>

c0025af2 <format_string>:
   auxiliary data AUX. */
static void
format_string (const char *string, int length,
               struct printf_conversion *c,
               void (*output) (char, void *), void *aux) 
{
c0025af2:	55                   	push   %ebp
c0025af3:	57                   	push   %edi
c0025af4:	56                   	push   %esi
c0025af5:	53                   	push   %ebx
c0025af6:	83 ec 1c             	sub    $0x1c,%esp
c0025af9:	89 c5                	mov    %eax,%ebp
c0025afb:	89 d3                	mov    %edx,%ebx
c0025afd:	89 54 24 08          	mov    %edx,0x8(%esp)
c0025b01:	89 4c 24 0c          	mov    %ecx,0xc(%esp)
c0025b05:	8b 74 24 30          	mov    0x30(%esp),%esi
c0025b09:	8b 7c 24 34          	mov    0x34(%esp),%edi
  int i;
  if (c->width > length && (c->flags & MINUS) == 0)
c0025b0d:	8b 51 04             	mov    0x4(%ecx),%edx
c0025b10:	39 da                	cmp    %ebx,%edx
c0025b12:	7e 42                	jle    c0025b56 <format_string+0x64>
c0025b14:	89 c8                	mov    %ecx,%eax
c0025b16:	f6 00 01             	testb  $0x1,(%eax)
c0025b19:	74 20                	je     c0025b3b <format_string+0x49>
    output_dup (' ', c->width - length, output, aux);
  for (i = 0; i < length; i++)
c0025b1b:	83 7c 24 08 00       	cmpl   $0x0,0x8(%esp)
c0025b20:	7f 3b                	jg     c0025b5d <format_string+0x6b>
    output (string[i], aux);
  if (c->width > length && (c->flags & MINUS) != 0)
    output_dup (' ', c->width - length, output, aux);
c0025b22:	2b 54 24 08          	sub    0x8(%esp),%edx
c0025b26:	83 ec 0c             	sub    $0xc,%esp
c0025b29:	57                   	push   %edi
c0025b2a:	89 f1                	mov    %esi,%ecx
c0025b2c:	b8 20 00 00 00       	mov    $0x20,%eax
c0025b31:	e8 30 fc ff ff       	call   c0025766 <output_dup>
c0025b36:	83 c4 10             	add    $0x10,%esp
}
c0025b39:	eb 4f                	jmp    c0025b8a <format_string+0x98>
    output_dup (' ', c->width - length, output, aux);
c0025b3b:	29 da                	sub    %ebx,%edx
c0025b3d:	83 ec 0c             	sub    $0xc,%esp
c0025b40:	57                   	push   %edi
c0025b41:	89 f1                	mov    %esi,%ecx
c0025b43:	b8 20 00 00 00       	mov    $0x20,%eax
c0025b48:	e8 19 fc ff ff       	call   c0025766 <output_dup>
  for (i = 0; i < length; i++)
c0025b4d:	83 c4 10             	add    $0x10,%esp
c0025b50:	85 db                	test   %ebx,%ebx
c0025b52:	7f 09                	jg     c0025b5d <format_string+0x6b>
c0025b54:	eb 22                	jmp    c0025b78 <format_string+0x86>
c0025b56:	83 7c 24 08 00       	cmpl   $0x0,0x8(%esp)
c0025b5b:	7e 2d                	jle    c0025b8a <format_string+0x98>
{
c0025b5d:	bb 00 00 00 00       	mov    $0x0,%ebx
    output (string[i], aux);
c0025b62:	83 ec 08             	sub    $0x8,%esp
c0025b65:	57                   	push   %edi
c0025b66:	0f be 44 1d 00       	movsbl 0x0(%ebp,%ebx,1),%eax
c0025b6b:	50                   	push   %eax
c0025b6c:	ff d6                	call   *%esi
  for (i = 0; i < length; i++)
c0025b6e:	43                   	inc    %ebx
c0025b6f:	83 c4 10             	add    $0x10,%esp
c0025b72:	39 5c 24 08          	cmp    %ebx,0x8(%esp)
c0025b76:	7f ea                	jg     c0025b62 <format_string+0x70>
  if (c->width > length && (c->flags & MINUS) != 0)
c0025b78:	8b 44 24 0c          	mov    0xc(%esp),%eax
c0025b7c:	8b 50 04             	mov    0x4(%eax),%edx
c0025b7f:	39 54 24 08          	cmp    %edx,0x8(%esp)
c0025b83:	7d 05                	jge    c0025b8a <format_string+0x98>
c0025b85:	f6 00 01             	testb  $0x1,(%eax)
c0025b88:	75 98                	jne    c0025b22 <format_string+0x30>
}
c0025b8a:	83 c4 1c             	add    $0x1c,%esp
c0025b8d:	5b                   	pop    %ebx
c0025b8e:	5e                   	pop    %esi
c0025b8f:	5f                   	pop    %edi
c0025b90:	5d                   	pop    %ebp
c0025b91:	c3                   	ret    

c0025b92 <printf>:
{
c0025b92:	83 ec 0c             	sub    $0xc,%esp
  va_start (args, format);
c0025b95:	8d 44 24 14          	lea    0x14(%esp),%eax
  retval = vprintf (format, args);
c0025b99:	83 ec 08             	sub    $0x8,%esp
c0025b9c:	50                   	push   %eax
c0025b9d:	ff 74 24 1c          	pushl  0x1c(%esp)
c0025ba1:	e8 b4 34 00 00       	call   c002905a <vprintf>
}
c0025ba6:	83 c4 1c             	add    $0x1c,%esp
c0025ba9:	c3                   	ret    

c0025baa <__printf>:
/* Wrapper for __vprintf() that converts varargs into a
   va_list. */
void
__printf (const char *format,
          void (*output) (char, void *), void *aux, ...) 
{
c0025baa:	83 ec 0c             	sub    $0xc,%esp
  va_list args;

  va_start (args, aux);
c0025bad:	8d 44 24 1c          	lea    0x1c(%esp),%eax
  __vprintf (format, args, output, aux);
c0025bb1:	ff 74 24 18          	pushl  0x18(%esp)
c0025bb5:	ff 74 24 18          	pushl  0x18(%esp)
c0025bb9:	50                   	push   %eax
c0025bba:	ff 74 24 1c          	pushl  0x1c(%esp)
c0025bbe:	e8 04 00 00 00       	call   c0025bc7 <__vprintf>
  va_end (args);
}
c0025bc3:	83 c4 1c             	add    $0x1c,%esp
c0025bc6:	c3                   	ret    

c0025bc7 <__vprintf>:
{
c0025bc7:	55                   	push   %ebp
c0025bc8:	57                   	push   %edi
c0025bc9:	56                   	push   %esi
c0025bca:	53                   	push   %ebx
c0025bcb:	83 ec 3c             	sub    $0x3c,%esp
c0025bce:	8b 74 24 50          	mov    0x50(%esp),%esi
  for (; *format != '\0'; format++)
c0025bd2:	8a 06                	mov    (%esi),%al
c0025bd4:	84 c0                	test   %al,%al
c0025bd6:	75 44                	jne    c0025c1c <__vprintf+0x55>
}
c0025bd8:	83 c4 3c             	add    $0x3c,%esp
c0025bdb:	5b                   	pop    %ebx
c0025bdc:	5e                   	pop    %esi
c0025bdd:	5f                   	pop    %edi
c0025bde:	5d                   	pop    %ebp
c0025bdf:	c3                   	ret    
      format++;
c0025be0:	8d 5e 01             	lea    0x1(%esi),%ebx
      if (*format == '%') 
c0025be3:	80 7e 01 25          	cmpb   $0x25,0x1(%esi)
c0025be7:	74 19                	je     c0025c02 <__vprintf+0x3b>
  c->flags = 0;
c0025be9:	c7 44 24 20 00 00 00 	movl   $0x0,0x20(%esp)
c0025bf0:	00 
c0025bf1:	bf 00 00 00 00       	mov    $0x0,%edi
c0025bf6:	be 00 00 00 00       	mov    $0x0,%esi
c0025bfb:	bd 01 00 00 00       	mov    $0x1,%ebp
c0025c00:	eb 3b                	jmp    c0025c3d <__vprintf+0x76>
          output ('%', aux);
c0025c02:	83 ec 08             	sub    $0x8,%esp
c0025c05:	ff 74 24 64          	pushl  0x64(%esp)
c0025c09:	6a 25                	push   $0x25
c0025c0b:	ff 54 24 68          	call   *0x68(%esp)
          continue;
c0025c0f:	83 c4 10             	add    $0x10,%esp
  for (; *format != '\0'; format++)
c0025c12:	8d 73 01             	lea    0x1(%ebx),%esi
c0025c15:	8a 43 01             	mov    0x1(%ebx),%al
c0025c18:	84 c0                	test   %al,%al
c0025c1a:	74 bc                	je     c0025bd8 <__vprintf+0x11>
      if (*format != '%') 
c0025c1c:	3c 25                	cmp    $0x25,%al
c0025c1e:	74 c0                	je     c0025be0 <__vprintf+0x19>
          output (*format, aux);
c0025c20:	83 ec 08             	sub    $0x8,%esp
c0025c23:	ff 74 24 64          	pushl  0x64(%esp)
c0025c27:	0f be c0             	movsbl %al,%eax
c0025c2a:	50                   	push   %eax
c0025c2b:	ff 54 24 68          	call   *0x68(%esp)
          continue;
c0025c2f:	83 c4 10             	add    $0x10,%esp
c0025c32:	89 f3                	mov    %esi,%ebx
c0025c34:	eb dc                	jmp    c0025c12 <__vprintf+0x4b>
          c->flags |= MINUS;
c0025c36:	83 ce 01             	or     $0x1,%esi
c0025c39:	89 ef                	mov    %ebp,%edi
      switch (*format++) 
c0025c3b:	89 cb                	mov    %ecx,%ebx
c0025c3d:	8d 4b 01             	lea    0x1(%ebx),%ecx
c0025c40:	8a 41 ff             	mov    -0x1(%ecx),%al
c0025c43:	8d 50 e0             	lea    -0x20(%eax),%edx
c0025c46:	80 fa 10             	cmp    $0x10,%dl
c0025c49:	77 23                	ja     c0025c6e <__vprintf+0xa7>
c0025c4b:	0f b6 d2             	movzbl %dl,%edx
c0025c4e:	ff 24 95 10 bf 02 c0 	jmp    *-0x3ffd40f0(,%edx,4)
          c->flags |= PLUS;
c0025c55:	83 ce 02             	or     $0x2,%esi
c0025c58:	eb df                	jmp    c0025c39 <__vprintf+0x72>
          c->flags |= SPACE;
c0025c5a:	83 ce 04             	or     $0x4,%esi
c0025c5d:	eb da                	jmp    c0025c39 <__vprintf+0x72>
          c->flags |= POUND;
c0025c5f:	83 ce 08             	or     $0x8,%esi
c0025c62:	eb d5                	jmp    c0025c39 <__vprintf+0x72>
          c->flags |= ZERO;
c0025c64:	83 ce 10             	or     $0x10,%esi
c0025c67:	eb d0                	jmp    c0025c39 <__vprintf+0x72>
          c->flags |= GROUP;
c0025c69:	83 ce 20             	or     $0x20,%esi
c0025c6c:	eb cb                	jmp    c0025c39 <__vprintf+0x72>
c0025c6e:	89 fa                	mov    %edi,%edx
c0025c70:	84 d2                	test   %dl,%dl
c0025c72:	0f 85 85 00 00 00    	jne    c0025cfd <__vprintf+0x136>
  if (c->flags & PLUS)
c0025c78:	8b 54 24 20          	mov    0x20(%esp),%edx
c0025c7c:	f6 c2 02             	test   $0x2,%dl
c0025c7f:	74 07                	je     c0025c88 <__vprintf+0xc1>
    c->flags &= ~SPACE;
c0025c81:	83 e2 fb             	and    $0xfffffffb,%edx
c0025c84:	89 54 24 20          	mov    %edx,0x20(%esp)
  c->width = 0;
c0025c88:	c7 44 24 24 00 00 00 	movl   $0x0,0x24(%esp)
c0025c8f:	00 
  if (*format == '*')
c0025c90:	3c 2a                	cmp    $0x2a,%al
c0025c92:	0f 84 81 00 00 00    	je     c0025d19 <__vprintf+0x152>
      for (; isdigit (*format); format++)
c0025c98:	0f be c0             	movsbl %al,%eax
static inline int isdigit (int c) { return c >= '0' && c <= '9'; }
c0025c9b:	8d 48 d0             	lea    -0x30(%eax),%ecx
c0025c9e:	ba 00 00 00 00       	mov    $0x0,%edx
c0025ca3:	83 f9 09             	cmp    $0x9,%ecx
c0025ca6:	77 21                	ja     c0025cc9 <__vprintf+0x102>
        c->width = c->width * 10 + *format - '0';
c0025ca8:	8d 14 92             	lea    (%edx,%edx,4),%edx
c0025cab:	01 d2                	add    %edx,%edx
c0025cad:	8d 54 10 d0          	lea    -0x30(%eax,%edx,1),%edx
      for (; isdigit (*format); format++)
c0025cb1:	43                   	inc    %ebx
c0025cb2:	0f be 03             	movsbl (%ebx),%eax
c0025cb5:	8d 48 d0             	lea    -0x30(%eax),%ecx
c0025cb8:	83 f9 09             	cmp    $0x9,%ecx
c0025cbb:	76 eb                	jbe    c0025ca8 <__vprintf+0xe1>
c0025cbd:	89 54 24 24          	mov    %edx,0x24(%esp)
  if (c->width < 0) 
c0025cc1:	8b 44 24 24          	mov    0x24(%esp),%eax
c0025cc5:	85 c0                	test   %eax,%eax
c0025cc7:	78 69                	js     c0025d32 <__vprintf+0x16b>
  c->precision = -1;
c0025cc9:	c7 44 24 28 ff ff ff 	movl   $0xffffffff,0x28(%esp)
c0025cd0:	ff 
  if (*format == '.') 
c0025cd1:	80 3b 2e             	cmpb   $0x2e,(%ebx)
c0025cd4:	74 69                	je     c0025d3f <__vprintf+0x178>
  if (c->precision >= 0)
c0025cd6:	8b 54 24 28          	mov    0x28(%esp),%edx
  c->type = INT;
c0025cda:	c7 44 24 2c 03 00 00 	movl   $0x3,0x2c(%esp)
c0025ce1:	00 
  switch (*format++) 
c0025ce2:	8d 7b 01             	lea    0x1(%ebx),%edi
c0025ce5:	8a 03                	mov    (%ebx),%al
c0025ce7:	8d 48 98             	lea    -0x68(%eax),%ecx
c0025cea:	80 f9 12             	cmp    $0x12,%cl
c0025ced:	0f 87 d5 01 00 00    	ja     c0025ec8 <__vprintf+0x301>
c0025cf3:	0f b6 c9             	movzbl %cl,%ecx
c0025cf6:	ff 24 8d 54 bf 02 c0 	jmp    *-0x3ffd40ac(,%ecx,4)
c0025cfd:	89 74 24 20          	mov    %esi,0x20(%esp)
  if (c->flags & MINUS)
c0025d01:	f7 c6 01 00 00 00    	test   $0x1,%esi
c0025d07:	0f 84 6b ff ff ff    	je     c0025c78 <__vprintf+0xb1>
    c->flags &= ~ZERO;
c0025d0d:	83 e6 ef             	and    $0xffffffef,%esi
c0025d10:	89 74 24 20          	mov    %esi,0x20(%esp)
c0025d14:	e9 5f ff ff ff       	jmp    c0025c78 <__vprintf+0xb1>
      c->width = va_arg (*args, int);
c0025d19:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025d1d:	8b 00                	mov    (%eax),%eax
c0025d1f:	89 44 24 24          	mov    %eax,0x24(%esp)
c0025d23:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025d27:	8d 40 04             	lea    0x4(%eax),%eax
c0025d2a:	89 44 24 54          	mov    %eax,0x54(%esp)
      switch (*format++) 
c0025d2e:	89 cb                	mov    %ecx,%ebx
c0025d30:	eb 8f                	jmp    c0025cc1 <__vprintf+0xfa>
      c->width = -c->width;
c0025d32:	f7 d8                	neg    %eax
c0025d34:	89 44 24 24          	mov    %eax,0x24(%esp)
      c->flags |= MINUS;
c0025d38:	83 4c 24 20 01       	orl    $0x1,0x20(%esp)
c0025d3d:	eb 8a                	jmp    c0025cc9 <__vprintf+0x102>
      format++;
c0025d3f:	8d 53 01             	lea    0x1(%ebx),%edx
      if (*format == '*') 
c0025d42:	8a 43 01             	mov    0x1(%ebx),%al
c0025d45:	3c 2a                	cmp    $0x2a,%al
c0025d47:	74 45                	je     c0025d8e <__vprintf+0x1c7>
          c->precision = 0;
c0025d49:	c7 44 24 28 00 00 00 	movl   $0x0,0x28(%esp)
c0025d50:	00 
          for (; isdigit (*format); format++)
c0025d51:	0f be c0             	movsbl %al,%eax
c0025d54:	8d 48 d0             	lea    -0x30(%eax),%ecx
c0025d57:	83 f9 09             	cmp    $0x9,%ecx
c0025d5a:	77 59                	ja     c0025db5 <__vprintf+0x1ee>
c0025d5c:	b9 00 00 00 00       	mov    $0x0,%ecx
            c->precision = c->precision * 10 + *format - '0';
c0025d61:	8d 0c 89             	lea    (%ecx,%ecx,4),%ecx
c0025d64:	01 c9                	add    %ecx,%ecx
c0025d66:	8d 4c 08 d0          	lea    -0x30(%eax,%ecx,1),%ecx
          for (; isdigit (*format); format++)
c0025d6a:	42                   	inc    %edx
c0025d6b:	0f be 02             	movsbl (%edx),%eax
c0025d6e:	8d 58 d0             	lea    -0x30(%eax),%ebx
c0025d71:	83 fb 09             	cmp    $0x9,%ebx
c0025d74:	76 eb                	jbe    c0025d61 <__vprintf+0x19a>
c0025d76:	89 4c 24 28          	mov    %ecx,0x28(%esp)
c0025d7a:	89 d3                	mov    %edx,%ebx
      if (c->precision < 0) 
c0025d7c:	8b 54 24 28          	mov    0x28(%esp),%edx
c0025d80:	85 d2                	test   %edx,%edx
c0025d82:	78 24                	js     c0025da8 <__vprintf+0x1e1>
    c->flags &= ~ZERO;
c0025d84:	83 64 24 20 ef       	andl   $0xffffffef,0x20(%esp)
c0025d89:	e9 4c ff ff ff       	jmp    c0025cda <__vprintf+0x113>
          format++;
c0025d8e:	83 c3 02             	add    $0x2,%ebx
          c->precision = va_arg (*args, int);
c0025d91:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025d95:	8b 00                	mov    (%eax),%eax
c0025d97:	89 44 24 28          	mov    %eax,0x28(%esp)
c0025d9b:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025d9f:	8d 40 04             	lea    0x4(%eax),%eax
c0025da2:	89 44 24 54          	mov    %eax,0x54(%esp)
c0025da6:	eb d4                	jmp    c0025d7c <__vprintf+0x1b5>
        c->precision = -1;
c0025da8:	c7 44 24 28 ff ff ff 	movl   $0xffffffff,0x28(%esp)
c0025daf:	ff 
c0025db0:	e9 21 ff ff ff       	jmp    c0025cd6 <__vprintf+0x10f>
      format++;
c0025db5:	89 d3                	mov    %edx,%ebx
  if (c->precision >= 0)
c0025db7:	ba 00 00 00 00       	mov    $0x0,%edx
c0025dbc:	eb c6                	jmp    c0025d84 <__vprintf+0x1bd>
      if (*format == 'h') 
c0025dbe:	8a 43 01             	mov    0x1(%ebx),%al
c0025dc1:	3c 68                	cmp    $0x68,%al
c0025dc3:	74 21                	je     c0025de6 <__vprintf+0x21f>
        c->type = SHORT;
c0025dc5:	c7 44 24 2c 02 00 00 	movl   $0x2,0x2c(%esp)
c0025dcc:	00 
      switch (*format) 
c0025dcd:	0f be e8             	movsbl %al,%ebp
c0025dd0:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025dd3:	80 fb 33             	cmp    $0x33,%bl
c0025dd6:	0f 87 ba 04 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025ddc:	0f b6 db             	movzbl %bl,%ebx
c0025ddf:	ff 24 9d a0 bf 02 c0 	jmp    *-0x3ffd4060(,%ebx,4)
          format++;
c0025de6:	8d 7b 02             	lea    0x2(%ebx),%edi
          c->type = CHAR;
c0025de9:	c7 44 24 2c 01 00 00 	movl   $0x1,0x2c(%esp)
c0025df0:	00 
      switch (*format) 
c0025df1:	8a 43 02             	mov    0x2(%ebx),%al
c0025df4:	0f be e8             	movsbl %al,%ebp
c0025df7:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025dfa:	80 fb 33             	cmp    $0x33,%bl
c0025dfd:	0f 87 93 04 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025e03:	0f b6 db             	movzbl %bl,%ebx
c0025e06:	ff 24 9d 70 c0 02 c0 	jmp    *-0x3ffd3f90(,%ebx,4)
      c->type = INTMAX;
c0025e0d:	c7 44 24 2c 04 00 00 	movl   $0x4,0x2c(%esp)
c0025e14:	00 
      switch (*format) 
c0025e15:	8a 43 01             	mov    0x1(%ebx),%al
c0025e18:	0f be e8             	movsbl %al,%ebp
c0025e1b:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025e1e:	80 fb 33             	cmp    $0x33,%bl
c0025e21:	0f 87 6f 04 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025e27:	0f b6 db             	movzbl %bl,%ebx
c0025e2a:	ff 24 9d 40 c1 02 c0 	jmp    *-0x3ffd3ec0(,%ebx,4)
      if (*format == 'l')
c0025e31:	8a 43 01             	mov    0x1(%ebx),%al
c0025e34:	3c 6c                	cmp    $0x6c,%al
c0025e36:	74 21                	je     c0025e59 <__vprintf+0x292>
        c->type = LONG;
c0025e38:	c7 44 24 2c 05 00 00 	movl   $0x5,0x2c(%esp)
c0025e3f:	00 
      switch (*format) 
c0025e40:	0f be e8             	movsbl %al,%ebp
c0025e43:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025e46:	80 fb 33             	cmp    $0x33,%bl
c0025e49:	0f 87 47 04 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025e4f:	0f b6 db             	movzbl %bl,%ebx
c0025e52:	ff 24 9d 10 c2 02 c0 	jmp    *-0x3ffd3df0(,%ebx,4)
          format++;
c0025e59:	8d 7b 02             	lea    0x2(%ebx),%edi
          c->type = LONGLONG;
c0025e5c:	c7 44 24 2c 06 00 00 	movl   $0x6,0x2c(%esp)
c0025e63:	00 
      switch (*format) 
c0025e64:	8a 43 02             	mov    0x2(%ebx),%al
c0025e67:	0f be e8             	movsbl %al,%ebp
c0025e6a:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025e6d:	80 fb 33             	cmp    $0x33,%bl
c0025e70:	0f 87 20 04 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025e76:	0f b6 db             	movzbl %bl,%ebx
c0025e79:	ff 24 9d e0 c2 02 c0 	jmp    *-0x3ffd3d20(,%ebx,4)
      c->type = PTRDIFFT;
c0025e80:	c7 44 24 2c 07 00 00 	movl   $0x7,0x2c(%esp)
c0025e87:	00 
      switch (*format) 
c0025e88:	8a 43 01             	mov    0x1(%ebx),%al
c0025e8b:	0f be e8             	movsbl %al,%ebp
c0025e8e:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025e91:	80 fb 33             	cmp    $0x33,%bl
c0025e94:	0f 87 fc 03 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025e9a:	0f b6 db             	movzbl %bl,%ebx
c0025e9d:	ff 24 9d b0 c3 02 c0 	jmp    *-0x3ffd3c50(,%ebx,4)
      c->type = SIZET;
c0025ea4:	c7 44 24 2c 08 00 00 	movl   $0x8,0x2c(%esp)
c0025eab:	00 
      switch (*format) 
c0025eac:	8a 43 01             	mov    0x1(%ebx),%al
c0025eaf:	0f be e8             	movsbl %al,%ebp
c0025eb2:	8d 58 bb             	lea    -0x45(%eax),%ebx
c0025eb5:	80 fb 33             	cmp    $0x33,%bl
c0025eb8:	0f 87 d8 03 00 00    	ja     c0026296 <__vprintf+0x6cf>
c0025ebe:	0f b6 db             	movzbl %bl,%ebx
c0025ec1:	ff 24 9d 80 c4 02 c0 	jmp    *-0x3ffd3b80(,%ebx,4)
c0025ec8:	0f be e8             	movsbl %al,%ebp
c0025ecb:	8d 70 bb             	lea    -0x45(%eax),%esi
c0025ece:	89 f1                	mov    %esi,%ecx
c0025ed0:	80 f9 33             	cmp    $0x33,%cl
c0025ed3:	0f 87 bb 03 00 00    	ja     c0026294 <__vprintf+0x6cd>
c0025ed9:	0f b6 f1             	movzbl %cl,%esi
c0025edc:	ff 24 b5 50 c5 02 c0 	jmp    *-0x3ffd3ab0(,%esi,4)
c0025ee3:	89 df                	mov    %ebx,%edi
            switch (c.type) 
c0025ee5:	83 7c 24 2c 08       	cmpl   $0x8,0x2c(%esp)
c0025eea:	0f 87 fb 00 00 00    	ja     c0025feb <__vprintf+0x424>
c0025ef0:	8b 44 24 2c          	mov    0x2c(%esp),%eax
c0025ef4:	ff 24 85 20 c6 02 c0 	jmp    *-0x3ffd39e0(,%eax,4)
                value = (signed char) va_arg (args, int);
c0025efb:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025eff:	0f be 08             	movsbl (%eax),%ecx
c0025f02:	89 cb                	mov    %ecx,%ebx
c0025f04:	c1 fb 1f             	sar    $0x1f,%ebx
c0025f07:	8d 40 04             	lea    0x4(%eax),%eax
c0025f0a:	89 44 24 54          	mov    %eax,0x54(%esp)
            format_integer (value < 0 ? -value : value,
c0025f0e:	89 c8                	mov    %ecx,%eax
c0025f10:	89 da                	mov    %ebx,%edx
c0025f12:	85 db                	test   %ebx,%ebx
c0025f14:	0f 88 f3 00 00 00    	js     c002600d <__vprintf+0x446>
c0025f1a:	83 ec 0c             	sub    $0xc,%esp
c0025f1d:	ff 74 24 68          	pushl  0x68(%esp)
c0025f21:	ff 74 24 68          	pushl  0x68(%esp)
c0025f25:	8d 74 24 34          	lea    0x34(%esp),%esi
c0025f29:	56                   	push   %esi
c0025f2a:	68 80 c6 02 c0       	push   $0xc002c680
c0025f2f:	89 d9                	mov    %ebx,%ecx
c0025f31:	c1 e9 1f             	shr    $0x1f,%ecx
c0025f34:	51                   	push   %ecx
c0025f35:	b9 01 00 00 00       	mov    $0x1,%ecx
c0025f3a:	e8 56 f8 ff ff       	call   c0025795 <format_integer>
          break;
c0025f3f:	83 c4 20             	add    $0x20,%esp
c0025f42:	89 fb                	mov    %edi,%ebx
c0025f44:	e9 c9 fc ff ff       	jmp    c0025c12 <__vprintf+0x4b>
                value = (short) va_arg (args, int);
c0025f49:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025f4d:	0f bf 08             	movswl (%eax),%ecx
c0025f50:	89 cb                	mov    %ecx,%ebx
c0025f52:	c1 fb 1f             	sar    $0x1f,%ebx
c0025f55:	8d 40 04             	lea    0x4(%eax),%eax
c0025f58:	89 44 24 54          	mov    %eax,0x54(%esp)
                break;
c0025f5c:	eb b0                	jmp    c0025f0e <__vprintf+0x347>
                value = va_arg (args, int);
c0025f5e:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025f62:	8b 08                	mov    (%eax),%ecx
c0025f64:	89 cb                	mov    %ecx,%ebx
c0025f66:	c1 fb 1f             	sar    $0x1f,%ebx
c0025f69:	8d 40 04             	lea    0x4(%eax),%eax
c0025f6c:	89 44 24 54          	mov    %eax,0x54(%esp)
                break;
c0025f70:	eb 9c                	jmp    c0025f0e <__vprintf+0x347>
                value = va_arg (args, intmax_t);
c0025f72:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025f76:	8b 08                	mov    (%eax),%ecx
c0025f78:	8b 58 04             	mov    0x4(%eax),%ebx
c0025f7b:	8d 40 08             	lea    0x8(%eax),%eax
c0025f7e:	89 44 24 54          	mov    %eax,0x54(%esp)
                break;
c0025f82:	eb 8a                	jmp    c0025f0e <__vprintf+0x347>
                value = va_arg (args, long);
c0025f84:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025f88:	8b 08                	mov    (%eax),%ecx
c0025f8a:	89 cb                	mov    %ecx,%ebx
c0025f8c:	c1 fb 1f             	sar    $0x1f,%ebx
c0025f8f:	8d 40 04             	lea    0x4(%eax),%eax
c0025f92:	89 44 24 54          	mov    %eax,0x54(%esp)
                break;
c0025f96:	e9 73 ff ff ff       	jmp    c0025f0e <__vprintf+0x347>
                value = va_arg (args, long long);
c0025f9b:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025f9f:	8b 08                	mov    (%eax),%ecx
c0025fa1:	8b 58 04             	mov    0x4(%eax),%ebx
c0025fa4:	8d 40 08             	lea    0x8(%eax),%eax
c0025fa7:	89 44 24 54          	mov    %eax,0x54(%esp)
                break;
c0025fab:	e9 5e ff ff ff       	jmp    c0025f0e <__vprintf+0x347>
                value = va_arg (args, ptrdiff_t);
c0025fb0:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025fb4:	8b 08                	mov    (%eax),%ecx
c0025fb6:	89 cb                	mov    %ecx,%ebx
c0025fb8:	c1 fb 1f             	sar    $0x1f,%ebx
c0025fbb:	8d 40 04             	lea    0x4(%eax),%eax
c0025fbe:	89 44 24 54          	mov    %eax,0x54(%esp)
                break;
c0025fc2:	e9 47 ff ff ff       	jmp    c0025f0e <__vprintf+0x347>
                value = va_arg (args, size_t);
c0025fc7:	8b 44 24 54          	mov    0x54(%esp),%eax
c0025fcb:	83 c0 04             	add    $0x4,%eax
c0025fce:	8b 74 24 54          	mov    0x54(%esp),%esi
c0025fd2:	8b 0e                	mov    (%esi),%ecx
c0025fd4:	bb 00 00 00 00       	mov    $0x0,%ebx
                if (value > SIZE_MAX / 2)
c0025fd9:	81 f9 ff ff ff 7f    	cmp    $0x7fffffff,%ecx
c0025fdf:	76 23                	jbe    c0026004 <__vprintf+0x43d>
                  value = value - SIZE_MAX - 1;
c0025fe1:	4b                   	dec    %ebx
                value = va_arg (args, size_t);
c0025fe2:	89 44 24 54          	mov    %eax,0x54(%esp)
c0025fe6:	e9 23 ff ff ff       	jmp    c0025f0e <__vprintf+0x347>
                NOT_REACHED ();
c0025feb:	68 60 d0 02 c0       	push   $0xc002d060
c0025ff0:	68 44 c6 02 c0       	push   $0xc002c644
c0025ff5:	68 dc 00 00 00       	push   $0xdc
c0025ffa:	68 b1 e2 02 c0       	push   $0xc002e2b1
c0025fff:	e8 3c 16 00 00       	call   c0027640 <debug_panic>
                value = va_arg (args, size_t);
c0026004:	89 44 24 54          	mov    %eax,0x54(%esp)
c0026008:	e9 01 ff ff ff       	jmp    c0025f0e <__vprintf+0x347>
            format_integer (value < 0 ? -value : value,
c002600d:	f7 d8                	neg    %eax
c002600f:	83 d2 00             	adc    $0x0,%edx
c0026012:	f7 da                	neg    %edx
c0026014:	e9 01 ff ff ff       	jmp    c0025f1a <__vprintf+0x353>
                value = va_arg (args, unsigned);
c0026019:	8b 7c 24 54          	mov    0x54(%esp),%edi
c002601d:	8b 3f                	mov    (%edi),%edi
c002601f:	bd 00 00 00 00       	mov    $0x0,%ebp
c0026024:	89 7c 24 08          	mov    %edi,0x8(%esp)
c0026028:	89 6c 24 0c          	mov    %ebp,0xc(%esp)
c002602c:	8b 7c 24 54          	mov    0x54(%esp),%edi
c0026030:	8d 7f 04             	lea    0x4(%edi),%edi
c0026033:	89 7c 24 54          	mov    %edi,0x54(%esp)
            switch (*format) 
c0026037:	3c 6f                	cmp    $0x6f,%al
c0026039:	0f 84 68 01 00 00    	je     c00261a7 <__vprintf+0x5e0>
c002603f:	3c 6f                	cmp    $0x6f,%al
c0026041:	0f 8e 0a 01 00 00    	jle    c0026151 <__vprintf+0x58a>
c0026047:	3c 75                	cmp    $0x75,%al
c0026049:	0f 84 0d 01 00 00    	je     c002615c <__vprintf+0x595>
c002604f:	3c 78                	cmp    $0x78,%al
c0026051:	0f 85 37 01 00 00    	jne    c002618e <__vprintf+0x5c7>
              case 'x': b = &base_x; break;
c0026057:	b8 60 c6 02 c0       	mov    $0xc002c660,%eax
c002605c:	e9 00 01 00 00       	jmp    c0026161 <__vprintf+0x59a>
                value = (unsigned char) va_arg (args, unsigned);
c0026061:	8b 74 24 54          	mov    0x54(%esp),%esi
c0026065:	0f b6 16             	movzbl (%esi),%edx
c0026068:	89 54 24 08          	mov    %edx,0x8(%esp)
c002606c:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0026073:	00 
                break;
c0026074:	89 fb                	mov    %edi,%ebx
                value = (unsigned char) va_arg (args, unsigned);
c0026076:	8d 7e 04             	lea    0x4(%esi),%edi
c0026079:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c002607d:	eb b8                	jmp    c0026037 <__vprintf+0x470>
                value = (unsigned short) va_arg (args, unsigned);
c002607f:	8b 74 24 54          	mov    0x54(%esp),%esi
c0026083:	0f b7 16             	movzwl (%esi),%edx
c0026086:	89 54 24 08          	mov    %edx,0x8(%esp)
c002608a:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0026091:	00 
                break;
c0026092:	89 fb                	mov    %edi,%ebx
                value = (unsigned short) va_arg (args, unsigned);
c0026094:	8d 7e 04             	lea    0x4(%esi),%edi
c0026097:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c002609b:	eb 9a                	jmp    c0026037 <__vprintf+0x470>
                value = va_arg (args, uintmax_t);
c002609d:	8b 74 24 54          	mov    0x54(%esp),%esi
c00260a1:	8b 1e                	mov    (%esi),%ebx
c00260a3:	8b 76 04             	mov    0x4(%esi),%esi
c00260a6:	89 5c 24 08          	mov    %ebx,0x8(%esp)
c00260aa:	89 74 24 0c          	mov    %esi,0xc(%esp)
                break;
c00260ae:	89 fb                	mov    %edi,%ebx
                value = va_arg (args, uintmax_t);
c00260b0:	8b 7c 24 54          	mov    0x54(%esp),%edi
c00260b4:	8d 7f 08             	lea    0x8(%edi),%edi
c00260b7:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c00260bb:	e9 77 ff ff ff       	jmp    c0026037 <__vprintf+0x470>
                value = va_arg (args, unsigned long);
c00260c0:	8b 74 24 54          	mov    0x54(%esp),%esi
c00260c4:	8b 1e                	mov    (%esi),%ebx
c00260c6:	be 00 00 00 00       	mov    $0x0,%esi
c00260cb:	89 5c 24 08          	mov    %ebx,0x8(%esp)
c00260cf:	89 74 24 0c          	mov    %esi,0xc(%esp)
                break;
c00260d3:	89 fb                	mov    %edi,%ebx
                value = va_arg (args, unsigned long);
c00260d5:	8b 7c 24 54          	mov    0x54(%esp),%edi
c00260d9:	8d 7f 04             	lea    0x4(%edi),%edi
c00260dc:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c00260e0:	e9 52 ff ff ff       	jmp    c0026037 <__vprintf+0x470>
                value = va_arg (args, unsigned long long);
c00260e5:	8b 74 24 54          	mov    0x54(%esp),%esi
c00260e9:	8b 1e                	mov    (%esi),%ebx
c00260eb:	8b 76 04             	mov    0x4(%esi),%esi
c00260ee:	89 5c 24 08          	mov    %ebx,0x8(%esp)
c00260f2:	89 74 24 0c          	mov    %esi,0xc(%esp)
                break;
c00260f6:	89 fb                	mov    %edi,%ebx
                value = va_arg (args, unsigned long long);
c00260f8:	8b 7c 24 54          	mov    0x54(%esp),%edi
c00260fc:	8d 7f 08             	lea    0x8(%edi),%edi
c00260ff:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c0026103:	e9 2f ff ff ff       	jmp    c0026037 <__vprintf+0x470>
                value &= ((uintmax_t) PTRDIFF_MAX << 1) | 1;
c0026108:	8b 74 24 54          	mov    0x54(%esp),%esi
c002610c:	8b 36                	mov    (%esi),%esi
c002610e:	89 74 24 08          	mov    %esi,0x8(%esp)
c0026112:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0026119:	00 
                break;
c002611a:	89 fb                	mov    %edi,%ebx
                value = va_arg (args, ptrdiff_t);
c002611c:	8b 7c 24 54          	mov    0x54(%esp),%edi
c0026120:	8d 7f 04             	lea    0x4(%edi),%edi
c0026123:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c0026127:	e9 0b ff ff ff       	jmp    c0026037 <__vprintf+0x470>
                value = va_arg (args, size_t);
c002612c:	8b 74 24 54          	mov    0x54(%esp),%esi
c0026130:	8b 1e                	mov    (%esi),%ebx
c0026132:	be 00 00 00 00       	mov    $0x0,%esi
c0026137:	89 5c 24 08          	mov    %ebx,0x8(%esp)
c002613b:	89 74 24 0c          	mov    %esi,0xc(%esp)
                break;
c002613f:	89 fb                	mov    %edi,%ebx
                value = va_arg (args, size_t);
c0026141:	8b 7c 24 54          	mov    0x54(%esp),%edi
c0026145:	8d 7f 04             	lea    0x4(%edi),%edi
c0026148:	89 7c 24 54          	mov    %edi,0x54(%esp)
                break;
c002614c:	e9 e6 fe ff ff       	jmp    c0026037 <__vprintf+0x470>
            switch (*format) 
c0026151:	3c 58                	cmp    $0x58,%al
c0026153:	75 39                	jne    c002618e <__vprintf+0x5c7>
              case 'X': b = &base_X; break;
c0026155:	b8 50 c6 02 c0       	mov    $0xc002c650,%eax
c002615a:	eb 05                	jmp    c0026161 <__vprintf+0x59a>
              case 'u': b = &base_d; break;
c002615c:	b8 80 c6 02 c0       	mov    $0xc002c680,%eax
            format_integer (value, false, false, b, &c, output, aux);
c0026161:	83 ec 0c             	sub    $0xc,%esp
c0026164:	ff 74 24 68          	pushl  0x68(%esp)
c0026168:	ff 74 24 68          	pushl  0x68(%esp)
c002616c:	8d 7c 24 34          	lea    0x34(%esp),%edi
c0026170:	57                   	push   %edi
c0026171:	50                   	push   %eax
c0026172:	6a 00                	push   $0x0
c0026174:	b9 00 00 00 00       	mov    $0x0,%ecx
c0026179:	8b 44 24 28          	mov    0x28(%esp),%eax
c002617d:	8b 54 24 2c          	mov    0x2c(%esp),%edx
c0026181:	e8 0f f6 ff ff       	call   c0025795 <format_integer>
          break;
c0026186:	83 c4 20             	add    $0x20,%esp
c0026189:	e9 84 fa ff ff       	jmp    c0025c12 <__vprintf+0x4b>
              default: NOT_REACHED ();
c002618e:	68 60 d0 02 c0       	push   $0xc002d060
c0026193:	68 44 c6 02 c0       	push   $0xc002c644
c0026198:	68 14 01 00 00       	push   $0x114
c002619d:	68 b1 e2 02 c0       	push   $0xc002e2b1
c00261a2:	e8 99 14 00 00       	call   c0027640 <debug_panic>
              case 'o': b = &base_o; break;
c00261a7:	b8 70 c6 02 c0       	mov    $0xc002c670,%eax
c00261ac:	eb b3                	jmp    c0026161 <__vprintf+0x59a>
      switch (*format) 
c00261ae:	89 df                	mov    %ebx,%edi
            char ch = va_arg (args, int);
c00261b0:	8b 44 24 54          	mov    0x54(%esp),%eax
c00261b4:	8d 70 04             	lea    0x4(%eax),%esi
c00261b7:	8b 00                	mov    (%eax),%eax
c00261b9:	88 44 24 1f          	mov    %al,0x1f(%esp)
            format_string (&ch, 1, &c, output, aux);
c00261bd:	83 ec 08             	sub    $0x8,%esp
c00261c0:	ff 74 24 64          	pushl  0x64(%esp)
c00261c4:	ff 74 24 64          	pushl  0x64(%esp)
c00261c8:	8d 4c 24 30          	lea    0x30(%esp),%ecx
c00261cc:	ba 01 00 00 00       	mov    $0x1,%edx
c00261d1:	8d 44 24 2f          	lea    0x2f(%esp),%eax
c00261d5:	e8 18 f9 ff ff       	call   c0025af2 <format_string>
          break;
c00261da:	83 c4 10             	add    $0x10,%esp
c00261dd:	89 fb                	mov    %edi,%ebx
            char ch = va_arg (args, int);
c00261df:	89 74 24 54          	mov    %esi,0x54(%esp)
          break;
c00261e3:	e9 2a fa ff ff       	jmp    c0025c12 <__vprintf+0x4b>
      switch (*format) 
c00261e8:	89 df                	mov    %ebx,%edi
            const char *s = va_arg (args, char *);
c00261ea:	8b 44 24 54          	mov    0x54(%esp),%eax
c00261ee:	8d 70 04             	lea    0x4(%eax),%esi
c00261f1:	8b 18                	mov    (%eax),%ebx
            if (s == NULL)
c00261f3:	85 db                	test   %ebx,%ebx
c00261f5:	74 30                	je     c0026227 <__vprintf+0x660>
            format_string (s, strnlen (s, c.precision), &c, output, aux);
c00261f7:	83 ec 08             	sub    $0x8,%esp
c00261fa:	52                   	push   %edx
c00261fb:	53                   	push   %ebx
c00261fc:	e8 0e 0b 00 00       	call   c0026d0f <strnlen>
c0026201:	83 c4 08             	add    $0x8,%esp
c0026204:	ff 74 24 64          	pushl  0x64(%esp)
c0026208:	ff 74 24 64          	pushl  0x64(%esp)
c002620c:	8d 4c 24 30          	lea    0x30(%esp),%ecx
c0026210:	89 c2                	mov    %eax,%edx
c0026212:	89 d8                	mov    %ebx,%eax
c0026214:	e8 d9 f8 ff ff       	call   c0025af2 <format_string>
          break;
c0026219:	83 c4 10             	add    $0x10,%esp
c002621c:	89 fb                	mov    %edi,%ebx
            const char *s = va_arg (args, char *);
c002621e:	89 74 24 54          	mov    %esi,0x54(%esp)
          break;
c0026222:	e9 eb f9 ff ff       	jmp    c0025c12 <__vprintf+0x4b>
              s = "(null)";
c0026227:	bb aa e2 02 c0       	mov    $0xc002e2aa,%ebx
c002622c:	eb c9                	jmp    c00261f7 <__vprintf+0x630>
      switch (*format) 
c002622e:	89 df                	mov    %ebx,%edi
            void *p = va_arg (args, void *);
c0026230:	8b 44 24 54          	mov    0x54(%esp),%eax
c0026234:	8d 70 04             	lea    0x4(%eax),%esi
c0026237:	8b 00                	mov    (%eax),%eax
            c.flags = POUND;
c0026239:	c7 44 24 20 08 00 00 	movl   $0x8,0x20(%esp)
c0026240:	00 
            format_integer ((uintptr_t) p, false, false,
c0026241:	83 ec 0c             	sub    $0xc,%esp
c0026244:	ff 74 24 68          	pushl  0x68(%esp)
c0026248:	ff 74 24 68          	pushl  0x68(%esp)
c002624c:	8d 5c 24 34          	lea    0x34(%esp),%ebx
c0026250:	53                   	push   %ebx
c0026251:	68 60 c6 02 c0       	push   $0xc002c660
c0026256:	6a 00                	push   $0x0
c0026258:	b9 00 00 00 00       	mov    $0x0,%ecx
c002625d:	ba 00 00 00 00       	mov    $0x0,%edx
c0026262:	e8 2e f5 ff ff       	call   c0025795 <format_integer>
          break;
c0026267:	83 c4 20             	add    $0x20,%esp
c002626a:	89 fb                	mov    %edi,%ebx
            void *p = va_arg (args, void *);
c002626c:	89 74 24 54          	mov    %esi,0x54(%esp)
          break;
c0026270:	e9 9d f9 ff ff       	jmp    c0025c12 <__vprintf+0x4b>
      switch (*format) 
c0026275:	89 df                	mov    %ebx,%edi
          __printf ("<<no %%%c in kernel>>", output, aux, *format);
c0026277:	55                   	push   %ebp
c0026278:	ff 74 24 60          	pushl  0x60(%esp)
c002627c:	ff 74 24 60          	pushl  0x60(%esp)
c0026280:	68 c3 e2 02 c0       	push   $0xc002e2c3
c0026285:	e8 20 f9 ff ff       	call   c0025baa <__printf>
          break;
c002628a:	83 c4 10             	add    $0x10,%esp
c002628d:	89 fb                	mov    %edi,%ebx
c002628f:	e9 7e f9 ff ff       	jmp    c0025c12 <__vprintf+0x4b>
      switch (*format) 
c0026294:	89 df                	mov    %ebx,%edi
          __printf ("<<no %%%c conversion>>", output, aux, *format);
c0026296:	55                   	push   %ebp
c0026297:	ff 74 24 60          	pushl  0x60(%esp)
c002629b:	ff 74 24 60          	pushl  0x60(%esp)
c002629f:	68 d9 e2 02 c0       	push   $0xc002e2d9
c00262a4:	e8 01 f9 ff ff       	call   c0025baa <__printf>
          break;
c00262a9:	83 c4 10             	add    $0x10,%esp
c00262ac:	89 fb                	mov    %edi,%ebx
c00262ae:	e9 5f f9 ff ff       	jmp    c0025c12 <__vprintf+0x4b>

c00262b3 <vsnprintf>:
{
c00262b3:	53                   	push   %ebx
c00262b4:	83 ec 18             	sub    $0x18,%esp
c00262b7:	8b 44 24 24          	mov    0x24(%esp),%eax
c00262bb:	8b 54 24 28          	mov    0x28(%esp),%edx
c00262bf:	8b 4c 24 2c          	mov    0x2c(%esp),%ecx
  aux.p = buffer;
c00262c3:	8b 5c 24 20          	mov    0x20(%esp),%ebx
c00262c7:	89 5c 24 04          	mov    %ebx,0x4(%esp)
  aux.length = 0;
c00262cb:	c7 44 24 08 00 00 00 	movl   $0x0,0x8(%esp)
c00262d2:	00 
  aux.max_length = buf_size > 0 ? buf_size - 1 : 0;
c00262d3:	85 c0                	test   %eax,%eax
c00262d5:	74 29                	je     c0026300 <vsnprintf+0x4d>
c00262d7:	48                   	dec    %eax
c00262d8:	89 44 24 0c          	mov    %eax,0xc(%esp)
  __vprintf (format, args, vsnprintf_helper, &aux);
c00262dc:	8d 44 24 04          	lea    0x4(%esp),%eax
c00262e0:	50                   	push   %eax
c00262e1:	68 44 57 02 c0       	push   $0xc0025744
c00262e6:	51                   	push   %ecx
c00262e7:	52                   	push   %edx
c00262e8:	e8 da f8 ff ff       	call   c0025bc7 <__vprintf>
    *aux.p = '\0';
c00262ed:	8b 44 24 14          	mov    0x14(%esp),%eax
c00262f1:	c6 00 00             	movb   $0x0,(%eax)
c00262f4:	83 c4 10             	add    $0x10,%esp
  return aux.length;
c00262f7:	8b 44 24 08          	mov    0x8(%esp),%eax
}
c00262fb:	83 c4 18             	add    $0x18,%esp
c00262fe:	5b                   	pop    %ebx
c00262ff:	c3                   	ret    
  aux.max_length = buf_size > 0 ? buf_size - 1 : 0;
c0026300:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0026307:	00 
  __vprintf (format, args, vsnprintf_helper, &aux);
c0026308:	8d 44 24 04          	lea    0x4(%esp),%eax
c002630c:	50                   	push   %eax
c002630d:	68 44 57 02 c0       	push   $0xc0025744
c0026312:	51                   	push   %ecx
c0026313:	52                   	push   %edx
c0026314:	e8 ae f8 ff ff       	call   c0025bc7 <__vprintf>
c0026319:	83 c4 10             	add    $0x10,%esp
c002631c:	eb d9                	jmp    c00262f7 <vsnprintf+0x44>

c002631e <snprintf>:
{
c002631e:	83 ec 0c             	sub    $0xc,%esp
  va_start (args, format);
c0026321:	8d 44 24 1c          	lea    0x1c(%esp),%eax
  retval = vsnprintf (buffer, buf_size, format, args);
c0026325:	50                   	push   %eax
c0026326:	ff 74 24 1c          	pushl  0x1c(%esp)
c002632a:	ff 74 24 1c          	pushl  0x1c(%esp)
c002632e:	ff 74 24 1c          	pushl  0x1c(%esp)
c0026332:	e8 7c ff ff ff       	call   c00262b3 <vsnprintf>
}
c0026337:	83 c4 1c             	add    $0x1c,%esp
c002633a:	c3                   	ret    

c002633b <hex_dump>:
   starting at OFS for the first byte in BUF.  If ASCII is true
   then the corresponding ASCII characters are also rendered
   alongside. */   
void
hex_dump (uintptr_t ofs, const void *buf_, size_t size, bool ascii)
{
c002633b:	55                   	push   %ebp
c002633c:	57                   	push   %edi
c002633d:	56                   	push   %esi
c002633e:	53                   	push   %ebx
c002633f:	83 ec 1c             	sub    $0x1c,%esp
c0026342:	8a 44 24 3c          	mov    0x3c(%esp),%al
c0026346:	88 44 24 0f          	mov    %al,0xf(%esp)
  const uint8_t *buf = buf_;
  const size_t per_line = 16; /* Maximum bytes per line. */

  while (size > 0)
c002634a:	83 7c 24 38 00       	cmpl   $0x0,0x38(%esp)
c002634f:	0f 84 d9 01 00 00    	je     c002652e <hex_dump+0x1f3>
c0026355:	8b 44 24 34          	mov    0x34(%esp),%eax
c0026359:	89 44 24 08          	mov    %eax,0x8(%esp)
c002635d:	e9 87 00 00 00       	jmp    c00263e9 <hex_dump+0xae>
      /* Number of bytes on this line. */
      start = ofs % per_line;
      end = per_line;
      if (end - start > size)
        end = start + size;
      n = end - start;
c0026362:	8b 44 24 38          	mov    0x38(%esp),%eax
c0026366:	89 44 24 04          	mov    %eax,0x4(%esp)

      /* Print line. */
      printf ("%08jx  ", (uintmax_t) ROUND_DOWN (ofs, per_line));
      for (i = 0; i < start; i++)
c002636a:	89 f3                	mov    %esi,%ebx
c002636c:	e9 e2 00 00 00       	jmp    c0026453 <hex_dump+0x118>
        printf ("   ");
      for (; i < end; i++) 
        printf ("%02hhx%c",
c0026371:	b8 2d 00 00 00       	mov    $0x2d,%eax
c0026376:	e9 f0 00 00 00       	jmp    c002646b <hex_dump+0x130>
            printf ("   ");
          printf ("|");
          for (i = 0; i < start; i++)
            printf (" ");
          for (; i < end; i++)
            printf ("%c",
c002637b:	83 ec 0c             	sub    $0xc,%esp
c002637e:	0f b6 c0             	movzbl %al,%eax
c0026381:	50                   	push   %eax
c0026382:	e8 73 2d 00 00       	call   c00290fa <putchar>
          for (; i < end; i++)
c0026387:	43                   	inc    %ebx
c0026388:	83 c4 10             	add    $0x10,%esp
c002638b:	39 fb                	cmp    %edi,%ebx
c002638d:	73 12                	jae    c00263a1 <hex_dump+0x66>
                    isprint (buf[i - start]) ? buf[i - start] : '.');
c002638f:	8a 04 1e             	mov    (%esi,%ebx,1),%al
static inline int isprint (int c) { return c >= 32 && c < 127; }
c0026392:	0f b6 d0             	movzbl %al,%edx
c0026395:	83 ea 20             	sub    $0x20,%edx
            printf ("%c",
c0026398:	83 fa 5e             	cmp    $0x5e,%edx
c002639b:	76 de                	jbe    c002637b <hex_dump+0x40>
c002639d:	89 e8                	mov    %ebp,%eax
c002639f:	eb da                	jmp    c002637b <hex_dump+0x40>
          for (; i < per_line; i++)
c00263a1:	83 fb 0f             	cmp    $0xf,%ebx
c00263a4:	77 13                	ja     c00263b9 <hex_dump+0x7e>
            printf (" ");
c00263a6:	83 ec 0c             	sub    $0xc,%esp
c00263a9:	6a 20                	push   $0x20
c00263ab:	e8 4a 2d 00 00       	call   c00290fa <putchar>
          for (; i < per_line; i++)
c00263b0:	43                   	inc    %ebx
c00263b1:	83 c4 10             	add    $0x10,%esp
c00263b4:	83 fb 0f             	cmp    $0xf,%ebx
c00263b7:	76 ed                	jbe    c00263a6 <hex_dump+0x6b>
          printf ("|");
c00263b9:	83 ec 0c             	sub    $0xc,%esp
c00263bc:	6a 7c                	push   $0x7c
c00263be:	e8 37 2d 00 00       	call   c00290fa <putchar>
c00263c3:	83 c4 10             	add    $0x10,%esp
        }
      printf ("\n");
c00263c6:	83 ec 0c             	sub    $0xc,%esp
c00263c9:	6a 0a                	push   $0xa
c00263cb:	e8 2a 2d 00 00       	call   c00290fa <putchar>

      ofs += n;
c00263d0:	8b 44 24 14          	mov    0x14(%esp),%eax
c00263d4:	01 44 24 40          	add    %eax,0x40(%esp)
      buf += n;
c00263d8:	01 44 24 18          	add    %eax,0x18(%esp)
  while (size > 0)
c00263dc:	83 c4 10             	add    $0x10,%esp
c00263df:	29 44 24 38          	sub    %eax,0x38(%esp)
c00263e3:	0f 84 45 01 00 00    	je     c002652e <hex_dump+0x1f3>
      start = ofs % per_line;
c00263e9:	8b 74 24 30          	mov    0x30(%esp),%esi
c00263ed:	83 e6 0f             	and    $0xf,%esi
      if (end - start > size)
c00263f0:	b8 10 00 00 00       	mov    $0x10,%eax
c00263f5:	29 f0                	sub    %esi,%eax
c00263f7:	89 44 24 04          	mov    %eax,0x4(%esp)
c00263fb:	3b 44 24 38          	cmp    0x38(%esp),%eax
c00263ff:	0f 86 ea 00 00 00    	jbe    c00264ef <hex_dump+0x1b4>
        end = start + size;
c0026405:	89 f7                	mov    %esi,%edi
c0026407:	03 7c 24 38          	add    0x38(%esp),%edi
      printf ("%08jx  ", (uintmax_t) ROUND_DOWN (ofs, per_line));
c002640b:	83 ec 04             	sub    $0x4,%esp
c002640e:	8b 44 24 34          	mov    0x34(%esp),%eax
c0026412:	83 e0 f0             	and    $0xfffffff0,%eax
c0026415:	ba 00 00 00 00       	mov    $0x0,%edx
c002641a:	52                   	push   %edx
c002641b:	50                   	push   %eax
c002641c:	68 f0 e2 02 c0       	push   $0xc002e2f0
c0026421:	e8 6c f7 ff ff       	call   c0025b92 <printf>
      for (i = 0; i < start; i++)
c0026426:	83 c4 10             	add    $0x10,%esp
c0026429:	85 f6                	test   %esi,%esi
c002642b:	0f 84 31 ff ff ff    	je     c0026362 <hex_dump+0x27>
      n = end - start;
c0026431:	8b 44 24 38          	mov    0x38(%esp),%eax
c0026435:	89 44 24 04          	mov    %eax,0x4(%esp)
      end = per_line;
c0026439:	bb 00 00 00 00       	mov    $0x0,%ebx
        printf ("   ");
c002643e:	83 ec 0c             	sub    $0xc,%esp
c0026441:	68 f8 e2 02 c0       	push   $0xc002e2f8
c0026446:	e8 47 f7 ff ff       	call   c0025b92 <printf>
      for (i = 0; i < start; i++)
c002644b:	43                   	inc    %ebx
c002644c:	83 c4 10             	add    $0x10,%esp
c002644f:	39 de                	cmp    %ebx,%esi
c0026451:	77 eb                	ja     c002643e <hex_dump+0x103>
      for (; i < end; i++) 
c0026453:	39 fb                	cmp    %edi,%ebx
c0026455:	73 30                	jae    c0026487 <hex_dump+0x14c>
                buf[i - start], i == per_line / 2 - 1? '-' : ' ');
c0026457:	8b 6c 24 08          	mov    0x8(%esp),%ebp
c002645b:	29 f5                	sub    %esi,%ebp
        printf ("%02hhx%c",
c002645d:	83 fb 07             	cmp    $0x7,%ebx
c0026460:	0f 84 0b ff ff ff    	je     c0026371 <hex_dump+0x36>
c0026466:	b8 20 00 00 00       	mov    $0x20,%eax
c002646b:	83 ec 04             	sub    $0x4,%esp
c002646e:	50                   	push   %eax
c002646f:	0f b6 44 1d 00       	movzbl 0x0(%ebp,%ebx,1),%eax
c0026474:	50                   	push   %eax
c0026475:	68 fc e2 02 c0       	push   $0xc002e2fc
c002647a:	e8 13 f7 ff ff       	call   c0025b92 <printf>
      for (; i < end; i++) 
c002647f:	43                   	inc    %ebx
c0026480:	83 c4 10             	add    $0x10,%esp
c0026483:	39 fb                	cmp    %edi,%ebx
c0026485:	72 d6                	jb     c002645d <hex_dump+0x122>
      if (ascii) 
c0026487:	80 7c 24 0f 00       	cmpb   $0x0,0xf(%esp)
c002648c:	0f 84 34 ff ff ff    	je     c00263c6 <hex_dump+0x8b>
          for (; i < per_line; i++)
c0026492:	83 fb 0f             	cmp    $0xf,%ebx
c0026495:	77 16                	ja     c00264ad <hex_dump+0x172>
            printf ("   ");
c0026497:	83 ec 0c             	sub    $0xc,%esp
c002649a:	68 f8 e2 02 c0       	push   $0xc002e2f8
c002649f:	e8 ee f6 ff ff       	call   c0025b92 <printf>
          for (; i < per_line; i++)
c00264a4:	43                   	inc    %ebx
c00264a5:	83 c4 10             	add    $0x10,%esp
c00264a8:	83 fb 10             	cmp    $0x10,%ebx
c00264ab:	75 ea                	jne    c0026497 <hex_dump+0x15c>
          printf ("|");
c00264ad:	83 ec 0c             	sub    $0xc,%esp
c00264b0:	6a 7c                	push   $0x7c
c00264b2:	e8 43 2c 00 00       	call   c00290fa <putchar>
          for (i = 0; i < start; i++)
c00264b7:	83 c4 10             	add    $0x10,%esp
c00264ba:	85 f6                	test   %esi,%esi
c00264bc:	74 63                	je     c0026521 <hex_dump+0x1e6>
c00264be:	bb 00 00 00 00       	mov    $0x0,%ebx
            printf (" ");
c00264c3:	83 ec 0c             	sub    $0xc,%esp
c00264c6:	6a 20                	push   $0x20
c00264c8:	e8 2d 2c 00 00       	call   c00290fa <putchar>
          for (i = 0; i < start; i++)
c00264cd:	43                   	inc    %ebx
c00264ce:	83 c4 10             	add    $0x10,%esp
c00264d1:	39 de                	cmp    %ebx,%esi
c00264d3:	75 ee                	jne    c00264c3 <hex_dump+0x188>
          for (; i < end; i++)
c00264d5:	39 fb                	cmp    %edi,%ebx
c00264d7:	0f 83 c4 fe ff ff    	jae    c00263a1 <hex_dump+0x66>
                    isprint (buf[i - start]) ? buf[i - start] : '.');
c00264dd:	8b 44 24 08          	mov    0x8(%esp),%eax
c00264e1:	29 f0                	sub    %esi,%eax
c00264e3:	89 c6                	mov    %eax,%esi
c00264e5:	bd 2e 00 00 00       	mov    $0x2e,%ebp
c00264ea:	e9 a0 fe ff ff       	jmp    c002638f <hex_dump+0x54>
      printf ("%08jx  ", (uintmax_t) ROUND_DOWN (ofs, per_line));
c00264ef:	83 ec 04             	sub    $0x4,%esp
c00264f2:	8b 44 24 34          	mov    0x34(%esp),%eax
c00264f6:	83 e0 f0             	and    $0xfffffff0,%eax
c00264f9:	ba 00 00 00 00       	mov    $0x0,%edx
c00264fe:	52                   	push   %edx
c00264ff:	50                   	push   %eax
c0026500:	68 f0 e2 02 c0       	push   $0xc002e2f0
c0026505:	e8 88 f6 ff ff       	call   c0025b92 <printf>
      for (i = 0; i < start; i++)
c002650a:	83 c4 10             	add    $0x10,%esp
      end = per_line;
c002650d:	bf 10 00 00 00       	mov    $0x10,%edi
      for (i = 0; i < start; i++)
c0026512:	89 f3                	mov    %esi,%ebx
c0026514:	85 f6                	test   %esi,%esi
c0026516:	0f 85 1d ff ff ff    	jne    c0026439 <hex_dump+0xfe>
c002651c:	e9 36 ff ff ff       	jmp    c0026457 <hex_dump+0x11c>
          for (i = 0; i < start; i++)
c0026521:	89 f3                	mov    %esi,%ebx
          for (; i < end; i++)
c0026523:	85 ff                	test   %edi,%edi
c0026525:	75 b6                	jne    c00264dd <hex_dump+0x1a2>
          for (i = 0; i < start; i++)
c0026527:	89 fb                	mov    %edi,%ebx
c0026529:	e9 78 fe ff ff       	jmp    c00263a6 <hex_dump+0x6b>
      size -= n;
    }
}
c002652e:	83 c4 1c             	add    $0x1c,%esp
c0026531:	5b                   	pop    %ebx
c0026532:	5e                   	pop    %esi
c0026533:	5f                   	pop    %edi
c0026534:	5d                   	pop    %ebp
c0026535:	c3                   	ret    

c0026536 <print_human_readable_size>:

/* Prints SIZE, which represents a number of bytes, in a
   human-readable format, e.g. "256 kB". */
void
print_human_readable_size (uint64_t size) 
{
c0026536:	57                   	push   %edi
c0026537:	56                   	push   %esi
c0026538:	83 ec 04             	sub    $0x4,%esp
c002653b:	8b 74 24 10          	mov    0x10(%esp),%esi
c002653f:	8b 7c 24 14          	mov    0x14(%esp),%edi
  if (size == 1)
c0026543:	89 f0                	mov    %esi,%eax
c0026545:	83 f0 01             	xor    $0x1,%eax
c0026548:	89 fa                	mov    %edi,%edx
c002654a:	09 c2                	or     %eax,%edx
c002654c:	74 1d                	je     c002656b <print_human_readable_size+0x35>
  else 
    {
      static const char *factors[] = {"bytes", "kB", "MB", "GB", "TB", NULL};
      const char **fp;

      for (fp = factors; size >= 1024 && fp[1] != NULL; fp++)
c002654e:	83 ff 00             	cmp    $0x0,%edi
c0026551:	77 08                	ja     c002655b <print_human_readable_size+0x25>
c0026553:	81 fe ff 03 00 00    	cmp    $0x3ff,%esi
c0026559:	76 5d                	jbe    c00265b8 <print_human_readable_size+0x82>
c002655b:	b9 94 67 03 c0       	mov    $0xc0036794,%ecx
c0026560:	83 3d 98 67 03 c0 00 	cmpl   $0x0,0xc0036798
c0026567:	75 1a                	jne    c0026583 <print_human_readable_size+0x4d>
c0026569:	eb 36                	jmp    c00265a1 <print_human_readable_size+0x6b>
    printf ("1 byte");
c002656b:	83 ec 0c             	sub    $0xc,%esp
c002656e:	68 05 e3 02 c0       	push   $0xc002e305
c0026573:	e8 1a f6 ff ff       	call   c0025b92 <printf>
c0026578:	83 c4 10             	add    $0x10,%esp
c002657b:	eb 35                	jmp    c00265b2 <print_human_readable_size+0x7c>
      for (fp = factors; size >= 1024 && fp[1] != NULL; fp++)
c002657d:	83 79 04 00          	cmpl   $0x0,0x4(%ecx)
c0026581:	74 1e                	je     c00265a1 <print_human_readable_size+0x6b>
        size /= 1024;
c0026583:	89 f0                	mov    %esi,%eax
c0026585:	89 fa                	mov    %edi,%edx
c0026587:	0f ac f8 0a          	shrd   $0xa,%edi,%eax
c002658b:	c1 ea 0a             	shr    $0xa,%edx
c002658e:	89 c6                	mov    %eax,%esi
c0026590:	89 d7                	mov    %edx,%edi
      for (fp = factors; size >= 1024 && fp[1] != NULL; fp++)
c0026592:	83 c1 04             	add    $0x4,%ecx
c0026595:	83 fa 00             	cmp    $0x0,%edx
c0026598:	77 e3                	ja     c002657d <print_human_readable_size+0x47>
c002659a:	3d ff 03 00 00       	cmp    $0x3ff,%eax
c002659f:	77 dc                	ja     c002657d <print_human_readable_size+0x47>
      printf ("%"PRIu64" %s", size, *fp);
c00265a1:	ff 31                	pushl  (%ecx)
c00265a3:	57                   	push   %edi
c00265a4:	56                   	push   %esi
c00265a5:	68 0c e3 02 c0       	push   $0xc002e30c
c00265aa:	e8 e3 f5 ff ff       	call   c0025b92 <printf>
c00265af:	83 c4 10             	add    $0x10,%esp
    }
}
c00265b2:	83 c4 04             	add    $0x4,%esp
c00265b5:	5e                   	pop    %esi
c00265b6:	5f                   	pop    %edi
c00265b7:	c3                   	ret    
      for (fp = factors; size >= 1024 && fp[1] != NULL; fp++)
c00265b8:	b9 94 67 03 c0       	mov    $0xc0036794,%ecx
c00265bd:	eb e2                	jmp    c00265a1 <print_human_readable_size+0x6b>

c00265bf <compare_thunk>:
}

/* Compares A and B by calling the AUX function. */
static int
compare_thunk (const void *a, const void *b, void *aux) 
{
c00265bf:	83 ec 14             	sub    $0x14,%esp
  int (**compare) (const void *, const void *) = aux;
  return (*compare) (a, b);
c00265c2:	ff 74 24 1c          	pushl  0x1c(%esp)
c00265c6:	ff 74 24 1c          	pushl  0x1c(%esp)
c00265ca:	8b 44 24 28          	mov    0x28(%esp),%eax
c00265ce:	ff 10                	call   *(%eax)
}
c00265d0:	83 c4 1c             	add    $0x1c,%esp
c00265d3:	c3                   	ret    

c00265d4 <do_swap>:

/* Swaps elements with 1-based indexes A_IDX and B_IDX in ARRAY
   with elements of SIZE bytes each. */
static void
do_swap (unsigned char *array, size_t a_idx, size_t b_idx, size_t size)
{
c00265d4:	55                   	push   %ebp
c00265d5:	57                   	push   %edi
c00265d6:	56                   	push   %esi
c00265d7:	53                   	push   %ebx
c00265d8:	8b 7c 24 14          	mov    0x14(%esp),%edi
  unsigned char *a = array + (a_idx - 1) * size;
c00265dc:	8d 72 ff             	lea    -0x1(%edx),%esi
c00265df:	0f af f7             	imul   %edi,%esi
  unsigned char *b = array + (b_idx - 1) * size;
c00265e2:	8d 59 ff             	lea    -0x1(%ecx),%ebx
c00265e5:	0f af df             	imul   %edi,%ebx
  size_t i;

  for (i = 0; i < size; i++)
c00265e8:	85 ff                	test   %edi,%edi
c00265ea:	74 1d                	je     c0026609 <do_swap+0x35>
c00265ec:	8d 14 30             	lea    (%eax,%esi,1),%edx
c00265ef:	01 f7                	add    %esi,%edi
c00265f1:	01 c7                	add    %eax,%edi
    {
      unsigned char t = a[i];
c00265f3:	0f b6 2a             	movzbl (%edx),%ebp
c00265f6:	89 d1                	mov    %edx,%ecx
c00265f8:	29 f1                	sub    %esi,%ecx
      a[i] = b[i];
c00265fa:	8a 04 19             	mov    (%ecx,%ebx,1),%al
c00265fd:	88 02                	mov    %al,(%edx)
      b[i] = t;
c00265ff:	89 e8                	mov    %ebp,%eax
c0026601:	88 04 19             	mov    %al,(%ecx,%ebx,1)
c0026604:	42                   	inc    %edx
  for (i = 0; i < size; i++)
c0026605:	39 fa                	cmp    %edi,%edx
c0026607:	75 ea                	jne    c00265f3 <do_swap+0x1f>
    }
}
c0026609:	5b                   	pop    %ebx
c002660a:	5e                   	pop    %esi
c002660b:	5f                   	pop    %edi
c002660c:	5d                   	pop    %ebp
c002660d:	c3                   	ret    

c002660e <heapify>:
   elements, passing AUX as auxiliary data. */
static void
heapify (unsigned char *array, size_t i, size_t cnt, size_t size,
         int (*compare) (const void *, const void *, void *aux),
         void *aux) 
{
c002660e:	55                   	push   %ebp
c002660f:	57                   	push   %edi
c0026610:	56                   	push   %esi
c0026611:	53                   	push   %ebx
c0026612:	83 ec 1c             	sub    $0x1c,%esp
c0026615:	89 44 24 0c          	mov    %eax,0xc(%esp)
c0026619:	89 d6                	mov    %edx,%esi
c002661b:	89 4c 24 08          	mov    %ecx,0x8(%esp)
c002661f:	8b 6c 24 30          	mov    0x30(%esp),%ebp
c0026623:	eb 4a                	jmp    c002666f <heapify+0x61>
  return compare (array + (a_idx - 1) * size, array + (b_idx - 1) * size, aux);
c0026625:	83 ec 04             	sub    $0x4,%esp
c0026628:	ff 74 24 3c          	pushl  0x3c(%esp)
c002662c:	8d 46 ff             	lea    -0x1(%esi),%eax
c002662f:	0f af c5             	imul   %ebp,%eax
c0026632:	8b 4c 24 14          	mov    0x14(%esp),%ecx
c0026636:	01 c8                	add    %ecx,%eax
c0026638:	50                   	push   %eax
c0026639:	8d 43 ff             	lea    -0x1(%ebx),%eax
c002663c:	0f af c5             	imul   %ebp,%eax
c002663f:	01 c8                	add    %ecx,%eax
c0026641:	50                   	push   %eax
c0026642:	ff 54 24 44          	call   *0x44(%esp)
      /* Set `max' to the index of the largest element among I
         and its children (if any). */
      size_t left = 2 * i;
      size_t right = 2 * i + 1;
      size_t max = i;
      if (left <= cnt && do_compare (array, left, max, size, compare, aux) > 0)
c0026646:	83 c4 10             	add    $0x10,%esp
c0026649:	85 c0                	test   %eax,%eax
c002664b:	7e 2e                	jle    c002667b <heapify+0x6d>
        max = left;
      if (right <= cnt
c002664d:	3b 7c 24 08          	cmp    0x8(%esp),%edi
c0026651:	76 5b                	jbe    c00266ae <heapify+0xa0>
        max = left;
c0026653:	89 df                	mov    %ebx,%edi
          && do_compare (array, right, max, size, compare, aux) > 0) 
        max = right;

      /* If the maximum value is already in element I, we're
         done. */
      if (max == i)
c0026655:	39 fe                	cmp    %edi,%esi
c0026657:	74 4d                	je     c00266a6 <heapify+0x98>
        break;

      /* Swap and continue down the heap. */
      do_swap (array, i, max, size);
c0026659:	83 ec 0c             	sub    $0xc,%esp
c002665c:	55                   	push   %ebp
c002665d:	89 f9                	mov    %edi,%ecx
c002665f:	89 f2                	mov    %esi,%edx
c0026661:	8b 44 24 1c          	mov    0x1c(%esp),%eax
c0026665:	e8 6a ff ff ff       	call   c00265d4 <do_swap>
c002666a:	89 fe                	mov    %edi,%esi
    {
c002666c:	83 c4 10             	add    $0x10,%esp
      size_t left = 2 * i;
c002666f:	8d 1c 36             	lea    (%esi,%esi,1),%ebx
      size_t right = 2 * i + 1;
c0026672:	8d 7b 01             	lea    0x1(%ebx),%edi
      if (left <= cnt && do_compare (array, left, max, size, compare, aux) > 0)
c0026675:	3b 5c 24 08          	cmp    0x8(%esp),%ebx
c0026679:	76 aa                	jbe    c0026625 <heapify+0x17>
      if (right <= cnt
c002667b:	3b 7c 24 08          	cmp    0x8(%esp),%edi
c002667f:	77 25                	ja     c00266a6 <heapify+0x98>
  return compare (array + (a_idx - 1) * size, array + (b_idx - 1) * size, aux);
c0026681:	83 ec 04             	sub    $0x4,%esp
c0026684:	ff 74 24 3c          	pushl  0x3c(%esp)
c0026688:	8d 46 ff             	lea    -0x1(%esi),%eax
c002668b:	0f af c5             	imul   %ebp,%eax
c002668e:	8b 54 24 14          	mov    0x14(%esp),%edx
c0026692:	01 d0                	add    %edx,%eax
c0026694:	50                   	push   %eax
c0026695:	0f af dd             	imul   %ebp,%ebx
c0026698:	01 d3                	add    %edx,%ebx
c002669a:	53                   	push   %ebx
c002669b:	ff 54 24 44          	call   *0x44(%esp)
          && do_compare (array, right, max, size, compare, aux) > 0) 
c002669f:	83 c4 10             	add    $0x10,%esp
c00266a2:	85 c0                	test   %eax,%eax
c00266a4:	7f af                	jg     c0026655 <heapify+0x47>
      i = max;
    }
}
c00266a6:	83 c4 1c             	add    $0x1c,%esp
c00266a9:	5b                   	pop    %ebx
c00266aa:	5e                   	pop    %esi
c00266ab:	5f                   	pop    %edi
c00266ac:	5d                   	pop    %ebp
c00266ad:	c3                   	ret    
  return compare (array + (a_idx - 1) * size, array + (b_idx - 1) * size, aux);
c00266ae:	83 ec 04             	sub    $0x4,%esp
c00266b1:	ff 74 24 3c          	pushl  0x3c(%esp)
c00266b5:	8d 43 ff             	lea    -0x1(%ebx),%eax
c00266b8:	0f af c5             	imul   %ebp,%eax
c00266bb:	8b 4c 24 14          	mov    0x14(%esp),%ecx
c00266bf:	01 c8                	add    %ecx,%eax
c00266c1:	50                   	push   %eax
c00266c2:	89 d8                	mov    %ebx,%eax
c00266c4:	0f af c5             	imul   %ebp,%eax
c00266c7:	01 c8                	add    %ecx,%eax
c00266c9:	50                   	push   %eax
c00266ca:	ff 54 24 44          	call   *0x44(%esp)
          && do_compare (array, right, max, size, compare, aux) > 0) 
c00266ce:	83 c4 10             	add    $0x10,%esp
c00266d1:	85 c0                	test   %eax,%eax
c00266d3:	7f 80                	jg     c0026655 <heapify+0x47>
        max = left;
c00266d5:	89 df                	mov    %ebx,%edi
c00266d7:	e9 79 ff ff ff       	jmp    c0026655 <heapify+0x47>

c00266dc <atoi>:
{
c00266dc:	56                   	push   %esi
c00266dd:	53                   	push   %ebx
c00266de:	83 ec 04             	sub    $0x4,%esp
c00266e1:	8b 54 24 10          	mov    0x10(%esp),%edx
  ASSERT (s != NULL);
c00266e5:	85 d2                	test   %edx,%edx
c00266e7:	75 1f                	jne    c0026708 <atoi+0x2c>
c00266e9:	83 ec 0c             	sub    $0xc,%esp
c00266ec:	68 ab e3 02 c0       	push   $0xc002e3ab
c00266f1:	68 df cb 02 c0       	push   $0xc002cbdf
c00266f6:	68 98 c6 02 c0       	push   $0xc002c698
c00266fb:	6a 0f                	push   $0xf
c00266fd:	68 5c e3 02 c0       	push   $0xc002e35c
c0026702:	e8 39 0f 00 00       	call   c0027640 <debug_panic>
    s++;
c0026707:	42                   	inc    %edx
  while (isspace ((unsigned char) *s))
c0026708:	8a 02                	mov    (%edx),%al
          || c == '\r' || c == '\t' || c == '\v');
c002670a:	3c 20                	cmp    $0x20,%al
c002670c:	74 f9                	je     c0026707 <atoi+0x2b>
c002670e:	8d 48 f7             	lea    -0x9(%eax),%ecx
c0026711:	80 f9 04             	cmp    $0x4,%cl
c0026714:	76 f1                	jbe    c0026707 <atoi+0x2b>
  if (*s == '+')
c0026716:	3c 2b                	cmp    $0x2b,%al
c0026718:	74 3e                	je     c0026758 <atoi+0x7c>
  else if (*s == '-')
c002671a:	3c 2d                	cmp    $0x2d,%al
c002671c:	74 3d                	je     c002675b <atoi+0x7f>
  for (value = 0; isdigit (*s); s++)
c002671e:	0f be 0a             	movsbl (%edx),%ecx
static inline int isdigit (int c) { return c >= '0' && c <= '9'; }
c0026721:	8d 41 d0             	lea    -0x30(%ecx),%eax
c0026724:	be 00 00 00 00       	mov    $0x0,%esi
c0026729:	83 f8 09             	cmp    $0x9,%eax
c002672c:	77 4c                	ja     c002677a <atoi+0x9e>
      negative = true;
c002672e:	b8 00 00 00 00       	mov    $0x0,%eax
    value = value * 10 - (*s - '0');
c0026733:	8d 04 80             	lea    (%eax,%eax,4),%eax
c0026736:	89 c3                	mov    %eax,%ebx
c0026738:	29 cb                	sub    %ecx,%ebx
c002673a:	8d 44 03 30          	lea    0x30(%ebx,%eax,1),%eax
  for (value = 0; isdigit (*s); s++)
c002673e:	42                   	inc    %edx
c002673f:	0f be 0a             	movsbl (%edx),%ecx
c0026742:	8d 59 d0             	lea    -0x30(%ecx),%ebx
c0026745:	83 fb 09             	cmp    $0x9,%ebx
c0026748:	76 e9                	jbe    c0026733 <atoi+0x57>
  if (!negative)
c002674a:	89 f3                	mov    %esi,%ebx
c002674c:	84 db                	test   %bl,%bl
c002674e:	75 02                	jne    c0026752 <atoi+0x76>
    value = -value;
c0026750:	f7 d8                	neg    %eax
}
c0026752:	83 c4 04             	add    $0x4,%esp
c0026755:	5b                   	pop    %ebx
c0026756:	5e                   	pop    %esi
c0026757:	c3                   	ret    
    s++;
c0026758:	42                   	inc    %edx
c0026759:	eb c3                	jmp    c002671e <atoi+0x42>
      s++;
c002675b:	8d 42 01             	lea    0x1(%edx),%eax
  for (value = 0; isdigit (*s); s++)
c002675e:	0f be 4a 01          	movsbl 0x1(%edx),%ecx
c0026762:	8d 51 d0             	lea    -0x30(%ecx),%edx
c0026765:	83 fa 09             	cmp    $0x9,%edx
c0026768:	77 09                	ja     c0026773 <atoi+0x97>
      s++;
c002676a:	89 c2                	mov    %eax,%edx
      negative = true;
c002676c:	be 01 00 00 00       	mov    $0x1,%esi
c0026771:	eb bb                	jmp    c002672e <atoi+0x52>
  for (value = 0; isdigit (*s); s++)
c0026773:	b8 00 00 00 00       	mov    $0x0,%eax
  return value;
c0026778:	eb d8                	jmp    c0026752 <atoi+0x76>
  for (value = 0; isdigit (*s); s++)
c002677a:	b8 00 00 00 00       	mov    $0x0,%eax
c002677f:	eb cf                	jmp    c0026750 <atoi+0x74>

c0026781 <sort>:
   B.  Runs in O(n lg n) time and O(1) space in CNT. */
void
sort (void *array, size_t cnt, size_t size,
      int (*compare) (const void *, const void *, void *aux),
      void *aux) 
{
c0026781:	55                   	push   %ebp
c0026782:	57                   	push   %edi
c0026783:	56                   	push   %esi
c0026784:	53                   	push   %ebx
c0026785:	83 ec 0c             	sub    $0xc,%esp
c0026788:	8b 5c 24 24          	mov    0x24(%esp),%ebx
c002678c:	8b 7c 24 28          	mov    0x28(%esp),%edi
c0026790:	8b 6c 24 2c          	mov    0x2c(%esp),%ebp
c0026794:	8b 74 24 30          	mov    0x30(%esp),%esi
  size_t i;

  ASSERT (array != NULL || cnt == 0);
c0026798:	83 7c 24 20 00       	cmpl   $0x0,0x20(%esp)
c002679d:	74 7b                	je     c002681a <sort+0x99>
  ASSERT (compare != NULL);
c002679f:	85 ed                	test   %ebp,%ebp
c00267a1:	0f 84 98 00 00 00    	je     c002683f <sort+0xbe>
  ASSERT (size > 0);
c00267a7:	85 ff                	test   %edi,%edi
c00267a9:	0f 84 b1 00 00 00    	je     c0026860 <sort+0xdf>

  /* Build a heap. */
  for (i = cnt / 2; i > 0; i--)
c00267af:	89 d8                	mov    %ebx,%eax
c00267b1:	d1 e8                	shr    %eax
c00267b3:	74 25                	je     c00267da <sort+0x59>
c00267b5:	89 5c 24 24          	mov    %ebx,0x24(%esp)
c00267b9:	89 c3                	mov    %eax,%ebx
    heapify (array, i, cnt, size, compare, aux);
c00267bb:	83 ec 04             	sub    $0x4,%esp
c00267be:	56                   	push   %esi
c00267bf:	55                   	push   %ebp
c00267c0:	57                   	push   %edi
c00267c1:	8b 4c 24 34          	mov    0x34(%esp),%ecx
c00267c5:	89 da                	mov    %ebx,%edx
c00267c7:	8b 44 24 30          	mov    0x30(%esp),%eax
c00267cb:	e8 3e fe ff ff       	call   c002660e <heapify>
  for (i = cnt / 2; i > 0; i--)
c00267d0:	83 c4 10             	add    $0x10,%esp
c00267d3:	4b                   	dec    %ebx
c00267d4:	75 e5                	jne    c00267bb <sort+0x3a>
c00267d6:	8b 5c 24 24          	mov    0x24(%esp),%ebx

  /* Sort the heap. */
  for (i = cnt; i > 1; i--) 
c00267da:	83 fb 01             	cmp    $0x1,%ebx
c00267dd:	76 33                	jbe    c0026812 <sort+0x91>
    {
      do_swap (array, 1, i, size);
c00267df:	83 ec 0c             	sub    $0xc,%esp
c00267e2:	57                   	push   %edi
c00267e3:	89 d9                	mov    %ebx,%ecx
c00267e5:	ba 01 00 00 00       	mov    $0x1,%edx
c00267ea:	8b 44 24 30          	mov    0x30(%esp),%eax
c00267ee:	e8 e1 fd ff ff       	call   c00265d4 <do_swap>
      heapify (array, 1, i - 1, size, compare, aux); 
c00267f3:	4b                   	dec    %ebx
c00267f4:	83 c4 0c             	add    $0xc,%esp
c00267f7:	56                   	push   %esi
c00267f8:	55                   	push   %ebp
c00267f9:	57                   	push   %edi
c00267fa:	89 d9                	mov    %ebx,%ecx
c00267fc:	ba 01 00 00 00       	mov    $0x1,%edx
c0026801:	8b 44 24 30          	mov    0x30(%esp),%eax
c0026805:	e8 04 fe ff ff       	call   c002660e <heapify>
  for (i = cnt; i > 1; i--) 
c002680a:	83 c4 10             	add    $0x10,%esp
c002680d:	83 fb 01             	cmp    $0x1,%ebx
c0026810:	75 cd                	jne    c00267df <sort+0x5e>
    }
}
c0026812:	83 c4 0c             	add    $0xc,%esp
c0026815:	5b                   	pop    %ebx
c0026816:	5e                   	pop    %esi
c0026817:	5f                   	pop    %edi
c0026818:	5d                   	pop    %ebp
c0026819:	c3                   	ret    
  ASSERT (array != NULL || cnt == 0);
c002681a:	85 db                	test   %ebx,%ebx
c002681c:	74 81                	je     c002679f <sort+0x1e>
c002681e:	83 ec 0c             	sub    $0xc,%esp
c0026821:	68 6f e3 02 c0       	push   $0xc002e36f
c0026826:	68 df cb 02 c0       	push   $0xc002cbdf
c002682b:	68 90 c6 02 c0       	push   $0xc002c690
c0026830:	68 8a 00 00 00       	push   $0x8a
c0026835:	68 5c e3 02 c0       	push   $0xc002e35c
c002683a:	e8 01 0e 00 00       	call   c0027640 <debug_panic>
  ASSERT (compare != NULL);
c002683f:	83 ec 0c             	sub    $0xc,%esp
c0026842:	68 89 e3 02 c0       	push   $0xc002e389
c0026847:	68 df cb 02 c0       	push   $0xc002cbdf
c002684c:	68 90 c6 02 c0       	push   $0xc002c690
c0026851:	68 8b 00 00 00       	push   $0x8b
c0026856:	68 5c e3 02 c0       	push   $0xc002e35c
c002685b:	e8 e0 0d 00 00       	call   c0027640 <debug_panic>
  ASSERT (size > 0);
c0026860:	83 ec 0c             	sub    $0xc,%esp
c0026863:	68 99 e3 02 c0       	push   $0xc002e399
c0026868:	68 df cb 02 c0       	push   $0xc002cbdf
c002686d:	68 90 c6 02 c0       	push   $0xc002c690
c0026872:	68 8c 00 00 00       	push   $0x8c
c0026877:	68 5c e3 02 c0       	push   $0xc002e35c
c002687c:	e8 bf 0d 00 00       	call   c0027640 <debug_panic>

c0026881 <qsort>:
{
c0026881:	83 ec 18             	sub    $0x18,%esp
  sort (array, cnt, size, compare_thunk, &compare);
c0026884:	8d 44 24 28          	lea    0x28(%esp),%eax
c0026888:	50                   	push   %eax
c0026889:	68 bf 65 02 c0       	push   $0xc00265bf
c002688e:	ff 74 24 2c          	pushl  0x2c(%esp)
c0026892:	ff 74 24 2c          	pushl  0x2c(%esp)
c0026896:	ff 74 24 2c          	pushl  0x2c(%esp)
c002689a:	e8 e2 fe ff ff       	call   c0026781 <sort>
}
c002689f:	83 c4 2c             	add    $0x2c,%esp
c00268a2:	c3                   	ret    

c00268a3 <binary_search>:
   B. */
void *
binary_search (const void *key, const void *array, size_t cnt, size_t size,
               int (*compare) (const void *, const void *, void *aux),
               void *aux) 
{
c00268a3:	55                   	push   %ebp
c00268a4:	57                   	push   %edi
c00268a5:	56                   	push   %esi
c00268a6:	53                   	push   %ebx
c00268a7:	83 ec 0c             	sub    $0xc,%esp
c00268aa:	8b 74 24 24          	mov    0x24(%esp),%esi
c00268ae:	8b 7c 24 2c          	mov    0x2c(%esp),%edi
  const unsigned char *first = array;
  const unsigned char *last = array + size * cnt;
c00268b2:	89 fd                	mov    %edi,%ebp
c00268b4:	0f af 6c 24 28       	imul   0x28(%esp),%ebp
c00268b9:	01 f5                	add    %esi,%ebp

  while (first < last) 
c00268bb:	39 ee                	cmp    %ebp,%esi
c00268bd:	72 0d                	jb     c00268cc <binary_search+0x29>
        first = middle + size;
      else
        return (void *) middle;
    }
  
  return NULL;
c00268bf:	b8 00 00 00 00       	mov    $0x0,%eax
c00268c4:	eb 3e                	jmp    c0026904 <binary_search+0x61>
      const unsigned char *middle = first + (range / 2) * size;
c00268c6:	89 dd                	mov    %ebx,%ebp
  while (first < last) 
c00268c8:	39 ee                	cmp    %ebp,%esi
c00268ca:	73 33                	jae    c00268ff <binary_search+0x5c>
      size_t range = (last - first) / size;
c00268cc:	89 e8                	mov    %ebp,%eax
c00268ce:	29 f0                	sub    %esi,%eax
c00268d0:	ba 00 00 00 00       	mov    $0x0,%edx
c00268d5:	f7 f7                	div    %edi
      const unsigned char *middle = first + (range / 2) * size;
c00268d7:	d1 e8                	shr    %eax
c00268d9:	0f af c7             	imul   %edi,%eax
c00268dc:	8d 1c 06             	lea    (%esi,%eax,1),%ebx
      int cmp = compare (key, middle, aux);
c00268df:	83 ec 04             	sub    $0x4,%esp
c00268e2:	ff 74 24 38          	pushl  0x38(%esp)
c00268e6:	53                   	push   %ebx
c00268e7:	ff 74 24 2c          	pushl  0x2c(%esp)
c00268eb:	ff 54 24 40          	call   *0x40(%esp)
      if (cmp < 0) 
c00268ef:	83 c4 10             	add    $0x10,%esp
c00268f2:	85 c0                	test   %eax,%eax
c00268f4:	78 d0                	js     c00268c6 <binary_search+0x23>
      else if (cmp > 0) 
c00268f6:	85 c0                	test   %eax,%eax
c00268f8:	7e 12                	jle    c002690c <binary_search+0x69>
        first = middle + size;
c00268fa:	8d 34 3b             	lea    (%ebx,%edi,1),%esi
c00268fd:	eb c9                	jmp    c00268c8 <binary_search+0x25>
  return NULL;
c00268ff:	b8 00 00 00 00       	mov    $0x0,%eax
}
c0026904:	83 c4 0c             	add    $0xc,%esp
c0026907:	5b                   	pop    %ebx
c0026908:	5e                   	pop    %esi
c0026909:	5f                   	pop    %edi
c002690a:	5d                   	pop    %ebp
c002690b:	c3                   	ret    
      const unsigned char *middle = first + (range / 2) * size;
c002690c:	89 d8                	mov    %ebx,%eax
c002690e:	eb f4                	jmp    c0026904 <binary_search+0x61>

c0026910 <bsearch>:
{
c0026910:	83 ec 14             	sub    $0x14,%esp
  return binary_search (key, array, cnt, size, compare_thunk, &compare);
c0026913:	8d 44 24 28          	lea    0x28(%esp),%eax
c0026917:	50                   	push   %eax
c0026918:	68 bf 65 02 c0       	push   $0xc00265bf
c002691d:	ff 74 24 2c          	pushl  0x2c(%esp)
c0026921:	ff 74 24 2c          	pushl  0x2c(%esp)
c0026925:	ff 74 24 2c          	pushl  0x2c(%esp)
c0026929:	ff 74 24 2c          	pushl  0x2c(%esp)
c002692d:	e8 71 ff ff ff       	call   c00268a3 <binary_search>
}
c0026932:	83 c4 2c             	add    $0x2c,%esp
c0026935:	c3                   	ret    

c0026936 <memcpy>:

/* Copies SIZE bytes from SRC to DST, which must not overlap.
   Returns DST. */
void *
memcpy (void *dst_, const void *src_, size_t size) 
{
c0026936:	56                   	push   %esi
c0026937:	53                   	push   %ebx
c0026938:	8b 44 24 0c          	mov    0xc(%esp),%eax
c002693c:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0026940:	8b 74 24 14          	mov    0x14(%esp),%esi
  const unsigned char *src = src_;

  ASSERT (dst != NULL || size == 0);
  ASSERT (src != NULL || size == 0);

  while (size-- > 0)
c0026944:	85 f6                	test   %esi,%esi
c0026946:	74 10                	je     c0026958 <memcpy+0x22>
c0026948:	ba 00 00 00 00       	mov    $0x0,%edx
    *dst++ = *src++;
c002694d:	8a 0c 13             	mov    (%ebx,%edx,1),%cl
c0026950:	88 0c 10             	mov    %cl,(%eax,%edx,1)
c0026953:	42                   	inc    %edx
  while (size-- > 0)
c0026954:	39 f2                	cmp    %esi,%edx
c0026956:	75 f5                	jne    c002694d <memcpy+0x17>

  return dst_;
}
c0026958:	5b                   	pop    %ebx
c0026959:	5e                   	pop    %esi
c002695a:	c3                   	ret    

c002695b <memmove>:

/* Copies SIZE bytes from SRC to DST, which are allowed to
   overlap.  Returns DST. */
void *
memmove (void *dst_, const void *src_, size_t size) 
{
c002695b:	57                   	push   %edi
c002695c:	56                   	push   %esi
c002695d:	53                   	push   %ebx
c002695e:	8b 4c 24 10          	mov    0x10(%esp),%ecx
c0026962:	8b 5c 24 14          	mov    0x14(%esp),%ebx
c0026966:	8b 74 24 18          	mov    0x18(%esp),%esi
  const unsigned char *src = src_;

  ASSERT (dst != NULL || size == 0);
  ASSERT (src != NULL || size == 0);

  if (dst < src) 
c002696a:	39 d9                	cmp    %ebx,%ecx
c002696c:	73 1d                	jae    c002698b <memmove+0x30>
    {
      while (size-- > 0)
c002696e:	85 f6                	test   %esi,%esi
c0026970:	74 35                	je     c00269a7 <memmove+0x4c>
c0026972:	b8 00 00 00 00       	mov    $0x0,%eax
        *dst++ = *src++;
c0026977:	8a 14 03             	mov    (%ebx,%eax,1),%dl
c002697a:	88 14 01             	mov    %dl,(%ecx,%eax,1)
c002697d:	40                   	inc    %eax
      while (size-- > 0)
c002697e:	39 f0                	cmp    %esi,%eax
c0026980:	75 f5                	jne    c0026977 <memmove+0x1c>
c0026982:	8d 3c 08             	lea    (%eax,%ecx,1),%edi
      while (size-- > 0)
        *--dst = *--src;
    }

  return dst;
}
c0026985:	89 f8                	mov    %edi,%eax
c0026987:	5b                   	pop    %ebx
c0026988:	5e                   	pop    %esi
c0026989:	5f                   	pop    %edi
c002698a:	c3                   	ret    
      dst += size;
c002698b:	8d 3c 31             	lea    (%ecx,%esi,1),%edi
      while (size-- > 0)
c002698e:	8d 56 ff             	lea    -0x1(%esi),%edx
c0026991:	85 f6                	test   %esi,%esi
c0026993:	74 f0                	je     c0026985 <memmove+0x2a>
c0026995:	89 ce                	mov    %ecx,%esi
c0026997:	89 f7                	mov    %esi,%edi
        *--dst = *--src;
c0026999:	8a 04 13             	mov    (%ebx,%edx,1),%al
c002699c:	88 04 11             	mov    %al,(%ecx,%edx,1)
      while (size-- > 0)
c002699f:	4a                   	dec    %edx
c00269a0:	83 fa ff             	cmp    $0xffffffff,%edx
c00269a3:	75 f2                	jne    c0026997 <memmove+0x3c>
c00269a5:	eb de                	jmp    c0026985 <memmove+0x2a>
      while (size-- > 0)
c00269a7:	89 cf                	mov    %ecx,%edi
c00269a9:	eb da                	jmp    c0026985 <memmove+0x2a>

c00269ab <memcmp>:
   at A and B.  Returns a positive value if the byte in A is
   greater, a negative value if the byte in B is greater, or zero
   if blocks A and B are equal. */
int
memcmp (const void *a_, const void *b_, size_t size) 
{
c00269ab:	57                   	push   %edi
c00269ac:	56                   	push   %esi
c00269ad:	53                   	push   %ebx
c00269ae:	8b 74 24 10          	mov    0x10(%esp),%esi
c00269b2:	8b 7c 24 14          	mov    0x14(%esp),%edi
c00269b6:	8b 5c 24 18          	mov    0x18(%esp),%ebx
  const unsigned char *b = b_;

  ASSERT (a != NULL || size == 0);
  ASSERT (b != NULL || size == 0);

  for (; size-- > 0; a++, b++)
c00269ba:	85 db                	test   %ebx,%ebx
c00269bc:	74 30                	je     c00269ee <memcmp+0x43>
    if (*a != *b)
c00269be:	8a 16                	mov    (%esi),%dl
c00269c0:	8a 0f                	mov    (%edi),%cl
c00269c2:	38 ca                	cmp    %cl,%dl
c00269c4:	75 15                	jne    c00269db <memcmp+0x30>
c00269c6:	b8 01 00 00 00       	mov    $0x1,%eax
  for (; size-- > 0; a++, b++)
c00269cb:	39 d8                	cmp    %ebx,%eax
c00269cd:	74 18                	je     c00269e7 <memcmp+0x3c>
    if (*a != *b)
c00269cf:	8a 14 06             	mov    (%esi,%eax,1),%dl
c00269d2:	40                   	inc    %eax
c00269d3:	8a 4c 07 ff          	mov    -0x1(%edi,%eax,1),%cl
c00269d7:	38 ca                	cmp    %cl,%dl
c00269d9:	74 f0                	je     c00269cb <memcmp+0x20>
      return *a > *b ? +1 : -1;
c00269db:	38 d1                	cmp    %dl,%cl
c00269dd:	19 c0                	sbb    %eax,%eax
c00269df:	83 e0 02             	and    $0x2,%eax
c00269e2:	48                   	dec    %eax
  return 0;
}
c00269e3:	5b                   	pop    %ebx
c00269e4:	5e                   	pop    %esi
c00269e5:	5f                   	pop    %edi
c00269e6:	c3                   	ret    
  return 0;
c00269e7:	b8 00 00 00 00       	mov    $0x0,%eax
c00269ec:	eb f5                	jmp    c00269e3 <memcmp+0x38>
c00269ee:	b8 00 00 00 00       	mov    $0x0,%eax
c00269f3:	eb ee                	jmp    c00269e3 <memcmp+0x38>

c00269f5 <strcmp>:
   char) is greater, a negative value if the character in B (as
   an unsigned char) is greater, or zero if strings A and B are
   equal. */
int
strcmp (const char *a_, const char *b_) 
{
c00269f5:	8b 4c 24 04          	mov    0x4(%esp),%ecx
c00269f9:	8b 44 24 08          	mov    0x8(%esp),%eax
  const unsigned char *b = (const unsigned char *) b_;

  ASSERT (a != NULL);
  ASSERT (b != NULL);

  while (*a != '\0' && *a == *b) 
c00269fd:	8a 11                	mov    (%ecx),%dl
c00269ff:	84 d2                	test   %dl,%dl
c0026a01:	74 10                	je     c0026a13 <strcmp+0x1e>
c0026a03:	3a 10                	cmp    (%eax),%dl
c0026a05:	75 0c                	jne    c0026a13 <strcmp+0x1e>
    {
      a++;
c0026a07:	41                   	inc    %ecx
      b++;
c0026a08:	40                   	inc    %eax
  while (*a != '\0' && *a == *b) 
c0026a09:	8a 11                	mov    (%ecx),%dl
c0026a0b:	84 d2                	test   %dl,%dl
c0026a0d:	74 04                	je     c0026a13 <strcmp+0x1e>
c0026a0f:	3a 10                	cmp    (%eax),%dl
c0026a11:	74 f4                	je     c0026a07 <strcmp+0x12>
    }

  return *a < *b ? -1 : *a > *b;
c0026a13:	8a 00                	mov    (%eax),%al
c0026a15:	38 d0                	cmp    %dl,%al
c0026a17:	77 07                	ja     c0026a20 <strcmp+0x2b>
c0026a19:	0f 92 c0             	setb   %al
c0026a1c:	0f b6 c0             	movzbl %al,%eax
c0026a1f:	c3                   	ret    
c0026a20:	b8 ff ff ff ff       	mov    $0xffffffff,%eax
}
c0026a25:	c3                   	ret    

c0026a26 <memchr>:
/* Returns a pointer to the first occurrence of CH in the first
   SIZE bytes starting at BLOCK.  Returns a null pointer if CH
   does not occur in BLOCK. */
void *
memchr (const void *block_, int ch_, size_t size) 
{
c0026a26:	53                   	push   %ebx
c0026a27:	8b 44 24 08          	mov    0x8(%esp),%eax
c0026a2b:	8b 5c 24 0c          	mov    0xc(%esp),%ebx
c0026a2f:	8b 54 24 10          	mov    0x10(%esp),%edx
  const unsigned char *block = block_;
  unsigned char ch = ch_;

  ASSERT (block != NULL || size == 0);

  for (; size-- > 0; block++)
c0026a33:	85 d2                	test   %edx,%edx
c0026a35:	74 1a                	je     c0026a51 <memchr+0x2b>
c0026a37:	88 d9                	mov    %bl,%cl
    if (*block == ch)
c0026a39:	3a 18                	cmp    (%eax),%bl
c0026a3b:	74 12                	je     c0026a4f <memchr+0x29>
c0026a3d:	01 c2                	add    %eax,%edx
  for (; size-- > 0; block++)
c0026a3f:	40                   	inc    %eax
c0026a40:	39 c2                	cmp    %eax,%edx
c0026a42:	74 06                	je     c0026a4a <memchr+0x24>
    if (*block == ch)
c0026a44:	3a 08                	cmp    (%eax),%cl
c0026a46:	75 f7                	jne    c0026a3f <memchr+0x19>
c0026a48:	eb 05                	jmp    c0026a4f <memchr+0x29>
      return (void *) block;

  return NULL;
c0026a4a:	b8 00 00 00 00       	mov    $0x0,%eax
}
c0026a4f:	5b                   	pop    %ebx
c0026a50:	c3                   	ret    
  return NULL;
c0026a51:	b8 00 00 00 00       	mov    $0x0,%eax
c0026a56:	eb f7                	jmp    c0026a4f <memchr+0x29>

c0026a58 <strchr>:
   null pointer if C does not appear in STRING.  If C == '\0'
   then returns a pointer to the null terminator at the end of
   STRING. */
char *
strchr (const char *string, int c_) 
{
c0026a58:	53                   	push   %ebx
c0026a59:	8b 44 24 08          	mov    0x8(%esp),%eax
c0026a5d:	8b 54 24 0c          	mov    0xc(%esp),%edx
  char c = c_;

  ASSERT (string != NULL);

  for (;;) 
    if (*string == c)
c0026a61:	8a 18                	mov    (%eax),%bl
c0026a63:	38 da                	cmp    %bl,%dl
c0026a65:	74 16                	je     c0026a7d <strchr+0x25>
c0026a67:	88 d1                	mov    %dl,%cl
      return (char *) string;
    else if (*string == '\0')
c0026a69:	84 db                	test   %bl,%bl
c0026a6b:	74 12                	je     c0026a7f <strchr+0x27>
      return NULL;
    else
      string++;
c0026a6d:	40                   	inc    %eax
    if (*string == c)
c0026a6e:	8a 10                	mov    (%eax),%dl
c0026a70:	38 d1                	cmp    %dl,%cl
c0026a72:	74 09                	je     c0026a7d <strchr+0x25>
    else if (*string == '\0')
c0026a74:	84 d2                	test   %dl,%dl
c0026a76:	75 f5                	jne    c0026a6d <strchr+0x15>
      return NULL;
c0026a78:	b8 00 00 00 00       	mov    $0x0,%eax
}
c0026a7d:	5b                   	pop    %ebx
c0026a7e:	c3                   	ret    
      return NULL;
c0026a7f:	b8 00 00 00 00       	mov    $0x0,%eax
c0026a84:	eb f7                	jmp    c0026a7d <strchr+0x25>

c0026a86 <strcspn>:

/* Returns the length of the initial substring of STRING that
   consists of characters that are not in STOP. */
size_t
strcspn (const char *string, const char *stop) 
{
c0026a86:	57                   	push   %edi
c0026a87:	56                   	push   %esi
c0026a88:	53                   	push   %ebx
c0026a89:	8b 74 24 10          	mov    0x10(%esp),%esi
c0026a8d:	8b 7c 24 14          	mov    0x14(%esp),%edi
  size_t length;

  for (length = 0; string[length] != '\0'; length++)
c0026a91:	8a 06                	mov    (%esi),%al
c0026a93:	84 c0                	test   %al,%al
c0026a95:	74 24                	je     c0026abb <strcspn+0x35>
c0026a97:	bb 00 00 00 00       	mov    $0x0,%ebx
    if (strchr (stop, string[length]) != NULL)
c0026a9c:	0f be c0             	movsbl %al,%eax
c0026a9f:	50                   	push   %eax
c0026aa0:	57                   	push   %edi
c0026aa1:	e8 b2 ff ff ff       	call   c0026a58 <strchr>
c0026aa6:	83 c4 08             	add    $0x8,%esp
c0026aa9:	85 c0                	test   %eax,%eax
c0026aab:	75 08                	jne    c0026ab5 <strcspn+0x2f>
  for (length = 0; string[length] != '\0'; length++)
c0026aad:	43                   	inc    %ebx
c0026aae:	8a 04 1e             	mov    (%esi,%ebx,1),%al
c0026ab1:	84 c0                	test   %al,%al
c0026ab3:	75 e7                	jne    c0026a9c <strcspn+0x16>
      break;
  return length;
}
c0026ab5:	89 d8                	mov    %ebx,%eax
c0026ab7:	5b                   	pop    %ebx
c0026ab8:	5e                   	pop    %esi
c0026ab9:	5f                   	pop    %edi
c0026aba:	c3                   	ret    
  for (length = 0; string[length] != '\0'; length++)
c0026abb:	bb 00 00 00 00       	mov    $0x0,%ebx
  return length;
c0026ac0:	eb f3                	jmp    c0026ab5 <strcspn+0x2f>

c0026ac2 <strpbrk>:
/* Returns a pointer to the first character in STRING that is
   also in STOP.  If no character in STRING is in STOP, returns a
   null pointer. */
char *
strpbrk (const char *string, const char *stop) 
{
c0026ac2:	56                   	push   %esi
c0026ac3:	53                   	push   %ebx
c0026ac4:	8b 5c 24 0c          	mov    0xc(%esp),%ebx
c0026ac8:	8b 74 24 10          	mov    0x10(%esp),%esi
  for (; *string != '\0'; string++)
c0026acc:	8a 13                	mov    (%ebx),%dl
c0026ace:	84 d2                	test   %dl,%dl
c0026ad0:	74 1a                	je     c0026aec <strpbrk+0x2a>
    if (strchr (stop, *string) != NULL)
c0026ad2:	0f be d2             	movsbl %dl,%edx
c0026ad5:	52                   	push   %edx
c0026ad6:	56                   	push   %esi
c0026ad7:	e8 7c ff ff ff       	call   c0026a58 <strchr>
c0026adc:	83 c4 08             	add    $0x8,%esp
c0026adf:	85 c0                	test   %eax,%eax
c0026ae1:	75 10                	jne    c0026af3 <strpbrk+0x31>
  for (; *string != '\0'; string++)
c0026ae3:	43                   	inc    %ebx
c0026ae4:	8a 13                	mov    (%ebx),%dl
c0026ae6:	84 d2                	test   %dl,%dl
c0026ae8:	75 e8                	jne    c0026ad2 <strpbrk+0x10>
c0026aea:	eb 09                	jmp    c0026af5 <strpbrk+0x33>
      return (char *) string;
  return NULL;
c0026aec:	b8 00 00 00 00       	mov    $0x0,%eax
c0026af1:	eb 02                	jmp    c0026af5 <strpbrk+0x33>
c0026af3:	89 d8                	mov    %ebx,%eax
}
c0026af5:	5b                   	pop    %ebx
c0026af6:	5e                   	pop    %esi
c0026af7:	c3                   	ret    

c0026af8 <strrchr>:

/* Returns a pointer to the last occurrence of C in STRING.
   Returns a null pointer if C does not occur in STRING. */
char *
strrchr (const char *string, int c_) 
{
c0026af8:	53                   	push   %ebx
c0026af9:	8b 54 24 08          	mov    0x8(%esp),%edx
  char c = c_;
c0026afd:	8a 5c 24 0c          	mov    0xc(%esp),%bl
  const char *p = NULL;

  for (; *string != '\0'; string++)
c0026b01:	8a 0a                	mov    (%edx),%cl
c0026b03:	84 c9                	test   %cl,%cl
c0026b05:	74 16                	je     c0026b1d <strrchr+0x25>
c0026b07:	b8 00 00 00 00       	mov    $0x0,%eax
c0026b0c:	eb 07                	jmp    c0026b15 <strrchr+0x1d>
c0026b0e:	42                   	inc    %edx
c0026b0f:	8a 0a                	mov    (%edx),%cl
c0026b11:	84 c9                	test   %cl,%cl
c0026b13:	74 0d                	je     c0026b22 <strrchr+0x2a>
    if (*string == c)
c0026b15:	38 cb                	cmp    %cl,%bl
c0026b17:	75 f5                	jne    c0026b0e <strrchr+0x16>
c0026b19:	89 d0                	mov    %edx,%eax
c0026b1b:	eb f1                	jmp    c0026b0e <strrchr+0x16>
  const char *p = NULL;
c0026b1d:	b8 00 00 00 00       	mov    $0x0,%eax
      p = string;
  return (char *) p;
}
c0026b22:	5b                   	pop    %ebx
c0026b23:	c3                   	ret    

c0026b24 <strspn>:

/* Returns the length of the initial substring of STRING that
   consists of characters in SKIP. */
size_t
strspn (const char *string, const char *skip) 
{
c0026b24:	57                   	push   %edi
c0026b25:	56                   	push   %esi
c0026b26:	53                   	push   %ebx
c0026b27:	8b 74 24 10          	mov    0x10(%esp),%esi
c0026b2b:	8b 7c 24 14          	mov    0x14(%esp),%edi
  size_t length;
  
  for (length = 0; string[length] != '\0'; length++)
c0026b2f:	8a 06                	mov    (%esi),%al
c0026b31:	84 c0                	test   %al,%al
c0026b33:	74 24                	je     c0026b59 <strspn+0x35>
c0026b35:	bb 00 00 00 00       	mov    $0x0,%ebx
    if (strchr (skip, string[length]) == NULL)
c0026b3a:	0f be c0             	movsbl %al,%eax
c0026b3d:	50                   	push   %eax
c0026b3e:	57                   	push   %edi
c0026b3f:	e8 14 ff ff ff       	call   c0026a58 <strchr>
c0026b44:	83 c4 08             	add    $0x8,%esp
c0026b47:	85 c0                	test   %eax,%eax
c0026b49:	74 08                	je     c0026b53 <strspn+0x2f>
  for (length = 0; string[length] != '\0'; length++)
c0026b4b:	43                   	inc    %ebx
c0026b4c:	8a 04 1e             	mov    (%esi,%ebx,1),%al
c0026b4f:	84 c0                	test   %al,%al
c0026b51:	75 e7                	jne    c0026b3a <strspn+0x16>
      break;
  return length;
}
c0026b53:	89 d8                	mov    %ebx,%eax
c0026b55:	5b                   	pop    %ebx
c0026b56:	5e                   	pop    %esi
c0026b57:	5f                   	pop    %edi
c0026b58:	c3                   	ret    
  for (length = 0; string[length] != '\0'; length++)
c0026b59:	bb 00 00 00 00       	mov    $0x0,%ebx
  return length;
c0026b5e:	eb f3                	jmp    c0026b53 <strspn+0x2f>

c0026b60 <strtok_r>:
     'to'
     'tokenize.'
*/
char *
strtok_r (char *s, const char *delimiters, char **save_ptr) 
{
c0026b60:	55                   	push   %ebp
c0026b61:	57                   	push   %edi
c0026b62:	56                   	push   %esi
c0026b63:	53                   	push   %ebx
c0026b64:	83 ec 1c             	sub    $0x1c,%esp
c0026b67:	8b 74 24 30          	mov    0x30(%esp),%esi
c0026b6b:	8b 7c 24 34          	mov    0x34(%esp),%edi
  char *token;
  
  ASSERT (delimiters != NULL);
c0026b6f:	85 ff                	test   %edi,%edi
c0026b71:	74 2c                	je     c0026b9f <strtok_r+0x3f>
  ASSERT (save_ptr != NULL);
c0026b73:	83 7c 24 38 00       	cmpl   $0x0,0x38(%esp)
c0026b78:	74 46                	je     c0026bc0 <strtok_r+0x60>

  /* If S is nonnull, start from it.
     If S is null, start from saved position. */
  if (s == NULL)
c0026b7a:	85 f6                	test   %esi,%esi
c0026b7c:	74 63                	je     c0026be1 <strtok_r+0x81>
    s = *save_ptr;
  ASSERT (s != NULL);

  /* Skip any DELIMITERS at our current position. */
  while (strchr (delimiters, *s) != NULL) 
c0026b7e:	8a 1e                	mov    (%esi),%bl
c0026b80:	83 ec 08             	sub    $0x8,%esp
c0026b83:	0f be c3             	movsbl %bl,%eax
c0026b86:	50                   	push   %eax
c0026b87:	57                   	push   %edi
c0026b88:	e8 cb fe ff ff       	call   c0026a58 <strchr>
c0026b8d:	83 c4 10             	add    $0x10,%esp
c0026b90:	85 c0                	test   %eax,%eax
c0026b92:	0f 84 87 00 00 00    	je     c0026c1f <strtok_r+0xbf>
    {
      /* strchr() will always return nonnull if we're searching
         for a null byte, because every string contains a null
         byte (at the end). */
      if (*s == '\0')
c0026b98:	84 db                	test   %bl,%bl
c0026b9a:	74 70                	je     c0026c0c <strtok_r+0xac>
        {
          *save_ptr = s;
          return NULL;
        }

      s++;
c0026b9c:	46                   	inc    %esi
c0026b9d:	eb df                	jmp    c0026b7e <strtok_r+0x1e>
  ASSERT (delimiters != NULL);
c0026b9f:	83 ec 0c             	sub    $0xc,%esp
c0026ba2:	68 a2 e3 02 c0       	push   $0xc002e3a2
c0026ba7:	68 df cb 02 c0       	push   $0xc002cbdf
c0026bac:	68 b0 c6 02 c0       	push   $0xc002c6b0
c0026bb1:	68 ef 00 00 00       	push   $0xef
c0026bb6:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026bbb:	e8 80 0a 00 00       	call   c0027640 <debug_panic>
  ASSERT (save_ptr != NULL);
c0026bc0:	83 ec 0c             	sub    $0xc,%esp
c0026bc3:	68 c8 e3 02 c0       	push   $0xc002e3c8
c0026bc8:	68 df cb 02 c0       	push   $0xc002cbdf
c0026bcd:	68 b0 c6 02 c0       	push   $0xc002c6b0
c0026bd2:	68 f0 00 00 00       	push   $0xf0
c0026bd7:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026bdc:	e8 5f 0a 00 00       	call   c0027640 <debug_panic>
    s = *save_ptr;
c0026be1:	8b 44 24 38          	mov    0x38(%esp),%eax
c0026be5:	8b 30                	mov    (%eax),%esi
  ASSERT (s != NULL);
c0026be7:	85 f6                	test   %esi,%esi
c0026be9:	75 93                	jne    c0026b7e <strtok_r+0x1e>
c0026beb:	83 ec 0c             	sub    $0xc,%esp
c0026bee:	68 ab e3 02 c0       	push   $0xc002e3ab
c0026bf3:	68 df cb 02 c0       	push   $0xc002cbdf
c0026bf8:	68 b0 c6 02 c0       	push   $0xc002c6b0
c0026bfd:	68 f6 00 00 00       	push   $0xf6
c0026c02:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026c07:	e8 34 0a 00 00       	call   c0027640 <debug_panic>
          *save_ptr = s;
c0026c0c:	8b 44 24 38          	mov    0x38(%esp),%eax
c0026c10:	89 30                	mov    %esi,(%eax)
          return NULL;
c0026c12:	b8 00 00 00 00       	mov    $0x0,%eax
      *save_ptr = s + 1;
    }
  else 
    *save_ptr = s;
  return token;
}
c0026c17:	83 c4 1c             	add    $0x1c,%esp
c0026c1a:	5b                   	pop    %ebx
c0026c1b:	5e                   	pop    %esi
c0026c1c:	5f                   	pop    %edi
c0026c1d:	5d                   	pop    %ebp
c0026c1e:	c3                   	ret    
c0026c1f:	89 f5                	mov    %esi,%ebp
c0026c21:	eb 04                	jmp    c0026c27 <strtok_r+0xc7>
    s++;
c0026c23:	8b 6c 24 0c          	mov    0xc(%esp),%ebp
c0026c27:	8d 45 01             	lea    0x1(%ebp),%eax
c0026c2a:	89 44 24 0c          	mov    %eax,0xc(%esp)
  while (strchr (delimiters, *s) == NULL)
c0026c2e:	8a 5d 01             	mov    0x1(%ebp),%bl
c0026c31:	83 ec 08             	sub    $0x8,%esp
c0026c34:	0f be c3             	movsbl %bl,%eax
c0026c37:	50                   	push   %eax
c0026c38:	57                   	push   %edi
c0026c39:	e8 1a fe ff ff       	call   c0026a58 <strchr>
c0026c3e:	83 c4 10             	add    $0x10,%esp
c0026c41:	85 c0                	test   %eax,%eax
c0026c43:	74 de                	je     c0026c23 <strtok_r+0xc3>
  if (*s != '\0') 
c0026c45:	84 db                	test   %bl,%bl
c0026c47:	75 0e                	jne    c0026c57 <strtok_r+0xf7>
    *save_ptr = s;
c0026c49:	8b 44 24 38          	mov    0x38(%esp),%eax
c0026c4d:	8b 54 24 0c          	mov    0xc(%esp),%edx
c0026c51:	89 10                	mov    %edx,(%eax)
c0026c53:	89 f0                	mov    %esi,%eax
c0026c55:	eb c0                	jmp    c0026c17 <strtok_r+0xb7>
      *s = '\0';
c0026c57:	8b 44 24 0c          	mov    0xc(%esp),%eax
c0026c5b:	c6 00 00             	movb   $0x0,(%eax)
      *save_ptr = s + 1;
c0026c5e:	83 c5 02             	add    $0x2,%ebp
c0026c61:	8b 44 24 38          	mov    0x38(%esp),%eax
c0026c65:	89 28                	mov    %ebp,(%eax)
c0026c67:	89 f0                	mov    %esi,%eax
c0026c69:	eb ac                	jmp    c0026c17 <strtok_r+0xb7>

c0026c6b <memset>:

/* Sets the SIZE bytes in DST to VALUE. */
void *
memset (void *dst_, int value, size_t size) 
{
c0026c6b:	53                   	push   %ebx
c0026c6c:	8b 44 24 08          	mov    0x8(%esp),%eax
c0026c70:	8b 5c 24 0c          	mov    0xc(%esp),%ebx
c0026c74:	8b 4c 24 10          	mov    0x10(%esp),%ecx
  unsigned char *dst = dst_;

  ASSERT (dst != NULL || size == 0);
  
  while (size-- > 0)
c0026c78:	85 c9                	test   %ecx,%ecx
c0026c7a:	74 0c                	je     c0026c88 <memset+0x1d>
c0026c7c:	01 c1                	add    %eax,%ecx
c0026c7e:	89 c2                	mov    %eax,%edx
    *dst++ = value;
c0026c80:	42                   	inc    %edx
c0026c81:	88 5a ff             	mov    %bl,-0x1(%edx)
  while (size-- > 0)
c0026c84:	39 d1                	cmp    %edx,%ecx
c0026c86:	75 f8                	jne    c0026c80 <memset+0x15>

  return dst_;
}
c0026c88:	5b                   	pop    %ebx
c0026c89:	c3                   	ret    

c0026c8a <strlen>:

/* Returns the length of STRING. */
size_t
strlen (const char *string) 
{
c0026c8a:	8b 54 24 04          	mov    0x4(%esp),%edx
  const char *p;

  ASSERT (string != NULL);

  for (p = string; *p != '\0'; p++)
c0026c8e:	80 3a 00             	cmpb   $0x0,(%edx)
c0026c91:	74 0b                	je     c0026c9e <strlen+0x14>
c0026c93:	89 d0                	mov    %edx,%eax
c0026c95:	40                   	inc    %eax
c0026c96:	80 38 00             	cmpb   $0x0,(%eax)
c0026c99:	75 fa                	jne    c0026c95 <strlen+0xb>
    continue;
  return p - string;
c0026c9b:	29 d0                	sub    %edx,%eax
}
c0026c9d:	c3                   	ret    
  for (p = string; *p != '\0'; p++)
c0026c9e:	89 d0                	mov    %edx,%eax
c0026ca0:	eb f9                	jmp    c0026c9b <strlen+0x11>

c0026ca2 <strstr>:
{
c0026ca2:	55                   	push   %ebp
c0026ca3:	57                   	push   %edi
c0026ca4:	56                   	push   %esi
c0026ca5:	53                   	push   %ebx
c0026ca6:	83 ec 04             	sub    $0x4,%esp
c0026ca9:	8b 6c 24 1c          	mov    0x1c(%esp),%ebp
  size_t haystack_len = strlen (haystack);
c0026cad:	bb ff ff ff ff       	mov    $0xffffffff,%ebx
c0026cb2:	b0 00                	mov    $0x0,%al
c0026cb4:	89 d9                	mov    %ebx,%ecx
c0026cb6:	8b 7c 24 18          	mov    0x18(%esp),%edi
c0026cba:	f2 ae                	repnz scas %es:(%edi),%al
c0026cbc:	f7 d1                	not    %ecx
c0026cbe:	8d 51 ff             	lea    -0x1(%ecx),%edx
  size_t needle_len = strlen (needle);
c0026cc1:	89 d9                	mov    %ebx,%ecx
c0026cc3:	89 ef                	mov    %ebp,%edi
c0026cc5:	f2 ae                	repnz scas %es:(%edi),%al
c0026cc7:	89 c8                	mov    %ecx,%eax
c0026cc9:	f7 d0                	not    %eax
c0026ccb:	8d 78 ff             	lea    -0x1(%eax),%edi
  if (haystack_len >= needle_len) 
c0026cce:	39 fa                	cmp    %edi,%edx
c0026cd0:	72 2c                	jb     c0026cfe <strstr+0x5c>
      for (i = 0; i <= haystack_len - needle_len; i++)
c0026cd2:	29 fa                	sub    %edi,%edx
c0026cd4:	89 14 24             	mov    %edx,(%esp)
c0026cd7:	bb 00 00 00 00       	mov    $0x0,%ebx
c0026cdc:	89 de                	mov    %ebx,%esi
c0026cde:	03 74 24 18          	add    0x18(%esp),%esi
        if (!memcmp (haystack + i, needle, needle_len))
c0026ce2:	57                   	push   %edi
c0026ce3:	55                   	push   %ebp
c0026ce4:	56                   	push   %esi
c0026ce5:	e8 c1 fc ff ff       	call   c00269ab <memcmp>
c0026cea:	83 c4 0c             	add    $0xc,%esp
c0026ced:	85 c0                	test   %eax,%eax
c0026cef:	74 14                	je     c0026d05 <strstr+0x63>
      for (i = 0; i <= haystack_len - needle_len; i++)
c0026cf1:	43                   	inc    %ebx
c0026cf2:	3b 1c 24             	cmp    (%esp),%ebx
c0026cf5:	76 e5                	jbe    c0026cdc <strstr+0x3a>
  return NULL;
c0026cf7:	b8 00 00 00 00       	mov    $0x0,%eax
c0026cfc:	eb 09                	jmp    c0026d07 <strstr+0x65>
c0026cfe:	b8 00 00 00 00       	mov    $0x0,%eax
c0026d03:	eb 02                	jmp    c0026d07 <strstr+0x65>
        if (!memcmp (haystack + i, needle, needle_len))
c0026d05:	89 f0                	mov    %esi,%eax
}
c0026d07:	83 c4 04             	add    $0x4,%esp
c0026d0a:	5b                   	pop    %ebx
c0026d0b:	5e                   	pop    %esi
c0026d0c:	5f                   	pop    %edi
c0026d0d:	5d                   	pop    %ebp
c0026d0e:	c3                   	ret    

c0026d0f <strnlen>:

/* If STRING is less than MAXLEN characters in length, returns
   its actual length.  Otherwise, returns MAXLEN. */
size_t
strnlen (const char *string, size_t maxlen) 
{
c0026d0f:	8b 4c 24 04          	mov    0x4(%esp),%ecx
c0026d13:	8b 54 24 08          	mov    0x8(%esp),%edx
  size_t length;

  for (length = 0; string[length] != '\0' && length < maxlen; length++)
c0026d17:	80 39 00             	cmpb   $0x0,(%ecx)
c0026d1a:	74 15                	je     c0026d31 <strnlen+0x22>
c0026d1c:	85 d2                	test   %edx,%edx
c0026d1e:	74 17                	je     c0026d37 <strnlen+0x28>
c0026d20:	b8 00 00 00 00       	mov    $0x0,%eax
c0026d25:	40                   	inc    %eax
c0026d26:	80 3c 01 00          	cmpb   $0x0,(%ecx,%eax,1)
c0026d2a:	74 0d                	je     c0026d39 <strnlen+0x2a>
c0026d2c:	39 c2                	cmp    %eax,%edx
c0026d2e:	75 f5                	jne    c0026d25 <strnlen+0x16>
c0026d30:	c3                   	ret    
c0026d31:	b8 00 00 00 00       	mov    $0x0,%eax
c0026d36:	c3                   	ret    
c0026d37:	89 d0                	mov    %edx,%eax
    continue;
  return length;
}
c0026d39:	c3                   	ret    

c0026d3a <strlcpy>:
   increasingly popular extension.  See
   http://www.courtesan.com/todd/papers/strlcpy.html for
   information on strlcpy(). */
size_t
strlcpy (char *dst, const char *src, size_t size) 
{
c0026d3a:	55                   	push   %ebp
c0026d3b:	57                   	push   %edi
c0026d3c:	56                   	push   %esi
c0026d3d:	53                   	push   %ebx
c0026d3e:	83 ec 0c             	sub    $0xc,%esp
c0026d41:	8b 5c 24 20          	mov    0x20(%esp),%ebx
c0026d45:	8b 74 24 24          	mov    0x24(%esp),%esi
c0026d49:	8b 54 24 28          	mov    0x28(%esp),%edx
  size_t src_len;

  ASSERT (dst != NULL);
c0026d4d:	85 db                	test   %ebx,%ebx
c0026d4f:	74 33                	je     c0026d84 <strlcpy+0x4a>
  ASSERT (src != NULL);
c0026d51:	85 f6                	test   %esi,%esi
c0026d53:	74 50                	je     c0026da5 <strlcpy+0x6b>

  src_len = strlen (src);
c0026d55:	b0 00                	mov    $0x0,%al
c0026d57:	b9 ff ff ff ff       	mov    $0xffffffff,%ecx
c0026d5c:	89 f7                	mov    %esi,%edi
c0026d5e:	f2 ae                	repnz scas %es:(%edi),%al
c0026d60:	89 c8                	mov    %ecx,%eax
c0026d62:	f7 d0                	not    %eax
c0026d64:	48                   	dec    %eax
  if (size > 0) 
c0026d65:	85 d2                	test   %edx,%edx
c0026d67:	74 13                	je     c0026d7c <strlcpy+0x42>
    {
      size_t dst_len = size - 1;
c0026d69:	4a                   	dec    %edx
c0026d6a:	89 c5                	mov    %eax,%ebp
c0026d6c:	39 d0                	cmp    %edx,%eax
c0026d6e:	76 02                	jbe    c0026d72 <strlcpy+0x38>
c0026d70:	89 d5                	mov    %edx,%ebp
      if (src_len < dst_len)
        dst_len = src_len;
      memcpy (dst, src, dst_len);
c0026d72:	89 df                	mov    %ebx,%edi
c0026d74:	89 e9                	mov    %ebp,%ecx
c0026d76:	f3 a4                	rep movsb %ds:(%esi),%es:(%edi)
      dst[dst_len] = '\0';
c0026d78:	c6 04 2b 00          	movb   $0x0,(%ebx,%ebp,1)
    }
  return src_len;
}
c0026d7c:	83 c4 0c             	add    $0xc,%esp
c0026d7f:	5b                   	pop    %ebx
c0026d80:	5e                   	pop    %esi
c0026d81:	5f                   	pop    %edi
c0026d82:	5d                   	pop    %ebp
c0026d83:	c3                   	ret    
  ASSERT (dst != NULL);
c0026d84:	83 ec 0c             	sub    $0xc,%esp
c0026d87:	68 d9 e3 02 c0       	push   $0xc002e3d9
c0026d8c:	68 df cb 02 c0       	push   $0xc002cbdf
c0026d91:	68 a8 c6 02 c0       	push   $0xc002c6a8
c0026d96:	68 4a 01 00 00       	push   $0x14a
c0026d9b:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026da0:	e8 9b 08 00 00       	call   c0027640 <debug_panic>
  ASSERT (src != NULL);
c0026da5:	83 ec 0c             	sub    $0xc,%esp
c0026da8:	68 e5 e3 02 c0       	push   $0xc002e3e5
c0026dad:	68 df cb 02 c0       	push   $0xc002cbdf
c0026db2:	68 a8 c6 02 c0       	push   $0xc002c6a8
c0026db7:	68 4b 01 00 00       	push   $0x14b
c0026dbc:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026dc1:	e8 7a 08 00 00       	call   c0027640 <debug_panic>

c0026dc6 <strlcat>:
   increasingly popular extension.  See
   http://www.courtesan.com/todd/papers/strlcpy.html for
   information on strlcpy(). */
size_t
strlcat (char *dst, const char *src, size_t size) 
{
c0026dc6:	55                   	push   %ebp
c0026dc7:	57                   	push   %edi
c0026dc8:	56                   	push   %esi
c0026dc9:	53                   	push   %ebx
c0026dca:	83 ec 0c             	sub    $0xc,%esp
c0026dcd:	8b 74 24 24          	mov    0x24(%esp),%esi
c0026dd1:	8b 5c 24 28          	mov    0x28(%esp),%ebx
  size_t src_len, dst_len;

  ASSERT (dst != NULL);
c0026dd5:	83 7c 24 20 00       	cmpl   $0x0,0x20(%esp)
c0026dda:	74 4f                	je     c0026e2b <strlcat+0x65>
  ASSERT (src != NULL);
c0026ddc:	85 f6                	test   %esi,%esi
c0026dde:	74 6c                	je     c0026e4c <strlcat+0x86>

  src_len = strlen (src);
c0026de0:	bd ff ff ff ff       	mov    $0xffffffff,%ebp
c0026de5:	b0 00                	mov    $0x0,%al
c0026de7:	89 e9                	mov    %ebp,%ecx
c0026de9:	89 f7                	mov    %esi,%edi
c0026deb:	f2 ae                	repnz scas %es:(%edi),%al
c0026ded:	f7 d1                	not    %ecx
c0026def:	8d 51 ff             	lea    -0x1(%ecx),%edx
  dst_len = strlen (dst);
c0026df2:	89 e9                	mov    %ebp,%ecx
c0026df4:	8b 7c 24 20          	mov    0x20(%esp),%edi
c0026df8:	f2 ae                	repnz scas %es:(%edi),%al
c0026dfa:	89 c8                	mov    %ecx,%eax
c0026dfc:	f7 d0                	not    %eax
c0026dfe:	48                   	dec    %eax
  if (size > 0 && dst_len < size) 
c0026dff:	85 db                	test   %ebx,%ebx
c0026e01:	74 1e                	je     c0026e21 <strlcat+0x5b>
c0026e03:	39 d8                	cmp    %ebx,%eax
c0026e05:	73 1a                	jae    c0026e21 <strlcat+0x5b>
    {
      size_t copy_cnt = size - dst_len - 1;
c0026e07:	8d 6b ff             	lea    -0x1(%ebx),%ebp
c0026e0a:	29 c5                	sub    %eax,%ebp
c0026e0c:	89 d1                	mov    %edx,%ecx
c0026e0e:	39 ea                	cmp    %ebp,%edx
c0026e10:	76 02                	jbe    c0026e14 <strlcat+0x4e>
c0026e12:	89 e9                	mov    %ebp,%ecx
      if (src_len < copy_cnt)
        copy_cnt = src_len;
      memcpy (dst + dst_len, src, copy_cnt);
c0026e14:	89 c3                	mov    %eax,%ebx
c0026e16:	03 5c 24 20          	add    0x20(%esp),%ebx
c0026e1a:	89 df                	mov    %ebx,%edi
c0026e1c:	f3 a4                	rep movsb %ds:(%esi),%es:(%edi)
      dst[dst_len + copy_cnt] = '\0';
c0026e1e:	c6 07 00             	movb   $0x0,(%edi)
    }
  return src_len + dst_len;
c0026e21:	01 d0                	add    %edx,%eax
}
c0026e23:	83 c4 0c             	add    $0xc,%esp
c0026e26:	5b                   	pop    %ebx
c0026e27:	5e                   	pop    %esi
c0026e28:	5f                   	pop    %edi
c0026e29:	5d                   	pop    %ebp
c0026e2a:	c3                   	ret    
  ASSERT (dst != NULL);
c0026e2b:	83 ec 0c             	sub    $0xc,%esp
c0026e2e:	68 d9 e3 02 c0       	push   $0xc002e3d9
c0026e33:	68 df cb 02 c0       	push   $0xc002cbdf
c0026e38:	68 a0 c6 02 c0       	push   $0xc002c6a0
c0026e3d:	68 68 01 00 00       	push   $0x168
c0026e42:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026e47:	e8 f4 07 00 00       	call   c0027640 <debug_panic>
  ASSERT (src != NULL);
c0026e4c:	83 ec 0c             	sub    $0xc,%esp
c0026e4f:	68 e5 e3 02 c0       	push   $0xc002e3e5
c0026e54:	68 df cb 02 c0       	push   $0xc002cbdf
c0026e59:	68 a0 c6 02 c0       	push   $0xc002c6a0
c0026e5e:	68 69 01 00 00       	push   $0x169
c0026e63:	68 b5 e3 02 c0       	push   $0xc002e3b5
c0026e68:	e8 d3 07 00 00       	call   c0027640 <debug_panic>

c0026e6d <udiv64>:

/* Divides unsigned 64-bit N by unsigned 64-bit D and returns the
   quotient. */
static uint64_t
udiv64 (uint64_t n, uint64_t d)
{
c0026e6d:	55                   	push   %ebp
c0026e6e:	57                   	push   %edi
c0026e6f:	56                   	push   %esi
c0026e70:	53                   	push   %ebx
c0026e71:	83 ec 1c             	sub    $0x1c,%esp
c0026e74:	89 04 24             	mov    %eax,(%esp)
c0026e77:	89 54 24 04          	mov    %edx,0x4(%esp)
c0026e7b:	8b 74 24 30          	mov    0x30(%esp),%esi
c0026e7f:	8b 7c 24 34          	mov    0x34(%esp),%edi
  if ((d >> 32) == 0) 
c0026e83:	85 ff                	test   %edi,%edi
c0026e85:	74 2f                	je     c0026eb6 <udiv64+0x49>
c0026e87:	89 fa                	mov    %edi,%edx
    }
  else 
    {
      /* Based on the algorithm and proof available from
         http://www.hackersdelight.org/revisions.pdf. */
      if (n < d)
c0026e89:	8b 0c 24             	mov    (%esp),%ecx
c0026e8c:	8b 5c 24 04          	mov    0x4(%esp),%ebx
c0026e90:	39 df                	cmp    %ebx,%edi
c0026e92:	0f 87 43 01 00 00    	ja     c0026fdb <udiv64+0x16e>
c0026e98:	72 08                	jb     c0026ea2 <udiv64+0x35>
c0026e9a:	39 ce                	cmp    %ecx,%esi
c0026e9c:	0f 87 39 01 00 00    	ja     c0026fdb <udiv64+0x16e>
        return 0;
      else 
        {
          uint32_t d1 = d >> 32;
c0026ea2:	89 d0                	mov    %edx,%eax
  if (x <= 0x0000FFFF)
c0026ea4:	81 fa ff ff 00 00    	cmp    $0xffff,%edx
c0026eaa:	77 56                	ja     c0026f02 <udiv64+0x95>
      x <<= 16; 
c0026eac:	c1 e0 10             	shl    $0x10,%eax
      n += 16;
c0026eaf:	b9 10 00 00 00       	mov    $0x10,%ecx
c0026eb4:	eb 51                	jmp    c0026f07 <udiv64+0x9a>
      uint32_t n1 = n >> 32;
c0026eb6:	8b 44 24 04          	mov    0x4(%esp),%eax
      return divl (b * (n1 % d0) + n0, d0) + b * (n1 / d0); 
c0026eba:	ba 00 00 00 00       	mov    $0x0,%edx
c0026ebf:	f7 f6                	div    %esi
c0026ec1:	89 d1                	mov    %edx,%ecx
c0026ec3:	89 c5                	mov    %eax,%ebp
c0026ec5:	b8 00 00 00 00       	mov    $0x0,%eax
c0026eca:	89 ca                	mov    %ecx,%edx
c0026ecc:	8b 0c 24             	mov    (%esp),%ecx
c0026ecf:	bb 00 00 00 00       	mov    $0x0,%ebx
c0026ed4:	01 c8                	add    %ecx,%eax
c0026ed6:	11 da                	adc    %ebx,%edx
  asm ("divl %4"
c0026ed8:	f7 f6                	div    %esi
      return divl (b * (n1 % d0) + n0, d0) + b * (n1 / d0); 
c0026eda:	be 00 00 00 00       	mov    $0x0,%esi
c0026edf:	89 c1                	mov    %eax,%ecx
c0026ee1:	bb 00 00 00 00       	mov    $0x0,%ebx
c0026ee6:	01 f1                	add    %esi,%ecx
c0026ee8:	11 eb                	adc    %ebp,%ebx
c0026eea:	89 4c 24 08          	mov    %ecx,0x8(%esp)
c0026eee:	89 5c 24 0c          	mov    %ebx,0xc(%esp)
          int s = nlz (d1);
          uint64_t q = divl (n >> 1, (d << s) >> 32) >> (31 - s);
          return n - (q - 1) * d < d ? q - 1 : q; 
        }
    }
}
c0026ef2:	8b 44 24 08          	mov    0x8(%esp),%eax
c0026ef6:	8b 54 24 0c          	mov    0xc(%esp),%edx
c0026efa:	83 c4 1c             	add    $0x1c,%esp
c0026efd:	5b                   	pop    %ebx
c0026efe:	5e                   	pop    %esi
c0026eff:	5f                   	pop    %edi
c0026f00:	5d                   	pop    %ebp
c0026f01:	c3                   	ret    
  int n = 0;
c0026f02:	b9 00 00 00 00       	mov    $0x0,%ecx
  if (x <= 0x00FFFFFF)
c0026f07:	3d ff ff ff 00       	cmp    $0xffffff,%eax
c0026f0c:	77 06                	ja     c0026f14 <udiv64+0xa7>
      n += 8;
c0026f0e:	83 c1 08             	add    $0x8,%ecx
      x <<= 8; 
c0026f11:	c1 e0 08             	shl    $0x8,%eax
  if (x <= 0x0FFFFFFF)
c0026f14:	3d ff ff ff 0f       	cmp    $0xfffffff,%eax
c0026f19:	77 06                	ja     c0026f21 <udiv64+0xb4>
      n += 4;
c0026f1b:	83 c1 04             	add    $0x4,%ecx
      x <<= 4;
c0026f1e:	c1 e0 04             	shl    $0x4,%eax
  if (x <= 0x3FFFFFFF)
c0026f21:	3d ff ff ff 3f       	cmp    $0x3fffffff,%eax
c0026f26:	77 06                	ja     c0026f2e <udiv64+0xc1>
      n += 2;
c0026f28:	83 c1 02             	add    $0x2,%ecx
      x <<= 2; 
c0026f2b:	c1 e0 02             	shl    $0x2,%eax
    n++;
c0026f2e:	3d 00 00 00 80       	cmp    $0x80000000,%eax
c0026f33:	83 d1 00             	adc    $0x0,%ecx
  uint32_t n1 = n >> 32;
c0026f36:	8b 04 24             	mov    (%esp),%eax
c0026f39:	8b 54 24 04          	mov    0x4(%esp),%edx
c0026f3d:	89 d3                	mov    %edx,%ebx
c0026f3f:	d1 eb                	shr    %ebx
          uint64_t q = divl (n >> 1, (d << s) >> 32) >> (31 - s);
c0026f41:	0f ac d0 01          	shrd   $0x1,%edx,%eax
c0026f45:	d1 ea                	shr    %edx
c0026f47:	89 44 24 08          	mov    %eax,0x8(%esp)
c0026f4b:	89 54 24 0c          	mov    %edx,0xc(%esp)
c0026f4f:	89 f0                	mov    %esi,%eax
c0026f51:	89 fa                	mov    %edi,%edx
c0026f53:	0f a5 f2             	shld   %cl,%esi,%edx
c0026f56:	d3 e0                	shl    %cl,%eax
c0026f58:	f6 c1 20             	test   $0x20,%cl
c0026f5b:	74 02                	je     c0026f5f <udiv64+0xf2>
c0026f5d:	89 c2                	mov    %eax,%edx
c0026f5f:	89 54 24 14          	mov    %edx,0x14(%esp)
  asm ("divl %4"
c0026f63:	89 da                	mov    %ebx,%edx
c0026f65:	8b 44 24 08          	mov    0x8(%esp),%eax
c0026f69:	f7 74 24 14          	divl   0x14(%esp)
          uint64_t q = divl (n >> 1, (d << s) >> 32) >> (31 - s);
c0026f6d:	ba 1f 00 00 00       	mov    $0x1f,%edx
c0026f72:	29 ca                	sub    %ecx,%edx
c0026f74:	89 d1                	mov    %edx,%ecx
c0026f76:	d3 e8                	shr    %cl,%eax
c0026f78:	b9 00 00 00 00       	mov    $0x0,%ecx
c0026f7d:	89 44 24 10          	mov    %eax,0x10(%esp)
c0026f81:	89 4c 24 14          	mov    %ecx,0x14(%esp)
          return n - (q - 1) * d < d ? q - 1 : q; 
c0026f85:	89 cb                	mov    %ecx,%ebx
c0026f87:	89 c1                	mov    %eax,%ecx
c0026f89:	83 c1 ff             	add    $0xffffffff,%ecx
c0026f8c:	83 d3 ff             	adc    $0xffffffff,%ebx
c0026f8f:	89 fd                	mov    %edi,%ebp
c0026f91:	0f af e9             	imul   %ecx,%ebp
c0026f94:	89 4c 24 08          	mov    %ecx,0x8(%esp)
c0026f98:	89 5c 24 0c          	mov    %ebx,0xc(%esp)
c0026f9c:	0f af de             	imul   %esi,%ebx
c0026f9f:	01 dd                	add    %ebx,%ebp
c0026fa1:	89 f0                	mov    %esi,%eax
c0026fa3:	f7 64 24 08          	mull   0x8(%esp)
c0026fa7:	01 ea                	add    %ebp,%edx
c0026fa9:	8b 0c 24             	mov    (%esp),%ecx
c0026fac:	8b 5c 24 04          	mov    0x4(%esp),%ebx
c0026fb0:	29 c1                	sub    %eax,%ecx
c0026fb2:	19 d3                	sbb    %edx,%ebx
c0026fb4:	39 df                	cmp    %ebx,%edi
c0026fb6:	0f 87 36 ff ff ff    	ja     c0026ef2 <udiv64+0x85>
c0026fbc:	72 08                	jb     c0026fc6 <udiv64+0x159>
c0026fbe:	39 ce                	cmp    %ecx,%esi
c0026fc0:	0f 87 2c ff ff ff    	ja     c0026ef2 <udiv64+0x85>
c0026fc6:	8b 44 24 10          	mov    0x10(%esp),%eax
c0026fca:	8b 54 24 14          	mov    0x14(%esp),%edx
c0026fce:	89 44 24 08          	mov    %eax,0x8(%esp)
c0026fd2:	89 54 24 0c          	mov    %edx,0xc(%esp)
c0026fd6:	e9 17 ff ff ff       	jmp    c0026ef2 <udiv64+0x85>
        return 0;
c0026fdb:	c7 44 24 08 00 00 00 	movl   $0x0,0x8(%esp)
c0026fe2:	00 
c0026fe3:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0026fea:	00 
c0026feb:	e9 02 ff ff ff       	jmp    c0026ef2 <udiv64+0x85>

c0026ff0 <sdiv64>:

/* Divides signed 64-bit N by signed 64-bit D and returns the
   quotient. */
static int64_t
sdiv64 (int64_t n, int64_t d)
{
c0026ff0:	57                   	push   %edi
c0026ff1:	56                   	push   %esi
c0026ff2:	53                   	push   %ebx
c0026ff3:	83 ec 08             	sub    $0x8,%esp
c0026ff6:	89 04 24             	mov    %eax,(%esp)
c0026ff9:	89 54 24 04          	mov    %edx,0x4(%esp)
c0026ffd:	8b 74 24 18          	mov    0x18(%esp),%esi
c0027001:	8b 7c 24 1c          	mov    0x1c(%esp),%edi
  uint64_t n_abs = n >= 0 ? (uint64_t) n : -(uint64_t) n;
c0027005:	85 d2                	test   %edx,%edx
c0027007:	78 32                	js     c002703b <sdiv64+0x4b>
c0027009:	8b 04 24             	mov    (%esp),%eax
c002700c:	8b 54 24 04          	mov    0x4(%esp),%edx
  uint64_t d_abs = d >= 0 ? (uint64_t) d : -(uint64_t) d;
c0027010:	85 ff                	test   %edi,%edi
c0027012:	78 30                	js     c0027044 <sdiv64+0x54>
c0027014:	89 f1                	mov    %esi,%ecx
c0027016:	89 fb                	mov    %edi,%ebx
  uint64_t q_abs = udiv64 (n_abs, d_abs);
c0027018:	53                   	push   %ebx
c0027019:	51                   	push   %ecx
c002701a:	e8 4e fe ff ff       	call   c0026e6d <udiv64>
c002701f:	83 c4 08             	add    $0x8,%esp
  return (n < 0) == (d < 0) ? (int64_t) q_abs : -(int64_t) q_abs;
c0027022:	8b 4c 24 04          	mov    0x4(%esp),%ecx
c0027026:	f7 d1                	not    %ecx
c0027028:	c1 e9 1f             	shr    $0x1f,%ecx
c002702b:	89 fb                	mov    %edi,%ebx
c002702d:	c1 eb 1f             	shr    $0x1f,%ebx
c0027030:	38 d9                	cmp    %bl,%cl
c0027032:	74 1d                	je     c0027051 <sdiv64+0x61>
}
c0027034:	83 c4 08             	add    $0x8,%esp
c0027037:	5b                   	pop    %ebx
c0027038:	5e                   	pop    %esi
c0027039:	5f                   	pop    %edi
c002703a:	c3                   	ret    
  uint64_t n_abs = n >= 0 ? (uint64_t) n : -(uint64_t) n;
c002703b:	f7 d8                	neg    %eax
c002703d:	83 d2 00             	adc    $0x0,%edx
c0027040:	f7 da                	neg    %edx
c0027042:	eb cc                	jmp    c0027010 <sdiv64+0x20>
  uint64_t d_abs = d >= 0 ? (uint64_t) d : -(uint64_t) d;
c0027044:	89 f1                	mov    %esi,%ecx
c0027046:	89 fb                	mov    %edi,%ebx
c0027048:	f7 d9                	neg    %ecx
c002704a:	83 d3 00             	adc    $0x0,%ebx
c002704d:	f7 db                	neg    %ebx
c002704f:	eb c7                	jmp    c0027018 <sdiv64+0x28>
  return (n < 0) == (d < 0) ? (int64_t) q_abs : -(int64_t) q_abs;
c0027051:	f7 d8                	neg    %eax
c0027053:	83 d2 00             	adc    $0x0,%edx
c0027056:	f7 da                	neg    %edx
c0027058:	eb da                	jmp    c0027034 <sdiv64+0x44>

c002705a <__divdi3>:
unsigned long long __umoddi3 (unsigned long long n, unsigned long long d);

/* Signed 64-bit division. */
long long
__divdi3 (long long n, long long d) 
{
c002705a:	83 ec 04             	sub    $0x4,%esp
  return sdiv64 (n, d);
c002705d:	ff 74 24 14          	pushl  0x14(%esp)
c0027061:	ff 74 24 14          	pushl  0x14(%esp)
c0027065:	8b 44 24 10          	mov    0x10(%esp),%eax
c0027069:	8b 54 24 14          	mov    0x14(%esp),%edx
c002706d:	e8 7e ff ff ff       	call   c0026ff0 <sdiv64>
}
c0027072:	83 c4 0c             	add    $0xc,%esp
c0027075:	c3                   	ret    

c0027076 <__moddi3>:

/* Signed 64-bit remainder. */
long long
__moddi3 (long long n, long long d) 
{
c0027076:	57                   	push   %edi
c0027077:	56                   	push   %esi
c0027078:	53                   	push   %ebx
c0027079:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c002707d:	8b 74 24 18          	mov    0x18(%esp),%esi
c0027081:	8b 7c 24 1c          	mov    0x1c(%esp),%edi
  return n - d * sdiv64 (n, d);
c0027085:	57                   	push   %edi
c0027086:	56                   	push   %esi
c0027087:	89 d8                	mov    %ebx,%eax
c0027089:	8b 54 24 1c          	mov    0x1c(%esp),%edx
c002708d:	e8 5e ff ff ff       	call   c0026ff0 <sdiv64>
c0027092:	83 c4 08             	add    $0x8,%esp
c0027095:	0f af c6             	imul   %esi,%eax
c0027098:	29 c3                	sub    %eax,%ebx
c002709a:	89 d8                	mov    %ebx,%eax
  return smod64 (n, d);
c002709c:	99                   	cltd   
}
c002709d:	5b                   	pop    %ebx
c002709e:	5e                   	pop    %esi
c002709f:	5f                   	pop    %edi
c00270a0:	c3                   	ret    

c00270a1 <__udivdi3>:

/* Unsigned 64-bit division. */
unsigned long long
__udivdi3 (unsigned long long n, unsigned long long d) 
{
c00270a1:	83 ec 04             	sub    $0x4,%esp
  return udiv64 (n, d);
c00270a4:	ff 74 24 14          	pushl  0x14(%esp)
c00270a8:	ff 74 24 14          	pushl  0x14(%esp)
c00270ac:	8b 44 24 10          	mov    0x10(%esp),%eax
c00270b0:	8b 54 24 14          	mov    0x14(%esp),%edx
c00270b4:	e8 b4 fd ff ff       	call   c0026e6d <udiv64>
}
c00270b9:	83 c4 0c             	add    $0xc,%esp
c00270bc:	c3                   	ret    

c00270bd <__umoddi3>:

/* Unsigned 64-bit remainder. */
unsigned long long
__umoddi3 (unsigned long long n, unsigned long long d) 
{
c00270bd:	57                   	push   %edi
c00270be:	56                   	push   %esi
c00270bf:	53                   	push   %ebx
c00270c0:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c00270c4:	8b 74 24 18          	mov    0x18(%esp),%esi
c00270c8:	8b 7c 24 1c          	mov    0x1c(%esp),%edi
  return n - d * udiv64 (n, d);
c00270cc:	57                   	push   %edi
c00270cd:	56                   	push   %esi
c00270ce:	89 d8                	mov    %ebx,%eax
c00270d0:	8b 54 24 1c          	mov    0x1c(%esp),%edx
c00270d4:	e8 94 fd ff ff       	call   c0026e6d <udiv64>
c00270d9:	83 c4 08             	add    $0x8,%esp
c00270dc:	0f af c6             	imul   %esi,%eax
c00270df:	29 c3                	sub    %eax,%ebx
c00270e1:	89 d8                	mov    %ebx,%eax
  return umod64 (n, d);
}
c00270e3:	ba 00 00 00 00       	mov    $0x0,%edx
c00270e8:	5b                   	pop    %ebx
c00270e9:	5e                   	pop    %esi
c00270ea:	5f                   	pop    %edi
c00270eb:	c3                   	ret    

c00270ec <parse_octal_field>:
static bool
parse_octal_field (const char *s, size_t size, unsigned long int *value)
{
  size_t ofs;

  *value = 0;
c00270ec:	c7 01 00 00 00 00    	movl   $0x0,(%ecx)
  for (ofs = 0; ofs < size; ofs++)
c00270f2:	85 d2                	test   %edx,%edx
c00270f4:	74 46                	je     c002713c <parse_octal_field+0x50>
{
c00270f6:	55                   	push   %ebp
c00270f7:	57                   	push   %edi
c00270f8:	56                   	push   %esi
c00270f9:	53                   	push   %ebx
c00270fa:	89 d5                	mov    %edx,%ebp
    {
      char c = s[ofs];
c00270fc:	8a 18                	mov    (%eax),%bl
      if (c >= '0' && c <= '7')
c00270fe:	8d 73 d0             	lea    -0x30(%ebx),%esi
c0027101:	89 f2                	mov    %esi,%edx
  for (ofs = 0; ofs < size; ofs++)
c0027103:	be 00 00 00 00       	mov    $0x0,%esi
      if (c >= '0' && c <= '7')
c0027108:	80 fa 07             	cmp    $0x7,%dl
c002710b:	77 39                	ja     c0027146 <parse_octal_field+0x5a>
c002710d:	bf 00 00 00 00       	mov    $0x0,%edi
c0027112:	be 00 00 00 00       	mov    $0x0,%esi
          if (*value > ULONG_MAX / 8)
            {
              /* Overflow. */
              return false;
            }
          *value = c - '0' + *value * 8;
c0027117:	0f be db             	movsbl %bl,%ebx
c002711a:	8d 7c fb d0          	lea    -0x30(%ebx,%edi,8),%edi
c002711e:	89 39                	mov    %edi,(%ecx)
  for (ofs = 0; ofs < size; ofs++)
c0027120:	46                   	inc    %esi
c0027121:	39 f5                	cmp    %esi,%ebp
c0027123:	74 1a                	je     c002713f <parse_octal_field+0x53>
      char c = s[ofs];
c0027125:	8a 1c 30             	mov    (%eax,%esi,1),%bl
      if (c >= '0' && c <= '7')
c0027128:	8d 53 d0             	lea    -0x30(%ebx),%edx
c002712b:	80 fa 07             	cmp    $0x7,%dl
c002712e:	77 16                	ja     c0027146 <parse_octal_field+0x5a>
          if (*value > ULONG_MAX / 8)
c0027130:	81 ff ff ff ff 1f    	cmp    $0x1fffffff,%edi
c0027136:	76 df                	jbe    c0027117 <parse_octal_field+0x2b>
              return false;
c0027138:	b0 00                	mov    $0x0,%al
c002713a:	eb 05                	jmp    c0027141 <parse_octal_field+0x55>
          return false;
        }
    }

  /* Field did not end in space or null byte. */
  return false;
c002713c:	b0 00                	mov    $0x0,%al
c002713e:	c3                   	ret    
c002713f:	b0 00                	mov    $0x0,%al
}
c0027141:	5b                   	pop    %ebx
c0027142:	5e                   	pop    %esi
c0027143:	5f                   	pop    %edi
c0027144:	5d                   	pop    %ebp
c0027145:	c3                   	ret    
      else if (c == ' ' || c == '\0')
c0027146:	f6 c3 df             	test   $0xdf,%bl
c0027149:	75 07                	jne    c0027152 <parse_octal_field+0x66>
          return ofs > 0;
c002714b:	85 f6                	test   %esi,%esi
c002714d:	0f 95 c0             	setne  %al
c0027150:	eb ef                	jmp    c0027141 <parse_octal_field+0x55>
          return false;
c0027152:	b0 00                	mov    $0x0,%al
c0027154:	eb eb                	jmp    c0027141 <parse_octal_field+0x55>

c0027156 <strip_antisocial_prefixes>:
{
c0027156:	55                   	push   %ebp
c0027157:	57                   	push   %edi
c0027158:	56                   	push   %esi
c0027159:	53                   	push   %ebx
c002715a:	83 ec 0c             	sub    $0xc,%esp
c002715d:	89 c5                	mov    %eax,%ebp
  while (*file_name == '/'
c002715f:	eb 11                	jmp    c0027172 <strip_antisocial_prefixes+0x1c>
    file_name = strchr (file_name, '/') + 1;
c0027161:	83 ec 08             	sub    $0x8,%esp
c0027164:	6a 2f                	push   $0x2f
c0027166:	55                   	push   %ebp
c0027167:	e8 ec f8 ff ff       	call   c0026a58 <strchr>
c002716c:	83 c4 10             	add    $0x10,%esp
c002716f:	8d 68 01             	lea    0x1(%eax),%ebp
  while (*file_name == '/'
c0027172:	8a 5d 00             	mov    0x0(%ebp),%bl
c0027175:	80 fb 2f             	cmp    $0x2f,%bl
c0027178:	74 e7                	je     c0027161 <strip_antisocial_prefixes+0xb>
         || !memcmp (file_name, "./", 2)
c002717a:	83 ec 04             	sub    $0x4,%esp
c002717d:	6a 02                	push   $0x2
c002717f:	68 11 d8 02 c0       	push   $0xc002d811
c0027184:	55                   	push   %ebp
c0027185:	e8 21 f8 ff ff       	call   c00269ab <memcmp>
c002718a:	83 c4 10             	add    $0x10,%esp
c002718d:	85 c0                	test   %eax,%eax
c002718f:	74 d0                	je     c0027161 <strip_antisocial_prefixes+0xb>
         || !memcmp (file_name, "../", 3))
c0027191:	83 ec 04             	sub    $0x4,%esp
c0027194:	6a 03                	push   $0x3
c0027196:	68 f1 e3 02 c0       	push   $0xc002e3f1
c002719b:	55                   	push   %ebp
c002719c:	e8 0a f8 ff ff       	call   c00269ab <memcmp>
c00271a1:	83 c4 10             	add    $0x10,%esp
c00271a4:	85 c0                	test   %eax,%eax
c00271a6:	74 b9                	je     c0027161 <strip_antisocial_prefixes+0xb>
  return *file_name == '\0' || !strcmp (file_name, "..") ? "." : file_name;
c00271a8:	84 db                	test   %bl,%bl
c00271aa:	74 23                	je     c00271cf <strip_antisocial_prefixes+0x79>
c00271ac:	bf 96 dd 02 c0       	mov    $0xc002dd96,%edi
c00271b1:	b9 03 00 00 00       	mov    $0x3,%ecx
c00271b6:	89 ee                	mov    %ebp,%esi
c00271b8:	f3 a6                	repz cmpsb %es:(%edi),%ds:(%esi)
c00271ba:	0f 97 c2             	seta   %dl
c00271bd:	0f 92 c0             	setb   %al
c00271c0:	38 c2                	cmp    %al,%dl
c00271c2:	75 07                	jne    c00271cb <strip_antisocial_prefixes+0x75>
c00271c4:	b8 97 dd 02 c0       	mov    $0xc002dd97,%eax
c00271c9:	eb 09                	jmp    c00271d4 <strip_antisocial_prefixes+0x7e>
c00271cb:	89 e8                	mov    %ebp,%eax
c00271cd:	eb 05                	jmp    c00271d4 <strip_antisocial_prefixes+0x7e>
c00271cf:	b8 97 dd 02 c0       	mov    $0xc002dd97,%eax
}
c00271d4:	83 c4 0c             	add    $0xc,%esp
c00271d7:	5b                   	pop    %ebx
c00271d8:	5e                   	pop    %esi
c00271d9:	5f                   	pop    %edi
c00271da:	5d                   	pop    %ebp
c00271db:	c3                   	ret    

c00271dc <ustar_make_header>:
{
c00271dc:	57                   	push   %edi
c00271dd:	56                   	push   %esi
c00271de:	53                   	push   %ebx
c00271df:	8b 44 24 10          	mov    0x10(%esp),%eax
c00271e3:	8b 5c 24 14          	mov    0x14(%esp),%ebx
c00271e7:	8b 74 24 1c          	mov    0x1c(%esp),%esi
  ASSERT (type == USTAR_REGULAR || type == USTAR_DIRECTORY);
c00271eb:	83 fb 30             	cmp    $0x30,%ebx
c00271ee:	0f 84 83 01 00 00    	je     c0027377 <ustar_make_header+0x19b>
c00271f4:	83 fb 35             	cmp    $0x35,%ebx
c00271f7:	0f 85 3e 01 00 00    	jne    c002733b <ustar_make_header+0x15f>
  file_name = strip_antisocial_prefixes (file_name);
c00271fd:	e8 54 ff ff ff       	call   c0027156 <strip_antisocial_prefixes>
c0027202:	89 c2                	mov    %eax,%edx
  if (strlen (file_name) > 99)
c0027204:	b0 00                	mov    $0x0,%al
c0027206:	b9 ff ff ff ff       	mov    $0xffffffff,%ecx
c002720b:	89 d7                	mov    %edx,%edi
c002720d:	f2 ae                	repnz scas %es:(%edi),%al
c002720f:	89 c8                	mov    %ecx,%eax
c0027211:	f7 d0                	not    %eax
c0027213:	48                   	dec    %eax
c0027214:	83 f8 63             	cmp    $0x63,%eax
c0027217:	0f 87 3c 01 00 00    	ja     c0027359 <ustar_make_header+0x17d>
  memset (h, 0, sizeof *h);
c002721d:	b9 80 00 00 00       	mov    $0x80,%ecx
c0027222:	b8 00 00 00 00       	mov    $0x0,%eax
c0027227:	89 f7                	mov    %esi,%edi
c0027229:	f3 ab                	rep stos %eax,%es:(%edi)
  strlcpy (h->name, file_name, sizeof h->name);
c002722b:	83 ec 04             	sub    $0x4,%esp
c002722e:	6a 64                	push   $0x64
c0027230:	52                   	push   %edx
c0027231:	56                   	push   %esi
c0027232:	e8 03 fb ff ff       	call   c0026d3a <strlcpy>
c0027237:	83 c4 10             	add    $0x10,%esp
  snprintf (h->mode, sizeof h->mode, "%07o",
c002723a:	b8 ed 01 00 00       	mov    $0x1ed,%eax
c002723f:	50                   	push   %eax
c0027240:	68 1f e4 02 c0       	push   $0xc002e41f
c0027245:	6a 08                	push   $0x8
c0027247:	8d 46 64             	lea    0x64(%esi),%eax
c002724a:	50                   	push   %eax
c002724b:	e8 ce f0 ff ff       	call   c002631e <snprintf>
  strlcpy (h->uid, "0000000", sizeof h->uid);
c0027250:	83 c4 0c             	add    $0xc,%esp
c0027253:	6a 08                	push   $0x8
c0027255:	68 24 e4 02 c0       	push   $0xc002e424
c002725a:	8d 46 6c             	lea    0x6c(%esi),%eax
c002725d:	50                   	push   %eax
c002725e:	e8 d7 fa ff ff       	call   c0026d3a <strlcpy>
  strlcpy (h->gid, "0000000", sizeof h->gid);
c0027263:	83 c4 0c             	add    $0xc,%esp
c0027266:	6a 08                	push   $0x8
c0027268:	68 24 e4 02 c0       	push   $0xc002e424
c002726d:	8d 46 74             	lea    0x74(%esi),%eax
c0027270:	50                   	push   %eax
c0027271:	e8 c4 fa ff ff       	call   c0026d3a <strlcpy>
  snprintf (h->size, sizeof h->size, "%011o", size);
c0027276:	ff 74 24 28          	pushl  0x28(%esp)
c002727a:	68 2c e4 02 c0       	push   $0xc002e42c
c002727f:	6a 0c                	push   $0xc
c0027281:	8d 46 7c             	lea    0x7c(%esi),%eax
c0027284:	50                   	push   %eax
c0027285:	e8 94 f0 ff ff       	call   c002631e <snprintf>
  snprintf (h->mtime, sizeof h->size, "%011o", 1136102400);
c002728a:	83 c4 20             	add    $0x20,%esp
c002728d:	68 00 8c b7 43       	push   $0x43b78c00
c0027292:	68 2c e4 02 c0       	push   $0xc002e42c
c0027297:	6a 0c                	push   $0xc
c0027299:	8d 86 88 00 00 00    	lea    0x88(%esi),%eax
c002729f:	50                   	push   %eax
c00272a0:	e8 79 f0 ff ff       	call   c002631e <snprintf>
  h->typeflag = type;
c00272a5:	88 9e 9c 00 00 00    	mov    %bl,0x9c(%esi)
  strlcpy (h->magic, "ustar", sizeof h->magic);
c00272ab:	83 c4 0c             	add    $0xc,%esp
c00272ae:	6a 06                	push   $0x6
c00272b0:	68 32 e4 02 c0       	push   $0xc002e432
c00272b5:	8d 86 01 01 00 00    	lea    0x101(%esi),%eax
c00272bb:	50                   	push   %eax
c00272bc:	e8 79 fa ff ff       	call   c0026d3a <strlcpy>
  h->version[0] = h->version[1] = '0';
c00272c1:	c6 86 08 01 00 00 30 	movb   $0x30,0x108(%esi)
c00272c8:	c6 86 07 01 00 00 30 	movb   $0x30,0x107(%esi)
  strlcpy (h->gname, "root", sizeof h->gname);
c00272cf:	83 c4 0c             	add    $0xc,%esp
c00272d2:	6a 20                	push   $0x20
c00272d4:	68 c8 d9 02 c0       	push   $0xc002d9c8
c00272d9:	8d 86 29 01 00 00    	lea    0x129(%esi),%eax
c00272df:	50                   	push   %eax
c00272e0:	e8 55 fa ff ff       	call   c0026d3a <strlcpy>
  strlcpy (h->uname, "root", sizeof h->uname);
c00272e5:	83 c4 0c             	add    $0xc,%esp
c00272e8:	6a 20                	push   $0x20
c00272ea:	68 c8 d9 02 c0       	push   $0xc002d9c8
c00272ef:	8d 86 09 01 00 00    	lea    0x109(%esi),%eax
c00272f5:	50                   	push   %eax
c00272f6:	e8 3f fa ff ff       	call   c0026d3a <strlcpy>
c00272fb:	83 c4 10             	add    $0x10,%esp
c00272fe:	b8 6c ff ff ff       	mov    $0xffffff6c,%eax
  chksum = 0;
c0027303:	b9 00 00 00 00       	mov    $0x0,%ecx
      chksum += in_chksum_field ? ' ' : header[i];
c0027308:	b3 20                	mov    $0x20,%bl
c002730a:	83 f8 07             	cmp    $0x7,%eax
c002730d:	77 5f                	ja     c002736e <ustar_make_header+0x192>
c002730f:	88 da                	mov    %bl,%dl
c0027311:	0f b6 d2             	movzbl %dl,%edx
c0027314:	01 d1                	add    %edx,%ecx
c0027316:	40                   	inc    %eax
  for (i = 0; i < USTAR_HEADER_SIZE; i++)
c0027317:	3d 6c 01 00 00       	cmp    $0x16c,%eax
c002731c:	75 ec                	jne    c002730a <ustar_make_header+0x12e>
  snprintf (h->chksum, sizeof h->chksum, "%07o", calculate_chksum (h));
c002731e:	51                   	push   %ecx
c002731f:	68 1f e4 02 c0       	push   $0xc002e41f
c0027324:	6a 08                	push   $0x8
c0027326:	81 c6 94 00 00 00    	add    $0x94,%esi
c002732c:	56                   	push   %esi
c002732d:	e8 ec ef ff ff       	call   c002631e <snprintf>
  return true;
c0027332:	83 c4 10             	add    $0x10,%esp
c0027335:	b0 01                	mov    $0x1,%al
}
c0027337:	5b                   	pop    %ebx
c0027338:	5e                   	pop    %esi
c0027339:	5f                   	pop    %edi
c002733a:	c3                   	ret    
  ASSERT (type == USTAR_REGULAR || type == USTAR_DIRECTORY);
c002733b:	83 ec 0c             	sub    $0xc,%esp
c002733e:	68 dc e4 02 c0       	push   $0xc002e4dc
c0027343:	68 df cb 02 c0       	push   $0xc002cbdf
c0027348:	68 bc c6 02 c0       	push   $0xc002c6bc
c002734d:	6a 59                	push   $0x59
c002734f:	68 f5 e3 02 c0       	push   $0xc002e3f5
c0027354:	e8 e7 02 00 00       	call   c0027640 <debug_panic>
      printf ("%s: file name too long\n", file_name);
c0027359:	83 ec 08             	sub    $0x8,%esp
c002735c:	52                   	push   %edx
c002735d:	68 07 e4 02 c0       	push   $0xc002e407
c0027362:	e8 2b e8 ff ff       	call   c0025b92 <printf>
      return false;
c0027367:	83 c4 10             	add    $0x10,%esp
c002736a:	b0 00                	mov    $0x0,%al
c002736c:	eb c9                	jmp    c0027337 <ustar_make_header+0x15b>
      chksum += in_chksum_field ? ' ' : header[i];
c002736e:	8a 94 06 94 00 00 00 	mov    0x94(%esi,%eax,1),%dl
c0027375:	eb 9a                	jmp    c0027311 <ustar_make_header+0x135>
  file_name = strip_antisocial_prefixes (file_name);
c0027377:	e8 da fd ff ff       	call   c0027156 <strip_antisocial_prefixes>
c002737c:	89 c2                	mov    %eax,%edx
  if (strlen (file_name) > 99)
c002737e:	b0 00                	mov    $0x0,%al
c0027380:	b9 ff ff ff ff       	mov    $0xffffffff,%ecx
c0027385:	89 d7                	mov    %edx,%edi
c0027387:	f2 ae                	repnz scas %es:(%edi),%al
c0027389:	89 c8                	mov    %ecx,%eax
c002738b:	f7 d0                	not    %eax
c002738d:	48                   	dec    %eax
c002738e:	83 f8 63             	cmp    $0x63,%eax
c0027391:	77 c6                	ja     c0027359 <ustar_make_header+0x17d>
  memset (h, 0, sizeof *h);
c0027393:	b9 80 00 00 00       	mov    $0x80,%ecx
c0027398:	b8 00 00 00 00       	mov    $0x0,%eax
c002739d:	89 f7                	mov    %esi,%edi
c002739f:	f3 ab                	rep stos %eax,%es:(%edi)
  strlcpy (h->name, file_name, sizeof h->name);
c00273a1:	83 ec 04             	sub    $0x4,%esp
c00273a4:	6a 64                	push   $0x64
c00273a6:	52                   	push   %edx
c00273a7:	56                   	push   %esi
c00273a8:	e8 8d f9 ff ff       	call   c0026d3a <strlcpy>
c00273ad:	83 c4 10             	add    $0x10,%esp
  snprintf (h->mode, sizeof h->mode, "%07o",
c00273b0:	b8 a4 01 00 00       	mov    $0x1a4,%eax
c00273b5:	e9 85 fe ff ff       	jmp    c002723f <ustar_make_header+0x63>

c00273ba <ustar_parse_header>:
   and returns a null pointer.  On failure, returns a
   human-readable error message. */
const char *
ustar_parse_header (const char header[USTAR_HEADER_SIZE],
                    const char **file_name, enum ustar_type *type, int *size)
{
c00273ba:	56                   	push   %esi
c00273bb:	53                   	push   %ebx
c00273bc:	83 ec 14             	sub    $0x14,%esp
c00273bf:	8b 5c 24 20          	mov    0x20(%esp),%ebx
c00273c3:	8d 93 00 02 00 00    	lea    0x200(%ebx),%edx
c00273c9:	89 d8                	mov    %ebx,%eax
    if (*block++ != 0)
c00273cb:	40                   	inc    %eax
c00273cc:	80 78 ff 00          	cmpb   $0x0,-0x1(%eax)
c00273d0:	0f 85 47 01 00 00    	jne    c002751d <ustar_parse_header+0x163>
  while (cnt-- > 0)
c00273d6:	39 c2                	cmp    %eax,%edx
c00273d8:	75 f1                	jne    c00273cb <ustar_parse_header+0x11>
  ASSERT (sizeof (struct ustar_header) == USTAR_HEADER_SIZE);

  /* Detect end of archive. */
  if (is_all_zeros (header, USTAR_HEADER_SIZE))
    {
      *file_name = NULL;
c00273da:	8b 44 24 24          	mov    0x24(%esp),%eax
c00273de:	c7 00 00 00 00 00    	movl   $0x0,(%eax)
      *type = USTAR_EOF;
c00273e4:	8b 44 24 28          	mov    0x28(%esp),%eax
c00273e8:	c7 00 ff ff ff ff    	movl   $0xffffffff,(%eax)
      *size = 0;
c00273ee:	8b 44 24 2c          	mov    0x2c(%esp),%eax
c00273f2:	c7 00 00 00 00 00    	movl   $0x0,(%eax)
      return NULL;
c00273f8:	b8 00 00 00 00       	mov    $0x0,%eax
  /* Success. */
  *file_name = strip_antisocial_prefixes (h->name);
  *type = h->typeflag;
  *size = size_ul;
  return NULL;
}
c00273fd:	83 c4 14             	add    $0x14,%esp
c0027400:	5b                   	pop    %ebx
c0027401:	5e                   	pop    %esi
c0027402:	c3                   	ret    
  else if (h->version[0] != '0' || h->version[1] != '0')
c0027403:	80 bb 08 01 00 00 30 	cmpb   $0x30,0x108(%ebx)
c002740a:	74 07                	je     c0027413 <ustar_parse_header+0x59>
    return "invalid ustar version";
c002740c:	b8 4c e4 02 c0       	mov    $0xc002e44c,%eax
c0027411:	eb ea                	jmp    c00273fd <ustar_parse_header+0x43>
  else if (!parse_octal_field (h->chksum, sizeof h->chksum, &chksum))
c0027413:	8d 83 94 00 00 00    	lea    0x94(%ebx),%eax
c0027419:	8d 4c 24 0c          	lea    0xc(%esp),%ecx
c002741d:	ba 08 00 00 00       	mov    $0x8,%edx
c0027422:	e8 c5 fc ff ff       	call   c00270ec <parse_octal_field>
c0027427:	84 c0                	test   %al,%al
c0027429:	0f 84 b2 00 00 00    	je     c00274e1 <ustar_parse_header+0x127>
c002742f:	b8 6c ff ff ff       	mov    $0xffffff6c,%eax
c0027434:	b9 00 00 00 00       	mov    $0x0,%ecx
      chksum += in_chksum_field ? ' ' : header[i];
c0027439:	be 20 00 00 00       	mov    $0x20,%esi
c002743e:	83 f8 07             	cmp    $0x7,%eax
c0027441:	77 1c                	ja     c002745f <ustar_parse_header+0xa5>
c0027443:	89 f2                	mov    %esi,%edx
c0027445:	0f b6 d2             	movzbl %dl,%edx
c0027448:	01 d1                	add    %edx,%ecx
c002744a:	40                   	inc    %eax
  for (i = 0; i < USTAR_HEADER_SIZE; i++)
c002744b:	3d 6c 01 00 00       	cmp    $0x16c,%eax
c0027450:	75 ec                	jne    c002743e <ustar_parse_header+0x84>
  else if (chksum != calculate_chksum (h))
c0027452:	39 4c 24 0c          	cmp    %ecx,0xc(%esp)
c0027456:	74 10                	je     c0027468 <ustar_parse_header+0xae>
    return "checksum mismatch";
c0027458:	b8 77 e4 02 c0       	mov    $0xc002e477,%eax
c002745d:	eb 9e                	jmp    c00273fd <ustar_parse_header+0x43>
      chksum += in_chksum_field ? ' ' : header[i];
c002745f:	8a 94 03 94 00 00 00 	mov    0x94(%ebx,%eax,1),%dl
c0027466:	eb dd                	jmp    c0027445 <ustar_parse_header+0x8b>
  else if (h->name[sizeof h->name - 1] != '\0' || h->prefix[0] != '\0')
c0027468:	80 7b 63 00          	cmpb   $0x0,0x63(%ebx)
c002746c:	75 7d                	jne    c00274eb <ustar_parse_header+0x131>
c002746e:	80 bb 59 01 00 00 00 	cmpb   $0x0,0x159(%ebx)
c0027475:	75 7e                	jne    c00274f5 <ustar_parse_header+0x13b>
  else if (h->typeflag != USTAR_REGULAR && h->typeflag != USTAR_DIRECTORY)
c0027477:	8a 83 9c 00 00 00    	mov    0x9c(%ebx),%al
c002747d:	3c 30                	cmp    $0x30,%al
c002747f:	74 3a                	je     c00274bb <ustar_parse_header+0x101>
c0027481:	3c 35                	cmp    $0x35,%al
c0027483:	75 7a                	jne    c00274ff <ustar_parse_header+0x145>
    size_ul = 0;
c0027485:	c7 44 24 08 00 00 00 	movl   $0x0,0x8(%esp)
c002748c:	00 
  *file_name = strip_antisocial_prefixes (h->name);
c002748d:	89 d8                	mov    %ebx,%eax
c002748f:	e8 c2 fc ff ff       	call   c0027156 <strip_antisocial_prefixes>
c0027494:	8b 74 24 24          	mov    0x24(%esp),%esi
c0027498:	89 06                	mov    %eax,(%esi)
  *type = h->typeflag;
c002749a:	0f be 83 9c 00 00 00 	movsbl 0x9c(%ebx),%eax
c00274a1:	8b 74 24 28          	mov    0x28(%esp),%esi
c00274a5:	89 06                	mov    %eax,(%esi)
  *size = size_ul;
c00274a7:	8b 44 24 08          	mov    0x8(%esp),%eax
c00274ab:	8b 74 24 2c          	mov    0x2c(%esp),%esi
c00274af:	89 06                	mov    %eax,(%esi)
  return NULL;
c00274b1:	b8 00 00 00 00       	mov    $0x0,%eax
c00274b6:	e9 42 ff ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
      if (!parse_octal_field (h->size, sizeof h->size, &size_ul))
c00274bb:	8d 43 7c             	lea    0x7c(%ebx),%eax
c00274be:	8d 4c 24 08          	lea    0x8(%esp),%ecx
c00274c2:	ba 0c 00 00 00       	mov    $0xc,%edx
c00274c7:	e8 20 fc ff ff       	call   c00270ec <parse_octal_field>
c00274cc:	84 c0                	test   %al,%al
c00274ce:	74 39                	je     c0027509 <ustar_parse_header+0x14f>
      else if (size_ul > INT_MAX)
c00274d0:	83 7c 24 08 00       	cmpl   $0x0,0x8(%esp)
c00274d5:	79 b6                	jns    c002748d <ustar_parse_header+0xd3>
        return "file too large";
c00274d7:	b8 cc e4 02 c0       	mov    $0xc002e4cc,%eax
c00274dc:	e9 1c ff ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
    return "corrupt chksum field";
c00274e1:	b8 62 e4 02 c0       	mov    $0xc002e462,%eax
c00274e6:	e9 12 ff ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
    return "file name too long";
c00274eb:	b8 89 e4 02 c0       	mov    $0xc002e489,%eax
c00274f0:	e9 08 ff ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
c00274f5:	b8 89 e4 02 c0       	mov    $0xc002e489,%eax
c00274fa:	e9 fe fe ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
    return "unimplemented file type";
c00274ff:	b8 9c e4 02 c0       	mov    $0xc002e49c,%eax
c0027504:	e9 f4 fe ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
        return "corrupt file size field";
c0027509:	b8 b4 e4 02 c0       	mov    $0xc002e4b4,%eax
c002750e:	e9 ea fe ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
    return "not a ustar archive";
c0027513:	b8 38 e4 02 c0       	mov    $0xc002e438,%eax
c0027518:	e9 e0 fe ff ff       	jmp    c00273fd <ustar_parse_header+0x43>
  if (memcmp (h->magic, "ustar", 6))
c002751d:	83 ec 04             	sub    $0x4,%esp
c0027520:	6a 06                	push   $0x6
c0027522:	68 32 e4 02 c0       	push   $0xc002e432
c0027527:	8d 83 01 01 00 00    	lea    0x101(%ebx),%eax
c002752d:	50                   	push   %eax
c002752e:	e8 78 f4 ff ff       	call   c00269ab <memcmp>
c0027533:	83 c4 10             	add    $0x10,%esp
c0027536:	85 c0                	test   %eax,%eax
c0027538:	75 d9                	jne    c0027513 <ustar_parse_header+0x159>
  else if (h->version[0] != '0' || h->version[1] != '0')
c002753a:	80 bb 07 01 00 00 30 	cmpb   $0x30,0x107(%ebx)
c0027541:	0f 84 bc fe ff ff    	je     c0027403 <ustar_parse_header+0x49>
    return "invalid ustar version";
c0027547:	b8 4c e4 02 c0       	mov    $0xc002e44c,%eax
c002754c:	e9 ac fe ff ff       	jmp    c00273fd <ustar_parse_header+0x43>

c0027551 <print_stacktrace>:

/* Print call stack of a thread.
   The thread may be running, ready, or blocked. */
static void
print_stacktrace(struct thread *t, void *aux UNUSED)
{
c0027551:	55                   	push   %ebp
c0027552:	89 e5                	mov    %esp,%ebp
c0027554:	53                   	push   %ebx
c0027555:	83 ec 04             	sub    $0x4,%esp
c0027558:	8b 5d 08             	mov    0x8(%ebp),%ebx
  void *retaddr = NULL, **frame = NULL;
  const char *status = "UNKNOWN";

  switch (t->status) {
c002755b:	8b 43 04             	mov    0x4(%ebx),%eax
c002755e:	83 f8 01             	cmp    $0x1,%eax
c0027561:	0f 84 ab 00 00 00    	je     c0027612 <print_stacktrace+0xc1>
c0027567:	83 f8 01             	cmp    $0x1,%eax
c002756a:	72 10                	jb     c002757c <print_stacktrace+0x2b>
c002756c:	83 f8 02             	cmp    $0x2,%eax
c002756f:	0f 84 a7 00 00 00    	je     c002761c <print_stacktrace+0xcb>
  const char *status = "UNKNOWN";
c0027575:	b8 13 e5 02 c0       	mov    $0xc002e513,%eax
c002757a:	eb 05                	jmp    c0027581 <print_stacktrace+0x30>
    case THREAD_RUNNING:  
      status = "RUNNING";
c002757c:	b8 c7 cf 02 c0       	mov    $0xc002cfc7,%eax

    default:
      break;
  }

  printf ("Call stack of thread `%s' (status %s):", t->name, status);
c0027581:	83 ec 04             	sub    $0x4,%esp
c0027584:	50                   	push   %eax
c0027585:	8d 43 08             	lea    0x8(%ebx),%eax
c0027588:	50                   	push   %eax
c0027589:	68 38 e5 02 c0       	push   $0xc002e538
c002758e:	e8 ff e5 ff ff       	call   c0025b92 <printf>

  if (t == thread_current()) 
c0027593:	e8 b9 94 ff ff       	call   c0020a51 <thread_current>
c0027598:	83 c4 10             	add    $0x10,%esp
c002759b:	39 c3                	cmp    %eax,%ebx
c002759d:	0f 84 83 00 00 00    	je     c0027626 <print_stacktrace+0xd5>
    {
      /* Retrieve the values of the base and instruction pointers
         as they were saved when this thread called switch_threads. */
      struct switch_threads_frame * saved_frame;

      saved_frame = (struct switch_threads_frame *)t->stack;
c00275a3:	8b 53 18             	mov    0x18(%ebx),%edx
         list, but have never been scheduled.
         We can identify because their `stack' member either points 
         at the top of their kernel stack page, or the 
         switch_threads_frame's 'eip' member points at switch_entry.
         See also threads.c. */
      if (t->stack == (uint8_t *)t + PGSIZE || saved_frame->eip == switch_entry)
c00275a6:	81 c3 00 10 00 00    	add    $0x1000,%ebx
c00275ac:	39 da                	cmp    %ebx,%edx
c00275ae:	74 7e                	je     c002762e <print_stacktrace+0xdd>
c00275b0:	8b 42 10             	mov    0x10(%edx),%eax
c00275b3:	3d 12 0f 02 c0       	cmp    $0xc0020f12,%eax
c00275b8:	74 74                	je     c002762e <print_stacktrace+0xdd>
        {
          printf (" thread was never scheduled.\n");
          return;
        }

      frame = (void **) saved_frame->ebp;
c00275ba:	8b 5a 08             	mov    0x8(%edx),%ebx
      retaddr = (void *) saved_frame->eip;
    }

  printf (" %p", retaddr);
c00275bd:	83 ec 08             	sub    $0x8,%esp
c00275c0:	50                   	push   %eax
c00275c1:	68 09 e2 02 c0       	push   $0xc002e209
c00275c6:	e8 c7 e5 ff ff       	call   c0025b92 <printf>
  for (; (uintptr_t) frame >= 0x1000 && frame[0] != NULL; frame = frame[0])
c00275cb:	83 c4 10             	add    $0x10,%esp
c00275ce:	81 fb ff 0f 00 00    	cmp    $0xfff,%ebx
c00275d4:	76 27                	jbe    c00275fd <print_stacktrace+0xac>
c00275d6:	83 3b 00             	cmpl   $0x0,(%ebx)
c00275d9:	74 22                	je     c00275fd <print_stacktrace+0xac>
    printf (" %p", frame[1]);
c00275db:	83 ec 08             	sub    $0x8,%esp
c00275de:	ff 73 04             	pushl  0x4(%ebx)
c00275e1:	68 09 e2 02 c0       	push   $0xc002e209
c00275e6:	e8 a7 e5 ff ff       	call   c0025b92 <printf>
  for (; (uintptr_t) frame >= 0x1000 && frame[0] != NULL; frame = frame[0])
c00275eb:	8b 1b                	mov    (%ebx),%ebx
c00275ed:	83 c4 10             	add    $0x10,%esp
c00275f0:	81 fb ff 0f 00 00    	cmp    $0xfff,%ebx
c00275f6:	76 05                	jbe    c00275fd <print_stacktrace+0xac>
c00275f8:	83 3b 00             	cmpl   $0x0,(%ebx)
c00275fb:	75 de                	jne    c00275db <print_stacktrace+0x8a>
  printf (".\n");
c00275fd:	83 ec 0c             	sub    $0xc,%esp
c0027600:	68 97 dd 02 c0       	push   $0xc002dd97
c0027605:	e8 84 1a 00 00       	call   c002908e <puts>
c002760a:	83 c4 10             	add    $0x10,%esp
}
c002760d:	8b 5d fc             	mov    -0x4(%ebp),%ebx
c0027610:	c9                   	leave  
c0027611:	c3                   	ret    
      status = "READY";
c0027612:	b8 0d e5 02 c0       	mov    $0xc002e50d,%eax
      break;
c0027617:	e9 65 ff ff ff       	jmp    c0027581 <print_stacktrace+0x30>
      status = "BLOCKED";
c002761c:	b8 6b cf 02 c0       	mov    $0xc002cf6b,%eax
      break;
c0027621:	e9 5b ff ff ff       	jmp    c0027581 <print_stacktrace+0x30>
      frame = __builtin_frame_address (1);
c0027626:	8b 5d 00             	mov    0x0(%ebp),%ebx
      retaddr = __builtin_return_address (0);
c0027629:	8b 45 04             	mov    0x4(%ebp),%eax
c002762c:	eb 8f                	jmp    c00275bd <print_stacktrace+0x6c>
          printf (" thread was never scheduled.\n");
c002762e:	83 ec 0c             	sub    $0xc,%esp
c0027631:	68 1b e5 02 c0       	push   $0xc002e51b
c0027636:	e8 53 1a 00 00       	call   c002908e <puts>
          return;
c002763b:	83 c4 10             	add    $0x10,%esp
c002763e:	eb cd                	jmp    c002760d <print_stacktrace+0xbc>

c0027640 <debug_panic>:
{
c0027640:	57                   	push   %edi
c0027641:	56                   	push   %esi
c0027642:	53                   	push   %ebx
c0027643:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0027647:	8b 74 24 14          	mov    0x14(%esp),%esi
c002764b:	8b 7c 24 18          	mov    0x18(%esp),%edi
  intr_disable ();
c002764f:	e8 2f 9a ff ff       	call   c0021083 <intr_disable>
  console_panic ();
c0027654:	e8 dc 19 00 00       	call   c0029035 <console_panic>
  level++;
c0027659:	a1 c0 82 03 c0       	mov    0xc00382c0,%eax
c002765e:	40                   	inc    %eax
c002765f:	a3 c0 82 03 c0       	mov    %eax,0xc00382c0
  if (level == 1) 
c0027664:	83 f8 01             	cmp    $0x1,%eax
c0027667:	74 11                	je     c002767a <debug_panic+0x3a>
  else if (level == 2)
c0027669:	83 f8 02             	cmp    $0x2,%eax
c002766c:	74 40                	je     c00276ae <debug_panic+0x6e>
  serial_flush ();
c002766e:	e8 d0 c4 ff ff       	call   c0023b43 <serial_flush>
  shutdown ();
c0027673:	e8 5c de ff ff       	call   c00254d4 <shutdown>
c0027678:	eb fe                	jmp    c0027678 <debug_panic+0x38>
      printf ("Kernel PANIC at %s:%d in %s(): ", file, line, function);
c002767a:	57                   	push   %edi
c002767b:	56                   	push   %esi
c002767c:	53                   	push   %ebx
c002767d:	68 60 e5 02 c0       	push   $0xc002e560
c0027682:	e8 0b e5 ff ff       	call   c0025b92 <printf>
      va_start (args, message);
c0027687:	8d 44 24 30          	lea    0x30(%esp),%eax
      vprintf (message, args);
c002768b:	83 c4 08             	add    $0x8,%esp
c002768e:	50                   	push   %eax
c002768f:	ff 74 24 28          	pushl  0x28(%esp)
c0027693:	e8 c2 19 00 00       	call   c002905a <vprintf>
      printf ("\n");
c0027698:	c7 04 24 0a 00 00 00 	movl   $0xa,(%esp)
c002769f:	e8 56 1a 00 00       	call   c00290fa <putchar>
      debug_backtrace ();
c00276a4:	e8 e6 de ff ff       	call   c002558f <debug_backtrace>
c00276a9:	83 c4 10             	add    $0x10,%esp
c00276ac:	eb c0                	jmp    c002766e <debug_panic+0x2e>
    printf ("Kernel PANIC recursion at %s:%d in %s().\n",
c00276ae:	57                   	push   %edi
c00276af:	56                   	push   %esi
c00276b0:	53                   	push   %ebx
c00276b1:	68 80 e5 02 c0       	push   $0xc002e580
c00276b6:	e8 d7 e4 ff ff       	call   c0025b92 <printf>
c00276bb:	83 c4 10             	add    $0x10,%esp
c00276be:	eb ae                	jmp    c002766e <debug_panic+0x2e>

c00276c0 <debug_backtrace_all>:

/* Prints call stack of all threads. */
void
debug_backtrace_all (void)
{
c00276c0:	53                   	push   %ebx
c00276c1:	83 ec 08             	sub    $0x8,%esp
  enum intr_level oldlevel = intr_disable ();
c00276c4:	e8 ba 99 ff ff       	call   c0021083 <intr_disable>
c00276c9:	89 c3                	mov    %eax,%ebx

  thread_foreach (print_stacktrace, 0);
c00276cb:	83 ec 08             	sub    $0x8,%esp
c00276ce:	6a 00                	push   $0x0
c00276d0:	68 51 75 02 c0       	push   $0xc0027551
c00276d5:	e8 3e 94 ff ff       	call   c0020b18 <thread_foreach>
  intr_set_level (oldlevel);
c00276da:	89 1c 24             	mov    %ebx,(%esp)
c00276dd:	e8 a8 99 ff ff       	call   c002108a <intr_set_level>
}
c00276e2:	83 c4 18             	add    $0x18,%esp
c00276e5:	5b                   	pop    %ebx
c00276e6:	c3                   	ret    

c00276e7 <list_init>:
}

/* Initializes LIST as an empty list. */
void
list_init (struct list *list)
{
c00276e7:	83 ec 0c             	sub    $0xc,%esp
c00276ea:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c00276ee:	85 c0                	test   %eax,%eax
c00276f0:	74 1a                	je     c002770c <list_init+0x25>
  list->head.prev = NULL;
c00276f2:	c7 00 00 00 00 00    	movl   $0x0,(%eax)
  list->head.next = &list->tail;
c00276f8:	8d 50 08             	lea    0x8(%eax),%edx
c00276fb:	89 50 04             	mov    %edx,0x4(%eax)
  list->tail.prev = &list->head;
c00276fe:	89 40 08             	mov    %eax,0x8(%eax)
  list->tail.next = NULL;
c0027701:	c7 40 0c 00 00 00 00 	movl   $0x0,0xc(%eax)
}
c0027708:	83 c4 0c             	add    $0xc,%esp
c002770b:	c3                   	ret    
  ASSERT (list != NULL);
c002770c:	83 ec 0c             	sub    $0xc,%esp
c002770f:	68 aa e5 02 c0       	push   $0xc002e5aa
c0027714:	68 df cb 02 c0       	push   $0xc002cbdf
c0027719:	68 b8 c7 02 c0       	push   $0xc002c7b8
c002771e:	6a 3f                	push   $0x3f
c0027720:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027725:	e8 16 ff ff ff       	call   c0027640 <debug_panic>

c002772a <list_begin>:

/* Returns the beginning of LIST.  */
struct list_elem *
list_begin (struct list *list)
{
c002772a:	83 ec 0c             	sub    $0xc,%esp
c002772d:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c0027731:	85 c0                	test   %eax,%eax
c0027733:	74 07                	je     c002773c <list_begin+0x12>
  return list->head.next;
c0027735:	8b 40 04             	mov    0x4(%eax),%eax
}
c0027738:	83 c4 0c             	add    $0xc,%esp
c002773b:	c3                   	ret    
  ASSERT (list != NULL);
c002773c:	83 ec 0c             	sub    $0xc,%esp
c002773f:	68 aa e5 02 c0       	push   $0xc002e5aa
c0027744:	68 df cb 02 c0       	push   $0xc002cbdf
c0027749:	68 ac c7 02 c0       	push   $0xc002c7ac
c002774e:	6a 4a                	push   $0x4a
c0027750:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027755:	e8 e6 fe ff ff       	call   c0027640 <debug_panic>

c002775a <list_next>:
/* Returns the element after ELEM in its list.  If ELEM is the
   last element in its list, returns the list tail.  Results are
   undefined if ELEM is itself a list tail. */
struct list_elem *
list_next (struct list_elem *elem)
{
c002775a:	83 ec 0c             	sub    $0xc,%esp
c002775d:	8b 44 24 10          	mov    0x10(%esp),%eax
  return elem != NULL && elem->prev == NULL && elem->next != NULL;
c0027761:	85 c0                	test   %eax,%eax
c0027763:	74 1f                	je     c0027784 <list_next+0x2a>
c0027765:	83 38 00             	cmpl   $0x0,(%eax)
c0027768:	74 12                	je     c002777c <list_next+0x22>
  return elem != NULL && elem->prev != NULL && elem->next != NULL;
c002776a:	83 38 00             	cmpl   $0x0,(%eax)
c002776d:	74 15                	je     c0027784 <list_next+0x2a>
c002776f:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0027773:	74 0f                	je     c0027784 <list_next+0x2a>
  ASSERT (is_head (elem) || is_interior (elem));
  return elem->next;
c0027775:	8b 40 04             	mov    0x4(%eax),%eax
}
c0027778:	83 c4 0c             	add    $0xc,%esp
c002777b:	c3                   	ret    
  return elem != NULL && elem->prev == NULL && elem->next != NULL;
c002777c:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0027780:	75 f3                	jne    c0027775 <list_next+0x1b>
c0027782:	eb e6                	jmp    c002776a <list_next+0x10>
  ASSERT (is_head (elem) || is_interior (elem));
c0027784:	83 ec 0c             	sub    $0xc,%esp
c0027787:	68 6c e6 02 c0       	push   $0xc002e66c
c002778c:	68 df cb 02 c0       	push   $0xc002cbdf
c0027791:	68 a0 c7 02 c0       	push   $0xc002c7a0
c0027796:	6a 54                	push   $0x54
c0027798:	68 b7 e5 02 c0       	push   $0xc002e5b7
c002779d:	e8 9e fe ff ff       	call   c0027640 <debug_panic>

c00277a2 <list_end>:
   list_end() is often used in iterating through a list from
   front to back.  See the big comment at the top of list.h for
   an example. */
struct list_elem *
list_end (struct list *list)
{
c00277a2:	83 ec 0c             	sub    $0xc,%esp
c00277a5:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c00277a9:	85 c0                	test   %eax,%eax
c00277ab:	74 07                	je     c00277b4 <list_end+0x12>
  return &list->tail;
c00277ad:	83 c0 08             	add    $0x8,%eax
}
c00277b0:	83 c4 0c             	add    $0xc,%esp
c00277b3:	c3                   	ret    
  ASSERT (list != NULL);
c00277b4:	83 ec 0c             	sub    $0xc,%esp
c00277b7:	68 aa e5 02 c0       	push   $0xc002e5aa
c00277bc:	68 df cb 02 c0       	push   $0xc002cbdf
c00277c1:	68 94 c7 02 c0       	push   $0xc002c794
c00277c6:	6a 60                	push   $0x60
c00277c8:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00277cd:	e8 6e fe ff ff       	call   c0027640 <debug_panic>

c00277d2 <list_rbegin>:

/* Returns the LIST's reverse beginning, for iterating through
   LIST in reverse order, from back to front. */
struct list_elem *
list_rbegin (struct list *list) 
{
c00277d2:	83 ec 0c             	sub    $0xc,%esp
c00277d5:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c00277d9:	85 c0                	test   %eax,%eax
c00277db:	74 07                	je     c00277e4 <list_rbegin+0x12>
  return list->tail.prev;
c00277dd:	8b 40 08             	mov    0x8(%eax),%eax
}
c00277e0:	83 c4 0c             	add    $0xc,%esp
c00277e3:	c3                   	ret    
  ASSERT (list != NULL);
c00277e4:	83 ec 0c             	sub    $0xc,%esp
c00277e7:	68 aa e5 02 c0       	push   $0xc002e5aa
c00277ec:	68 df cb 02 c0       	push   $0xc002cbdf
c00277f1:	68 88 c7 02 c0       	push   $0xc002c788
c00277f6:	6a 69                	push   $0x69
c00277f8:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00277fd:	e8 3e fe ff ff       	call   c0027640 <debug_panic>

c0027802 <list_prev>:
/* Returns the element before ELEM in its list.  If ELEM is the
   first element in its list, returns the list head.  Results are
   undefined if ELEM is itself a list head. */
struct list_elem *
list_prev (struct list_elem *elem)
{
c0027802:	83 ec 0c             	sub    $0xc,%esp
c0027805:	8b 44 24 10          	mov    0x10(%esp),%eax
  return elem != NULL && elem->prev != NULL && elem->next != NULL;
c0027809:	85 c0                	test   %eax,%eax
c002780b:	74 1c                	je     c0027829 <list_prev+0x27>
c002780d:	83 38 00             	cmpl   $0x0,(%eax)
c0027810:	74 0c                	je     c002781e <list_prev+0x1c>
c0027812:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0027816:	74 06                	je     c002781e <list_prev+0x1c>
  ASSERT (is_interior (elem) || is_tail (elem));
  return elem->prev;
c0027818:	8b 00                	mov    (%eax),%eax
}
c002781a:	83 c4 0c             	add    $0xc,%esp
c002781d:	c3                   	ret    
  return elem != NULL && elem->prev != NULL && elem->next == NULL;
c002781e:	83 38 00             	cmpl   $0x0,(%eax)
c0027821:	74 06                	je     c0027829 <list_prev+0x27>
c0027823:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0027827:	74 ef                	je     c0027818 <list_prev+0x16>
  ASSERT (is_interior (elem) || is_tail (elem));
c0027829:	83 ec 0c             	sub    $0xc,%esp
c002782c:	68 94 e6 02 c0       	push   $0xc002e694
c0027831:	68 df cb 02 c0       	push   $0xc002cbdf
c0027836:	68 7c c7 02 c0       	push   $0xc002c77c
c002783b:	6a 73                	push   $0x73
c002783d:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027842:	e8 f9 fd ff ff       	call   c0027640 <debug_panic>

c0027847 <find_end_of_run>:
   run.
   A through B (exclusive) must form a non-empty range. */
static struct list_elem *
find_end_of_run (struct list_elem *a, struct list_elem *b,
                 list_less_func *less, void *aux)
{
c0027847:	55                   	push   %ebp
c0027848:	57                   	push   %edi
c0027849:	56                   	push   %esi
c002784a:	53                   	push   %ebx
c002784b:	83 ec 0c             	sub    $0xc,%esp
c002784e:	8b 6c 24 20          	mov    0x20(%esp),%ebp
  ASSERT (a != NULL);
c0027852:	85 c0                	test   %eax,%eax
c0027854:	74 50                	je     c00278a6 <find_end_of_run+0x5f>
c0027856:	89 c3                	mov    %eax,%ebx
c0027858:	89 d6                	mov    %edx,%esi
c002785a:	89 cf                	mov    %ecx,%edi
  ASSERT (b != NULL);
c002785c:	85 d2                	test   %edx,%edx
c002785e:	74 67                	je     c00278c7 <find_end_of_run+0x80>
  ASSERT (less != NULL);
c0027860:	85 c9                	test   %ecx,%ecx
c0027862:	0f 84 80 00 00 00    	je     c00278e8 <find_end_of_run+0xa1>
  ASSERT (a != b);
c0027868:	39 d0                	cmp    %edx,%eax
c002786a:	0f 84 99 00 00 00    	je     c0027909 <find_end_of_run+0xc2>
  
  do 
    {
      a = list_next (a);
c0027870:	83 ec 0c             	sub    $0xc,%esp
c0027873:	53                   	push   %ebx
c0027874:	e8 e1 fe ff ff       	call   c002775a <list_next>
c0027879:	83 c4 10             	add    $0x10,%esp
c002787c:	89 c3                	mov    %eax,%ebx
    }
  while (a != b && !less (a, list_prev (a), aux));
c002787e:	39 c6                	cmp    %eax,%esi
c0027880:	74 1a                	je     c002789c <find_end_of_run+0x55>
c0027882:	83 ec 0c             	sub    $0xc,%esp
c0027885:	50                   	push   %eax
c0027886:	e8 77 ff ff ff       	call   c0027802 <list_prev>
c002788b:	83 c4 0c             	add    $0xc,%esp
c002788e:	55                   	push   %ebp
c002788f:	50                   	push   %eax
c0027890:	53                   	push   %ebx
c0027891:	ff d7                	call   *%edi
c0027893:	83 c4 10             	add    $0x10,%esp
c0027896:	84 c0                	test   %al,%al
c0027898:	74 d6                	je     c0027870 <find_end_of_run+0x29>
      a = list_next (a);
c002789a:	89 de                	mov    %ebx,%esi
  return a;
}
c002789c:	89 f0                	mov    %esi,%eax
c002789e:	83 c4 0c             	add    $0xc,%esp
c00278a1:	5b                   	pop    %ebx
c00278a2:	5e                   	pop    %esi
c00278a3:	5f                   	pop    %edi
c00278a4:	5d                   	pop    %ebp
c00278a5:	c3                   	ret    
  ASSERT (a != NULL);
c00278a6:	83 ec 0c             	sub    $0xc,%esp
c00278a9:	68 2d d4 02 c0       	push   $0xc002d42d
c00278ae:	68 df cb 02 c0       	push   $0xc002cbdf
c00278b3:	68 00 c7 02 c0       	push   $0xc002c700
c00278b8:	68 69 01 00 00       	push   $0x169
c00278bd:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00278c2:	e8 79 fd ff ff       	call   c0027640 <debug_panic>
  ASSERT (b != NULL);
c00278c7:	83 ec 0c             	sub    $0xc,%esp
c00278ca:	68 cf e5 02 c0       	push   $0xc002e5cf
c00278cf:	68 df cb 02 c0       	push   $0xc002cbdf
c00278d4:	68 00 c7 02 c0       	push   $0xc002c700
c00278d9:	68 6a 01 00 00       	push   $0x16a
c00278de:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00278e3:	e8 58 fd ff ff       	call   c0027640 <debug_panic>
  ASSERT (less != NULL);
c00278e8:	83 ec 0c             	sub    $0xc,%esp
c00278eb:	68 d9 e5 02 c0       	push   $0xc002e5d9
c00278f0:	68 df cb 02 c0       	push   $0xc002cbdf
c00278f5:	68 00 c7 02 c0       	push   $0xc002c700
c00278fa:	68 6b 01 00 00       	push   $0x16b
c00278ff:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027904:	e8 37 fd ff ff       	call   c0027640 <debug_panic>
  ASSERT (a != b);
c0027909:	83 ec 0c             	sub    $0xc,%esp
c002790c:	68 e6 e5 02 c0       	push   $0xc002e5e6
c0027911:	68 df cb 02 c0       	push   $0xc002cbdf
c0027916:	68 00 c7 02 c0       	push   $0xc002c700
c002791b:	68 6c 01 00 00       	push   $0x16c
c0027920:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027925:	e8 16 fd ff ff       	call   c0027640 <debug_panic>

c002792a <is_sorted>:
{
c002792a:	55                   	push   %ebp
c002792b:	57                   	push   %edi
c002792c:	56                   	push   %esi
c002792d:	53                   	push   %ebx
c002792e:	83 ec 0c             	sub    $0xc,%esp
c0027931:	89 c3                	mov    %eax,%ebx
c0027933:	89 d6                	mov    %edx,%esi
c0027935:	89 cd                	mov    %ecx,%ebp
c0027937:	8b 7c 24 20          	mov    0x20(%esp),%edi
  if (a != b)
c002793b:	39 d0                	cmp    %edx,%eax
c002793d:	74 2e                	je     c002796d <is_sorted+0x43>
    while ((a = list_next (a)) != b) 
c002793f:	83 ec 0c             	sub    $0xc,%esp
c0027942:	53                   	push   %ebx
c0027943:	e8 12 fe ff ff       	call   c002775a <list_next>
c0027948:	83 c4 10             	add    $0x10,%esp
c002794b:	89 c3                	mov    %eax,%ebx
c002794d:	39 c6                	cmp    %eax,%esi
c002794f:	74 20                	je     c0027971 <is_sorted+0x47>
      if (less (a, list_prev (a), aux))
c0027951:	83 ec 0c             	sub    $0xc,%esp
c0027954:	53                   	push   %ebx
c0027955:	e8 a8 fe ff ff       	call   c0027802 <list_prev>
c002795a:	83 c4 0c             	add    $0xc,%esp
c002795d:	57                   	push   %edi
c002795e:	50                   	push   %eax
c002795f:	53                   	push   %ebx
c0027960:	ff d5                	call   *%ebp
c0027962:	83 c4 10             	add    $0x10,%esp
c0027965:	84 c0                	test   %al,%al
c0027967:	74 d6                	je     c002793f <is_sorted+0x15>
        return false;
c0027969:	b0 00                	mov    $0x0,%al
c002796b:	eb 06                	jmp    c0027973 <is_sorted+0x49>
  return true;
c002796d:	b0 01                	mov    $0x1,%al
c002796f:	eb 02                	jmp    c0027973 <is_sorted+0x49>
c0027971:	b0 01                	mov    $0x1,%al
}
c0027973:	83 c4 0c             	add    $0xc,%esp
c0027976:	5b                   	pop    %ebx
c0027977:	5e                   	pop    %esi
c0027978:	5f                   	pop    %edi
c0027979:	5d                   	pop    %ebp
c002797a:	c3                   	ret    

c002797b <list_rend>:
{
c002797b:	83 ec 0c             	sub    $0xc,%esp
c002797e:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c0027982:	85 c0                	test   %eax,%eax
c0027984:	74 04                	je     c002798a <list_rend+0xf>
}
c0027986:	83 c4 0c             	add    $0xc,%esp
c0027989:	c3                   	ret    
  ASSERT (list != NULL);
c002798a:	83 ec 0c             	sub    $0xc,%esp
c002798d:	68 aa e5 02 c0       	push   $0xc002e5aa
c0027992:	68 df cb 02 c0       	push   $0xc002cbdf
c0027997:	68 70 c7 02 c0       	push   $0xc002c770
c002799c:	68 87 00 00 00       	push   $0x87
c00279a1:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00279a6:	e8 95 fc ff ff       	call   c0027640 <debug_panic>

c00279ab <list_head>:
{
c00279ab:	83 ec 0c             	sub    $0xc,%esp
c00279ae:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c00279b2:	85 c0                	test   %eax,%eax
c00279b4:	74 04                	je     c00279ba <list_head+0xf>
}
c00279b6:	83 c4 0c             	add    $0xc,%esp
c00279b9:	c3                   	ret    
  ASSERT (list != NULL);
c00279ba:	83 ec 0c             	sub    $0xc,%esp
c00279bd:	68 aa e5 02 c0       	push   $0xc002e5aa
c00279c2:	68 df cb 02 c0       	push   $0xc002cbdf
c00279c7:	68 64 c7 02 c0       	push   $0xc002c764
c00279cc:	68 99 00 00 00       	push   $0x99
c00279d1:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00279d6:	e8 65 fc ff ff       	call   c0027640 <debug_panic>

c00279db <list_tail>:
{
c00279db:	83 ec 0c             	sub    $0xc,%esp
c00279de:	8b 44 24 10          	mov    0x10(%esp),%eax
  ASSERT (list != NULL);
c00279e2:	85 c0                	test   %eax,%eax
c00279e4:	74 07                	je     c00279ed <list_tail+0x12>
  return &list->tail;
c00279e6:	83 c0 08             	add    $0x8,%eax
}
c00279e9:	83 c4 0c             	add    $0xc,%esp
c00279ec:	c3                   	ret    
  ASSERT (list != NULL);
c00279ed:	83 ec 0c             	sub    $0xc,%esp
c00279f0:	68 aa e5 02 c0       	push   $0xc002e5aa
c00279f5:	68 df cb 02 c0       	push   $0xc002cbdf
c00279fa:	68 58 c7 02 c0       	push   $0xc002c758
c00279ff:	68 a1 00 00 00       	push   $0xa1
c0027a04:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027a09:	e8 32 fc ff ff       	call   c0027640 <debug_panic>

c0027a0e <list_insert>:
{
c0027a0e:	83 ec 0c             	sub    $0xc,%esp
c0027a11:	8b 44 24 10          	mov    0x10(%esp),%eax
c0027a15:	8b 54 24 14          	mov    0x14(%esp),%edx
  return elem != NULL && elem->prev != NULL && elem->next != NULL;
c0027a19:	85 c0                	test   %eax,%eax
c0027a1b:	74 2c                	je     c0027a49 <list_insert+0x3b>
c0027a1d:	83 38 00             	cmpl   $0x0,(%eax)
c0027a20:	74 1c                	je     c0027a3e <list_insert+0x30>
c0027a22:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0027a26:	74 16                	je     c0027a3e <list_insert+0x30>
  ASSERT (elem != NULL);
c0027a28:	85 d2                	test   %edx,%edx
c0027a2a:	74 3e                	je     c0027a6a <list_insert+0x5c>
  elem->prev = before->prev;
c0027a2c:	8b 08                	mov    (%eax),%ecx
c0027a2e:	89 0a                	mov    %ecx,(%edx)
  elem->next = before;
c0027a30:	89 42 04             	mov    %eax,0x4(%edx)
  before->prev->next = elem;
c0027a33:	8b 08                	mov    (%eax),%ecx
c0027a35:	89 51 04             	mov    %edx,0x4(%ecx)
  before->prev = elem;
c0027a38:	89 10                	mov    %edx,(%eax)
}
c0027a3a:	83 c4 0c             	add    $0xc,%esp
c0027a3d:	c3                   	ret    
  return elem != NULL && elem->prev != NULL && elem->next == NULL;
c0027a3e:	83 38 00             	cmpl   $0x0,(%eax)
c0027a41:	74 06                	je     c0027a49 <list_insert+0x3b>
c0027a43:	83 78 04 00          	cmpl   $0x0,0x4(%eax)
c0027a47:	74 df                	je     c0027a28 <list_insert+0x1a>
  ASSERT (is_interior (before) || is_tail (before));
c0027a49:	83 ec 0c             	sub    $0xc,%esp
c0027a4c:	68 bc e6 02 c0       	push   $0xc002e6bc
c0027a51:	68 df cb 02 c0       	push   $0xc002cbdf
c0027a56:	68 4c c7 02 c0       	push   $0xc002c74c
c0027a5b:	68 ab 00 00 00       	push   $0xab
c0027a60:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027a65:	e8 d6 fb ff ff       	call   c0027640 <debug_panic>
  ASSERT (elem != NULL);
c0027a6a:	83 ec 0c             	sub    $0xc,%esp
c0027a6d:	68 ed e5 02 c0       	push   $0xc002e5ed
c0027a72:	68 df cb 02 c0       	push   $0xc002cbdf
c0027a77:	68 4c c7 02 c0       	push   $0xc002c74c
c0027a7c:	68 ac 00 00 00       	push   $0xac
c0027a81:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027a86:	e8 b5 fb ff ff       	call   c0027640 <debug_panic>

c0027a8b <list_splice>:
{
c0027a8b:	56                   	push   %esi
c0027a8c:	53                   	push   %ebx
c0027a8d:	83 ec 04             	sub    $0x4,%esp
c0027a90:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0027a94:	8b 74 24 14          	mov    0x14(%esp),%esi
c0027a98:	8b 44 24 18          	mov    0x18(%esp),%eax
  return elem != NULL && elem->prev != NULL && elem->next != NULL;
c0027a9c:	85 db                	test   %ebx,%ebx
c0027a9e:	74 64                	je     c0027b04 <list_splice+0x79>
c0027aa0:	83 3b 00             	cmpl   $0x0,(%ebx)
c0027aa3:	74 54                	je     c0027af9 <list_splice+0x6e>
c0027aa5:	83 7b 04 00          	cmpl   $0x0,0x4(%ebx)
c0027aa9:	74 4e                	je     c0027af9 <list_splice+0x6e>
  if (first == last)
c0027aab:	39 c6                	cmp    %eax,%esi
c0027aad:	74 44                	je     c0027af3 <list_splice+0x68>
  last = list_prev (last);
c0027aaf:	83 ec 0c             	sub    $0xc,%esp
c0027ab2:	50                   	push   %eax
c0027ab3:	e8 4a fd ff ff       	call   c0027802 <list_prev>
c0027ab8:	83 c4 10             	add    $0x10,%esp
  return elem != NULL && elem->prev != NULL && elem->next != NULL;
c0027abb:	85 f6                	test   %esi,%esi
c0027abd:	74 66                	je     c0027b25 <list_splice+0x9a>
c0027abf:	8b 16                	mov    (%esi),%edx
c0027ac1:	85 d2                	test   %edx,%edx
c0027ac3:	74 60                	je     c0027b25 <list_splice+0x9a>
c0027ac5:	83 7e 04 00          	cmpl   $0x0,0x4(%esi)
c0027ac9:	74 5a                	je     c0027b25 <list_splice+0x9a>
c0027acb:	85 c0                	test   %eax,%eax
c0027acd:	74 77                	je     c0027b46 <list_splice+0xbb>
c0027acf:	83 38 00             	cmpl   $0x0,(%eax)
c0027ad2:	74 72                	je     c0027b46 <list_splice+0xbb>
c0027ad4:	8b 48 04             	mov    0x4(%eax),%ecx
c0027ad7:	85 c9                	test   %ecx,%ecx
c0027ad9:	74 6b                	je     c0027b46 <list_splice+0xbb>
  first->prev->next = last->next;
c0027adb:	89 4a 04             	mov    %ecx,0x4(%edx)
  last->next->prev = first->prev;
c0027ade:	8b 50 04             	mov    0x4(%eax),%edx
c0027ae1:	8b 0e                	mov    (%esi),%ecx
c0027ae3:	89 0a                	mov    %ecx,(%edx)
  first->prev = before->prev;
c0027ae5:	8b 13                	mov    (%ebx),%edx
c0027ae7:	89 16                	mov    %edx,(%esi)
  last->next = before;
c0027ae9:	89 58 04             	mov    %ebx,0x4(%eax)
  before->prev->next = first;
c0027aec:	8b 13                	mov    (%ebx),%edx
c0027aee:	89 72 04             	mov    %esi,0x4(%edx)
  before->prev = last;
c0027af1:	89 03                	mov    %eax,(%ebx)
}
c0027af3:	83 c4 04             	add    $0x4,%esp
c0027af6:	5b                   	pop    %ebx
c0027af7:	5e                   	pop    %esi
c0027af8:	c3                   	ret    
  return elem != NULL && elem->prev != NULL && elem->next == NULL;
c0027af9:	83 3b 00             	cmpl   $0x0,(%ebx)
c0027afc:	74 06                	je     c0027b04 <list_splice+0x79>
c0027afe:	83 7b 04 00          	cmpl   $0x0,0x4(%ebx)
c0027b02:	74 a7                	je     c0027aab <list_splice+0x20>
  ASSERT (is_interior (before) || is_tail (before));
c0027b04:	83 ec 0c             	sub    $0xc,%esp
c0027b07:	68 bc e6 02 c0       	push   $0xc002e6bc
c0027b0c:	68 df cb 02 c0       	push   $0xc002cbdf
c0027b11:	68 40 c7 02 c0       	push   $0xc002c740
c0027b16:	68 bb 00 00 00       	push   $0xbb
c0027b1b:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027b20:	e8 1b fb ff ff       	call   c0027640 <debug_panic>
  ASSERT (is_interior (first));
c0027b25:	83 ec 0c             	sub    $0xc,%esp
c0027b28:	68 fa e5 02 c0       	push   $0xc002e5fa
c0027b2d:	68 df cb 02 c0       	push   $0xc002cbdf
c0027b32:	68 40 c7 02 c0       	push   $0xc002c740
c0027b37:	68 c0 00 00 00       	push   $0xc0
c0027b3c:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027b41:	e8 fa fa ff ff       	call   c0027640 <debug_panic>
  ASSERT (is_interior (last));
c0027b46:	83 ec 0c             	sub    $0xc,%esp
c0027b49:	68 0e e6 02 c0       	push   $0xc002e60e
c0027b4e:	68 df cb 02 c0       	push   $0xc002cbdf
c0027b53:	68 40 c7 02 c0       	push   $0xc002c740
c0027b58:	68 c1 00 00 00       	push   $0xc1
c0027b5d:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027b62:	e8 d9 fa ff ff       	call   c0027640 <debug_panic>

c0027b67 <list_push_front>:
{
c0027b67:	83 ec 18             	sub    $0x18,%esp
  list_insert (list_begin (list), elem);
c0027b6a:	ff 74 24 1c          	pushl  0x1c(%esp)
c0027b6e:	e8 b7 fb ff ff       	call   c002772a <list_begin>
c0027b73:	83 c4 08             	add    $0x8,%esp
c0027b76:	ff 74 24 1c          	pushl  0x1c(%esp)
c0027b7a:	50                   	push   %eax
c0027b7b:	e8 8e fe ff ff       	call   c0027a0e <list_insert>
}
c0027b80:	83 c4 1c             	add    $0x1c,%esp
c0027b83:	c3                   	ret    

c0027b84 <list_push_back>:
{
c0027b84:	83 ec 18             	sub    $0x18,%esp
  list_insert (list_end (list), elem);
c0027b87:	ff 74 24 1c          	pushl  0x1c(%esp)
c0027b8b:	e8 12 fc ff ff       	call   c00277a2 <list_end>
c0027b90:	83 c4 08             	add    $0x8,%esp
c0027b93:	ff 74 24 1c          	pushl  0x1c(%esp)
c0027b97:	50                   	push   %eax
c0027b98:	e8 71 fe ff ff       	call   c0027a0e <list_insert>
}
c0027b9d:	83 c4 1c             	add    $0x1c,%esp
c0027ba0:	c3                   	ret    

c0027ba1 <list_remove>:
{
c0027ba1:	83 ec 0c             	sub    $0xc,%esp
c0027ba4:	8b 44 24 10          	mov    0x10(%esp),%eax
  return elem != NULL && elem->prev != NULL && elem->next != NULL;
c0027ba8:	85 c0                	test   %eax,%eax
c0027baa:	74 1e                	je     c0027bca <list_remove+0x29>
c0027bac:	8b 10                	mov    (%eax),%edx
c0027bae:	85 d2                	test   %edx,%edx
c0027bb0:	74 18                	je     c0027bca <list_remove+0x29>
c0027bb2:	8b 48 04             	mov    0x4(%eax),%ecx
c0027bb5:	85 c9                	test   %ecx,%ecx
c0027bb7:	74 11                	je     c0027bca <list_remove+0x29>
  elem->prev->next = elem->next;
c0027bb9:	89 4a 04             	mov    %ecx,0x4(%edx)
  elem->next->prev = elem->prev;
c0027bbc:	8b 50 04             	mov    0x4(%eax),%edx
c0027bbf:	8b 08                	mov    (%eax),%ecx
c0027bc1:	89 0a                	mov    %ecx,(%edx)
  return elem->next;
c0027bc3:	8b 40 04             	mov    0x4(%eax),%eax
}
c0027bc6:	83 c4 0c             	add    $0xc,%esp
c0027bc9:	c3                   	ret    
  ASSERT (is_interior (elem));
c0027bca:	83 ec 0c             	sub    $0xc,%esp
c0027bcd:	68 21 e6 02 c0       	push   $0xc002e621
c0027bd2:	68 df cb 02 c0       	push   $0xc002cbdf
c0027bd7:	68 34 c7 02 c0       	push   $0xc002c734
c0027bdc:	68 fb 00 00 00       	push   $0xfb
c0027be1:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027be6:	e8 55 fa ff ff       	call   c0027640 <debug_panic>

c0027beb <list_size>:
{
c0027beb:	57                   	push   %edi
c0027bec:	56                   	push   %esi
c0027bed:	53                   	push   %ebx
c0027bee:	8b 7c 24 10          	mov    0x10(%esp),%edi
  for (e = list_begin (list); e != list_end (list); e = list_next (e))
c0027bf2:	83 ec 0c             	sub    $0xc,%esp
c0027bf5:	57                   	push   %edi
c0027bf6:	e8 2f fb ff ff       	call   c002772a <list_begin>
c0027bfb:	83 c4 10             	add    $0x10,%esp
c0027bfe:	89 c3                	mov    %eax,%ebx
  size_t cnt = 0;
c0027c00:	be 00 00 00 00       	mov    $0x0,%esi
  for (e = list_begin (list); e != list_end (list); e = list_next (e))
c0027c05:	eb 0f                	jmp    c0027c16 <list_size+0x2b>
    cnt++;
c0027c07:	46                   	inc    %esi
  for (e = list_begin (list); e != list_end (list); e = list_next (e))
c0027c08:	83 ec 0c             	sub    $0xc,%esp
c0027c0b:	53                   	push   %ebx
c0027c0c:	e8 49 fb ff ff       	call   c002775a <list_next>
c0027c11:	83 c4 10             	add    $0x10,%esp
c0027c14:	89 c3                	mov    %eax,%ebx
c0027c16:	83 ec 0c             	sub    $0xc,%esp
c0027c19:	57                   	push   %edi
c0027c1a:	e8 83 fb ff ff       	call   c00277a2 <list_end>
c0027c1f:	83 c4 10             	add    $0x10,%esp
c0027c22:	39 c3                	cmp    %eax,%ebx
c0027c24:	75 e1                	jne    c0027c07 <list_size+0x1c>
}
c0027c26:	89 f0                	mov    %esi,%eax
c0027c28:	5b                   	pop    %ebx
c0027c29:	5e                   	pop    %esi
c0027c2a:	5f                   	pop    %edi
c0027c2b:	c3                   	ret    

c0027c2c <list_empty>:
{
c0027c2c:	56                   	push   %esi
c0027c2d:	53                   	push   %ebx
c0027c2e:	83 ec 10             	sub    $0x10,%esp
c0027c31:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  return list_begin (list) == list_end (list);
c0027c35:	53                   	push   %ebx
c0027c36:	e8 ef fa ff ff       	call   c002772a <list_begin>
c0027c3b:	89 c6                	mov    %eax,%esi
c0027c3d:	89 1c 24             	mov    %ebx,(%esp)
c0027c40:	e8 5d fb ff ff       	call   c00277a2 <list_end>
c0027c45:	39 c6                	cmp    %eax,%esi
c0027c47:	0f 94 c0             	sete   %al
}
c0027c4a:	83 c4 14             	add    $0x14,%esp
c0027c4d:	5b                   	pop    %ebx
c0027c4e:	5e                   	pop    %esi
c0027c4f:	c3                   	ret    

c0027c50 <list_front>:
{
c0027c50:	53                   	push   %ebx
c0027c51:	83 ec 14             	sub    $0x14,%esp
c0027c54:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  ASSERT (!list_empty (list));
c0027c58:	53                   	push   %ebx
c0027c59:	e8 ce ff ff ff       	call   c0027c2c <list_empty>
c0027c5e:	83 c4 10             	add    $0x10,%esp
c0027c61:	84 c0                	test   %al,%al
c0027c63:	75 08                	jne    c0027c6d <list_front+0x1d>
  return list->head.next;
c0027c65:	8b 43 04             	mov    0x4(%ebx),%eax
}
c0027c68:	83 c4 08             	add    $0x8,%esp
c0027c6b:	5b                   	pop    %ebx
c0027c6c:	c3                   	ret    
  ASSERT (!list_empty (list));
c0027c6d:	83 ec 0c             	sub    $0xc,%esp
c0027c70:	68 34 e6 02 c0       	push   $0xc002e634
c0027c75:	68 df cb 02 c0       	push   $0xc002cbdf
c0027c7a:	68 28 c7 02 c0       	push   $0xc002c728
c0027c7f:	68 1a 01 00 00       	push   $0x11a
c0027c84:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027c89:	e8 b2 f9 ff ff       	call   c0027640 <debug_panic>

c0027c8e <list_pop_front>:
{
c0027c8e:	53                   	push   %ebx
c0027c8f:	83 ec 14             	sub    $0x14,%esp
  struct list_elem *front = list_front (list);
c0027c92:	ff 74 24 1c          	pushl  0x1c(%esp)
c0027c96:	e8 b5 ff ff ff       	call   c0027c50 <list_front>
c0027c9b:	89 c3                	mov    %eax,%ebx
  list_remove (front);
c0027c9d:	89 04 24             	mov    %eax,(%esp)
c0027ca0:	e8 fc fe ff ff       	call   c0027ba1 <list_remove>
}
c0027ca5:	89 d8                	mov    %ebx,%eax
c0027ca7:	83 c4 18             	add    $0x18,%esp
c0027caa:	5b                   	pop    %ebx
c0027cab:	c3                   	ret    

c0027cac <list_back>:
{
c0027cac:	53                   	push   %ebx
c0027cad:	83 ec 14             	sub    $0x14,%esp
c0027cb0:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  ASSERT (!list_empty (list));
c0027cb4:	53                   	push   %ebx
c0027cb5:	e8 72 ff ff ff       	call   c0027c2c <list_empty>
c0027cba:	83 c4 10             	add    $0x10,%esp
c0027cbd:	84 c0                	test   %al,%al
c0027cbf:	75 08                	jne    c0027cc9 <list_back+0x1d>
  return list->tail.prev;
c0027cc1:	8b 43 08             	mov    0x8(%ebx),%eax
}
c0027cc4:	83 c4 08             	add    $0x8,%esp
c0027cc7:	5b                   	pop    %ebx
c0027cc8:	c3                   	ret    
  ASSERT (!list_empty (list));
c0027cc9:	83 ec 0c             	sub    $0xc,%esp
c0027ccc:	68 34 e6 02 c0       	push   $0xc002e634
c0027cd1:	68 df cb 02 c0       	push   $0xc002cbdf
c0027cd6:	68 1c c7 02 c0       	push   $0xc002c71c
c0027cdb:	68 23 01 00 00       	push   $0x123
c0027ce0:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027ce5:	e8 56 f9 ff ff       	call   c0027640 <debug_panic>

c0027cea <list_pop_back>:
{
c0027cea:	53                   	push   %ebx
c0027ceb:	83 ec 14             	sub    $0x14,%esp
  struct list_elem *back = list_back (list);
c0027cee:	ff 74 24 1c          	pushl  0x1c(%esp)
c0027cf2:	e8 b5 ff ff ff       	call   c0027cac <list_back>
c0027cf7:	89 c3                	mov    %eax,%ebx
  list_remove (back);
c0027cf9:	89 04 24             	mov    %eax,(%esp)
c0027cfc:	e8 a0 fe ff ff       	call   c0027ba1 <list_remove>
}
c0027d01:	89 d8                	mov    %ebx,%eax
c0027d03:	83 c4 18             	add    $0x18,%esp
c0027d06:	5b                   	pop    %ebx
c0027d07:	c3                   	ret    

c0027d08 <list_reverse>:
{
c0027d08:	56                   	push   %esi
c0027d09:	53                   	push   %ebx
c0027d0a:	83 ec 10             	sub    $0x10,%esp
c0027d0d:	8b 74 24 1c          	mov    0x1c(%esp),%esi
  if (!list_empty (list)) 
c0027d11:	56                   	push   %esi
c0027d12:	e8 15 ff ff ff       	call   c0027c2c <list_empty>
c0027d17:	83 c4 10             	add    $0x10,%esp
c0027d1a:	84 c0                	test   %al,%al
c0027d1c:	74 06                	je     c0027d24 <list_reverse+0x1c>
}
c0027d1e:	83 c4 04             	add    $0x4,%esp
c0027d21:	5b                   	pop    %ebx
c0027d22:	5e                   	pop    %esi
c0027d23:	c3                   	ret    
      for (e = list_begin (list); e != list_end (list); e = e->prev)
c0027d24:	83 ec 0c             	sub    $0xc,%esp
c0027d27:	56                   	push   %esi
c0027d28:	e8 fd f9 ff ff       	call   c002772a <list_begin>
c0027d2d:	83 c4 10             	add    $0x10,%esp
c0027d30:	89 c3                	mov    %eax,%ebx
c0027d32:	eb 0c                	jmp    c0027d40 <list_reverse+0x38>
  struct list_elem *t = *a;
c0027d34:	8b 13                	mov    (%ebx),%edx
  *a = *b;
c0027d36:	8b 43 04             	mov    0x4(%ebx),%eax
c0027d39:	89 03                	mov    %eax,(%ebx)
  *b = t;
c0027d3b:	89 53 04             	mov    %edx,0x4(%ebx)
      for (e = list_begin (list); e != list_end (list); e = e->prev)
c0027d3e:	89 c3                	mov    %eax,%ebx
c0027d40:	83 ec 0c             	sub    $0xc,%esp
c0027d43:	56                   	push   %esi
c0027d44:	e8 59 fa ff ff       	call   c00277a2 <list_end>
c0027d49:	83 c4 10             	add    $0x10,%esp
c0027d4c:	39 c3                	cmp    %eax,%ebx
c0027d4e:	75 e4                	jne    c0027d34 <list_reverse+0x2c>
  struct list_elem *t = *a;
c0027d50:	8b 46 04             	mov    0x4(%esi),%eax
  *a = *b;
c0027d53:	8b 56 08             	mov    0x8(%esi),%edx
c0027d56:	89 56 04             	mov    %edx,0x4(%esi)
  *b = t;
c0027d59:	89 46 08             	mov    %eax,0x8(%esi)
  struct list_elem *t = *a;
c0027d5c:	8b 0a                	mov    (%edx),%ecx
  *a = *b;
c0027d5e:	8b 58 04             	mov    0x4(%eax),%ebx
c0027d61:	89 1a                	mov    %ebx,(%edx)
  *b = t;
c0027d63:	89 48 04             	mov    %ecx,0x4(%eax)
}
c0027d66:	eb b6                	jmp    c0027d1e <list_reverse+0x16>

c0027d68 <list_sort>:
/* Sorts LIST according to LESS given auxiliary data AUX, using a
   natural iterative merge sort that runs in O(n lg n) time and
   O(1) space in the number of elements in LIST. */
void
list_sort (struct list *list, list_less_func *less, void *aux)
{
c0027d68:	55                   	push   %ebp
c0027d69:	57                   	push   %edi
c0027d6a:	56                   	push   %esi
c0027d6b:	53                   	push   %ebx
c0027d6c:	83 ec 1c             	sub    $0x1c,%esp
c0027d6f:	8b 6c 24 34          	mov    0x34(%esp),%ebp
c0027d73:	8b 7c 24 38          	mov    0x38(%esp),%edi
  size_t output_run_cnt;        /* Number of runs output in current pass. */

  ASSERT (list != NULL);
c0027d77:	83 7c 24 30 00       	cmpl   $0x0,0x30(%esp)
c0027d7c:	74 29                	je     c0027da7 <list_sort+0x3f>
  ASSERT (less != NULL);
c0027d7e:	85 ed                	test   %ebp,%ebp
c0027d80:	0f 85 f9 01 00 00    	jne    c0027f7f <list_sort+0x217>
c0027d86:	83 ec 0c             	sub    $0xc,%esp
c0027d89:	68 d9 e5 02 c0       	push   $0xc002e5d9
c0027d8e:	68 df cb 02 c0       	push   $0xc002cbdf
c0027d93:	68 10 c7 02 c0       	push   $0xc002c710
c0027d98:	68 9a 01 00 00       	push   $0x19a
c0027d9d:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027da2:	e8 99 f8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (list != NULL);
c0027da7:	83 ec 0c             	sub    $0xc,%esp
c0027daa:	68 aa e5 02 c0       	push   $0xc002e5aa
c0027daf:	68 df cb 02 c0       	push   $0xc002cbdf
c0027db4:	68 10 c7 02 c0       	push   $0xc002c710
c0027db9:	68 99 01 00 00       	push   $0x199
c0027dbe:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027dc3:	e8 78 f8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (a0 != NULL);
c0027dc8:	83 ec 0c             	sub    $0xc,%esp
c0027dcb:	68 47 e6 02 c0       	push   $0xc002e647
c0027dd0:	68 df cb 02 c0       	push   $0xc002cbdf
c0027dd5:	68 f0 c6 02 c0       	push   $0xc002c6f0
c0027dda:	68 80 01 00 00       	push   $0x180
c0027ddf:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027de4:	e8 57 f8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (a1b0 != NULL);
c0027de9:	83 ec 0c             	sub    $0xc,%esp
c0027dec:	68 52 e6 02 c0       	push   $0xc002e652
c0027df1:	68 df cb 02 c0       	push   $0xc002cbdf
c0027df6:	68 f0 c6 02 c0       	push   $0xc002c6f0
c0027dfb:	68 81 01 00 00       	push   $0x181
c0027e00:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027e05:	e8 36 f8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (b1 != NULL);
c0027e0a:	83 ec 0c             	sub    $0xc,%esp
c0027e0d:	68 5f e6 02 c0       	push   $0xc002e65f
c0027e12:	68 df cb 02 c0       	push   $0xc002cbdf
c0027e17:	68 f0 c6 02 c0       	push   $0xc002c6f0
c0027e1c:	68 82 01 00 00       	push   $0x182
c0027e21:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027e26:	e8 15 f8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (is_sorted (a0, a1b0, less, aux));
c0027e2b:	83 ec 0c             	sub    $0xc,%esp
c0027e2e:	68 e8 e6 02 c0       	push   $0xc002e6e8
c0027e33:	68 df cb 02 c0       	push   $0xc002cbdf
c0027e38:	68 f0 c6 02 c0       	push   $0xc002c6f0
c0027e3d:	68 84 01 00 00       	push   $0x184
c0027e42:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027e47:	e8 f4 f7 ff ff       	call   c0027640 <debug_panic>
  ASSERT (is_sorted (a1b0, b1, less, aux));
c0027e4c:	83 ec 0c             	sub    $0xc,%esp
c0027e4f:	68 08 e7 02 c0       	push   $0xc002e708
c0027e54:	68 df cb 02 c0       	push   $0xc002cbdf
c0027e59:	68 f0 c6 02 c0       	push   $0xc002c6f0
c0027e5e:	68 85 01 00 00       	push   $0x185
c0027e63:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027e68:	e8 d3 f7 ff ff       	call   c0027640 <debug_panic>
        a1b0 = list_next (a1b0);
c0027e6d:	83 ec 0c             	sub    $0xc,%esp
c0027e70:	53                   	push   %ebx
c0027e71:	e8 e4 f8 ff ff       	call   c002775a <list_next>
c0027e76:	89 c3                	mov    %eax,%ebx
        list_splice (a0, list_prev (a1b0), a1b0);
c0027e78:	89 04 24             	mov    %eax,(%esp)
c0027e7b:	e8 82 f9 ff ff       	call   c0027802 <list_prev>
c0027e80:	83 c4 0c             	add    $0xc,%esp
c0027e83:	53                   	push   %ebx
c0027e84:	50                   	push   %eax
c0027e85:	56                   	push   %esi
c0027e86:	e8 00 fc ff ff       	call   c0027a8b <list_splice>
c0027e8b:	83 c4 10             	add    $0x10,%esp
  while (a0 != a1b0 && a1b0 != b1)
c0027e8e:	39 f3                	cmp    %esi,%ebx
c0027e90:	74 25                	je     c0027eb7 <list_sort+0x14f>
c0027e92:	39 5c 24 08          	cmp    %ebx,0x8(%esp)
c0027e96:	74 1f                	je     c0027eb7 <list_sort+0x14f>
    if (!less (a1b0, a0, aux)) 
c0027e98:	83 ec 04             	sub    $0x4,%esp
c0027e9b:	57                   	push   %edi
c0027e9c:	56                   	push   %esi
c0027e9d:	53                   	push   %ebx
c0027e9e:	ff d5                	call   *%ebp
c0027ea0:	83 c4 10             	add    $0x10,%esp
c0027ea3:	84 c0                	test   %al,%al
c0027ea5:	75 c6                	jne    c0027e6d <list_sort+0x105>
      a0 = list_next (a0);
c0027ea7:	83 ec 0c             	sub    $0xc,%esp
c0027eaa:	56                   	push   %esi
c0027eab:	e8 aa f8 ff ff       	call   c002775a <list_next>
c0027eb0:	83 c4 10             	add    $0x10,%esp
c0027eb3:	89 c6                	mov    %eax,%esi
c0027eb5:	eb d7                	jmp    c0027e8e <list_sort+0x126>
{
c0027eb7:	8b 74 24 08          	mov    0x8(%esp),%esi
      struct list_elem *a0;     /* Start of first run. */
      struct list_elem *a1b0;   /* End of first run, start of second. */
      struct list_elem *b1;     /* End of second run. */

      output_run_cnt = 0;
      for (a0 = list_begin (list); a0 != list_end (list); a0 = b1)
c0027ebb:	83 ec 0c             	sub    $0xc,%esp
c0027ebe:	ff 74 24 3c          	pushl  0x3c(%esp)
c0027ec2:	e8 db f8 ff ff       	call   c00277a2 <list_end>
c0027ec7:	83 c4 10             	add    $0x10,%esp
c0027eca:	39 c6                	cmp    %eax,%esi
c0027ecc:	0f 84 a6 00 00 00    	je     c0027f78 <list_sort+0x210>
        {
          /* Each iteration produces one output run. */
          output_run_cnt++;
c0027ed2:	ff 44 24 0c          	incl   0xc(%esp)

          /* Locate two adjacent runs of nondecreasing elements
             A0...A1B0 and A1B0...B1. */
          a1b0 = find_end_of_run (a0, list_end (list), less, aux);
c0027ed6:	83 ec 0c             	sub    $0xc,%esp
c0027ed9:	57                   	push   %edi
c0027eda:	89 e9                	mov    %ebp,%ecx
c0027edc:	89 c2                	mov    %eax,%edx
c0027ede:	89 f0                	mov    %esi,%eax
c0027ee0:	e8 62 f9 ff ff       	call   c0027847 <find_end_of_run>
c0027ee5:	89 c3                	mov    %eax,%ebx
          if (a1b0 == list_end (list))
c0027ee7:	83 c4 04             	add    $0x4,%esp
c0027eea:	ff 74 24 3c          	pushl  0x3c(%esp)
c0027eee:	e8 af f8 ff ff       	call   c00277a2 <list_end>
c0027ef3:	83 c4 10             	add    $0x10,%esp
c0027ef6:	39 c3                	cmp    %eax,%ebx
c0027ef8:	74 7e                	je     c0027f78 <list_sort+0x210>
            break;
          b1 = find_end_of_run (a1b0, list_end (list), less, aux);
c0027efa:	83 ec 0c             	sub    $0xc,%esp
c0027efd:	57                   	push   %edi
c0027efe:	89 e9                	mov    %ebp,%ecx
c0027f00:	89 c2                	mov    %eax,%edx
c0027f02:	89 d8                	mov    %ebx,%eax
c0027f04:	e8 3e f9 ff ff       	call   c0027847 <find_end_of_run>
c0027f09:	89 44 24 18          	mov    %eax,0x18(%esp)
  ASSERT (a0 != NULL);
c0027f0d:	83 c4 10             	add    $0x10,%esp
c0027f10:	85 f6                	test   %esi,%esi
c0027f12:	0f 84 b0 fe ff ff    	je     c0027dc8 <list_sort+0x60>
  ASSERT (a1b0 != NULL);
c0027f18:	85 db                	test   %ebx,%ebx
c0027f1a:	0f 84 c9 fe ff ff    	je     c0027de9 <list_sort+0x81>
  ASSERT (b1 != NULL);
c0027f20:	83 7c 24 08 00       	cmpl   $0x0,0x8(%esp)
c0027f25:	0f 84 df fe ff ff    	je     c0027e0a <list_sort+0xa2>
  ASSERT (is_sorted (a0, a1b0, less, aux));
c0027f2b:	83 ec 0c             	sub    $0xc,%esp
c0027f2e:	57                   	push   %edi
c0027f2f:	89 e9                	mov    %ebp,%ecx
c0027f31:	89 da                	mov    %ebx,%edx
c0027f33:	89 f0                	mov    %esi,%eax
c0027f35:	e8 f0 f9 ff ff       	call   c002792a <is_sorted>
c0027f3a:	83 c4 10             	add    $0x10,%esp
c0027f3d:	84 c0                	test   %al,%al
c0027f3f:	0f 84 e6 fe ff ff    	je     c0027e2b <list_sort+0xc3>
  ASSERT (is_sorted (a1b0, b1, less, aux));
c0027f45:	83 ec 0c             	sub    $0xc,%esp
c0027f48:	57                   	push   %edi
c0027f49:	89 e9                	mov    %ebp,%ecx
c0027f4b:	8b 54 24 18          	mov    0x18(%esp),%edx
c0027f4f:	89 d8                	mov    %ebx,%eax
c0027f51:	e8 d4 f9 ff ff       	call   c002792a <is_sorted>
c0027f56:	83 c4 10             	add    $0x10,%esp
c0027f59:	84 c0                	test   %al,%al
c0027f5b:	0f 84 eb fe ff ff    	je     c0027e4c <list_sort+0xe4>
  while (a0 != a1b0 && a1b0 != b1)
c0027f61:	39 de                	cmp    %ebx,%esi
c0027f63:	0f 84 4e ff ff ff    	je     c0027eb7 <list_sort+0x14f>
c0027f69:	3b 5c 24 08          	cmp    0x8(%esp),%ebx
c0027f6d:	0f 85 25 ff ff ff    	jne    c0027e98 <list_sort+0x130>
c0027f73:	e9 3f ff ff ff       	jmp    c0027eb7 <list_sort+0x14f>

          /* Merge the runs. */
          inplace_merge (a0, a1b0, b1, less, aux);
        }
    }
  while (output_run_cnt > 1);
c0027f78:	83 7c 24 0c 01       	cmpl   $0x1,0xc(%esp)
c0027f7d:	76 1e                	jbe    c0027f9d <list_sort+0x235>
      for (a0 = list_begin (list); a0 != list_end (list); a0 = b1)
c0027f7f:	83 ec 0c             	sub    $0xc,%esp
c0027f82:	ff 74 24 3c          	pushl  0x3c(%esp)
c0027f86:	e8 9f f7 ff ff       	call   c002772a <list_begin>
c0027f8b:	83 c4 10             	add    $0x10,%esp
c0027f8e:	89 c6                	mov    %eax,%esi
      output_run_cnt = 0;
c0027f90:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0027f97:	00 
      for (a0 = list_begin (list); a0 != list_end (list); a0 = b1)
c0027f98:	e9 1e ff ff ff       	jmp    c0027ebb <list_sort+0x153>

  ASSERT (is_sorted (list_begin (list), list_end (list), less, aux));
c0027f9d:	83 ec 0c             	sub    $0xc,%esp
c0027fa0:	ff 74 24 3c          	pushl  0x3c(%esp)
c0027fa4:	e8 f9 f7 ff ff       	call   c00277a2 <list_end>
c0027fa9:	83 c4 04             	add    $0x4,%esp
c0027fac:	89 c3                	mov    %eax,%ebx
c0027fae:	ff 74 24 3c          	pushl  0x3c(%esp)
c0027fb2:	e8 73 f7 ff ff       	call   c002772a <list_begin>
c0027fb7:	89 3c 24             	mov    %edi,(%esp)
c0027fba:	89 e9                	mov    %ebp,%ecx
c0027fbc:	89 da                	mov    %ebx,%edx
c0027fbe:	e8 67 f9 ff ff       	call   c002792a <is_sorted>
c0027fc3:	83 c4 10             	add    $0x10,%esp
c0027fc6:	84 c0                	test   %al,%al
c0027fc8:	74 08                	je     c0027fd2 <list_sort+0x26a>
}
c0027fca:	83 c4 1c             	add    $0x1c,%esp
c0027fcd:	5b                   	pop    %ebx
c0027fce:	5e                   	pop    %esi
c0027fcf:	5f                   	pop    %edi
c0027fd0:	5d                   	pop    %ebp
c0027fd1:	c3                   	ret    
  ASSERT (is_sorted (list_begin (list), list_end (list), less, aux));
c0027fd2:	83 ec 0c             	sub    $0xc,%esp
c0027fd5:	68 28 e7 02 c0       	push   $0xc002e728
c0027fda:	68 df cb 02 c0       	push   $0xc002cbdf
c0027fdf:	68 10 c7 02 c0       	push   $0xc002c710
c0027fe4:	68 b7 01 00 00       	push   $0x1b7
c0027fe9:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0027fee:	e8 4d f6 ff ff       	call   c0027640 <debug_panic>

c0027ff3 <list_insert_ordered>:
   sorted according to LESS given auxiliary data AUX.
   Runs in O(n) average case in the number of elements in LIST. */
void
list_insert_ordered (struct list *list, struct list_elem *elem,
                     list_less_func *less, void *aux)
{
c0027ff3:	55                   	push   %ebp
c0027ff4:	57                   	push   %edi
c0027ff5:	56                   	push   %esi
c0027ff6:	53                   	push   %ebx
c0027ff7:	83 ec 0c             	sub    $0xc,%esp
c0027ffa:	8b 74 24 20          	mov    0x20(%esp),%esi
c0027ffe:	8b 7c 24 24          	mov    0x24(%esp),%edi
c0028002:	8b 6c 24 28          	mov    0x28(%esp),%ebp
  struct list_elem *e;

  ASSERT (list != NULL);
c0028006:	85 f6                	test   %esi,%esi
c0028008:	74 50                	je     c002805a <list_insert_ordered+0x67>
  ASSERT (elem != NULL);
c002800a:	85 ff                	test   %edi,%edi
c002800c:	74 6d                	je     c002807b <list_insert_ordered+0x88>
  ASSERT (less != NULL);
c002800e:	85 ed                	test   %ebp,%ebp
c0028010:	0f 84 86 00 00 00    	je     c002809c <list_insert_ordered+0xa9>

  for (e = list_begin (list); e != list_end (list); e = list_next (e))
c0028016:	83 ec 0c             	sub    $0xc,%esp
c0028019:	56                   	push   %esi
c002801a:	e8 0b f7 ff ff       	call   c002772a <list_begin>
c002801f:	83 c4 10             	add    $0x10,%esp
c0028022:	89 c3                	mov    %eax,%ebx
c0028024:	83 ec 0c             	sub    $0xc,%esp
c0028027:	56                   	push   %esi
c0028028:	e8 75 f7 ff ff       	call   c00277a2 <list_end>
c002802d:	83 c4 10             	add    $0x10,%esp
c0028030:	39 c3                	cmp    %eax,%ebx
c0028032:	0f 84 85 00 00 00    	je     c00280bd <list_insert_ordered+0xca>
    if (less (elem, e, aux))
c0028038:	83 ec 04             	sub    $0x4,%esp
c002803b:	ff 74 24 30          	pushl  0x30(%esp)
c002803f:	53                   	push   %ebx
c0028040:	57                   	push   %edi
c0028041:	ff d5                	call   *%ebp
c0028043:	83 c4 10             	add    $0x10,%esp
c0028046:	84 c0                	test   %al,%al
c0028048:	75 73                	jne    c00280bd <list_insert_ordered+0xca>
  for (e = list_begin (list); e != list_end (list); e = list_next (e))
c002804a:	83 ec 0c             	sub    $0xc,%esp
c002804d:	53                   	push   %ebx
c002804e:	e8 07 f7 ff ff       	call   c002775a <list_next>
c0028053:	83 c4 10             	add    $0x10,%esp
c0028056:	89 c3                	mov    %eax,%ebx
c0028058:	eb ca                	jmp    c0028024 <list_insert_ordered+0x31>
  ASSERT (list != NULL);
c002805a:	83 ec 0c             	sub    $0xc,%esp
c002805d:	68 aa e5 02 c0       	push   $0xc002e5aa
c0028062:	68 df cb 02 c0       	push   $0xc002cbdf
c0028067:	68 dc c6 02 c0       	push   $0xc002c6dc
c002806c:	68 c3 01 00 00       	push   $0x1c3
c0028071:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0028076:	e8 c5 f5 ff ff       	call   c0027640 <debug_panic>
  ASSERT (elem != NULL);
c002807b:	83 ec 0c             	sub    $0xc,%esp
c002807e:	68 ed e5 02 c0       	push   $0xc002e5ed
c0028083:	68 df cb 02 c0       	push   $0xc002cbdf
c0028088:	68 dc c6 02 c0       	push   $0xc002c6dc
c002808d:	68 c4 01 00 00       	push   $0x1c4
c0028092:	68 b7 e5 02 c0       	push   $0xc002e5b7
c0028097:	e8 a4 f5 ff ff       	call   c0027640 <debug_panic>
  ASSERT (less != NULL);
c002809c:	83 ec 0c             	sub    $0xc,%esp
c002809f:	68 d9 e5 02 c0       	push   $0xc002e5d9
c00280a4:	68 df cb 02 c0       	push   $0xc002cbdf
c00280a9:	68 dc c6 02 c0       	push   $0xc002c6dc
c00280ae:	68 c5 01 00 00       	push   $0x1c5
c00280b3:	68 b7 e5 02 c0       	push   $0xc002e5b7
c00280b8:	e8 83 f5 ff ff       	call   c0027640 <debug_panic>
      break;
  return list_insert (e, elem);
c00280bd:	83 ec 08             	sub    $0x8,%esp
c00280c0:	57                   	push   %edi
c00280c1:	53                   	push   %ebx
c00280c2:	e8 47 f9 ff ff       	call   c0027a0e <list_insert>
}
c00280c7:	83 c4 1c             	add    $0x1c,%esp
c00280ca:	5b                   	pop    %ebx
c00280cb:	5e                   	pop    %esi
c00280cc:	5f                   	pop    %edi
c00280cd:	5d                   	pop    %ebp
c00280ce:	c3                   	ret    

c00280cf <list_unique>:
   given auxiliary data AUX.  If DUPLICATES is non-null, then the
   elements from LIST are appended to DUPLICATES. */
void
list_unique (struct list *list, struct list *duplicates,
             list_less_func *less, void *aux)
{
c00280cf:	55                   	push   %ebp
c00280d0:	57                   	push   %edi
c00280d1:	56                   	push   %esi
c00280d2:	53                   	push   %ebx
c00280d3:	83 ec 0c             	sub    $0xc,%esp
c00280d6:	8b 7c 24 20          	mov    0x20(%esp),%edi
c00280da:	8b 6c 24 28          	mov    0x28(%esp),%ebp
  struct list_elem *elem, *next;

  ASSERT (list != NULL);
c00280de:	85 ff                	test   %edi,%edi
c00280e0:	74 1c                	je     c00280fe <list_unique+0x2f>
  ASSERT (less != NULL);
c00280e2:	85 ed                	test   %ebp,%ebp
c00280e4:	74 39                	je     c002811f <list_unique+0x50>
  if (list_empty (list))
c00280e6:	83 ec 0c             	sub    $0xc,%esp
c00280e9:	57                   	push   %edi
c00280ea:	e8 3d fb ff ff       	call   c0027c2c <list_empty>
c00280ef:	83 c4 10             	add    $0x10,%esp
c00280f2:	84 c0                	test   %al,%al
c00280f4:	74 4a                	je     c0028140 <list_unique+0x71>
        if (duplicates != NULL)
          list_push_back (duplicates, next);
      }
    else
      elem = next;
}
c00280f6:	83 c4 0c             	add    $0xc,%esp
c00280f9:	5b                   	pop    %ebx
c00280fa:	5e                   	pop    %esi
c00280fb:	5f                   	pop    %edi
c00280fc:	5d                   	pop    %ebp
c00280fd:	c3                   	ret    
  ASSERT (list != NULL);
c00280fe:	83 ec 0c             	sub    $0xc,%esp
c0028101:	68 aa e5 02 c0       	push   $0xc002e5aa
c0028106:	68 df cb 02 c0       	push   $0xc002cbdf
c002810b:	68 d0 c6 02 c0       	push   $0xc002c6d0
c0028110:	68 d7 01 00 00       	push   $0x1d7
c0028115:	68 b7 e5 02 c0       	push   $0xc002e5b7
c002811a:	e8 21 f5 ff ff       	call   c0027640 <debug_panic>
  ASSERT (less != NULL);
c002811f:	83 ec 0c             	sub    $0xc,%esp
c0028122:	68 d9 e5 02 c0       	push   $0xc002e5d9
c0028127:	68 df cb 02 c0       	push   $0xc002cbdf
c002812c:	68 d0 c6 02 c0       	push   $0xc002c6d0
c0028131:	68 d8 01 00 00       	push   $0x1d8
c0028136:	68 b7 e5 02 c0       	push   $0xc002e5b7
c002813b:	e8 00 f5 ff ff       	call   c0027640 <debug_panic>
  elem = list_begin (list);
c0028140:	83 ec 0c             	sub    $0xc,%esp
c0028143:	57                   	push   %edi
c0028144:	e8 e1 f5 ff ff       	call   c002772a <list_begin>
c0028149:	83 c4 10             	add    $0x10,%esp
c002814c:	89 c6                	mov    %eax,%esi
  while ((next = list_next (elem)) != list_end (list))
c002814e:	eb 04                	jmp    c0028154 <list_unique+0x85>
c0028150:	89 f3                	mov    %esi,%ebx
c0028152:	89 de                	mov    %ebx,%esi
c0028154:	83 ec 0c             	sub    $0xc,%esp
c0028157:	56                   	push   %esi
c0028158:	e8 fd f5 ff ff       	call   c002775a <list_next>
c002815d:	89 c3                	mov    %eax,%ebx
c002815f:	89 3c 24             	mov    %edi,(%esp)
c0028162:	e8 3b f6 ff ff       	call   c00277a2 <list_end>
c0028167:	83 c4 10             	add    $0x10,%esp
c002816a:	39 c3                	cmp    %eax,%ebx
c002816c:	74 88                	je     c00280f6 <list_unique+0x27>
    if (!less (elem, next, aux) && !less (next, elem, aux)) 
c002816e:	83 ec 04             	sub    $0x4,%esp
c0028171:	ff 74 24 30          	pushl  0x30(%esp)
c0028175:	53                   	push   %ebx
c0028176:	56                   	push   %esi
c0028177:	ff d5                	call   *%ebp
c0028179:	83 c4 10             	add    $0x10,%esp
c002817c:	84 c0                	test   %al,%al
c002817e:	75 d2                	jne    c0028152 <list_unique+0x83>
c0028180:	83 ec 04             	sub    $0x4,%esp
c0028183:	ff 74 24 30          	pushl  0x30(%esp)
c0028187:	56                   	push   %esi
c0028188:	53                   	push   %ebx
c0028189:	ff d5                	call   *%ebp
c002818b:	83 c4 10             	add    $0x10,%esp
c002818e:	84 c0                	test   %al,%al
c0028190:	75 c0                	jne    c0028152 <list_unique+0x83>
        list_remove (next);
c0028192:	83 ec 0c             	sub    $0xc,%esp
c0028195:	53                   	push   %ebx
c0028196:	e8 06 fa ff ff       	call   c0027ba1 <list_remove>
        if (duplicates != NULL)
c002819b:	83 c4 10             	add    $0x10,%esp
c002819e:	83 7c 24 24 00       	cmpl   $0x0,0x24(%esp)
c00281a3:	74 ab                	je     c0028150 <list_unique+0x81>
          list_push_back (duplicates, next);
c00281a5:	83 ec 08             	sub    $0x8,%esp
c00281a8:	53                   	push   %ebx
c00281a9:	ff 74 24 30          	pushl  0x30(%esp)
c00281ad:	e8 d2 f9 ff ff       	call   c0027b84 <list_push_back>
c00281b2:	83 c4 10             	add    $0x10,%esp
c00281b5:	89 f3                	mov    %esi,%ebx
c00281b7:	eb 99                	jmp    c0028152 <list_unique+0x83>

c00281b9 <list_max>:
   to LESS given auxiliary data AUX.  If there is more than one
   maximum, returns the one that appears earlier in the list.  If
   the list is empty, returns its tail. */
struct list_elem *
list_max (struct list *list, list_less_func *less, void *aux)
{
c00281b9:	55                   	push   %ebp
c00281ba:	57                   	push   %edi
c00281bb:	56                   	push   %esi
c00281bc:	53                   	push   %ebx
c00281bd:	83 ec 18             	sub    $0x18,%esp
c00281c0:	8b 7c 24 2c          	mov    0x2c(%esp),%edi
c00281c4:	8b 6c 24 34          	mov    0x34(%esp),%ebp
  struct list_elem *max = list_begin (list);
c00281c8:	57                   	push   %edi
c00281c9:	e8 5c f5 ff ff       	call   c002772a <list_begin>
c00281ce:	89 c6                	mov    %eax,%esi
  if (max != list_end (list)) 
c00281d0:	89 3c 24             	mov    %edi,(%esp)
c00281d3:	e8 ca f5 ff ff       	call   c00277a2 <list_end>
c00281d8:	83 c4 10             	add    $0x10,%esp
c00281db:	39 c6                	cmp    %eax,%esi
c00281dd:	74 43                	je     c0028222 <list_max+0x69>
    {
      struct list_elem *e;
      
      for (e = list_next (max); e != list_end (list); e = list_next (e))
c00281df:	83 ec 0c             	sub    $0xc,%esp
c00281e2:	56                   	push   %esi
c00281e3:	e8 72 f5 ff ff       	call   c002775a <list_next>
c00281e8:	83 c4 10             	add    $0x10,%esp
c00281eb:	89 c3                	mov    %eax,%ebx
c00281ed:	eb 0e                	jmp    c00281fd <list_max+0x44>
c00281ef:	83 ec 0c             	sub    $0xc,%esp
c00281f2:	53                   	push   %ebx
c00281f3:	e8 62 f5 ff ff       	call   c002775a <list_next>
c00281f8:	83 c4 10             	add    $0x10,%esp
c00281fb:	89 c3                	mov    %eax,%ebx
c00281fd:	83 ec 0c             	sub    $0xc,%esp
c0028200:	57                   	push   %edi
c0028201:	e8 9c f5 ff ff       	call   c00277a2 <list_end>
c0028206:	83 c4 10             	add    $0x10,%esp
c0028209:	39 c3                	cmp    %eax,%ebx
c002820b:	74 17                	je     c0028224 <list_max+0x6b>
        if (less (max, e, aux))
c002820d:	83 ec 04             	sub    $0x4,%esp
c0028210:	55                   	push   %ebp
c0028211:	53                   	push   %ebx
c0028212:	56                   	push   %esi
c0028213:	ff 54 24 34          	call   *0x34(%esp)
c0028217:	83 c4 10             	add    $0x10,%esp
c002821a:	84 c0                	test   %al,%al
c002821c:	74 d1                	je     c00281ef <list_max+0x36>
          max = e; 
c002821e:	89 de                	mov    %ebx,%esi
c0028220:	eb cd                	jmp    c00281ef <list_max+0x36>
  struct list_elem *max = list_begin (list);
c0028222:	89 c6                	mov    %eax,%esi
    }
  return max;
}
c0028224:	89 f0                	mov    %esi,%eax
c0028226:	83 c4 0c             	add    $0xc,%esp
c0028229:	5b                   	pop    %ebx
c002822a:	5e                   	pop    %esi
c002822b:	5f                   	pop    %edi
c002822c:	5d                   	pop    %ebp
c002822d:	c3                   	ret    

c002822e <list_min>:
   to LESS given auxiliary data AUX.  If there is more than one
   minimum, returns the one that appears earlier in the list.  If
   the list is empty, returns its tail. */
struct list_elem *
list_min (struct list *list, list_less_func *less, void *aux)
{
c002822e:	55                   	push   %ebp
c002822f:	57                   	push   %edi
c0028230:	56                   	push   %esi
c0028231:	53                   	push   %ebx
c0028232:	83 ec 18             	sub    $0x18,%esp
c0028235:	8b 7c 24 2c          	mov    0x2c(%esp),%edi
c0028239:	8b 6c 24 34          	mov    0x34(%esp),%ebp
  struct list_elem *min = list_begin (list);
c002823d:	57                   	push   %edi
c002823e:	e8 e7 f4 ff ff       	call   c002772a <list_begin>
c0028243:	89 c6                	mov    %eax,%esi
  if (min != list_end (list)) 
c0028245:	89 3c 24             	mov    %edi,(%esp)
c0028248:	e8 55 f5 ff ff       	call   c00277a2 <list_end>
c002824d:	83 c4 10             	add    $0x10,%esp
c0028250:	39 c6                	cmp    %eax,%esi
c0028252:	74 43                	je     c0028297 <list_min+0x69>
    {
      struct list_elem *e;
      
      for (e = list_next (min); e != list_end (list); e = list_next (e))
c0028254:	83 ec 0c             	sub    $0xc,%esp
c0028257:	56                   	push   %esi
c0028258:	e8 fd f4 ff ff       	call   c002775a <list_next>
c002825d:	83 c4 10             	add    $0x10,%esp
c0028260:	89 c3                	mov    %eax,%ebx
c0028262:	eb 0e                	jmp    c0028272 <list_min+0x44>
c0028264:	83 ec 0c             	sub    $0xc,%esp
c0028267:	53                   	push   %ebx
c0028268:	e8 ed f4 ff ff       	call   c002775a <list_next>
c002826d:	83 c4 10             	add    $0x10,%esp
c0028270:	89 c3                	mov    %eax,%ebx
c0028272:	83 ec 0c             	sub    $0xc,%esp
c0028275:	57                   	push   %edi
c0028276:	e8 27 f5 ff ff       	call   c00277a2 <list_end>
c002827b:	83 c4 10             	add    $0x10,%esp
c002827e:	39 c3                	cmp    %eax,%ebx
c0028280:	74 17                	je     c0028299 <list_min+0x6b>
        if (less (e, min, aux))
c0028282:	83 ec 04             	sub    $0x4,%esp
c0028285:	55                   	push   %ebp
c0028286:	56                   	push   %esi
c0028287:	53                   	push   %ebx
c0028288:	ff 54 24 34          	call   *0x34(%esp)
c002828c:	83 c4 10             	add    $0x10,%esp
c002828f:	84 c0                	test   %al,%al
c0028291:	74 d1                	je     c0028264 <list_min+0x36>
          min = e; 
c0028293:	89 de                	mov    %ebx,%esi
c0028295:	eb cd                	jmp    c0028264 <list_min+0x36>
  struct list_elem *min = list_begin (list);
c0028297:	89 c6                	mov    %eax,%esi
    }
  return min;
}
c0028299:	89 f0                	mov    %esi,%eax
c002829b:	83 c4 0c             	add    $0xc,%esp
c002829e:	5b                   	pop    %ebx
c002829f:	5e                   	pop    %esi
c00282a0:	5f                   	pop    %edi
c00282a1:	5d                   	pop    %ebp
c00282a2:	c3                   	ret    

c00282a3 <bitmap_buf_size>:

/* Returns the number of elements required for BIT_CNT bits. */
static inline size_t
elem_cnt (size_t bit_cnt)
{
  return DIV_ROUND_UP (bit_cnt, ELEM_BITS);
c00282a3:	8b 44 24 04          	mov    0x4(%esp),%eax
c00282a7:	83 c0 1f             	add    $0x1f,%eax
c00282aa:	c1 e8 05             	shr    $0x5,%eax
/* Returns the number of bytes required to accomodate a bitmap
   with BIT_CNT bits (for use with bitmap_create_in_buf()). */
size_t
bitmap_buf_size (size_t bit_cnt) 
{
  return sizeof (struct bitmap) + byte_cnt (bit_cnt);
c00282ad:	8d 04 85 08 00 00 00 	lea    0x8(,%eax,4),%eax
}
c00282b4:	c3                   	ret    

c00282b5 <bitmap_destroy>:

/* Destroys bitmap B, freeing its storage.
   Not for use on bitmaps created by bitmap_create_in_buf(). */
void
bitmap_destroy (struct bitmap *b) 
{
c00282b5:	53                   	push   %ebx
c00282b6:	83 ec 08             	sub    $0x8,%esp
c00282b9:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  if (b != NULL) 
c00282bd:	85 db                	test   %ebx,%ebx
c00282bf:	74 16                	je     c00282d7 <bitmap_destroy+0x22>
    {
      free (b->bits);
c00282c1:	83 ec 0c             	sub    $0xc,%esp
c00282c4:	ff 73 04             	pushl  0x4(%ebx)
c00282c7:	e8 86 ab ff ff       	call   c0022e52 <free>
      free (b);
c00282cc:	89 1c 24             	mov    %ebx,(%esp)
c00282cf:	e8 7e ab ff ff       	call   c0022e52 <free>
c00282d4:	83 c4 10             	add    $0x10,%esp
    }
}
c00282d7:	83 c4 08             	add    $0x8,%esp
c00282da:	5b                   	pop    %ebx
c00282db:	c3                   	ret    

c00282dc <bitmap_size>:

/* Returns the number of bits in B. */
size_t
bitmap_size (const struct bitmap *b)
{
  return b->bit_cnt;
c00282dc:	8b 44 24 04          	mov    0x4(%esp),%eax
c00282e0:	8b 00                	mov    (%eax),%eax
}
c00282e2:	c3                   	ret    

c00282e3 <bitmap_mark>:
}

/* Atomically sets the bit numbered BIT_IDX in B to true. */
void
bitmap_mark (struct bitmap *b, size_t bit_idx) 
{
c00282e3:	53                   	push   %ebx
c00282e4:	8b 4c 24 0c          	mov    0xc(%esp),%ecx
  return bit_idx / ELEM_BITS;
c00282e8:	89 cb                	mov    %ecx,%ebx
c00282ea:	c1 eb 05             	shr    $0x5,%ebx
  elem_type mask = bit_mask (bit_idx);

  /* This is equivalent to `b->bits[idx] |= mask' except that it
     is guaranteed to be atomic on a uniprocessor machine.  See
     the description of the OR instruction in [IA32-v2b]. */
  asm ("orl %1, %0" : "=m" (b->bits[idx]) : "r" (mask) : "cc");
c00282ed:	8b 44 24 08          	mov    0x8(%esp),%eax
c00282f1:	8b 50 04             	mov    0x4(%eax),%edx
  return (elem_type) 1 << (bit_idx % ELEM_BITS);
c00282f4:	b8 01 00 00 00       	mov    $0x1,%eax
c00282f9:	d3 e0                	shl    %cl,%eax
  asm ("orl %1, %0" : "=m" (b->bits[idx]) : "r" (mask) : "cc");
c00282fb:	09 04 9a             	or     %eax,(%edx,%ebx,4)
}
c00282fe:	5b                   	pop    %ebx
c00282ff:	c3                   	ret    

c0028300 <bitmap_reset>:

/* Atomically sets the bit numbered BIT_IDX in B to false. */
void
bitmap_reset (struct bitmap *b, size_t bit_idx) 
{
c0028300:	53                   	push   %ebx
c0028301:	8b 4c 24 0c          	mov    0xc(%esp),%ecx
  return bit_idx / ELEM_BITS;
c0028305:	89 cb                	mov    %ecx,%ebx
c0028307:	c1 eb 05             	shr    $0x5,%ebx
  elem_type mask = bit_mask (bit_idx);

  /* This is equivalent to `b->bits[idx] &= ~mask' except that it
     is guaranteed to be atomic on a uniprocessor machine.  See
     the description of the AND instruction in [IA32-v2a]. */
  asm ("andl %1, %0" : "=m" (b->bits[idx]) : "r" (~mask) : "cc");
c002830a:	8b 44 24 08          	mov    0x8(%esp),%eax
c002830e:	8b 50 04             	mov    0x4(%eax),%edx
  return (elem_type) 1 << (bit_idx % ELEM_BITS);
c0028311:	b8 01 00 00 00       	mov    $0x1,%eax
c0028316:	d3 e0                	shl    %cl,%eax
  asm ("andl %1, %0" : "=m" (b->bits[idx]) : "r" (~mask) : "cc");
c0028318:	f7 d0                	not    %eax
c002831a:	21 04 9a             	and    %eax,(%edx,%ebx,4)
}
c002831d:	5b                   	pop    %ebx
c002831e:	c3                   	ret    

c002831f <bitmap_set>:
{
c002831f:	83 ec 0c             	sub    $0xc,%esp
c0028322:	8b 44 24 10          	mov    0x10(%esp),%eax
c0028326:	8b 54 24 14          	mov    0x14(%esp),%edx
c002832a:	8b 4c 24 18          	mov    0x18(%esp),%ecx
  ASSERT (b != NULL);
c002832e:	85 c0                	test   %eax,%eax
c0028330:	74 19                	je     c002834b <bitmap_set+0x2c>
  ASSERT (idx < b->bit_cnt);
c0028332:	39 10                	cmp    %edx,(%eax)
c0028334:	76 36                	jbe    c002836c <bitmap_set+0x4d>
  if (value)
c0028336:	84 c9                	test   %cl,%cl
c0028338:	75 53                	jne    c002838d <bitmap_set+0x6e>
    bitmap_reset (b, idx);
c002833a:	83 ec 08             	sub    $0x8,%esp
c002833d:	52                   	push   %edx
c002833e:	50                   	push   %eax
c002833f:	e8 bc ff ff ff       	call   c0028300 <bitmap_reset>
c0028344:	83 c4 10             	add    $0x10,%esp
}
c0028347:	83 c4 0c             	add    $0xc,%esp
c002834a:	c3                   	ret    
  ASSERT (b != NULL);
c002834b:	83 ec 0c             	sub    $0xc,%esp
c002834e:	68 cf e5 02 c0       	push   $0xc002e5cf
c0028353:	68 df cb 02 c0       	push   $0xc002cbdf
c0028358:	68 20 c8 02 c0       	push   $0xc002c820
c002835d:	68 93 00 00 00       	push   $0x93
c0028362:	68 62 e7 02 c0       	push   $0xc002e762
c0028367:	e8 d4 f2 ff ff       	call   c0027640 <debug_panic>
  ASSERT (idx < b->bit_cnt);
c002836c:	83 ec 0c             	sub    $0xc,%esp
c002836f:	68 7c e7 02 c0       	push   $0xc002e77c
c0028374:	68 df cb 02 c0       	push   $0xc002cbdf
c0028379:	68 20 c8 02 c0       	push   $0xc002c820
c002837e:	68 94 00 00 00       	push   $0x94
c0028383:	68 62 e7 02 c0       	push   $0xc002e762
c0028388:	e8 b3 f2 ff ff       	call   c0027640 <debug_panic>
    bitmap_mark (b, idx);
c002838d:	83 ec 08             	sub    $0x8,%esp
c0028390:	52                   	push   %edx
c0028391:	50                   	push   %eax
c0028392:	e8 4c ff ff ff       	call   c00282e3 <bitmap_mark>
c0028397:	83 c4 10             	add    $0x10,%esp
c002839a:	eb ab                	jmp    c0028347 <bitmap_set+0x28>

c002839c <bitmap_flip>:
/* Atomically toggles the bit numbered IDX in B;
   that is, if it is true, makes it false,
   and if it is false, makes it true. */
void
bitmap_flip (struct bitmap *b, size_t bit_idx) 
{
c002839c:	53                   	push   %ebx
c002839d:	8b 4c 24 0c          	mov    0xc(%esp),%ecx
  return bit_idx / ELEM_BITS;
c00283a1:	89 cb                	mov    %ecx,%ebx
c00283a3:	c1 eb 05             	shr    $0x5,%ebx
  elem_type mask = bit_mask (bit_idx);

  /* This is equivalent to `b->bits[idx] ^= mask' except that it
     is guaranteed to be atomic on a uniprocessor machine.  See
     the description of the XOR instruction in [IA32-v2b]. */
  asm ("xorl %1, %0" : "=m" (b->bits[idx]) : "r" (mask) : "cc");
c00283a6:	8b 44 24 08          	mov    0x8(%esp),%eax
c00283aa:	8b 50 04             	mov    0x4(%eax),%edx
  return (elem_type) 1 << (bit_idx % ELEM_BITS);
c00283ad:	b8 01 00 00 00       	mov    $0x1,%eax
c00283b2:	d3 e0                	shl    %cl,%eax
  asm ("xorl %1, %0" : "=m" (b->bits[idx]) : "r" (mask) : "cc");
c00283b4:	31 04 9a             	xor    %eax,(%edx,%ebx,4)
}
c00283b7:	5b                   	pop    %ebx
c00283b8:	c3                   	ret    

c00283b9 <bitmap_test>:

/* Returns the value of the bit numbered IDX in B. */
bool
bitmap_test (const struct bitmap *b, size_t idx) 
{
c00283b9:	53                   	push   %ebx
c00283ba:	83 ec 08             	sub    $0x8,%esp
c00283bd:	8b 44 24 10          	mov    0x10(%esp),%eax
c00283c1:	8b 4c 24 14          	mov    0x14(%esp),%ecx
  ASSERT (b != NULL);
c00283c5:	85 c0                	test   %eax,%eax
c00283c7:	74 1e                	je     c00283e7 <bitmap_test+0x2e>
  ASSERT (idx < b->bit_cnt);
c00283c9:	39 08                	cmp    %ecx,(%eax)
c00283cb:	76 3b                	jbe    c0028408 <bitmap_test+0x4f>
  return bit_idx / ELEM_BITS;
c00283cd:	89 cb                	mov    %ecx,%ebx
c00283cf:	c1 eb 05             	shr    $0x5,%ebx
  return (b->bits[elem_idx (idx)] & bit_mask (idx)) != 0;
c00283d2:	8b 50 04             	mov    0x4(%eax),%edx
  return (elem_type) 1 << (bit_idx % ELEM_BITS);
c00283d5:	b8 01 00 00 00       	mov    $0x1,%eax
c00283da:	d3 e0                	shl    %cl,%eax
  return (b->bits[elem_idx (idx)] & bit_mask (idx)) != 0;
c00283dc:	85 04 9a             	test   %eax,(%edx,%ebx,4)
c00283df:	0f 95 c0             	setne  %al
}
c00283e2:	83 c4 08             	add    $0x8,%esp
c00283e5:	5b                   	pop    %ebx
c00283e6:	c3                   	ret    
  ASSERT (b != NULL);
c00283e7:	83 ec 0c             	sub    $0xc,%esp
c00283ea:	68 cf e5 02 c0       	push   $0xc002e5cf
c00283ef:	68 df cb 02 c0       	push   $0xc002cbdf
c00283f4:	68 14 c8 02 c0       	push   $0xc002c814
c00283f9:	68 c8 00 00 00       	push   $0xc8
c00283fe:	68 62 e7 02 c0       	push   $0xc002e762
c0028403:	e8 38 f2 ff ff       	call   c0027640 <debug_panic>
  ASSERT (idx < b->bit_cnt);
c0028408:	83 ec 0c             	sub    $0xc,%esp
c002840b:	68 7c e7 02 c0       	push   $0xc002e77c
c0028410:	68 df cb 02 c0       	push   $0xc002cbdf
c0028415:	68 14 c8 02 c0       	push   $0xc002c814
c002841a:	68 c9 00 00 00       	push   $0xc9
c002841f:	68 62 e7 02 c0       	push   $0xc002e762
c0028424:	e8 17 f2 ff ff       	call   c0027640 <debug_panic>

c0028429 <bitmap_set_multiple>:
}

/* Sets the CNT bits starting at START in B to VALUE. */
void
bitmap_set_multiple (struct bitmap *b, size_t start, size_t cnt, bool value) 
{
c0028429:	55                   	push   %ebp
c002842a:	57                   	push   %edi
c002842b:	56                   	push   %esi
c002842c:	53                   	push   %ebx
c002842d:	83 ec 0c             	sub    $0xc,%esp
c0028430:	8b 74 24 20          	mov    0x20(%esp),%esi
c0028434:	8b 5c 24 24          	mov    0x24(%esp),%ebx
c0028438:	8b 54 24 28          	mov    0x28(%esp),%edx
c002843c:	8a 44 24 2c          	mov    0x2c(%esp),%al
  size_t i;
  
  ASSERT (b != NULL);
c0028440:	85 f6                	test   %esi,%esi
c0028442:	74 2f                	je     c0028473 <bitmap_set_multiple+0x4a>
  ASSERT (start <= b->bit_cnt);
c0028444:	8b 0e                	mov    (%esi),%ecx
c0028446:	39 d9                	cmp    %ebx,%ecx
c0028448:	72 4a                	jb     c0028494 <bitmap_set_multiple+0x6b>
  ASSERT (start + cnt <= b->bit_cnt);
c002844a:	8d 2c 13             	lea    (%ebx,%edx,1),%ebp
c002844d:	39 e9                	cmp    %ebp,%ecx
c002844f:	72 64                	jb     c00284b5 <bitmap_set_multiple+0x8c>

  for (i = 0; i < cnt; i++)
c0028451:	85 d2                	test   %edx,%edx
c0028453:	74 16                	je     c002846b <bitmap_set_multiple+0x42>
    bitmap_set (b, start + i, value);
c0028455:	0f b6 f8             	movzbl %al,%edi
c0028458:	83 ec 04             	sub    $0x4,%esp
c002845b:	57                   	push   %edi
c002845c:	53                   	push   %ebx
c002845d:	56                   	push   %esi
c002845e:	e8 bc fe ff ff       	call   c002831f <bitmap_set>
c0028463:	43                   	inc    %ebx
  for (i = 0; i < cnt; i++)
c0028464:	83 c4 10             	add    $0x10,%esp
c0028467:	39 dd                	cmp    %ebx,%ebp
c0028469:	75 ed                	jne    c0028458 <bitmap_set_multiple+0x2f>
}
c002846b:	83 c4 0c             	add    $0xc,%esp
c002846e:	5b                   	pop    %ebx
c002846f:	5e                   	pop    %esi
c0028470:	5f                   	pop    %edi
c0028471:	5d                   	pop    %ebp
c0028472:	c3                   	ret    
  ASSERT (b != NULL);
c0028473:	83 ec 0c             	sub    $0xc,%esp
c0028476:	68 cf e5 02 c0       	push   $0xc002e5cf
c002847b:	68 df cb 02 c0       	push   $0xc002cbdf
c0028480:	68 f0 c7 02 c0       	push   $0xc002c7f0
c0028485:	68 de 00 00 00       	push   $0xde
c002848a:	68 62 e7 02 c0       	push   $0xc002e762
c002848f:	e8 ac f1 ff ff       	call   c0027640 <debug_panic>
  ASSERT (start <= b->bit_cnt);
c0028494:	83 ec 0c             	sub    $0xc,%esp
c0028497:	68 8d e7 02 c0       	push   $0xc002e78d
c002849c:	68 df cb 02 c0       	push   $0xc002cbdf
c00284a1:	68 f0 c7 02 c0       	push   $0xc002c7f0
c00284a6:	68 df 00 00 00       	push   $0xdf
c00284ab:	68 62 e7 02 c0       	push   $0xc002e762
c00284b0:	e8 8b f1 ff ff       	call   c0027640 <debug_panic>
  ASSERT (start + cnt <= b->bit_cnt);
c00284b5:	83 ec 0c             	sub    $0xc,%esp
c00284b8:	68 a1 e7 02 c0       	push   $0xc002e7a1
c00284bd:	68 df cb 02 c0       	push   $0xc002cbdf
c00284c2:	68 f0 c7 02 c0       	push   $0xc002c7f0
c00284c7:	68 e0 00 00 00       	push   $0xe0
c00284cc:	68 62 e7 02 c0       	push   $0xc002e762
c00284d1:	e8 6a f1 ff ff       	call   c0027640 <debug_panic>

c00284d6 <bitmap_set_all>:
{
c00284d6:	83 ec 0c             	sub    $0xc,%esp
c00284d9:	8b 44 24 10          	mov    0x10(%esp),%eax
c00284dd:	8b 54 24 14          	mov    0x14(%esp),%edx
  ASSERT (b != NULL);
c00284e1:	85 c0                	test   %eax,%eax
c00284e3:	74 12                	je     c00284f7 <bitmap_set_all+0x21>
  bitmap_set_multiple (b, 0, bitmap_size (b), value);
c00284e5:	0f b6 d2             	movzbl %dl,%edx
c00284e8:	52                   	push   %edx
c00284e9:	ff 30                	pushl  (%eax)
c00284eb:	6a 00                	push   $0x0
c00284ed:	50                   	push   %eax
c00284ee:	e8 36 ff ff ff       	call   c0028429 <bitmap_set_multiple>
}
c00284f3:	83 c4 1c             	add    $0x1c,%esp
c00284f6:	c3                   	ret    
  ASSERT (b != NULL);
c00284f7:	83 ec 0c             	sub    $0xc,%esp
c00284fa:	68 cf e5 02 c0       	push   $0xc002e5cf
c00284ff:	68 df cb 02 c0       	push   $0xc002cbdf
c0028504:	68 04 c8 02 c0       	push   $0xc002c804
c0028509:	68 d3 00 00 00       	push   $0xd3
c002850e:	68 62 e7 02 c0       	push   $0xc002e762
c0028513:	e8 28 f1 ff ff       	call   c0027640 <debug_panic>

c0028518 <bitmap_create>:
{
c0028518:	56                   	push   %esi
c0028519:	53                   	push   %ebx
c002851a:	83 ec 10             	sub    $0x10,%esp
c002851d:	8b 74 24 1c          	mov    0x1c(%esp),%esi
  struct bitmap *b = malloc (sizeof *b);
c0028521:	6a 08                	push   $0x8
c0028523:	e8 89 a7 ff ff       	call   c0022cb1 <malloc>
c0028528:	89 c3                	mov    %eax,%ebx
  if (b != NULL)
c002852a:	83 c4 10             	add    $0x10,%esp
c002852d:	85 c0                	test   %eax,%eax
c002852f:	74 2c                	je     c002855d <bitmap_create+0x45>
      b->bit_cnt = bit_cnt;
c0028531:	89 30                	mov    %esi,(%eax)
      b->bits = malloc (byte_cnt (bit_cnt));
c0028533:	83 ec 0c             	sub    $0xc,%esp
  return DIV_ROUND_UP (bit_cnt, ELEM_BITS);
c0028536:	8d 46 1f             	lea    0x1f(%esi),%eax
c0028539:	c1 e8 05             	shr    $0x5,%eax
  return sizeof (elem_type) * elem_cnt (bit_cnt);
c002853c:	c1 e0 02             	shl    $0x2,%eax
      b->bits = malloc (byte_cnt (bit_cnt));
c002853f:	50                   	push   %eax
c0028540:	e8 6c a7 ff ff       	call   c0022cb1 <malloc>
c0028545:	89 43 04             	mov    %eax,0x4(%ebx)
      if (b->bits != NULL || bit_cnt == 0)
c0028548:	83 c4 10             	add    $0x10,%esp
c002854b:	85 c0                	test   %eax,%eax
c002854d:	74 16                	je     c0028565 <bitmap_create+0x4d>
          bitmap_set_all (b, false);
c002854f:	83 ec 08             	sub    $0x8,%esp
c0028552:	6a 00                	push   $0x0
c0028554:	53                   	push   %ebx
c0028555:	e8 7c ff ff ff       	call   c00284d6 <bitmap_set_all>
          return b;
c002855a:	83 c4 10             	add    $0x10,%esp
}
c002855d:	89 d8                	mov    %ebx,%eax
c002855f:	83 c4 04             	add    $0x4,%esp
c0028562:	5b                   	pop    %ebx
c0028563:	5e                   	pop    %esi
c0028564:	c3                   	ret    
      if (b->bits != NULL || bit_cnt == 0)
c0028565:	85 f6                	test   %esi,%esi
c0028567:	74 e6                	je     c002854f <bitmap_create+0x37>
      free (b);
c0028569:	83 ec 0c             	sub    $0xc,%esp
c002856c:	53                   	push   %ebx
c002856d:	e8 e0 a8 ff ff       	call   c0022e52 <free>
c0028572:	83 c4 10             	add    $0x10,%esp
  return NULL;
c0028575:	bb 00 00 00 00       	mov    $0x0,%ebx
c002857a:	eb e1                	jmp    c002855d <bitmap_create+0x45>

c002857c <bitmap_create_in_buf>:
{
c002857c:	56                   	push   %esi
c002857d:	53                   	push   %ebx
c002857e:	83 ec 04             	sub    $0x4,%esp
c0028581:	8b 74 24 10          	mov    0x10(%esp),%esi
c0028585:	8b 5c 24 14          	mov    0x14(%esp),%ebx
  ASSERT (block_size >= bitmap_buf_size (bit_cnt));
c0028589:	56                   	push   %esi
c002858a:	e8 14 fd ff ff       	call   c00282a3 <bitmap_buf_size>
c002858f:	83 c4 04             	add    $0x4,%esp
c0028592:	3b 44 24 18          	cmp    0x18(%esp),%eax
c0028596:	77 1b                	ja     c00285b3 <bitmap_create_in_buf+0x37>
  b->bit_cnt = bit_cnt;
c0028598:	89 33                	mov    %esi,(%ebx)
  b->bits = (elem_type *) (b + 1);
c002859a:	8d 43 08             	lea    0x8(%ebx),%eax
c002859d:	89 43 04             	mov    %eax,0x4(%ebx)
  bitmap_set_all (b, false);
c00285a0:	83 ec 08             	sub    $0x8,%esp
c00285a3:	6a 00                	push   $0x0
c00285a5:	53                   	push   %ebx
c00285a6:	e8 2b ff ff ff       	call   c00284d6 <bitmap_set_all>
}
c00285ab:	89 d8                	mov    %ebx,%eax
c00285ad:	83 c4 14             	add    $0x14,%esp
c00285b0:	5b                   	pop    %ebx
c00285b1:	5e                   	pop    %esi
c00285b2:	c3                   	ret    
  ASSERT (block_size >= bitmap_buf_size (bit_cnt));
c00285b3:	83 ec 0c             	sub    $0xc,%esp
c00285b6:	68 bc e7 02 c0       	push   $0xc002e7bc
c00285bb:	68 df cb 02 c0       	push   $0xc002cbdf
c00285c0:	68 2c c8 02 c0       	push   $0xc002c82c
c00285c5:	6a 68                	push   $0x68
c00285c7:	68 62 e7 02 c0       	push   $0xc002e762
c00285cc:	e8 6f f0 ff ff       	call   c0027640 <debug_panic>

c00285d1 <bitmap_count>:

/* Returns the number of bits in B between START and START + CNT,
   exclusive, that are set to VALUE. */
size_t
bitmap_count (const struct bitmap *b, size_t start, size_t cnt, bool value) 
{
c00285d1:	55                   	push   %ebp
c00285d2:	57                   	push   %edi
c00285d3:	56                   	push   %esi
c00285d4:	53                   	push   %ebx
c00285d5:	83 ec 1c             	sub    $0x1c,%esp
c00285d8:	8b 7c 24 30          	mov    0x30(%esp),%edi
c00285dc:	8b 74 24 34          	mov    0x34(%esp),%esi
c00285e0:	8b 44 24 38          	mov    0x38(%esp),%eax
c00285e4:	8a 5c 24 3c          	mov    0x3c(%esp),%bl
  size_t i, value_cnt;

  ASSERT (b != NULL);
c00285e8:	85 ff                	test   %edi,%edi
c00285ea:	74 29                	je     c0028615 <bitmap_count+0x44>
  ASSERT (start <= b->bit_cnt);
c00285ec:	8b 17                	mov    (%edi),%edx
c00285ee:	39 f2                	cmp    %esi,%edx
c00285f0:	72 44                	jb     c0028636 <bitmap_count+0x65>
  ASSERT (start + cnt <= b->bit_cnt);
c00285f2:	8d 2c 06             	lea    (%esi,%eax,1),%ebp
c00285f5:	39 ea                	cmp    %ebp,%edx
c00285f7:	72 5e                	jb     c0028657 <bitmap_count+0x86>

  value_cnt = 0;
  for (i = 0; i < cnt; i++)
c00285f9:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0028600:	00 
c0028601:	85 c0                	test   %eax,%eax
c0028603:	75 78                	jne    c002867d <bitmap_count+0xac>
c0028605:	89 44 24 0c          	mov    %eax,0xc(%esp)
    if (bitmap_test (b, start + i) == value)
      value_cnt++;
  return value_cnt;
}
c0028609:	8b 44 24 0c          	mov    0xc(%esp),%eax
c002860d:	83 c4 1c             	add    $0x1c,%esp
c0028610:	5b                   	pop    %ebx
c0028611:	5e                   	pop    %esi
c0028612:	5f                   	pop    %edi
c0028613:	5d                   	pop    %ebp
c0028614:	c3                   	ret    
  ASSERT (b != NULL);
c0028615:	83 ec 0c             	sub    $0xc,%esp
c0028618:	68 cf e5 02 c0       	push   $0xc002e5cf
c002861d:	68 df cb 02 c0       	push   $0xc002cbdf
c0028622:	68 e0 c7 02 c0       	push   $0xc002c7e0
c0028627:	68 ed 00 00 00       	push   $0xed
c002862c:	68 62 e7 02 c0       	push   $0xc002e762
c0028631:	e8 0a f0 ff ff       	call   c0027640 <debug_panic>
  ASSERT (start <= b->bit_cnt);
c0028636:	83 ec 0c             	sub    $0xc,%esp
c0028639:	68 8d e7 02 c0       	push   $0xc002e78d
c002863e:	68 df cb 02 c0       	push   $0xc002cbdf
c0028643:	68 e0 c7 02 c0       	push   $0xc002c7e0
c0028648:	68 ee 00 00 00       	push   $0xee
c002864d:	68 62 e7 02 c0       	push   $0xc002e762
c0028652:	e8 e9 ef ff ff       	call   c0027640 <debug_panic>
  ASSERT (start + cnt <= b->bit_cnt);
c0028657:	83 ec 0c             	sub    $0xc,%esp
c002865a:	68 a1 e7 02 c0       	push   $0xc002e7a1
c002865f:	68 df cb 02 c0       	push   $0xc002cbdf
c0028664:	68 e0 c7 02 c0       	push   $0xc002c7e0
c0028669:	68 ef 00 00 00       	push   $0xef
c002866e:	68 62 e7 02 c0       	push   $0xc002e762
c0028673:	e8 c8 ef ff ff       	call   c0027640 <debug_panic>
c0028678:	46                   	inc    %esi
  for (i = 0; i < cnt; i++)
c0028679:	39 f5                	cmp    %esi,%ebp
c002867b:	74 8c                	je     c0028609 <bitmap_count+0x38>
    if (bitmap_test (b, start + i) == value)
c002867d:	83 ec 08             	sub    $0x8,%esp
c0028680:	56                   	push   %esi
c0028681:	57                   	push   %edi
c0028682:	e8 32 fd ff ff       	call   c00283b9 <bitmap_test>
c0028687:	83 c4 10             	add    $0x10,%esp
c002868a:	38 d8                	cmp    %bl,%al
c002868c:	75 ea                	jne    c0028678 <bitmap_count+0xa7>
      value_cnt++;
c002868e:	ff 44 24 0c          	incl   0xc(%esp)
c0028692:	eb e4                	jmp    c0028678 <bitmap_count+0xa7>

c0028694 <bitmap_contains>:

/* Returns true if any bits in B between START and START + CNT,
   exclusive, are set to VALUE, and false otherwise. */
bool
bitmap_contains (const struct bitmap *b, size_t start, size_t cnt, bool value) 
{
c0028694:	55                   	push   %ebp
c0028695:	57                   	push   %edi
c0028696:	56                   	push   %esi
c0028697:	53                   	push   %ebx
c0028698:	83 ec 0c             	sub    $0xc,%esp
c002869b:	8b 7c 24 20          	mov    0x20(%esp),%edi
c002869f:	8b 74 24 24          	mov    0x24(%esp),%esi
c00286a3:	8b 44 24 28          	mov    0x28(%esp),%eax
c00286a7:	8a 5c 24 2c          	mov    0x2c(%esp),%bl
  size_t i;
  
  ASSERT (b != NULL);
c00286ab:	85 ff                	test   %edi,%edi
c00286ad:	74 2b                	je     c00286da <bitmap_contains+0x46>
  ASSERT (start <= b->bit_cnt);
c00286af:	8b 17                	mov    (%edi),%edx
c00286b1:	39 f2                	cmp    %esi,%edx
c00286b3:	72 46                	jb     c00286fb <bitmap_contains+0x67>
  ASSERT (start + cnt <= b->bit_cnt);
c00286b5:	8d 2c 06             	lea    (%esi,%eax,1),%ebp
c00286b8:	39 ea                	cmp    %ebp,%edx
c00286ba:	72 60                	jb     c002871c <bitmap_contains+0x88>

  for (i = 0; i < cnt; i++)
c00286bc:	85 c0                	test   %eax,%eax
c00286be:	74 7f                	je     c002873f <bitmap_contains+0xab>
    if (bitmap_test (b, start + i) == value)
c00286c0:	83 ec 08             	sub    $0x8,%esp
c00286c3:	56                   	push   %esi
c00286c4:	57                   	push   %edi
c00286c5:	e8 ef fc ff ff       	call   c00283b9 <bitmap_test>
c00286ca:	83 c4 10             	add    $0x10,%esp
c00286cd:	38 d8                	cmp    %bl,%al
c00286cf:	74 6c                	je     c002873d <bitmap_contains+0xa9>
c00286d1:	46                   	inc    %esi
  for (i = 0; i < cnt; i++)
c00286d2:	39 f5                	cmp    %esi,%ebp
c00286d4:	75 ea                	jne    c00286c0 <bitmap_contains+0x2c>
      return true;
  return false;
c00286d6:	b0 00                	mov    $0x0,%al
c00286d8:	eb 65                	jmp    c002873f <bitmap_contains+0xab>
  ASSERT (b != NULL);
c00286da:	83 ec 0c             	sub    $0xc,%esp
c00286dd:	68 cf e5 02 c0       	push   $0xc002e5cf
c00286e2:	68 df cb 02 c0       	push   $0xc002cbdf
c00286e7:	68 d0 c7 02 c0       	push   $0xc002c7d0
c00286ec:	68 ff 00 00 00       	push   $0xff
c00286f1:	68 62 e7 02 c0       	push   $0xc002e762
c00286f6:	e8 45 ef ff ff       	call   c0027640 <debug_panic>
  ASSERT (start <= b->bit_cnt);
c00286fb:	83 ec 0c             	sub    $0xc,%esp
c00286fe:	68 8d e7 02 c0       	push   $0xc002e78d
c0028703:	68 df cb 02 c0       	push   $0xc002cbdf
c0028708:	68 d0 c7 02 c0       	push   $0xc002c7d0
c002870d:	68 00 01 00 00       	push   $0x100
c0028712:	68 62 e7 02 c0       	push   $0xc002e762
c0028717:	e8 24 ef ff ff       	call   c0027640 <debug_panic>
  ASSERT (start + cnt <= b->bit_cnt);
c002871c:	83 ec 0c             	sub    $0xc,%esp
c002871f:	68 a1 e7 02 c0       	push   $0xc002e7a1
c0028724:	68 df cb 02 c0       	push   $0xc002cbdf
c0028729:	68 d0 c7 02 c0       	push   $0xc002c7d0
c002872e:	68 01 01 00 00       	push   $0x101
c0028733:	68 62 e7 02 c0       	push   $0xc002e762
c0028738:	e8 03 ef ff ff       	call   c0027640 <debug_panic>
      return true;
c002873d:	b0 01                	mov    $0x1,%al
}
c002873f:	83 c4 0c             	add    $0xc,%esp
c0028742:	5b                   	pop    %ebx
c0028743:	5e                   	pop    %esi
c0028744:	5f                   	pop    %edi
c0028745:	5d                   	pop    %ebp
c0028746:	c3                   	ret    

c0028747 <bitmap_any>:

/* Returns true if any bits in B between START and START + CNT,
   exclusive, are set to true, and false otherwise.*/
bool
bitmap_any (const struct bitmap *b, size_t start, size_t cnt) 
{
c0028747:	83 ec 0c             	sub    $0xc,%esp
  return bitmap_contains (b, start, cnt, true);
c002874a:	6a 01                	push   $0x1
c002874c:	ff 74 24 1c          	pushl  0x1c(%esp)
c0028750:	ff 74 24 1c          	pushl  0x1c(%esp)
c0028754:	ff 74 24 1c          	pushl  0x1c(%esp)
c0028758:	e8 37 ff ff ff       	call   c0028694 <bitmap_contains>
}
c002875d:	83 c4 1c             	add    $0x1c,%esp
c0028760:	c3                   	ret    

c0028761 <bitmap_none>:

/* Returns true if no bits in B between START and START + CNT,
   exclusive, are set to true, and false otherwise.*/
bool
bitmap_none (const struct bitmap *b, size_t start, size_t cnt) 
{
c0028761:	83 ec 0c             	sub    $0xc,%esp
  return !bitmap_contains (b, start, cnt, true);
c0028764:	6a 01                	push   $0x1
c0028766:	ff 74 24 1c          	pushl  0x1c(%esp)
c002876a:	ff 74 24 1c          	pushl  0x1c(%esp)
c002876e:	ff 74 24 1c          	pushl  0x1c(%esp)
c0028772:	e8 1d ff ff ff       	call   c0028694 <bitmap_contains>
c0028777:	83 f0 01             	xor    $0x1,%eax
}
c002877a:	83 c4 1c             	add    $0x1c,%esp
c002877d:	c3                   	ret    

c002877e <bitmap_all>:

/* Returns true if every bit in B between START and START + CNT,
   exclusive, is set to true, and false otherwise. */
bool
bitmap_all (const struct bitmap *b, size_t start, size_t cnt) 
{
c002877e:	83 ec 0c             	sub    $0xc,%esp
  return !bitmap_contains (b, start, cnt, false);
c0028781:	6a 00                	push   $0x0
c0028783:	ff 74 24 1c          	pushl  0x1c(%esp)
c0028787:	ff 74 24 1c          	pushl  0x1c(%esp)
c002878b:	ff 74 24 1c          	pushl  0x1c(%esp)
c002878f:	e8 00 ff ff ff       	call   c0028694 <bitmap_contains>
c0028794:	83 f0 01             	xor    $0x1,%eax
}
c0028797:	83 c4 1c             	add    $0x1c,%esp
c002879a:	c3                   	ret    

c002879b <bitmap_scan>:
   consecutive bits in B at or after START that are all set to
   VALUE.
   If there is no such group, returns BITMAP_ERROR. */
size_t
bitmap_scan (const struct bitmap *b, size_t start, size_t cnt, bool value) 
{
c002879b:	55                   	push   %ebp
c002879c:	57                   	push   %edi
c002879d:	56                   	push   %esi
c002879e:	53                   	push   %ebx
c002879f:	83 ec 1c             	sub    $0x1c,%esp
c00287a2:	8b 74 24 30          	mov    0x30(%esp),%esi
c00287a6:	8b 5c 24 34          	mov    0x34(%esp),%ebx
c00287aa:	8b 7c 24 38          	mov    0x38(%esp),%edi
c00287ae:	8a 54 24 3c          	mov    0x3c(%esp),%dl
  ASSERT (b != NULL);
c00287b2:	85 f6                	test   %esi,%esi
c00287b4:	74 17                	je     c00287cd <bitmap_scan+0x32>
  ASSERT (start <= b->bit_cnt);
c00287b6:	8b 06                	mov    (%esi),%eax
c00287b8:	39 d8                	cmp    %ebx,%eax
c00287ba:	72 32                	jb     c00287ee <bitmap_scan+0x53>

  if (cnt <= b->bit_cnt) 
c00287bc:	39 f8                	cmp    %edi,%eax
c00287be:	73 4f                	jae    c002880f <bitmap_scan+0x74>
      size_t i;
      for (i = start; i <= last; i++)
        if (!bitmap_contains (b, i, cnt, !value))
          return i; 
    }
  return BITMAP_ERROR;
c00287c0:	b8 ff ff ff ff       	mov    $0xffffffff,%eax
}
c00287c5:	83 c4 1c             	add    $0x1c,%esp
c00287c8:	5b                   	pop    %ebx
c00287c9:	5e                   	pop    %esi
c00287ca:	5f                   	pop    %edi
c00287cb:	5d                   	pop    %ebp
c00287cc:	c3                   	ret    
  ASSERT (b != NULL);
c00287cd:	83 ec 0c             	sub    $0xc,%esp
c00287d0:	68 cf e5 02 c0       	push   $0xc002e5cf
c00287d5:	68 df cb 02 c0       	push   $0xc002cbdf
c00287da:	68 c4 c7 02 c0       	push   $0xc002c7c4
c00287df:	68 2a 01 00 00       	push   $0x12a
c00287e4:	68 62 e7 02 c0       	push   $0xc002e762
c00287e9:	e8 52 ee ff ff       	call   c0027640 <debug_panic>
  ASSERT (start <= b->bit_cnt);
c00287ee:	83 ec 0c             	sub    $0xc,%esp
c00287f1:	68 8d e7 02 c0       	push   $0xc002e78d
c00287f6:	68 df cb 02 c0       	push   $0xc002cbdf
c00287fb:	68 c4 c7 02 c0       	push   $0xc002c7c4
c0028800:	68 2b 01 00 00       	push   $0x12b
c0028805:	68 62 e7 02 c0       	push   $0xc002e762
c002880a:	e8 31 ee ff ff       	call   c0027640 <debug_panic>
      size_t last = b->bit_cnt - cnt;
c002880f:	29 f8                	sub    %edi,%eax
c0028811:	89 44 24 0c          	mov    %eax,0xc(%esp)
      for (i = start; i <= last; i++)
c0028815:	39 c3                	cmp    %eax,%ebx
c0028817:	77 24                	ja     c002883d <bitmap_scan+0xa2>
        if (!bitmap_contains (b, i, cnt, !value))
c0028819:	83 f2 01             	xor    $0x1,%edx
c002881c:	0f b6 ea             	movzbl %dl,%ebp
c002881f:	55                   	push   %ebp
c0028820:	57                   	push   %edi
c0028821:	53                   	push   %ebx
c0028822:	56                   	push   %esi
c0028823:	e8 6c fe ff ff       	call   c0028694 <bitmap_contains>
c0028828:	83 c4 10             	add    $0x10,%esp
c002882b:	84 c0                	test   %al,%al
c002882d:	74 15                	je     c0028844 <bitmap_scan+0xa9>
      for (i = start; i <= last; i++)
c002882f:	43                   	inc    %ebx
c0028830:	39 5c 24 0c          	cmp    %ebx,0xc(%esp)
c0028834:	73 e9                	jae    c002881f <bitmap_scan+0x84>
  return BITMAP_ERROR;
c0028836:	b8 ff ff ff ff       	mov    $0xffffffff,%eax
c002883b:	eb 88                	jmp    c00287c5 <bitmap_scan+0x2a>
c002883d:	b8 ff ff ff ff       	mov    $0xffffffff,%eax
c0028842:	eb 81                	jmp    c00287c5 <bitmap_scan+0x2a>
c0028844:	89 d8                	mov    %ebx,%eax
c0028846:	e9 7a ff ff ff       	jmp    c00287c5 <bitmap_scan+0x2a>

c002884b <bitmap_scan_and_flip>:
   If CNT is zero, returns 0.
   Bits are set atomically, but testing bits is not atomic with
   setting them. */
size_t
bitmap_scan_and_flip (struct bitmap *b, size_t start, size_t cnt, bool value)
{
c002884b:	55                   	push   %ebp
c002884c:	57                   	push   %edi
c002884d:	56                   	push   %esi
c002884e:	53                   	push   %ebx
c002884f:	83 ec 0c             	sub    $0xc,%esp
c0028852:	8b 7c 24 20          	mov    0x20(%esp),%edi
c0028856:	8b 6c 24 28          	mov    0x28(%esp),%ebp
c002885a:	8b 5c 24 2c          	mov    0x2c(%esp),%ebx
  size_t idx = bitmap_scan (b, start, cnt, value);
c002885e:	0f b6 c3             	movzbl %bl,%eax
c0028861:	50                   	push   %eax
c0028862:	55                   	push   %ebp
c0028863:	ff 74 24 2c          	pushl  0x2c(%esp)
c0028867:	57                   	push   %edi
c0028868:	e8 2e ff ff ff       	call   c002879b <bitmap_scan>
c002886d:	83 c4 10             	add    $0x10,%esp
c0028870:	89 c6                	mov    %eax,%esi
  if (idx != BITMAP_ERROR) 
c0028872:	83 f8 ff             	cmp    $0xffffffff,%eax
c0028875:	74 12                	je     c0028889 <bitmap_scan_and_flip+0x3e>
    bitmap_set_multiple (b, idx, cnt, !value);
c0028877:	83 f3 01             	xor    $0x1,%ebx
c002887a:	0f b6 db             	movzbl %bl,%ebx
c002887d:	53                   	push   %ebx
c002887e:	55                   	push   %ebp
c002887f:	50                   	push   %eax
c0028880:	57                   	push   %edi
c0028881:	e8 a3 fb ff ff       	call   c0028429 <bitmap_set_multiple>
c0028886:	83 c4 10             	add    $0x10,%esp
  return idx;
}
c0028889:	89 f0                	mov    %esi,%eax
c002888b:	83 c4 0c             	add    $0xc,%esp
c002888e:	5b                   	pop    %ebx
c002888f:	5e                   	pop    %esi
c0028890:	5f                   	pop    %edi
c0028891:	5d                   	pop    %ebp
c0028892:	c3                   	ret    

c0028893 <bitmap_dump>:
/* Debugging. */

/* Dumps the contents of B to the console as hexadecimal. */
void
bitmap_dump (const struct bitmap *b) 
{
c0028893:	83 ec 0c             	sub    $0xc,%esp
c0028896:	8b 54 24 10          	mov    0x10(%esp),%edx
  hex_dump (0, b->bits, byte_cnt (b->bit_cnt), false);
c002889a:	6a 00                	push   $0x0
  return DIV_ROUND_UP (bit_cnt, ELEM_BITS);
c002889c:	8b 02                	mov    (%edx),%eax
c002889e:	83 c0 1f             	add    $0x1f,%eax
c00288a1:	c1 e8 05             	shr    $0x5,%eax
  return sizeof (elem_type) * elem_cnt (bit_cnt);
c00288a4:	c1 e0 02             	shl    $0x2,%eax
  hex_dump (0, b->bits, byte_cnt (b->bit_cnt), false);
c00288a7:	50                   	push   %eax
c00288a8:	ff 72 04             	pushl  0x4(%edx)
c00288ab:	6a 00                	push   $0x0
c00288ad:	e8 89 da ff ff       	call   c002633b <hex_dump>
}
c00288b2:	83 c4 1c             	add    $0x1c,%esp
c00288b5:	c3                   	ret    

c00288b6 <find_bucket>:
}

/* Returns the bucket in H that E belongs in. */
static struct list *
find_bucket (struct hash *h, struct hash_elem *e) 
{
c00288b6:	53                   	push   %ebx
c00288b7:	83 ec 10             	sub    $0x10,%esp
c00288ba:	89 c3                	mov    %eax,%ebx
  size_t bucket_idx = h->hash (e, h->aux) & (h->bucket_cnt - 1);
c00288bc:	ff 70 14             	pushl  0x14(%eax)
c00288bf:	52                   	push   %edx
c00288c0:	ff 50 0c             	call   *0xc(%eax)
c00288c3:	8b 4b 04             	mov    0x4(%ebx),%ecx
c00288c6:	8d 51 ff             	lea    -0x1(%ecx),%edx
c00288c9:	21 d0                	and    %edx,%eax
  return &h->buckets[bucket_idx];
c00288cb:	c1 e0 04             	shl    $0x4,%eax
c00288ce:	03 43 08             	add    0x8(%ebx),%eax
}
c00288d1:	83 c4 18             	add    $0x18,%esp
c00288d4:	5b                   	pop    %ebx
c00288d5:	c3                   	ret    

c00288d6 <find_elem>:

/* Searches BUCKET in H for a hash element equal to E.  Returns
   it if found or a null pointer otherwise. */
static struct hash_elem *
find_elem (struct hash *h, struct list *bucket, struct hash_elem *e) 
{
c00288d6:	55                   	push   %ebp
c00288d7:	57                   	push   %edi
c00288d8:	56                   	push   %esi
c00288d9:	53                   	push   %ebx
c00288da:	83 ec 18             	sub    $0x18,%esp
c00288dd:	89 c6                	mov    %eax,%esi
c00288df:	89 d5                	mov    %edx,%ebp
c00288e1:	89 cf                	mov    %ecx,%edi
  struct list_elem *i;

  for (i = list_begin (bucket); i != list_end (bucket); i = list_next (i)) 
c00288e3:	52                   	push   %edx
c00288e4:	e8 41 ee ff ff       	call   c002772a <list_begin>
c00288e9:	89 c3                	mov    %eax,%ebx
c00288eb:	83 c4 10             	add    $0x10,%esp
c00288ee:	eb 0e                	jmp    c00288fe <find_elem+0x28>
c00288f0:	83 ec 0c             	sub    $0xc,%esp
c00288f3:	53                   	push   %ebx
c00288f4:	e8 61 ee ff ff       	call   c002775a <list_next>
c00288f9:	89 c3                	mov    %eax,%ebx
c00288fb:	83 c4 10             	add    $0x10,%esp
c00288fe:	83 ec 0c             	sub    $0xc,%esp
c0028901:	55                   	push   %ebp
c0028902:	e8 9b ee ff ff       	call   c00277a2 <list_end>
c0028907:	83 c4 10             	add    $0x10,%esp
c002890a:	39 c3                	cmp    %eax,%ebx
c002890c:	74 28                	je     c0028936 <find_elem+0x60>
    {
      struct hash_elem *hi = list_elem_to_hash_elem (i);
      if (!h->less (hi, e, h->aux) && !h->less (e, hi, h->aux))
c002890e:	83 ec 04             	sub    $0x4,%esp
c0028911:	ff 76 14             	pushl  0x14(%esi)
c0028914:	57                   	push   %edi
c0028915:	53                   	push   %ebx
c0028916:	ff 56 10             	call   *0x10(%esi)
c0028919:	83 c4 10             	add    $0x10,%esp
c002891c:	84 c0                	test   %al,%al
c002891e:	75 d0                	jne    c00288f0 <find_elem+0x1a>
c0028920:	83 ec 04             	sub    $0x4,%esp
c0028923:	ff 76 14             	pushl  0x14(%esi)
c0028926:	53                   	push   %ebx
c0028927:	57                   	push   %edi
c0028928:	ff 56 10             	call   *0x10(%esi)
c002892b:	83 c4 10             	add    $0x10,%esp
c002892e:	84 c0                	test   %al,%al
c0028930:	75 be                	jne    c00288f0 <find_elem+0x1a>
c0028932:	89 d8                	mov    %ebx,%eax
c0028934:	eb 05                	jmp    c002893b <find_elem+0x65>
        return hi; 
    }
  return NULL;
c0028936:	b8 00 00 00 00       	mov    $0x0,%eax
}
c002893b:	83 c4 0c             	add    $0xc,%esp
c002893e:	5b                   	pop    %ebx
c002893f:	5e                   	pop    %esi
c0028940:	5f                   	pop    %edi
c0028941:	5d                   	pop    %ebp
c0028942:	c3                   	ret    

c0028943 <rehash>:
   ideal.  This function can fail because of an out-of-memory
   condition, but that'll just make hash accesses less efficient;
   we can still continue. */
static void
rehash (struct hash *h) 
{
c0028943:	55                   	push   %ebp
c0028944:	57                   	push   %edi
c0028945:	56                   	push   %esi
c0028946:	53                   	push   %ebx
c0028947:	83 ec 2c             	sub    $0x2c,%esp
c002894a:	89 44 24 0c          	mov    %eax,0xc(%esp)
  size_t old_bucket_cnt, new_bucket_cnt;
  struct list *new_buckets, *old_buckets;
  size_t i;

  ASSERT (h != NULL);
c002894e:	85 c0                	test   %eax,%eax
c0028950:	74 21                	je     c0028973 <rehash+0x30>

  /* Save old bucket info for later use. */
  old_buckets = h->buckets;
  old_bucket_cnt = h->bucket_cnt;
c0028952:	8b 44 24 0c          	mov    0xc(%esp),%eax
c0028956:	8b 48 04             	mov    0x4(%eax),%ecx
c0028959:	89 4c 24 18          	mov    %ecx,0x18(%esp)

  /* Calculate the number of buckets to use now.
     We want one bucket for about every BEST_ELEMS_PER_BUCKET.
     We must have at least four buckets, and the number of
     buckets must be a power of 2. */
  new_bucket_cnt = h->elem_cnt / BEST_ELEMS_PER_BUCKET;
c002895d:	8b 00                	mov    (%eax),%eax
c002895f:	89 44 24 10          	mov    %eax,0x10(%esp)
c0028963:	89 c3                	mov    %eax,%ebx
c0028965:	d1 eb                	shr    %ebx
c0028967:	83 fb 04             	cmp    $0x4,%ebx
c002896a:	73 2d                	jae    c0028999 <rehash+0x56>
c002896c:	bb 04 00 00 00       	mov    $0x4,%ebx
c0028971:	eb 26                	jmp    c0028999 <rehash+0x56>
  ASSERT (h != NULL);
c0028973:	83 ec 0c             	sub    $0xc,%esp
c0028976:	68 e4 e7 02 c0       	push   $0xc002e7e4
c002897b:	68 df cb 02 c0       	push   $0xc002cbdf
c0028980:	68 80 c8 02 c0       	push   $0xc002c880
c0028985:	68 66 01 00 00       	push   $0x166
c002898a:	68 ee e7 02 c0       	push   $0xc002e7ee
c002898f:	e8 ac ec ff ff       	call   c0027640 <debug_panic>
  return x & (x - 1);
c0028994:	8d 43 ff             	lea    -0x1(%ebx),%eax
c0028997:	21 c3                	and    %eax,%ebx
  return x != 0 && turn_off_least_1bit (x) == 0;
c0028999:	85 db                	test   %ebx,%ebx
c002899b:	74 f7                	je     c0028994 <rehash+0x51>
  return x & (x - 1);
c002899d:	8d 43 ff             	lea    -0x1(%ebx),%eax
  if (new_bucket_cnt < 4)
    new_bucket_cnt = 4;
  while (!is_power_of_2 (new_bucket_cnt))
c00289a0:	21 d8                	and    %ebx,%eax
c00289a2:	75 f0                	jne    c0028994 <rehash+0x51>
c00289a4:	89 c6                	mov    %eax,%esi
c00289a6:	89 44 24 10          	mov    %eax,0x10(%esp)
    new_bucket_cnt = turn_off_least_1bit (new_bucket_cnt);

  /* Don't do anything if the bucket count wouldn't change. */
  if (new_bucket_cnt == old_bucket_cnt)
c00289aa:	3b 5c 24 18          	cmp    0x18(%esp),%ebx
c00289ae:	0f 84 ce 00 00 00    	je     c0028a82 <rehash+0x13f>
  old_buckets = h->buckets;
c00289b4:	8b 44 24 0c          	mov    0xc(%esp),%eax
c00289b8:	8b 40 08             	mov    0x8(%eax),%eax
c00289bb:	89 44 24 1c          	mov    %eax,0x1c(%esp)
    return;

  /* Allocate new buckets and initialize them as empty. */
  new_buckets = malloc (sizeof *new_buckets * new_bucket_cnt);
c00289bf:	83 ec 0c             	sub    $0xc,%esp
c00289c2:	89 d8                	mov    %ebx,%eax
c00289c4:	c1 e0 04             	shl    $0x4,%eax
c00289c7:	50                   	push   %eax
c00289c8:	e8 e4 a2 ff ff       	call   c0022cb1 <malloc>
c00289cd:	89 c5                	mov    %eax,%ebp
  if (new_buckets == NULL) 
c00289cf:	83 c4 10             	add    $0x10,%esp
c00289d2:	85 c0                	test   %eax,%eax
c00289d4:	0f 84 a8 00 00 00    	je     c0028a82 <rehash+0x13f>
c00289da:	89 c7                	mov    %eax,%edi
         be less efficient.  However, it is still usable, so
         there's no reason for it to be an error. */
      return;
    }
  for (i = 0; i < new_bucket_cnt; i++) 
    list_init (&new_buckets[i]);
c00289dc:	83 ec 0c             	sub    $0xc,%esp
c00289df:	57                   	push   %edi
c00289e0:	e8 02 ed ff ff       	call   c00276e7 <list_init>
  for (i = 0; i < new_bucket_cnt; i++) 
c00289e5:	46                   	inc    %esi
c00289e6:	83 c7 10             	add    $0x10,%edi
c00289e9:	83 c4 10             	add    $0x10,%esp
c00289ec:	39 f3                	cmp    %esi,%ebx
c00289ee:	75 ec                	jne    c00289dc <rehash+0x99>

  /* Install new bucket info. */
  h->buckets = new_buckets;
c00289f0:	8b 44 24 0c          	mov    0xc(%esp),%eax
c00289f4:	89 68 08             	mov    %ebp,0x8(%eax)
  h->bucket_cnt = new_bucket_cnt;
c00289f7:	89 58 04             	mov    %ebx,0x4(%eax)

  /* Move each old element into the appropriate new bucket. */
  for (i = 0; i < old_bucket_cnt; i++) 
c00289fa:	83 7c 24 18 00       	cmpl   $0x0,0x18(%esp)
c00289ff:	74 72                	je     c0028a73 <rehash+0x130>
c0028a01:	8b 44 24 1c          	mov    0x1c(%esp),%eax
c0028a05:	89 44 24 14          	mov    %eax,0x14(%esp)
c0028a09:	eb 52                	jmp    c0028a5d <rehash+0x11a>

      old_bucket = &old_buckets[i];
      for (elem = list_begin (old_bucket);
           elem != list_end (old_bucket); elem = next) 
        {
          struct list *new_bucket
c0028a0b:	89 da                	mov    %ebx,%edx
c0028a0d:	8b 44 24 0c          	mov    0xc(%esp),%eax
c0028a11:	e8 a0 fe ff ff       	call   c00288b6 <find_bucket>
c0028a16:	89 c7                	mov    %eax,%edi
            = find_bucket (h, list_elem_to_hash_elem (elem));
          next = list_next (elem);
c0028a18:	83 ec 0c             	sub    $0xc,%esp
c0028a1b:	53                   	push   %ebx
c0028a1c:	e8 39 ed ff ff       	call   c002775a <list_next>
c0028a21:	89 c6                	mov    %eax,%esi
          list_remove (elem);
c0028a23:	89 1c 24             	mov    %ebx,(%esp)
c0028a26:	e8 76 f1 ff ff       	call   c0027ba1 <list_remove>
          list_push_front (new_bucket, elem);
c0028a2b:	83 c4 08             	add    $0x8,%esp
c0028a2e:	53                   	push   %ebx
c0028a2f:	57                   	push   %edi
c0028a30:	e8 32 f1 ff ff       	call   c0027b67 <list_push_front>
           elem != list_end (old_bucket); elem = next) 
c0028a35:	83 c4 10             	add    $0x10,%esp
c0028a38:	89 f3                	mov    %esi,%ebx
c0028a3a:	83 ec 0c             	sub    $0xc,%esp
c0028a3d:	55                   	push   %ebp
c0028a3e:	e8 5f ed ff ff       	call   c00277a2 <list_end>
      for (elem = list_begin (old_bucket);
c0028a43:	83 c4 10             	add    $0x10,%esp
c0028a46:	39 c3                	cmp    %eax,%ebx
c0028a48:	75 c1                	jne    c0028a0b <rehash+0xc8>
  for (i = 0; i < old_bucket_cnt; i++) 
c0028a4a:	ff 44 24 10          	incl   0x10(%esp)
c0028a4e:	8b 44 24 10          	mov    0x10(%esp),%eax
c0028a52:	83 44 24 14 10       	addl   $0x10,0x14(%esp)
c0028a57:	39 44 24 18          	cmp    %eax,0x18(%esp)
c0028a5b:	74 16                	je     c0028a73 <rehash+0x130>
      old_bucket = &old_buckets[i];
c0028a5d:	8b 44 24 14          	mov    0x14(%esp),%eax
c0028a61:	89 c5                	mov    %eax,%ebp
      for (elem = list_begin (old_bucket);
c0028a63:	83 ec 0c             	sub    $0xc,%esp
c0028a66:	50                   	push   %eax
c0028a67:	e8 be ec ff ff       	call   c002772a <list_begin>
c0028a6c:	89 c3                	mov    %eax,%ebx
c0028a6e:	83 c4 10             	add    $0x10,%esp
c0028a71:	eb c7                	jmp    c0028a3a <rehash+0xf7>
        }
    }

  free (old_buckets);
c0028a73:	83 ec 0c             	sub    $0xc,%esp
c0028a76:	ff 74 24 28          	pushl  0x28(%esp)
c0028a7a:	e8 d3 a3 ff ff       	call   c0022e52 <free>
c0028a7f:	83 c4 10             	add    $0x10,%esp
}
c0028a82:	83 c4 2c             	add    $0x2c,%esp
c0028a85:	5b                   	pop    %ebx
c0028a86:	5e                   	pop    %esi
c0028a87:	5f                   	pop    %edi
c0028a88:	5d                   	pop    %ebp
c0028a89:	c3                   	ret    

c0028a8a <hash_clear>:
{
c0028a8a:	55                   	push   %ebp
c0028a8b:	57                   	push   %edi
c0028a8c:	56                   	push   %esi
c0028a8d:	53                   	push   %ebx
c0028a8e:	83 ec 0c             	sub    $0xc,%esp
c0028a91:	8b 74 24 20          	mov    0x20(%esp),%esi
c0028a95:	8b 7c 24 24          	mov    0x24(%esp),%edi
  for (i = 0; i < h->bucket_cnt; i++) 
c0028a99:	83 7e 04 00          	cmpl   $0x0,0x4(%esi)
c0028a9d:	74 4c                	je     c0028aeb <hash_clear+0x61>
c0028a9f:	bd 00 00 00 00       	mov    $0x0,%ebp
c0028aa4:	eb 37                	jmp    c0028add <hash_clear+0x53>
            struct list_elem *list_elem = list_pop_front (bucket);
c0028aa6:	83 ec 0c             	sub    $0xc,%esp
c0028aa9:	53                   	push   %ebx
c0028aaa:	e8 df f1 ff ff       	call   c0027c8e <list_pop_front>
            destructor (hash_elem, h->aux);
c0028aaf:	83 c4 08             	add    $0x8,%esp
c0028ab2:	ff 76 14             	pushl  0x14(%esi)
c0028ab5:	50                   	push   %eax
c0028ab6:	ff d7                	call   *%edi
c0028ab8:	83 c4 10             	add    $0x10,%esp
        while (!list_empty (bucket)) 
c0028abb:	83 ec 0c             	sub    $0xc,%esp
c0028abe:	53                   	push   %ebx
c0028abf:	e8 68 f1 ff ff       	call   c0027c2c <list_empty>
c0028ac4:	83 c4 10             	add    $0x10,%esp
c0028ac7:	84 c0                	test   %al,%al
c0028ac9:	74 db                	je     c0028aa6 <hash_clear+0x1c>
      list_init (bucket); 
c0028acb:	83 ec 0c             	sub    $0xc,%esp
c0028ace:	53                   	push   %ebx
c0028acf:	e8 13 ec ff ff       	call   c00276e7 <list_init>
  for (i = 0; i < h->bucket_cnt; i++) 
c0028ad4:	45                   	inc    %ebp
c0028ad5:	83 c4 10             	add    $0x10,%esp
c0028ad8:	39 6e 04             	cmp    %ebp,0x4(%esi)
c0028adb:	76 0e                	jbe    c0028aeb <hash_clear+0x61>
      struct list *bucket = &h->buckets[i];
c0028add:	89 eb                	mov    %ebp,%ebx
c0028adf:	c1 e3 04             	shl    $0x4,%ebx
c0028ae2:	03 5e 08             	add    0x8(%esi),%ebx
      if (destructor != NULL) 
c0028ae5:	85 ff                	test   %edi,%edi
c0028ae7:	75 d2                	jne    c0028abb <hash_clear+0x31>
c0028ae9:	eb e0                	jmp    c0028acb <hash_clear+0x41>
  h->elem_cnt = 0;
c0028aeb:	c7 06 00 00 00 00    	movl   $0x0,(%esi)
}
c0028af1:	83 c4 0c             	add    $0xc,%esp
c0028af4:	5b                   	pop    %ebx
c0028af5:	5e                   	pop    %esi
c0028af6:	5f                   	pop    %edi
c0028af7:	5d                   	pop    %ebp
c0028af8:	c3                   	ret    

c0028af9 <hash_init>:
{
c0028af9:	53                   	push   %ebx
c0028afa:	83 ec 14             	sub    $0x14,%esp
c0028afd:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  h->elem_cnt = 0;
c0028b01:	c7 03 00 00 00 00    	movl   $0x0,(%ebx)
  h->bucket_cnt = 4;
c0028b07:	c7 43 04 04 00 00 00 	movl   $0x4,0x4(%ebx)
  h->buckets = malloc (sizeof *h->buckets * h->bucket_cnt);
c0028b0e:	6a 40                	push   $0x40
c0028b10:	e8 9c a1 ff ff       	call   c0022cb1 <malloc>
c0028b15:	89 43 08             	mov    %eax,0x8(%ebx)
  h->hash = hash;
c0028b18:	8b 54 24 24          	mov    0x24(%esp),%edx
c0028b1c:	89 53 0c             	mov    %edx,0xc(%ebx)
  h->less = less;
c0028b1f:	8b 54 24 28          	mov    0x28(%esp),%edx
c0028b23:	89 53 10             	mov    %edx,0x10(%ebx)
  h->aux = aux;
c0028b26:	8b 54 24 2c          	mov    0x2c(%esp),%edx
c0028b2a:	89 53 14             	mov    %edx,0x14(%ebx)
  if (h->buckets != NULL) 
c0028b2d:	83 c4 10             	add    $0x10,%esp
c0028b30:	85 c0                	test   %eax,%eax
c0028b32:	74 15                	je     c0028b49 <hash_init+0x50>
      hash_clear (h, NULL);
c0028b34:	83 ec 08             	sub    $0x8,%esp
c0028b37:	6a 00                	push   $0x0
c0028b39:	53                   	push   %ebx
c0028b3a:	e8 4b ff ff ff       	call   c0028a8a <hash_clear>
      return true;
c0028b3f:	83 c4 10             	add    $0x10,%esp
c0028b42:	b0 01                	mov    $0x1,%al
}
c0028b44:	83 c4 08             	add    $0x8,%esp
c0028b47:	5b                   	pop    %ebx
c0028b48:	c3                   	ret    
    return false;
c0028b49:	b0 00                	mov    $0x0,%al
c0028b4b:	eb f7                	jmp    c0028b44 <hash_init+0x4b>

c0028b4d <hash_destroy>:
{
c0028b4d:	53                   	push   %ebx
c0028b4e:	83 ec 08             	sub    $0x8,%esp
c0028b51:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0028b55:	8b 44 24 14          	mov    0x14(%esp),%eax
  if (destructor != NULL)
c0028b59:	85 c0                	test   %eax,%eax
c0028b5b:	74 0d                	je     c0028b6a <hash_destroy+0x1d>
    hash_clear (h, destructor);
c0028b5d:	83 ec 08             	sub    $0x8,%esp
c0028b60:	50                   	push   %eax
c0028b61:	53                   	push   %ebx
c0028b62:	e8 23 ff ff ff       	call   c0028a8a <hash_clear>
c0028b67:	83 c4 10             	add    $0x10,%esp
  free (h->buckets);
c0028b6a:	83 ec 0c             	sub    $0xc,%esp
c0028b6d:	ff 73 08             	pushl  0x8(%ebx)
c0028b70:	e8 dd a2 ff ff       	call   c0022e52 <free>
}
c0028b75:	83 c4 18             	add    $0x18,%esp
c0028b78:	5b                   	pop    %ebx
c0028b79:	c3                   	ret    

c0028b7a <hash_insert>:
{
c0028b7a:	55                   	push   %ebp
c0028b7b:	57                   	push   %edi
c0028b7c:	56                   	push   %esi
c0028b7d:	53                   	push   %ebx
c0028b7e:	83 ec 0c             	sub    $0xc,%esp
c0028b81:	8b 5c 24 20          	mov    0x20(%esp),%ebx
c0028b85:	8b 74 24 24          	mov    0x24(%esp),%esi
  struct list *bucket = find_bucket (h, new);
c0028b89:	89 f2                	mov    %esi,%edx
c0028b8b:	89 d8                	mov    %ebx,%eax
c0028b8d:	e8 24 fd ff ff       	call   c00288b6 <find_bucket>
c0028b92:	89 c5                	mov    %eax,%ebp
  struct hash_elem *old = find_elem (h, bucket, new);
c0028b94:	89 f1                	mov    %esi,%ecx
c0028b96:	89 c2                	mov    %eax,%edx
c0028b98:	89 d8                	mov    %ebx,%eax
c0028b9a:	e8 37 fd ff ff       	call   c00288d6 <find_elem>
c0028b9f:	89 c7                	mov    %eax,%edi
  if (old == NULL) 
c0028ba1:	85 c0                	test   %eax,%eax
c0028ba3:	74 11                	je     c0028bb6 <hash_insert+0x3c>
  rehash (h);
c0028ba5:	89 d8                	mov    %ebx,%eax
c0028ba7:	e8 97 fd ff ff       	call   c0028943 <rehash>
}
c0028bac:	89 f8                	mov    %edi,%eax
c0028bae:	83 c4 0c             	add    $0xc,%esp
c0028bb1:	5b                   	pop    %ebx
c0028bb2:	5e                   	pop    %esi
c0028bb3:	5f                   	pop    %edi
c0028bb4:	5d                   	pop    %ebp
c0028bb5:	c3                   	ret    

/* Inserts E into BUCKET (in hash table H). */
static void
insert_elem (struct hash *h, struct list *bucket, struct hash_elem *e) 
{
  h->elem_cnt++;
c0028bb6:	ff 03                	incl   (%ebx)
  list_push_front (bucket, &e->list_elem);
c0028bb8:	83 ec 08             	sub    $0x8,%esp
c0028bbb:	56                   	push   %esi
c0028bbc:	55                   	push   %ebp
c0028bbd:	e8 a5 ef ff ff       	call   c0027b67 <list_push_front>
c0028bc2:	83 c4 10             	add    $0x10,%esp
c0028bc5:	eb de                	jmp    c0028ba5 <hash_insert+0x2b>

c0028bc7 <hash_replace>:
{
c0028bc7:	55                   	push   %ebp
c0028bc8:	57                   	push   %edi
c0028bc9:	56                   	push   %esi
c0028bca:	53                   	push   %ebx
c0028bcb:	83 ec 0c             	sub    $0xc,%esp
c0028bce:	8b 5c 24 20          	mov    0x20(%esp),%ebx
c0028bd2:	8b 74 24 24          	mov    0x24(%esp),%esi
  struct list *bucket = find_bucket (h, new);
c0028bd6:	89 f2                	mov    %esi,%edx
c0028bd8:	89 d8                	mov    %ebx,%eax
c0028bda:	e8 d7 fc ff ff       	call   c00288b6 <find_bucket>
c0028bdf:	89 c5                	mov    %eax,%ebp
  struct hash_elem *old = find_elem (h, bucket, new);
c0028be1:	89 f1                	mov    %esi,%ecx
c0028be3:	89 c2                	mov    %eax,%edx
c0028be5:	89 d8                	mov    %ebx,%eax
c0028be7:	e8 ea fc ff ff       	call   c00288d6 <find_elem>
c0028bec:	89 c7                	mov    %eax,%edi
  if (old != NULL)
c0028bee:	85 c0                	test   %eax,%eax
c0028bf0:	74 0e                	je     c0028c00 <hash_replace+0x39>

/* Removes E from hash table H. */
static void
remove_elem (struct hash *h, struct hash_elem *e) 
{
  h->elem_cnt--;
c0028bf2:	ff 0b                	decl   (%ebx)
  list_remove (&e->list_elem);
c0028bf4:	83 ec 0c             	sub    $0xc,%esp
c0028bf7:	50                   	push   %eax
c0028bf8:	e8 a4 ef ff ff       	call   c0027ba1 <list_remove>
c0028bfd:	83 c4 10             	add    $0x10,%esp
  h->elem_cnt++;
c0028c00:	ff 03                	incl   (%ebx)
  list_push_front (bucket, &e->list_elem);
c0028c02:	83 ec 08             	sub    $0x8,%esp
c0028c05:	56                   	push   %esi
c0028c06:	55                   	push   %ebp
c0028c07:	e8 5b ef ff ff       	call   c0027b67 <list_push_front>
  rehash (h);
c0028c0c:	89 d8                	mov    %ebx,%eax
c0028c0e:	e8 30 fd ff ff       	call   c0028943 <rehash>
}
c0028c13:	89 f8                	mov    %edi,%eax
c0028c15:	83 c4 1c             	add    $0x1c,%esp
c0028c18:	5b                   	pop    %ebx
c0028c19:	5e                   	pop    %esi
c0028c1a:	5f                   	pop    %edi
c0028c1b:	5d                   	pop    %ebp
c0028c1c:	c3                   	ret    

c0028c1d <hash_find>:
{
c0028c1d:	83 ec 0c             	sub    $0xc,%esp
  return find_elem (h, find_bucket (h, e), e);
c0028c20:	8b 54 24 14          	mov    0x14(%esp),%edx
c0028c24:	8b 44 24 10          	mov    0x10(%esp),%eax
c0028c28:	e8 89 fc ff ff       	call   c00288b6 <find_bucket>
c0028c2d:	8b 4c 24 14          	mov    0x14(%esp),%ecx
c0028c31:	89 c2                	mov    %eax,%edx
c0028c33:	8b 44 24 10          	mov    0x10(%esp),%eax
c0028c37:	e8 9a fc ff ff       	call   c00288d6 <find_elem>
}
c0028c3c:	83 c4 0c             	add    $0xc,%esp
c0028c3f:	c3                   	ret    

c0028c40 <hash_delete>:
{
c0028c40:	56                   	push   %esi
c0028c41:	53                   	push   %ebx
c0028c42:	83 ec 04             	sub    $0x4,%esp
c0028c45:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0028c49:	8b 74 24 14          	mov    0x14(%esp),%esi
  struct hash_elem *found = find_elem (h, find_bucket (h, e), e);
c0028c4d:	89 f2                	mov    %esi,%edx
c0028c4f:	89 d8                	mov    %ebx,%eax
c0028c51:	e8 60 fc ff ff       	call   c00288b6 <find_bucket>
c0028c56:	89 f1                	mov    %esi,%ecx
c0028c58:	89 c2                	mov    %eax,%edx
c0028c5a:	89 d8                	mov    %ebx,%eax
c0028c5c:	e8 75 fc ff ff       	call   c00288d6 <find_elem>
c0028c61:	89 c6                	mov    %eax,%esi
  if (found != NULL) 
c0028c63:	85 c0                	test   %eax,%eax
c0028c65:	74 15                	je     c0028c7c <hash_delete+0x3c>
  h->elem_cnt--;
c0028c67:	ff 0b                	decl   (%ebx)
  list_remove (&e->list_elem);
c0028c69:	83 ec 0c             	sub    $0xc,%esp
c0028c6c:	50                   	push   %eax
c0028c6d:	e8 2f ef ff ff       	call   c0027ba1 <list_remove>
      rehash (h); 
c0028c72:	89 d8                	mov    %ebx,%eax
c0028c74:	e8 ca fc ff ff       	call   c0028943 <rehash>
c0028c79:	83 c4 10             	add    $0x10,%esp
}
c0028c7c:	89 f0                	mov    %esi,%eax
c0028c7e:	83 c4 04             	add    $0x4,%esp
c0028c81:	5b                   	pop    %ebx
c0028c82:	5e                   	pop    %esi
c0028c83:	c3                   	ret    

c0028c84 <hash_apply>:
{
c0028c84:	55                   	push   %ebp
c0028c85:	57                   	push   %edi
c0028c86:	56                   	push   %esi
c0028c87:	53                   	push   %ebx
c0028c88:	83 ec 1c             	sub    $0x1c,%esp
c0028c8b:	8b 6c 24 30          	mov    0x30(%esp),%ebp
  ASSERT (action != NULL);
c0028c8f:	83 7c 24 34 00       	cmpl   $0x0,0x34(%esp)
c0028c94:	74 16                	je     c0028cac <hash_apply+0x28>
  for (i = 0; i < h->bucket_cnt; i++) 
c0028c96:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0028c9d:	00 
c0028c9e:	83 7d 04 00          	cmpl   $0x0,0x4(%ebp)
c0028ca2:	75 61                	jne    c0028d05 <hash_apply+0x81>
}
c0028ca4:	83 c4 1c             	add    $0x1c,%esp
c0028ca7:	5b                   	pop    %ebx
c0028ca8:	5e                   	pop    %esi
c0028ca9:	5f                   	pop    %edi
c0028caa:	5d                   	pop    %ebp
c0028cab:	c3                   	ret    
  ASSERT (action != NULL);
c0028cac:	83 ec 0c             	sub    $0xc,%esp
c0028caf:	68 06 e8 02 c0       	push   $0xc002e806
c0028cb4:	68 df cb 02 c0       	push   $0xc002cbdf
c0028cb9:	68 74 c8 02 c0       	push   $0xc002c874
c0028cbe:	68 a7 00 00 00       	push   $0xa7
c0028cc3:	68 ee e7 02 c0       	push   $0xc002e7ee
c0028cc8:	e8 73 e9 ff ff       	call   c0027640 <debug_panic>
          next = list_next (elem);
c0028ccd:	83 ec 0c             	sub    $0xc,%esp
c0028cd0:	53                   	push   %ebx
c0028cd1:	e8 84 ea ff ff       	call   c002775a <list_next>
c0028cd6:	89 c6                	mov    %eax,%esi
          action (list_elem_to_hash_elem (elem), h->aux);
c0028cd8:	83 c4 08             	add    $0x8,%esp
c0028cdb:	ff 75 14             	pushl  0x14(%ebp)
c0028cde:	53                   	push   %ebx
c0028cdf:	ff 54 24 44          	call   *0x44(%esp)
      for (elem = list_begin (bucket); elem != list_end (bucket); elem = next) 
c0028ce3:	83 c4 10             	add    $0x10,%esp
c0028ce6:	89 f3                	mov    %esi,%ebx
c0028ce8:	83 ec 0c             	sub    $0xc,%esp
c0028ceb:	57                   	push   %edi
c0028cec:	e8 b1 ea ff ff       	call   c00277a2 <list_end>
c0028cf1:	83 c4 10             	add    $0x10,%esp
c0028cf4:	39 c3                	cmp    %eax,%ebx
c0028cf6:	75 d5                	jne    c0028ccd <hash_apply+0x49>
  for (i = 0; i < h->bucket_cnt; i++) 
c0028cf8:	ff 44 24 0c          	incl   0xc(%esp)
c0028cfc:	8b 44 24 0c          	mov    0xc(%esp),%eax
c0028d00:	39 45 04             	cmp    %eax,0x4(%ebp)
c0028d03:	76 9f                	jbe    c0028ca4 <hash_apply+0x20>
      struct list *bucket = &h->buckets[i];
c0028d05:	8b 7c 24 0c          	mov    0xc(%esp),%edi
c0028d09:	c1 e7 04             	shl    $0x4,%edi
c0028d0c:	03 7d 08             	add    0x8(%ebp),%edi
      for (elem = list_begin (bucket); elem != list_end (bucket); elem = next) 
c0028d0f:	83 ec 0c             	sub    $0xc,%esp
c0028d12:	57                   	push   %edi
c0028d13:	e8 12 ea ff ff       	call   c002772a <list_begin>
c0028d18:	89 c3                	mov    %eax,%ebx
c0028d1a:	83 c4 10             	add    $0x10,%esp
c0028d1d:	eb c9                	jmp    c0028ce8 <hash_apply+0x64>

c0028d1f <hash_first>:
{
c0028d1f:	53                   	push   %ebx
c0028d20:	83 ec 08             	sub    $0x8,%esp
c0028d23:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c0028d27:	8b 44 24 14          	mov    0x14(%esp),%eax
  ASSERT (i != NULL);
c0028d2b:	85 db                	test   %ebx,%ebx
c0028d2d:	74 1d                	je     c0028d4c <hash_first+0x2d>
  ASSERT (h != NULL);
c0028d2f:	85 c0                	test   %eax,%eax
c0028d31:	74 3a                	je     c0028d6d <hash_first+0x4e>
  i->hash = h;
c0028d33:	89 03                	mov    %eax,(%ebx)
  i->bucket = i->hash->buckets;
c0028d35:	8b 40 08             	mov    0x8(%eax),%eax
c0028d38:	89 43 04             	mov    %eax,0x4(%ebx)
  i->elem = list_elem_to_hash_elem (list_head (i->bucket));
c0028d3b:	83 ec 0c             	sub    $0xc,%esp
c0028d3e:	50                   	push   %eax
c0028d3f:	e8 67 ec ff ff       	call   c00279ab <list_head>
c0028d44:	89 43 08             	mov    %eax,0x8(%ebx)
}
c0028d47:	83 c4 18             	add    $0x18,%esp
c0028d4a:	5b                   	pop    %ebx
c0028d4b:	c3                   	ret    
  ASSERT (i != NULL);
c0028d4c:	83 ec 0c             	sub    $0xc,%esp
c0028d4f:	68 15 e8 02 c0       	push   $0xc002e815
c0028d54:	68 df cb 02 c0       	push   $0xc002cbdf
c0028d59:	68 68 c8 02 c0       	push   $0xc002c868
c0028d5e:	68 ca 00 00 00       	push   $0xca
c0028d63:	68 ee e7 02 c0       	push   $0xc002e7ee
c0028d68:	e8 d3 e8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (h != NULL);
c0028d6d:	83 ec 0c             	sub    $0xc,%esp
c0028d70:	68 e4 e7 02 c0       	push   $0xc002e7e4
c0028d75:	68 df cb 02 c0       	push   $0xc002cbdf
c0028d7a:	68 68 c8 02 c0       	push   $0xc002c868
c0028d7f:	68 cb 00 00 00       	push   $0xcb
c0028d84:	68 ee e7 02 c0       	push   $0xc002e7ee
c0028d89:	e8 b2 e8 ff ff       	call   c0027640 <debug_panic>

c0028d8e <hash_next>:
{
c0028d8e:	56                   	push   %esi
c0028d8f:	53                   	push   %ebx
c0028d90:	83 ec 04             	sub    $0x4,%esp
c0028d93:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (i != NULL);
c0028d97:	85 db                	test   %ebx,%ebx
c0028d99:	74 4f                	je     c0028dea <hash_next+0x5c>
  i->elem = list_elem_to_hash_elem (list_next (&i->elem->list_elem));
c0028d9b:	83 ec 0c             	sub    $0xc,%esp
c0028d9e:	ff 73 08             	pushl  0x8(%ebx)
c0028da1:	e8 b4 e9 ff ff       	call   c002775a <list_next>
c0028da6:	89 43 08             	mov    %eax,0x8(%ebx)
  while (i->elem == list_elem_to_hash_elem (list_end (i->bucket)))
c0028da9:	83 c4 10             	add    $0x10,%esp
c0028dac:	8b 73 08             	mov    0x8(%ebx),%esi
c0028daf:	83 ec 0c             	sub    $0xc,%esp
c0028db2:	ff 73 04             	pushl  0x4(%ebx)
c0028db5:	e8 e8 e9 ff ff       	call   c00277a2 <list_end>
c0028dba:	83 c4 10             	add    $0x10,%esp
c0028dbd:	39 c6                	cmp    %eax,%esi
c0028dbf:	75 51                	jne    c0028e12 <hash_next+0x84>
      if (++i->bucket >= i->hash->buckets + i->hash->bucket_cnt)
c0028dc1:	8b 43 04             	mov    0x4(%ebx),%eax
c0028dc4:	8d 50 10             	lea    0x10(%eax),%edx
c0028dc7:	89 53 04             	mov    %edx,0x4(%ebx)
c0028dca:	8b 0b                	mov    (%ebx),%ecx
c0028dcc:	8b 41 04             	mov    0x4(%ecx),%eax
c0028dcf:	c1 e0 04             	shl    $0x4,%eax
c0028dd2:	03 41 08             	add    0x8(%ecx),%eax
c0028dd5:	39 c2                	cmp    %eax,%edx
c0028dd7:	73 32                	jae    c0028e0b <hash_next+0x7d>
      i->elem = list_elem_to_hash_elem (list_begin (i->bucket));
c0028dd9:	83 ec 0c             	sub    $0xc,%esp
c0028ddc:	52                   	push   %edx
c0028ddd:	e8 48 e9 ff ff       	call   c002772a <list_begin>
c0028de2:	89 43 08             	mov    %eax,0x8(%ebx)
c0028de5:	83 c4 10             	add    $0x10,%esp
c0028de8:	eb c2                	jmp    c0028dac <hash_next+0x1e>
  ASSERT (i != NULL);
c0028dea:	83 ec 0c             	sub    $0xc,%esp
c0028ded:	68 15 e8 02 c0       	push   $0xc002e815
c0028df2:	68 df cb 02 c0       	push   $0xc002cbdf
c0028df7:	68 5c c8 02 c0       	push   $0xc002c85c
c0028dfc:	68 dd 00 00 00       	push   $0xdd
c0028e01:	68 ee e7 02 c0       	push   $0xc002e7ee
c0028e06:	e8 35 e8 ff ff       	call   c0027640 <debug_panic>
          i->elem = NULL;
c0028e0b:	c7 43 08 00 00 00 00 	movl   $0x0,0x8(%ebx)
  return i->elem;
c0028e12:	8b 43 08             	mov    0x8(%ebx),%eax
}
c0028e15:	83 c4 04             	add    $0x4,%esp
c0028e18:	5b                   	pop    %ebx
c0028e19:	5e                   	pop    %esi
c0028e1a:	c3                   	ret    

c0028e1b <hash_cur>:
  return i->elem;
c0028e1b:	8b 44 24 04          	mov    0x4(%esp),%eax
c0028e1f:	8b 40 08             	mov    0x8(%eax),%eax
}
c0028e22:	c3                   	ret    

c0028e23 <hash_size>:
  return h->elem_cnt;
c0028e23:	8b 44 24 04          	mov    0x4(%esp),%eax
c0028e27:	8b 00                	mov    (%eax),%eax
}
c0028e29:	c3                   	ret    

c0028e2a <hash_empty>:
  return h->elem_cnt == 0;
c0028e2a:	8b 44 24 04          	mov    0x4(%esp),%eax
c0028e2e:	83 38 00             	cmpl   $0x0,(%eax)
c0028e31:	0f 94 c0             	sete   %al
}
c0028e34:	c3                   	ret    

c0028e35 <hash_bytes>:
{
c0028e35:	53                   	push   %ebx
c0028e36:	83 ec 08             	sub    $0x8,%esp
c0028e39:	8b 4c 24 10          	mov    0x10(%esp),%ecx
c0028e3d:	8b 5c 24 14          	mov    0x14(%esp),%ebx
  ASSERT (buf != NULL);
c0028e41:	85 c9                	test   %ecx,%ecx
c0028e43:	74 35                	je     c0028e7a <hash_bytes+0x45>
  while (size-- > 0)
c0028e45:	b8 c5 9d 1c 81       	mov    $0x811c9dc5,%eax
c0028e4a:	85 db                	test   %ebx,%ebx
c0028e4c:	74 27                	je     c0028e75 <hash_bytes+0x40>
c0028e4e:	01 cb                	add    %ecx,%ebx
c0028e50:	b8 c5 9d 1c 81       	mov    $0x811c9dc5,%eax
    hash = (hash * FNV_32_PRIME) ^ *buf++;
c0028e55:	89 c2                	mov    %eax,%edx
c0028e57:	c1 e2 10             	shl    $0x10,%edx
c0028e5a:	01 c2                	add    %eax,%edx
c0028e5c:	01 d2                	add    %edx,%edx
c0028e5e:	01 c2                	add    %eax,%edx
c0028e60:	8d 14 d0             	lea    (%eax,%edx,8),%edx
c0028e63:	8d 14 d0             	lea    (%eax,%edx,8),%edx
c0028e66:	01 d2                	add    %edx,%edx
c0028e68:	01 d0                	add    %edx,%eax
c0028e6a:	41                   	inc    %ecx
c0028e6b:	0f b6 51 ff          	movzbl -0x1(%ecx),%edx
c0028e6f:	31 d0                	xor    %edx,%eax
  while (size-- > 0)
c0028e71:	39 d9                	cmp    %ebx,%ecx
c0028e73:	75 e0                	jne    c0028e55 <hash_bytes+0x20>
} 
c0028e75:	83 c4 08             	add    $0x8,%esp
c0028e78:	5b                   	pop    %ebx
c0028e79:	c3                   	ret    
  ASSERT (buf != NULL);
c0028e7a:	83 ec 0c             	sub    $0xc,%esp
c0028e7d:	68 1f e8 02 c0       	push   $0xc002e81f
c0028e82:	68 df cb 02 c0       	push   $0xc002cbdf
c0028e87:	68 50 c8 02 c0       	push   $0xc002c850
c0028e8c:	68 10 01 00 00       	push   $0x110
c0028e91:	68 ee e7 02 c0       	push   $0xc002e7ee
c0028e96:	e8 a5 e7 ff ff       	call   c0027640 <debug_panic>

c0028e9b <hash_string>:
{
c0028e9b:	53                   	push   %ebx
c0028e9c:	83 ec 08             	sub    $0x8,%esp
c0028e9f:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  ASSERT (s != NULL);
c0028ea3:	85 db                	test   %ebx,%ebx
c0028ea5:	74 36                	je     c0028edd <hash_string+0x42>
  while (*s != '\0')
c0028ea7:	8a 0b                	mov    (%ebx),%cl
c0028ea9:	b8 c5 9d 1c 81       	mov    $0x811c9dc5,%eax
c0028eae:	84 c9                	test   %cl,%cl
c0028eb0:	74 26                	je     c0028ed8 <hash_string+0x3d>
c0028eb2:	b8 c5 9d 1c 81       	mov    $0x811c9dc5,%eax
    hash = (hash * FNV_32_PRIME) ^ *s++;
c0028eb7:	89 c2                	mov    %eax,%edx
c0028eb9:	c1 e2 10             	shl    $0x10,%edx
c0028ebc:	01 c2                	add    %eax,%edx
c0028ebe:	01 d2                	add    %edx,%edx
c0028ec0:	01 c2                	add    %eax,%edx
c0028ec2:	8d 14 d0             	lea    (%eax,%edx,8),%edx
c0028ec5:	8d 14 d0             	lea    (%eax,%edx,8),%edx
c0028ec8:	01 d2                	add    %edx,%edx
c0028eca:	01 d0                	add    %edx,%eax
c0028ecc:	43                   	inc    %ebx
c0028ecd:	0f b6 c9             	movzbl %cl,%ecx
c0028ed0:	31 c8                	xor    %ecx,%eax
  while (*s != '\0')
c0028ed2:	8a 0b                	mov    (%ebx),%cl
c0028ed4:	84 c9                	test   %cl,%cl
c0028ed6:	75 df                	jne    c0028eb7 <hash_string+0x1c>
}
c0028ed8:	83 c4 08             	add    $0x8,%esp
c0028edb:	5b                   	pop    %ebx
c0028edc:	c3                   	ret    
  ASSERT (s != NULL);
c0028edd:	83 ec 0c             	sub    $0xc,%esp
c0028ee0:	68 ab e3 02 c0       	push   $0xc002e3ab
c0028ee5:	68 df cb 02 c0       	push   $0xc002cbdf
c0028eea:	68 44 c8 02 c0       	push   $0xc002c844
c0028eef:	68 20 01 00 00       	push   $0x120
c0028ef4:	68 ee e7 02 c0       	push   $0xc002e7ee
c0028ef9:	e8 42 e7 ff ff       	call   c0027640 <debug_panic>

c0028efe <hash_int>:
{
c0028efe:	83 ec 14             	sub    $0x14,%esp
  return hash_bytes (&i, sizeof i);
c0028f01:	6a 04                	push   $0x4
c0028f03:	8d 44 24 1c          	lea    0x1c(%esp),%eax
c0028f07:	50                   	push   %eax
c0028f08:	e8 28 ff ff ff       	call   c0028e35 <hash_bytes>
}
c0028f0d:	83 c4 1c             	add    $0x1c,%esp
c0028f10:	c3                   	ret    

c0028f11 <putchar_have_lock>:
/* Writes C to the vga display and serial port.
   The caller has already acquired the console lock if
   appropriate. */
static void
putchar_have_lock (uint8_t c) 
{
c0028f11:	53                   	push   %ebx
c0028f12:	83 ec 08             	sub    $0x8,%esp
c0028f15:	89 c3                	mov    %eax,%ebx
  return (intr_context ()
c0028f17:	e8 88 83 ff ff       	call   c00212a4 <intr_context>
          || lock_held_by_current_thread (&console_lock));
c0028f1c:	84 c0                	test   %al,%al
c0028f1e:	75 09                	jne    c0028f29 <putchar_have_lock+0x18>
          || !use_console_lock
c0028f20:	80 3d d4 82 03 c0 00 	cmpb   $0x0,0xc00382d4
c0028f27:	75 27                	jne    c0028f50 <putchar_have_lock+0x3f>
  ASSERT (console_locked_by_current_thread ());
  write_cnt++;
c0028f29:	83 05 c8 82 03 c0 01 	addl   $0x1,0xc00382c8
c0028f30:	83 15 cc 82 03 c0 00 	adcl   $0x0,0xc00382cc
  serial_putc (c);
c0028f37:	0f b6 db             	movzbl %bl,%ebx
c0028f3a:	83 ec 0c             	sub    $0xc,%esp
c0028f3d:	53                   	push   %ebx
c0028f3e:	e8 77 ab ff ff       	call   c0023aba <serial_putc>
  vga_putc (c);
c0028f43:	89 1c 24             	mov    %ebx,(%esp)
c0028f46:	e8 c1 a7 ff ff       	call   c002370c <vga_putc>
}
c0028f4b:	83 c4 18             	add    $0x18,%esp
c0028f4e:	5b                   	pop    %ebx
c0028f4f:	c3                   	ret    
          || lock_held_by_current_thread (&console_lock));
c0028f50:	83 ec 0c             	sub    $0xc,%esp
c0028f53:	68 d8 82 03 c0       	push   $0xc00382d8
c0028f58:	e8 cb 93 ff ff       	call   c0022328 <lock_held_by_current_thread>
  ASSERT (console_locked_by_current_thread ());
c0028f5d:	83 c4 10             	add    $0x10,%esp
c0028f60:	84 c0                	test   %al,%al
c0028f62:	75 c5                	jne    c0028f29 <putchar_have_lock+0x18>
c0028f64:	83 ec 0c             	sub    $0xc,%esp
c0028f67:	68 2c e8 02 c0       	push   $0xc002e82c
c0028f6c:	68 df cb 02 c0       	push   $0xc002cbdf
c0028f71:	68 88 c8 02 c0       	push   $0xc002c888
c0028f76:	68 bb 00 00 00       	push   $0xbb
c0028f7b:	68 71 e8 02 c0       	push   $0xc002e871
c0028f80:	e8 bb e6 ff ff       	call   c0027640 <debug_panic>

c0028f85 <vprintf_helper>:
{
c0028f85:	83 ec 0c             	sub    $0xc,%esp
c0028f88:	8b 44 24 14          	mov    0x14(%esp),%eax
  (*char_cnt)++;
c0028f8c:	ff 00                	incl   (%eax)
  putchar_have_lock (c);
c0028f8e:	0f b6 44 24 10       	movzbl 0x10(%esp),%eax
c0028f93:	e8 79 ff ff ff       	call   c0028f11 <putchar_have_lock>
}
c0028f98:	83 c4 0c             	add    $0xc,%esp
c0028f9b:	c3                   	ret    

c0028f9c <acquire_console>:
{
c0028f9c:	83 ec 0c             	sub    $0xc,%esp
  if (!intr_context () && use_console_lock) 
c0028f9f:	e8 00 83 ff ff       	call   c00212a4 <intr_context>
c0028fa4:	84 c0                	test   %al,%al
c0028fa6:	75 09                	jne    c0028fb1 <acquire_console+0x15>
c0028fa8:	80 3d d4 82 03 c0 00 	cmpb   $0x0,0xc00382d4
c0028faf:	75 04                	jne    c0028fb5 <acquire_console+0x19>
}
c0028fb1:	83 c4 0c             	add    $0xc,%esp
c0028fb4:	c3                   	ret    
      if (lock_held_by_current_thread (&console_lock)) 
c0028fb5:	83 ec 0c             	sub    $0xc,%esp
c0028fb8:	68 d8 82 03 c0       	push   $0xc00382d8
c0028fbd:	e8 66 93 ff ff       	call   c0022328 <lock_held_by_current_thread>
c0028fc2:	83 c4 10             	add    $0x10,%esp
c0028fc5:	84 c0                	test   %al,%al
c0028fc7:	74 08                	je     c0028fd1 <acquire_console+0x35>
        console_lock_depth++; 
c0028fc9:	ff 05 d0 82 03 c0    	incl   0xc00382d0
c0028fcf:	eb e0                	jmp    c0028fb1 <acquire_console+0x15>
        lock_acquire (&console_lock); 
c0028fd1:	83 ec 0c             	sub    $0xc,%esp
c0028fd4:	68 d8 82 03 c0       	push   $0xc00382d8
c0028fd9:	e8 88 93 ff ff       	call   c0022366 <lock_acquire>
c0028fde:	83 c4 10             	add    $0x10,%esp
}
c0028fe1:	eb ce                	jmp    c0028fb1 <acquire_console+0x15>

c0028fe3 <release_console>:
{
c0028fe3:	83 ec 0c             	sub    $0xc,%esp
  if (!intr_context () && use_console_lock) 
c0028fe6:	e8 b9 82 ff ff       	call   c00212a4 <intr_context>
c0028feb:	84 c0                	test   %al,%al
c0028fed:	75 18                	jne    c0029007 <release_console+0x24>
c0028fef:	80 3d d4 82 03 c0 00 	cmpb   $0x0,0xc00382d4
c0028ff6:	74 0f                	je     c0029007 <release_console+0x24>
      if (console_lock_depth > 0)
c0028ff8:	a1 d0 82 03 c0       	mov    0xc00382d0,%eax
c0028ffd:	85 c0                	test   %eax,%eax
c0028fff:	7e 0a                	jle    c002900b <release_console+0x28>
        console_lock_depth--;
c0029001:	48                   	dec    %eax
c0029002:	a3 d0 82 03 c0       	mov    %eax,0xc00382d0
}
c0029007:	83 c4 0c             	add    $0xc,%esp
c002900a:	c3                   	ret    
        lock_release (&console_lock); 
c002900b:	83 ec 0c             	sub    $0xc,%esp
c002900e:	68 d8 82 03 c0       	push   $0xc00382d8
c0029013:	e8 73 94 ff ff       	call   c002248b <lock_release>
c0029018:	83 c4 10             	add    $0x10,%esp
}
c002901b:	eb ea                	jmp    c0029007 <release_console+0x24>

c002901d <console_init>:
{
c002901d:	83 ec 18             	sub    $0x18,%esp
  lock_init (&console_lock);
c0029020:	68 d8 82 03 c0       	push   $0xc00382d8
c0029025:	e8 ba 92 ff ff       	call   c00222e4 <lock_init>
  use_console_lock = true;
c002902a:	c6 05 d4 82 03 c0 01 	movb   $0x1,0xc00382d4
}
c0029031:	83 c4 1c             	add    $0x1c,%esp
c0029034:	c3                   	ret    

c0029035 <console_panic>:
  use_console_lock = false;
c0029035:	c6 05 d4 82 03 c0 00 	movb   $0x0,0xc00382d4
c002903c:	c3                   	ret    

c002903d <console_print_stats>:
{
c002903d:	83 ec 10             	sub    $0x10,%esp
  printf ("Console: %lld characters output\n", write_cnt);
c0029040:	ff 35 cc 82 03 c0    	pushl  0xc00382cc
c0029046:	ff 35 c8 82 03 c0    	pushl  0xc00382c8
c002904c:	68 50 e8 02 c0       	push   $0xc002e850
c0029051:	e8 3c cb ff ff       	call   c0025b92 <printf>
}
c0029056:	83 c4 1c             	add    $0x1c,%esp
c0029059:	c3                   	ret    

c002905a <vprintf>:
{
c002905a:	83 ec 1c             	sub    $0x1c,%esp
  int char_cnt = 0;
c002905d:	c7 44 24 0c 00 00 00 	movl   $0x0,0xc(%esp)
c0029064:	00 
  acquire_console ();
c0029065:	e8 32 ff ff ff       	call   c0028f9c <acquire_console>
  __vprintf (format, args, vprintf_helper, &char_cnt);
c002906a:	8d 44 24 0c          	lea    0xc(%esp),%eax
c002906e:	50                   	push   %eax
c002906f:	68 85 8f 02 c0       	push   $0xc0028f85
c0029074:	ff 74 24 2c          	pushl  0x2c(%esp)
c0029078:	ff 74 24 2c          	pushl  0x2c(%esp)
c002907c:	e8 46 cb ff ff       	call   c0025bc7 <__vprintf>
  release_console ();
c0029081:	e8 5d ff ff ff       	call   c0028fe3 <release_console>
}
c0029086:	8b 44 24 1c          	mov    0x1c(%esp),%eax
c002908a:	83 c4 2c             	add    $0x2c,%esp
c002908d:	c3                   	ret    

c002908e <puts>:
{
c002908e:	53                   	push   %ebx
c002908f:	83 ec 08             	sub    $0x8,%esp
c0029092:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  acquire_console ();
c0029096:	e8 01 ff ff ff       	call   c0028f9c <acquire_console>
  while (*s != '\0')
c002909b:	8a 03                	mov    (%ebx),%al
c002909d:	84 c0                	test   %al,%al
c002909f:	74 0f                	je     c00290b0 <puts+0x22>
    putchar_have_lock (*s++);
c00290a1:	43                   	inc    %ebx
c00290a2:	0f b6 c0             	movzbl %al,%eax
c00290a5:	e8 67 fe ff ff       	call   c0028f11 <putchar_have_lock>
  while (*s != '\0')
c00290aa:	8a 03                	mov    (%ebx),%al
c00290ac:	84 c0                	test   %al,%al
c00290ae:	75 f1                	jne    c00290a1 <puts+0x13>
  putchar_have_lock ('\n');
c00290b0:	b8 0a 00 00 00       	mov    $0xa,%eax
c00290b5:	e8 57 fe ff ff       	call   c0028f11 <putchar_have_lock>
  release_console ();
c00290ba:	e8 24 ff ff ff       	call   c0028fe3 <release_console>
}
c00290bf:	b8 00 00 00 00       	mov    $0x0,%eax
c00290c4:	83 c4 08             	add    $0x8,%esp
c00290c7:	5b                   	pop    %ebx
c00290c8:	c3                   	ret    

c00290c9 <putbuf>:
{
c00290c9:	56                   	push   %esi
c00290ca:	53                   	push   %ebx
c00290cb:	83 ec 04             	sub    $0x4,%esp
c00290ce:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c00290d2:	8b 74 24 14          	mov    0x14(%esp),%esi
  acquire_console ();
c00290d6:	e8 c1 fe ff ff       	call   c0028f9c <acquire_console>
  while (n-- > 0)
c00290db:	85 f6                	test   %esi,%esi
c00290dd:	74 10                	je     c00290ef <putbuf+0x26>
c00290df:	01 de                	add    %ebx,%esi
    putchar_have_lock (*buffer++);
c00290e1:	43                   	inc    %ebx
c00290e2:	0f b6 43 ff          	movzbl -0x1(%ebx),%eax
c00290e6:	e8 26 fe ff ff       	call   c0028f11 <putchar_have_lock>
  while (n-- > 0)
c00290eb:	39 de                	cmp    %ebx,%esi
c00290ed:	75 f2                	jne    c00290e1 <putbuf+0x18>
  release_console ();
c00290ef:	e8 ef fe ff ff       	call   c0028fe3 <release_console>
}
c00290f4:	83 c4 04             	add    $0x4,%esp
c00290f7:	5b                   	pop    %ebx
c00290f8:	5e                   	pop    %esi
c00290f9:	c3                   	ret    

c00290fa <putchar>:
{
c00290fa:	83 ec 0c             	sub    $0xc,%esp
  acquire_console ();
c00290fd:	e8 9a fe ff ff       	call   c0028f9c <acquire_console>
  putchar_have_lock (c);
c0029102:	0f b6 44 24 10       	movzbl 0x10(%esp),%eax
c0029107:	e8 05 fe ff ff       	call   c0028f11 <putchar_have_lock>
  release_console ();
c002910c:	e8 d2 fe ff ff       	call   c0028fe3 <release_console>
}
c0029111:	8b 44 24 10          	mov    0x10(%esp),%eax
c0029115:	83 c4 0c             	add    $0xc,%esp
c0029118:	c3                   	ret    

c0029119 <msg>:
/* Prints FORMAT as if with printf(),
   prefixing the output by the name of the test
   and following it with a new-line character. */
void
msg (const char *format, ...) 
{
c0029119:	83 ec 14             	sub    $0x14,%esp
  va_list args;
  
  printf ("(%s) ", test_name);
c002911c:	ff 35 f0 82 03 c0    	pushl  0xc00382f0
c0029122:	68 8c e8 02 c0       	push   $0xc002e88c
c0029127:	e8 66 ca ff ff       	call   c0025b92 <printf>
  va_start (args, format);
c002912c:	8d 44 24 24          	lea    0x24(%esp),%eax
  vprintf (format, args);
c0029130:	83 c4 08             	add    $0x8,%esp
c0029133:	50                   	push   %eax
c0029134:	ff 74 24 1c          	pushl  0x1c(%esp)
c0029138:	e8 1d ff ff ff       	call   c002905a <vprintf>
  va_end (args);
  putchar ('\n');
c002913d:	c7 04 24 0a 00 00 00 	movl   $0xa,(%esp)
c0029144:	e8 b1 ff ff ff       	call   c00290fa <putchar>
}
c0029149:	83 c4 1c             	add    $0x1c,%esp
c002914c:	c3                   	ret    

c002914d <run_test>:
{
c002914d:	56                   	push   %esi
c002914e:	53                   	push   %ebx
c002914f:	83 ec 04             	sub    $0x4,%esp
c0029152:	8b 74 24 10          	mov    0x10(%esp),%esi
  for (t = tests; t < tests + sizeof tests / sizeof *tests; t++)
c0029156:	bb c0 c8 02 c0       	mov    $0xc002c8c0,%ebx
    if (!strcmp (name, t->name))
c002915b:	83 ec 08             	sub    $0x8,%esp
c002915e:	ff 33                	pushl  (%ebx)
c0029160:	56                   	push   %esi
c0029161:	e8 8f d8 ff ff       	call   c00269f5 <strcmp>
c0029166:	83 c4 10             	add    $0x10,%esp
c0029169:	85 c0                	test   %eax,%eax
c002916b:	74 25                	je     c0029192 <run_test+0x45>
  for (t = tests; t < tests + sizeof tests / sizeof *tests; t++)
c002916d:	83 c3 08             	add    $0x8,%ebx
c0029170:	81 fb 98 c9 02 c0    	cmp    $0xc002c998,%ebx
c0029176:	72 e3                	jb     c002915b <run_test+0xe>
  PANIC ("no test named \"%s\"", name);
c0029178:	83 ec 0c             	sub    $0xc,%esp
c002917b:	56                   	push   %esi
c002917c:	68 9c e8 02 c0       	push   $0xc002e89c
c0029181:	68 a8 c8 02 c0       	push   $0xc002c8a8
c0029186:	6a 3c                	push   $0x3c
c0029188:	68 af e8 02 c0       	push   $0xc002e8af
c002918d:	e8 ae e4 ff ff       	call   c0027640 <debug_panic>
        test_name = name;
c0029192:	89 35 f0 82 03 c0    	mov    %esi,0xc00382f0
        msg ("begin");
c0029198:	83 ec 0c             	sub    $0xc,%esp
c002919b:	68 92 e8 02 c0       	push   $0xc002e892
c00291a0:	e8 74 ff ff ff       	call   c0029119 <msg>
        t->function ();
c00291a5:	ff 53 04             	call   *0x4(%ebx)
        msg ("end");
c00291a8:	c7 04 24 98 e8 02 c0 	movl   $0xc002e898,(%esp)
c00291af:	e8 65 ff ff ff       	call   c0029119 <msg>
        return;
c00291b4:	83 c4 10             	add    $0x10,%esp
}
c00291b7:	83 c4 04             	add    $0x4,%esp
c00291ba:	5b                   	pop    %ebx
c00291bb:	5e                   	pop    %esi
c00291bc:	c3                   	ret    

c00291bd <fail>:
   prefixing the output by the name of the test and FAIL:
   and following it with a new-line character,
   and then panics the kernel. */
void
fail (const char *format, ...) 
{
c00291bd:	83 ec 14             	sub    $0x14,%esp
  va_list args;
  
  printf ("(%s) FAIL: ", test_name);
c00291c0:	ff 35 f0 82 03 c0    	pushl  0xc00382f0
c00291c6:	68 cb e8 02 c0       	push   $0xc002e8cb
c00291cb:	e8 c2 c9 ff ff       	call   c0025b92 <printf>
  va_start (args, format);
c00291d0:	8d 44 24 24          	lea    0x24(%esp),%eax
  vprintf (format, args);
c00291d4:	83 c4 08             	add    $0x8,%esp
c00291d7:	50                   	push   %eax
c00291d8:	ff 74 24 1c          	pushl  0x1c(%esp)
c00291dc:	e8 79 fe ff ff       	call   c002905a <vprintf>
  va_end (args);
  putchar ('\n');
c00291e1:	c7 04 24 0a 00 00 00 	movl   $0xa,(%esp)
c00291e8:	e8 0d ff ff ff       	call   c00290fa <putchar>

  PANIC ("test failed");
c00291ed:	68 d7 e8 02 c0       	push   $0xc002e8d7
c00291f2:	68 a0 c8 02 c0       	push   $0xc002c8a0
c00291f7:	6a 5d                	push   $0x5d
c00291f9:	68 af e8 02 c0       	push   $0xc002e8af
c00291fe:	e8 3d e4 ff ff       	call   c0027640 <debug_panic>

c0029203 <pass>:
}

/* Prints a message indicating the current test passed. */
void
pass (void) 
{
c0029203:	83 ec 14             	sub    $0x14,%esp
  printf ("(%s) PASS\n", test_name);
c0029206:	ff 35 f0 82 03 c0    	pushl  0xc00382f0
c002920c:	68 e3 e8 02 c0       	push   $0xc002e8e3
c0029211:	e8 7c c9 ff ff       	call   c0025b92 <printf>
}
c0029216:	83 c4 1c             	add    $0x1c,%esp
c0029219:	c3                   	ret    

c002921a <sleeper>:
}

/* Sleeper thread. */
static void
sleeper (void *t_) 
{
c002921a:	55                   	push   %ebp
c002921b:	57                   	push   %edi
c002921c:	56                   	push   %esi
c002921d:	53                   	push   %ebx
c002921e:	83 ec 1c             	sub    $0x1c,%esp
c0029221:	8b 6c 24 30          	mov    0x30(%esp),%ebp
  struct sleep_thread *t = t_;
  struct sleep_test *test = t->test;
c0029225:	8b 5d 00             	mov    0x0(%ebp),%ebx
  int i;

  for (i = 1; i <= test->iterations; i++) 
c0029228:	83 7b 08 00          	cmpl   $0x0,0x8(%ebx)
c002922c:	7e 62                	jle    c0029290 <sleeper+0x76>
c002922e:	be 01 00 00 00       	mov    $0x1,%esi
    {
      int64_t sleep_until = test->start + i * t->duration;
      timer_sleep (sleep_until - timer_ticks ());
      lock_acquire (&test->output_lock);
c0029233:	8d 43 0c             	lea    0xc(%ebx),%eax
c0029236:	89 44 24 0c          	mov    %eax,0xc(%esp)
      int64_t sleep_until = test->start + i * t->duration;
c002923a:	89 f0                	mov    %esi,%eax
c002923c:	8b 4c 24 30          	mov    0x30(%esp),%ecx
c0029240:	0f af 41 08          	imul   0x8(%ecx),%eax
c0029244:	99                   	cltd   
c0029245:	03 03                	add    (%ebx),%eax
c0029247:	13 53 04             	adc    0x4(%ebx),%edx
c002924a:	89 c7                	mov    %eax,%edi
c002924c:	89 d5                	mov    %edx,%ebp
      timer_sleep (sleep_until - timer_ticks ());
c002924e:	e8 27 a0 ff ff       	call   c002327a <timer_ticks>
c0029253:	83 ec 08             	sub    $0x8,%esp
c0029256:	29 c7                	sub    %eax,%edi
c0029258:	19 d5                	sbb    %edx,%ebp
c002925a:	55                   	push   %ebp
c002925b:	57                   	push   %edi
c002925c:	e8 5e a0 ff ff       	call   c00232bf <timer_sleep>
      lock_acquire (&test->output_lock);
c0029261:	8b 7c 24 1c          	mov    0x1c(%esp),%edi
c0029265:	89 3c 24             	mov    %edi,(%esp)
c0029268:	e8 f9 90 ff ff       	call   c0022366 <lock_acquire>
      *test->output_pos++ = t->id;
c002926d:	8b 43 24             	mov    0x24(%ebx),%eax
c0029270:	8d 50 04             	lea    0x4(%eax),%edx
c0029273:	89 53 24             	mov    %edx,0x24(%ebx)
c0029276:	8b 4c 24 40          	mov    0x40(%esp),%ecx
c002927a:	8b 51 04             	mov    0x4(%ecx),%edx
c002927d:	89 10                	mov    %edx,(%eax)
      lock_release (&test->output_lock);
c002927f:	89 3c 24             	mov    %edi,(%esp)
c0029282:	e8 04 92 ff ff       	call   c002248b <lock_release>
  for (i = 1; i <= test->iterations; i++) 
c0029287:	46                   	inc    %esi
c0029288:	83 c4 10             	add    $0x10,%esp
c002928b:	39 73 08             	cmp    %esi,0x8(%ebx)
c002928e:	7d aa                	jge    c002923a <sleeper+0x20>
    }
}
c0029290:	83 c4 1c             	add    $0x1c,%esp
c0029293:	5b                   	pop    %ebx
c0029294:	5e                   	pop    %esi
c0029295:	5f                   	pop    %edi
c0029296:	5d                   	pop    %ebp
c0029297:	c3                   	ret    

c0029298 <test_sleep>:
{
c0029298:	55                   	push   %ebp
c0029299:	57                   	push   %edi
c002929a:	56                   	push   %esi
c002929b:	53                   	push   %ebx
c002929c:	83 ec 5c             	sub    $0x5c,%esp
c002929f:	89 04 24             	mov    %eax,(%esp)
c00292a2:	89 54 24 0c          	mov    %edx,0xc(%esp)
  ASSERT (!thread_mlfqs);
c00292a6:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c00292ad:	0f 85 63 01 00 00    	jne    c0029416 <test_sleep+0x17e>
  msg ("Creating %d threads to sleep %d times each.", thread_cnt, iterations);
c00292b3:	83 ec 04             	sub    $0x4,%esp
c00292b6:	8b 7c 24 10          	mov    0x10(%esp),%edi
c00292ba:	57                   	push   %edi
c00292bb:	8b 74 24 08          	mov    0x8(%esp),%esi
c00292bf:	56                   	push   %esi
c00292c0:	68 08 eb 02 c0       	push   $0xc002eb08
c00292c5:	e8 4f fe ff ff       	call   c0029119 <msg>
  msg ("Thread 0 sleeps 10 ticks each time,");
c00292ca:	c7 04 24 34 eb 02 c0 	movl   $0xc002eb34,(%esp)
c00292d1:	e8 43 fe ff ff       	call   c0029119 <msg>
  msg ("thread 1 sleeps 20 ticks each time, and so on.");
c00292d6:	c7 04 24 58 eb 02 c0 	movl   $0xc002eb58,(%esp)
c00292dd:	e8 37 fe ff ff       	call   c0029119 <msg>
  msg ("If successful, product of iteration count and");
c00292e2:	c7 04 24 88 eb 02 c0 	movl   $0xc002eb88,(%esp)
c00292e9:	e8 2b fe ff ff       	call   c0029119 <msg>
  msg ("sleep duration will appear in nondescending order.");
c00292ee:	c7 04 24 b8 eb 02 c0 	movl   $0xc002ebb8,(%esp)
c00292f5:	e8 1f fe ff ff       	call   c0029119 <msg>
  threads = malloc (sizeof *threads * thread_cnt);
c00292fa:	89 f0                	mov    %esi,%eax
c00292fc:	c1 e0 04             	shl    $0x4,%eax
c00292ff:	89 04 24             	mov    %eax,(%esp)
c0029302:	e8 aa 99 ff ff       	call   c0022cb1 <malloc>
c0029307:	89 c3                	mov    %eax,%ebx
c0029309:	89 44 24 14          	mov    %eax,0x14(%esp)
  output = malloc (sizeof *output * iterations * thread_cnt * 2);
c002930d:	8d 04 fd 00 00 00 00 	lea    0x0(,%edi,8),%eax
c0029314:	0f af c6             	imul   %esi,%eax
c0029317:	89 04 24             	mov    %eax,(%esp)
c002931a:	e8 92 99 ff ff       	call   c0022cb1 <malloc>
c002931f:	89 44 24 18          	mov    %eax,0x18(%esp)
  if (threads == NULL || output == NULL)
c0029323:	83 c4 10             	add    $0x10,%esp
c0029326:	85 db                	test   %ebx,%ebx
c0029328:	0f 84 06 01 00 00    	je     c0029434 <test_sleep+0x19c>
c002932e:	85 c0                	test   %eax,%eax
c0029330:	0f 84 fe 00 00 00    	je     c0029434 <test_sleep+0x19c>
  test.start = timer_ticks () + 100;
c0029336:	e8 3f 9f ff ff       	call   c002327a <timer_ticks>
c002933b:	83 c0 64             	add    $0x64,%eax
c002933e:	83 d2 00             	adc    $0x0,%edx
c0029341:	89 44 24 28          	mov    %eax,0x28(%esp)
c0029345:	89 54 24 2c          	mov    %edx,0x2c(%esp)
  test.iterations = iterations;
c0029349:	8b 44 24 0c          	mov    0xc(%esp),%eax
c002934d:	89 44 24 30          	mov    %eax,0x30(%esp)
  lock_init (&test.output_lock);
c0029351:	83 ec 0c             	sub    $0xc,%esp
c0029354:	8d 44 24 40          	lea    0x40(%esp),%eax
c0029358:	50                   	push   %eax
c0029359:	e8 86 8f ff ff       	call   c00222e4 <lock_init>
  test.output_pos = output;
c002935e:	8b 44 24 18          	mov    0x18(%esp),%eax
c0029362:	89 44 24 5c          	mov    %eax,0x5c(%esp)
  for (i = 0; i < thread_cnt; i++)
c0029366:	83 c4 10             	add    $0x10,%esp
c0029369:	83 3c 24 00          	cmpl   $0x0,(%esp)
c002936d:	0f 8e 8a 01 00 00    	jle    c00294fd <test_sleep+0x265>
c0029373:	8b 5c 24 04          	mov    0x4(%esp),%ebx
c0029377:	ba 00 00 00 00       	mov    $0x0,%edx
      t->test = &test;
c002937c:	8d 6c 24 28          	lea    0x28(%esp),%ebp
      snprintf (name, sizeof name, "thread %d", i);
c0029380:	8d 7c 24 18          	lea    0x18(%esp),%edi
      t->test = &test;
c0029384:	89 2b                	mov    %ebp,(%ebx)
      t->id = i;
c0029386:	89 53 04             	mov    %edx,0x4(%ebx)
      t->duration = (i + 1) * 10;
c0029389:	8d 72 01             	lea    0x1(%edx),%esi
c002938c:	8d 04 b6             	lea    (%esi,%esi,4),%eax
c002938f:	01 c0                	add    %eax,%eax
c0029391:	89 43 08             	mov    %eax,0x8(%ebx)
      t->iterations = 0;
c0029394:	c7 43 0c 00 00 00 00 	movl   $0x0,0xc(%ebx)
      snprintf (name, sizeof name, "thread %d", i);
c002939b:	52                   	push   %edx
c002939c:	68 ba ea 02 c0       	push   $0xc002eaba
c00293a1:	6a 10                	push   $0x10
c00293a3:	57                   	push   %edi
c00293a4:	e8 75 cf ff ff       	call   c002631e <snprintf>
      thread_create (name, PRI_DEFAULT, sleeper, t);
c00293a9:	53                   	push   %ebx
c00293aa:	68 1a 92 02 c0       	push   $0xc002921a
c00293af:	6a 1f                	push   $0x1f
c00293b1:	57                   	push   %edi
c00293b2:	e8 85 75 ff ff       	call   c002093c <thread_create>
c00293b7:	83 c3 10             	add    $0x10,%ebx
  for (i = 0; i < thread_cnt; i++)
c00293ba:	89 f2                	mov    %esi,%edx
c00293bc:	83 c4 20             	add    $0x20,%esp
c00293bf:	39 34 24             	cmp    %esi,(%esp)
c00293c2:	75 c0                	jne    c0029384 <test_sleep+0xec>
  timer_sleep (100 + thread_cnt * iterations * 10 + 100);
c00293c4:	83 ec 08             	sub    $0x8,%esp
c00293c7:	0f af 74 24 14       	imul   0x14(%esp),%esi
c00293cc:	8d 04 b6             	lea    (%esi,%esi,4),%eax
c00293cf:	8d 84 00 c8 00 00 00 	lea    0xc8(%eax,%eax,1),%eax
c00293d6:	99                   	cltd   
c00293d7:	52                   	push   %edx
c00293d8:	50                   	push   %eax
c00293d9:	e8 e1 9e ff ff       	call   c00232bf <timer_sleep>
  lock_acquire (&test.output_lock);
c00293de:	83 c4 04             	add    $0x4,%esp
c00293e1:	8d 44 24 40          	lea    0x40(%esp),%eax
c00293e5:	50                   	push   %eax
c00293e6:	e8 7b 8f ff ff       	call   c0022366 <lock_acquire>
  for (op = output; op < test.output_pos; op++) 
c00293eb:	83 c4 10             	add    $0x10,%esp
c00293ee:	8b 44 24 08          	mov    0x8(%esp),%eax
c00293f2:	3b 44 24 4c          	cmp    0x4c(%esp),%eax
c00293f6:	0f 83 cc 00 00 00    	jae    c00294c8 <test_sleep+0x230>
      ASSERT (*op >= 0 && *op < thread_cnt);
c00293fc:	8b 44 24 08          	mov    0x8(%esp),%eax
c0029400:	8b 18                	mov    (%eax),%ebx
c0029402:	85 db                	test   %ebx,%ebx
c0029404:	78 44                	js     c002944a <test_sleep+0x1b2>
c0029406:	39 1c 24             	cmp    %ebx,(%esp)
c0029409:	7e 3f                	jle    c002944a <test_sleep+0x1b2>
c002940b:	8b 74 24 08          	mov    0x8(%esp),%esi
c002940f:	bd 00 00 00 00       	mov    $0x0,%ebp
c0029414:	eb 78                	jmp    c002948e <test_sleep+0x1f6>
  ASSERT (!thread_mlfqs);
c0029416:	83 ec 0c             	sub    $0xc,%esp
c0029419:	68 ac ea 02 c0       	push   $0xc002eaac
c002941e:	68 df cb 02 c0       	push   $0xc002cbdf
c0029423:	68 98 c9 02 c0       	push   $0xc002c998
c0029428:	6a 3c                	push   $0x3c
c002942a:	68 e4 ea 02 c0       	push   $0xc002eae4
c002942f:	e8 0c e2 ff ff       	call   c0027640 <debug_panic>
    PANIC ("couldn't allocate memory for test");
c0029434:	68 ec eb 02 c0       	push   $0xc002ebec
c0029439:	68 98 c9 02 c0       	push   $0xc002c998
c002943e:	6a 48                	push   $0x48
c0029440:	68 e4 ea 02 c0       	push   $0xc002eae4
c0029445:	e8 f6 e1 ff ff       	call   c0027640 <debug_panic>
      ASSERT (*op >= 0 && *op < thread_cnt);
c002944a:	83 ec 0c             	sub    $0xc,%esp
c002944d:	68 c4 ea 02 c0       	push   $0xc002eac4
c0029452:	68 df cb 02 c0       	push   $0xc002cbdf
c0029457:	68 98 c9 02 c0       	push   $0xc002c998
c002945c:	6a 6e                	push   $0x6e
c002945e:	68 e4 ea 02 c0       	push   $0xc002eae4
c0029463:	e8 d8 e1 ff ff       	call   c0027640 <debug_panic>
        fail ("thread %d woke up out of order (%d > %d)!",
c0029468:	57                   	push   %edi
c0029469:	55                   	push   %ebp
c002946a:	ff 73 04             	pushl  0x4(%ebx)
c002946d:	68 44 ec 02 c0       	push   $0xc002ec44
c0029472:	e8 46 fd ff ff       	call   c00291bd <fail>
c0029477:	83 c4 10             	add    $0x10,%esp
  for (op = output; op < test.output_pos; op++) 
c002947a:	83 c6 04             	add    $0x4,%esi
c002947d:	39 74 24 4c          	cmp    %esi,0x4c(%esp)
c0029481:	76 3f                	jbe    c00294c2 <test_sleep+0x22a>
      ASSERT (*op >= 0 && *op < thread_cnt);
c0029483:	8b 1e                	mov    (%esi),%ebx
c0029485:	85 db                	test   %ebx,%ebx
c0029487:	78 c1                	js     c002944a <test_sleep+0x1b2>
c0029489:	39 1c 24             	cmp    %ebx,(%esp)
c002948c:	7e bc                	jle    c002944a <test_sleep+0x1b2>
      t = threads + *op;
c002948e:	c1 e3 04             	shl    $0x4,%ebx
c0029491:	03 5c 24 04          	add    0x4(%esp),%ebx
      new_prod = ++t->iterations * t->duration;
c0029495:	8b 43 0c             	mov    0xc(%ebx),%eax
c0029498:	40                   	inc    %eax
c0029499:	89 43 0c             	mov    %eax,0xc(%ebx)
c002949c:	8b 53 08             	mov    0x8(%ebx),%edx
c002949f:	89 c7                	mov    %eax,%edi
c00294a1:	0f af fa             	imul   %edx,%edi
      msg ("thread %d: duration=%d, iteration=%d, product=%d",
c00294a4:	83 ec 0c             	sub    $0xc,%esp
c00294a7:	57                   	push   %edi
c00294a8:	50                   	push   %eax
c00294a9:	52                   	push   %edx
c00294aa:	ff 73 04             	pushl  0x4(%ebx)
c00294ad:	68 10 ec 02 c0       	push   $0xc002ec10
c00294b2:	e8 62 fc ff ff       	call   c0029119 <msg>
      if (new_prod >= product)
c00294b7:	83 c4 20             	add    $0x20,%esp
c00294ba:	39 ef                	cmp    %ebp,%edi
c00294bc:	7c aa                	jl     c0029468 <test_sleep+0x1d0>
        product = new_prod;
c00294be:	89 fd                	mov    %edi,%ebp
c00294c0:	eb b8                	jmp    c002947a <test_sleep+0x1e2>
  for (i = 0; i < thread_cnt; i++)
c00294c2:	83 3c 24 00          	cmpl   $0x0,(%esp)
c00294c6:	7e 71                	jle    c0029539 <test_sleep+0x2a1>
c00294c8:	8b 44 24 04          	mov    0x4(%esp),%eax
c00294cc:	8d 70 0c             	lea    0xc(%eax),%esi
        product = new_prod;
c00294cf:	bb 00 00 00 00       	mov    $0x0,%ebx
c00294d4:	8b 2c 24             	mov    (%esp),%ebp
c00294d7:	8b 7c 24 0c          	mov    0xc(%esp),%edi
c00294db:	eb 08                	jmp    c00294e5 <test_sleep+0x24d>
  for (i = 0; i < thread_cnt; i++)
c00294dd:	43                   	inc    %ebx
c00294de:	83 c6 10             	add    $0x10,%esi
c00294e1:	39 dd                	cmp    %ebx,%ebp
c00294e3:	7e 54                	jle    c0029539 <test_sleep+0x2a1>
    if (threads[i].iterations != iterations)
c00294e5:	8b 06                	mov    (%esi),%eax
c00294e7:	39 c7                	cmp    %eax,%edi
c00294e9:	74 f2                	je     c00294dd <test_sleep+0x245>
      fail ("thread %d woke up %d times instead of %d",
c00294eb:	57                   	push   %edi
c00294ec:	50                   	push   %eax
c00294ed:	53                   	push   %ebx
c00294ee:	68 70 ec 02 c0       	push   $0xc002ec70
c00294f3:	e8 c5 fc ff ff       	call   c00291bd <fail>
c00294f8:	83 c4 10             	add    $0x10,%esp
c00294fb:	eb e0                	jmp    c00294dd <test_sleep+0x245>
  timer_sleep (100 + thread_cnt * iterations * 10 + 100);
c00294fd:	83 ec 08             	sub    $0x8,%esp
c0029500:	8b 44 24 08          	mov    0x8(%esp),%eax
c0029504:	0f af 44 24 14       	imul   0x14(%esp),%eax
c0029509:	8d 04 80             	lea    (%eax,%eax,4),%eax
c002950c:	8d 84 00 c8 00 00 00 	lea    0xc8(%eax,%eax,1),%eax
c0029513:	99                   	cltd   
c0029514:	52                   	push   %edx
c0029515:	50                   	push   %eax
c0029516:	e8 a4 9d ff ff       	call   c00232bf <timer_sleep>
  lock_acquire (&test.output_lock);
c002951b:	83 c4 04             	add    $0x4,%esp
c002951e:	8d 44 24 40          	lea    0x40(%esp),%eax
c0029522:	50                   	push   %eax
c0029523:	e8 3e 8e ff ff       	call   c0022366 <lock_acquire>
  for (op = output; op < test.output_pos; op++) 
c0029528:	83 c4 10             	add    $0x10,%esp
c002952b:	8b 44 24 08          	mov    0x8(%esp),%eax
c002952f:	3b 44 24 4c          	cmp    0x4c(%esp),%eax
c0029533:	0f 82 c3 fe ff ff    	jb     c00293fc <test_sleep+0x164>
  lock_release (&test.output_lock);
c0029539:	83 ec 0c             	sub    $0xc,%esp
c002953c:	8d 44 24 40          	lea    0x40(%esp),%eax
c0029540:	50                   	push   %eax
c0029541:	e8 45 8f ff ff       	call   c002248b <lock_release>
  free (output);
c0029546:	83 c4 04             	add    $0x4,%esp
c0029549:	ff 74 24 14          	pushl  0x14(%esp)
c002954d:	e8 00 99 ff ff       	call   c0022e52 <free>
  free (threads);
c0029552:	83 c4 04             	add    $0x4,%esp
c0029555:	ff 74 24 10          	pushl  0x10(%esp)
c0029559:	e8 f4 98 ff ff       	call   c0022e52 <free>
}
c002955e:	83 c4 10             	add    $0x10,%esp
c0029561:	83 c4 5c             	add    $0x5c,%esp
c0029564:	5b                   	pop    %ebx
c0029565:	5e                   	pop    %esi
c0029566:	5f                   	pop    %edi
c0029567:	5d                   	pop    %ebp
c0029568:	c3                   	ret    

c0029569 <test_alarm_single>:
{
c0029569:	83 ec 0c             	sub    $0xc,%esp
  test_sleep (5, 1);
c002956c:	ba 01 00 00 00       	mov    $0x1,%edx
c0029571:	b8 05 00 00 00       	mov    $0x5,%eax
c0029576:	e8 1d fd ff ff       	call   c0029298 <test_sleep>
}
c002957b:	83 c4 0c             	add    $0xc,%esp
c002957e:	c3                   	ret    

c002957f <test_alarm_multiple>:
{
c002957f:	83 ec 0c             	sub    $0xc,%esp
  test_sleep (5, 7);
c0029582:	ba 07 00 00 00       	mov    $0x7,%edx
c0029587:	b8 05 00 00 00       	mov    $0x5,%eax
c002958c:	e8 07 fd ff ff       	call   c0029298 <test_sleep>
}
c0029591:	83 c4 0c             	add    $0xc,%esp
c0029594:	c3                   	ret    

c0029595 <sleeper>:
}

/* Sleeper thread. */
static void
sleeper (void *test_) 
{
c0029595:	55                   	push   %ebp
c0029596:	57                   	push   %edi
c0029597:	56                   	push   %esi
c0029598:	53                   	push   %ebx
c0029599:	83 ec 14             	sub    $0x14,%esp
c002959c:	8b 5c 24 28          	mov    0x28(%esp),%ebx
  struct sleep_test *test = test_;
  int i;

  /* Make sure we're at the beginning of a timer tick. */
  timer_sleep (1);
c00295a0:	6a 00                	push   $0x0
c00295a2:	6a 01                	push   $0x1
c00295a4:	e8 16 9d ff ff       	call   c00232bf <timer_sleep>

  for (i = 1; i <= test->iterations; i++) 
c00295a9:	83 c4 10             	add    $0x10,%esp
c00295ac:	83 7b 08 00          	cmpl   $0x0,0x8(%ebx)
c00295b0:	7e 49                	jle    c00295fb <sleeper+0x66>
c00295b2:	bd 01 00 00 00       	mov    $0x1,%ebp
    {
      int64_t sleep_until = test->start + i * 10;
c00295b7:	8d 44 ad 00          	lea    0x0(%ebp,%ebp,4),%eax
c00295bb:	8d 34 00             	lea    (%eax,%eax,1),%esi
c00295be:	89 f7                	mov    %esi,%edi
c00295c0:	c1 ff 1f             	sar    $0x1f,%edi
c00295c3:	03 33                	add    (%ebx),%esi
c00295c5:	13 7b 04             	adc    0x4(%ebx),%edi
      timer_sleep (sleep_until - timer_ticks ());
c00295c8:	e8 ad 9c ff ff       	call   c002327a <timer_ticks>
c00295cd:	83 ec 08             	sub    $0x8,%esp
c00295d0:	29 c6                	sub    %eax,%esi
c00295d2:	19 d7                	sbb    %edx,%edi
c00295d4:	57                   	push   %edi
c00295d5:	56                   	push   %esi
c00295d6:	e8 e4 9c ff ff       	call   c00232bf <timer_sleep>
      *test->output_pos++ = timer_ticks () - test->start;
c00295db:	8b 73 0c             	mov    0xc(%ebx),%esi
c00295de:	8d 46 04             	lea    0x4(%esi),%eax
c00295e1:	89 43 0c             	mov    %eax,0xc(%ebx)
c00295e4:	e8 91 9c ff ff       	call   c002327a <timer_ticks>
c00295e9:	2b 03                	sub    (%ebx),%eax
c00295eb:	89 06                	mov    %eax,(%esi)
      thread_yield ();
c00295ed:	e8 8f 78 ff ff       	call   c0020e81 <thread_yield>
  for (i = 1; i <= test->iterations; i++) 
c00295f2:	45                   	inc    %ebp
c00295f3:	83 c4 10             	add    $0x10,%esp
c00295f6:	39 6b 08             	cmp    %ebp,0x8(%ebx)
c00295f9:	7d bc                	jge    c00295b7 <sleeper+0x22>
    }
}
c00295fb:	83 c4 0c             	add    $0xc,%esp
c00295fe:	5b                   	pop    %ebx
c00295ff:	5e                   	pop    %esi
c0029600:	5f                   	pop    %edi
c0029601:	5d                   	pop    %ebp
c0029602:	c3                   	ret    

c0029603 <test_alarm_simultaneous>:
{
c0029603:	55                   	push   %ebp
c0029604:	57                   	push   %edi
c0029605:	56                   	push   %esi
c0029606:	53                   	push   %ebx
c0029607:	83 ec 2c             	sub    $0x2c,%esp
  ASSERT (!thread_mlfqs);
c002960a:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c0029611:	0f 85 17 01 00 00    	jne    c002972e <test_alarm_simultaneous+0x12b>
  msg ("Creating %d threads to sleep %d times each.", thread_cnt, iterations);
c0029617:	83 ec 04             	sub    $0x4,%esp
c002961a:	6a 05                	push   $0x5
c002961c:	6a 03                	push   $0x3
c002961e:	68 08 eb 02 c0       	push   $0xc002eb08
c0029623:	e8 f1 fa ff ff       	call   c0029119 <msg>
  msg ("Each thread sleeps 10 ticks each time.");
c0029628:	c7 04 24 c8 ec 02 c0 	movl   $0xc002ecc8,(%esp)
c002962f:	e8 e5 fa ff ff       	call   c0029119 <msg>
  msg ("Within an iteration, all threads should wake up on the same tick.");
c0029634:	c7 04 24 f0 ec 02 c0 	movl   $0xc002ecf0,(%esp)
c002963b:	e8 d9 fa ff ff       	call   c0029119 <msg>
  output = malloc (sizeof *output * iterations * thread_cnt * 2);
c0029640:	c7 04 24 78 00 00 00 	movl   $0x78,(%esp)
c0029647:	e8 65 96 ff ff       	call   c0022cb1 <malloc>
c002964c:	89 c6                	mov    %eax,%esi
  if (output == NULL)
c002964e:	83 c4 10             	add    $0x10,%esp
c0029651:	85 c0                	test   %eax,%eax
c0029653:	0f 84 f3 00 00 00    	je     c002974c <test_alarm_simultaneous+0x149>
  test.start = timer_ticks () + 100;
c0029659:	e8 1c 9c ff ff       	call   c002327a <timer_ticks>
c002965e:	83 c0 64             	add    $0x64,%eax
c0029661:	83 d2 00             	adc    $0x0,%edx
c0029664:	89 04 24             	mov    %eax,(%esp)
c0029667:	89 54 24 04          	mov    %edx,0x4(%esp)
  test.iterations = iterations;
c002966b:	c7 44 24 08 05 00 00 	movl   $0x5,0x8(%esp)
c0029672:	00 
  test.output_pos = output;
c0029673:	89 74 24 0c          	mov    %esi,0xc(%esp)
  for (i = 0; i < thread_cnt; i++)
c0029677:	bb 00 00 00 00       	mov    $0x0,%ebx
      snprintf (name, sizeof name, "thread %d", i);
c002967c:	8d 7c 24 10          	lea    0x10(%esp),%edi
      thread_create (name, PRI_DEFAULT, sleeper, &test);
c0029680:	89 e5                	mov    %esp,%ebp
      snprintf (name, sizeof name, "thread %d", i);
c0029682:	53                   	push   %ebx
c0029683:	68 ba ea 02 c0       	push   $0xc002eaba
c0029688:	6a 10                	push   $0x10
c002968a:	57                   	push   %edi
c002968b:	e8 8e cc ff ff       	call   c002631e <snprintf>
      thread_create (name, PRI_DEFAULT, sleeper, &test);
c0029690:	55                   	push   %ebp
c0029691:	68 95 95 02 c0       	push   $0xc0029595
c0029696:	6a 1f                	push   $0x1f
c0029698:	57                   	push   %edi
c0029699:	e8 9e 72 ff ff       	call   c002093c <thread_create>
  for (i = 0; i < thread_cnt; i++)
c002969e:	43                   	inc    %ebx
c002969f:	83 c4 20             	add    $0x20,%esp
c00296a2:	83 fb 03             	cmp    $0x3,%ebx
c00296a5:	75 db                	jne    c0029682 <test_alarm_simultaneous+0x7f>
  timer_sleep (100 + iterations * 10 + 100);
c00296a7:	83 ec 08             	sub    $0x8,%esp
c00296aa:	6a 00                	push   $0x0
c00296ac:	68 fa 00 00 00       	push   $0xfa
c00296b1:	e8 09 9c ff ff       	call   c00232bf <timer_sleep>
  msg ("iteration 0, thread 0: woke up after %d ticks", output[0]);
c00296b6:	83 c4 08             	add    $0x8,%esp
c00296b9:	ff 36                	pushl  (%esi)
c00296bb:	68 34 ed 02 c0       	push   $0xc002ed34
c00296c0:	e8 54 fa ff ff       	call   c0029119 <msg>
  for (i = 1; i < test.output_pos - output; i++) 
c00296c5:	89 f5                	mov    %esi,%ebp
c00296c7:	8b 44 24 1c          	mov    0x1c(%esp),%eax
c00296cb:	29 f0                	sub    %esi,%eax
c00296cd:	83 c4 10             	add    $0x10,%esp
c00296d0:	83 f8 07             	cmp    $0x7,%eax
c00296d3:	7e 48                	jle    c002971d <test_alarm_simultaneous+0x11a>
c00296d5:	bb 01 00 00 00       	mov    $0x1,%ebx
    msg ("iteration %d, thread %d: woke up %d ticks later",
c00296da:	bf 03 00 00 00       	mov    $0x3,%edi
c00296df:	8b 04 9e             	mov    (%esi,%ebx,4),%eax
c00296e2:	2b 44 9e fc          	sub    -0x4(%esi,%ebx,4),%eax
c00296e6:	50                   	push   %eax
c00296e7:	89 d8                	mov    %ebx,%eax
c00296e9:	99                   	cltd   
c00296ea:	f7 ff                	idiv   %edi
c00296ec:	52                   	push   %edx
c00296ed:	b8 56 55 55 55       	mov    $0x55555556,%eax
c00296f2:	f7 eb                	imul   %ebx
c00296f4:	89 d1                	mov    %edx,%ecx
c00296f6:	89 d8                	mov    %ebx,%eax
c00296f8:	c1 f8 1f             	sar    $0x1f,%eax
c00296fb:	89 c2                	mov    %eax,%edx
c00296fd:	89 c8                	mov    %ecx,%eax
c00296ff:	29 d0                	sub    %edx,%eax
c0029701:	50                   	push   %eax
c0029702:	68 64 ed 02 c0       	push   $0xc002ed64
c0029707:	e8 0d fa ff ff       	call   c0029119 <msg>
  for (i = 1; i < test.output_pos - output; i++) 
c002970c:	43                   	inc    %ebx
c002970d:	8b 44 24 1c          	mov    0x1c(%esp),%eax
c0029711:	29 e8                	sub    %ebp,%eax
c0029713:	c1 f8 02             	sar    $0x2,%eax
c0029716:	83 c4 10             	add    $0x10,%esp
c0029719:	39 c3                	cmp    %eax,%ebx
c002971b:	7c c2                	jl     c00296df <test_alarm_simultaneous+0xdc>
  free (output);
c002971d:	83 ec 0c             	sub    $0xc,%esp
c0029720:	56                   	push   %esi
c0029721:	e8 2c 97 ff ff       	call   c0022e52 <free>
}
c0029726:	83 c4 3c             	add    $0x3c,%esp
c0029729:	5b                   	pop    %ebx
c002972a:	5e                   	pop    %esi
c002972b:	5f                   	pop    %edi
c002972c:	5d                   	pop    %ebp
c002972d:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002972e:	83 ec 0c             	sub    $0xc,%esp
c0029731:	68 ac ea 02 c0       	push   $0xc002eaac
c0029736:	68 df cb 02 c0       	push   $0xc002cbdf
c002973b:	68 a4 c9 02 c0       	push   $0xc002c9a4
c0029740:	6a 28                	push   $0x28
c0029742:	68 9c ec 02 c0       	push   $0xc002ec9c
c0029747:	e8 f4 de ff ff       	call   c0027640 <debug_panic>
    PANIC ("couldn't allocate memory for test");
c002974c:	68 ec eb 02 c0       	push   $0xc002ebec
c0029751:	68 a4 c9 02 c0       	push   $0xc002c9a4
c0029756:	6a 31                	push   $0x31
c0029758:	68 9c ec 02 c0       	push   $0xc002ec9c
c002975d:	e8 de de ff ff       	call   c0027640 <debug_panic>

c0029762 <alarm_priority_thread>:
    sema_down (&wait_sema);
}

static void
alarm_priority_thread (void *aux UNUSED) 
{
c0029762:	57                   	push   %edi
c0029763:	56                   	push   %esi
c0029764:	83 ec 04             	sub    $0x4,%esp
  /* Busy-wait until the current time changes. */
  int64_t start_time = timer_ticks ();
c0029767:	e8 0e 9b ff ff       	call   c002327a <timer_ticks>
c002976c:	89 c6                	mov    %eax,%esi
c002976e:	89 d7                	mov    %edx,%edi
  while (timer_elapsed (start_time) == 0)
c0029770:	83 ec 08             	sub    $0x8,%esp
c0029773:	57                   	push   %edi
c0029774:	56                   	push   %esi
c0029775:	e8 29 9b ff ff       	call   c00232a3 <timer_elapsed>
c002977a:	83 c4 10             	add    $0x10,%esp
c002977d:	09 c2                	or     %eax,%edx
c002977f:	74 ef                	je     c0029770 <alarm_priority_thread+0xe>
    continue;

  /* Now we know we're at the very beginning of a timer tick, so
     we can call timer_sleep() without worrying about races
     between checking the time and a timer interrupt. */
  timer_sleep (wake_time - timer_ticks ());
c0029781:	8b 35 10 83 03 c0    	mov    0xc0038310,%esi
c0029787:	8b 3d 14 83 03 c0    	mov    0xc0038314,%edi
c002978d:	e8 e8 9a ff ff       	call   c002327a <timer_ticks>
c0029792:	83 ec 08             	sub    $0x8,%esp
c0029795:	29 c6                	sub    %eax,%esi
c0029797:	19 d7                	sbb    %edx,%edi
c0029799:	57                   	push   %edi
c002979a:	56                   	push   %esi
c002979b:	e8 1f 9b ff ff       	call   c00232bf <timer_sleep>

  /* Print a message on wake-up. */
  msg ("Thread %s woke up.", thread_name ());
c00297a0:	e8 56 73 ff ff       	call   c0020afb <thread_name>
c00297a5:	83 c4 08             	add    $0x8,%esp
c00297a8:	50                   	push   %eax
c00297a9:	68 94 ed 02 c0       	push   $0xc002ed94
c00297ae:	e8 66 f9 ff ff       	call   c0029119 <msg>

  sema_up (&wait_sema);
c00297b3:	c7 04 24 f8 82 03 c0 	movl   $0xc00382f8,(%esp)
c00297ba:	e8 12 8a ff ff       	call   c00221d1 <sema_up>
}
c00297bf:	83 c4 14             	add    $0x14,%esp
c00297c2:	5e                   	pop    %esi
c00297c3:	5f                   	pop    %edi
c00297c4:	c3                   	ret    

c00297c5 <test_alarm_priority>:
{
c00297c5:	55                   	push   %ebp
c00297c6:	57                   	push   %edi
c00297c7:	56                   	push   %esi
c00297c8:	53                   	push   %ebx
c00297c9:	83 ec 1c             	sub    $0x1c,%esp
  ASSERT (!thread_mlfqs);
c00297cc:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c00297d3:	0f 85 94 00 00 00    	jne    c002986d <test_alarm_priority+0xa8>
  wake_time = timer_ticks () + 5 * TIMER_FREQ;
c00297d9:	e8 9c 9a ff ff       	call   c002327a <timer_ticks>
c00297de:	05 f4 01 00 00       	add    $0x1f4,%eax
c00297e3:	83 d2 00             	adc    $0x0,%edx
c00297e6:	a3 10 83 03 c0       	mov    %eax,0xc0038310
c00297eb:	89 15 14 83 03 c0    	mov    %edx,0xc0038314
  sema_init (&wait_sema, 0);
c00297f1:	83 ec 08             	sub    $0x8,%esp
c00297f4:	6a 00                	push   $0x0
c00297f6:	68 f8 82 03 c0       	push   $0xc00382f8
c00297fb:	e8 b1 88 ff ff       	call   c00220b1 <sema_init>
c0029800:	83 c4 10             	add    $0x10,%esp
c0029803:	bb 05 00 00 00       	mov    $0x5,%ebx
      int priority = PRI_DEFAULT - (i + 5) % 10 - 1;
c0029808:	bd 0a 00 00 00       	mov    $0xa,%ebp
      snprintf (name, sizeof name, "priority %d", priority);
c002980d:	89 e7                	mov    %esp,%edi
      int priority = PRI_DEFAULT - (i + 5) % 10 - 1;
c002980f:	89 d8                	mov    %ebx,%eax
c0029811:	99                   	cltd   
c0029812:	f7 fd                	idiv   %ebp
c0029814:	be 1e 00 00 00       	mov    $0x1e,%esi
c0029819:	29 d6                	sub    %edx,%esi
      snprintf (name, sizeof name, "priority %d", priority);
c002981b:	56                   	push   %esi
c002981c:	68 a7 ed 02 c0       	push   $0xc002eda7
c0029821:	6a 10                	push   $0x10
c0029823:	57                   	push   %edi
c0029824:	e8 f5 ca ff ff       	call   c002631e <snprintf>
      thread_create (name, priority, alarm_priority_thread, NULL);
c0029829:	6a 00                	push   $0x0
c002982b:	68 62 97 02 c0       	push   $0xc0029762
c0029830:	56                   	push   %esi
c0029831:	57                   	push   %edi
c0029832:	e8 05 71 ff ff       	call   c002093c <thread_create>
c0029837:	43                   	inc    %ebx
  for (i = 0; i < 10; i++) 
c0029838:	83 c4 20             	add    $0x20,%esp
c002983b:	83 fb 0f             	cmp    $0xf,%ebx
c002983e:	75 cf                	jne    c002980f <test_alarm_priority+0x4a>
  thread_set_priority (PRI_MIN);
c0029840:	83 ec 0c             	sub    $0xc,%esp
c0029843:	6a 00                	push   $0x0
c0029845:	e8 46 73 ff ff       	call   c0020b90 <thread_set_priority>
c002984a:	83 c4 10             	add    $0x10,%esp
c002984d:	bb 0a 00 00 00       	mov    $0xa,%ebx
    sema_down (&wait_sema);
c0029852:	83 ec 0c             	sub    $0xc,%esp
c0029855:	68 f8 82 03 c0       	push   $0xc00382f8
c002985a:	e8 91 88 ff ff       	call   c00220f0 <sema_down>
  for (i = 0; i < 10; i++)
c002985f:	83 c4 10             	add    $0x10,%esp
c0029862:	4b                   	dec    %ebx
c0029863:	75 ed                	jne    c0029852 <test_alarm_priority+0x8d>
}
c0029865:	83 c4 1c             	add    $0x1c,%esp
c0029868:	5b                   	pop    %ebx
c0029869:	5e                   	pop    %esi
c002986a:	5f                   	pop    %edi
c002986b:	5d                   	pop    %ebp
c002986c:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002986d:	83 ec 0c             	sub    $0xc,%esp
c0029870:	68 ac ea 02 c0       	push   $0xc002eaac
c0029875:	68 df cb 02 c0       	push   $0xc002cbdf
c002987a:	68 b0 c9 02 c0       	push   $0xc002c9b0
c002987f:	6a 16                	push   $0x16
c0029881:	68 b4 ed 02 c0       	push   $0xc002edb4
c0029886:	e8 b5 dd ff ff       	call   c0027640 <debug_panic>

c002988b <test_alarm_zero>:
#include "threads/thread.h"
#include "devices/timer.h"

void
test_alarm_zero (void) 
{
c002988b:	83 ec 14             	sub    $0x14,%esp
  timer_sleep (0);
c002988e:	6a 00                	push   $0x0
c0029890:	6a 00                	push   $0x0
c0029892:	e8 28 9a ff ff       	call   c00232bf <timer_sleep>
  pass ();
c0029897:	e8 67 f9 ff ff       	call   c0029203 <pass>
}
c002989c:	83 c4 1c             	add    $0x1c,%esp
c002989f:	c3                   	ret    

c00298a0 <test_alarm_negative>:
#include "threads/thread.h"
#include "devices/timer.h"

void
test_alarm_negative (void) 
{
c00298a0:	83 ec 14             	sub    $0x14,%esp
  timer_sleep (-100);
c00298a3:	6a ff                	push   $0xffffffff
c00298a5:	6a 9c                	push   $0xffffff9c
c00298a7:	e8 13 9a ff ff       	call   c00232bf <timer_sleep>
  pass ();
c00298ac:	e8 52 f9 ff ff       	call   c0029203 <pass>
}
c00298b1:	83 c4 1c             	add    $0x1c,%esp
c00298b4:	c3                   	ret    

c00298b5 <changing_thread>:
  msg ("Thread 2 should have just exited.");
}

static void
changing_thread (void *aux UNUSED) 
{
c00298b5:	83 ec 18             	sub    $0x18,%esp
  msg ("Thread 2 now lowering priority.");
c00298b8:	68 dc ed 02 c0       	push   $0xc002eddc
c00298bd:	e8 57 f8 ff ff       	call   c0029119 <msg>
  thread_set_priority (PRI_DEFAULT - 1);
c00298c2:	c7 04 24 1e 00 00 00 	movl   $0x1e,(%esp)
c00298c9:	e8 c2 72 ff ff       	call   c0020b90 <thread_set_priority>
  msg ("Thread 2 exiting.");
c00298ce:	c7 04 24 9a ee 02 c0 	movl   $0xc002ee9a,(%esp)
c00298d5:	e8 3f f8 ff ff       	call   c0029119 <msg>
}
c00298da:	83 c4 1c             	add    $0x1c,%esp
c00298dd:	c3                   	ret    

c00298de <test_priority_change>:
{
c00298de:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (!thread_mlfqs);
c00298e1:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c00298e8:	75 49                	jne    c0029933 <test_priority_change+0x55>
  msg ("Creating a high-priority thread 2.");
c00298ea:	83 ec 0c             	sub    $0xc,%esp
c00298ed:	68 24 ee 02 c0       	push   $0xc002ee24
c00298f2:	e8 22 f8 ff ff       	call   c0029119 <msg>
  thread_create ("thread 2", PRI_DEFAULT + 1, changing_thread, NULL);
c00298f7:	6a 00                	push   $0x0
c00298f9:	68 b5 98 02 c0       	push   $0xc00298b5
c00298fe:	6a 20                	push   $0x20
c0029900:	68 ac ee 02 c0       	push   $0xc002eeac
c0029905:	e8 32 70 ff ff       	call   c002093c <thread_create>
  msg ("Thread 2 should have just lowered its priority.");
c002990a:	83 c4 14             	add    $0x14,%esp
c002990d:	68 48 ee 02 c0       	push   $0xc002ee48
c0029912:	e8 02 f8 ff ff       	call   c0029119 <msg>
  thread_set_priority (PRI_DEFAULT - 2);
c0029917:	c7 04 24 1d 00 00 00 	movl   $0x1d,(%esp)
c002991e:	e8 6d 72 ff ff       	call   c0020b90 <thread_set_priority>
  msg ("Thread 2 should have just exited.");
c0029923:	c7 04 24 78 ee 02 c0 	movl   $0xc002ee78,(%esp)
c002992a:	e8 ea f7 ff ff       	call   c0029119 <msg>
}
c002992f:	83 c4 1c             	add    $0x1c,%esp
c0029932:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c0029933:	83 ec 0c             	sub    $0xc,%esp
c0029936:	68 ac ea 02 c0       	push   $0xc002eaac
c002993b:	68 df cb 02 c0       	push   $0xc002cbdf
c0029940:	68 c4 c9 02 c0       	push   $0xc002c9c4
c0029945:	6a 10                	push   $0x10
c0029947:	68 fc ed 02 c0       	push   $0xc002edfc
c002994c:	e8 ef dc ff ff       	call   c0027640 <debug_panic>

c0029951 <acquire2_thread_func>:
  msg ("acquire1: done");
}

static void
acquire2_thread_func (void *lock_) 
{
c0029951:	53                   	push   %ebx
c0029952:	83 ec 14             	sub    $0x14,%esp
c0029955:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  struct lock *lock = lock_;

  lock_acquire (lock);
c0029959:	53                   	push   %ebx
c002995a:	e8 07 8a ff ff       	call   c0022366 <lock_acquire>
  msg ("acquire2: got the lock");
c002995f:	c7 04 24 b5 ee 02 c0 	movl   $0xc002eeb5,(%esp)
c0029966:	e8 ae f7 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c002996b:	89 1c 24             	mov    %ebx,(%esp)
c002996e:	e8 18 8b ff ff       	call   c002248b <lock_release>
  msg ("acquire2: done");
c0029973:	c7 04 24 cc ee 02 c0 	movl   $0xc002eecc,(%esp)
c002997a:	e8 9a f7 ff ff       	call   c0029119 <msg>
}
c002997f:	83 c4 18             	add    $0x18,%esp
c0029982:	5b                   	pop    %ebx
c0029983:	c3                   	ret    

c0029984 <acquire1_thread_func>:
{
c0029984:	53                   	push   %ebx
c0029985:	83 ec 14             	sub    $0x14,%esp
c0029988:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_acquire (lock);
c002998c:	53                   	push   %ebx
c002998d:	e8 d4 89 ff ff       	call   c0022366 <lock_acquire>
  msg ("acquire1: got the lock");
c0029992:	c7 04 24 db ee 02 c0 	movl   $0xc002eedb,(%esp)
c0029999:	e8 7b f7 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c002999e:	89 1c 24             	mov    %ebx,(%esp)
c00299a1:	e8 e5 8a ff ff       	call   c002248b <lock_release>
  msg ("acquire1: done");
c00299a6:	c7 04 24 f2 ee 02 c0 	movl   $0xc002eef2,(%esp)
c00299ad:	e8 67 f7 ff ff       	call   c0029119 <msg>
}
c00299b2:	83 c4 18             	add    $0x18,%esp
c00299b5:	5b                   	pop    %ebx
c00299b6:	c3                   	ret    

c00299b7 <test_priority_donate_one>:
{
c00299b7:	53                   	push   %ebx
c00299b8:	83 ec 28             	sub    $0x28,%esp
  ASSERT (!thread_mlfqs);
c00299bb:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c00299c2:	0f 85 9c 00 00 00    	jne    c0029a64 <test_priority_donate_one+0xad>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c00299c8:	e8 d6 71 ff ff       	call   c0020ba3 <thread_get_priority>
c00299cd:	83 f8 1f             	cmp    $0x1f,%eax
c00299d0:	0f 85 ac 00 00 00    	jne    c0029a82 <test_priority_donate_one+0xcb>
  lock_init (&lock);
c00299d6:	83 ec 0c             	sub    $0xc,%esp
c00299d9:	8d 5c 24 14          	lea    0x14(%esp),%ebx
c00299dd:	53                   	push   %ebx
c00299de:	e8 01 89 ff ff       	call   c00222e4 <lock_init>
  lock_acquire (&lock);
c00299e3:	89 1c 24             	mov    %ebx,(%esp)
c00299e6:	e8 7b 89 ff ff       	call   c0022366 <lock_acquire>
  thread_create ("acquire1", PRI_DEFAULT + 1, acquire1_thread_func, &lock);
c00299eb:	53                   	push   %ebx
c00299ec:	68 84 99 02 c0       	push   $0xc0029984
c00299f1:	6a 20                	push   $0x20
c00299f3:	68 01 ef 02 c0       	push   $0xc002ef01
c00299f8:	e8 3f 6f ff ff       	call   c002093c <thread_create>
  msg ("This thread should have priority %d.  Actual priority: %d.",
c00299fd:	83 c4 20             	add    $0x20,%esp
c0029a00:	e8 9e 71 ff ff       	call   c0020ba3 <thread_get_priority>
c0029a05:	83 ec 04             	sub    $0x4,%esp
c0029a08:	50                   	push   %eax
c0029a09:	6a 20                	push   $0x20
c0029a0b:	68 68 ef 02 c0       	push   $0xc002ef68
c0029a10:	e8 04 f7 ff ff       	call   c0029119 <msg>
  thread_create ("acquire2", PRI_DEFAULT + 2, acquire2_thread_func, &lock);
c0029a15:	53                   	push   %ebx
c0029a16:	68 51 99 02 c0       	push   $0xc0029951
c0029a1b:	6a 21                	push   $0x21
c0029a1d:	68 0a ef 02 c0       	push   $0xc002ef0a
c0029a22:	e8 15 6f ff ff       	call   c002093c <thread_create>
  msg ("This thread should have priority %d.  Actual priority: %d.",
c0029a27:	83 c4 20             	add    $0x20,%esp
c0029a2a:	e8 74 71 ff ff       	call   c0020ba3 <thread_get_priority>
c0029a2f:	83 ec 04             	sub    $0x4,%esp
c0029a32:	50                   	push   %eax
c0029a33:	6a 21                	push   $0x21
c0029a35:	68 68 ef 02 c0       	push   $0xc002ef68
c0029a3a:	e8 da f6 ff ff       	call   c0029119 <msg>
  lock_release (&lock);
c0029a3f:	89 1c 24             	mov    %ebx,(%esp)
c0029a42:	e8 44 8a ff ff       	call   c002248b <lock_release>
  msg ("acquire2, acquire1 must already have finished, in that order.");
c0029a47:	c7 04 24 a4 ef 02 c0 	movl   $0xc002efa4,(%esp)
c0029a4e:	e8 c6 f6 ff ff       	call   c0029119 <msg>
  msg ("This should be the last line before finishing this test.");
c0029a53:	c7 04 24 e4 ef 02 c0 	movl   $0xc002efe4,(%esp)
c0029a5a:	e8 ba f6 ff ff       	call   c0029119 <msg>
}
c0029a5f:	83 c4 38             	add    $0x38,%esp
c0029a62:	5b                   	pop    %ebx
c0029a63:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c0029a64:	83 ec 0c             	sub    $0xc,%esp
c0029a67:	68 ac ea 02 c0       	push   $0xc002eaac
c0029a6c:	68 df cb 02 c0       	push   $0xc002cbdf
c0029a71:	68 dc c9 02 c0       	push   $0xc002c9dc
c0029a76:	6a 1b                	push   $0x1b
c0029a78:	68 14 ef 02 c0       	push   $0xc002ef14
c0029a7d:	e8 be db ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029a82:	83 ec 0c             	sub    $0xc,%esp
c0029a85:	68 40 ef 02 c0       	push   $0xc002ef40
c0029a8a:	68 df cb 02 c0       	push   $0xc002cbdf
c0029a8f:	68 dc c9 02 c0       	push   $0xc002c9dc
c0029a94:	6a 1e                	push   $0x1e
c0029a96:	68 14 ef 02 c0       	push   $0xc002ef14
c0029a9b:	e8 a0 db ff ff       	call   c0027640 <debug_panic>

c0029aa0 <b_thread_func>:
  msg ("Thread a finished.");
}

static void
b_thread_func (void *lock_) 
{
c0029aa0:	53                   	push   %ebx
c0029aa1:	83 ec 14             	sub    $0x14,%esp
c0029aa4:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  struct lock *lock = lock_;

  lock_acquire (lock);
c0029aa8:	53                   	push   %ebx
c0029aa9:	e8 b8 88 ff ff       	call   c0022366 <lock_acquire>
  msg ("Thread b acquired lock b.");
c0029aae:	c7 04 24 1d f0 02 c0 	movl   $0xc002f01d,(%esp)
c0029ab5:	e8 5f f6 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c0029aba:	89 1c 24             	mov    %ebx,(%esp)
c0029abd:	e8 c9 89 ff ff       	call   c002248b <lock_release>
  msg ("Thread b finished.");
c0029ac2:	c7 04 24 37 f0 02 c0 	movl   $0xc002f037,(%esp)
c0029ac9:	e8 4b f6 ff ff       	call   c0029119 <msg>
}
c0029ace:	83 c4 18             	add    $0x18,%esp
c0029ad1:	5b                   	pop    %ebx
c0029ad2:	c3                   	ret    

c0029ad3 <a_thread_func>:
{
c0029ad3:	53                   	push   %ebx
c0029ad4:	83 ec 14             	sub    $0x14,%esp
c0029ad7:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_acquire (lock);
c0029adb:	53                   	push   %ebx
c0029adc:	e8 85 88 ff ff       	call   c0022366 <lock_acquire>
  msg ("Thread a acquired lock a.");
c0029ae1:	c7 04 24 4a f0 02 c0 	movl   $0xc002f04a,(%esp)
c0029ae8:	e8 2c f6 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c0029aed:	89 1c 24             	mov    %ebx,(%esp)
c0029af0:	e8 96 89 ff ff       	call   c002248b <lock_release>
  msg ("Thread a finished.");
c0029af5:	c7 04 24 64 f0 02 c0 	movl   $0xc002f064,(%esp)
c0029afc:	e8 18 f6 ff ff       	call   c0029119 <msg>
}
c0029b01:	83 c4 18             	add    $0x18,%esp
c0029b04:	5b                   	pop    %ebx
c0029b05:	c3                   	ret    

c0029b06 <test_priority_donate_multiple>:
{
c0029b06:	56                   	push   %esi
c0029b07:	53                   	push   %ebx
c0029b08:	83 ec 34             	sub    $0x34,%esp
  ASSERT (!thread_mlfqs);
c0029b0b:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c0029b12:	0f 85 e4 00 00 00    	jne    c0029bfc <test_priority_donate_multiple+0xf6>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029b18:	e8 86 70 ff ff       	call   c0020ba3 <thread_get_priority>
c0029b1d:	83 f8 1f             	cmp    $0x1f,%eax
c0029b20:	0f 85 f4 00 00 00    	jne    c0029c1a <test_priority_donate_multiple+0x114>
  lock_init (&a);
c0029b26:	83 ec 0c             	sub    $0xc,%esp
c0029b29:	8d 5c 24 24          	lea    0x24(%esp),%ebx
c0029b2d:	53                   	push   %ebx
c0029b2e:	e8 b1 87 ff ff       	call   c00222e4 <lock_init>
  lock_init (&b);
c0029b33:	83 c4 04             	add    $0x4,%esp
c0029b36:	8d 74 24 0c          	lea    0xc(%esp),%esi
c0029b3a:	56                   	push   %esi
c0029b3b:	e8 a4 87 ff ff       	call   c00222e4 <lock_init>
  lock_acquire (&a);
c0029b40:	89 1c 24             	mov    %ebx,(%esp)
c0029b43:	e8 1e 88 ff ff       	call   c0022366 <lock_acquire>
  lock_acquire (&b);
c0029b48:	89 34 24             	mov    %esi,(%esp)
c0029b4b:	e8 16 88 ff ff       	call   c0022366 <lock_acquire>
  thread_create ("a", PRI_DEFAULT + 1, a_thread_func, &a);
c0029b50:	53                   	push   %ebx
c0029b51:	68 d3 9a 02 c0       	push   $0xc0029ad3
c0029b56:	6a 20                	push   $0x20
c0029b58:	68 9f dc 02 c0       	push   $0xc002dc9f
c0029b5d:	e8 da 6d ff ff       	call   c002093c <thread_create>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029b62:	83 c4 20             	add    $0x20,%esp
c0029b65:	e8 39 70 ff ff       	call   c0020ba3 <thread_get_priority>
c0029b6a:	83 ec 04             	sub    $0x4,%esp
c0029b6d:	50                   	push   %eax
c0029b6e:	6a 20                	push   $0x20
c0029b70:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029b75:	e8 9f f5 ff ff       	call   c0029119 <msg>
  thread_create ("b", PRI_DEFAULT + 2, b_thread_func, &b);
c0029b7a:	56                   	push   %esi
c0029b7b:	68 a0 9a 02 c0       	push   $0xc0029aa0
c0029b80:	6a 21                	push   $0x21
c0029b82:	68 eb e5 02 c0       	push   $0xc002e5eb
c0029b87:	e8 b0 6d ff ff       	call   c002093c <thread_create>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029b8c:	83 c4 20             	add    $0x20,%esp
c0029b8f:	e8 0f 70 ff ff       	call   c0020ba3 <thread_get_priority>
c0029b94:	83 ec 04             	sub    $0x4,%esp
c0029b97:	50                   	push   %eax
c0029b98:	6a 21                	push   $0x21
c0029b9a:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029b9f:	e8 75 f5 ff ff       	call   c0029119 <msg>
  lock_release (&b);
c0029ba4:	89 34 24             	mov    %esi,(%esp)
c0029ba7:	e8 df 88 ff ff       	call   c002248b <lock_release>
  msg ("Thread b should have just finished.");
c0029bac:	c7 04 24 e4 f0 02 c0 	movl   $0xc002f0e4,(%esp)
c0029bb3:	e8 61 f5 ff ff       	call   c0029119 <msg>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029bb8:	e8 e6 6f ff ff       	call   c0020ba3 <thread_get_priority>
c0029bbd:	83 c4 0c             	add    $0xc,%esp
c0029bc0:	50                   	push   %eax
c0029bc1:	6a 20                	push   $0x20
c0029bc3:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029bc8:	e8 4c f5 ff ff       	call   c0029119 <msg>
  lock_release (&a);
c0029bcd:	89 1c 24             	mov    %ebx,(%esp)
c0029bd0:	e8 b6 88 ff ff       	call   c002248b <lock_release>
  msg ("Thread a should have just finished.");
c0029bd5:	c7 04 24 08 f1 02 c0 	movl   $0xc002f108,(%esp)
c0029bdc:	e8 38 f5 ff ff       	call   c0029119 <msg>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029be1:	e8 bd 6f ff ff       	call   c0020ba3 <thread_get_priority>
c0029be6:	83 c4 0c             	add    $0xc,%esp
c0029be9:	50                   	push   %eax
c0029bea:	6a 1f                	push   $0x1f
c0029bec:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029bf1:	e8 23 f5 ff ff       	call   c0029119 <msg>
}
c0029bf6:	83 c4 44             	add    $0x44,%esp
c0029bf9:	5b                   	pop    %ebx
c0029bfa:	5e                   	pop    %esi
c0029bfb:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c0029bfc:	83 ec 0c             	sub    $0xc,%esp
c0029bff:	68 ac ea 02 c0       	push   $0xc002eaac
c0029c04:	68 df cb 02 c0       	push   $0xc002cbdf
c0029c09:	68 f8 c9 02 c0       	push   $0xc002c9f8
c0029c0e:	6a 1b                	push   $0x1b
c0029c10:	68 78 f0 02 c0       	push   $0xc002f078
c0029c15:	e8 26 da ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029c1a:	83 ec 0c             	sub    $0xc,%esp
c0029c1d:	68 40 ef 02 c0       	push   $0xc002ef40
c0029c22:	68 df cb 02 c0       	push   $0xc002cbdf
c0029c27:	68 f8 c9 02 c0       	push   $0xc002c9f8
c0029c2c:	6a 1e                	push   $0x1e
c0029c2e:	68 78 f0 02 c0       	push   $0xc002f078
c0029c33:	e8 08 da ff ff       	call   c0027640 <debug_panic>

c0029c38 <c_thread_func>:
  msg ("Thread b finished.");
}

static void
c_thread_func (void *a_ UNUSED) 
{
c0029c38:	83 ec 18             	sub    $0x18,%esp
  msg ("Thread c finished.");
c0029c3b:	68 2c f1 02 c0       	push   $0xc002f12c
c0029c40:	e8 d4 f4 ff ff       	call   c0029119 <msg>
}
c0029c45:	83 c4 1c             	add    $0x1c,%esp
c0029c48:	c3                   	ret    

c0029c49 <b_thread_func>:
{
c0029c49:	53                   	push   %ebx
c0029c4a:	83 ec 14             	sub    $0x14,%esp
c0029c4d:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_acquire (lock);
c0029c51:	53                   	push   %ebx
c0029c52:	e8 0f 87 ff ff       	call   c0022366 <lock_acquire>
  msg ("Thread b acquired lock b.");
c0029c57:	c7 04 24 1d f0 02 c0 	movl   $0xc002f01d,(%esp)
c0029c5e:	e8 b6 f4 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c0029c63:	89 1c 24             	mov    %ebx,(%esp)
c0029c66:	e8 20 88 ff ff       	call   c002248b <lock_release>
  msg ("Thread b finished.");
c0029c6b:	c7 04 24 37 f0 02 c0 	movl   $0xc002f037,(%esp)
c0029c72:	e8 a2 f4 ff ff       	call   c0029119 <msg>
}
c0029c77:	83 c4 18             	add    $0x18,%esp
c0029c7a:	5b                   	pop    %ebx
c0029c7b:	c3                   	ret    

c0029c7c <a_thread_func>:
{
c0029c7c:	53                   	push   %ebx
c0029c7d:	83 ec 14             	sub    $0x14,%esp
c0029c80:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_acquire (lock);
c0029c84:	53                   	push   %ebx
c0029c85:	e8 dc 86 ff ff       	call   c0022366 <lock_acquire>
  msg ("Thread a acquired lock a.");
c0029c8a:	c7 04 24 4a f0 02 c0 	movl   $0xc002f04a,(%esp)
c0029c91:	e8 83 f4 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c0029c96:	89 1c 24             	mov    %ebx,(%esp)
c0029c99:	e8 ed 87 ff ff       	call   c002248b <lock_release>
  msg ("Thread a finished.");
c0029c9e:	c7 04 24 64 f0 02 c0 	movl   $0xc002f064,(%esp)
c0029ca5:	e8 6f f4 ff ff       	call   c0029119 <msg>
}
c0029caa:	83 c4 18             	add    $0x18,%esp
c0029cad:	5b                   	pop    %ebx
c0029cae:	c3                   	ret    

c0029caf <test_priority_donate_multiple2>:
{
c0029caf:	56                   	push   %esi
c0029cb0:	53                   	push   %ebx
c0029cb1:	83 ec 34             	sub    $0x34,%esp
  ASSERT (!thread_mlfqs);
c0029cb4:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c0029cbb:	0f 85 eb 00 00 00    	jne    c0029dac <test_priority_donate_multiple2+0xfd>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029cc1:	e8 dd 6e ff ff       	call   c0020ba3 <thread_get_priority>
c0029cc6:	83 f8 1f             	cmp    $0x1f,%eax
c0029cc9:	0f 85 fb 00 00 00    	jne    c0029dca <test_priority_donate_multiple2+0x11b>
  lock_init (&a);
c0029ccf:	83 ec 0c             	sub    $0xc,%esp
c0029cd2:	8d 74 24 24          	lea    0x24(%esp),%esi
c0029cd6:	56                   	push   %esi
c0029cd7:	e8 08 86 ff ff       	call   c00222e4 <lock_init>
  lock_init (&b);
c0029cdc:	83 c4 04             	add    $0x4,%esp
c0029cdf:	8d 5c 24 0c          	lea    0xc(%esp),%ebx
c0029ce3:	53                   	push   %ebx
c0029ce4:	e8 fb 85 ff ff       	call   c00222e4 <lock_init>
  lock_acquire (&a);
c0029ce9:	89 34 24             	mov    %esi,(%esp)
c0029cec:	e8 75 86 ff ff       	call   c0022366 <lock_acquire>
  lock_acquire (&b);
c0029cf1:	89 1c 24             	mov    %ebx,(%esp)
c0029cf4:	e8 6d 86 ff ff       	call   c0022366 <lock_acquire>
  thread_create ("a", PRI_DEFAULT + 3, a_thread_func, &a);
c0029cf9:	56                   	push   %esi
c0029cfa:	68 7c 9c 02 c0       	push   $0xc0029c7c
c0029cff:	6a 22                	push   $0x22
c0029d01:	68 9f dc 02 c0       	push   $0xc002dc9f
c0029d06:	e8 31 6c ff ff       	call   c002093c <thread_create>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029d0b:	83 c4 20             	add    $0x20,%esp
c0029d0e:	e8 90 6e ff ff       	call   c0020ba3 <thread_get_priority>
c0029d13:	83 ec 04             	sub    $0x4,%esp
c0029d16:	50                   	push   %eax
c0029d17:	6a 22                	push   $0x22
c0029d19:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029d1e:	e8 f6 f3 ff ff       	call   c0029119 <msg>
  thread_create ("c", PRI_DEFAULT + 1, c_thread_func, NULL);
c0029d23:	6a 00                	push   $0x0
c0029d25:	68 38 9c 02 c0       	push   $0xc0029c38
c0029d2a:	6a 20                	push   $0x20
c0029d2c:	68 8a e0 02 c0       	push   $0xc002e08a
c0029d31:	e8 06 6c ff ff       	call   c002093c <thread_create>
  thread_create ("b", PRI_DEFAULT + 5, b_thread_func, &b);
c0029d36:	83 c4 20             	add    $0x20,%esp
c0029d39:	53                   	push   %ebx
c0029d3a:	68 49 9c 02 c0       	push   $0xc0029c49
c0029d3f:	6a 24                	push   $0x24
c0029d41:	68 eb e5 02 c0       	push   $0xc002e5eb
c0029d46:	e8 f1 6b ff ff       	call   c002093c <thread_create>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029d4b:	e8 53 6e ff ff       	call   c0020ba3 <thread_get_priority>
c0029d50:	83 c4 0c             	add    $0xc,%esp
c0029d53:	50                   	push   %eax
c0029d54:	6a 24                	push   $0x24
c0029d56:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029d5b:	e8 b9 f3 ff ff       	call   c0029119 <msg>
  lock_release (&a);
c0029d60:	89 34 24             	mov    %esi,(%esp)
c0029d63:	e8 23 87 ff ff       	call   c002248b <lock_release>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029d68:	e8 36 6e ff ff       	call   c0020ba3 <thread_get_priority>
c0029d6d:	83 c4 0c             	add    $0xc,%esp
c0029d70:	50                   	push   %eax
c0029d71:	6a 24                	push   $0x24
c0029d73:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029d78:	e8 9c f3 ff ff       	call   c0029119 <msg>
  lock_release (&b);
c0029d7d:	89 1c 24             	mov    %ebx,(%esp)
c0029d80:	e8 06 87 ff ff       	call   c002248b <lock_release>
  msg ("Threads b, a, c should have just finished, in that order.");
c0029d85:	c7 04 24 70 f1 02 c0 	movl   $0xc002f170,(%esp)
c0029d8c:	e8 88 f3 ff ff       	call   c0029119 <msg>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c0029d91:	e8 0d 6e ff ff       	call   c0020ba3 <thread_get_priority>
c0029d96:	83 c4 0c             	add    $0xc,%esp
c0029d99:	50                   	push   %eax
c0029d9a:	6a 1f                	push   $0x1f
c0029d9c:	68 a8 f0 02 c0       	push   $0xc002f0a8
c0029da1:	e8 73 f3 ff ff       	call   c0029119 <msg>
}
c0029da6:	83 c4 44             	add    $0x44,%esp
c0029da9:	5b                   	pop    %ebx
c0029daa:	5e                   	pop    %esi
c0029dab:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c0029dac:	83 ec 0c             	sub    $0xc,%esp
c0029daf:	68 ac ea 02 c0       	push   $0xc002eaac
c0029db4:	68 df cb 02 c0       	push   $0xc002cbdf
c0029db9:	68 18 ca 02 c0       	push   $0xc002ca18
c0029dbe:	6a 21                	push   $0x21
c0029dc0:	68 40 f1 02 c0       	push   $0xc002f140
c0029dc5:	e8 76 d8 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029dca:	83 ec 0c             	sub    $0xc,%esp
c0029dcd:	68 40 ef 02 c0       	push   $0xc002ef40
c0029dd2:	68 df cb 02 c0       	push   $0xc002cbdf
c0029dd7:	68 18 ca 02 c0       	push   $0xc002ca18
c0029ddc:	6a 24                	push   $0x24
c0029dde:	68 40 f1 02 c0       	push   $0xc002f140
c0029de3:	e8 58 d8 ff ff       	call   c0027640 <debug_panic>

c0029de8 <high_thread_func>:
  msg ("Middle thread finished.");
}

static void
high_thread_func (void *lock_) 
{
c0029de8:	53                   	push   %ebx
c0029de9:	83 ec 14             	sub    $0x14,%esp
c0029dec:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  struct lock *lock = lock_;

  lock_acquire (lock);
c0029df0:	53                   	push   %ebx
c0029df1:	e8 70 85 ff ff       	call   c0022366 <lock_acquire>
  msg ("High thread got the lock.");
c0029df6:	c7 04 24 aa f1 02 c0 	movl   $0xc002f1aa,(%esp)
c0029dfd:	e8 17 f3 ff ff       	call   c0029119 <msg>
  lock_release (lock);
c0029e02:	89 1c 24             	mov    %ebx,(%esp)
c0029e05:	e8 81 86 ff ff       	call   c002248b <lock_release>
  msg ("High thread finished.");
c0029e0a:	c7 04 24 c4 f1 02 c0 	movl   $0xc002f1c4,(%esp)
c0029e11:	e8 03 f3 ff ff       	call   c0029119 <msg>
}
c0029e16:	83 c4 18             	add    $0x18,%esp
c0029e19:	5b                   	pop    %ebx
c0029e1a:	c3                   	ret    

c0029e1b <medium_thread_func>:
{
c0029e1b:	53                   	push   %ebx
c0029e1c:	83 ec 14             	sub    $0x14,%esp
c0029e1f:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_acquire (locks->b);
c0029e23:	ff 73 04             	pushl  0x4(%ebx)
c0029e26:	e8 3b 85 ff ff       	call   c0022366 <lock_acquire>
  lock_acquire (locks->a);
c0029e2b:	83 c4 04             	add    $0x4,%esp
c0029e2e:	ff 33                	pushl  (%ebx)
c0029e30:	e8 31 85 ff ff       	call   c0022366 <lock_acquire>
  msg ("Medium thread should have priority %d.  Actual priority: %d.",
c0029e35:	e8 69 6d ff ff       	call   c0020ba3 <thread_get_priority>
c0029e3a:	83 c4 0c             	add    $0xc,%esp
c0029e3d:	50                   	push   %eax
c0029e3e:	6a 21                	push   $0x21
c0029e40:	68 1c f2 02 c0       	push   $0xc002f21c
c0029e45:	e8 cf f2 ff ff       	call   c0029119 <msg>
  msg ("Medium thread got the lock.");
c0029e4a:	c7 04 24 da f1 02 c0 	movl   $0xc002f1da,(%esp)
c0029e51:	e8 c3 f2 ff ff       	call   c0029119 <msg>
  lock_release (locks->a);
c0029e56:	83 c4 04             	add    $0x4,%esp
c0029e59:	ff 33                	pushl  (%ebx)
c0029e5b:	e8 2b 86 ff ff       	call   c002248b <lock_release>
  thread_yield ();
c0029e60:	e8 1c 70 ff ff       	call   c0020e81 <thread_yield>
  lock_release (locks->b);
c0029e65:	83 c4 04             	add    $0x4,%esp
c0029e68:	ff 73 04             	pushl  0x4(%ebx)
c0029e6b:	e8 1b 86 ff ff       	call   c002248b <lock_release>
  thread_yield ();
c0029e70:	e8 0c 70 ff ff       	call   c0020e81 <thread_yield>
  msg ("High thread should have just finished.");
c0029e75:	c7 04 24 5c f2 02 c0 	movl   $0xc002f25c,(%esp)
c0029e7c:	e8 98 f2 ff ff       	call   c0029119 <msg>
  msg ("Middle thread finished.");
c0029e81:	c7 04 24 f6 f1 02 c0 	movl   $0xc002f1f6,(%esp)
c0029e88:	e8 8c f2 ff ff       	call   c0029119 <msg>
}
c0029e8d:	83 c4 18             	add    $0x18,%esp
c0029e90:	5b                   	pop    %ebx
c0029e91:	c3                   	ret    

c0029e92 <test_priority_donate_nest>:
{
c0029e92:	56                   	push   %esi
c0029e93:	53                   	push   %ebx
c0029e94:	83 ec 44             	sub    $0x44,%esp
  ASSERT (!thread_mlfqs);
c0029e97:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c0029e9e:	0f 85 ce 00 00 00    	jne    c0029f72 <test_priority_donate_nest+0xe0>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029ea4:	e8 fa 6c ff ff       	call   c0020ba3 <thread_get_priority>
c0029ea9:	83 f8 1f             	cmp    $0x1f,%eax
c0029eac:	0f 85 de 00 00 00    	jne    c0029f90 <test_priority_donate_nest+0xfe>
  lock_init (&a);
c0029eb2:	83 ec 0c             	sub    $0xc,%esp
c0029eb5:	8d 5c 24 34          	lea    0x34(%esp),%ebx
c0029eb9:	53                   	push   %ebx
c0029eba:	e8 25 84 ff ff       	call   c00222e4 <lock_init>
  lock_init (&b);
c0029ebf:	83 c4 04             	add    $0x4,%esp
c0029ec2:	8d 74 24 1c          	lea    0x1c(%esp),%esi
c0029ec6:	56                   	push   %esi
c0029ec7:	e8 18 84 ff ff       	call   c00222e4 <lock_init>
  lock_acquire (&a);
c0029ecc:	89 1c 24             	mov    %ebx,(%esp)
c0029ecf:	e8 92 84 ff ff       	call   c0022366 <lock_acquire>
  locks.a = &a;
c0029ed4:	89 5c 24 18          	mov    %ebx,0x18(%esp)
  locks.b = &b;
c0029ed8:	89 74 24 1c          	mov    %esi,0x1c(%esp)
  thread_create ("medium", PRI_DEFAULT + 1, medium_thread_func, &locks);
c0029edc:	8d 44 24 18          	lea    0x18(%esp),%eax
c0029ee0:	50                   	push   %eax
c0029ee1:	68 1b 9e 02 c0       	push   $0xc0029e1b
c0029ee6:	6a 20                	push   $0x20
c0029ee8:	68 0e f2 02 c0       	push   $0xc002f20e
c0029eed:	e8 4a 6a ff ff       	call   c002093c <thread_create>
  thread_yield ();
c0029ef2:	83 c4 20             	add    $0x20,%esp
c0029ef5:	e8 87 6f ff ff       	call   c0020e81 <thread_yield>
  msg ("Low thread should have priority %d.  Actual priority: %d.",
c0029efa:	e8 a4 6c ff ff       	call   c0020ba3 <thread_get_priority>
c0029eff:	83 ec 04             	sub    $0x4,%esp
c0029f02:	50                   	push   %eax
c0029f03:	6a 20                	push   $0x20
c0029f05:	68 b0 f2 02 c0       	push   $0xc002f2b0
c0029f0a:	e8 0a f2 ff ff       	call   c0029119 <msg>
  thread_create ("high", PRI_DEFAULT + 2, high_thread_func, &b);
c0029f0f:	56                   	push   %esi
c0029f10:	68 e8 9d 02 c0       	push   $0xc0029de8
c0029f15:	6a 21                	push   $0x21
c0029f17:	68 15 f2 02 c0       	push   $0xc002f215
c0029f1c:	e8 1b 6a ff ff       	call   c002093c <thread_create>
  thread_yield ();
c0029f21:	83 c4 20             	add    $0x20,%esp
c0029f24:	e8 58 6f ff ff       	call   c0020e81 <thread_yield>
  msg ("Low thread should have priority %d.  Actual priority: %d.",
c0029f29:	e8 75 6c ff ff       	call   c0020ba3 <thread_get_priority>
c0029f2e:	83 ec 04             	sub    $0x4,%esp
c0029f31:	50                   	push   %eax
c0029f32:	6a 21                	push   $0x21
c0029f34:	68 b0 f2 02 c0       	push   $0xc002f2b0
c0029f39:	e8 db f1 ff ff       	call   c0029119 <msg>
  lock_release (&a);
c0029f3e:	89 1c 24             	mov    %ebx,(%esp)
c0029f41:	e8 45 85 ff ff       	call   c002248b <lock_release>
  thread_yield ();
c0029f46:	e8 36 6f ff ff       	call   c0020e81 <thread_yield>
  msg ("Medium thread should just have finished.");
c0029f4b:	c7 04 24 ec f2 02 c0 	movl   $0xc002f2ec,(%esp)
c0029f52:	e8 c2 f1 ff ff       	call   c0029119 <msg>
  msg ("Low thread should have priority %d.  Actual priority: %d.",
c0029f57:	e8 47 6c ff ff       	call   c0020ba3 <thread_get_priority>
c0029f5c:	83 c4 0c             	add    $0xc,%esp
c0029f5f:	50                   	push   %eax
c0029f60:	6a 1f                	push   $0x1f
c0029f62:	68 b0 f2 02 c0       	push   $0xc002f2b0
c0029f67:	e8 ad f1 ff ff       	call   c0029119 <msg>
}
c0029f6c:	83 c4 54             	add    $0x54,%esp
c0029f6f:	5b                   	pop    %ebx
c0029f70:	5e                   	pop    %esi
c0029f71:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c0029f72:	83 ec 0c             	sub    $0xc,%esp
c0029f75:	68 ac ea 02 c0       	push   $0xc002eaac
c0029f7a:	68 df cb 02 c0       	push   $0xc002cbdf
c0029f7f:	68 38 ca 02 c0       	push   $0xc002ca38
c0029f84:	6a 22                	push   $0x22
c0029f86:	68 84 f2 02 c0       	push   $0xc002f284
c0029f8b:	e8 b0 d6 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c0029f90:	83 ec 0c             	sub    $0xc,%esp
c0029f93:	68 40 ef 02 c0       	push   $0xc002ef40
c0029f98:	68 df cb 02 c0       	push   $0xc002cbdf
c0029f9d:	68 38 ca 02 c0       	push   $0xc002ca38
c0029fa2:	6a 25                	push   $0x25
c0029fa4:	68 84 f2 02 c0       	push   $0xc002f284
c0029fa9:	e8 92 d6 ff ff       	call   c0027640 <debug_panic>

c0029fae <h_thread_func>:
  msg ("Thread M finished.");
}

static void
h_thread_func (void *ls_) 
{
c0029fae:	53                   	push   %ebx
c0029faf:	83 ec 14             	sub    $0x14,%esp
c0029fb2:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  struct lock_and_sema *ls = ls_;

  lock_acquire (&ls->lock);
c0029fb6:	53                   	push   %ebx
c0029fb7:	e8 aa 83 ff ff       	call   c0022366 <lock_acquire>
  msg ("Thread H acquired lock.");
c0029fbc:	c7 04 24 15 f3 02 c0 	movl   $0xc002f315,(%esp)
c0029fc3:	e8 51 f1 ff ff       	call   c0029119 <msg>

  sema_up (&ls->sema);
c0029fc8:	8d 43 18             	lea    0x18(%ebx),%eax
c0029fcb:	89 04 24             	mov    %eax,(%esp)
c0029fce:	e8 fe 81 ff ff       	call   c00221d1 <sema_up>
  lock_release (&ls->lock);
c0029fd3:	89 1c 24             	mov    %ebx,(%esp)
c0029fd6:	e8 b0 84 ff ff       	call   c002248b <lock_release>
  msg ("Thread H finished.");
c0029fdb:	c7 04 24 2d f3 02 c0 	movl   $0xc002f32d,(%esp)
c0029fe2:	e8 32 f1 ff ff       	call   c0029119 <msg>
}
c0029fe7:	83 c4 18             	add    $0x18,%esp
c0029fea:	5b                   	pop    %ebx
c0029feb:	c3                   	ret    

c0029fec <m_thread_func>:
{
c0029fec:	83 ec 18             	sub    $0x18,%esp
  sema_down (&ls->sema);
c0029fef:	8b 44 24 1c          	mov    0x1c(%esp),%eax
c0029ff3:	83 c0 18             	add    $0x18,%eax
c0029ff6:	50                   	push   %eax
c0029ff7:	e8 f4 80 ff ff       	call   c00220f0 <sema_down>
  msg ("Thread M finished.");
c0029ffc:	c7 04 24 40 f3 02 c0 	movl   $0xc002f340,(%esp)
c002a003:	e8 11 f1 ff ff       	call   c0029119 <msg>
}
c002a008:	83 c4 1c             	add    $0x1c,%esp
c002a00b:	c3                   	ret    

c002a00c <l_thread_func>:
{
c002a00c:	53                   	push   %ebx
c002a00d:	83 ec 14             	sub    $0x14,%esp
c002a010:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  lock_acquire (&ls->lock);
c002a014:	53                   	push   %ebx
c002a015:	e8 4c 83 ff ff       	call   c0022366 <lock_acquire>
  msg ("Thread L acquired lock.");
c002a01a:	c7 04 24 53 f3 02 c0 	movl   $0xc002f353,(%esp)
c002a021:	e8 f3 f0 ff ff       	call   c0029119 <msg>
  sema_down (&ls->sema);
c002a026:	8d 43 18             	lea    0x18(%ebx),%eax
c002a029:	89 04 24             	mov    %eax,(%esp)
c002a02c:	e8 bf 80 ff ff       	call   c00220f0 <sema_down>
  msg ("Thread L downed semaphore.");
c002a031:	c7 04 24 6b f3 02 c0 	movl   $0xc002f36b,(%esp)
c002a038:	e8 dc f0 ff ff       	call   c0029119 <msg>
  lock_release (&ls->lock);
c002a03d:	89 1c 24             	mov    %ebx,(%esp)
c002a040:	e8 46 84 ff ff       	call   c002248b <lock_release>
  msg ("Thread L finished.");
c002a045:	c7 04 24 86 f3 02 c0 	movl   $0xc002f386,(%esp)
c002a04c:	e8 c8 f0 ff ff       	call   c0029119 <msg>
}
c002a051:	83 c4 18             	add    $0x18,%esp
c002a054:	5b                   	pop    %ebx
c002a055:	c3                   	ret    

c002a056 <test_priority_donate_sema>:
{
c002a056:	56                   	push   %esi
c002a057:	53                   	push   %ebx
c002a058:	83 ec 34             	sub    $0x34,%esp
  ASSERT (!thread_mlfqs);
c002a05b:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a062:	75 7e                	jne    c002a0e2 <test_priority_donate_sema+0x8c>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a064:	e8 3a 6b ff ff       	call   c0020ba3 <thread_get_priority>
c002a069:	83 f8 1f             	cmp    $0x1f,%eax
c002a06c:	0f 85 8e 00 00 00    	jne    c002a100 <test_priority_donate_sema+0xaa>
  lock_init (&ls.lock);
c002a072:	83 ec 0c             	sub    $0xc,%esp
c002a075:	8d 5c 24 10          	lea    0x10(%esp),%ebx
c002a079:	53                   	push   %ebx
c002a07a:	e8 65 82 ff ff       	call   c00222e4 <lock_init>
  sema_init (&ls.sema, 0);
c002a07f:	83 c4 08             	add    $0x8,%esp
c002a082:	6a 00                	push   $0x0
c002a084:	8d 74 24 28          	lea    0x28(%esp),%esi
c002a088:	56                   	push   %esi
c002a089:	e8 23 80 ff ff       	call   c00220b1 <sema_init>
  thread_create ("low", PRI_DEFAULT + 1, l_thread_func, &ls);
c002a08e:	53                   	push   %ebx
c002a08f:	68 0c a0 02 c0       	push   $0xc002a00c
c002a094:	6a 20                	push   $0x20
c002a096:	68 99 f3 02 c0       	push   $0xc002f399
c002a09b:	e8 9c 68 ff ff       	call   c002093c <thread_create>
  thread_create ("med", PRI_DEFAULT + 3, m_thread_func, &ls);
c002a0a0:	83 c4 20             	add    $0x20,%esp
c002a0a3:	53                   	push   %ebx
c002a0a4:	68 ec 9f 02 c0       	push   $0xc0029fec
c002a0a9:	6a 22                	push   $0x22
c002a0ab:	68 9d f3 02 c0       	push   $0xc002f39d
c002a0b0:	e8 87 68 ff ff       	call   c002093c <thread_create>
  thread_create ("high", PRI_DEFAULT + 5, h_thread_func, &ls);
c002a0b5:	53                   	push   %ebx
c002a0b6:	68 ae 9f 02 c0       	push   $0xc0029fae
c002a0bb:	6a 24                	push   $0x24
c002a0bd:	68 15 f2 02 c0       	push   $0xc002f215
c002a0c2:	e8 75 68 ff ff       	call   c002093c <thread_create>
  sema_up (&ls.sema);
c002a0c7:	83 c4 14             	add    $0x14,%esp
c002a0ca:	56                   	push   %esi
c002a0cb:	e8 01 81 ff ff       	call   c00221d1 <sema_up>
  msg ("Main thread finished.");
c002a0d0:	c7 04 24 a1 f3 02 c0 	movl   $0xc002f3a1,(%esp)
c002a0d7:	e8 3d f0 ff ff       	call   c0029119 <msg>
}
c002a0dc:	83 c4 44             	add    $0x44,%esp
c002a0df:	5b                   	pop    %ebx
c002a0e0:	5e                   	pop    %esi
c002a0e1:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002a0e2:	83 ec 0c             	sub    $0xc,%esp
c002a0e5:	68 ac ea 02 c0       	push   $0xc002eaac
c002a0ea:	68 df cb 02 c0       	push   $0xc002cbdf
c002a0ef:	68 54 ca 02 c0       	push   $0xc002ca54
c002a0f4:	6a 23                	push   $0x23
c002a0f6:	68 b8 f3 02 c0       	push   $0xc002f3b8
c002a0fb:	e8 40 d5 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a100:	83 ec 0c             	sub    $0xc,%esp
c002a103:	68 40 ef 02 c0       	push   $0xc002ef40
c002a108:	68 df cb 02 c0       	push   $0xc002cbdf
c002a10d:	68 54 ca 02 c0       	push   $0xc002ca54
c002a112:	6a 26                	push   $0x26
c002a114:	68 b8 f3 02 c0       	push   $0xc002f3b8
c002a119:	e8 22 d5 ff ff       	call   c0027640 <debug_panic>

c002a11e <acquire_thread_func>:
       PRI_DEFAULT - 10, thread_get_priority ());
}

static void
acquire_thread_func (void *lock_) 
{
c002a11e:	53                   	push   %ebx
c002a11f:	83 ec 14             	sub    $0x14,%esp
c002a122:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
  struct lock *lock = lock_;

  lock_acquire (lock);
c002a126:	53                   	push   %ebx
c002a127:	e8 3a 82 ff ff       	call   c0022366 <lock_acquire>
  msg ("acquire: got the lock");
c002a12c:	c7 04 24 e3 f3 02 c0 	movl   $0xc002f3e3,(%esp)
c002a133:	e8 e1 ef ff ff       	call   c0029119 <msg>
  lock_release (lock);
c002a138:	89 1c 24             	mov    %ebx,(%esp)
c002a13b:	e8 4b 83 ff ff       	call   c002248b <lock_release>
  msg ("acquire: done");
c002a140:	c7 04 24 f9 f3 02 c0 	movl   $0xc002f3f9,(%esp)
c002a147:	e8 cd ef ff ff       	call   c0029119 <msg>
}
c002a14c:	83 c4 18             	add    $0x18,%esp
c002a14f:	5b                   	pop    %ebx
c002a150:	c3                   	ret    

c002a151 <test_priority_donate_lower>:
{
c002a151:	53                   	push   %ebx
c002a152:	83 ec 28             	sub    $0x28,%esp
  ASSERT (!thread_mlfqs);
c002a155:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a15c:	0f 85 a8 00 00 00    	jne    c002a20a <test_priority_donate_lower+0xb9>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a162:	e8 3c 6a ff ff       	call   c0020ba3 <thread_get_priority>
c002a167:	83 f8 1f             	cmp    $0x1f,%eax
c002a16a:	0f 85 b8 00 00 00    	jne    c002a228 <test_priority_donate_lower+0xd7>
  lock_init (&lock);
c002a170:	83 ec 0c             	sub    $0xc,%esp
c002a173:	8d 5c 24 14          	lea    0x14(%esp),%ebx
c002a177:	53                   	push   %ebx
c002a178:	e8 67 81 ff ff       	call   c00222e4 <lock_init>
  lock_acquire (&lock);
c002a17d:	89 1c 24             	mov    %ebx,(%esp)
c002a180:	e8 e1 81 ff ff       	call   c0022366 <lock_acquire>
  thread_create ("acquire", PRI_DEFAULT + 10, acquire_thread_func, &lock);
c002a185:	53                   	push   %ebx
c002a186:	68 1e a1 02 c0       	push   $0xc002a11e
c002a18b:	6a 29                	push   $0x29
c002a18d:	68 07 f4 02 c0       	push   $0xc002f407
c002a192:	e8 a5 67 ff ff       	call   c002093c <thread_create>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c002a197:	83 c4 20             	add    $0x20,%esp
c002a19a:	e8 04 6a ff ff       	call   c0020ba3 <thread_get_priority>
c002a19f:	83 ec 04             	sub    $0x4,%esp
c002a1a2:	50                   	push   %eax
c002a1a3:	6a 29                	push   $0x29
c002a1a5:	68 a8 f0 02 c0       	push   $0xc002f0a8
c002a1aa:	e8 6a ef ff ff       	call   c0029119 <msg>
  msg ("Lowering base priority...");
c002a1af:	c7 04 24 0f f4 02 c0 	movl   $0xc002f40f,(%esp)
c002a1b6:	e8 5e ef ff ff       	call   c0029119 <msg>
  thread_set_priority (PRI_DEFAULT - 10);
c002a1bb:	c7 04 24 15 00 00 00 	movl   $0x15,(%esp)
c002a1c2:	e8 c9 69 ff ff       	call   c0020b90 <thread_set_priority>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c002a1c7:	e8 d7 69 ff ff       	call   c0020ba3 <thread_get_priority>
c002a1cc:	83 c4 0c             	add    $0xc,%esp
c002a1cf:	50                   	push   %eax
c002a1d0:	6a 29                	push   $0x29
c002a1d2:	68 a8 f0 02 c0       	push   $0xc002f0a8
c002a1d7:	e8 3d ef ff ff       	call   c0029119 <msg>
  lock_release (&lock);
c002a1dc:	89 1c 24             	mov    %ebx,(%esp)
c002a1df:	e8 a7 82 ff ff       	call   c002248b <lock_release>
  msg ("acquire must already have finished.");
c002a1e4:	c7 04 24 58 f4 02 c0 	movl   $0xc002f458,(%esp)
c002a1eb:	e8 29 ef ff ff       	call   c0029119 <msg>
  msg ("Main thread should have priority %d.  Actual priority: %d.",
c002a1f0:	e8 ae 69 ff ff       	call   c0020ba3 <thread_get_priority>
c002a1f5:	83 c4 0c             	add    $0xc,%esp
c002a1f8:	50                   	push   %eax
c002a1f9:	6a 15                	push   $0x15
c002a1fb:	68 a8 f0 02 c0       	push   $0xc002f0a8
c002a200:	e8 14 ef ff ff       	call   c0029119 <msg>
}
c002a205:	83 c4 38             	add    $0x38,%esp
c002a208:	5b                   	pop    %ebx
c002a209:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002a20a:	83 ec 0c             	sub    $0xc,%esp
c002a20d:	68 ac ea 02 c0       	push   $0xc002eaac
c002a212:	68 df cb 02 c0       	push   $0xc002cbdf
c002a217:	68 70 ca 02 c0       	push   $0xc002ca70
c002a21c:	6a 15                	push   $0x15
c002a21e:	68 2c f4 02 c0       	push   $0xc002f42c
c002a223:	e8 18 d4 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a228:	83 ec 0c             	sub    $0xc,%esp
c002a22b:	68 40 ef 02 c0       	push   $0xc002ef40
c002a230:	68 df cb 02 c0       	push   $0xc002cbdf
c002a235:	68 70 ca 02 c0       	push   $0xc002ca70
c002a23a:	6a 18                	push   $0x18
c002a23c:	68 2c f4 02 c0       	push   $0xc002f42c
c002a241:	e8 fa d3 ff ff       	call   c0027640 <debug_panic>

c002a246 <simple_thread_func>:
    }
}

static void 
simple_thread_func (void *data_) 
{
c002a246:	56                   	push   %esi
c002a247:	53                   	push   %ebx
c002a248:	83 ec 04             	sub    $0x4,%esp
c002a24b:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c002a24f:	be 10 00 00 00       	mov    $0x10,%esi
  struct simple_thread_data *data = data_;
  int i;
  
  for (i = 0; i < ITER_CNT; i++) 
    {
      lock_acquire (data->lock);
c002a254:	83 ec 0c             	sub    $0xc,%esp
c002a257:	ff 73 08             	pushl  0x8(%ebx)
c002a25a:	e8 07 81 ff ff       	call   c0022366 <lock_acquire>
      *(*data->op)++ = data->id;
c002a25f:	8b 53 0c             	mov    0xc(%ebx),%edx
c002a262:	8b 02                	mov    (%edx),%eax
c002a264:	8d 48 04             	lea    0x4(%eax),%ecx
c002a267:	89 0a                	mov    %ecx,(%edx)
c002a269:	8b 13                	mov    (%ebx),%edx
c002a26b:	89 10                	mov    %edx,(%eax)
      lock_release (data->lock);
c002a26d:	83 c4 04             	add    $0x4,%esp
c002a270:	ff 73 08             	pushl  0x8(%ebx)
c002a273:	e8 13 82 ff ff       	call   c002248b <lock_release>
      thread_yield ();
c002a278:	e8 04 6c ff ff       	call   c0020e81 <thread_yield>
  for (i = 0; i < ITER_CNT; i++) 
c002a27d:	83 c4 10             	add    $0x10,%esp
c002a280:	4e                   	dec    %esi
c002a281:	75 d1                	jne    c002a254 <simple_thread_func+0xe>
    }
}
c002a283:	83 c4 04             	add    $0x4,%esp
c002a286:	5b                   	pop    %ebx
c002a287:	5e                   	pop    %esi
c002a288:	c3                   	ret    

c002a289 <test_priority_fifo>:
{
c002a289:	55                   	push   %ebp
c002a28a:	57                   	push   %edi
c002a28b:	56                   	push   %esi
c002a28c:	53                   	push   %ebx
c002a28d:	81 ec 4c 01 00 00    	sub    $0x14c,%esp
  ASSERT (!thread_mlfqs);
c002a293:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a29a:	0f 85 f1 00 00 00    	jne    c002a391 <test_priority_fifo+0x108>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a2a0:	e8 fe 68 ff ff       	call   c0020ba3 <thread_get_priority>
c002a2a5:	83 f8 1f             	cmp    $0x1f,%eax
c002a2a8:	0f 85 01 01 00 00    	jne    c002a3af <test_priority_fifo+0x126>
  msg ("%d threads will iterate %d times in the same order each time.",
c002a2ae:	83 ec 04             	sub    $0x4,%esp
c002a2b1:	6a 10                	push   $0x10
c002a2b3:	6a 10                	push   $0x10
c002a2b5:	68 e0 f4 02 c0       	push   $0xc002f4e0
c002a2ba:	e8 5a ee ff ff       	call   c0029119 <msg>
  msg ("If the order varies then there is a bug.");
c002a2bf:	c7 04 24 20 f5 02 c0 	movl   $0xc002f520,(%esp)
c002a2c6:	e8 4e ee ff ff       	call   c0029119 <msg>
  output = op = malloc (sizeof *output * THREAD_CNT * ITER_CNT * 2);
c002a2cb:	c7 04 24 00 08 00 00 	movl   $0x800,(%esp)
c002a2d2:	e8 da 89 ff ff       	call   c0022cb1 <malloc>
c002a2d7:	89 44 24 1c          	mov    %eax,0x1c(%esp)
c002a2db:	89 44 24 34          	mov    %eax,0x34(%esp)
  ASSERT (output != NULL);
c002a2df:	83 c4 10             	add    $0x10,%esp
c002a2e2:	85 c0                	test   %eax,%eax
c002a2e4:	0f 84 e3 00 00 00    	je     c002a3cd <test_priority_fifo+0x144>
  lock_init (&lock);
c002a2ea:	83 ec 0c             	sub    $0xc,%esp
c002a2ed:	8d 44 24 34          	lea    0x34(%esp),%eax
c002a2f1:	50                   	push   %eax
c002a2f2:	e8 ed 7f ff ff       	call   c00222e4 <lock_init>
  thread_set_priority (PRI_DEFAULT + 2);
c002a2f7:	c7 04 24 21 00 00 00 	movl   $0x21,(%esp)
c002a2fe:	e8 8d 68 ff ff       	call   c0020b90 <thread_set_priority>
c002a303:	8d 5c 24 50          	lea    0x50(%esp),%ebx
c002a307:	83 c4 10             	add    $0x10,%esp
  for (i = 0; i < THREAD_CNT; i++) 
c002a30a:	be 00 00 00 00       	mov    $0x0,%esi
      snprintf (name, sizeof name, "%d", i);
c002a30f:	8d 7c 24 14          	lea    0x14(%esp),%edi
      d->lock = &lock;
c002a313:	8d 6c 24 28          	lea    0x28(%esp),%ebp
      snprintf (name, sizeof name, "%d", i);
c002a317:	56                   	push   %esi
c002a318:	68 c1 ea 02 c0       	push   $0xc002eac1
c002a31d:	6a 10                	push   $0x10
c002a31f:	57                   	push   %edi
c002a320:	e8 f9 bf ff ff       	call   c002631e <snprintf>
      d->id = i;
c002a325:	89 33                	mov    %esi,(%ebx)
      d->iterations = 0;
c002a327:	c7 43 04 00 00 00 00 	movl   $0x0,0x4(%ebx)
      d->lock = &lock;
c002a32e:	89 6b 08             	mov    %ebp,0x8(%ebx)
      d->op = &op;
c002a331:	8d 44 24 34          	lea    0x34(%esp),%eax
c002a335:	89 43 0c             	mov    %eax,0xc(%ebx)
      thread_create (name, PRI_DEFAULT + 1, simple_thread_func, d);
c002a338:	53                   	push   %ebx
c002a339:	68 46 a2 02 c0       	push   $0xc002a246
c002a33e:	6a 20                	push   $0x20
c002a340:	57                   	push   %edi
c002a341:	e8 f6 65 ff ff       	call   c002093c <thread_create>
  for (i = 0; i < THREAD_CNT; i++) 
c002a346:	46                   	inc    %esi
c002a347:	83 c3 10             	add    $0x10,%ebx
c002a34a:	83 c4 20             	add    $0x20,%esp
c002a34d:	83 fe 10             	cmp    $0x10,%esi
c002a350:	75 c5                	jne    c002a317 <test_priority_fifo+0x8e>
  thread_set_priority (PRI_DEFAULT);
c002a352:	83 ec 0c             	sub    $0xc,%esp
c002a355:	6a 1f                	push   $0x1f
c002a357:	e8 34 68 ff ff       	call   c0020b90 <thread_set_priority>
  ASSERT (lock.holder == NULL);
c002a35c:	83 c4 10             	add    $0x10,%esp
c002a35f:	83 7c 24 28 00       	cmpl   $0x0,0x28(%esp)
c002a364:	0f 85 81 00 00 00    	jne    c002a3eb <test_priority_fifo+0x162>
  for (; output < op; output++) 
c002a36a:	8b 44 24 0c          	mov    0xc(%esp),%eax
c002a36e:	3b 44 24 24          	cmp    0x24(%esp),%eax
c002a372:	0f 83 0f 01 00 00    	jae    c002a487 <test_priority_fifo+0x1fe>
      ASSERT (*output >= 0 && *output < THREAD_CNT);
c002a378:	8b 18                	mov    (%eax),%ebx
c002a37a:	83 fb 0f             	cmp    $0xf,%ebx
c002a37d:	0f 87 86 00 00 00    	ja     c002a409 <test_priority_fifo+0x180>
c002a383:	8b 7c 24 0c          	mov    0xc(%esp),%edi
c002a387:	be 00 00 00 00       	mov    $0x0,%esi
c002a38c:	e9 bb 00 00 00       	jmp    c002a44c <test_priority_fifo+0x1c3>
  ASSERT (!thread_mlfqs);
c002a391:	83 ec 0c             	sub    $0xc,%esp
c002a394:	68 ac ea 02 c0       	push   $0xc002eaac
c002a399:	68 df cb 02 c0       	push   $0xc002cbdf
c002a39e:	68 8c ca 02 c0       	push   $0xc002ca8c
c002a3a3:	6a 28                	push   $0x28
c002a3a5:	68 bc f4 02 c0       	push   $0xc002f4bc
c002a3aa:	e8 91 d2 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a3af:	83 ec 0c             	sub    $0xc,%esp
c002a3b2:	68 40 ef 02 c0       	push   $0xc002ef40
c002a3b7:	68 df cb 02 c0       	push   $0xc002cbdf
c002a3bc:	68 8c ca 02 c0       	push   $0xc002ca8c
c002a3c1:	6a 2b                	push   $0x2b
c002a3c3:	68 bc f4 02 c0       	push   $0xc002f4bc
c002a3c8:	e8 73 d2 ff ff       	call   c0027640 <debug_panic>
  ASSERT (output != NULL);
c002a3cd:	83 ec 0c             	sub    $0xc,%esp
c002a3d0:	68 7c f4 02 c0       	push   $0xc002f47c
c002a3d5:	68 df cb 02 c0       	push   $0xc002cbdf
c002a3da:	68 8c ca 02 c0       	push   $0xc002ca8c
c002a3df:	6a 32                	push   $0x32
c002a3e1:	68 bc f4 02 c0       	push   $0xc002f4bc
c002a3e6:	e8 55 d2 ff ff       	call   c0027640 <debug_panic>
  ASSERT (lock.holder == NULL);
c002a3eb:	83 ec 0c             	sub    $0xc,%esp
c002a3ee:	68 8b f4 02 c0       	push   $0xc002f48b
c002a3f3:	68 df cb 02 c0       	push   $0xc002cbdf
c002a3f8:	68 8c ca 02 c0       	push   $0xc002ca8c
c002a3fd:	6a 44                	push   $0x44
c002a3ff:	68 bc f4 02 c0       	push   $0xc002f4bc
c002a404:	e8 37 d2 ff ff       	call   c0027640 <debug_panic>
      ASSERT (*output >= 0 && *output < THREAD_CNT);
c002a409:	83 ec 0c             	sub    $0xc,%esp
c002a40c:	68 4c f5 02 c0       	push   $0xc002f54c
c002a411:	68 df cb 02 c0       	push   $0xc002cbdf
c002a416:	68 8c ca 02 c0       	push   $0xc002ca8c
c002a41b:	6a 4b                	push   $0x4b
c002a41d:	68 bc f4 02 c0       	push   $0xc002f4bc
c002a422:	e8 19 d2 ff ff       	call   c0027640 <debug_panic>
        printf ("(priority-fifo) iteration:");
c002a427:	83 ec 0c             	sub    $0xc,%esp
c002a42a:	68 9f f4 02 c0       	push   $0xc002f49f
c002a42f:	e8 5e b7 ff ff       	call   c0025b92 <printf>
c002a434:	83 c4 10             	add    $0x10,%esp
c002a437:	eb 24                	jmp    c002a45d <test_priority_fifo+0x1d4>
      d->iterations++;
c002a439:	ff 43 04             	incl   0x4(%ebx)
  for (; output < op; output++) 
c002a43c:	83 c7 04             	add    $0x4,%edi
c002a43f:	39 7c 24 24          	cmp    %edi,0x24(%esp)
c002a443:	76 42                	jbe    c002a487 <test_priority_fifo+0x1fe>
      ASSERT (*output >= 0 && *output < THREAD_CNT);
c002a445:	8b 1f                	mov    (%edi),%ebx
c002a447:	83 fb 0f             	cmp    $0xf,%ebx
c002a44a:	77 bd                	ja     c002a409 <test_priority_fifo+0x180>
      d = data + *output;
c002a44c:	c1 e3 04             	shl    $0x4,%ebx
c002a44f:	8d 44 24 40          	lea    0x40(%esp),%eax
c002a453:	01 c3                	add    %eax,%ebx
      if (cnt % THREAD_CNT == 0)
c002a455:	f7 c6 0f 00 00 00    	test   $0xf,%esi
c002a45b:	74 ca                	je     c002a427 <test_priority_fifo+0x19e>
      printf (" %d", d->id);
c002a45d:	83 ec 08             	sub    $0x8,%esp
c002a460:	ff 33                	pushl  (%ebx)
c002a462:	68 c0 ea 02 c0       	push   $0xc002eac0
c002a467:	e8 26 b7 ff ff       	call   c0025b92 <printf>
      if (++cnt % THREAD_CNT == 0)
c002a46c:	46                   	inc    %esi
c002a46d:	83 c4 10             	add    $0x10,%esp
c002a470:	f7 c6 0f 00 00 00    	test   $0xf,%esi
c002a476:	75 c1                	jne    c002a439 <test_priority_fifo+0x1b0>
        printf ("\n");
c002a478:	83 ec 0c             	sub    $0xc,%esp
c002a47b:	6a 0a                	push   $0xa
c002a47d:	e8 78 ec ff ff       	call   c00290fa <putchar>
c002a482:	83 c4 10             	add    $0x10,%esp
c002a485:	eb b2                	jmp    c002a439 <test_priority_fifo+0x1b0>
}
c002a487:	81 c4 4c 01 00 00    	add    $0x14c,%esp
c002a48d:	5b                   	pop    %ebx
c002a48e:	5e                   	pop    %esi
c002a48f:	5f                   	pop    %edi
c002a490:	5d                   	pop    %ebp
c002a491:	c3                   	ret    

c002a492 <simple_thread_func>:
  msg ("The high-priority thread should have already completed.");
}

static void 
simple_thread_func (void *aux UNUSED) 
{
c002a492:	53                   	push   %ebx
c002a493:	83 ec 08             	sub    $0x8,%esp
  int i;
  
  for (i = 0; i < 5; i++) 
c002a496:	bb 00 00 00 00       	mov    $0x0,%ebx
    {
      msg ("Thread %s iteration %d", thread_name (), i);
c002a49b:	e8 5b 66 ff ff       	call   c0020afb <thread_name>
c002a4a0:	83 ec 04             	sub    $0x4,%esp
c002a4a3:	53                   	push   %ebx
c002a4a4:	50                   	push   %eax
c002a4a5:	68 71 f5 02 c0       	push   $0xc002f571
c002a4aa:	e8 6a ec ff ff       	call   c0029119 <msg>
      thread_yield ();
c002a4af:	e8 cd 69 ff ff       	call   c0020e81 <thread_yield>
  for (i = 0; i < 5; i++) 
c002a4b4:	43                   	inc    %ebx
c002a4b5:	83 c4 10             	add    $0x10,%esp
c002a4b8:	83 fb 05             	cmp    $0x5,%ebx
c002a4bb:	75 de                	jne    c002a49b <simple_thread_func+0x9>
    }
  msg ("Thread %s done!", thread_name ());
c002a4bd:	e8 39 66 ff ff       	call   c0020afb <thread_name>
c002a4c2:	83 ec 08             	sub    $0x8,%esp
c002a4c5:	50                   	push   %eax
c002a4c6:	68 88 f5 02 c0       	push   $0xc002f588
c002a4cb:	e8 49 ec ff ff       	call   c0029119 <msg>
}
c002a4d0:	83 c4 18             	add    $0x18,%esp
c002a4d3:	5b                   	pop    %ebx
c002a4d4:	c3                   	ret    

c002a4d5 <test_priority_preempt>:
{
c002a4d5:	83 ec 0c             	sub    $0xc,%esp
  ASSERT (!thread_mlfqs);
c002a4d8:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a4df:	75 2d                	jne    c002a50e <test_priority_preempt+0x39>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a4e1:	e8 bd 66 ff ff       	call   c0020ba3 <thread_get_priority>
c002a4e6:	83 f8 1f             	cmp    $0x1f,%eax
c002a4e9:	75 41                	jne    c002a52c <test_priority_preempt+0x57>
  thread_create ("high-priority", PRI_DEFAULT + 1, simple_thread_func, NULL);
c002a4eb:	6a 00                	push   $0x0
c002a4ed:	68 92 a4 02 c0       	push   $0xc002a492
c002a4f2:	6a 20                	push   $0x20
c002a4f4:	68 98 f5 02 c0       	push   $0xc002f598
c002a4f9:	e8 3e 64 ff ff       	call   c002093c <thread_create>
  msg ("The high-priority thread should have already completed.");
c002a4fe:	c7 04 24 d0 f5 02 c0 	movl   $0xc002f5d0,(%esp)
c002a505:	e8 0f ec ff ff       	call   c0029119 <msg>
}
c002a50a:	83 c4 1c             	add    $0x1c,%esp
c002a50d:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002a50e:	83 ec 0c             	sub    $0xc,%esp
c002a511:	68 ac ea 02 c0       	push   $0xc002eaac
c002a516:	68 df cb 02 c0       	push   $0xc002cbdf
c002a51b:	68 a0 ca 02 c0       	push   $0xc002caa0
c002a520:	6a 15                	push   $0x15
c002a522:	68 a8 f5 02 c0       	push   $0xc002f5a8
c002a527:	e8 14 d1 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_get_priority () == PRI_DEFAULT);
c002a52c:	83 ec 0c             	sub    $0xc,%esp
c002a52f:	68 40 ef 02 c0       	push   $0xc002ef40
c002a534:	68 df cb 02 c0       	push   $0xc002cbdf
c002a539:	68 a0 ca 02 c0       	push   $0xc002caa0
c002a53e:	6a 18                	push   $0x18
c002a540:	68 a8 f5 02 c0       	push   $0xc002f5a8
c002a545:	e8 f6 d0 ff ff       	call   c0027640 <debug_panic>

c002a54a <priority_sema_thread>:
    }
}

static void
priority_sema_thread (void *aux UNUSED) 
{
c002a54a:	83 ec 18             	sub    $0x18,%esp
  sema_down (&sema);
c002a54d:	68 18 83 03 c0       	push   $0xc0038318
c002a552:	e8 99 7b ff ff       	call   c00220f0 <sema_down>
  msg ("Thread %s woke up.", thread_name ());
c002a557:	e8 9f 65 ff ff       	call   c0020afb <thread_name>
c002a55c:	83 c4 08             	add    $0x8,%esp
c002a55f:	50                   	push   %eax
c002a560:	68 94 ed 02 c0       	push   $0xc002ed94
c002a565:	e8 af eb ff ff       	call   c0029119 <msg>
}
c002a56a:	83 c4 1c             	add    $0x1c,%esp
c002a56d:	c3                   	ret    

c002a56e <test_priority_sema>:
{
c002a56e:	55                   	push   %ebp
c002a56f:	57                   	push   %edi
c002a570:	56                   	push   %esi
c002a571:	53                   	push   %ebx
c002a572:	83 ec 1c             	sub    $0x1c,%esp
  ASSERT (!thread_mlfqs);
c002a575:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a57c:	0f 85 87 00 00 00    	jne    c002a609 <test_priority_sema+0x9b>
  sema_init (&sema, 0);
c002a582:	83 ec 08             	sub    $0x8,%esp
c002a585:	6a 00                	push   $0x0
c002a587:	68 18 83 03 c0       	push   $0xc0038318
c002a58c:	e8 20 7b ff ff       	call   c00220b1 <sema_init>
  thread_set_priority (PRI_MIN);
c002a591:	c7 04 24 00 00 00 00 	movl   $0x0,(%esp)
c002a598:	e8 f3 65 ff ff       	call   c0020b90 <thread_set_priority>
c002a59d:	83 c4 10             	add    $0x10,%esp
c002a5a0:	bb 03 00 00 00       	mov    $0x3,%ebx
      int priority = PRI_DEFAULT - (i + 3) % 10 - 1;
c002a5a5:	bd 0a 00 00 00       	mov    $0xa,%ebp
      snprintf (name, sizeof name, "priority %d", priority);
c002a5aa:	89 e7                	mov    %esp,%edi
      int priority = PRI_DEFAULT - (i + 3) % 10 - 1;
c002a5ac:	89 d8                	mov    %ebx,%eax
c002a5ae:	99                   	cltd   
c002a5af:	f7 fd                	idiv   %ebp
c002a5b1:	be 1e 00 00 00       	mov    $0x1e,%esi
c002a5b6:	29 d6                	sub    %edx,%esi
      snprintf (name, sizeof name, "priority %d", priority);
c002a5b8:	56                   	push   %esi
c002a5b9:	68 a7 ed 02 c0       	push   $0xc002eda7
c002a5be:	6a 10                	push   $0x10
c002a5c0:	57                   	push   %edi
c002a5c1:	e8 58 bd ff ff       	call   c002631e <snprintf>
      thread_create (name, priority, priority_sema_thread, NULL);
c002a5c6:	6a 00                	push   $0x0
c002a5c8:	68 4a a5 02 c0       	push   $0xc002a54a
c002a5cd:	56                   	push   %esi
c002a5ce:	57                   	push   %edi
c002a5cf:	e8 68 63 ff ff       	call   c002093c <thread_create>
c002a5d4:	43                   	inc    %ebx
  for (i = 0; i < 10; i++) 
c002a5d5:	83 c4 20             	add    $0x20,%esp
c002a5d8:	83 fb 0d             	cmp    $0xd,%ebx
c002a5db:	75 cf                	jne    c002a5ac <test_priority_sema+0x3e>
c002a5dd:	bb 0a 00 00 00       	mov    $0xa,%ebx
      sema_up (&sema);
c002a5e2:	83 ec 0c             	sub    $0xc,%esp
c002a5e5:	68 18 83 03 c0       	push   $0xc0038318
c002a5ea:	e8 e2 7b ff ff       	call   c00221d1 <sema_up>
      msg ("Back in main thread."); 
c002a5ef:	c7 04 24 08 f6 02 c0 	movl   $0xc002f608,(%esp)
c002a5f6:	e8 1e eb ff ff       	call   c0029119 <msg>
  for (i = 0; i < 10; i++) 
c002a5fb:	83 c4 10             	add    $0x10,%esp
c002a5fe:	4b                   	dec    %ebx
c002a5ff:	75 e1                	jne    c002a5e2 <test_priority_sema+0x74>
}
c002a601:	83 c4 1c             	add    $0x1c,%esp
c002a604:	5b                   	pop    %ebx
c002a605:	5e                   	pop    %esi
c002a606:	5f                   	pop    %edi
c002a607:	5d                   	pop    %ebp
c002a608:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002a609:	83 ec 0c             	sub    $0xc,%esp
c002a60c:	68 ac ea 02 c0       	push   $0xc002eaac
c002a611:	68 df cb 02 c0       	push   $0xc002cbdf
c002a616:	68 b8 ca 02 c0       	push   $0xc002cab8
c002a61b:	6a 15                	push   $0x15
c002a61d:	68 20 f6 02 c0       	push   $0xc002f620
c002a622:	e8 19 d0 ff ff       	call   c0027640 <debug_panic>

c002a627 <priority_condvar_thread>:
    }
}

static void
priority_condvar_thread (void *aux UNUSED) 
{
c002a627:	83 ec 0c             	sub    $0xc,%esp
  msg ("Thread %s starting.", thread_name ());
c002a62a:	e8 cc 64 ff ff       	call   c0020afb <thread_name>
c002a62f:	83 ec 08             	sub    $0x8,%esp
c002a632:	50                   	push   %eax
c002a633:	68 44 f6 02 c0       	push   $0xc002f644
c002a638:	e8 dc ea ff ff       	call   c0029119 <msg>
  lock_acquire (&lock);
c002a63d:	c7 04 24 3c 83 03 c0 	movl   $0xc003833c,(%esp)
c002a644:	e8 1d 7d ff ff       	call   c0022366 <lock_acquire>
  cond_wait (&condition, &lock);
c002a649:	83 c4 08             	add    $0x8,%esp
c002a64c:	68 3c 83 03 c0       	push   $0xc003833c
c002a651:	68 2c 83 03 c0       	push   $0xc003832c
c002a656:	e8 de 7e ff ff       	call   c0022539 <cond_wait>
  msg ("Thread %s woke up.", thread_name ());
c002a65b:	e8 9b 64 ff ff       	call   c0020afb <thread_name>
c002a660:	83 c4 08             	add    $0x8,%esp
c002a663:	50                   	push   %eax
c002a664:	68 94 ed 02 c0       	push   $0xc002ed94
c002a669:	e8 ab ea ff ff       	call   c0029119 <msg>
  lock_release (&lock);
c002a66e:	c7 04 24 3c 83 03 c0 	movl   $0xc003833c,(%esp)
c002a675:	e8 11 7e ff ff       	call   c002248b <lock_release>
}
c002a67a:	83 c4 1c             	add    $0x1c,%esp
c002a67d:	c3                   	ret    

c002a67e <test_priority_condvar>:
{
c002a67e:	55                   	push   %ebp
c002a67f:	57                   	push   %edi
c002a680:	56                   	push   %esi
c002a681:	53                   	push   %ebx
c002a682:	83 ec 1c             	sub    $0x1c,%esp
  ASSERT (!thread_mlfqs);
c002a685:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a68c:	0f 85 af 00 00 00    	jne    c002a741 <test_priority_condvar+0xc3>
  lock_init (&lock);
c002a692:	83 ec 0c             	sub    $0xc,%esp
c002a695:	68 3c 83 03 c0       	push   $0xc003833c
c002a69a:	e8 45 7c ff ff       	call   c00222e4 <lock_init>
  cond_init (&condition);
c002a69f:	c7 04 24 2c 83 03 c0 	movl   $0xc003832c,(%esp)
c002a6a6:	e8 55 7e ff ff       	call   c0022500 <cond_init>
  thread_set_priority (PRI_MIN);
c002a6ab:	c7 04 24 00 00 00 00 	movl   $0x0,(%esp)
c002a6b2:	e8 d9 64 ff ff       	call   c0020b90 <thread_set_priority>
c002a6b7:	83 c4 10             	add    $0x10,%esp
c002a6ba:	bb 07 00 00 00       	mov    $0x7,%ebx
      int priority = PRI_DEFAULT - (i + 7) % 10 - 1;
c002a6bf:	bd 0a 00 00 00       	mov    $0xa,%ebp
      snprintf (name, sizeof name, "priority %d", priority);
c002a6c4:	89 e7                	mov    %esp,%edi
      int priority = PRI_DEFAULT - (i + 7) % 10 - 1;
c002a6c6:	89 d8                	mov    %ebx,%eax
c002a6c8:	99                   	cltd   
c002a6c9:	f7 fd                	idiv   %ebp
c002a6cb:	be 1e 00 00 00       	mov    $0x1e,%esi
c002a6d0:	29 d6                	sub    %edx,%esi
      snprintf (name, sizeof name, "priority %d", priority);
c002a6d2:	56                   	push   %esi
c002a6d3:	68 a7 ed 02 c0       	push   $0xc002eda7
c002a6d8:	6a 10                	push   $0x10
c002a6da:	57                   	push   %edi
c002a6db:	e8 3e bc ff ff       	call   c002631e <snprintf>
      thread_create (name, priority, priority_condvar_thread, NULL);
c002a6e0:	6a 00                	push   $0x0
c002a6e2:	68 27 a6 02 c0       	push   $0xc002a627
c002a6e7:	56                   	push   %esi
c002a6e8:	57                   	push   %edi
c002a6e9:	e8 4e 62 ff ff       	call   c002093c <thread_create>
c002a6ee:	43                   	inc    %ebx
  for (i = 0; i < 10; i++) 
c002a6ef:	83 c4 20             	add    $0x20,%esp
c002a6f2:	83 fb 11             	cmp    $0x11,%ebx
c002a6f5:	75 cf                	jne    c002a6c6 <test_priority_condvar+0x48>
c002a6f7:	bb 0a 00 00 00       	mov    $0xa,%ebx
      lock_acquire (&lock);
c002a6fc:	83 ec 0c             	sub    $0xc,%esp
c002a6ff:	68 3c 83 03 c0       	push   $0xc003833c
c002a704:	e8 5d 7c ff ff       	call   c0022366 <lock_acquire>
      msg ("Signaling...");
c002a709:	c7 04 24 58 f6 02 c0 	movl   $0xc002f658,(%esp)
c002a710:	e8 04 ea ff ff       	call   c0029119 <msg>
      cond_signal (&condition, &lock);
c002a715:	83 c4 08             	add    $0x8,%esp
c002a718:	68 3c 83 03 c0       	push   $0xc003833c
c002a71d:	68 2c 83 03 c0       	push   $0xc003832c
c002a722:	e8 0b 7f ff ff       	call   c0022632 <cond_signal>
      lock_release (&lock);
c002a727:	c7 04 24 3c 83 03 c0 	movl   $0xc003833c,(%esp)
c002a72e:	e8 58 7d ff ff       	call   c002248b <lock_release>
  for (i = 0; i < 10; i++) 
c002a733:	83 c4 10             	add    $0x10,%esp
c002a736:	4b                   	dec    %ebx
c002a737:	75 c3                	jne    c002a6fc <test_priority_condvar+0x7e>
}
c002a739:	83 c4 1c             	add    $0x1c,%esp
c002a73c:	5b                   	pop    %ebx
c002a73d:	5e                   	pop    %esi
c002a73e:	5f                   	pop    %edi
c002a73f:	5d                   	pop    %ebp
c002a740:	c3                   	ret    
  ASSERT (!thread_mlfqs);
c002a741:	83 ec 0c             	sub    $0xc,%esp
c002a744:	68 ac ea 02 c0       	push   $0xc002eaac
c002a749:	68 df cb 02 c0       	push   $0xc002cbdf
c002a74e:	68 cc ca 02 c0       	push   $0xc002cacc
c002a753:	6a 16                	push   $0x16
c002a755:	68 68 f6 02 c0       	push   $0xc002f668
c002a75a:	e8 e1 ce ff ff       	call   c0027640 <debug_panic>

c002a75f <interloper_thread_func>:
                                         thread_get_priority ());
}

static void
interloper_thread_func (void *arg_ UNUSED)
{
c002a75f:	83 ec 0c             	sub    $0xc,%esp
  msg ("%s finished.", thread_name ());
c002a762:	e8 94 63 ff ff       	call   c0020afb <thread_name>
c002a767:	83 ec 08             	sub    $0x8,%esp
c002a76a:	50                   	push   %eax
c002a76b:	68 8f f6 02 c0       	push   $0xc002f68f
c002a770:	e8 a4 e9 ff ff       	call   c0029119 <msg>
}
c002a775:	83 c4 1c             	add    $0x1c,%esp
c002a778:	c3                   	ret    

c002a779 <donor_thread_func>:
{
c002a779:	56                   	push   %esi
c002a77a:	53                   	push   %ebx
c002a77b:	83 ec 04             	sub    $0x4,%esp
c002a77e:	8b 5c 24 10          	mov    0x10(%esp),%ebx
  if (locks->first)
c002a782:	8b 43 04             	mov    0x4(%ebx),%eax
c002a785:	85 c0                	test   %eax,%eax
c002a787:	74 0c                	je     c002a795 <donor_thread_func+0x1c>
    lock_acquire (locks->first);
c002a789:	83 ec 0c             	sub    $0xc,%esp
c002a78c:	50                   	push   %eax
c002a78d:	e8 d4 7b ff ff       	call   c0022366 <lock_acquire>
c002a792:	83 c4 10             	add    $0x10,%esp
  lock_acquire (locks->second);
c002a795:	83 ec 0c             	sub    $0xc,%esp
c002a798:	ff 33                	pushl  (%ebx)
c002a79a:	e8 c7 7b ff ff       	call   c0022366 <lock_acquire>
  msg ("%s got lock", thread_name ());
c002a79f:	e8 57 63 ff ff       	call   c0020afb <thread_name>
c002a7a4:	83 c4 08             	add    $0x8,%esp
c002a7a7:	50                   	push   %eax
c002a7a8:	68 9c f6 02 c0       	push   $0xc002f69c
c002a7ad:	e8 67 e9 ff ff       	call   c0029119 <msg>
  lock_release (locks->second);
c002a7b2:	83 c4 04             	add    $0x4,%esp
c002a7b5:	ff 33                	pushl  (%ebx)
c002a7b7:	e8 cf 7c ff ff       	call   c002248b <lock_release>
  msg ("%s should have priority %d. Actual priority: %d", 
c002a7bc:	e8 e2 63 ff ff       	call   c0020ba3 <thread_get_priority>
c002a7c1:	89 c6                	mov    %eax,%esi
c002a7c3:	e8 33 63 ff ff       	call   c0020afb <thread_name>
c002a7c8:	56                   	push   %esi
c002a7c9:	6a 15                	push   $0x15
c002a7cb:	50                   	push   %eax
c002a7cc:	68 c4 f6 02 c0       	push   $0xc002f6c4
c002a7d1:	e8 43 e9 ff ff       	call   c0029119 <msg>
  if (locks->first)
c002a7d6:	8b 43 04             	mov    0x4(%ebx),%eax
c002a7d9:	83 c4 20             	add    $0x20,%esp
c002a7dc:	85 c0                	test   %eax,%eax
c002a7de:	74 0c                	je     c002a7ec <donor_thread_func+0x73>
    lock_release (locks->first);
c002a7e0:	83 ec 0c             	sub    $0xc,%esp
c002a7e3:	50                   	push   %eax
c002a7e4:	e8 a2 7c ff ff       	call   c002248b <lock_release>
c002a7e9:	83 c4 10             	add    $0x10,%esp
  msg ("%s finishing with priority %d.", thread_name (),
c002a7ec:	e8 b2 63 ff ff       	call   c0020ba3 <thread_get_priority>
c002a7f1:	89 c3                	mov    %eax,%ebx
c002a7f3:	e8 03 63 ff ff       	call   c0020afb <thread_name>
c002a7f8:	83 ec 04             	sub    $0x4,%esp
c002a7fb:	53                   	push   %ebx
c002a7fc:	50                   	push   %eax
c002a7fd:	68 f4 f6 02 c0       	push   $0xc002f6f4
c002a802:	e8 12 e9 ff ff       	call   c0029119 <msg>
}
c002a807:	83 c4 14             	add    $0x14,%esp
c002a80a:	5b                   	pop    %ebx
c002a80b:	5e                   	pop    %esi
c002a80c:	c3                   	ret    

c002a80d <test_priority_donate_chain>:
{
c002a80d:	55                   	push   %ebp
c002a80e:	57                   	push   %edi
c002a80f:	56                   	push   %esi
c002a810:	53                   	push   %ebx
c002a811:	81 ec 1c 01 00 00    	sub    $0x11c,%esp
  ASSERT (!thread_mlfqs);
c002a817:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a81e:	75 73                	jne    c002a893 <test_priority_donate_chain+0x86>
  thread_set_priority (PRI_MIN);
c002a820:	83 ec 0c             	sub    $0xc,%esp
c002a823:	6a 00                	push   $0x0
c002a825:	e8 66 63 ff ff       	call   c0020b90 <thread_set_priority>
c002a82a:	8d 5c 24 78          	lea    0x78(%esp),%ebx
c002a82e:	8d b4 24 20 01 00 00 	lea    0x120(%esp),%esi
c002a835:	83 c4 10             	add    $0x10,%esp
    lock_init (&locks[i]);
c002a838:	83 ec 0c             	sub    $0xc,%esp
c002a83b:	53                   	push   %ebx
c002a83c:	e8 a3 7a ff ff       	call   c00222e4 <lock_init>
c002a841:	83 c3 18             	add    $0x18,%ebx
  for (i = 0; i < NESTING_DEPTH - 1; i++)
c002a844:	83 c4 10             	add    $0x10,%esp
c002a847:	39 f3                	cmp    %esi,%ebx
c002a849:	75 ed                	jne    c002a838 <test_priority_donate_chain+0x2b>
  lock_acquire (&locks[0]);
c002a84b:	83 ec 0c             	sub    $0xc,%esp
c002a84e:	8d 44 24 74          	lea    0x74(%esp),%eax
c002a852:	50                   	push   %eax
c002a853:	e8 0e 7b ff ff       	call   c0022366 <lock_acquire>
  msg ("%s got lock.", thread_name ());
c002a858:	e8 9e 62 ff ff       	call   c0020afb <thread_name>
c002a85d:	83 c4 08             	add    $0x8,%esp
c002a860:	50                   	push   %eax
c002a861:	68 a8 f6 02 c0       	push   $0xc002f6a8
c002a866:	e8 ae e8 ff ff       	call   c0029119 <msg>
c002a86b:	8d 84 24 90 00 00 00 	lea    0x90(%esp),%eax
c002a872:	89 44 24 14          	mov    %eax,0x14(%esp)
c002a876:	8d 74 24 40          	lea    0x40(%esp),%esi
c002a87a:	83 c4 10             	add    $0x10,%esp
c002a87d:	c7 44 24 08 02 00 00 	movl   $0x2,0x8(%esp)
c002a884:	00 
  for (i = 1; i < NESTING_DEPTH; i++)
c002a885:	bb 01 00 00 00       	mov    $0x1,%ebx
      snprintf (name, sizeof name, "thread %d", i);
c002a88a:	8d 6c 24 18          	lea    0x18(%esp),%ebp
c002a88e:	e9 97 00 00 00       	jmp    c002a92a <test_priority_donate_chain+0x11d>
  ASSERT (!thread_mlfqs);
c002a893:	83 ec 0c             	sub    $0xc,%esp
c002a896:	68 ac ea 02 c0       	push   $0xc002eaac
c002a89b:	68 df cb 02 c0       	push   $0xc002cbdf
c002a8a0:	68 e4 ca 02 c0       	push   $0xc002cae4
c002a8a5:	6a 34                	push   $0x34
c002a8a7:	68 14 f7 02 c0       	push   $0xc002f714
c002a8ac:	e8 8f cd ff ff       	call   c0027640 <debug_panic>
      lock_pairs[i].first = i < NESTING_DEPTH - 1 ? locks + i: NULL;
c002a8b1:	b8 00 00 00 00       	mov    $0x0,%eax
c002a8b6:	89 46 04             	mov    %eax,0x4(%esi)
      lock_pairs[i].second = locks + i - 1;
c002a8b9:	8b 44 24 04          	mov    0x4(%esp),%eax
c002a8bd:	83 e8 18             	sub    $0x18,%eax
c002a8c0:	89 06                	mov    %eax,(%esi)
      thread_create (name, thread_priority, donor_thread_func, lock_pairs + i);
c002a8c2:	56                   	push   %esi
c002a8c3:	68 79 a7 02 c0       	push   $0xc002a779
c002a8c8:	57                   	push   %edi
c002a8c9:	55                   	push   %ebp
c002a8ca:	e8 6d 60 ff ff       	call   c002093c <thread_create>
      msg ("%s should have priority %d.  Actual priority: %d.",
c002a8cf:	e8 cf 62 ff ff       	call   c0020ba3 <thread_get_priority>
c002a8d4:	89 44 24 1c          	mov    %eax,0x1c(%esp)
c002a8d8:	e8 1e 62 ff ff       	call   c0020afb <thread_name>
c002a8dd:	ff 74 24 1c          	pushl  0x1c(%esp)
c002a8e1:	57                   	push   %edi
c002a8e2:	50                   	push   %eax
c002a8e3:	68 40 f7 02 c0       	push   $0xc002f740
c002a8e8:	e8 2c e8 ff ff       	call   c0029119 <msg>
      snprintf (name, sizeof name, "interloper %d", i);
c002a8ed:	83 c4 20             	add    $0x20,%esp
c002a8f0:	53                   	push   %ebx
c002a8f1:	68 b5 f6 02 c0       	push   $0xc002f6b5
c002a8f6:	6a 10                	push   $0x10
c002a8f8:	55                   	push   %ebp
c002a8f9:	e8 20 ba ff ff       	call   c002631e <snprintf>
      thread_create (name, thread_priority - 1, interloper_thread_func, NULL);
c002a8fe:	6a 00                	push   $0x0
c002a900:	68 5f a7 02 c0       	push   $0xc002a75f
c002a905:	8b 7c 24 20          	mov    0x20(%esp),%edi
c002a909:	57                   	push   %edi
c002a90a:	55                   	push   %ebp
c002a90b:	e8 2c 60 ff ff       	call   c002093c <thread_create>
  for (i = 1; i < NESTING_DEPTH; i++)
c002a910:	43                   	inc    %ebx
c002a911:	83 44 24 24 18       	addl   $0x18,0x24(%esp)
c002a916:	83 c6 08             	add    $0x8,%esi
c002a919:	89 f8                	mov    %edi,%eax
c002a91b:	83 c0 03             	add    $0x3,%eax
c002a91e:	89 44 24 28          	mov    %eax,0x28(%esp)
c002a922:	83 c4 20             	add    $0x20,%esp
c002a925:	83 fb 08             	cmp    $0x8,%ebx
c002a928:	74 29                	je     c002a953 <test_priority_donate_chain+0x146>
      snprintf (name, sizeof name, "thread %d", i);
c002a92a:	53                   	push   %ebx
c002a92b:	68 ba ea 02 c0       	push   $0xc002eaba
c002a930:	6a 10                	push   $0x10
c002a932:	55                   	push   %ebp
c002a933:	e8 e6 b9 ff ff       	call   c002631e <snprintf>
c002a938:	8d 04 1b             	lea    (%ebx,%ebx,1),%eax
c002a93b:	8d 3c 18             	lea    (%eax,%ebx,1),%edi
      lock_pairs[i].first = i < NESTING_DEPTH - 1 ? locks + i: NULL;
c002a93e:	83 c4 10             	add    $0x10,%esp
c002a941:	83 fb 06             	cmp    $0x6,%ebx
c002a944:	0f 8f 67 ff ff ff    	jg     c002a8b1 <test_priority_donate_chain+0xa4>
c002a94a:	8b 44 24 04          	mov    0x4(%esp),%eax
c002a94e:	e9 63 ff ff ff       	jmp    c002a8b6 <test_priority_donate_chain+0xa9>
  lock_release (&locks[0]);
c002a953:	83 ec 0c             	sub    $0xc,%esp
c002a956:	8d 44 24 74          	lea    0x74(%esp),%eax
c002a95a:	50                   	push   %eax
c002a95b:	e8 2b 7b ff ff       	call   c002248b <lock_release>
  msg ("%s finishing with priority %d.", thread_name (),
c002a960:	e8 3e 62 ff ff       	call   c0020ba3 <thread_get_priority>
c002a965:	89 c3                	mov    %eax,%ebx
c002a967:	e8 8f 61 ff ff       	call   c0020afb <thread_name>
c002a96c:	83 c4 0c             	add    $0xc,%esp
c002a96f:	53                   	push   %ebx
c002a970:	50                   	push   %eax
c002a971:	68 f4 f6 02 c0       	push   $0xc002f6f4
c002a976:	e8 9e e7 ff ff       	call   c0029119 <msg>
}
c002a97b:	81 c4 2c 01 00 00    	add    $0x12c,%esp
c002a981:	5b                   	pop    %ebx
c002a982:	5e                   	pop    %esi
c002a983:	5f                   	pop    %edi
c002a984:	5d                   	pop    %ebp
c002a985:	c3                   	ret    

c002a986 <test_mlfqs_load_1>:
#include "threads/thread.h"
#include "devices/timer.h"

void
test_mlfqs_load_1 (void) 
{
c002a986:	55                   	push   %ebp
c002a987:	57                   	push   %edi
c002a988:	56                   	push   %esi
c002a989:	53                   	push   %ebx
c002a98a:	83 ec 0c             	sub    $0xc,%esp
  int64_t start_time;
  int elapsed;
  int load_avg;
  
  ASSERT (thread_mlfqs);
c002a98d:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002a994:	74 1b                	je     c002a9b1 <test_mlfqs_load_1+0x2b>

  msg ("spinning for up to 45 seconds, please wait...");
c002a996:	83 ec 0c             	sub    $0xc,%esp
c002a999:	68 c0 f7 02 c0       	push   $0xc002f7c0
c002a99e:	e8 76 e7 ff ff       	call   c0029119 <msg>

  start_time = timer_ticks ();
c002a9a3:	e8 d2 88 ff ff       	call   c002327a <timer_ticks>
c002a9a8:	89 c6                	mov    %eax,%esi
c002a9aa:	89 d7                	mov    %edx,%edi
c002a9ac:	83 c4 10             	add    $0x10,%esp
c002a9af:	eb 6a                	jmp    c002aa1b <test_mlfqs_load_1+0x95>
  ASSERT (thread_mlfqs);
c002a9b1:	83 ec 0c             	sub    $0xc,%esp
c002a9b4:	68 ad ea 02 c0       	push   $0xc002eaad
c002a9b9:	68 df cb 02 c0       	push   $0xc002cbdf
c002a9be:	68 00 cb 02 c0       	push   $0xc002cb00
c002a9c3:	6a 18                	push   $0x18
c002a9c5:	68 9c f7 02 c0       	push   $0xc002f79c
c002a9ca:	e8 71 cc ff ff       	call   c0027640 <debug_panic>
  for (;;) 
    {
      load_avg = thread_get_load_avg ();
      ASSERT (load_avg >= 0);
c002a9cf:	83 ec 0c             	sub    $0xc,%esp
c002a9d2:	68 72 f7 02 c0       	push   $0xc002f772
c002a9d7:	68 df cb 02 c0       	push   $0xc002cbdf
c002a9dc:	68 00 cb 02 c0       	push   $0xc002cb00
c002a9e1:	6a 20                	push   $0x20
c002a9e3:	68 9c f7 02 c0       	push   $0xc002f79c
c002a9e8:	e8 53 cc ff ff       	call   c0027640 <debug_panic>
      elapsed = timer_elapsed (start_time) / TIMER_FREQ;
      if (load_avg > 100)
        fail ("load average is %d.%02d "
c002a9ed:	50                   	push   %eax
c002a9ee:	b8 1f 85 eb 51       	mov    $0x51eb851f,%eax
c002a9f3:	f7 eb                	imul   %ebx
c002a9f5:	89 d0                	mov    %edx,%eax
c002a9f7:	c1 f8 05             	sar    $0x5,%eax
c002a9fa:	89 da                	mov    %ebx,%edx
c002a9fc:	c1 fa 1f             	sar    $0x1f,%edx
c002a9ff:	29 d0                	sub    %edx,%eax
c002aa01:	8d 14 80             	lea    (%eax,%eax,4),%edx
c002aa04:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002aa07:	c1 e2 02             	shl    $0x2,%edx
c002aa0a:	29 d3                	sub    %edx,%ebx
c002aa0c:	53                   	push   %ebx
c002aa0d:	50                   	push   %eax
c002aa0e:	68 f0 f7 02 c0       	push   $0xc002f7f0
c002aa13:	e8 a5 e7 ff ff       	call   c00291bd <fail>
c002aa18:	83 c4 10             	add    $0x10,%esp
      load_avg = thread_get_load_avg ();
c002aa1b:	e8 99 61 ff ff       	call   c0020bb9 <thread_get_load_avg>
c002aa20:	89 c3                	mov    %eax,%ebx
      ASSERT (load_avg >= 0);
c002aa22:	85 c0                	test   %eax,%eax
c002aa24:	78 a9                	js     c002a9cf <test_mlfqs_load_1+0x49>
      elapsed = timer_elapsed (start_time) / TIMER_FREQ;
c002aa26:	83 ec 08             	sub    $0x8,%esp
c002aa29:	57                   	push   %edi
c002aa2a:	56                   	push   %esi
c002aa2b:	e8 73 88 ff ff       	call   c00232a3 <timer_elapsed>
c002aa30:	6a 00                	push   $0x0
c002aa32:	6a 64                	push   $0x64
c002aa34:	52                   	push   %edx
c002aa35:	50                   	push   %eax
c002aa36:	e8 1f c6 ff ff       	call   c002705a <__divdi3>
c002aa3b:	89 c5                	mov    %eax,%ebp
      if (load_avg > 100)
c002aa3d:	83 c4 20             	add    $0x20,%esp
c002aa40:	83 fb 64             	cmp    $0x64,%ebx
c002aa43:	7f a8                	jg     c002a9ed <test_mlfqs_load_1+0x67>
              "but should be between 0 and 1 (after %d seconds)",
              load_avg / 100, load_avg % 100, elapsed);
      else if (load_avg > 50)
c002aa45:	83 fb 32             	cmp    $0x32,%ebx
c002aa48:	7f 17                	jg     c002aa61 <test_mlfqs_load_1+0xdb>
        break;
      else if (elapsed > 45)
c002aa4a:	83 f8 2d             	cmp    $0x2d,%eax
c002aa4d:	7e cc                	jle    c002aa1b <test_mlfqs_load_1+0x95>
        fail ("load average stayed below 0.5 for more than 45 seconds");
c002aa4f:	83 ec 0c             	sub    $0xc,%esp
c002aa52:	68 3c f8 02 c0       	push   $0xc002f83c
c002aa57:	e8 61 e7 ff ff       	call   c00291bd <fail>
c002aa5c:	83 c4 10             	add    $0x10,%esp
c002aa5f:	eb ba                	jmp    c002aa1b <test_mlfqs_load_1+0x95>
    }

  if (elapsed < 38)
c002aa61:	83 f8 25             	cmp    $0x25,%eax
c002aa64:	7e 76                	jle    c002aadc <test_mlfqs_load_1+0x156>
    fail ("load average took only %d seconds to rise above 0.5", elapsed);
  msg ("load average rose to 0.5 after %d seconds", elapsed);
c002aa66:	83 ec 08             	sub    $0x8,%esp
c002aa69:	55                   	push   %ebp
c002aa6a:	68 a8 f8 02 c0       	push   $0xc002f8a8
c002aa6f:	e8 a5 e6 ff ff       	call   c0029119 <msg>

  msg ("sleeping for another 10 seconds, please wait...");
c002aa74:	c7 04 24 d4 f8 02 c0 	movl   $0xc002f8d4,(%esp)
c002aa7b:	e8 99 e6 ff ff       	call   c0029119 <msg>
  timer_sleep (TIMER_FREQ * 10);
c002aa80:	83 c4 08             	add    $0x8,%esp
c002aa83:	6a 00                	push   $0x0
c002aa85:	68 e8 03 00 00       	push   $0x3e8
c002aa8a:	e8 30 88 ff ff       	call   c00232bf <timer_sleep>

  load_avg = thread_get_load_avg ();
c002aa8f:	e8 25 61 ff ff       	call   c0020bb9 <thread_get_load_avg>
c002aa94:	89 c3                	mov    %eax,%ebx
  if (load_avg < 0)
c002aa96:	83 c4 10             	add    $0x10,%esp
c002aa99:	85 c0                	test   %eax,%eax
c002aa9b:	78 55                	js     c002aaf2 <test_mlfqs_load_1+0x16c>
    fail ("load average fell below 0");
  if (load_avg > 50)
c002aa9d:	83 fb 32             	cmp    $0x32,%ebx
c002aaa0:	7f 62                	jg     c002ab04 <test_mlfqs_load_1+0x17e>
    fail ("load average stayed above 0.5 for more than 10 seconds");
  msg ("load average fell back below 0.5 (to %d.%02d)",
c002aaa2:	83 ec 04             	sub    $0x4,%esp
c002aaa5:	b8 1f 85 eb 51       	mov    $0x51eb851f,%eax
c002aaaa:	f7 eb                	imul   %ebx
c002aaac:	89 d0                	mov    %edx,%eax
c002aaae:	c1 f8 05             	sar    $0x5,%eax
c002aab1:	89 da                	mov    %ebx,%edx
c002aab3:	c1 fa 1f             	sar    $0x1f,%edx
c002aab6:	29 d0                	sub    %edx,%eax
c002aab8:	8d 14 80             	lea    (%eax,%eax,4),%edx
c002aabb:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002aabe:	c1 e2 02             	shl    $0x2,%edx
c002aac1:	29 d3                	sub    %edx,%ebx
c002aac3:	53                   	push   %ebx
c002aac4:	50                   	push   %eax
c002aac5:	68 3c f9 02 c0       	push   $0xc002f93c
c002aaca:	e8 4a e6 ff ff       	call   c0029119 <msg>
       load_avg / 100, load_avg % 100);

  pass ();
c002aacf:	e8 2f e7 ff ff       	call   c0029203 <pass>
}
c002aad4:	83 c4 1c             	add    $0x1c,%esp
c002aad7:	5b                   	pop    %ebx
c002aad8:	5e                   	pop    %esi
c002aad9:	5f                   	pop    %edi
c002aada:	5d                   	pop    %ebp
c002aadb:	c3                   	ret    
    fail ("load average took only %d seconds to rise above 0.5", elapsed);
c002aadc:	83 ec 08             	sub    $0x8,%esp
c002aadf:	50                   	push   %eax
c002aae0:	68 74 f8 02 c0       	push   $0xc002f874
c002aae5:	e8 d3 e6 ff ff       	call   c00291bd <fail>
c002aaea:	83 c4 10             	add    $0x10,%esp
c002aaed:	e9 74 ff ff ff       	jmp    c002aa66 <test_mlfqs_load_1+0xe0>
    fail ("load average fell below 0");
c002aaf2:	83 ec 0c             	sub    $0xc,%esp
c002aaf5:	68 80 f7 02 c0       	push   $0xc002f780
c002aafa:	e8 be e6 ff ff       	call   c00291bd <fail>
c002aaff:	83 c4 10             	add    $0x10,%esp
c002ab02:	eb 99                	jmp    c002aa9d <test_mlfqs_load_1+0x117>
    fail ("load average stayed above 0.5 for more than 10 seconds");
c002ab04:	83 ec 0c             	sub    $0xc,%esp
c002ab07:	68 04 f9 02 c0       	push   $0xc002f904
c002ab0c:	e8 ac e6 ff ff       	call   c00291bd <fail>
c002ab11:	83 c4 10             	add    $0x10,%esp
c002ab14:	eb 8c                	jmp    c002aaa2 <test_mlfqs_load_1+0x11c>

c002ab16 <load_thread>:
    }
}

static void
load_thread (void *aux UNUSED) 
{
c002ab16:	53                   	push   %ebx
c002ab17:	83 ec 14             	sub    $0x14,%esp
  int64_t sleep_time = 10 * TIMER_FREQ;
  int64_t spin_time = sleep_time + 60 * TIMER_FREQ;
  int64_t exit_time = spin_time + 60 * TIMER_FREQ;

  thread_set_nice (20);
c002ab1a:	6a 14                	push   $0x14
c002ab1c:	e8 91 60 ff ff       	call   c0020bb2 <thread_set_nice>
  timer_sleep (sleep_time - timer_elapsed (start_time));
c002ab21:	83 c4 08             	add    $0x8,%esp
c002ab24:	ff 35 5c 83 03 c0    	pushl  0xc003835c
c002ab2a:	ff 35 58 83 03 c0    	pushl  0xc0038358
c002ab30:	e8 6e 87 ff ff       	call   c00232a3 <timer_elapsed>
c002ab35:	83 c4 08             	add    $0x8,%esp
c002ab38:	b9 e8 03 00 00       	mov    $0x3e8,%ecx
c002ab3d:	bb 00 00 00 00       	mov    $0x0,%ebx
c002ab42:	29 c1                	sub    %eax,%ecx
c002ab44:	19 d3                	sbb    %edx,%ebx
c002ab46:	53                   	push   %ebx
c002ab47:	51                   	push   %ecx
c002ab48:	e8 72 87 ff ff       	call   c00232bf <timer_sleep>
  while (timer_elapsed (start_time) < spin_time)
c002ab4d:	83 c4 10             	add    $0x10,%esp
c002ab50:	83 ec 08             	sub    $0x8,%esp
c002ab53:	ff 35 5c 83 03 c0    	pushl  0xc003835c
c002ab59:	ff 35 58 83 03 c0    	pushl  0xc0038358
c002ab5f:	e8 3f 87 ff ff       	call   c00232a3 <timer_elapsed>
c002ab64:	83 c4 10             	add    $0x10,%esp
c002ab67:	85 d2                	test   %edx,%edx
c002ab69:	78 e5                	js     c002ab50 <load_thread+0x3a>
c002ab6b:	85 d2                	test   %edx,%edx
c002ab6d:	7e 31                	jle    c002aba0 <load_thread+0x8a>
    continue;
  timer_sleep (exit_time - timer_elapsed (start_time));
c002ab6f:	83 ec 08             	sub    $0x8,%esp
c002ab72:	ff 35 5c 83 03 c0    	pushl  0xc003835c
c002ab78:	ff 35 58 83 03 c0    	pushl  0xc0038358
c002ab7e:	e8 20 87 ff ff       	call   c00232a3 <timer_elapsed>
c002ab83:	83 c4 08             	add    $0x8,%esp
c002ab86:	b9 c8 32 00 00       	mov    $0x32c8,%ecx
c002ab8b:	bb 00 00 00 00       	mov    $0x0,%ebx
c002ab90:	29 c1                	sub    %eax,%ecx
c002ab92:	19 d3                	sbb    %edx,%ebx
c002ab94:	53                   	push   %ebx
c002ab95:	51                   	push   %ecx
c002ab96:	e8 24 87 ff ff       	call   c00232bf <timer_sleep>
}
c002ab9b:	83 c4 18             	add    $0x18,%esp
c002ab9e:	5b                   	pop    %ebx
c002ab9f:	c3                   	ret    
  while (timer_elapsed (start_time) < spin_time)
c002aba0:	3d 57 1b 00 00       	cmp    $0x1b57,%eax
c002aba5:	76 a9                	jbe    c002ab50 <load_thread+0x3a>
c002aba7:	eb c6                	jmp    c002ab6f <load_thread+0x59>

c002aba9 <test_mlfqs_load_60>:
{
c002aba9:	55                   	push   %ebp
c002abaa:	57                   	push   %edi
c002abab:	56                   	push   %esi
c002abac:	53                   	push   %ebx
c002abad:	83 ec 2c             	sub    $0x2c,%esp
  ASSERT (thread_mlfqs);
c002abb0:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002abb7:	0f 84 2c 01 00 00    	je     c002ace9 <test_mlfqs_load_60+0x140>
  start_time = timer_ticks ();
c002abbd:	e8 b8 86 ff ff       	call   c002327a <timer_ticks>
c002abc2:	a3 58 83 03 c0       	mov    %eax,0xc0038358
c002abc7:	89 15 5c 83 03 c0    	mov    %edx,0xc003835c
  msg ("Starting %d niced load threads...", THREAD_CNT);
c002abcd:	83 ec 08             	sub    $0x8,%esp
c002abd0:	6a 3c                	push   $0x3c
c002abd2:	68 98 f9 02 c0       	push   $0xc002f998
c002abd7:	e8 3d e5 ff ff       	call   c0029119 <msg>
c002abdc:	83 c4 10             	add    $0x10,%esp
  for (i = 0; i < THREAD_CNT; i++) 
c002abdf:	bb 00 00 00 00       	mov    $0x0,%ebx
      snprintf(name, sizeof name, "load %d", i);
c002abe4:	8d 74 24 10          	lea    0x10(%esp),%esi
c002abe8:	53                   	push   %ebx
c002abe9:	68 6a f9 02 c0       	push   $0xc002f96a
c002abee:	6a 10                	push   $0x10
c002abf0:	56                   	push   %esi
c002abf1:	e8 28 b7 ff ff       	call   c002631e <snprintf>
      thread_create (name, PRI_DEFAULT, load_thread, NULL);
c002abf6:	6a 00                	push   $0x0
c002abf8:	68 16 ab 02 c0       	push   $0xc002ab16
c002abfd:	6a 1f                	push   $0x1f
c002abff:	56                   	push   %esi
c002ac00:	e8 37 5d ff ff       	call   c002093c <thread_create>
  for (i = 0; i < THREAD_CNT; i++) 
c002ac05:	43                   	inc    %ebx
c002ac06:	83 c4 20             	add    $0x20,%esp
c002ac09:	83 fb 3c             	cmp    $0x3c,%ebx
c002ac0c:	75 da                	jne    c002abe8 <test_mlfqs_load_60+0x3f>
       timer_elapsed (start_time) / TIMER_FREQ);
c002ac0e:	83 ec 08             	sub    $0x8,%esp
c002ac11:	ff 35 5c 83 03 c0    	pushl  0xc003835c
c002ac17:	ff 35 58 83 03 c0    	pushl  0xc0038358
c002ac1d:	e8 81 86 ff ff       	call   c00232a3 <timer_elapsed>
  msg ("Starting threads took %d seconds.",
c002ac22:	6a 00                	push   $0x0
c002ac24:	6a 64                	push   $0x64
c002ac26:	52                   	push   %edx
c002ac27:	50                   	push   %eax
c002ac28:	e8 2d c4 ff ff       	call   c002705a <__divdi3>
c002ac2d:	83 c4 1c             	add    $0x1c,%esp
c002ac30:	52                   	push   %edx
c002ac31:	50                   	push   %eax
c002ac32:	68 bc f9 02 c0       	push   $0xc002f9bc
c002ac37:	e8 dd e4 ff ff       	call   c0029119 <msg>
c002ac3c:	83 c4 10             	add    $0x10,%esp
c002ac3f:	bb 00 00 00 00       	mov    $0x0,%ebx
c002ac44:	be e8 03 00 00       	mov    $0x3e8,%esi
c002ac49:	bf 00 00 00 00       	mov    $0x0,%edi
      msg ("After %d seconds, load average=%d.%02d.",
c002ac4e:	bd 1f 85 eb 51       	mov    $0x51eb851f,%ebp
c002ac53:	89 5c 24 04          	mov    %ebx,0x4(%esp)
      int64_t sleep_until = start_time + TIMER_FREQ * (2 * i + 10);
c002ac57:	89 f0                	mov    %esi,%eax
c002ac59:	89 fa                	mov    %edi,%edx
c002ac5b:	03 05 58 83 03 c0    	add    0xc0038358,%eax
c002ac61:	13 15 5c 83 03 c0    	adc    0xc003835c,%edx
c002ac67:	89 44 24 08          	mov    %eax,0x8(%esp)
c002ac6b:	89 54 24 0c          	mov    %edx,0xc(%esp)
      timer_sleep (sleep_until - timer_ticks ());
c002ac6f:	e8 06 86 ff ff       	call   c002327a <timer_ticks>
c002ac74:	83 ec 08             	sub    $0x8,%esp
c002ac77:	8b 4c 24 10          	mov    0x10(%esp),%ecx
c002ac7b:	8b 5c 24 14          	mov    0x14(%esp),%ebx
c002ac7f:	29 c1                	sub    %eax,%ecx
c002ac81:	19 d3                	sbb    %edx,%ebx
c002ac83:	53                   	push   %ebx
c002ac84:	51                   	push   %ecx
c002ac85:	e8 35 86 ff ff       	call   c00232bf <timer_sleep>
      load_avg = thread_get_load_avg ();
c002ac8a:	e8 2a 5f ff ff       	call   c0020bb9 <thread_get_load_avg>
c002ac8f:	89 c1                	mov    %eax,%ecx
      msg ("After %d seconds, load average=%d.%02d.",
c002ac91:	f7 ed                	imul   %ebp
c002ac93:	89 d0                	mov    %edx,%eax
c002ac95:	c1 f8 05             	sar    $0x5,%eax
c002ac98:	89 ca                	mov    %ecx,%edx
c002ac9a:	c1 fa 1f             	sar    $0x1f,%edx
c002ac9d:	29 d0                	sub    %edx,%eax
c002ac9f:	8d 14 80             	lea    (%eax,%eax,4),%edx
c002aca2:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002aca5:	c1 e2 02             	shl    $0x2,%edx
c002aca8:	29 d1                	sub    %edx,%ecx
c002acaa:	51                   	push   %ecx
c002acab:	50                   	push   %eax
c002acac:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
c002acb0:	53                   	push   %ebx
c002acb1:	68 e0 f9 02 c0       	push   $0xc002f9e0
c002acb6:	e8 5e e4 ff ff       	call   c0029119 <msg>
c002acbb:	81 c6 c8 00 00 00    	add    $0xc8,%esi
c002acc1:	83 d7 00             	adc    $0x0,%edi
c002acc4:	89 d8                	mov    %ebx,%eax
c002acc6:	83 c0 02             	add    $0x2,%eax
c002acc9:	89 44 24 24          	mov    %eax,0x24(%esp)
  for (i = 0; i < 90; i++) 
c002accd:	83 c4 20             	add    $0x20,%esp
c002acd0:	89 f0                	mov    %esi,%eax
c002acd2:	35 38 4a 00 00       	xor    $0x4a38,%eax
c002acd7:	89 fa                	mov    %edi,%edx
c002acd9:	09 c2                	or     %eax,%edx
c002acdb:	0f 85 76 ff ff ff    	jne    c002ac57 <test_mlfqs_load_60+0xae>
}
c002ace1:	83 c4 2c             	add    $0x2c,%esp
c002ace4:	5b                   	pop    %ebx
c002ace5:	5e                   	pop    %esi
c002ace6:	5f                   	pop    %edi
c002ace7:	5d                   	pop    %ebp
c002ace8:	c3                   	ret    
  ASSERT (thread_mlfqs);
c002ace9:	83 ec 0c             	sub    $0xc,%esp
c002acec:	68 ad ea 02 c0       	push   $0xc002eaad
c002acf1:	68 df cb 02 c0       	push   $0xc002cbdf
c002acf6:	68 14 cb 02 c0       	push   $0xc002cb14
c002acfb:	6a 77                	push   $0x77
c002acfd:	68 74 f9 02 c0       	push   $0xc002f974
c002ad02:	e8 39 c9 ff ff       	call   c0027640 <debug_panic>

c002ad07 <load_thread>:
    }
}

static void
load_thread (void *seq_no_) 
{
c002ad07:	57                   	push   %edi
c002ad08:	56                   	push   %esi
c002ad09:	53                   	push   %ebx
c002ad0a:	8b 44 24 10          	mov    0x10(%esp),%eax
  int seq_no = (int) seq_no_;
  int sleep_time = TIMER_FREQ * (10 + seq_no);
c002ad0e:	8d 44 80 32          	lea    0x32(%eax,%eax,4),%eax
c002ad12:	8d 34 80             	lea    (%eax,%eax,4),%esi
c002ad15:	c1 e6 02             	shl    $0x2,%esi
  int spin_time = sleep_time + TIMER_FREQ * THREAD_CNT;
c002ad18:	8d 9e 70 17 00 00    	lea    0x1770(%esi),%ebx
  int exit_time = TIMER_FREQ * (THREAD_CNT * 2);

  timer_sleep (sleep_time - timer_elapsed (start_time));
c002ad1e:	83 ec 08             	sub    $0x8,%esp
c002ad21:	ff 35 64 83 03 c0    	pushl  0xc0038364
c002ad27:	ff 35 60 83 03 c0    	pushl  0xc0038360
c002ad2d:	e8 71 85 ff ff       	call   c00232a3 <timer_elapsed>
c002ad32:	83 c4 08             	add    $0x8,%esp
c002ad35:	89 f7                	mov    %esi,%edi
c002ad37:	c1 ff 1f             	sar    $0x1f,%edi
c002ad3a:	29 c6                	sub    %eax,%esi
c002ad3c:	19 d7                	sbb    %edx,%edi
c002ad3e:	57                   	push   %edi
c002ad3f:	56                   	push   %esi
c002ad40:	e8 7a 85 ff ff       	call   c00232bf <timer_sleep>
  while (timer_elapsed (start_time) < spin_time)
c002ad45:	83 c4 10             	add    $0x10,%esp
c002ad48:	89 df                	mov    %ebx,%edi
c002ad4a:	c1 ff 1f             	sar    $0x1f,%edi
c002ad4d:	83 ec 08             	sub    $0x8,%esp
c002ad50:	ff 35 64 83 03 c0    	pushl  0xc0038364
c002ad56:	ff 35 60 83 03 c0    	pushl  0xc0038360
c002ad5c:	e8 42 85 ff ff       	call   c00232a3 <timer_elapsed>
c002ad61:	83 c4 10             	add    $0x10,%esp
c002ad64:	39 fa                	cmp    %edi,%edx
c002ad66:	7c e5                	jl     c002ad4d <load_thread+0x46>
c002ad68:	7f 04                	jg     c002ad6e <load_thread+0x67>
c002ad6a:	39 d8                	cmp    %ebx,%eax
c002ad6c:	72 df                	jb     c002ad4d <load_thread+0x46>
    continue;
  timer_sleep (exit_time - timer_elapsed (start_time));
c002ad6e:	83 ec 08             	sub    $0x8,%esp
c002ad71:	ff 35 64 83 03 c0    	pushl  0xc0038364
c002ad77:	ff 35 60 83 03 c0    	pushl  0xc0038360
c002ad7d:	e8 21 85 ff ff       	call   c00232a3 <timer_elapsed>
c002ad82:	83 c4 08             	add    $0x8,%esp
c002ad85:	b9 e0 2e 00 00       	mov    $0x2ee0,%ecx
c002ad8a:	bb 00 00 00 00       	mov    $0x0,%ebx
c002ad8f:	29 c1                	sub    %eax,%ecx
c002ad91:	19 d3                	sbb    %edx,%ebx
c002ad93:	53                   	push   %ebx
c002ad94:	51                   	push   %ecx
c002ad95:	e8 25 85 ff ff       	call   c00232bf <timer_sleep>
}
c002ad9a:	83 c4 10             	add    $0x10,%esp
c002ad9d:	5b                   	pop    %ebx
c002ad9e:	5e                   	pop    %esi
c002ad9f:	5f                   	pop    %edi
c002ada0:	c3                   	ret    

c002ada1 <test_mlfqs_load_avg>:
{
c002ada1:	55                   	push   %ebp
c002ada2:	57                   	push   %edi
c002ada3:	56                   	push   %esi
c002ada4:	53                   	push   %ebx
c002ada5:	83 ec 2c             	sub    $0x2c,%esp
  ASSERT (thread_mlfqs);
c002ada8:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002adaf:	0f 84 37 01 00 00    	je     c002aeec <test_mlfqs_load_avg+0x14b>
  start_time = timer_ticks ();
c002adb5:	e8 c0 84 ff ff       	call   c002327a <timer_ticks>
c002adba:	a3 60 83 03 c0       	mov    %eax,0xc0038360
c002adbf:	89 15 64 83 03 c0    	mov    %edx,0xc0038364
  msg ("Starting %d load threads...", THREAD_CNT);
c002adc5:	83 ec 08             	sub    $0x8,%esp
c002adc8:	6a 3c                	push   $0x3c
c002adca:	68 08 fa 02 c0       	push   $0xc002fa08
c002adcf:	e8 45 e3 ff ff       	call   c0029119 <msg>
c002add4:	83 c4 10             	add    $0x10,%esp
  for (i = 0; i < THREAD_CNT; i++) 
c002add7:	bb 00 00 00 00       	mov    $0x0,%ebx
      snprintf(name, sizeof name, "load %d", i);
c002addc:	8d 74 24 10          	lea    0x10(%esp),%esi
c002ade0:	53                   	push   %ebx
c002ade1:	68 6a f9 02 c0       	push   $0xc002f96a
c002ade6:	6a 10                	push   $0x10
c002ade8:	56                   	push   %esi
c002ade9:	e8 30 b5 ff ff       	call   c002631e <snprintf>
      thread_create (name, PRI_DEFAULT, load_thread, (void *) i);
c002adee:	53                   	push   %ebx
c002adef:	68 07 ad 02 c0       	push   $0xc002ad07
c002adf4:	6a 1f                	push   $0x1f
c002adf6:	56                   	push   %esi
c002adf7:	e8 40 5b ff ff       	call   c002093c <thread_create>
  for (i = 0; i < THREAD_CNT; i++) 
c002adfc:	43                   	inc    %ebx
c002adfd:	83 c4 20             	add    $0x20,%esp
c002ae00:	83 fb 3c             	cmp    $0x3c,%ebx
c002ae03:	75 db                	jne    c002ade0 <test_mlfqs_load_avg+0x3f>
       timer_elapsed (start_time) / TIMER_FREQ);
c002ae05:	83 ec 08             	sub    $0x8,%esp
c002ae08:	ff 35 64 83 03 c0    	pushl  0xc0038364
c002ae0e:	ff 35 60 83 03 c0    	pushl  0xc0038360
c002ae14:	e8 8a 84 ff ff       	call   c00232a3 <timer_elapsed>
  msg ("Starting threads took %d seconds.",
c002ae19:	6a 00                	push   $0x0
c002ae1b:	6a 64                	push   $0x64
c002ae1d:	52                   	push   %edx
c002ae1e:	50                   	push   %eax
c002ae1f:	e8 36 c2 ff ff       	call   c002705a <__divdi3>
c002ae24:	83 c4 1c             	add    $0x1c,%esp
c002ae27:	52                   	push   %edx
c002ae28:	50                   	push   %eax
c002ae29:	68 bc f9 02 c0       	push   $0xc002f9bc
c002ae2e:	e8 e6 e2 ff ff       	call   c0029119 <msg>
  thread_set_nice (-20);
c002ae33:	c7 04 24 ec ff ff ff 	movl   $0xffffffec,(%esp)
c002ae3a:	e8 73 5d ff ff       	call   c0020bb2 <thread_set_nice>
c002ae3f:	83 c4 10             	add    $0x10,%esp
c002ae42:	bb 00 00 00 00       	mov    $0x0,%ebx
c002ae47:	be e8 03 00 00       	mov    $0x3e8,%esi
c002ae4c:	bf 00 00 00 00       	mov    $0x0,%edi
      msg ("After %d seconds, load average=%d.%02d.",
c002ae51:	bd 1f 85 eb 51       	mov    $0x51eb851f,%ebp
c002ae56:	89 5c 24 04          	mov    %ebx,0x4(%esp)
      int64_t sleep_until = start_time + TIMER_FREQ * (2 * i + 10);
c002ae5a:	89 f0                	mov    %esi,%eax
c002ae5c:	89 fa                	mov    %edi,%edx
c002ae5e:	03 05 60 83 03 c0    	add    0xc0038360,%eax
c002ae64:	13 15 64 83 03 c0    	adc    0xc0038364,%edx
c002ae6a:	89 44 24 08          	mov    %eax,0x8(%esp)
c002ae6e:	89 54 24 0c          	mov    %edx,0xc(%esp)
      timer_sleep (sleep_until - timer_ticks ());
c002ae72:	e8 03 84 ff ff       	call   c002327a <timer_ticks>
c002ae77:	83 ec 08             	sub    $0x8,%esp
c002ae7a:	8b 4c 24 10          	mov    0x10(%esp),%ecx
c002ae7e:	8b 5c 24 14          	mov    0x14(%esp),%ebx
c002ae82:	29 c1                	sub    %eax,%ecx
c002ae84:	19 d3                	sbb    %edx,%ebx
c002ae86:	53                   	push   %ebx
c002ae87:	51                   	push   %ecx
c002ae88:	e8 32 84 ff ff       	call   c00232bf <timer_sleep>
      load_avg = thread_get_load_avg ();
c002ae8d:	e8 27 5d ff ff       	call   c0020bb9 <thread_get_load_avg>
c002ae92:	89 c1                	mov    %eax,%ecx
      msg ("After %d seconds, load average=%d.%02d.",
c002ae94:	f7 ed                	imul   %ebp
c002ae96:	89 d0                	mov    %edx,%eax
c002ae98:	c1 f8 05             	sar    $0x5,%eax
c002ae9b:	89 ca                	mov    %ecx,%edx
c002ae9d:	c1 fa 1f             	sar    $0x1f,%edx
c002aea0:	29 d0                	sub    %edx,%eax
c002aea2:	8d 14 80             	lea    (%eax,%eax,4),%edx
c002aea5:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002aea8:	c1 e2 02             	shl    $0x2,%edx
c002aeab:	29 d1                	sub    %edx,%ecx
c002aead:	51                   	push   %ecx
c002aeae:	50                   	push   %eax
c002aeaf:	8b 5c 24 1c          	mov    0x1c(%esp),%ebx
c002aeb3:	53                   	push   %ebx
c002aeb4:	68 e0 f9 02 c0       	push   $0xc002f9e0
c002aeb9:	e8 5b e2 ff ff       	call   c0029119 <msg>
c002aebe:	81 c6 c8 00 00 00    	add    $0xc8,%esi
c002aec4:	83 d7 00             	adc    $0x0,%edi
c002aec7:	89 d8                	mov    %ebx,%eax
c002aec9:	83 c0 02             	add    $0x2,%eax
c002aecc:	89 44 24 24          	mov    %eax,0x24(%esp)
  for (i = 0; i < 90; i++) 
c002aed0:	83 c4 20             	add    $0x20,%esp
c002aed3:	89 f0                	mov    %esi,%eax
c002aed5:	35 38 4a 00 00       	xor    $0x4a38,%eax
c002aeda:	89 fa                	mov    %edi,%edx
c002aedc:	09 c2                	or     %eax,%edx
c002aede:	0f 85 76 ff ff ff    	jne    c002ae5a <test_mlfqs_load_avg+0xb9>
}
c002aee4:	83 c4 2c             	add    $0x2c,%esp
c002aee7:	5b                   	pop    %ebx
c002aee8:	5e                   	pop    %esi
c002aee9:	5f                   	pop    %edi
c002aeea:	5d                   	pop    %ebp
c002aeeb:	c3                   	ret    
  ASSERT (thread_mlfqs);
c002aeec:	83 ec 0c             	sub    $0xc,%esp
c002aeef:	68 ad ea 02 c0       	push   $0xc002eaad
c002aef4:	68 df cb 02 c0       	push   $0xc002cbdf
c002aef9:	68 28 cb 02 c0       	push   $0xc002cb28
c002aefe:	68 82 00 00 00       	push   $0x82
c002af03:	68 24 fa 02 c0       	push   $0xc002fa24
c002af08:	e8 33 c7 ff ff       	call   c0027640 <debug_panic>

c002af0d <test_mlfqs_recent_1>:
/* Sensitive to assumption that recent_cpu updates happen exactly
   when timer_ticks() % TIMER_FREQ == 0. */

void
test_mlfqs_recent_1 (void) 
{
c002af0d:	55                   	push   %ebp
c002af0e:	57                   	push   %edi
c002af0f:	56                   	push   %esi
c002af10:	53                   	push   %ebx
c002af11:	83 ec 1c             	sub    $0x1c,%esp
  int64_t start_time;
  int last_elapsed = 0;
  
  ASSERT (thread_mlfqs);
c002af14:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002af1b:	74 5c                	je     c002af79 <test_mlfqs_recent_1+0x6c>

  do 
    {
      msg ("Sleeping 10 seconds to allow recent_cpu to decay, please wait...");
c002af1d:	83 ec 0c             	sub    $0xc,%esp
c002af20:	68 74 fa 02 c0       	push   $0xc002fa74
c002af25:	e8 ef e1 ff ff       	call   c0029119 <msg>
      start_time = timer_ticks ();
c002af2a:	e8 4b 83 ff ff       	call   c002327a <timer_ticks>
c002af2f:	89 c6                	mov    %eax,%esi
c002af31:	89 d7                	mov    %edx,%edi
      timer_sleep (DIV_ROUND_UP (start_time, TIMER_FREQ) - start_time
c002af33:	83 c0 63             	add    $0x63,%eax
c002af36:	83 d2 00             	adc    $0x0,%edx
c002af39:	6a 00                	push   $0x0
c002af3b:	6a 64                	push   $0x64
c002af3d:	52                   	push   %edx
c002af3e:	50                   	push   %eax
c002af3f:	e8 16 c1 ff ff       	call   c002705a <__divdi3>
c002af44:	83 c4 18             	add    $0x18,%esp
c002af47:	29 f0                	sub    %esi,%eax
c002af49:	19 fa                	sbb    %edi,%edx
c002af4b:	05 e8 03 00 00       	add    $0x3e8,%eax
c002af50:	83 d2 00             	adc    $0x0,%edx
c002af53:	52                   	push   %edx
c002af54:	50                   	push   %eax
c002af55:	e8 65 83 ff ff       	call   c00232bf <timer_sleep>
                   + 10 * TIMER_FREQ);
    }
  while (thread_get_recent_cpu () > 700);
c002af5a:	e8 60 5c ff ff       	call   c0020bbf <thread_get_recent_cpu>
c002af5f:	83 c4 10             	add    $0x10,%esp
c002af62:	3d bc 02 00 00       	cmp    $0x2bc,%eax
c002af67:	7f b4                	jg     c002af1d <test_mlfqs_recent_1+0x10>

  start_time = timer_ticks ();
c002af69:	e8 0c 83 ff ff       	call   c002327a <timer_ticks>
c002af6e:	89 c6                	mov    %eax,%esi
c002af70:	89 d7                	mov    %edx,%edi
  int last_elapsed = 0;
c002af72:	bd 00 00 00 00       	mov    $0x0,%ebp
c002af77:	eb 20                	jmp    c002af99 <test_mlfqs_recent_1+0x8c>
  ASSERT (thread_mlfqs);
c002af79:	83 ec 0c             	sub    $0xc,%esp
c002af7c:	68 ad ea 02 c0       	push   $0xc002eaad
c002af81:	68 df cb 02 c0       	push   $0xc002cbdf
c002af86:	68 3c cb 02 c0       	push   $0xc002cb3c
c002af8b:	6a 73                	push   $0x73
c002af8d:	68 4c fa 02 c0       	push   $0xc002fa4c
c002af92:	e8 a9 c6 ff ff       	call   c0027640 <debug_panic>
{
c002af97:	89 dd                	mov    %ebx,%ebp
  for (;;) 
    {
      int elapsed = timer_elapsed (start_time);
c002af99:	83 ec 08             	sub    $0x8,%esp
c002af9c:	57                   	push   %edi
c002af9d:	56                   	push   %esi
c002af9e:	e8 00 83 ff ff       	call   c00232a3 <timer_elapsed>
c002afa3:	89 c3                	mov    %eax,%ebx
      if (elapsed % (TIMER_FREQ * 2) == 0 && elapsed > last_elapsed) 
c002afa5:	b9 c8 00 00 00       	mov    $0xc8,%ecx
c002afaa:	99                   	cltd   
c002afab:	f7 f9                	idiv   %ecx
c002afad:	83 c4 10             	add    $0x10,%esp
c002afb0:	85 d2                	test   %edx,%edx
c002afb2:	75 e3                	jne    c002af97 <test_mlfqs_recent_1+0x8a>
c002afb4:	39 dd                	cmp    %ebx,%ebp
c002afb6:	7d df                	jge    c002af97 <test_mlfqs_recent_1+0x8a>
        {
          int recent_cpu = thread_get_recent_cpu ();
c002afb8:	e8 02 5c ff ff       	call   c0020bbf <thread_get_recent_cpu>
c002afbd:	89 44 24 0c          	mov    %eax,0xc(%esp)
          int load_avg = thread_get_load_avg ();
c002afc1:	e8 f3 5b ff ff       	call   c0020bb9 <thread_get_load_avg>
c002afc6:	89 c1                	mov    %eax,%ecx
          int elapsed_seconds = elapsed / TIMER_FREQ;
c002afc8:	b8 1f 85 eb 51       	mov    $0x51eb851f,%eax
c002afcd:	f7 eb                	imul   %ebx
c002afcf:	89 d5                	mov    %edx,%ebp
c002afd1:	c1 fd 05             	sar    $0x5,%ebp
c002afd4:	89 d8                	mov    %ebx,%eax
c002afd6:	c1 f8 1f             	sar    $0x1f,%eax
c002afd9:	29 c5                	sub    %eax,%ebp
          msg ("After %d seconds, recent_cpu is %d.%02d, load_avg is %d.%02d.",
c002afdb:	83 ec 08             	sub    $0x8,%esp
c002afde:	b8 1f 85 eb 51       	mov    $0x51eb851f,%eax
c002afe3:	f7 e9                	imul   %ecx
c002afe5:	89 d0                	mov    %edx,%eax
c002afe7:	c1 f8 05             	sar    $0x5,%eax
c002afea:	89 ca                	mov    %ecx,%edx
c002afec:	c1 fa 1f             	sar    $0x1f,%edx
c002afef:	29 d0                	sub    %edx,%eax
c002aff1:	8d 14 80             	lea    (%eax,%eax,4),%edx
c002aff4:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002aff7:	c1 e2 02             	shl    $0x2,%edx
c002affa:	29 d1                	sub    %edx,%ecx
c002affc:	51                   	push   %ecx
c002affd:	50                   	push   %eax
c002affe:	b8 1f 85 eb 51       	mov    $0x51eb851f,%eax
c002b003:	8b 4c 24 1c          	mov    0x1c(%esp),%ecx
c002b007:	f7 e9                	imul   %ecx
c002b009:	89 d0                	mov    %edx,%eax
c002b00b:	c1 f8 05             	sar    $0x5,%eax
c002b00e:	89 ca                	mov    %ecx,%edx
c002b010:	c1 fa 1f             	sar    $0x1f,%edx
c002b013:	29 d0                	sub    %edx,%eax
c002b015:	8d 14 80             	lea    (%eax,%eax,4),%edx
c002b018:	8d 14 92             	lea    (%edx,%edx,4),%edx
c002b01b:	c1 e2 02             	shl    $0x2,%edx
c002b01e:	29 d1                	sub    %edx,%ecx
c002b020:	51                   	push   %ecx
c002b021:	50                   	push   %eax
c002b022:	55                   	push   %ebp
c002b023:	68 b8 fa 02 c0       	push   $0xc002fab8
c002b028:	e8 ec e0 ff ff       	call   c0029119 <msg>
               elapsed_seconds,
               recent_cpu / 100, recent_cpu % 100,
               load_avg / 100, load_avg % 100);
          if (elapsed_seconds >= 180)
c002b02d:	83 c4 20             	add    $0x20,%esp
c002b030:	81 fd b3 00 00 00    	cmp    $0xb3,%ebp
c002b036:	0f 8e 5b ff ff ff    	jle    c002af97 <test_mlfqs_recent_1+0x8a>
            break;
        } 
      last_elapsed = elapsed;
    }
}
c002b03c:	83 c4 1c             	add    $0x1c,%esp
c002b03f:	5b                   	pop    %ebx
c002b040:	5e                   	pop    %esi
c002b041:	5f                   	pop    %edi
c002b042:	5d                   	pop    %ebp
c002b043:	c3                   	ret    

c002b044 <test_mlfqs_fair>:

static void load_thread (void *aux);

static void
test_mlfqs_fair (int thread_cnt, int nice_min, int nice_step)
{
c002b044:	55                   	push   %ebp
c002b045:	57                   	push   %edi
c002b046:	56                   	push   %esi
c002b047:	53                   	push   %ebx
c002b048:	81 ec 6c 01 00 00    	sub    $0x16c,%esp
c002b04e:	89 44 24 08          	mov    %eax,0x8(%esp)
c002b052:	89 54 24 04          	mov    %edx,0x4(%esp)
c002b056:	89 4c 24 0c          	mov    %ecx,0xc(%esp)
  struct thread_info info[MAX_THREAD_CNT];
  int64_t start_time;
  int nice;
  int i;

  ASSERT (thread_mlfqs);
c002b05a:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002b061:	0f 84 23 01 00 00    	je     c002b18a <test_mlfqs_fair+0x146>
  ASSERT (thread_cnt <= MAX_THREAD_CNT);
c002b067:	83 7c 24 08 14       	cmpl   $0x14,0x8(%esp)
c002b06c:	0f 8f 36 01 00 00    	jg     c002b1a8 <test_mlfqs_fair+0x164>
  ASSERT (nice_min >= -10);
c002b072:	83 7c 24 04 f6       	cmpl   $0xfffffff6,0x4(%esp)
c002b077:	0f 8c 49 01 00 00    	jl     c002b1c6 <test_mlfqs_fair+0x182>
  ASSERT (nice_step >= 0);
c002b07d:	83 7c 24 0c 00       	cmpl   $0x0,0xc(%esp)
c002b082:	0f 88 5c 01 00 00    	js     c002b1e4 <test_mlfqs_fair+0x1a0>
  ASSERT (nice_min + nice_step * (thread_cnt - 1) <= 20);
c002b088:	8b 44 24 08          	mov    0x8(%esp),%eax
c002b08c:	48                   	dec    %eax
c002b08d:	0f af 44 24 0c       	imul   0xc(%esp),%eax
c002b092:	03 44 24 04          	add    0x4(%esp),%eax
c002b096:	83 f8 14             	cmp    $0x14,%eax
c002b099:	0f 8f 63 01 00 00    	jg     c002b202 <test_mlfqs_fair+0x1be>

  thread_set_nice (-20);
c002b09f:	83 ec 0c             	sub    $0xc,%esp
c002b0a2:	6a ec                	push   $0xffffffec
c002b0a4:	e8 09 5b ff ff       	call   c0020bb2 <thread_set_nice>

  start_time = timer_ticks ();
c002b0a9:	e8 cc 81 ff ff       	call   c002327a <timer_ticks>
c002b0ae:	89 c6                	mov    %eax,%esi
c002b0b0:	89 d7                	mov    %edx,%edi
  msg ("Starting %d threads...", thread_cnt);
c002b0b2:	83 c4 08             	add    $0x8,%esp
c002b0b5:	8b 5c 24 10          	mov    0x10(%esp),%ebx
c002b0b9:	53                   	push   %ebx
c002b0ba:	68 32 fb 02 c0       	push   $0xc002fb32
c002b0bf:	e8 55 e0 ff ff       	call   c0029119 <msg>
  nice = nice_min;
  for (i = 0; i < thread_cnt; i++) 
c002b0c4:	83 c4 10             	add    $0x10,%esp
c002b0c7:	85 db                	test   %ebx,%ebx
c002b0c9:	0f 8e 51 01 00 00    	jle    c002b220 <test_mlfqs_fair+0x1dc>
c002b0cf:	8d 5c 24 20          	lea    0x20(%esp),%ebx
c002b0d3:	bd 00 00 00 00       	mov    $0x0,%ebp
    {
      struct thread_info *ti = &info[i];
      char name[16];

      ti->start_time = start_time;
c002b0d8:	89 33                	mov    %esi,(%ebx)
c002b0da:	89 7b 04             	mov    %edi,0x4(%ebx)
      ti->tick_count = 0;
c002b0dd:	c7 43 08 00 00 00 00 	movl   $0x0,0x8(%ebx)
      ti->nice = nice;
c002b0e4:	8b 44 24 04          	mov    0x4(%esp),%eax
c002b0e8:	89 43 0c             	mov    %eax,0xc(%ebx)

      snprintf(name, sizeof name, "load %d", i);
c002b0eb:	55                   	push   %ebp
c002b0ec:	68 6a f9 02 c0       	push   $0xc002f96a
c002b0f1:	6a 10                	push   $0x10
c002b0f3:	8d 54 24 1c          	lea    0x1c(%esp),%edx
c002b0f7:	52                   	push   %edx
c002b0f8:	e8 21 b2 ff ff       	call   c002631e <snprintf>
      thread_create (name, PRI_DEFAULT, load_thread, ti);
c002b0fd:	53                   	push   %ebx
c002b0fe:	68 5c b2 02 c0       	push   $0xc002b25c
c002b103:	6a 1f                	push   $0x1f
c002b105:	8d 4c 24 2c          	lea    0x2c(%esp),%ecx
c002b109:	51                   	push   %ecx
c002b10a:	e8 2d 58 ff ff       	call   c002093c <thread_create>

      nice += nice_step;
c002b10f:	8b 54 24 2c          	mov    0x2c(%esp),%edx
c002b113:	01 54 24 24          	add    %edx,0x24(%esp)
  for (i = 0; i < thread_cnt; i++) 
c002b117:	45                   	inc    %ebp
c002b118:	83 c3 10             	add    $0x10,%ebx
c002b11b:	83 c4 20             	add    $0x20,%esp
c002b11e:	39 6c 24 08          	cmp    %ebp,0x8(%esp)
c002b122:	75 b4                	jne    c002b0d8 <test_mlfqs_fair+0x94>
    }
  msg ("Starting threads took %"PRId64" ticks.", timer_elapsed (start_time));
c002b124:	83 ec 08             	sub    $0x8,%esp
c002b127:	57                   	push   %edi
c002b128:	56                   	push   %esi
c002b129:	e8 75 81 ff ff       	call   c00232a3 <timer_elapsed>
c002b12e:	83 c4 0c             	add    $0xc,%esp
c002b131:	52                   	push   %edx
c002b132:	50                   	push   %eax
c002b133:	68 bc fb 02 c0       	push   $0xc002fbbc
c002b138:	e8 dc df ff ff       	call   c0029119 <msg>

  msg ("Sleeping 40 seconds to let threads run, please wait...");
c002b13d:	c7 04 24 e0 fb 02 c0 	movl   $0xc002fbe0,(%esp)
c002b144:	e8 d0 df ff ff       	call   c0029119 <msg>
  timer_sleep (40 * TIMER_FREQ);
c002b149:	83 c4 08             	add    $0x8,%esp
c002b14c:	6a 00                	push   $0x0
c002b14e:	68 a0 0f 00 00       	push   $0xfa0
c002b153:	e8 67 81 ff ff       	call   c00232bf <timer_sleep>
c002b158:	8d 74 24 38          	lea    0x38(%esp),%esi
c002b15c:	83 c4 10             	add    $0x10,%esp
c002b15f:	bb 00 00 00 00       	mov    $0x0,%ebx
  
  for (i = 0; i < thread_cnt; i++)
    msg ("Thread %d received %d ticks.", i, info[i].tick_count);
c002b164:	83 ec 04             	sub    $0x4,%esp
c002b167:	ff 36                	pushl  (%esi)
c002b169:	53                   	push   %ebx
c002b16a:	68 49 fb 02 c0       	push   $0xc002fb49
c002b16f:	e8 a5 df ff ff       	call   c0029119 <msg>
  for (i = 0; i < thread_cnt; i++)
c002b174:	43                   	inc    %ebx
c002b175:	83 c6 10             	add    $0x10,%esi
c002b178:	83 c4 10             	add    $0x10,%esp
c002b17b:	39 dd                	cmp    %ebx,%ebp
c002b17d:	75 e5                	jne    c002b164 <test_mlfqs_fair+0x120>
}
c002b17f:	81 c4 6c 01 00 00    	add    $0x16c,%esp
c002b185:	5b                   	pop    %ebx
c002b186:	5e                   	pop    %esi
c002b187:	5f                   	pop    %edi
c002b188:	5d                   	pop    %ebp
c002b189:	c3                   	ret    
  ASSERT (thread_mlfqs);
c002b18a:	83 ec 0c             	sub    $0xc,%esp
c002b18d:	68 ad ea 02 c0       	push   $0xc002eaad
c002b192:	68 df cb 02 c0       	push   $0xc002cbdf
c002b197:	68 50 cb 02 c0       	push   $0xc002cb50
c002b19c:	6a 49                	push   $0x49
c002b19e:	68 68 fb 02 c0       	push   $0xc002fb68
c002b1a3:	e8 98 c4 ff ff       	call   c0027640 <debug_panic>
  ASSERT (thread_cnt <= MAX_THREAD_CNT);
c002b1a8:	83 ec 0c             	sub    $0xc,%esp
c002b1ab:	68 f6 fa 02 c0       	push   $0xc002faf6
c002b1b0:	68 df cb 02 c0       	push   $0xc002cbdf
c002b1b5:	68 50 cb 02 c0       	push   $0xc002cb50
c002b1ba:	6a 4a                	push   $0x4a
c002b1bc:	68 68 fb 02 c0       	push   $0xc002fb68
c002b1c1:	e8 7a c4 ff ff       	call   c0027640 <debug_panic>
  ASSERT (nice_min >= -10);
c002b1c6:	83 ec 0c             	sub    $0xc,%esp
c002b1c9:	68 13 fb 02 c0       	push   $0xc002fb13
c002b1ce:	68 df cb 02 c0       	push   $0xc002cbdf
c002b1d3:	68 50 cb 02 c0       	push   $0xc002cb50
c002b1d8:	6a 4b                	push   $0x4b
c002b1da:	68 68 fb 02 c0       	push   $0xc002fb68
c002b1df:	e8 5c c4 ff ff       	call   c0027640 <debug_panic>
  ASSERT (nice_step >= 0);
c002b1e4:	83 ec 0c             	sub    $0xc,%esp
c002b1e7:	68 23 fb 02 c0       	push   $0xc002fb23
c002b1ec:	68 df cb 02 c0       	push   $0xc002cbdf
c002b1f1:	68 50 cb 02 c0       	push   $0xc002cb50
c002b1f6:	6a 4c                	push   $0x4c
c002b1f8:	68 68 fb 02 c0       	push   $0xc002fb68
c002b1fd:	e8 3e c4 ff ff       	call   c0027640 <debug_panic>
  ASSERT (nice_min + nice_step * (thread_cnt - 1) <= 20);
c002b202:	83 ec 0c             	sub    $0xc,%esp
c002b205:	68 8c fb 02 c0       	push   $0xc002fb8c
c002b20a:	68 df cb 02 c0       	push   $0xc002cbdf
c002b20f:	68 50 cb 02 c0       	push   $0xc002cb50
c002b214:	6a 4d                	push   $0x4d
c002b216:	68 68 fb 02 c0       	push   $0xc002fb68
c002b21b:	e8 20 c4 ff ff       	call   c0027640 <debug_panic>
  msg ("Starting threads took %"PRId64" ticks.", timer_elapsed (start_time));
c002b220:	83 ec 08             	sub    $0x8,%esp
c002b223:	57                   	push   %edi
c002b224:	56                   	push   %esi
c002b225:	e8 79 80 ff ff       	call   c00232a3 <timer_elapsed>
c002b22a:	83 c4 0c             	add    $0xc,%esp
c002b22d:	52                   	push   %edx
c002b22e:	50                   	push   %eax
c002b22f:	68 bc fb 02 c0       	push   $0xc002fbbc
c002b234:	e8 e0 de ff ff       	call   c0029119 <msg>
  msg ("Sleeping 40 seconds to let threads run, please wait...");
c002b239:	c7 04 24 e0 fb 02 c0 	movl   $0xc002fbe0,(%esp)
c002b240:	e8 d4 de ff ff       	call   c0029119 <msg>
  timer_sleep (40 * TIMER_FREQ);
c002b245:	83 c4 08             	add    $0x8,%esp
c002b248:	6a 00                	push   $0x0
c002b24a:	68 a0 0f 00 00       	push   $0xfa0
c002b24f:	e8 6b 80 ff ff       	call   c00232bf <timer_sleep>
c002b254:	83 c4 10             	add    $0x10,%esp
c002b257:	e9 23 ff ff ff       	jmp    c002b17f <test_mlfqs_fair+0x13b>

c002b25c <load_thread>:

static void
load_thread (void *ti_) 
{
c002b25c:	57                   	push   %edi
c002b25d:	56                   	push   %esi
c002b25e:	53                   	push   %ebx
c002b25f:	8b 7c 24 10          	mov    0x10(%esp),%edi
  struct thread_info *ti = ti_;
  int64_t sleep_time = 5 * TIMER_FREQ;
  int64_t spin_time = sleep_time + 30 * TIMER_FREQ;
  int64_t last_time = 0;

  thread_set_nice (ti->nice);
c002b263:	83 ec 0c             	sub    $0xc,%esp
c002b266:	ff 77 0c             	pushl  0xc(%edi)
c002b269:	e8 44 59 ff ff       	call   c0020bb2 <thread_set_nice>
  timer_sleep (sleep_time - timer_elapsed (ti->start_time));
c002b26e:	83 c4 08             	add    $0x8,%esp
c002b271:	ff 77 04             	pushl  0x4(%edi)
c002b274:	ff 37                	pushl  (%edi)
c002b276:	e8 28 80 ff ff       	call   c00232a3 <timer_elapsed>
c002b27b:	83 c4 08             	add    $0x8,%esp
c002b27e:	b9 f4 01 00 00       	mov    $0x1f4,%ecx
c002b283:	bb 00 00 00 00       	mov    $0x0,%ebx
c002b288:	29 c1                	sub    %eax,%ecx
c002b28a:	19 d3                	sbb    %edx,%ebx
c002b28c:	53                   	push   %ebx
c002b28d:	51                   	push   %ecx
c002b28e:	e8 2c 80 ff ff       	call   c00232bf <timer_sleep>
  while (timer_elapsed (ti->start_time) < spin_time) 
c002b293:	83 c4 10             	add    $0x10,%esp
  int64_t last_time = 0;
c002b296:	be 00 00 00 00       	mov    $0x0,%esi
c002b29b:	bb 00 00 00 00       	mov    $0x0,%ebx
  while (timer_elapsed (ti->start_time) < spin_time) 
c002b2a0:	eb 1b                	jmp    c002b2bd <load_thread+0x61>
c002b2a2:	3d ab 0d 00 00       	cmp    $0xdab,%eax
c002b2a7:	77 2c                	ja     c002b2d5 <load_thread+0x79>
    {
      int64_t cur_time = timer_ticks ();
c002b2a9:	e8 cc 7f ff ff       	call   c002327a <timer_ticks>
      if (cur_time != last_time)
c002b2ae:	31 c6                	xor    %eax,%esi
c002b2b0:	31 d3                	xor    %edx,%ebx
c002b2b2:	09 f3                	or     %esi,%ebx
c002b2b4:	74 03                	je     c002b2b9 <load_thread+0x5d>
        ti->tick_count++;
c002b2b6:	ff 47 08             	incl   0x8(%edi)
{
c002b2b9:	89 c6                	mov    %eax,%esi
c002b2bb:	89 d3                	mov    %edx,%ebx
  while (timer_elapsed (ti->start_time) < spin_time) 
c002b2bd:	83 ec 08             	sub    $0x8,%esp
c002b2c0:	ff 77 04             	pushl  0x4(%edi)
c002b2c3:	ff 37                	pushl  (%edi)
c002b2c5:	e8 d9 7f ff ff       	call   c00232a3 <timer_elapsed>
c002b2ca:	83 c4 10             	add    $0x10,%esp
c002b2cd:	85 d2                	test   %edx,%edx
c002b2cf:	78 d8                	js     c002b2a9 <load_thread+0x4d>
c002b2d1:	85 d2                	test   %edx,%edx
c002b2d3:	7e cd                	jle    c002b2a2 <load_thread+0x46>
      last_time = cur_time;
    }
}
c002b2d5:	5b                   	pop    %ebx
c002b2d6:	5e                   	pop    %esi
c002b2d7:	5f                   	pop    %edi
c002b2d8:	c3                   	ret    

c002b2d9 <test_mlfqs_fair_2>:
{
c002b2d9:	83 ec 0c             	sub    $0xc,%esp
  test_mlfqs_fair (2, 0, 0);
c002b2dc:	b9 00 00 00 00       	mov    $0x0,%ecx
c002b2e1:	ba 00 00 00 00       	mov    $0x0,%edx
c002b2e6:	b8 02 00 00 00       	mov    $0x2,%eax
c002b2eb:	e8 54 fd ff ff       	call   c002b044 <test_mlfqs_fair>
}
c002b2f0:	83 c4 0c             	add    $0xc,%esp
c002b2f3:	c3                   	ret    

c002b2f4 <test_mlfqs_fair_20>:
{
c002b2f4:	83 ec 0c             	sub    $0xc,%esp
  test_mlfqs_fair (20, 0, 0);
c002b2f7:	b9 00 00 00 00       	mov    $0x0,%ecx
c002b2fc:	ba 00 00 00 00       	mov    $0x0,%edx
c002b301:	b8 14 00 00 00       	mov    $0x14,%eax
c002b306:	e8 39 fd ff ff       	call   c002b044 <test_mlfqs_fair>
}
c002b30b:	83 c4 0c             	add    $0xc,%esp
c002b30e:	c3                   	ret    

c002b30f <test_mlfqs_nice_2>:
{
c002b30f:	83 ec 0c             	sub    $0xc,%esp
  test_mlfqs_fair (2, 0, 5);
c002b312:	b9 05 00 00 00       	mov    $0x5,%ecx
c002b317:	ba 00 00 00 00       	mov    $0x0,%edx
c002b31c:	b8 02 00 00 00       	mov    $0x2,%eax
c002b321:	e8 1e fd ff ff       	call   c002b044 <test_mlfqs_fair>
}
c002b326:	83 c4 0c             	add    $0xc,%esp
c002b329:	c3                   	ret    

c002b32a <test_mlfqs_nice_10>:
{
c002b32a:	83 ec 0c             	sub    $0xc,%esp
  test_mlfqs_fair (10, 0, 1);
c002b32d:	b9 01 00 00 00       	mov    $0x1,%ecx
c002b332:	ba 00 00 00 00       	mov    $0x0,%edx
c002b337:	b8 0a 00 00 00       	mov    $0xa,%eax
c002b33c:	e8 03 fd ff ff       	call   c002b044 <test_mlfqs_fair>
}
c002b341:	83 c4 0c             	add    $0xc,%esp
c002b344:	c3                   	ret    

c002b345 <block_thread>:
  msg ("Block thread should have already acquired lock.");
}

static void
block_thread (void *lock_) 
{
c002b345:	57                   	push   %edi
c002b346:	56                   	push   %esi
c002b347:	83 ec 10             	sub    $0x10,%esp
  struct lock *lock = lock_;
  int64_t start_time;

  msg ("Block thread spinning for 20 seconds...");
c002b34a:	68 18 fc 02 c0       	push   $0xc002fc18
c002b34f:	e8 c5 dd ff ff       	call   c0029119 <msg>
  start_time = timer_ticks ();
c002b354:	e8 21 7f ff ff       	call   c002327a <timer_ticks>
c002b359:	89 c6                	mov    %eax,%esi
c002b35b:	89 d7                	mov    %edx,%edi
  while (timer_elapsed (start_time) < 20 * TIMER_FREQ)
c002b35d:	83 c4 10             	add    $0x10,%esp
c002b360:	83 ec 08             	sub    $0x8,%esp
c002b363:	57                   	push   %edi
c002b364:	56                   	push   %esi
c002b365:	e8 39 7f ff ff       	call   c00232a3 <timer_elapsed>
c002b36a:	83 c4 10             	add    $0x10,%esp
c002b36d:	85 d2                	test   %edx,%edx
c002b36f:	78 ef                	js     c002b360 <block_thread+0x1b>
c002b371:	85 d2                	test   %edx,%edx
c002b373:	7e 2b                	jle    c002b3a0 <block_thread+0x5b>
    continue;

  msg ("Block thread acquiring lock...");
c002b375:	83 ec 0c             	sub    $0xc,%esp
c002b378:	68 40 fc 02 c0       	push   $0xc002fc40
c002b37d:	e8 97 dd ff ff       	call   c0029119 <msg>
  lock_acquire (lock);
c002b382:	83 c4 04             	add    $0x4,%esp
c002b385:	ff 74 24 1c          	pushl  0x1c(%esp)
c002b389:	e8 d8 6f ff ff       	call   c0022366 <lock_acquire>

  msg ("...got it.");
c002b38e:	c7 04 24 18 fd 02 c0 	movl   $0xc002fd18,(%esp)
c002b395:	e8 7f dd ff ff       	call   c0029119 <msg>
}
c002b39a:	83 c4 14             	add    $0x14,%esp
c002b39d:	5e                   	pop    %esi
c002b39e:	5f                   	pop    %edi
c002b39f:	c3                   	ret    
  while (timer_elapsed (start_time) < 20 * TIMER_FREQ)
c002b3a0:	3d cf 07 00 00       	cmp    $0x7cf,%eax
c002b3a5:	76 b9                	jbe    c002b360 <block_thread+0x1b>
c002b3a7:	eb cc                	jmp    c002b375 <block_thread+0x30>

c002b3a9 <test_mlfqs_block>:
{
c002b3a9:	57                   	push   %edi
c002b3aa:	56                   	push   %esi
c002b3ab:	53                   	push   %ebx
c002b3ac:	83 ec 20             	sub    $0x20,%esp
  ASSERT (thread_mlfqs);
c002b3af:	80 3d 6c 83 03 c0 00 	cmpb   $0x0,0xc003836c
c002b3b6:	0f 84 a9 00 00 00    	je     c002b465 <test_mlfqs_block+0xbc>
  msg ("Main thread acquiring lock.");
c002b3bc:	83 ec 0c             	sub    $0xc,%esp
c002b3bf:	68 23 fd 02 c0       	push   $0xc002fd23
c002b3c4:	e8 50 dd ff ff       	call   c0029119 <msg>
  lock_init (&lock);
c002b3c9:	83 c4 04             	add    $0x4,%esp
c002b3cc:	8d 5c 24 14          	lea    0x14(%esp),%ebx
c002b3d0:	53                   	push   %ebx
c002b3d1:	e8 0e 6f ff ff       	call   c00222e4 <lock_init>
  lock_acquire (&lock);
c002b3d6:	89 1c 24             	mov    %ebx,(%esp)
c002b3d9:	e8 88 6f ff ff       	call   c0022366 <lock_acquire>
  msg ("Main thread creating block thread, sleeping 25 seconds...");
c002b3de:	c7 04 24 84 fc 02 c0 	movl   $0xc002fc84,(%esp)
c002b3e5:	e8 2f dd ff ff       	call   c0029119 <msg>
  thread_create ("block", PRI_DEFAULT, block_thread, &lock);
c002b3ea:	53                   	push   %ebx
c002b3eb:	68 45 b3 02 c0       	push   $0xc002b345
c002b3f0:	6a 1f                	push   $0x1f
c002b3f2:	68 a6 ea 02 c0       	push   $0xc002eaa6
c002b3f7:	e8 40 55 ff ff       	call   c002093c <thread_create>
  timer_sleep (25 * TIMER_FREQ);
c002b3fc:	83 c4 18             	add    $0x18,%esp
c002b3ff:	6a 00                	push   $0x0
c002b401:	68 c4 09 00 00       	push   $0x9c4
c002b406:	e8 b4 7e ff ff       	call   c00232bf <timer_sleep>
  msg ("Main thread spinning for 5 seconds...");
c002b40b:	c7 04 24 c0 fc 02 c0 	movl   $0xc002fcc0,(%esp)
c002b412:	e8 02 dd ff ff       	call   c0029119 <msg>
  start_time = timer_ticks ();
c002b417:	e8 5e 7e ff ff       	call   c002327a <timer_ticks>
c002b41c:	89 c6                	mov    %eax,%esi
c002b41e:	89 d7                	mov    %edx,%edi
  while (timer_elapsed (start_time) < 5 * TIMER_FREQ)
c002b420:	83 c4 10             	add    $0x10,%esp
c002b423:	83 ec 08             	sub    $0x8,%esp
c002b426:	57                   	push   %edi
c002b427:	56                   	push   %esi
c002b428:	e8 76 7e ff ff       	call   c00232a3 <timer_elapsed>
c002b42d:	83 c4 10             	add    $0x10,%esp
c002b430:	85 d2                	test   %edx,%edx
c002b432:	78 ef                	js     c002b423 <test_mlfqs_block+0x7a>
c002b434:	85 d2                	test   %edx,%edx
c002b436:	7e 4b                	jle    c002b483 <test_mlfqs_block+0xda>
  msg ("Main thread releasing lock.");
c002b438:	83 ec 0c             	sub    $0xc,%esp
c002b43b:	68 3f fd 02 c0       	push   $0xc002fd3f
c002b440:	e8 d4 dc ff ff       	call   c0029119 <msg>
  lock_release (&lock);
c002b445:	83 c4 04             	add    $0x4,%esp
c002b448:	8d 44 24 14          	lea    0x14(%esp),%eax
c002b44c:	50                   	push   %eax
c002b44d:	e8 39 70 ff ff       	call   c002248b <lock_release>
  msg ("Block thread should have already acquired lock.");
c002b452:	c7 04 24 e8 fc 02 c0 	movl   $0xc002fce8,(%esp)
c002b459:	e8 bb dc ff ff       	call   c0029119 <msg>
}
c002b45e:	83 c4 30             	add    $0x30,%esp
c002b461:	5b                   	pop    %ebx
c002b462:	5e                   	pop    %esi
c002b463:	5f                   	pop    %edi
c002b464:	c3                   	ret    
  ASSERT (thread_mlfqs);
c002b465:	83 ec 0c             	sub    $0xc,%esp
c002b468:	68 ad ea 02 c0       	push   $0xc002eaad
c002b46d:	68 df cb 02 c0       	push   $0xc002cbdf
c002b472:	68 60 cb 02 c0       	push   $0xc002cb60
c002b477:	6a 1c                	push   $0x1c
c002b479:	68 60 fc 02 c0       	push   $0xc002fc60
c002b47e:	e8 bd c1 ff ff       	call   c0027640 <debug_panic>
  while (timer_elapsed (start_time) < 5 * TIMER_FREQ)
c002b483:	3d f3 01 00 00       	cmp    $0x1f3,%eax
c002b488:	76 99                	jbe    c002b423 <test_mlfqs_block+0x7a>
c002b48a:	eb ac                	jmp    c002b438 <test_mlfqs_block+0x8f>
